#!/bin/bash 
#XW_lib="libdl.so.2 libz.so.1 libstdc++.so.5 libm.so.6 libgcc_s.so.1 libpthread.so.0 libc.so.6 ld-linux.so.2 libxml2.so.2 libxslt.so.1"
XW_lib="libxml2.so.2 libxslt.so.1"
DEFDIR="$PWD"
TrediPath="$DEFDIR/it-3di"
NEWDIR=\\$PWD

change_opt(){
 for i in `grep "opt\/it-3di" $DEFDIR/it-3di/ -R  | awk -F":" '{print $1}'`; do 
  #cp $i{,_back};
  cat $i | sed  -e "/\/opt/s#/opt#${NEWDIR}#" >$i; 
  echo """cambio di percorso sul file di configurazione $i in $DEFDIR l'originale
        è stato salvato in $i""""_back"
 done


}
check_env () {
      retr=0
      echo """ 
              Controllo dipendenze Necessarie Per l'avvio di Extraway 
"""                
      XW_LDD=$(ldd it-3di/extraway/xw/bin/xw | awk '{print $1}' | grep -v linux)
      for lib in $XW_LDD $XW_lib ; do 
        if [[ $( find /lib -iname $lib 2> /dev/null | grep $lib) ]] ; then
                echo " $lib OK " ; retr=0
                elif [[ $( find /usr/lib -iname $lib 2> /dev/null | grep $lib) ]] ; then 
                        echo " $lib OK " ; retr=0        
        else 
             echo " $lib Not Found" ; if [ $retr == 0 ] ; then retr=1; fi
        fi ;
       done
      return $retr

}

account () {
  if [[ -e  "$1"  || -d $TrediPath || -d "$1/it-3di" ]]; then
   InstDir=${1:-$DEFDIR} ; 
    check_env || echo " Prego Controllare le dipendenze"  exit 1
  else 
    echo "inserire il percorso della installazione [$DEFDIR]"; 
                read InstDir;
    
  fi
#[ $PWD != /opt ] && change_path
XWHome=$InstDir/it-3di/extraway/xw ;
date=`date +%G%m%d` ;
  if [ -x $XWHome/bin/xw ]; then
  factory=$( sed "s/\r//g"  $XWHome/conf/xw.ini | awk -F'=' '/Company/ {print $2}' )
  version=$( $XWHome/bin/xw -v | head -n1 | sed 's/.*Version \(.*\)/\1/' ) ;
    echo """ Per poter ottenere il numero di serie contattare l'assistenza 
             tecnica al numero 051-450844  e comunicare la chiave di abilitazione 
         """
    $XWHome/bin/xw -r || exit 1 ; 
  else 
  echo "non è stata trovata la directory degli eseguibili" exit 1
  fi        
    if [[ $version != '' ]]; then 
      context_file=$XWHome/context/context.stat.xml
    #  echo -e $context_file | tr "\r\n" "\n" | sed -e  "s/\(.*\)\(.*\) \(id=\"struct\"\) \(.*\) \(.*\)\(date=\".*\"\)/\1\2 \3 \5 name=\"ExtraWay\" version=\"$version\" date=\"$date\"/" >  $XWHome/context/context.stat.xml;

    CONTEXT="""<?xml version=\"1.0\" encoding=\"iso-8859-1\"?> 
    <!DOCTYPE context SYSTEM \"http://www.3di.it/extraway/context_20030724.dtd\">
    <context checksum=\"\">
       <object id=\"struct\" name=\"$factory\" version=\"$version\" date=\"$date\"/>
       <object id=\"classif\" name=\"\" version=\"001.000\" date=\"20030724\"/>
       <object id=\"gestman\" name=\"\" version=\"001.000\" date=\"20030724\"/>
       <object id=\"techref\" name=\"ExtraWay Technical Reference\" version=\"000.000.004\" date=\"20030814\"/>
       <object id=\"namespace\" name=\"http://www.3di.it/ns/xw-200303121136\" version=\"\" date=\"20020312\"/>
    </context>
    """
    echo $CONTEXT > $context_file
    else
      echo "Errore in fase di aggiornamento del file context.conf version not found $version"
    fi
#modificare il context.stat.xml
} 

block (){
  if [[ -e  "$1"  || -d $TrediPath || -d "$1/it-3di" ]]; then
   InstDir=${1:-$DEFDIR} ; 
  else 
    echo "inserire il percorso della installazione [$DEFDIR]"; 
                read InstDir;
    
  fi
#export JAVA_HOME=$InstDir/jdk1.5.0_06

chown -R extraway:extraway  $InstDir/it-3di/extraway/;
$InstDir/it-3di/extraway/xw/bin/xwctl stop

chown -R extraway:extraway  $InstDir/apache-tomcat-5.5.27;
$InstDir/apache-tomcat-5.5.27/bin/tomcat.sh stop
}

run (){
  if [[ -e  "$1"  || -d $TrediPath || -d "$1/it-3di" ]]; then
   InstDir=${1:-$DEFDIR} ; 
    check_env || echo " Prego Controllare le dipendenze"  exit 1
  else 
    echo "inserire il percorso della installazione [$DEFDIR]"; 
                read InstDir;
    
  fi
#[ $DEFDIR != /opt ] && change_opt
#export JAVA_HOME=$InstDir/jdk1.5.0_06

#chown -R extraway:extraway  $InstDir/it-3di/extraway/;
$InstDir/it-3di/extraway/xw/bin/xwctl start

#chown -R extraway:extraway  $InstDir/jakarta-tomcat-5.0.28/;
$InstDir/apache-tomcat-5.5.27/bin/tomcat.sh start
echo """
    l'applicazione è attiva all'indirizzo:
    http://localhost:8080/xway/application/xdocway/engine/xdocway.jsp
    user admin
    password 3dinformatica """
}

case "$1" in

  start)
    run $2;
;;

  stop)
    block  $2;
;;

  check)
  check_env ;
;;

  registration)
    account  $2;
;;

  change_path)
    change_opt;
;;

  *)
      echo """Usage: $0 (start|stop|check|registration) [install_directory] 
                                                                          
        registration  registra la versione del server Extraway 
        check   controlle le librerie necessarie al server Extraway
        start   avvia l'applicazione Docway/Titulus  
        stop    chiude l'applicazione Docway/Titulus
          

""";
      ret='2';

;;

esac 

exit $ret
