<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

 <xsl:variable name="hxptemplate" select="document('../html/templates/keyNav.html')"/>

 <xsl:include href="../../../../formatter/factory/keyNav.xsl"/>

 <xsl:template name="customcontent">
  <xsl:param name="templatedata" select="''"/>
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:choose>
   <xsl:when test="$templatedata='overflowheight'">
    <xsl:if test="$blockData/ancestor-or-self::field[@name='XML']">;height:380px;</xsl:if>
   </xsl:when>
   <!--
   <xsl:when test="$templatedata='checkdisplay'">
    <xsl:if test="$blockData/ancestor-or-self::field[@name='UD']">;display:none;</xsl:if>
   </xsl:when>        
   -->
   <xsl:otherwise>
    <xsl:text>must implement customcontent</xsl:text>
   </xsl:otherwise>
  </xsl:choose> 
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-keyalias']">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:if test="$blockData/@alias">
   <xsl:copy>
    <xsl:copy-of select="@*[not(name()='id')]"/>
    <xsl:value-of select="$blockData/@alias"/>
   </xsl:copy>
  </xsl:if>
 </xsl:template>

 <!--
  ximAlfa            = 0x00000001; // Alfanumerico
  ximNum             = 0x00000002; // Numerico
  ximDate            = 0x00000004; // Data
  ximMono            = 0x00000008; // Monovalore
  ximMulti           = 0x00000010; // Multi valore, se sono presenti entrambi allora  una doppia indicizzazione
  ximSkip            = 0x00000020; // Da non indicizzare
  ximEs              = 0x00000040; // Expert System
  ximAttrcat         = 0x00000080; // Da questo si deriva una chiave di attrubuti concatenati
  ximAttrsp          = 0x00000100; // Da questo si deriva una chiave di attributi spaziati
  ximAttrrule        = 0x00000200; // Da questo si deriva una chiave di attributi con regola di composizione
  ximExtracat        = 0x00000400; // Indici tramite dll esterna.
  ximKeyalso         = 0x00000800; // Chiave "also"
  ximInstance        = 0x02000000; // Chiave per multi istanza o bacini di pescaggio
  ximAlias           = 0x04000000; // Chiave "alias" (alimenta un altro indice)
  ximRelative        = 0x08000000;
  ximContainer       = 0x10000000;
  ximContainerChild  = 0x20000000;
  ximTransparent     = 0x40000000;
  ximDefault         = 0x80000000; // Manca impostazione in conf.xml.

  serialRepProt      = 0x00000001; // Repertorio o Seriale Protocollare
  serialEmpty        = 0x00000002; // Seriale per il quale si ammette il valore vuoto. 
  serialNoCheck      = 0x00000004; // Seriale per il quale non si compie il test di validit del contenuto.
 -->

 <xsl:template name="hasBit">
  <xsl:param name="where"/>
  <xsl:param name="bit"/>
  <xsl:variable name="nibble" select="floor($bit div 4)"/>
  <xsl:if test="string-length($where) - 2 > $nibble">
   <xsl:variable name="value" select="substring($where,string-length($where) - $nibble,1)"/>
   <xsl:variable name="nibbleBit" select="$bit mod 4"/>
   <xsl:choose>
    <xsl:when test="$nibble='f'">1</xsl:when>
    <xsl:when test="$nibbleBit=0">
     <xsl:if test="$value='1' or $value='3' or $value='7' or $value='5' or $value='9' or $value='b' or $value='d'">1</xsl:if>
    </xsl:when>
    <xsl:when test="$nibbleBit=1">
     <xsl:if test="$value='2' or $value='3' or $value='7' or $value='6' or $value='a' or $value='b' or $value='e'">1</xsl:if>
    </xsl:when>
    <xsl:when test="$nibbleBit=2">
     <xsl:if test="$value='4' or $value='5' or $value='7' or $value='6' or $value='c' or $value='d' or $value='e'">1</xsl:if>
    </xsl:when>
    <xsl:when test="$nibbleBit=3">
     <xsl:if test="$value='8' or $value='a' or $value='e' or $value='c' or $value='9' or $value='b' or $value='d'">1</xsl:if>
    </xsl:when>
   </xsl:choose>
  </xsl:if>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-keyattributes']">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:variable name="idxmode" select="$blockData/@idxmode" />
  <xsl:variable name="num">
   <xsl:call-template name="hasBit"><xsl:with-param name="where" select="$idxmode"/><xsl:with-param name="bit" select="1"/></xsl:call-template>
  </xsl:variable>
  <xsl:variable name="date">
   <xsl:call-template name="hasBit"><xsl:with-param name="where" select="$idxmode"/><xsl:with-param name="bit" select="2"/></xsl:call-template>
  </xsl:variable>
  <xsl:variable name="mono">
   <xsl:call-template name="hasBit"><xsl:with-param name="where" select="$idxmode"/><xsl:with-param name="bit" select="3"/></xsl:call-template>
  </xsl:variable>
  <xsl:variable name="multi">
   <xsl:call-template name="hasBit"><xsl:with-param name="where" select="$idxmode"/><xsl:with-param name="bit" select="4"/></xsl:call-template>
  </xsl:variable>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>

   <xsl:if test="$num='1'"> numeric </xsl:if>
   <xsl:if test="$date='1'"> date </xsl:if>
   <xsl:choose>
    <xsl:when test="$mono='1' and $multi='1'"> double </xsl:when>
    <xsl:when test="$mono='1'"> mono </xsl:when>
    <xsl:when test="$multi='1'"> multi </xsl:when>
   </xsl:choose>

   <xsl:variable name="details">
    <xsl:for-each select="$blockData/@*[name()!='alias' and name()!='id' and name()!='name' and name()!='value' and string-length(normalize-space(.))>0]">
     <xsl:text> </xsl:text>
     <xsl:value-of select="name()"/>
     <xsl:text>="</xsl:text>
     <xsl:value-of select="."/>
     <xsl:text>" </xsl:text>
    </xsl:for-each>
   </xsl:variable>
   <xsl:if test="string-length($details) > 0">
    <xsl:text>(</xsl:text><xsl:value-of select="$details"/><xsl:text>)</xsl:text>
   </xsl:if>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>

 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-fieldtemplate']">
  <!-- do nothing, handled in the right place later -->
 </xsl:template>

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockData" select="''"/>
		<xsl:text>must implement containerConditional</xsl:text>
	</xsl:template>

	<xsl:template name="contextcustom">
		<xsl:param name="blockData" select="''"/>
		<xsl:param name="specName" select="''"/>
		<xsl:text>must implement contextcustom</xsl:text>
	</xsl:template>	

 <xsl:template match="*[@id='hxp-custom-datafield']">
  <xsl:variable name="thecontext" select="/"/>
  <xsl:for-each select="$hxpdata/container/field[@name!='UD']">
   <xsl:variable name="xmlfield" select="."/>
   <xsl:for-each select="$thecontext//*[@id='hxp-custom-fieldtemplate']/tr">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:apply-templates mode="template">
      <xsl:with-param name="blockData" select="$xmlfield"/>
     </xsl:apply-templates>
    </xsl:copy>
   </xsl:for-each>
  </xsl:for-each>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-systemfield']">
  <xsl:for-each select="//*[@id='hxp-custom-fieldtemplate']/tr">
   <xsl:copy>
    <xsl:copy-of select="@*[name()!='id']"/>
    <xsl:apply-templates mode="template">
     <xsl:with-param name="blockData" select="$hxpdata/container/field[@name='UD']"/>
    </xsl:apply-templates>
   </xsl:copy>
  </xsl:for-each>
 </xsl:template>

 <xsl:output method="html" indent="yes" encoding="iso-8859-1" />
</xsl:stylesheet>


