<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:xw="http://www.3di.it/ns/xw-200203121136" exclude-result-prefixes="xw">


  <xsl:template match="@DateIns|@DateMod" mode="aData">
    <xsl:call-template name="dateformatter"/>
  </xsl:template>


  <xsl:template match="@TimeIns|@TimeMod" mode="aData">
    <xsl:value-of select="substring(.,1,2)"/>
    <xsl:text>:</xsl:text>
    <xsl:value-of select="substring(.,3,2)"/>
    <xsl:text>:</xsl:text>
    <xsl:value-of select="substring(.,5,2)"/>
  </xsl:template>

  <xsl:template match="xw:usr" mode="aData">
    <table>
      <tbody>
        <tr>
          <td>Record created&#160;on&#160;</td>
          <td><xsl:apply-templates select="@DateIns" mode="aData"/></td>
          <td>&#160;at&#160;</td>
          <td><xsl:apply-templates select="@TimeIns" mode="aData"/></td>
          <td>&#160;from user&#160;</td>
          <td><xsl:value-of select="@UserIns"/></td>
        </tr>
        <tr>
          <xsl:choose>
            <xsl:when test="    (@DateIns!=@DateMod) or (@TimeIns!=@TimeMod)
                             or (@UserIns!=@UserMod)">
              <td>Record last changed&#160;on&#160;</td>
              <td><xsl:apply-templates select="@DateMod" mode="aData"/></td>
              <td>&#160;at&#160;</td>
              <td><xsl:apply-templates select="@TimeMod" mode="aData"/></td>
              <td>&#160;from user&#160;</td>
              <td><xsl:value-of select="@UserMod"/></td>
            </xsl:when>
            <xsl:otherwise>
              <td colspan="6">Record never changed</td>
            </xsl:otherwise>
          </xsl:choose>
        </tr>
      </tbody>
    </table>
  </xsl:template>
  

</xsl:stylesheet>

