<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:xw="http://www.3di.it/ns/xw-200203121136" exclude-result-prefixes="xw">

  <!-- sia 'showdoc' che 'showtarget'
  <xsl:variable name="_docname" select="/response/@verbo"/>
  -->
  <xsl:variable name="_docname" select="'showdoc'"/>
  <xsl:variable name="hxptemplate" select="document(concat('../html/templates/',concat($_docname,'.html')))"/>
  <xsl:include href="../../../../formatter/factory/document.xsl"/>
  <xsl:include href="admindata.xsl"/>

  <xsl:template name="customcontent">
    <xsl:text>must implement customcontent</xsl:text>
  </xsl:template>

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockData" select="''"/>
	</xsl:template>

	<xsl:template name="contextcustom">
		<xsl:param name="blockData" select="''"/>
		<xsl:param name="specName" select="''"/>
	</xsl:template>	

  <xsl:template match="*[@id='hxp-custom-doclike']">  
    <xsl:param name="blockData" select="''"/>            
    <xsl:copy>
      <xsl:for-each select="@*[name()!='id']">
        <xsl:call-template name="stringparser">
          <xsl:with-param name="data" select="$blockData"/>
        </xsl:call-template>
      </xsl:for-each>
      <xsl:attribute name="href">
        <xsl:text>javascript:void(0)</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="onclick">
        <xsl:text>return doFindLike('</xsl:text>
        <xsl:value-of select="$hxpdata/@physDoc"/>
        <xsl:text>');</xsl:text>
      </xsl:attribute>
      <xsl:call-template name="hxpcontinuecontext">
        <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>    
    </xsl:copy>
  </xsl:template>

  <xsl:template match="*[@id='hxp-custom-adminData']">
    <xsl:if test="'1' = $isAdmin">
      <xsl:apply-templates select="$hxpdata/xw:usr" mode="aData"/>
    </xsl:if>
  </xsl:template>

  <xsl:template match="processing-instruction()" mode="xmlcopy">
   <xsl:apply-templates select="."/>
  </xsl:template>

  <xsl:template match="*[name()!='xw:usr']" mode="xmlcopy">
   <table cellspacing="0" cellpadding="0" border="0">
   <tr>
   <td style="width:8pt" valign="top">
    <xsl:if test="count(*|text()) > 0">
     <xsl:attribute name="rowspan">3</xsl:attribute> 
     <a class="tnode" href="javascript:void(0)"> 
      <xsl:attribute name="onclick">
       <xsl:text>return hideShowBranch(this,'</xsl:text>
       <xsl:call-template name="makeabscoord"/>
       <xsl:text>')</xsl:text>
      </xsl:attribute>
      -
     </a>
    </xsl:if>
   </td>
   <td colspan="2">
    <table cellspacing="0" cellpadding="0" border="0">
    <tr>
    <td valign="top">
     <b>
     <xsl:text>&lt;</xsl:text>
     <xsl:value-of select="name()"/>
     </b>
    </td>
    <xsl:if test="count(@*) > 0">
     <td>&#160;</td>
    </xsl:if>
    <td>
    <xsl:for-each select="@*">
     <xsl:text> </xsl:text>
     <b><i><xsl:value-of select="name()"/></i></b>
     <xsl:text> = "</xsl:text>
     <xsl:value-of select="."/>
     <xsl:text>" </xsl:text><!-- <br/> -->
    </xsl:for-each>
    <xsl:if test="count(*|text()) = 0">/</xsl:if>
    <xsl:text>&gt;</xsl:text>
    </td>
    </tr>
    </table>
   </td>
   </tr>
   <xsl:if test="count(*|text()) > 0">
    <tr>
    <td colspan="2" style="display:">
     <xsl:attribute name="id"><xsl:call-template name="makeabscoord"/></xsl:attribute>
     <table cellspacing="0" cellpadding="0">
      <tr>
       <xsl:if test="count(*) = 0"><td style="width:8pt"></td></xsl:if>
       <td><xsl:apply-templates mode="xmlcopy"/></td>
      </tr>
     </table>
    </td>
    </tr>
    <tr>
    <td colspan="2">
     <b>
     <xsl:text>&lt;/</xsl:text>
     <xsl:value-of select="name()"/>
     <xsl:text>&gt;</xsl:text>
     </b>
    </td>
    </tr>
   </xsl:if>
   </table>
  </xsl:template>
    
  <xsl:template match="*[@id='hxp-custom-docbody']">
  <!--
    <xsl:variable name="_doctype" select="$hxpdata/@db"/>
    <xsl:variable name="dbtemplate" select="document(concat('../html/templates/',$_doctype,'/',$_docname,'.html'))"/>
    <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
      <xsl:apply-templates select="$dbtemplate/html/body/*" mode="template"/>
    </xsl:copy>
  -->
   <script>
    function hideShowBranch(elem,theId)
    {var isHidden=document.getElementById(theId).style.display=='none';
     elem.innerHTML=(isHidden?'-':'+');
     document.getElementById(theId).style.display=(isHidden?'':'none');
     return false;
    }
   </script>
   <xsl:apply-templates select="$hxpdata/*" mode="xmlcopy"/>
  </xsl:template>

  <xsl:template match="*[@id='hxp-custom-errorchecker']">
    <xsl:param name="blockData" select="$hxpdata"/>
    <xsl:choose>
      <xsl:when test="1>count($hxpdata/*)">
        <xsl:apply-templates select="$hxpdata"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="hxpformatter">
          <xsl:with-param name="value" select="'containerof-response'"/>
          <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- scrive il nome dell'archivio nel caso di visualizzazione docs di raccolte -->
  <xsl:template match="*[@id='hxp-custom-arcDoc']"> 
    <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/> 
      <xsl:if test="$hxpdata/@selid=$hxpdata/@cId">
        <script><xsl:text>document.write("</xsl:text>
          <xsl:value-of select="$hxpdata/@db" />
          <xsl:text>".toUpperCase());</xsl:text></script>
      </xsl:if>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="*[@id='hxp-custom-navbar']">
    <xsl:param name="blockData" select="$hxpdata"/>

    <!-- in caso di showtarget non mostra la barra di navigazione -->
    <!-- se xverb e' print allora mostro barra per poter stampare i documenti -->

    <xsl:if test="($hxpdata/@xverb='@print') and ($hxpdata/@verbo='showtarget')">        
     <table id="printHeader">
     <tr>
     <td nowrap="nowrap">
      <span  class="testoTitolo">
       <a onmouseover="window.status='Print';return true" onmouseout="window.status=''" href="javascript:void(0)" onclick="return window.print()">Print&#160;</a> 
       <!--<script>document.write(printHeaderF(<xsl:value-of select="$hxpdata/@count" />));</script>-->
       <script>document.write(" "+printHeaderF(parent.actionFrame.tot_doc));</script>
       <xsl:choose>
        <xsl:when test="$hxpdata/@selid=$hxpdata/@cId">
         records.&#160;
        </xsl:when>
        <xsl:otherwise>
         records of <xsl:value-of select="$hxpdata/@db" />:&#160;    
        </xsl:otherwise>
       </xsl:choose>             
       <span id="searchString">Search expression</span>
      </span>        
     </td>
     </tr>
<!--
     <tr>
     <td align="right" nowrap="nowrap">
      <a onmouseover="window.status='Salva';return true" onmouseout="window.status=''" href="javascript:void(0)" onclick="return savePage()">Salva</a> 
     </td>
     </tr>
-->
     </table>

     <hr/>
    </xsl:if>   

    <!-- se verbo='showtarget' e xverb='child' mostro pulsante back e  fwd di history -->
    <xsl:if test="($hxpdata/@verbo='showtarget') and ($hxpdata/@xverb='child')">
      <table border="0">
        <tbody>
          <tr>
            <td>
              <span id="prevShow" style="display:none;">
                <a href="javascript:void(0)" onclick="return prevHistory();">
                  <img src="../formatter/html/data/common/images/document/indietro_on_.gif" border="0" title="Back" alt="Back" onMouseDown="changeIconPush(this)" onMouseOut="changeIconPop(this)" onMouseUp="changeIconPop(this)"/>
                </a>
              </span>
              <span id="prevHide">
                <a>
                  <img src="../formatter/html/data/common/images/document/indietro_off_.gif" border="0" title="Back" alt="Back" />
                </a>
              </span>      
            </td>
            <td>
              <span id="nextShow" style="display:none;">
                <a href="javascript:void(0)" onclick="return nextHistory();">
                  <img src="../formatter/html/data/common/images/document/avanti_on_.gif" border="0" title="Next" alt="Next" onMouseDown="changeIconPush(this)" onMouseOut="changeIconPop(this)" onMouseUp="changeIconPop(this)"/>
                </a>
              </span>
              <span id="nextHide">
                <a>
                  <img src="../formatter/html/data/common/images/document/avanti_off_.gif" border="0" title="Next" alt="Next" />
                </a>
              </span>      
            </td>
            <td>
              <a href="javascript:void(0)" onclick="window.open('/xway/help/index.html','helpWin');" onmouseover="window.status='Suggestons'; return true" onmouseout="window.status=''"><img alt="Suggestions" title="Suggestions" src="../formatter/html/data/common/images/suggerimenti.gif" border="none" onMouseDown="changeIconPush(this)" onMouseUp="changeIconPop(this)" onMouseOut="changeIconPop(this)"/></a>
            </td>
            <td><xsl:text>&#160;&#160;&#160;&#160;n. records: </xsl:text><xsl:value-of select="count($hxpdata/*[$hxpdata/@db=name()])"/></td>
          </tr>
        </tbody>
      </table>
      <hr/>
    </xsl:if>  

    <xsl:if test="$hxpdata/@verbo='showdoc'">
      <xsl:call-template name="hxpformatter">
        <xsl:with-param name="value" select="'containerof-response'"/>
        <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template match="processing-instruction('xw-sr')">
    <xsl:text disable-output-escaping="yes">&lt;span class="key-hit"></xsl:text>
  </xsl:template>
  
  <xsl:template match="processing-instruction('xw-er')">
    <xsl:text disable-output-escaping="yes">&lt;/span></xsl:text>
    <xsl:if test="count(following-sibling::node()[name()='xw-sr'])>0"><!-- msie 6 ignora uno spazio tra xw-er xw-sr -->
      <xsl:if test="2>count(following-sibling::node()[name()='xw-sr'][position()=1]/preceding-sibling::node())-count(preceding-sibling::node())">
        <xsl:text disable-output-escaping="yes">&#160;</xsl:text>
      </xsl:if>
    </xsl:if>
  </xsl:template>

  <xsl:output method="html" indent="yes" 
    />
  <!--Sarebbe utile per hack di position:fixed per explorer
  encoding="iso-8859-1" doctype-public="-//W3C//DTD XHTML 1.1//EN"
  doctype-system="http://www.w3.org/1999/xhtml"-->
</xsl:stylesheet>

