<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
 <xsl:variable name="_docname" select="/response/@verbo"/>
 <xsl:variable name="hxptemplate" 
               select="document(concat('../html/templates/',concat($_docname,'.html')))"/>
 <xsl:include href="../../../../formatter/factory/index.xsl"/>
 <xsl:template name="customcontent">
  <xsl:param name="templatedata" select="''"/>
  <xsl:choose>
   <xsl:when test="$templatedata='lastelem1'">
    <xsl:if test="not(contains($hxpdata/@xverb,'full'))">
     <xsl:value-of select="floor((count($hxpdata/vocabolario) + 1) div 2)"/>
    </xsl:if>
   </xsl:when>
   <xsl:when test="$templatedata='firstelem2'">
    <xsl:if test="not(contains($hxpdata/@xverb,'full'))">
     <xsl:value-of select="floor((count($hxpdata/vocabolario) + 1) div 2) + 1"/>
    </xsl:if>
    <xsl:if test="contains($hxpdata/@xverb,'full')">
     <xsl:value-of select="number($hxpdata/count) + 1"/>
    </xsl:if>
   </xsl:when>
   <xsl:otherwise>
    <xsl:text>must implement </xsl:text><xsl:value-of select="$templatedata"/><xsl:text> handler</xsl:text>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-testKey']">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:if test="$hxpdata/@shwMode!='hideKey' or string-length($blockData/@descr)=0">
   <xsl:copy>
    <xsl:copy-of select="@*"/>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:copy>
  </xsl:if>
 </xsl:template>

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockData" select="''"/>
	</xsl:template>

	<xsl:template name="contextcustom">
		<xsl:param name="blockData" select="''"/>
		<xsl:param name="specName" select="''"/>
	</xsl:template>	

 <xsl:template match="*[@id='hxp-custom-title']">
  <title>Vocabolario - <xsl:value-of select="$hxpdata/@keypath"/> su <xsl:value-of select="$hxpdata/@db"/></title>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-id']">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$hxpdata/@keypath='grande voce'">
    <a href="javascript:void(0)" onclick="return link2smallvox('{$blockData/@chiave}','piccola voce')">
    <xsl:value-of select="$blockData/@descr"/>
    </a>
   </xsl:when>
   <xsl:when test="$hxpdata/@keypath='grande_voce_penale'">
    <a href="javascript:void(0)" onclick="return link2smallvox('{$blockData/@chiave}','piccola_voce_penale')">
    <xsl:value-of select="$blockData/@descr"/>
    </a>
   </xsl:when>
   <xsl:when test="$hxpdata/@keypath='grande_voce_dottr'">
    <a href="javascript:void(0)" onclick="return link2smallvox('{$blockData/@chiave}','grande_voce_dottr')">
    <xsl:value-of select="$blockData/@descr"/>
    </a>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$blockData/@descr"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="vocabolario/@chiave">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$hxpdata/@shwMode='dt'"> <!-- yyyymmdd -->
    <xsl:choose>
      <xsl:when test="string-length() &lt; 8">
        <xsl:value-of select="."/><xsl:text>****</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="substring(.,7,2)"/><xsl:text>/</xsl:text>
        <xsl:value-of select="substring(.,5,2)"/><xsl:text>/</xsl:text>
        <xsl:value-of select="substring(.,1,4)"/>
      </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:when test="$hxpdata/@shwMode='dt1'"> <!-- yyyy mm dd -->
    <xsl:value-of select="substring(.,9,2)"/><xsl:text>/</xsl:text>
    <xsl:value-of select="substring(.,6,2)"/><xsl:text>/</xsl:text>
    <xsl:value-of select="substring(.,1,4)"/>
   </xsl:when>
   <xsl:when test="$hxpdata/@shwMode='dt2'"> <!-- ddmmyyyy -->
    <xsl:value-of select="substring(.,1,2)"/><xsl:text>/</xsl:text>
    <xsl:value-of select="substring(.,3,2)"/><xsl:text>/</xsl:text>
    <xsl:value-of select="substring(.,5,4)"/>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="."/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-longKey']">
   <xsl:param name="blockData" select="''"/>
   <xsl:if test="'1'=$hxpdata/@doubleKey">
     <xsl:copy>
       <xsl:copy-of select="@*[name()!='id']"/>
       <xsl:copy-of select="*"/>
     </xsl:copy>
   </xsl:if>
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-select_all']">
  <xsl:param name="blockData" select="''"/>
   <xsl:choose>
    <xsl:when test="$hxpdata/@count>0">
     <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
      <xsl:attribute name="onclick">return selectAll(document.vocab);</xsl:attribute>
      <xsl:call-template name="hxpcontinuecontext">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:copy>
    </xsl:when>
    <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
    
 <xsl:template match="*[@id='hxp-custom-select_invert']">
  <xsl:param name="blockData" select="''"/>
   <xsl:choose>
    <xsl:when test="$hxpdata/@count>0">
     <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
      <xsl:attribute name="onclick">return selectInvert(document.vocab);</xsl:attribute>
      <xsl:call-template name="hxpcontinuecontext">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:copy>
    </xsl:when>
    <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>  
 </xsl:template> 

 <xsl:output method="html" indent="yes" encoding="iso-8859-1" />
</xsl:stylesheet>
