<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
 <!-- ...per "settare" il verbo opportunamente in lexs (reflect)... -->
 <xsl:variable name="_doctype" select="/response/@db" />

 <xsl:variable name="_docname">
  <xsl:value-of select="/response/@verbo"/>
  <xsl:if test="/response/@xverb='@print' or /response/@xverb='@save'">
   <xsl:value-of select="'@print'"/>
  </xsl:if>
 </xsl:variable>

 <xsl:variable name="hxptemplate" 
               select="document(concat('../html/templates/',concat($_docname,'.html')))"/>
 <xsl:include href="../../../../formatter/factory/titles.xsl"/>

 <xsl:template name="customcontent">
  <xsl:text>must implement customcontent</xsl:text>
 </xsl:template>

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockData" select="''"/>
	</xsl:template>

	<xsl:template name="contextcustom">
		<xsl:param name="blockData" select="''"/>
		<xsl:param name="specName" select="''"/>
	</xsl:template>	

 <xsl:template match="*[@id='hxp-custom-navbar']">
  <!-- mozilla hangs with document.write (see titles.js) -->
  <span id="titnavbarcode" style="display:none">
   <!--script-->                                    <!-- se nella forma hxp-title-data-navbar-(path) cerca -->
	<xsl:text>/*document.write(*/titnavbarcode(</xsl:text>  <!-- le immagini in (path) altrimenti se nella forma hxp-title-data-navbar usa path di default -->
	<xsl:value-of select="$hxpdata/@pos"/>
	<xsl:text>,</xsl:text>
	<xsl:value-of select="$hxpdata/@count"/>
	<xsl:text>,</xsl:text>
	<xsl:value-of select="$hxpdata/@pageCount"/>
        <!--
	<xsl:if test="substring-after($value,'-')!=''">
		<xsl:text>,'</xsl:text>
		<xsl:value-of select="substring-after($value,'-')"/>
		<xsl:text>'</xsl:text>
	</xsl:if>
        -->
	<xsl:text>)/*)*/</xsl:text>
   <!--/script-->
  </span>
 <!--
  <script>
   <xsl:text>document.write(titnavbarcode(</xsl:text>
   <xsl:value-of select="$hxpdata/@pos"/>
   <xsl:text>,</xsl:text>
   <xsl:value-of select="$hxpdata/@count"/>
   <xsl:text>,</xsl:text>
   <xsl:value-of select="$hxpdata/@pageCount"/>
   <xsl:text>))</xsl:text>
  </script>
  -->
 </xsl:template>

 <!-- Link per la stampa dei documenti - nel caso di raccolta non scriver il nome dell'archivio -->
 <xsl:template match="*[@id='hxp-custom-printLink']">
  <span  class="testoTitolo">
   <a onmouseover="window.status='Print';return true" onmouseout="window.status=''" href="javascript:void(0)" onclick="return printPage()">Print&#160;</a> 
   <xsl:value-of select="$hxpdata/@pageCount" />
   <xsl:choose>
    <xsl:when test="$hxpdata/@selid=$hxpdata/@cId">
     records.&#160;
    </xsl:when>
    <xsl:otherwise>
     records of <xsl:value-of select="$hxpdata/@db" />:&#160;    
    </xsl:otherwise>
   </xsl:choose> 
   <span id="searchString">Search expression</span>
  </span> 
 </xsl:template>

 <xsl:template match="*[@id='hxp-custom-tit']">
  <xsl:param name="blockData" select="$hxpdata"/>
  <!--
   <script>
   -->
    <xsl:choose>
     <xsl:when test="$blockData/@db!=''">
      <xsl:if test="$hxpdata/@selid=$hxpdata/@cId"> <!-- nelle raccolte visualizzo il nome dell'archivio -->
       <xsl:value-of select="$blockData/@db"/><xsl:text> - </xsl:text>
      </xsl:if>
      <!--
      <xsl:text>document.write(formatTitleString('</xsl:text> 
      <xsl:value-of select="$blockData/@db" /><xsl:text>','</xsl:text>
      <xsl:apply-templates select="$blockData/@testo" mode="quoted-value-of" />
      <xsl:text>'))</xsl:text>      
      -->
      <xsl:value-of select="$blockData/@testo" />
     </xsl:when>
     <xsl:otherwise>
      <!--
      <xsl:text>document.write(formatTitleString('</xsl:text> 
      <xsl:value-of select="$hxpdata/@db" /><xsl:text>','</xsl:text>
      <xsl:apply-templates select="$blockData/@testo" mode="quoted-value-of" />
      <xsl:text>'))</xsl:text>
      -->
      <xsl:value-of select="$blockData/@testo" />
     </xsl:otherwise>
    </xsl:choose>
  <!--
   </script>
   -->
 </xsl:template>
 
  <xsl:template match="*[@id='hxp-custom-printdocs']"> <!-- disabilitato nel caso delle raccolte -->  
  <xsl:param name="blockData" select="''"/>            
   <xsl:choose>   
    <xsl:when test="($hxpdata/@selid=$hxpdata/@cId)">
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="disable" select="'1'"/>
     </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
     <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
       <xsl:attribute name="onclick"><xsl:text>return printdocs(</xsl:text><xsl:value-of select="$hxpdata/@count"/><xsl:text>);</xsl:text></xsl:attribute>
       <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>    
       <xsl:call-template name="hxpcontinuecontext">
        <xsl:with-param name="blockData" select="$blockData"/>
       </xsl:call-template>    
     </xsl:copy>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:template>

 <xsl:template match="*[@id='hxp-custom-select_all']">
  <xsl:param name="blockData" select="''"/>
   <xsl:choose>
    <xsl:when test="$hxpdata/@count>0">
     <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
      <xsl:attribute name="onclick">return selectAll(document.theForm);</xsl:attribute>
      <xsl:call-template name="hxpcontinuecontext">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:copy>
    </xsl:when>
    <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
    
 <xsl:template match="*[@id='hxp-custom-select_invert']">
  <xsl:param name="blockData" select="''"/>
   <xsl:choose>
    <xsl:when test="$hxpdata/@count>0">
     <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']"/>
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
      <xsl:attribute name="onclick">return selectInvert(document.theForm);</xsl:attribute>
      <xsl:call-template name="hxpcontinuecontext">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:copy>
    </xsl:when>
    <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>  
 </xsl:template> 

 <xsl:output method="html" indent="yes" encoding="iso-8859-1" />
</xsl:stylesheet>            
