/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
 
 /* titles.js */

 function isDigit(ch)
 {return('0123456789'.indexOf(ch)>=0);
 }
 function dateFormat(s)
 {var delimiter='/';
  if (s.charAt(2)=='/') //already set as (dd/mm/yyyy)
   return s;
  if (s.substring(4,5)==' ')
   return(s.substring(8,10)+delimiter+s.substring(5,7)+delimiter+s.substring(0,4));  //yyyy mm dd
  if(parseInt(s.substring(4,6),10)>12) // ddmmyyyy
   return (s.substring(0,2)+delimiter+s.substring(2,4)+delimiter+s.substring(4,8));
  return (s.substring(6,8)+delimiter+s.substring(4,6)+delimiter+s.substring(0,4)); // yyyymmdd
 }
 function checkNumber(s)
 {var index,start;
  for(index=0;index<s.length;index++)
   if(!isDigit(s.substring(index,index+1)))
    return s;
  if(s.length==8) // date?
   return dateFormat(s);
  for(index=0;index<s.length-1;index++)
   if(s.substring(index,index+1)!='0')
    break;
  return s.substring(index,s.length);
 }
 function formatTitleString(db,tit)
 {tit=tit+' '; // add final blank to have an homogeneous behaviour
  var result='',last=0,pos=0,stop;
  for(;;)
  {pos=tit.indexOf(' ',pos);
   if(pos==-1)break;
   if(isDigit(tit.substring(pos+1,pos+2)))
   {stop=tit.indexOf(' ',pos+1);
    if(stop==-1)break;
    result+=tit.substring(last,pos+1);
    result+=checkNumber(tit.substring(pos+1,stop));
    pos=last=stop;
   }
   else pos++;
  }
  result+=tit.substring(last,tit.length);
  var i_index=result.indexOf(". 0 ");
  if((i_index>-1)&&(i_index<5))//???
   result=result.substring(0,i_index+1)+result.substring(i_index+3);
  return formatTitle(db,result);
 }
 function formatTitle(db, tit) 
 {var retTitle = "";
  var hasBody = false;
  var titleSplitted = tit.split(" |");
  if(titleSplitted[0] == '') {
    tit = tit.substring(2);
    titleSplitted = tit.split(" |");
  }
  var vuoto = 1;
  for(idx=0; idx < titleSplitted.length; idx++) {
    if( (titleSplitted[idx] != '') && (titleSplitted[idx] != ' ') ) {
      vuoto = 0;
      break;
    }
  }
  if(vuoto) titleSplitted[0] = "Empty Title";
  if(titleSplitted.length<2)
  {titleSplitted=tit.split(" - ");
   if(titleSplitted.length<2 || db=='eurius') return tit;
  }
  else if(titleSplitted.length>2)
   hasBody=true;
  retTitle += '<span style="color:blue;">' + titleSplitted[0] + '</span>' +'</span></a><span class=testoTitolo>';
  if(hasBody) 
  {retTitle += '&#160;<span style="color:green;font-style:italic">' + titleSplitted[1] + '</span>';
   retTitle += '<span style="color:black;">';
   for(var index=2;index<titleSplitted.length;index++)
    retTitle += '&#160;'+titleSplitted[index];
   retTitle += '</span>';
  }
  else
  {retTitle+='<span style="color:black;">';
   for(var index=1;index<titleSplitted.length;index++)
   {retTitle+='&#160;';
    if(index>1)retTitle+='-&#160;';
    retTitle+=titleSplitted[index];
   }
   retTitle+='</span>';
  }
  return retTitle+'<hr size="1"/><a>';
 }
 function hitme(current, // choosed range
                pos,count,pageCount,
                total)  // numbero of ranges in which the selection has been splitted
 {var totSel=count;
  var perPage=pageCount;
  var firstInPage=pos;
  var numPages=(totSel+perPage-1)/perPage;
  var curPage=firstInPage/perPage; // zero based
 }
 var maxHits=16;     // number of tabs for fast forwarding between pages
 function nav2page(index,pos,count,pageCount,fwd)
 {var totSel=count;
  var perPage=pageCount;
  var firstInPage=pos;
  var numPages=Math.floor((totSel+perPage-1)/perPage);
  var curPage=Math.floor(firstInPage/perPage); // zero based
  var totHits=(maxHits>numPages?numPages:maxHits);
  var pagesPerHit=(1.+numPages)/totHits;
  var navPos=Math.floor(pagesPerHit*perPage*index);
  navPos=Math.floor(navPos/perPage)*perPage;
  if(navPos==pos)
   navPos+=fwd?pageCount:-pageCount;
  getForm("hxpForm").verbo.value='showtitles';
  getForm("hxpForm").pos.value=navPos;
  getForm("hxpForm").submit();
  return false;
 }
 function titnavbarcode(pos,count,pageCount)
 {var totSel=count;
  var perPage=pageCount;
  var firstInPage=pos;
  var numPages=Math.floor((totSel+perPage-1)/perPage);
  var curPage=Math.floor(firstInPage/perPage); // zero based
  if(numPages<=4)return '';
  var totHits= (maxHits>numPages?numPages:maxHits);
  var pagesPerHit=(1.+numPages)/totHits;
  var result='';
  var firstR=true;
  for(var index=0;index<totHits;index++)
  {var hitPage=Math.floor(index*pagesPerHit);
   if(index==0&&curPage==0);
   else if(index==totHits-1&&curPage==numPages-1)
    result+='<img src="../formatter/html/data/images/titles/a_rr.gif" alt="a_rr" />';
   else if(hitPage>curPage)
   {if(firstR)
    {firstR=false;
     result+='<img src="../formatter/html/data/images/titles/a_rl.gif" alt="a_rl" />';
    }
    result+='<img onclick="nav2page('+index+','+pos+','+count+','+pageCount+',true)" src="../formatter/html/data/images/titles/a_gr.gif" title="page '+(1+hitPage)+'" alt="page '+(1+hitPage)+'" />';
   }
   else if(hitPage==curPage);
   else result+='<img onclick="nav2page('+index+','+pos+','+count+','+pageCount+',false)" src="../formatter/html/data/images/titles/a_gl.gif" title="page '+(1+hitPage)+'" alt="page '+(1+hitPage)+'" />';
  }
  return result;
 }
 function customLoadHandler()
 {var queryFrase = writeFrase(1000);
  /* change page title */
  if((getForm("hxpForm").selid.value == getForm("hxpForm").cId.value) && (getForm("hxpForm").xverb.value == '@print')) // collection print 
   document.title = 'Stampa - ' + queryFrase;  
  else if(getForm("hxpForm").selid.value == getForm("hxpForm").cId.value) // if it's a collection 
   document.title = queryFrase;
  else if(getForm("hxpForm").xverb.value == '@print') // if print title page
   document.title = getForm("hxpForm").db.value.toUpperCase() + ' Stampa - ' + queryFrase;
  else
   document.title = getForm("hxpForm").db.value.toUpperCase() + ' ' + queryFrase;
  // notify the opener of the positive end
  if(parseInt(getForm("hxpForm").count.value)>0&&
     typeof(opener)!='undefined'&&typeof(opener.document.theForm)!='undefined'&&
     typeof(opener.document.theForm.lastqueryid)!='undefined')
  {opener.document.theForm.lastqueryid.value=getForm("hxpForm").selid.value;
   opener.document.theForm.exportDocs.disabled=false;
   opener.getForm("hxpForm").sele.value=getForm("hxpForm").sele.value;//rw-0028883
  }
 }

