<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "java.util.Date" %>
<%@ page import = "it.highwaytech.util.Text" %>
<%@ page import = "it.highwaytech.util.RawData" %>
<%@ page import = "it.highwaytech.broker.Broker" %>
<%@ page import = "it.highwaytech.broker.ServerObserver" %>
<%@ page import = "it.highwaytech.broker.ServerCommand" %>
<%@ page import = "it.highwaytech.apps.JRequest" %>
<%@ page import = "it.highwaytech.apps.AttachPrint" %>
<%@ page import = "it.highwaytech.apps.ShowFcsTxtAttachInfo" %>
<%@ page import = "org.dom4j.*" %>
<%@ include file = "resource.jsp" %>
<%
 String pageTitle = appTitle;
 // see also: jsp.js
 //                             0 (db)        1        2         3           4
 final String menuitems[]={defaultMenuItem,"record","index","thesaurus","connection"};
 final String verbo_catalogazione_XML    = "map";
 final String verbo_elenco_chiavi_XML    = "view structure";
 final String verbo_rigenerazione_titoli = "renew cache";
 final String verbo_rigenerazione_indici = "rebuild";
 final String verbo_indicizzazione       = "update";
 final String verbo_compattamento_indici = "compact";
 final String verbo_compattamento_db     = "compact";
 final String verbo_staticizzazione_db   = "make static";
 final String verbo_riapertura_archivio  = "reopen";
 final String verbo_crea_azzera_archivio = "create";
 final String verbo_watch                = "watch";
 final String verbo_viewer               = "search and view";
 final String verbo_tools                = "tools";
 final String verbo_thimport             = "import";
 final String verbo_thexport             = "export";
 final String verbo_thsex                = "list";
 final String verbo_doc                  = "modify";
 final String verbo_checkvoc             = "check";
 final String verbo_calcola_impronta     = "hash";
 final String verbo_elimina_chiave       = "delete";
 final String verbo_confronta_chiavi     = "compare";
 final String verbo_connessioni          = "list";
 final String verbo_riorganizzazione_unita_informative = "relocate";
 final String verbo_elimina_doc          = "delete";

 // Federico 05/02/09: integrato jsp per rimozione di piu' documenti nei tools [RW 0056678]
 final String verbo_elimina_doc_multi    = "multiple delete";

 final String verbo_hier_browser         = "hier browser";
 final String verbo_hier_root            = "hier root";
 final String verbo_desCipher            = "des cipher";
 final String verbo_docImport            = "import";
 final String verbo_keylist              = "list";
 final String verbo_model                = "model";
 final String verbo_server_info          = "server info";
 final String verbo_headers              = "headers";
 final String verbo_XMLCommand           = "xml command";
 final String verbo_getmail              = "get mail";
 final String verbo_sendmail             = "send mail";
 final String verbo_properties           = "properties";

 // Federico 10/07/08: introdotto recupero delle informazioni sugli allegati testuali prodotti dal File Conversion Service
 // nell'estrazione del testo [RW 0053061]
 final String verbo_fcs_txt_info         = "Attach indexing info";

 Broker broker = null;
 JRequest rq = null;
 int conn=-1;
 try
 {rq = new JRequest(request);
  String theMenublock = rq.readStringParameter("menublock",defaultMenuItem);

  String theSkin   = rq.readStringParameter("skin","jsp");
  String theDb     = rq.keyVal("db");
  String theDbPath = rq.keyVal("dbPath");
  String theHost   = rq.keyVal("host");
  String thePort   = rq.keyVal("port");
  String theUser   = rq.readStringParameter("user","");
  String thePassword = rq.keyVal("pwd");
  String thePath   = rq.keyVal("path");

  final String inputInitTitle             = "Set the full path of the archive .stat.xml file (extension excluded)";
  final String submitInitTitle            = "Create a new archive following the given path.\nOn an existing archive, cause deletion of map and indexes";
  final String inputCatTitle              = "Set the full path of the directory contaning the XML files to map";
  final String submitCatTitle             = "Start mapping of Information Units from given path.\n'Mapping' means that for each XML files found in the given path, eXtraWay Server will recognize existing Information Units and feed the archive map with their reference";
  final String checkCatTitleTitle         = "Reset title cache at the end of mapping procedure";
  final String checkCatCmpIndexTitle      = "Pack indexex (also used by '"+verbo_rigenerazione_indici+"')";
  final String checkCatOwnerTitle         = "Only records mapped with ownership can be modified";
  final String relocateTitle              = "Apply a new file location rule";

%>
 <html>
 <head>
   <!--
  < %@ include file = "head.jsp" % >
    -->
  <script language="JavaScript" src="jsp.js"></script>
  <link rel="stylesheet" href="<%= theSkin %>.css" type="text/css"/>
  <title><%= titleString %></title>
 </head>
 <body onload="consoleLoadHandler()">
<%
  String verbo=rq.keyVal("verbo");
  boolean createDb=(verbo.compareTo(verbo_crea_azzera_archivio)==0&&theDbPath!=null&&theDbPath.length()>0);
  broker = new Broker();
  if(rq.numTuples>0&&verbo.length()>0&&theDb!=null&&theDb.length()>0)
  {
   appTitle=pageTitle;
   pageTitle=verbo;
   %>
   <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
   <tbody style="width:100%;height:92%">
   <tr style="width:100%;height:2%">
    <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
   </tr>
   <tr style="width:100%;height:100%">
    <td class="pageframe" style="width:100%;height:100%">
     <div style="width:100%;height:90%;overflow:auto;">
     <%@ include file = "console/worker.jsp" %>
     </div>
    </td>
   </tr>
   </tbody>
   </table>
   <%
  }
  else
  {%>
   <form style="height:100%;" onKeyPress="checkSubmit(event)" method="post" name="theForm" onsubmit="return true;" action="<%= rq.hwScript %>">
   <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
   <tbody>
    <tr style="width:100%;">
     <td class="pageframe" colspan="2" valign="top" height="2%">
      <table width="100%" cellpadding="0" cellspacing="0">
       <tr>
        <td align="left"><h2>&#160Main Menu</h2></td>
        <td align="right"><h2><a style="text-decoration:none" href="javascript:changeLocation('tools')"><%= pageTitle %></a></h2></td>
       </tr>
      </table>
     </td>
    </tr>
    <tr style="width:100%">
     <td class="pageframe" valign="top">
      <%@ include file = "console/menu.jsp" %>
     </td>
     <td style="width:100%" class="pageframe" valign="top">
      <%@ include file = "console/content.jsp" %>
     </td>
    </tr>
    <!--
    <tr>
     <td rowspan="2" class="pageframe" valign="top">
      < %@ include file = "console/menu.jsp" %>
     </td>
     <td class="pageframe" colspan="2" valign="top" align="right" height="2%">
      <h2><%= pageTitle %></h2>
     </td>
    </tr>
    <tr>
     <td class="pageframe" valign="top" height="100%">
      < %@ include file = "console/content.jsp" %>
     </td>
     <td rowspan="2" class="pageframe" valign="top">
      &#160;
     </td>
    </tr>
    <tr>
     <td colspan="2" class="pageframe">
      &#160;
     </td>
    </tr>
    -->
   </tbody>
   </table>
   </form>
   <%
  }
 }
 catch(Throwable t)
 {t.printStackTrace();
  %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
 }
 finally
 {if(broker!=null&&conn>=0)broker.releaseConnection(conn);
  if(rq!=null)rq.close();
 }
%>

 </body>
 </html>
