<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "it.highwaytech.broker.XMLCommand" %>
<%@ page import = "it.highwaytech.broker.ServerObserver" %>
<%@ include file = "resource.jsp" %>
<% 
 final String pageTitle = "importazione";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
<body> 
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>   
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{
 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theQuery = rq.keyVal("query");
 String theUpdate = rq.keyVal("update");
 String theValidate = rq.keyVal("validate");
 byte[] theFile  = rq.keyFile("file");
 
 String theSkin  = rq.readStringParameter("skin","jsp");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     (theFile!=null && theFile.length>0)
     ) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword))
  {
   String fileName = rq.keyVal("file");
   String theName = fileName;
   int pos = theName.lastIndexOf("\\");
   if (pos>=0) theName = theName.substring(pos+1);
   pos = theName.lastIndexOf("/");
   if (pos>=0) theName = theName.substring(pos+1);
   String theExt = "xml";
   pos = theName.lastIndexOf(".");
   if (pos>=0) theExt = theName.substring(pos+1).toLowerCase();
   String theId = broker.addAttach(conn,theDb,theFile,theName,true);
   int bits = XMLCommand.importXML;
   if (theExt.equals("csv")) bits = XMLCommand.importCSV|XMLCommand.importIntermediate;
   if (!theValidate.equals("1")) bits|=XMLCommand.importNOV;
   boolean update = theUpdate.equals("1");
   if (update) bits |= XMLCommand.importUpdate;
   XMLCommand theCommand = new XMLCommand(theId,bits);
   
   synchronized(broker.observers)
   {
      int theObsID = -1;
      try
      {
            String coordString = theDb+(theHost.length()>0?("@"+theHost+(thePort.length()>0?(":"+thePort):"")):"");
            ServerObserver theObserver = new ServerObserver(new java.util.Date(), "import" + (update?" ":" no ") + "update " + coordString);
            theObsID = broker.storeObserver(theObserver);
            broker.XMLCommand(conn,theDb,theCommand.toString(),theObsID);
            %>
            <jsp:forward page="watch.jsp" />
            <% 
      }
      catch (Exception e)
      {
         if (theObsID !=-1) broker.removeObserver(theObsID);
         throw e;
      }
   
   }
   /*
   String result = broker.XMLCommand(conn,theDb,theCommand.toString());
   int ack=XMLCommand.getAcknowledge(result);
   if(ack==0) 
   {
     % ><%= "<b>Error code: " + XMLCommand.getErrorCode(result) + "</b>" % ><%
   }
   else
   {
     % ><%= "<b>Done!</b>" % ><%
   }
   */
  }
  else 
  {
   %><b>Cannot connect!<b><%;
  }
 }
 else 
 {
  %>
   <form enctype="multipart/form-data" name="theForm" method="post" action="<%= rq.hwScript %>">
   <table>
   <%@ include file = "console/connData.jsp" %>  
   <tbody>
   <tr>
    <td colspan="3"><input class="file" type="file" name="file"></td>
    <td>file</td>
   </tr>
   <tr>
    <td colspan="2"><input type="checkbox" name="update" value="1" style="width:1em;background-color:white">&#160update</td>
    <td colspan="2"><input type="checkbox" name="validate" value="1" style="width:1em;background-color:white">&#160validate</td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" type="submit" value="submit"></td>
    <td colspan="3"></td>
   </tr> 
   </tbody>
   </table>     
   </form>
  <%
 }
}
catch(Throwable t) 
{
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally 
{
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
  </td>
  </tr> 
  </tbody>  
  </table>
 </body> 
 </html> 
 <%
}

%>

