<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%@ page import = "it.highwaytech.broker.ServerObserver" %>
<%@ page import = "it.highwaytech.broker.*" %>
<%@ page import = "it.highwaytech.util.*" %>
<%@ page import = "it.highwaytech.apps.JRequest" %>
<%@ page import = "it.highwaytech.db.QueryResult" %>
<%@ include file = "resource.jsp" %>
<%
// Federico 05/02/09: classe introdotta per consentire l'uso di un observer per il monitoraggio dell'esecuzione [RW 0056678]
class MultipleDelete extends ServerObserverThread {

    final Log log = LogFactory.getLogger(MultipleDelete.class);

    Broker broker;
    String dbName;
    ServerObserver o;
    QueryResult qr;
    int connId;

    public MultipleDelete(Broker broker, int connId, String dbName, int observerId, QueryResult qr) {
        super(broker, connId, dbName, null, 0, observerId);

        this.broker = broker;
        this.dbName = dbName;
        this.connId = connId;
        this.qr     = qr;
        this.o      = broker.getObserver(observerId);
    }

    public void run() {
        log.info("MultipleDelete.run(): ************************** method start **************************");
        log.info("MultipleDelete.run(): found " + qr.elements + " docs to be deleted");

        o.storeStatus("Cancellazione documento ");
        o.updateDoc(0);
        o.openStat(qr.elements);

        try {
            for (int ii = 1; ii < qr.elements + 1 ; ii++) {
                int docNumber = broker.getNumDoc(connId, dbName, qr, ii - 1);

                broker.removeDoc(connId, dbName, docNumber);

                o.updateDoc(ii);

                log.info("MultipleDelete.run(): done " + ii);
            }

            o.storeStatus(" ... operazione conclusa.<br/><br/>");
        }
        catch(Exception e) {
            log.error("MultipleDelete.run(): got exception:", e);
            o.storeException(e);
        }
        finally {
            o.end();

            log.info("MultipleDelete.run(): ************************** method end **************************");
        }
    }
}

final String pageTitle = "cancellazione documenti";
%>
<html>
<head>
 <%@ include file = "head.jsp" %>
<body>
  <table class="pageframe" style="width:100%;height:100%" cellpadding="8" cellspacing="10">
  <tbody>
  <tr class="pageframe" height="2%">
   <td class="pageframe" height="2%"><%@ include file = "top.jsp" %></td>
  </tr>
  <tr class="pageframe" height="100%">
  <td class="pageframe" valign="top">
<%
Broker broker = null;
int conn      = -1;
JRequest rq   = null;
Log log       = LogFactory.getLogger(JRequest.class);


try
{
 rq = new JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theQuery = rq.keyVal("query");
 String theDoc   = rq.keyVal("idDoc");
 String theSkin  = rq.readStringParameter("skin","jsp");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     ((theDoc!=null && theDoc.length()>0)||(theQuery!=null && theQuery.length()>0))
     ) {
  broker = new Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword))
  {
   if(theQuery!=null && theQuery.length()>0)
   {
    QueryResult qr=broker.find(conn,theDb,theQuery,"",0,-1,0);
    if(qr.elements==1)
    {int docNumber=broker.getNumDoc(conn,theDb,qr,0);
     broker.removeDoc(conn,theDb,docNumber);
     %><b>Done!</b><%;
     log.info("removeMultipleDoc.jsp - Sinlgle doc - Done");
    }
    else
    {
    // Federico 05/02/09: introdotto un observer per il monitoraggio dell'esecuzione  [RW 0056678]
	ServerObserver o  = new ServerObserver(new java.util.Date(), "Cancellazione dei " + qr.elements + " documenti trovati dalla query " + theQuery);
    (new MultipleDelete(broker, conn, theDb, broker.storeObserver(o), qr)).start();

     %><%= o.title %><%
     %><br><br><form method="post" action="watch.jsp"><input type="hidden" name="id" value="<%= String.valueOf(o.getObserverId()) %>">
     <input type="hidden" name="skin" value="<%= theSkin %>"><input class="typeButton" type="submit" value="watch..."></form><%
    }
   }
   else
   if (theDoc!=null && theDoc.length()>0)
   { broker.removeDoc(conn,theDb,Integer.parseInt(theDoc));
     %><b>Done!<b><%;
	log.info("removeMultipleDoc.jsp - Sinlgle doc - Done");
   }
   else
   {
     %><b>???<b><%;
   }
  }
  else
  {
   %><b>Cannot connect!<b><%;
  }
 }
 else
 {
  %>
   <form name="theForm" method="post" action="<%= rq.hwScript %>">
   <!-- Federico 05/02/09: allargato l'input della query [RW 0056678] -->
   <table>
   <%@ include file = "console/connData.jsp" %>
   <tbody>
   <tr>
    <td colspan="3"><input style="width: 100%" type="text" name="query" value="<%= theQuery!=null&&theQuery.length()>0?theQuery:"" %>"></td>
    <td colspan="1">query</td>
   </tr>
   <tr><td colspan="4"></td></tr>
   <tr>
    <td><input class="typeButton" onclick="return confirm('All record into the resul set will be deleted, do you confirm?')" type="submit" value="submit"></td>
    <td colspan="3"></td>
   </tr>
   </tbody>
   </table>
   </form>
  <%
 }
}
catch(Throwable t)
{
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally
{
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close();
 %>
  </td>
  </tr>
  </tbody>
  </table>
 </body>
 </html>
 <%
}
%>

