<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{rq = new it.highwaytech.apps.JRequest(request);
 String theDb         = rq.keyVal("db");
 String theHost       = rq.keyVal("host");
 String thePort       = rq.keyVal("port");
 String theUser       = rq.keyVal("user");
 String thePassword   = rq.keyVal("pwd");
 String theField      = rq.keyVal("field");
 String theTable      = rq.keyVal("tablename");
 String theStylesheet = rq.keyVal("stylesheet");
 String theRels       = rq.keyVal("relation");
 if(rq.numTuples>0&&theDb.length()>0&&theField.length()>0) 
 {broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if(conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) 
  {int domain = rq.readIntParameter("domain",0xff);
   it.highwaytech.db.ThsKey theKey,lastKey=null;
   int thsMode = 0;//it.highwaytech.broker.ServerCommand.btree_FREQUENZE;
   java.util.Vector result = null;
   int keyCount = rq.readIntParameter("keyCount",256);
   int relNumber = rq.readIntParameter("rl",0);
   int rels[]=(theRels.length()>0?it.highwaytech.util.Text.split2intArray(theRels,","):null);

   // tenta una lettura prima di impostare ContentType e outputStream, in caso di eccezione...
   result = broker.getThsKeys(conn,theDb,theTable,theField,
                              lastKey==null?"":lastKey.getParent(),
                              lastKey==null?relNumber:lastKey.getRel(),
                              domain,
                              lastKey==null?"":lastKey.getParent(),
                              "",1,
                              it.highwaytech.broker.ServerCommand.btree_NEXTKEY,
                              thsMode);

   response.setContentType("text/xml");
   java.io.OutputStream outputStream = response.getOutputStream();

   outputStream.write(("<?xml version=\"1.0\" encoding=\"iso-8859-1\" standalone=\"yes\"?>\r\n").getBytes());
   if(theStylesheet.length()>0)outputStream.write(("<?xml-stylesheet type=\"text/xsl\" href=\""+theStylesheet+"\"?>\r\n").getBytes());
   outputStream.write(("<!DOCTYPE thes\r\n").getBytes());
   outputStream.write((" [<!ELEMENT thes (term)*>\r\n").getBytes());
   outputStream.write(("  <!ATTLIST thes db  CDATA #IMPLIED\r\n").getBytes());
   outputStream.write(("                 key CDATA #IMPLIED>\r\n").getBytes());
   outputStream.write(("  <!ELEMENT term (name,(rel)+)>\r\n").getBytes());
   outputStream.write(("  <!ELEMENT rel  (type,name)>\r\n").getBytes());
   outputStream.write(("  <!ELEMENT name (#PCDATA)>\r\n").getBytes());
   outputStream.write(("  <!ELEMENT type (#PCDATA)>\r\n").getBytes());
   outputStream.write((" ]>\r\n").getBytes());

   outputStream.write(("<thes db=\""+theDb+"\" key=\""+theField+"\">\r\n").getBytes());
   for(;;)
   {result = broker.getThsKeys(conn,theDb,theTable,theField,
                               lastKey==null?"":lastKey.getParent(),
                               lastKey==null?relNumber:lastKey.getRel(),
                               domain,
                               lastKey==null?"":lastKey.getParent(),
                               "",keyCount,
                               it.highwaytech.broker.ServerCommand.btree_NEXTKEY,
                               thsMode);
    if(result==null)break;
    if(lastKey!=null&&result.size()==1)
    {outputStream.write((" </term>\r\n").getBytes());
     break;
    }
    for(int index=(lastKey==null?0:1); index<result.size(); index++)
    {theKey = (it.highwaytech.db.ThsKey)result.get(index);
     boolean skipThis=(rels!=null);
     if(skipThis)
      for(int relPos=0;relPos<rels.length;relPos++)
       if(rels[relPos]==theKey.getRel())
       {skipThis=false;
        break;
       }
     if(!skipThis)
     {if(lastKey==null||lastKey.getParent().compareTo(theKey.getParent())!=0)
       outputStream.write(((lastKey==null?"":" </term>\r\n")+" <term>\r\n  <name>"+theKey.getParent()+"</name>\r\n").getBytes());
      outputStream.write(("  <rel>\r\n   <type>"+theKey.getRel()+"</type>\r\n   <name>" + theKey.getChild() + "</name>\r\n  </rel>\r\n").getBytes());
      lastKey=theKey;
     }
    }
   }
   outputStream.write(("</thes>").getBytes());
   outputStream.flush();
   outputStream.close();
  }
  else {%>Cannot connect!<%;}
 }
 else 
 {%>
   <html>
   <head>
   <title>thesaurus</title>
   <link rel="stylesheet" href="jsp.css" type="text/css"/>
   </head>
   <body> 
   <h2>thesaurus</h2>
   <form method="post" action="<%= rq.hwScript %>">
        <input type="text"     name="host"       value="<%= theHost.length()>0?theHost:"" %>"  > host
    <br><input type="text"     name="port"       value="<%= thePort.length()>0?thePort:"" %>"           > port
    <br><input type="text"     name="user"       value="<%= theUser.length()>0?theUser:"" %>"    > username
    <br><input type="password" name="pwd"        value="<%= thePassword.length()>0?thePassword:"" %>"   > password
    <br><input type="text"     name="db"         value="<%= theDb.length()>0?theDb:"" %>"               > db
    <br><input type="hidden"   name="tablename"  value="<%= theTable.length()>0?theTable:"tabella" %>"  > table
    <br><input type="text"     name="field"      value="<%= theField.length()>0?theField:"generico" %>" title="canale del thesaurus dichiarato nel conf"> field 
    <br><input type="text"     name="relation"   value="<%= theRels.length()>0?theRels:"" %>"           title="indici comma delimited delle relazioni da esportare come da dsp (opzionale)"> relation
    <br><input type="text"     name="stylesheet" value="<%= theStylesheet %>"                           title="riferimento al foglio di stile da referenziare (opzionale)"> stylesheet
    <input type="hidden" name="rl" value="">
    <br><br><input type="submit" value="submit">
   </form>
   </font> 
   </body> 
   </html> 
  <%
 }
}
catch(Throwable t) 
{t.printStackTrace();
 %><%= "\r\nSorry, an exception occurred: \r\n"+t.toString()+"\r\n" %><%
}finally 
{if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
}
%>
