<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>

<html>
<head>
<title>Cancellazione relazioni Thesaurus</title>
<link rel="stylesheet" href="jsp.css" type="text/css"/>
</head>
<body> 
<h2>Cancellazione relazioni Thesaurus</h2>
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try {

 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");

 if (rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) {
   boolean noMoreKeys = false;
   java.util.Vector result = null;
   int keyCount = 128, thsMode = 0; 
   it.highwaytech.db.ThsKey theKey, startKey;
   int theRel = rq.readIntParameter("rl",0);
   int domain = rq.readIntParameter("domain",0xff);
   int relCounter = 0;
   String theParent = rq.readStringParameter("t1","");
   String theChild = rq.readStringParameter("t2","");

    startKey = new it.highwaytech.db.ThsKey(broker.keyString2ThsNumber(conn,theDb,
                                                                       theTable,theField),
                                            theParent.getBytes(),
                                            theRel,domain,
                                            theChild.getBytes());

    while(noMoreKeys==false){

      result = broker.getThsKeys(conn,theDb,
                                 theTable,theField,
                                 theParent,theRel,domain,theChild,theParent,
                                 keyCount,
                                 it.highwaytech.broker.ServerCommand.btree_NEXTKEY,
                                 thsMode);
    
      if(result==null)
        break;

      for(int index=0; index<result.size(); index++){
        theKey = (it.highwaytech.db.ThsKey)result.get(index);
        if(theParent.length()>0 && theParent.compareTo(theKey.getParent())!=0){
          noMoreKeys = true;
          break;
        }
        if((theRel==0 || theRel==theKey.getRel()) &&
           (theChild.length()==0 || theChild.compareTo(theKey.getChild())!=0)){
          if(broker.deleteThsKey(conn,theDb,theKey,null)>0)
           relCounter++;
          else{
           %><b>Error<b> deleting '<%= theKey.getChild() %>' <%= ""+theKey.getRel() %> '<%= theKey.getChild() %>'<br><%;
          }
        }
      }
      if(result.size()<keyCount)
        break;

      startKey = (it.highwaytech.db.ThsKey)result.get(result.size()-1);
    }
    %> <b><%= ""+relCounter %></b> relazioni cancellate <%;
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else {
  %>
   <form method="post" action="<%= rq.hwScript %>">
        <input type="text" name="host"  value="<%= theHost!=null&&theHost.length()>0?theHost:"" %>">   host
    <br><input type="text" name="port"  value="<%= thePort!=null&&thePort.length()>0?thePort:"" %>">            port
    <br><input type="text" name="user"  value="<%= theUser!=null&&theUser.length()>0?theUser:"" %>">     username
    <br><input type="password" name="pwd"  value="<%= thePassword!=null&&thePassword.length()>0?thePassword:"" %>"> password
    <br><input type="text" name="db"    value="<%= theDb!=null&&theDb.length()>0?theDb:"" %>">                  db
    <br><input type="text" name="tablename" value="<%= theTable!=null&&theTable.length()>0?theTable:"tabella" %>"> table
    <br><input type="text" name="field" value="<%= theField!=null&&theField.length()>0?theField:"generico" %>"> field
    <br><input type="text" name="t1" value=""> parent
    <br><input type="text" name="rl" value=""> rel (number)
    <br><input type="text" name="t2" value=""> child
    <br><br><input type="submit" value="Cancella Relazioni">
   </form>
  <%
 }
}catch(Throwable t) {
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}finally {
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
 %> 
 </font> 
 </body> 
 </html> 
 <%
}

%>

