<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<%@ page import = "java.sql.*" %>
<%@ page import = "java.util.*" %>
<%
it.highwaytech.broker.Broker broker = null;
int conn=-1;
it.highwaytech.apps.JRequest rq = null;

try 
{
 rq = new it.highwaytech.apps.JRequest(request);
 String theDb    = rq.keyVal("db");
 String theHost  = rq.keyVal("host");
 String thePort  = rq.keyVal("port");
 String theUser  = rq.keyVal("user");
 String thePassword = rq.keyVal("pwd");
 String theField = rq.keyVal("field");
 String theTable = rq.keyVal("tablename");
 String theStart = rq.keyVal("start");
 String theVrels = rq.keyVal("vrels");
 String theXrels = rq.keyVal("xrels");
 String theCommon= rq.keyVal("common");
 String editMode = rq.keyVal("editMode");
 String theBound = rq.keyVal("bound");
 int theLastrel  = rq.readIntParameter("lastrel",0);
 boolean keyLower= rq.readIntParameter("keylower",0)!=0?true:false;;
 boolean isEdit  = rq.keyVal("edit").length()>0 && Integer.parseInt(rq.keyVal("edit"))==1?true:false;
 boolean isStart = rq.keyVal("isStart").length()>0 && Integer.parseInt(rq.keyVal("isStart"))==1?true:false;

 if (!isStart && rq.numTuples>0 &&
     theDb!=null && theDb.length()>0 &&
     theField!=null && theField.length()>0) 
 {
  broker = new it.highwaytech.broker.Broker();
  int iPort = (thePort!=null && thePort.length()>0)?Integer.parseInt(thePort):-1;
  conn = broker.acquireConnection(theHost,iPort,theDb,"","",-1);
  if (conn>=0 && broker.Connect(conn,theHost,iPort,theDb,-1,theUser,thePassword)) 
  {
   int domain = rq.readIntParameter("domain",0xff);
   it.highwaytech.db.KeyPath keyPath;
   int thsMode = 0; //it.highwaytech.broker.ServerCommand.btree_FREQUENZE;
   it.highwaytech.db.KeyPathList result = null;
   int keyCount = rq.readIntParameter("keyCount",256);
   int relNumber = rq.readIntParameter("rl",0);
   int counter=0;

   response.setContentType("text/plain");
   java.io.OutputStream outputStream = response.getOutputStream();

   outputStream.write(("db=\""+theDb+"\" key=\""+theField+"\r\n").getBytes());

   for(;;)
   {result=broker.getKeysEx(conn,
                            theDb,
                            theTable,
                            theField,
                            (byte)domain,
                            keyCount,
                            it.highwaytech.broker.ServerCommand.btree_NEXTKEY|
                            it.highwaytech.broker.ServerCommand.btree_ONSTARTBROKENNOBREAK,
                            theVrels,
                            theXrels,
                            theCommon,
                            counter!=0?result.keyPath(result.length()-1).toString():theStart,
                            (byte)theLastrel,
                            theBound
                            );
    if(result==null||(counter!=0&&result.length()==1))break;
    boolean writeEnable;
    counter++;
    for(int index=0; index<result.length(); index++)
    {it.highwaytech.db.KeyPath elem=result.keyPath(index);
     it.highwaytech.db.KeyPath prev=index>0?result.keyPath(index-1):null;
     writeEnable = false;
     for(int j=0;j<elem.length();j++)
     {writeEnable = writeEnable || 
                    index==0 || 
                    prev.length()<j+1 || 
                    (j!=0 && elem.getRel(j-1)!=prev.getRel(j-1)) ||
                    elem.getTerm(j).compareTo(prev.getTerm(j))!=0;
      if(writeEnable)outputStream.write((""+elem.getTerm(j)+"\r\n").getBytes());
     }
    }
//if(counter==4)break;
   }
   outputStream.flush();
   outputStream.close();
  }
  else {%><b>Cannot connect!<b><%;}
 }
 else 
 {
  %>
  <html>
  <head>
  <title>thesaurus</title>
  <link rel="stylesheet" href="jsp.css" type="text/css"/>
  </head>
  <body> 
  <h2>thesaurus</h2>

   <form method="post" action="<%= rq.hwScript %>">
        <input type="text"     name="host"      value="<%= theHost!=null&&theHost.length()>0?theHost:"" %>">    host
    <br><input type="text"     name="port"      value="<%= thePort!=null&&thePort.length()>0?thePort:"" %>">             port
    <br><input type="text"     name="user"      value="<%= theUser!=null&&theUser.length()>0?theUser:"" %>">      username
    <br><input type="password" name="pwd"       value="<%= thePassword!=null&&thePassword.length()>0?thePassword:"" %>"> password
    <br><input type="text"     name="db"        value="<%= theDb!=null&&theDb.length()>0?theDb:"" %>">                   db
    <br><input type="text"     name="tablename" value="<%= theTable!=null&&theTable.length()>0?theTable:"tabella" %>">   table
    <br><input type="text"     name="field"     value="<%= theField!=null&&theField.length()>0?theField:"generico" %>">  field
    <br><input type="text"     name="vrels"     value="<%= theVrels!=null&&theVrels.length()>0?theVrels:"" %>">          relazioni visibili
    <br><input type="text"     name="xrels"     value="<%= theXrels!=null&&theXrels.length()>0?theXrels:"" %>">          relazioni espanse
    <br><input type="text"     name="common"    value="<%= theXrels!=null&&theCommon.length()>0?theCommon:"" %>">        percorso di relazione richiesto
    <br><input type="text"     name="lastrel"   value="<%= theLastrel>0?""+theLastrel:"" %>">                            relazione terminale
    <br><input type="text"     name="start"     value="<%= theStart!=null&&theStart.length()>0?theStart:"" %>">          posizionamento

    <input type="hidden" name="edit" value="<%= ""+(isEdit?1:0) %>">
    <br><br><input type="submit" value="submit">
   </form>
  </body> 
  </html> 
  <%
 }
}
catch(Throwable t) 
{
 t.printStackTrace();
 %><%= "<br>Sorry, an exception occurred: <br><b>"+t.toString()+"</b><br>" %><%
}
finally 
{
 if(broker!=null&&conn>=0)broker.releaseConnection(conn);
 if(rq!=null)rq.close(); 
}

%>

