<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Utilizzato dalla gestione gerarchica dei documenti (incluso da hierBrowser.xsl) -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<!-- hxp-hb-tree-... -->
	<xsl:template name="copyBtreeTemplateElement">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:choose>
					<xsl:when test="name()='colspan' and .='$hxp-hb-fillrow'">
						<xsl:attribute name="colspan">
							<xsl:value-of select="99 - $blockData/@depth" />
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:for-each select="node()">
				<xsl:call-template name="copyBlockTemplateElement">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="btreeBranches">
		<xsl:param name="btreeData" select="''" />
		<xsl:param name="btreeTemplate" select="''" />
		<xsl:param name="lev" select="''" />		
		<xsl:if test="$lev > 1 and string-length($btreeData/@brothers) >= $lev">
			<xsl:choose>
				<xsl:when test="$lev = string-length($btreeData/@brothers)"> <!-- ultimo ramo -->
					<xsl:choose>
						<xsl:when test="substring($btreeData/@brothers,$lev,1)='1'"> <!-- seguono fratelli -->
							<xsl:choose>
								<xsl:when test="$btreeData/@sons='1'"> <!-- ci sono figli -->
									<xsl:choose>
										<xsl:when test="$btreeData/@opened='1'">
											<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-cbo']"> <!-- corner with brothers and sons opened -->
												<xsl:call-template name="copyBtreeTemplateElement">
													<xsl:with-param name="blockData" select="$btreeData" />
												</xsl:call-template>
											</xsl:for-each>
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-cbc']"> <!-- corner with brothers and sons closed -->
												<xsl:call-template name="copyBtreeTemplateElement">
													<xsl:with-param name="blockData" select="$btreeData" />
												</xsl:call-template>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-cb']"> <!-- leaf corner with brothers -->
										<xsl:call-template name="copyBtreeTemplateElement">
											<xsl:with-param name="blockData" select="$btreeData" />
										</xsl:call-template>
									</xsl:for-each>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise> <!-- no fratelli a seguire -->
							<xsl:choose>
								<xsl:when test="$btreeData/@sons='1'">
									<xsl:choose>
										<xsl:when test="$btreeData/@opened='1'">
											<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-co']"> <!-- corner without brothers, with sons opened -->
												<xsl:call-template name="copyBtreeTemplateElement">
													<xsl:with-param name="blockData" select="$btreeData" />
												</xsl:call-template>
											</xsl:for-each>
										</xsl:when>
										<xsl:otherwise>
											<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-cc']"> <!-- corner without brothers, with sons closed -->
												<xsl:call-template name="copyBtreeTemplateElement">
													<xsl:with-param name="blockData" select="$btreeData" />
												</xsl:call-template>
											</xsl:for-each>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-c']"> <!-- leaf corner without brothers -->
										<xsl:call-template name="copyBtreeTemplateElement">
											<xsl:with-param name="blockData" select="$btreeData" />
										</xsl:call-template>
									</xsl:for-each>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="substring($btreeData/@brothers,$lev,1)='1'">
							<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-bb']"> <!-- branch with brothers -->
								<xsl:call-template name="copyBtreeTemplateElement">
									<xsl:with-param name="blockData" select="$btreeData" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>
							<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-b']"> <!-- branch without brothers -->
								<xsl:call-template name="copyBtreeTemplateElement">
									<xsl:with-param name="blockData" select="$btreeData" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="btreeBranches">
				<xsl:with-param name="btreeData" select="$btreeData" />
				<xsl:with-param name="btreeTemplate" select="$btreeTemplate" />
				<xsl:with-param name="lev" select="$lev + 1" />
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="btreeFormatter">
		<xsl:param name="btreeData" select="''" />
		<xsl:param name="btreeTemplate" select="''" />
		<xsl:call-template name="btreeBranches">
			<xsl:with-param name="btreeData" select="$btreeData" />
			<xsl:with-param name="btreeTemplate" select="$btreeTemplate" />
			<xsl:with-param name="lev" select="2" />
		</xsl:call-template>
		<xsl:choose>
			<xsl:when test="$btreeData/@depth = '1'"> <!-- radice -->
				<xsl:choose>
					<xsl:when test="$btreeData/@sons = '1'"> <!-- ci sono figli -->
						<xsl:choose>
							<xsl:when test="$btreeData/@opened = '1'">
								<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-ro']"> <!-- Root Opened -->
									<xsl:call-template name="copyBtreeTemplateElement">
										<xsl:with-param name="blockData" select="$btreeData" />
									</xsl:call-template>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-rc']"> <!-- Root Closed -->
									<xsl:call-template name="copyBtreeTemplateElement">
										<xsl:with-param name="blockData" select="$btreeData" />
									</xsl:call-template>
								</xsl:for-each>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-ra']"> <!-- Root Alone -->
							<xsl:call-template name="copyBtreeTemplateElement">
								<xsl:with-param name="blockData" select="$btreeData" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise> <!-- figlio -->
				<xsl:choose>
					<xsl:when test="$btreeData/@sons = '1'"> <!-- ci sono figli -->
						<xsl:choose>
							<xsl:when test="$btreeData/@opened = '1'">
								<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-fo']"> <!-- Folder Opened -->
									<xsl:call-template name="copyBtreeTemplateElement">
										<xsl:with-param name="blockData" select="$btreeData" />
									</xsl:call-template>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-fc']"> <!-- Folder Closed -->
									<xsl:call-template name="copyBtreeTemplateElement">
										<xsl:with-param name="blockData" select="$btreeData" />
									</xsl:call-template>
								</xsl:for-each>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-l']"> <!-- leaf -->
							<xsl:call-template name="copyBtreeTemplateElement">
								<xsl:with-param name="blockData" select="$btreeData" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:for-each select="$btreeTemplate/descendant-or-self::*[@id='hxp-hb-tree-title']">
			<xsl:call-template name="copyBtreeTemplateElement">
				<xsl:with-param name="blockData" select="$btreeData" />
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>
	
	<!-- hxp-hb-tree-containerof-... -->
	<xsl:template name="hxpbtreecontainer">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="elemName" select="''" />
		<xsl:variable name="templateRow" select="." />
		<xsl:variable name="btreeTemplate" select="*" />
		<xsl:for-each select="$blockData/*[name()=$elemName]">
			<xsl:variable name="btreeData" select="." />
			<xsl:for-each select="$templateRow">
				<xsl:copy>
					<xsl:copy-of select="$templateRow/@*[name()!='id']" />
					<xsl:call-template name="btreeFormatter">
						<xsl:with-param name="btreeData" select="$btreeData" />
						<xsl:with-param name="btreeTemplate" select="$btreeTemplate" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	
	<!-- Smistamento dei template hxp-hb-tree-... -->
	<xsl:template name="hbtree">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='containerof'"> <!-- hxp-hb-tree-containerof-... -->
				<xsl:call-template name="hxpbtreecontainer">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="elemName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise> <!-- hxp-hb-tree-... -->
				<xsl:call-template name="copyBtreeTemplateElement">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
