<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />
	
	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/calllookup.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:attribute name="scroll">auto</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
		</form>
	</xsl:template>
	
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:call-template name="hxpidhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
