<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:include href="hxp.xsl"/>
<xsl:include href="genericResourceHandler.xsl"/>

<!-- Javascript da includere -->
<xsl:template name="jslist">
	<script>
		<xsl:attribute name="src">../../../formatter/html/data/js/collect.js</xsl:attribute>
		<xsl:attribute name="type">text/javascript</xsl:attribute>
		<xsl:text>;</xsl:text>
	</script>
</xsl:template>

<!-- attributi del body -->
<xsl:template name="bodyattributes">
	<xsl:attribute name="scroll">auto</xsl:attribute>
	<!--
	<xsl:attribute name="onKeyPress">submitOnEnter(event)</xsl:attribute>
	-->
</xsl:template>


<!-- hxpForm (form nascosta) -->
<xsl:template name="beforeend">
	<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
		<!-- Federico 19/07/05: gli input hidden devono essere contenuti in un "div" o un "p" (specifiche W3C) -->
		<div>
			<xsl:call-template name="sessiondata"/>
			<input type="hidden" name="verbo"     value="{$hxpdata/@verbo}"/>
			<input type="hidden" name="xverb"     value="{$hxpdata/@xverb}"/>
			<input type="hidden" name="cList"     value="{$hxpdata/@cList}"/>
			<input type="hidden" name="cParam"    value="{$hxpdata/@cParam}"/>
			<input type="hidden" name="keylist"   value="{$hxpdata/@keylist}"/>
			<!-- altri parametri in hxp -->
		</div>
	</form>
</xsl:template>


<!-- Smistamento dei template 'hxp-collect-action-' -->
<xsl:template name="cAction">
	<xsl:param name="value" select="''"/>
	<xsl:param name="blockData" select="$hxpdata"/>
	<xsl:choose>
		<!-- gestione dell'id 'hxp-collect-action-closedialog' -->
		<xsl:when test="$value='closedialog'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
				<xsl:if test="name()='a'">
					<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
				</xsl:if>
				<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
				<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-collclose' -->
		<xsl:when test="$value='collclose'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
											<xsl:attribute name="disabled">disabled</xsl:attribute>
											<xsl:if test="./@src">
												<xsl:if test="contains(./@src, 'act-collclose_on_.gif')">
													<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collclose_on_.gif'), 'act-collclose_off_.gif')"/></xsl:attribute>
												</xsl:if>
											</xsl:if>
										</xsl:if>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
											<xsl:with-param name="disable" select="'1'"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:when>
								<xsl:otherwise>
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='a'">
											<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
										</xsl:if>
										<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:text>Collection-Deactivate</xsl:text></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-collclose_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collclose_on_.gif'), 'act-collclose_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-collopen' -->
		<xsl:when test="$value='collopen'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='a'">
											<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
										</xsl:if>
										<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:when>
								<xsl:otherwise>
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
											<xsl:attribute name="disabled">disabled</xsl:attribute>
											<xsl:if test="./@src">
												<xsl:if test="contains(./@src, 'act-collopen_on_.gif')">
													<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collopen_on_.gif'), 'act-collopen_off_.gif')"/></xsl:attribute>
												</xsl:if>
											</xsl:if>
										</xsl:if>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
											<xsl:with-param name="disable" select="'1'"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-collopen_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collopen_on_.gif'), 'act-collopen_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-collswitcher' -->
		<xsl:when test="$value='collswitcher'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:text>collopen</xsl:text></xsl:attribute>
										<xsl:if test="name()='a'">
											<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
										</xsl:if>
										<xsl:attribute name="onclick"><xsl:text>return GoTo_('collopen')</xsl:text></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id='collect_long_collopen']/@value"/></xsl:attribute>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:when>
								<xsl:otherwise>
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:text>collclose</xsl:text></xsl:attribute>
										<xsl:if test="name()='a'">
											<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
										</xsl:if>
										<xsl:if test="./@src">
											<xsl:if test="contains(./@src, 'act-collopen_on_.gif')">
												<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collopen_on_.gif'), 'act-collclose_on_.gif')"/></xsl:attribute>
											</xsl:if>
										</xsl:if>
										<xsl:attribute name="onclick"><xsl:text>return GoTo_('collclose')</xsl:text></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id='collect_long_collclose']/@value"/></xsl:attribute>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:text>collopen</xsl:text></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-collopen_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-collopen_on_.gif'), 'act-collopen_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-create' -->
		<xsl:when test="$value='create'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<!-- La creazione di una nuova raccolta si fa SOLO dalla vis. delle raccolte private -->
					<xsl:choose>
						<xsl:when test="$hxpdata/@cName=''">
							<!-- nessuna raccolta attiva -->
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='a'">
									<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
								<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-create_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-create_on_.gif'), 'act-create_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-listprivate' -->
		<xsl:when test="$value='listprivate'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='a'">
							<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
						<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
							<xsl:attribute name="disabled">disabled</xsl:attribute>
							<xsl:if test="./@src">
								<xsl:if test="contains(./@src, 'act-listprivate_on_.gif')">
									<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-listprivate_on_.gif'), 'act-listprivate_off_.gif')"/></xsl:attribute>
								</xsl:if>
							</xsl:if>
						</xsl:if>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
							<xsl:with-param name="disable" select="'1'"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-listpublic' -->
		<xsl:when test="$value='listpublic'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
							<xsl:attribute name="disabled">disabled</xsl:attribute>
							<xsl:if test="./@src">
								<xsl:if test="contains(./@src, 'act-create_on_.gif')">
									<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-listpublic_on_.gif'), 'act-listpublic_off_.gif')"/></xsl:attribute>
								</xsl:if>
							</xsl:if>
						</xsl:if>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
							<xsl:with-param name="disable" select="'1'"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='a'">
							<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
						<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-listswitcher' -->
		<xsl:when test="$value='listswitcher'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cName=''">
					<!-- nessuna raccolta attiva -->
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:choose>
							<xsl:when test="$hxpdata/@cIsPublic='1'">
								<xsl:attribute name="id"><xsl:value-of select="'listprivate'"/></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-listpublic_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-listpublic_on_.gif'), 'act-listprivate_on_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:if test="name()='a'">
									<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:attribute name="onclick"><xsl:text>return GoTo_('listprivate')</xsl:text></xsl:attribute>
								<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id='collect_title_listprivate']/@value"/></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="id"><xsl:value-of select="'listpublic'"/></xsl:attribute>
								<xsl:if test="name()='a'">
									<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:attribute name="onclick"><xsl:text>return GoTo_('listpublic')</xsl:text></xsl:attribute>
								<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id='collect_title_listpublic']/@value"/></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="'listprivate'"/></xsl:attribute>
						<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
							<xsl:attribute name="disabled">disabled</xsl:attribute>
							<xsl:if test="./@src">
								<xsl:if test="contains(./@src, 'act-listpublic_on_.gif')">
									<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-listpublic_on_.gif'), 'act-listpublic_off_.gif')"/></xsl:attribute>
								</xsl:if>
							</xsl:if>
						</xsl:if>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
							<xsl:with-param name="disable" select="'1'"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-periodic' -->
		<xsl:when test="$value='periodic'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:choose>
					<xsl:when test="$hxpdata/@pos='1'">
						<xsl:attribute name="id"><xsl:value-of select="'listunperiodic'"/></xsl:attribute>
						<xsl:attribute name="title"><xsl:text>non periodiche</xsl:text></xsl:attribute>
						<xsl:if test="name()='a'">
							<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="onclick">return GoTo_('listunperiodic');</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="id"><xsl:value-of select="'listperiodic'"/></xsl:attribute>
						<xsl:attribute name="title"><xsl:text>periodiche</xsl:text></xsl:attribute>
						<xsl:if test="name()='a'">
							<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="onclick">return GoTo_('listperiodic');</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-saveaspublic' -->
		<xsl:when test="$value='saveaspublic'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName=''">
									<!-- nessuna raccolta attiva -->
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='a'">
											<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
										</xsl:if>
										<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:when>
								<xsl:otherwise>
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']"/>
										<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
										<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
											<xsl:attribute name="disabled">disabled</xsl:attribute>
											<xsl:if test="./@src">
												<xsl:if test="contains(./@src, 'act-saveaspublic_on_.gif')">
													<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-saveaspublic_on_.gif'), 'act-saveaspublic_off_.gif')"/></xsl:attribute>
												</xsl:if>
											</xsl:if>
										</xsl:if>
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData"/>
											<xsl:with-param name="disable" select="'1'"/>
										</xsl:call-template>
									</xsl:copy>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-saveaspublic_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-saveaspublic_on_.gif'), 'act-saveaspublic_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-remove' -->
		<xsl:when test="$value='remove'">
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
					<xsl:choose>
						<xsl:when test="$hxpdata/@cName=''">
							<!-- nessuna raccolta attiva -->
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='a'">
									<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
								</xsl:if>
								<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
								<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:when>
						<xsl:otherwise>
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
								<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
									<xsl:attribute name="disabled">disabled</xsl:attribute>
									<xsl:if test="./@src">
										<xsl:if test="contains(./@src, 'act-remove_on_.gif')">
											<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-remove_on_.gif'), 'act-remove_off_.gif')"/></xsl:attribute>
										</xsl:if>
									</xsl:if>
								</xsl:if>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData"/>
									<xsl:with-param name="disable" select="'1'"/>
								</xsl:call-template>
							</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
							<xsl:attribute name="disabled">disabled</xsl:attribute>
							<xsl:if test="./@src">
								<xsl:if test="contains(./@src, 'act-remove_on_.gif')">
									<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-remove_on_.gif'), 'act-remove_off_.gif')"/></xsl:attribute>
								</xsl:if>
							</xsl:if>
						</xsl:if>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
							<xsl:with-param name="disable" select="'1'"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-action-show' -->
		<xsl:when test="$value='show'">
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='a'">
							<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
						</xsl:if>
						<xsl:attribute name="onclick"><xsl:text>return GoTo_('</xsl:text><xsl:value-of select="$value"/><xsl:text>')</xsl:text></xsl:attribute>
						<xsl:attribute name="title"><xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_title_', $value)]/@value"/></xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="id"><xsl:value-of select="$value"/></xsl:attribute>
						<xsl:if test="name()='input' and (@type='button' or @type='submit' or @type='image')">
							<xsl:attribute name="disabled">disabled</xsl:attribute>
							<xsl:if test="./@src">
								<xsl:if test="contains(./@src, 'act-show_on_.gif')">
									<xsl:attribute name="src"><xsl:value-of select="concat(substring-before(./@src, 'act-show_on_.gif'), 'act-show_off_.gif')"/></xsl:attribute>
								</xsl:if>
							</xsl:if>
						</xsl:if>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
							<xsl:with-param name="disable" select="'1'"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="hxperrorhandler">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!-- Smistamento dei template 'hxp-collect-data-' -->
<xsl:template name="cData">
	<xsl:param name="value" select="''"/>
	<xsl:param name="blockData" select="$hxpdata"/>
	<xsl:variable name="Normalized_cName">
		<xsl:if test="string-length(normalize-space($blockData/@cName)) &gt; 0">
			<xsl:call-template name="CollectionNameNormalizer">
				<xsl:with-param name="text_to_normalize" select="$blockData/@cName" />
			</xsl:call-template>
		</xsl:if>
	</xsl:variable>
	<xsl:variable name="SelectSize">
		<xsl:choose>
			<xsl:when test="contains($value, '-')">
				<xsl:value-of select="substring-after($value, '-')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'20'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="SelectDataType">
		<xsl:choose>
			<xsl:when test="contains($value, '-')">
				<xsl:value-of select="substring-before($value, '-')"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$value"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:choose>
		<xsl:when test="$SelectDataType='CollectionDatation'">
			<xsl:element name="select">
				<xsl:attribute name="id"><xsl:text>selettore-datation</xsl:text></xsl:attribute>
				<xsl:attribute name="name"><xsl:text>selettore-datation</xsl:text></xsl:attribute>
				<xsl:attribute name="size"><xsl:value-of select="$SelectSize"/></xsl:attribute>
				<xsl:attribute name="onchange"><xsl:text>return ParificaSelettori(this.options.selectedIndex, 'selettore-recordcounts::selettore-name::selettore-datation')</xsl:text></xsl:attribute>
				<xsl:if test="string-length(normalize-space($blockData/@cIsPublic)) = 0">
					<xsl:if test="string-length(normalize-space($blockData/@cName)) &gt; 0">
						<xsl:if test="contains($blockData/@cList, concat('&#09;', $Normalized_cName, '&#09;'))">
							<xsl:attribute name="disabled"><xsl:text>disabled</xsl:text></xsl:attribute>
						</xsl:if>
					</xsl:if>
				</xsl:if>
				<xsl:call-template name="cCollectionGetData">
					<xsl:with-param name="CollectionData" select="$blockData/@cList"/>
					<xsl:with-param name="ActiveCollectionName" select="$blockData/@cName"/>
					<xsl:with-param name="CollectionIsPublic" select="$blockData/@cIsPublic"/>
					<xsl:with-param name="CollectionPart" select="'3'"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:when>
		<xsl:when test="$SelectDataType='CollectionDatationHeader'">
			<xsl:value-of select="$hxpresource_generic//*[@id=$SelectDataType]/@value"/>
		</xsl:when>
		<xsl:when test="$SelectDataType='CollectionName'">
			<xsl:element name="select">
				<xsl:attribute name="id"><xsl:text>selettore-name</xsl:text></xsl:attribute>
				<xsl:attribute name="name"><xsl:text>selettore-name</xsl:text></xsl:attribute>
				<xsl:attribute name="size"><xsl:value-of select="$SelectSize"/></xsl:attribute>
				<xsl:attribute name="onchange"><xsl:text>return ParificaSelettori(this.options.selectedIndex, 'selettore-recordcounts::selettore-name::selettore-datation')</xsl:text></xsl:attribute>
				<xsl:if test="string-length(normalize-space($blockData/@cIsPublic)) = 0">
					<xsl:if test="string-length(normalize-space($blockData/@cName)) &gt; 0">
						<xsl:if test="contains($blockData/@cList, concat('&#09;', $Normalized_cName, '&#09;'))">
							<xsl:attribute name="disabled"><xsl:text>disabled</xsl:text></xsl:attribute>
						</xsl:if>
					</xsl:if>
				</xsl:if>
				<xsl:call-template name="cCollectionGetData">
					<xsl:with-param name="CollectionData" select="$blockData/@cList"/>
					<xsl:with-param name="ActiveCollectionName" select="$blockData/@cName"/>
					<xsl:with-param name="CollectionIsPublic" select="$blockData/@cIsPublic"/>
					<xsl:with-param name="CollectionPart" select="'2'"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:when>
		<xsl:when test="$SelectDataType='CollectionNameHeader'">
			<xsl:choose>
				<xsl:when test="'1' = $hxpdata/@cIsPublic">
					<xsl:value-of select="$hxpresource_generic//*[@id=concat($SelectDataType, '-public')]/@value"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$hxpresource_generic//*[@id=concat($SelectDataType, '-private')]/@value"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="$SelectDataType='CollectionRecordCounts'">
			<xsl:element name="select">
				<xsl:attribute name="id"><xsl:text>selettore-recordcounts</xsl:text></xsl:attribute>
				<xsl:attribute name="name"><xsl:text>selettore-recordcounts</xsl:text></xsl:attribute>
				<xsl:attribute name="size"><xsl:value-of select="$SelectSize"/></xsl:attribute>
				<xsl:attribute name="onchange"><xsl:text>return ParificaSelettori(this.options.selectedIndex, 'selettore-recordcounts::selettore-name::selettore-datation')</xsl:text></xsl:attribute>
				<xsl:if test="string-length(normalize-space($blockData/@cIsPublic)) = 0">
					<xsl:if test="string-length(normalize-space($blockData/@cName)) &gt; 0">
						<xsl:if test="contains($blockData/@cList, concat('&#09;', $Normalized_cName, '&#09;'))">
							<xsl:attribute name="disabled"><xsl:text>disabled</xsl:text></xsl:attribute>
						</xsl:if>
					</xsl:if>
				</xsl:if>
				<xsl:call-template name="cCollectionGetData">
					<xsl:with-param name="CollectionData" select="$blockData/@cList"/>
					<xsl:with-param name="ActiveCollectionName" select="$blockData/@cName"/>
					<xsl:with-param name="CollectionIsPublic" select="$blockData/@cIsPublic"/>
					<xsl:with-param name="CollectionPart" select="'1'"/>
				</xsl:call-template>
			</xsl:element>
		</xsl:when>
		<xsl:when test="$SelectDataType='CollectionRecordCountsHeader'">
			<xsl:value-of select="$hxpresource_generic//*[@id=$SelectDataType]/@value"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="hxperrorhandler">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!-- Smistamento dei template 'hxp-collect-div-' -->
<xsl:template name="cDiv">
	<xsl:param name="value" select="''"/>
	<xsl:param name="blockData" select="$hxpdata"/>
	<xsl:choose>
		<!-- gestione dell'id 'hxp-collect-div-closedialog' -->
		<xsl:when test="$value='closedialog'">
			<xsl:call-template name="GenerateLabelForFormControls">
				<xsl:with-param name="FormControlId" select="$value"/>
			</xsl:call-template>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-collclose' -->
		<xsl:when test="$value='collclose'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:element name="span">
							<xsl:attribute name="style"><xsl:text>color:#D3D3D3</xsl:text></xsl:attribute>
							<xsl:value-of select="$hxpresource_generic//*[@id='Disattiva']/@value"/>
						</xsl:element>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
										<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-collopen' -->
		<xsl:when test="$value='collopen'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
										<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-collswitcher' -->
		<xsl:when test="$value='collswitcher'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName = ''">
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="'collopen'"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="'collclose'"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="'collopen'"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-create' -->
		<xsl:when test="$value='create'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$hxpdata/@cName=''">
							<!-- nessuna raccolta attiva -->
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-listprivate' -->
		<xsl:when test="$value='listprivate'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
						<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-listpublic' -->
		<xsl:when test="$value='listpublic'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
						<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-listswitcher' -->
		<xsl:when test="$value='listswitcher'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cName=''">
					<!-- nessuna raccolta attiva -->
					<xsl:choose>
						<xsl:when test="$hxpdata/@cIsPublic='1'">
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="'listprivate'"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="'listpublic'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="'listprivate'"/>
						<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-remove' -->
		<xsl:when test="$value='remove'">
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
					<xsl:choose>
						<xsl:when test="$hxpdata/@cName=''">
							<!-- nessuna raccolta attiva -->
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
						<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-saveaspublic' -->
		<xsl:when test="$value='saveaspublic'">
			<xsl:choose>
				<xsl:when test="$hxpdata/@cIsPublic='1'">
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
							<xsl:choose>
								<xsl:when test="$hxpdata/@cName=''">
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="GenerateLabelForFormControls">
										<xsl:with-param name="FormControlId" select="$value"/>
										<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="GenerateLabelForFormControls">
								<xsl:with-param name="FormControlId" select="$value"/>
								<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<!-- gestione dell'id 'hxp-collect-div-show' -->
		<xsl:when test="$value='show'">
			<xsl:choose>
				<xsl:when test="string-length(normalize-space($hxpdata/@cList)) &gt; 0">
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="GenerateLabelForFormControls">
						<xsl:with-param name="FormControlId" select="$value"/>
						<xsl:with-param name="DecoratorTextDisabled" select="'1'"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="hxperrorhandler">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!--xsl:template match="*[@id][starts-with(@id,'hxp-')]" mode="template" name="hxparser"-->
<xsl:template match="*[@id]" mode="template" name="hxparser">
	<xsl:param name="blockData" select="$hxpdata"/>
	<xsl:param name="disable" select="''"/>
	<xsl:choose>
		<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
		<xsl:when test="starts-with(@id,'hxp')">
			<xsl:variable name="value" select="substring-after(@id,'-')"/>
			<xsl:choose>
				<xsl:when test="substring-before($value,'-')='collect'">
					<xsl:choose>
						<!-- gestione dell'id 'hxp-collect-action-' -->
						<xsl:when test="starts-with(substring-after($value,'-'),'action-')">
							<xsl:call-template name="cAction">
								<xsl:with-param name="value" select="substring-after($value,'action-')"/>
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
						</xsl:when>
						<!-- gestione dell'id 'hxp-collect-data-' -->
						<xsl:when test="starts-with(substring-after($value,'-'),'data-')">
							<xsl:call-template name="cData">
								<xsl:with-param name="value" select="substring-after($value,'data-')"/>
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
						</xsl:when>
						<!-- gestione dell'id 'hxp-collect-div-' -->
						<xsl:when test="starts-with(substring-after($value,'-'),'div-')">
							<xsl:call-template name="cDiv">
								<xsl:with-param name="value" select="substring-after($value,'div-')"/>
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
						</xsl:when>
						<!-- gestione dell'id 'hxp-collect-genericResource-' -->
						<xsl:when test="starts-with(substring-after($value,'-'),'genericResource')">
							<xsl:call-template name="hxpGenericResource">
								<xsl:with-param name="resourceName" select="substring-after($value,'-genericResource-')"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="hxperrorhandler">
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxpidhandler">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<xsl:copy>
				<xsl:copy-of select="@*"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="disable" select="$disable"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!-- 
Template che si preoccupa di popolare/valorizzare le option delle select 
contenenti le informazioni sulle raccolte e cio nello specifico avremo: 
a) CollectionPart = 3  si preoccupa della "CollectionDatation"
b) CollectionPart = 2  si preoccupa della "CollectionName"
b) CollectionPart = 1  si preoccupa della "CollectionRecordCounts"
 -->
<xsl:template name="cCollectionGetData">
	<xsl:param name="CollectionData" select="''"/>
	<xsl:param name="ActiveCollectionName" select="''"/>
	<xsl:param name="CollectionPart" select="''"/>
	<xsl:param name="SelezionaPrimaOption" select="'1'"/>
	<xsl:param name="CollectionIsPublic" select="''"/>
	<xsl:variable name="CollectionForcedName">
		<xsl:choose>
			<xsl:when test="$CollectionIsPublic = '1'">
				<xsl:value-of select="''"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="CollectionNameNormalizer">
					<xsl:with-param name="text_to_normalize" select="$ActiveCollectionName" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:choose>
		<xsl:when test="normalize-space($CollectionData) = ''">
			<xsl:element name="option">
				<xsl:attribute name="value"></xsl:attribute>
				<xsl:attribute name="selected"><xsl:text>selected</xsl:text></xsl:attribute>
				<xsl:text> </xsl:text>
			</xsl:element>
		</xsl:when>
		<xsl:otherwise>
			<xsl:choose>
				<xsl:when test="contains($CollectionData, '&#10;')">
					<xsl:call-template name="PopolatoreOption">
						<xsl:with-param name="CollectionData" select="substring-before($CollectionData, '&#10;')"/>
						<xsl:with-param name="ActiveCollectionName" select="$CollectionForcedName"/>
						<xsl:with-param name="CollectionPart" select="$CollectionPart"/>
						<xsl:with-param name="SelezionaPrimaOption" select="$SelezionaPrimaOption"/>
					</xsl:call-template>
					<xsl:call-template name="cCollectionGetData">
						<xsl:with-param name="CollectionData" select="substring-after($CollectionData, '&#10;')"/>
						<xsl:with-param name="ActiveCollectionName" select="$CollectionForcedName"/>
						<xsl:with-param name="CollectionPart" select="$CollectionPart"/>
						<xsl:with-param name="SelezionaPrimaOption" select="'0'"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="PopolatoreOption">
						<xsl:with-param name="CollectionData" select="$CollectionData"/>
						<xsl:with-param name="ActiveCollectionName" select="$CollectionForcedName"/>
						<xsl:with-param name="CollectionPart" select="$CollectionPart"/>
						<xsl:with-param name="SelezionaPrimaOption" select="$SelezionaPrimaOption"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<xsl:template name="PopolatoreOption">
	<xsl:param name="CollectionData" select="''"/>
	<xsl:param name="ActiveCollectionName" select="''"/>
	<xsl:param name="CollectionPart" select="''"/>
	<xsl:param name="SelezionaPrimaOption" select="''"/>
	<xsl:variable name="CollRecordCounts" select="substring-before($CollectionData, '&#09;')"/>
	<xsl:variable name="CollName" select="substring-before(substring-after($CollectionData, '&#09;'), '&#09;')"/>
	<xsl:variable name="CollDatation" select="substring-after(substring-after($CollectionData, '&#09;'), '&#09;')"/>
	<xsl:element name="option">
		<xsl:attribute name="value">
			<xsl:choose>
				<xsl:when test="$CollectionPart = '1'">
					<xsl:value-of select="$CollRecordCounts"/>
				</xsl:when>
				<xsl:when test="$CollectionPart = '2'">
					<xsl:value-of select="$CollName"/>
				</xsl:when>
				<xsl:when test="$CollectionPart = '3'">
					<xsl:value-of select="$CollDatation"/>
				</xsl:when>
				<xsl:otherwise>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:attribute>
		<xsl:choose>
			<xsl:when test="$ActiveCollectionName = ''">
				<xsl:if test="$SelezionaPrimaOption = '1'">
					<xsl:attribute name="selected"><xsl:text>selected</xsl:text></xsl:attribute>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$ActiveCollectionName = $CollName">
					<xsl:attribute name="selected"><xsl:text>selected</xsl:text></xsl:attribute>
					<xsl:attribute name="class"><xsl:text>ActivedCollect</xsl:text></xsl:attribute>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="$CollectionPart = '1'">
				<xsl:value-of select="$CollRecordCounts"/>
			</xsl:when>
			<xsl:when test="$CollectionPart = '2'">
				<xsl:value-of select="translate($CollName, '_', ' ')"/>
			</xsl:when>
			<xsl:when test="$CollectionPart = '3'">
				<xsl:call-template name="DateFormatter">
					<xsl:with-param name="DataDaFormattare" select="$CollDatation"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:element>
</xsl:template>


<xsl:template name="DateFormatter">
	<xsl:param name="DataDaFormattare" select="''"/>
	<xsl:value-of select="concat(substring($DataDaFormattare, 7, 2), '-', substring($DataDaFormattare, 5, 2), '-', substring($DataDaFormattare, 1, 4))"/>
</xsl:template>


<xsl:template name="CollectionNameNormalizer">
	<xsl:param name="text_to_normalize" select="''" />
	<xsl:value-of select="translate($text_to_normalize, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')" />
</xsl:template>


<xsl:template name="GenerateLabelForFormControls">
	<xsl:param name="FormControlId" select="''"/>
	<xsl:param name="DecoratorTextDisabled" select="''"/>
	<xsl:element name="label">
		<xsl:attribute name="for"><xsl:value-of select="$FormControlId"/></xsl:attribute>
		<xsl:if test="$DecoratorTextDisabled = '1'">
			<xsl:attribute name="style"><xsl:text>color:#D3D3D3</xsl:text></xsl:attribute>
		</xsl:if>
		<xsl:value-of select="$hxpresource_generic//*[@id=concat('collect_short_', $FormControlId)]/@value"/>
	</xsl:element>
</xsl:template>

</xsl:stylesheet>
