<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

 <xsl:variable name="hxp-path-separator" select="'.'"/>

 <xsl:variable name="modelTemplate" select="'Template'"/>
 <xsl:variable name="noParseContainerId" select="'hxp-core-noparse'"/>
 <xsl:variable name="noparse" select="':noparse:'"/>

 <xsl:variable name="start-attribute"     select="'$'" />
 <xsl:variable name="start-parameters"    select="'('" />
 <xsl:variable name="stop-parameters"     select="')'" />
 <xsl:variable name="param-id"            select="concat($start-attribute,'hxp_core_')" />
 <xsl:variable name="param-copy"          select="concat('copy',$start-parameters)" />
 <xsl:variable name="param-content"       select="concat('content',$start-parameters)" />
 <xsl:variable name="param-path"          select="concat('path',$start-parameters)" />
 <xsl:variable name="param-pathTemplate"  select="concat('path',$modelTemplate,$start-parameters)" />
 <xsl:variable name="param-slashPath"     select="concat('slashPath',$start-parameters)" />
 <xsl:variable name="param-slashPathTemplate" select="concat('slashPath',$modelTemplate,$start-parameters)" />
 <xsl:variable name="param-testElements"  select="concat('testElements',$start-parameters)" />
 <xsl:variable name="param-testValue"     select="concat('testValue',$start-parameters)" />
 <xsl:variable name="param-instanceIndex" select="concat('instanceIndex',$start-parameters)" />
 <xsl:variable name="param-dbTable"       select="concat('dbTable',$start-parameters)" />
 
 <xsl:template name="matchBrace">
  <xsl:param name="where" select="''"/>
  <xsl:param name="match" select="''"/>
  <xsl:param name="test" select="''"/>
  <xsl:choose>
   <xsl:when test="contains($test,$start-parameters) and string-length($where) &gt; string-length($match)">
    <xsl:variable name="totest" select="substring-before(substring-after($where,concat($match,$stop-parameters)),$stop-parameters)"/>
    <xsl:call-template name="matchBrace">
     <xsl:with-param name="where" select="$where"/>
     <xsl:with-param name="match" select="concat($match,$stop-parameters,$totest)"/>
     <xsl:with-param name="test" select="$totest"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$match"/>
   </xsl:otherwise>
  </xsl:choose>        
 </xsl:template>

 <xsl:template name="hxp-core-string">
  <xsl:param name="block-path" select="''"/>
  <xsl:param name="block-data" select="$hxpdata" />
  <xsl:param name="the-string" select="''" />
  <xsl:choose>
   <xsl:when test="contains($the-string,$param-id)">
    <xsl:value-of select="substring-before($the-string,$param-id)" />
    <xsl:variable name="remainder" select="substring-after($the-string,$param-id)" />
    <xsl:choose>
     <xsl:when test="starts-with($remainder,$param-instanceIndex)"><!-- $hxp-core-instanceIndex(@diritto,CC) -->
      <xsl:variable name="elemName" select="name($block-data)"/>
      <xsl:choose>
       <xsl:when test="not($elemName='')">
        <xsl:variable name="attrName" select="substring-before(substring-after($remainder,'@'),',')"/>
        <xsl:variable name="value" select="substring-before(substring-after($remainder,','),$stop-parameters)"/>
        <xsl:value-of select="count($block-data/preceding-sibling::*[name()=$elemName and count(@*[name()=$attrName and .=$value])=1])"/>
       </xsl:when>
       <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>    
     </xsl:when>
     <!-- testElements(list1,list2,value1:list1 succed,value2:list2 succeded,default:list1 and list2 fails) -->
     <xsl:when test="starts-with($remainder,$param-testElements)">
      <!--
      <xsl:choose>
       <xsl:when test="starts-with($block-path,$noparse)">
        <xsl:value-of select="substring-before(substring-after(substring-after(substring-after(substring-after($remainder,','),','),','),','),$stop-parameters)"/>
       </xsl:when>
       <xsl:otherwise>
       -->
        <xsl:variable name="positionIndex">
         <xsl:choose>
          <xsl:when test="starts-with($block-path,'(')"><xsl:value-of select="substring-after(substring-before($block-path,')'),'(')"/></xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
         </xsl:choose>
        </xsl:variable>
        <xsl:variable name="firstTrue">
         <xsl:call-template name="testElements">
          <xsl:with-param name="blockPath" select="$block-path"/>
          <xsl:with-param name="blockData" select="$block-data"/>
          <xsl:with-param name="elements" select="substring-after(substring-before($remainder,','),$param-testElements)"/>
          <xsl:with-param name="positionIndex" select="$positionIndex"/>
         </xsl:call-template>
        </xsl:variable>
        <xsl:choose>
         <xsl:when test="contains($firstTrue,'1')">
          <xsl:value-of select="substring-before(substring-after(substring-after($remainder,','),','),',')"/>
         </xsl:when>
         <xsl:otherwise>
          <xsl:variable name="secondTrue">
           <xsl:call-template name="testElements">
            <xsl:with-param name="blockPath" select="$block-path"/>
            <xsl:with-param name="blockData" select="$block-data"/>
            <xsl:with-param name="elements" select="substring-before(substring-after($remainder,','),',')"/>
            <xsl:with-param name="positionIndex" select="$positionIndex"/>
           </xsl:call-template>
          </xsl:variable>
          <xsl:choose>
           <xsl:when test="contains($secondTrue,'1')">
            <xsl:value-of select="substring-before(substring-after(substring-after(substring-after($remainder,','),','),','),',')"/>
           </xsl:when>
           <xsl:otherwise>
            <xsl:value-of select="substring-before(substring-after(substring-after(substring-after(substring-after($remainder,','),','),','),','),$stop-parameters)"/>
           </xsl:otherwise>
          </xsl:choose>
         </xsl:otherwise>
        </xsl:choose>
      <!--
       </xsl:otherwise>
      </xsl:choose>
       -->
     </xsl:when>

     <!-- testValue(path,expr2,value1:expr1==expr2,value2:expr1!=expr2) -->
     <xsl:when test="starts-with($remainder,$param-testValue)">
      <xsl:variable name="value1">
       <xsl:call-template name="hxp-core-content">
        <xsl:with-param name="path" select="substring-before(substring-after($remainder,$param-testValue),',')"/>
        <xsl:with-param name="blockData" select="$block-data"/><xsl:with-param name="blockPath" select="$block-path"/>
        <xsl:with-param name="mode" select="'w'"/>
       </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="value2">
       <xsl:call-template name="hxp-core-string">
        <xsl:with-param name="block-path" select="$block-path"/>
        <xsl:with-param name="block-data" select="$block-data" />
        <xsl:with-param name="the-string" select="substring-before(substring-after($remainder,','),',')" />
       </xsl:call-template>
      </xsl:variable>
      
      <xsl:variable name="result">
      <xsl:choose>
       <xsl:when test="normalize-space($value1) = normalize-space($value2)">
        <!--
        <xsl:call-template name="hxp-core-string">
         <xsl:with-param name="block-path" select="$block-path"/>
         <xsl:with-param name="block-data" select="$block-data" />
         <xsl:with-param name="the-string" select="substring-before(substring-after(substring-after($remainder,','),','),',')" />
        </xsl:call-template>
        -->
        <xsl:value-of select="substring-before(substring-after(substring-after($remainder,','),','),',')"/>
       </xsl:when>
       <xsl:otherwise>
        
        <xsl:variable name="lastPart" select="substring-after(substring-after(substring-after($remainder,','),','),',')"/>
        <xsl:variable name="test" select="substring-before($lastPart,$stop-parameters)"/>
        <xsl:variable name="lastParameter">
         <xsl:call-template name="matchBrace">
          <xsl:with-param name="where" select="$lastPart"/>
          <xsl:with-param name="match" select="$test"/>
          <xsl:with-param name="test" select="$test"/>
         </xsl:call-template>
        </xsl:variable>
        <!--
        <xsl:call-template name="hxp-core-string">
         <xsl:with-param name="block-path" select="$block-path"/>
         <xsl:with-param name="block-data" select="$block-data" />
         <xsl:with-param name="the-string" select="$lastParameter" />
        </xsl:call-template>
        -->
        <xsl:value-of select="$lastParameter"/>
       </xsl:otherwise>
      </xsl:choose>
      </xsl:variable>
      
      <xsl:variable name="parsedResult">
       <xsl:call-template name="qunescape">
        <xsl:with-param name="data" select="$result"/>
       </xsl:call-template>        
      </xsl:variable>
      
      <xsl:call-template name="hxp-core-string">
       <xsl:with-param name="block-path" select="$block-path"/>
       <xsl:with-param name="block-data" select="$block-data" />
       <xsl:with-param name="the-string" select="$parsedResult" />
      </xsl:call-template>
      
     </xsl:when>
     
     <xsl:when test="starts-with($remainder,$param-content)">
      <!--
      <xsl:choose>
       <xsl:when test="starts-with($block-path,$noparse)"/>
       <xsl:otherwise>
       -->
        <xsl:call-template name="hxp-core-content">
         <xsl:with-param name="blockPath" select="$block-path"/>
         <xsl:with-param name="blockData" select="$block-data"/>
         <xsl:with-param name="path" select="substring-before(substring-after($remainder,$param-content),$stop-parameters)"/>
         <xsl:with-param name="mode" select="'w'"/>
        </xsl:call-template>
      <!--  
       </xsl:otherwise>
      </xsl:choose>
      -->
     </xsl:when>
     <xsl:when test="starts-with($remainder,$param-copy)">
      <xsl:call-template name="hxp-core-content">
       <xsl:with-param name="path" select="substring-before(substring-after($remainder,$param-content),$stop-parameters)"/>
       <xsl:with-param name="block-data" select="$block-data"/>
       <xsl:with-param name="mode" select="'c'"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$param-pathTemplate)">
      <xsl:choose>
       <!--	
       <xsl:when test="ancestor::*[@id=$noParseContainerId]">
	   -->
       <xsl:when test="contains($block-path,$noparse)">
        <xsl:value-of select="$param-id" />
        <xsl:value-of select="substring-before($remainder,concat($modelTemplate,$start-parameters))" />
        <xsl:value-of select="$start-parameters" />
        <xsl:value-of select="$stop-parameters" />
       </xsl:when>
       <xsl:otherwise>
        <xsl:value-of select="substring-after($block-path,'[0]')"/>
       </xsl:otherwise>
      </xsl:choose> 
     </xsl:when>   
     <xsl:when test="starts-with($remainder,$param-path)">
      <!--
      <xsl:choose>
       <xsl:when test="starts-with($block-path,$noparse)">
        <xsl:value-of select="$param-id" />
        <xsl:value-of select="substring-before($remainder,$stop-parameters)" />
        <xsl:value-of select="$stop-parameters" />
       </xsl:when>
       <xsl:otherwise>
       -->
        <!-- accrocchio per evitare il percorso completo di ud_name non gestito da common.DocEdit
         <xsl:value-of select="$block-path" />
         -->
        <xsl:variable name="result" select="substring-after($block-path,'[0]')"/>
        <xsl:variable name="argument" select="substring-before(substring-after($remainder,$param-path),$stop-parameters)"/>
        <xsl:choose>
         <xsl:when test="not($argument='')">
          <xsl:value-of select="substring-after($result,$argument)"/>
         </xsl:when>
         <xsl:otherwise>
          <xsl:value-of select="$result"/>                
         </xsl:otherwise>
        </xsl:choose> 
      <!--
       </xsl:otherwise>
      </xsl:choose>
       -->
     </xsl:when>
     <xsl:when test="starts-with($remainder,$param-slashPathTemplate)">
      <xsl:choose>
       <!--	
       <xsl:when test="ancestor::*[@id=$noParseContainerId]">
        -->
       <xsl:when test="contains($block-path,$noparse)">
        <xsl:value-of select="$param-id" />
        <xsl:value-of select="substring-before($remainder,concat($modelTemplate,$start-parameters))" />
        <xsl:value-of select="$start-parameters" />
        <xsl:value-of select="$stop-parameters" />
       </xsl:when>
       <xsl:otherwise>
        <xsl:call-template name="clearIndex">
         <xsl:with-param name="path" select="translate(substring-after($block-path,'[0]'),'.','/')"/>
        </xsl:call-template>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$param-slashPath)"><!-- usato per compilare i nomi dei campi di ricerca e vocabolari -->
      <!-- 
      <xsl:choose>
       <xsl:when test="starts-with($block-path,$noparse)">
        <xsl:value-of select="$param-id" />
        <xsl:value-of select="substring-before($remainder,$stop-parameters)" />
        <xsl:value-of select="$stop-parameters" />
       </xsl:when>
       <xsl:otherwise>
      --> 
        <xsl:call-template name="clearIndex">
         <xsl:with-param name="path" select="translate(substring-after($block-path,'[0]'),'.','/')"/>
        </xsl:call-template>
      <!--  
       </xsl:otherwise>
      </xsl:choose>
      -->
     </xsl:when>
     <xsl:when test="starts-with($remainder,$param-dbTable)">
       <xsl:value-of select="substring-after($hxpdata/@dbTable,'@')" />
     </xsl:when>
     
     <xsl:otherwise>
      <xsl:value-of select="$param-id" />
      <xsl:value-of select="substring-before($remainder,$stop-parameters)" />
      <xsl:value-of select="$stop-parameters" />
     </xsl:otherwise>
    </xsl:choose>
    
    <xsl:variable name="args" select="substring-after($remainder,$start-parameters)"/>
    <xsl:variable name="test" select="substring-before($args,$stop-parameters)"/>
    <xsl:variable name="used">
     <xsl:call-template name="matchBrace">
      <xsl:with-param name="where" select="$args"/>
      <xsl:with-param name="match" select="$test"/>
      <xsl:with-param name="test" select="$test"/>
     </xsl:call-template>
    </xsl:variable>      
    
    <xsl:call-template name="hxpstring">
     <xsl:with-param name="data" select="$block-data" />
     <xsl:with-param name="blockPath" select="$block-path"/>
     <xsl:with-param name="thestring" select="substring-after($args,concat($used,$stop-parameters))" />
     <!--
     <xsl:with-param name="thestring" select="substring-after($remainder,$stop-parameters)" />
     -->     
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$the-string" />
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="clearIndex">
  <xsl:param name="path" select="''"/>
  <xsl:if test="string-length($path)>0">
   <xsl:choose>
    <xsl:when test="contains($path,'[')">
     <xsl:value-of select="substring-before($path,'[')"/>
     <xsl:call-template name="clearIndex">
      <xsl:with-param name="path" select="substring-after($path,']')"/>
     </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="$path"/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:if>
 </xsl:template>

 <xsl:template match="*" mode="node-filter"/>
 <xsl:template match="@*|text()|processing-instruction()" mode="node-filter">
  <xsl:apply-templates select="."/>
 </xsl:template>

 <!-- hxp-core-copy|content|container|contains-<path>
      a/b[1]/*/c/@d
   -->
 <xsl:template name="hxp-core-content">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="path" select="''"/>
  <xsl:param name="mode" select="''"/>
  <xsl:choose>
   <xsl:when test="string-length($path)=0">
    <xsl:choose>
     <xsl:when test="$mode='c'">
      <xsl:copy-of select="$blockData"/>
     </xsl:when>
     <xsl:when test="$mode='tt'">
      <xsl:if test="string-length(normalize-space($blockData|$blockData/text()))>0">
       <xsl:copy-of select="'1'"/>
      </xsl:if> 
     </xsl:when>
     <xsl:when test="$mode='t'">
      <xsl:if test="$blockData">1</xsl:if>
     </xsl:when>
     <xsl:when test="$mode='w'">
      <xsl:apply-templates select="$blockData|$blockData/text()" mode="node-filter"/>
     </xsl:when>
     <xsl:otherwise>
		<!--
      <xsl:if test="$mode='w'">
       <xsl:apply-templates select="$blockData|$blockData/text()" mode="node-filter"/>
      </xsl:if>
	    -->
      <xsl:apply-templates mode="template">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:apply-templates>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <!--
   <xsl:when test="contains($blockPath,$noparse)">
    <xsl:choose>
     <xsl:when test="$mode='t' or $mode='tt'">
      <xsl:choose>
       <xsl:when test="starts-with($blockPath,'(')">
        <xsl:variable name="repetition" select="substring-after(substring-before($blockPath,')'),'(')"/>
        <xsl:if test="$repetition='0'">
         <xsl:value-of select="'1'"/>
        </xsl:if>
       </xsl:when>
       <xsl:otherwise>
        <xsl:value-of select="'1'"/>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:when test="$mode='w'"/>
     <xsl:otherwise>
      <xsl:apply-templates mode="template">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:apply-templates>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   -->
   <xsl:otherwise>
    <xsl:variable name="current">
     <xsl:choose>
      <xsl:when test="contains($path,'/')">
       <xsl:value-of select="substring-before($path,'/')"/>
      </xsl:when>
      <xsl:otherwise>
       <xsl:value-of select="$path"/>
      </xsl:otherwise>
     </xsl:choose>
    </xsl:variable>
    <xsl:choose>
     <xsl:when test="contains($current,'[')">
      <xsl:choose>
       <xsl:when test="substring-before($current,'[')='*'">
        <xsl:call-template name="hxp-core-content">
         <xsl:with-param name="path" select="substring-after($path,'/')"/>
         <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,name($blockData/*[position()=number(substring-before(substring-after($current,'['),']'))]),substring-after($current,'*'))"/>
         <xsl:with-param name="blockData" select="$blockData/*[position()=number(substring-before(substring-after($current,'['),']'))]"/>
         <xsl:with-param name="mode" select="$mode"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:otherwise>
        <xsl:choose>
         <!-- predicato [@<nome attributo>=<valore>] -->
         <xsl:when test="starts-with(substring-after($current,'['),'@')">
          <xsl:variable name="attrName" select="normalize-space(substring-before(substring-after($current,'[@'),'='))"/>
          <xsl:variable name="attrValue" select="normalize-space(substring-before(substring-after(substring-after($current,'[@'),'='),']'))"/>
          
          <xsl:choose>
           <xsl:when test="count($blockData/*[name()=substring-before($current,'[')][@*[name()=$attrName and .=$attrValue]])=0 and $mode='v'">
            <xsl:call-template name="hxp-core-content">
             <xsl:with-param name="path" select="''"/>
             <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
             <xsl:with-param name="blockData" select="$blockData/*[name()=substring-before($current,'[')][@*[name()=$attrName and .=$attrValue]]"/>
             <xsl:with-param name="mode" select="$mode"/>
            </xsl:call-template>
           </xsl:when>
           <xsl:otherwise>
            <xsl:variable name="context" select="."/>
            <xsl:for-each select="$blockData/*[name()=substring-before($current,'[')][@*[name()=$attrName and .=$attrValue]]">
             <xsl:variable name="target" select="."/>
             <xsl:for-each select="$context">
              <xsl:call-template name="hxp-core-content">
               <xsl:with-param name="path" select="substring-after($path,'/')"/>
               <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
               <xsl:with-param name="blockData" select="$target"/>
               <xsl:with-param name="mode" select="$mode"/>
              </xsl:call-template>
             </xsl:for-each>
            </xsl:for-each>
           </xsl:otherwise>
          </xsl:choose>
          
         </xsl:when>
         <xsl:otherwise>       
          <xsl:call-template name="hxp-core-content">
           <xsl:with-param name="path" select="substring-after($path,'/')"/>
           <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
           <xsl:with-param name="blockData" select="$blockData/*[name()=substring-before($current,'[')][position()=number(substring-before(substring-after($current,'['),']'))]"/>
           <xsl:with-param name="mode" select="$mode"/>
          </xsl:call-template>
         </xsl:otherwise> 
        </xsl:choose> 
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:when test="starts-with($current,'@')">
      <xsl:choose>
       <xsl:when test="$current='@*'">
        <xsl:variable name="context" select="."/>
        <xsl:for-each select="$blockData/@*">
         <xsl:variable name="target" select="."/>
         <xsl:variable name="current-name" select='name()'/>
         <xsl:for-each select="$context">
          <xsl:call-template name="hxp-core-content">
           <xsl:with-param name="path" select="substring-after($path,'/')"/>
           <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,'@',$current-name)"/>
           <xsl:with-param name="blockData" select="$target"/>
           <xsl:with-param name="mode" select="$mode"/>
          </xsl:call-template>
         </xsl:for-each>
        </xsl:for-each>
       </xsl:when>
       <xsl:otherwise>
        <!--       
        <xsl:variable name="context" select="."/>
        <xsl:for-each select="$blockData/@*[name()=substring-after($current,'@')]">
         <xsl:variable name="target" select="."/>
         <xsl:for-each select="$context">
          <xsl:call-template name="hxp-core-content">
           <xsl:with-param name="path" select="substring-after($path,'/')"/>
           <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
           <xsl:with-param name="blockData" select="$target"/>
           <xsl:with-param name="mode" select="$mode"/>
          </xsl:call-template>
         </xsl:for-each>
        </xsl:for-each>
        -->
        <xsl:choose>
         <xsl:when test="count($blockData/@*[name()=substring-after($current,'@')])=0 and $mode='v'">
          <xsl:call-template name="hxp-core-content">
           <xsl:with-param name="path" select="''"/>
           <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
           <xsl:with-param name="blockData" select="$blockData/@*[name()=substring-after($current,'@')]"/>
           <xsl:with-param name="mode" select="$mode"/>
          </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
          <xsl:variable name="context" select="."/>
          <xsl:for-each select="$blockData/@*[name()=substring-after($current,'@')]">
           <xsl:variable name="target" select="."/>
           <xsl:for-each select="$context">
            <xsl:call-template name="hxp-core-content">
             <xsl:with-param name="path" select="substring-after($path,'/')"/>
             <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current)"/>
             <xsl:with-param name="blockData" select="$target"/>
             <xsl:with-param name="mode" select="$mode"/>
            </xsl:call-template>
           </xsl:for-each>
          </xsl:for-each>
         </xsl:otherwise>
        </xsl:choose>
        
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:when test="string-length($current)=0"><!-- starts with / -->
      <xsl:call-template name="hxp-core-content">
       <xsl:with-param name="path" select="substring-after($path,'/')"/>
       <xsl:with-param name="blockPath" select="''"/>
       <xsl:with-param name="blockData" select="$hxpdata"/>
       <xsl:with-param name="mode" select="$mode"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:choose>
       <xsl:when test="$current='.'">
        <xsl:call-template name="hxp-core-content">
         <xsl:with-param name="path" select="substring-after($path,'/')"/>
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
         <xsl:with-param name="mode" select="$mode"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:when test="$current='..'">
        <xsl:call-template name="hxp-core-content">
         <xsl:with-param name="path" select="substring-after($path,'/')"/>
         <xsl:with-param name="blockPath" select="substring-before($blockPath,$hxp-path-separator)"/>
         <xsl:with-param name="blockData" select="$blockData/.."/>
         <xsl:with-param name="mode" select="$mode"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:when test="$current='*'">
        <xsl:variable name="context" select="."/>
        <xsl:for-each select="$blockData/*">
         <xsl:variable name="target" select='.'/>
         <xsl:variable name="current-name" select='name()'/>
         <xsl:variable name="pos" select='count(preceding-sibling::*[name()=$current-name])'/>
         <xsl:for-each select="$context">
          <xsl:call-template name="hxp-core-content">
           <xsl:with-param name="path" select="substring-after($path,'/')"/>
           <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current-name,'[',$pos,']')"/>
           <xsl:with-param name="blockData" select="$target"/>
           <xsl:with-param name="mode" select="$mode"/>
          </xsl:call-template>
         </xsl:for-each>
        </xsl:for-each>
       </xsl:when>
       <xsl:otherwise>
        <xsl:choose>
         <xsl:when test="starts-with($blockPath,'(')"><!-- repetition --> 
          <xsl:variable name="repetition" select="substring-after(substring-before($blockPath,')'),'(')"/>
          <xsl:variable name="cleanBlockPath">
           <xsl:call-template name="clearRepetition"><xsl:with-param name="path" select="$blockPath"/></xsl:call-template>
          </xsl:variable>
          <xsl:choose>
           <xsl:when test="count($blockData/*[name()=$current][position()=1+number($repetition)])=0 and $mode='v'">
            <xsl:call-template name="hxp-core-content">
             <xsl:with-param name="path" select="substring-after($path,'/')"/>
             <xsl:with-param name="blockPath" select="concat($cleanBlockPath,$hxp-path-separator,$current,'[',$repetition,']')"/>
             <xsl:with-param name="blockData" select="$blockData/*[name()=$current][position()=1+number($repetition)]"/>
             <xsl:with-param name="mode" select="$mode"/>
            </xsl:call-template>
           </xsl:when>
           <xsl:otherwise>
            <xsl:if test="count($blockData/*[name()=$current][position()=1+number($repetition)]) > 0">
             <xsl:call-template name="hxp-core-content">
              <xsl:with-param name="path" select="substring-after($path,'/')"/>
              <xsl:with-param name="blockPath" select="concat($cleanBlockPath,$hxp-path-separator,$current,'[',$repetition,']')"/>
              <xsl:with-param name="blockData" select="$blockData/*[name()=$current][position()=1+number($repetition)]"/>
              <xsl:with-param name="mode" select="$mode"/>
             </xsl:call-template>
            </xsl:if>
           </xsl:otherwise>
          </xsl:choose>
         </xsl:when>
         <xsl:otherwise>
          <xsl:choose>
           <xsl:when test="count($blockData/*[name()=$current])=0 and $mode='v'">
            <xsl:call-template name="hxp-core-content">
             <xsl:with-param name="path" select="substring-after($path,'/')"/>
             <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current,'[0]')"/>
             <xsl:with-param name="blockData" select="$blockData/*[name()=$current]"/>
             <xsl:with-param name="mode" select="$mode"/>
            </xsl:call-template>
           </xsl:when>
           <xsl:otherwise>
            <xsl:variable name="context" select="."/>
            <xsl:for-each select="$blockData/*[name()=$current]">
             <xsl:variable name="target" select='.'/>
             <xsl:variable name="pos" select='count(preceding-sibling::*[name()=$current])'/>
             <xsl:for-each select="$context">
              <xsl:call-template name="hxp-core-content">
               <xsl:with-param name="path" select="substring-after($path,'/')"/>
               <xsl:with-param name="blockPath" select="concat($blockPath,$hxp-path-separator,$current,'[',$pos,']')"/>
               <xsl:with-param name="blockData" select="$target"/>
               <xsl:with-param name="mode" select="$mode"/>
              </xsl:call-template>
             </xsl:for-each>
            </xsl:for-each>
           </xsl:otherwise>
          </xsl:choose>
         </xsl:otherwise>
        </xsl:choose>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="clearRepetition">
  <xsl:param name="path" select="''"/>
  <xsl:choose>
   <xsl:when test="starts-with($path,'(')">
    <xsl:call-template name="clearRepetition">
     <xsl:with-param name="path" select="substring-after($path,')')"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$path"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:variable name="repetitionElementSeparator" select="'|'"/>
 <xsl:variable name="iteratedElementPrefix" select="'*'"/>
 <!-- utilizzato per determinare il numero di ripetizioni da eseguire, 
      riceve in ingresso una lista di elementi e un indice verificando la 
      presenza di almeno un elemento della lista con l'indice indicato -->
 <xsl:template name="testElements">
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="positionIndex" select="'0'"/>
  <xsl:param name="elements" select="''"/>
  <!-- il parametro elements � composto da nomi di elemento separati da $repetitionElementSeparator 
       e preceduti da $iteratedElementPrefix se l'elemento � assoggettato ad una ripetizione annidata -->
  <xsl:if test="string-length($elements)>0">
   <xsl:variable name="theElement">
    <xsl:choose>
     <xsl:when test="contains($elements,$repetitionElementSeparator)">
      <xsl:value-of select="substring-before($elements,$repetitionElementSeparator)"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$elements"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <xsl:variable name="result">
    <xsl:choose>
     <xsl:when test="starts-with(normalize-space($theElement),$iteratedElementPrefix)">
      <xsl:if test="$positionIndex='0'">
       <xsl:call-template name="hxp-core-content">
        <xsl:with-param name="path" select="normalize-space(substring-after(normalize-space($theElement),$iteratedElementPrefix))"/>
        <xsl:with-param name="blockData" select="$blockData"/>
        <xsl:with-param name="blockPath" select="concat('(',$positionIndex,')',$blockPath)"/>
        <xsl:with-param name="mode" select="'t'"/><!--test-->
       </xsl:call-template>
      </xsl:if>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxp-core-content">
       <xsl:with-param name="path" select="normalize-space($theElement)"/>
       <xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="blockPath" select="concat('(',$positionIndex,')',$blockPath)"/>
       <xsl:with-param name="mode" select="'t'"/><!--test-->
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <xsl:choose>
    <xsl:when test="not(contains($result,'1'))">
     <xsl:call-template name="testElements">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="positionIndex" select="$positionIndex"/>
      <xsl:with-param name="elements" select="substring-after($elements,$repetitionElementSeparator)"/>
     </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="$result"/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:if>
 </xsl:template>
 <!--
 <xsl:template name="testElements">
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="elements" select="''"/>
  <xsl:param name="positionIndex" select="'0'"/>
  <xsl:if test="string-length($elements)>0">
   <xsl:variable name="theElement">
    <xsl:choose>
     <xsl:when test="contains($elements,$repetitionElementSeparator)">
      <xsl:value-of select="substring-before($elements,$repetitionElementSeparator)"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$elements"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <xsl:variable name="result">
    <xsl:call-template name="hxp-core-content">
     <xsl:with-param name="path" select="normalize-space($theElement)"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="blockPath" select="concat('(',$positionIndex,')',$blockPath)"/>
     <xsl:with-param name="mode" select="'t'"/>
    </xsl:call-template>
   </xsl:variable>
   <xsl:choose>
    <xsl:when test="not(contains($result,'1'))">
     <xsl:call-template name="testElements">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="positionIndex" select="$positionIndex"/>
      <xsl:with-param name="elements" select="substring-after($elements,$repetitionElementSeparator)"/>
     </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="$result"/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:if>
 </xsl:template>
 -->
 <xsl:template name="repetition">
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="elements" select="''"/>
  <xsl:param name="repetitionIndex" select="'0'"/>
  <xsl:variable name="testRepetition">
   <xsl:call-template name="testElements">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
    <xsl:with-param name="elements" select="$elements"/>
    <xsl:with-param name="positionIndex" select="$repetitionIndex"/>
   </xsl:call-template>
  </xsl:variable>
  <xsl:if test="contains($testRepetition,'1')">
   <xsl:apply-templates select="./node()" mode="template">
    <xsl:with-param name="blockData" select="$blockData"/>
    <xsl:with-param name="blockPath" select="concat('(',$repetitionIndex,')',$blockPath)"/>
   </xsl:apply-templates>
   <xsl:call-template name="repetition">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
    <xsl:with-param name="elements" select="$elements"/>
    <xsl:with-param name="repetitionIndex" select="string(1+number($repetitionIndex))"/>
   </xsl:call-template>
  </xsl:if>
 </xsl:template>
 
 <xsl:template name="testPath">
  <xsl:param name="path" select="''"/><xsl:param name="blockData"/><xsl:param name="blockPath"/>
  <xsl:choose>
   <xsl:when test="contains($path,'|')">
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-before($path,'|')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'t'"/><!--test-->
     </xsl:call-template>
    </xsl:variable>
    <xsl:choose>
     <xsl:when test="contains($result,'1')">
      <xsl:value-of select="$result"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="testPath">
       <xsl:with-param name="path" select="substring-after($path,'|')"/>
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      </xsl:call-template>
     </xsl:otherwise>   
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxp-core-content">
     <xsl:with-param name="path" select="$path"/>
     <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="mode" select="'t'"/><!--test-->
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>   
 
 <xsl:template name="testFunctionality">
  <xsl:param name="code"/>
  <xsl:param name="value"/>
  <xsl:choose>
   <xsl:when test="contains($code,'|')">
    <xsl:choose>
     <xsl:when test="$hxpdata//funzionalita_disponibili/@*[name()=substring-before($code,'|')]=$value">1</xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="testFunctionality">
       <xsl:with-param name="code" select="substring-after($code,'|')"/>
      </xsl:call-template>  
     </xsl:otherwise>
    </xsl:choose>        
   </xsl:when>
   <xsl:otherwise>
    <xsl:if test="$hxpdata//funzionalita_disponibili/@*[name()=$code]=$value">1</xsl:if>
   </xsl:otherwise>    
  </xsl:choose>  
 </xsl:template>   

 <xsl:template name="hxp-core">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="param" select="''"/>
  
  <xsl:variable name="chooser" select="substring-before($param,'-')"/>
  
  <xsl:choose>
   <xsl:when test="$chooser='repeatable'">
    <!-- in presenza del dato itera else non copia neppure l'elemento -->
    <xsl:variable name="cleanBlockPath">
     <xsl:call-template name="clearRepetition">
      <xsl:with-param name="path" select="$blockPath"/>
     </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="result">
     <xsl:call-template name="testElements">
      <xsl:with-param name="blockPath" select="$cleanBlockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="elements" select="substring-after($param,'-')"/>
      <xsl:with-param name="positionIndex" select="'0'"/>
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="contains($result,'1')">
     <xsl:copy>
      <xsl:call-template name="attrparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
      <xsl:call-template name="repetition">
       <xsl:with-param name="blockPath" select="$cleanBlockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="repetitionIndex" select="'0'"/>
       <xsl:with-param name="elements" select="substring-after($param,'-')"/>
      </xsl:call-template>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   <xsl:when test="$chooser='repetition'">
    <!-- itera almeno una volta, le iterazioni totali sono pari al massimo numero di ripetizioni del singolo elemento -->
    <xsl:copy>
     <xsl:call-template name="attrparser">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
     <xsl:variable name="cleanBlockPath">
      <xsl:call-template name="clearRepetition">
       <xsl:with-param name="path" select="$blockPath"/>
      </xsl:call-template>
     </xsl:variable>
     <xsl:apply-templates select="./node()" mode="template">
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="blockPath" select="concat('(0)',$cleanBlockPath)"/>
     </xsl:apply-templates>
     <xsl:call-template name="repetition">
      <xsl:with-param name="blockPath" select="$cleanBlockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="repetitionIndex" select="'1'"/>
      <xsl:with-param name="elements" select="substring-after($param,'-')"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:when test="$chooser='copy'"><!-- copy nodes of the argument node-set -->
    <xsl:copy>
     <xsl:call-template name="attrparser">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="mode" select="'c'"/><!--copy-->
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:when test="$chooser='content'"><!-- apply templates on non element nodes of the argument node-set -->
    <xsl:copy>
     <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
     <!--
     <xsl:for-each select="@*[not(name()='id')]"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
     -->
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="mode" select="'w'"/><!--write-->
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:when test="$chooser='container'"><!-- parsed even when the argument expression select an empty set of nodes -->
    <xsl:copy>
     <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
     <!--   
     <xsl:for-each select="@*[not(name()='id')]"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
     -->
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'v'"/><!--virtual-->
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:when test="$chooser='contains'"><!-- parsed when the argument expression doesn't select an empty set of nodes -->
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="not($result='')">
     <xsl:copy>
      <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
      <!--  
      <xsl:for-each select="@*[not(name()='id')]"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
      -->
      <xsl:copy-of select="$result"/>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   <xsl:when test="$chooser='text'"><!-- parsed when string-length(normalize-space(argument/text()))>0, but leaving context unchanged -->
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'tt'"/><!--text-->
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="contains($result,'1')">
     <xsl:copy>
      <!-- fo si lamenta se gli id sono duplicati! -->
      <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
      <!--
      <xsl:for-each select="@*[not(name()='id')]"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
      -->
      <xsl:apply-templates select="./node()" mode="template"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:apply-templates>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   <xsl:when test="$chooser='notext'"><!-- parsed when string-length(normalize-space(argument/text()))=0, but leaving context unchanged -->
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'tt'"/><!--text-->
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="not(contains($result,'1'))">
     <xsl:copy>
      <xsl:call-template name="attrparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
      <xsl:apply-templates select="./node()" mode="template">
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      </xsl:apply-templates>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   <xsl:when test="$chooser='testParameter'"><!-- testParameter-name:value -->
    <xsl:variable name="result">
     <xsl:call-template name="getcustomparam"><xsl:with-param name="param" select="substring-before(substring-after($param,'-'),':')"/></xsl:call-template>
    </xsl:variable>
    <xsl:if test="$result=substring-after($param,':')">
     <xsl:copy>
      <xsl:call-template name="attrparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
      <xsl:apply-templates select="./node()" mode="template">
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      </xsl:apply-templates>
     </xsl:copy>
    </xsl:if>
   </xsl:when> 
   
   <xsl:when test="$chooser='testContent'"><!-- testContent-<xpath>,<value> -->
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-before(substring-after($param,'-'),',')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'t'"/><!--test-->
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="contains($result,'1')">
     <xsl:variable name="content">
      <xsl:call-template name="hxp-core-content">
       <xsl:with-param name="path" select="substring-before(substring-after($param,'-'),',')"/>
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
       <xsl:with-param name="mode" select="'w'"/>
      </xsl:call-template>
     </xsl:variable> 
     <xsl:if test="$content=substring-after($param,',')">
      <xsl:copy>
       <xsl:call-template name="attrparser">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       </xsl:call-template>
       <xsl:apply-templates select="./node()" mode="template">
        <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
       </xsl:apply-templates>
      </xsl:copy>
     </xsl:if>
    </xsl:if>
   </xsl:when>
   
   <xsl:when test="$chooser='test'"><!-- parsed when the argument expression doesn't select an empty set of nodes, but leaving context unchanged -->
    <xsl:variable name="result">
     <xsl:call-template name="testPath">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
     </xsl:call-template>   
    </xsl:variable>
    <xsl:if test="contains($result,'1')">
     <xsl:copy>
      <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
      <!--
      <xsl:for-each select="@*[not(name()='id')]"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
      -->
      <xsl:apply-templates select="./node()" mode="template">
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      </xsl:apply-templates>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   
   <xsl:when test="$chooser='emptyset'"><!-- parsed when the argument expression select an empty set of nodes -->
    <xsl:variable name="result">
     <xsl:call-template name="hxp-core-content">
      <xsl:with-param name="path" select="substring-after($param,'-')"/>
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      <xsl:with-param name="mode" select="'t'"/><!--test-->
     </xsl:call-template>
    </xsl:variable>
    <xsl:if test="not(contains($result,'1'))">
     <xsl:copy>
      <xsl:call-template name="attrparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
      <xsl:apply-templates select="./node()" mode="template">
       <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
      </xsl:apply-templates>
     </xsl:copy>
    </xsl:if>
   </xsl:when>

   <xsl:when test="$chooser='id'"><!-- hxp-core-id-<...> -->
    <xsl:copy>
     <xsl:attribute name="id"><xsl:value-of select="substring-after($param,'-')"/></xsl:attribute>
     <xsl:for-each select="@*[not(name()='id')]">
      <xsl:call-template name="stringparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      </xsl:call-template>
     </xsl:for-each>
     <xsl:apply-templates select="./node()" mode="template">
      <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
     </xsl:apply-templates>
    </xsl:copy> 
   </xsl:when>

   <xsl:when test="$chooser='testRight'">
    <xsl:variable name="mode" select="substring-before(substring-after($param,'-'),',')"/>
    <xsl:variable name="arg">
     <xsl:call-template name="hxp-core-string">
      <xsl:with-param name="block-path" select="$blockPath"/><xsl:with-param name="block-data" select="$blockData" />
      <xsl:with-param name="the-string" select="substring-before(substring-after($param,','),',')" />
     </xsl:call-template>     
    </xsl:variable>
    <xsl:variable name="enabled">
     <xsl:choose>
      <xsl:when test="$mode='visibility'">
       <xsl:if test="contains($hxpdata//funzionalita_disponibili/@visibility,concat(',',substring-after($arg,'/'),','))">1</xsl:if>
      </xsl:when> 
      <xsl:otherwise>
       <xsl:call-template name="testFunctionality">
        <xsl:with-param name="code">
         <xsl:call-template name="hxp-core-string">
          <xsl:with-param name="block-path" select="$blockPath"/><xsl:with-param name="block-data" select="$blockData" />
          <xsl:with-param name="the-string" select="$mode" />
         </xsl:call-template>     
        </xsl:with-param>
        <xsl:with-param name="value" select="$arg"/>
       </xsl:call-template>
      </xsl:otherwise>
     </xsl:choose> 
    </xsl:variable>
    
    <xsl:if test="contains($enabled,'1')">
     <xsl:variable name="more" select="substring-after(substring-after($param,','),',')"/>
     <xsl:choose>
      <xsl:when test="string-length($more)>0"><!-- solo hxp-core -->
       <xsl:call-template name="hxp-core">
        <xsl:with-param name="blockData" select="$blockData"/>
        <xsl:with-param name="blockPath" select="$blockPath"/>
        <xsl:with-param name="param" select="substring-after($more,'hxp-core-')"/>
       </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
       <xsl:copy>
        <xsl:call-template name="attrparser">
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
        <xsl:apply-templates select="./node()" mode="template">
         <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
        </xsl:apply-templates>
       </xsl:copy> 
      </xsl:otherwise>
     </xsl:choose>
    </xsl:if>
   </xsl:when>

   <!-- impostazione dell'attributo checked -->
   <xsl:when test="$chooser='checkData'">
    <xsl:copy>
     <xsl:for-each select="@*[name()!='id']">
      <xsl:call-template name="stringparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      </xsl:call-template>
     </xsl:for-each>
     
     <xsl:variable name="probe"><xsl:for-each select="$blockData"><xsl:value-of select="'1'"/></xsl:for-each></xsl:variable>
     <xsl:variable name="check">
      <xsl:choose>
       <xsl:when test="contains($probe,'1')"><!-- modifica, assumendo che l'elemento vuoto non venga potato -->
        <xsl:if test="normalize-space($blockData/.) = @value">1</xsl:if>        
       </xsl:when>
       <xsl:otherwise><!-- inserimento -->
        <xsl:variable name="argument">
         <xsl:call-template name="hxp-core-string">
          <xsl:with-param name="block-path" select="$blockPath"/>
          <xsl:with-param name="block-data" select="$blockData"/>
          <xsl:with-param name="the-string" select="substring-after($param,'-')" />
         </xsl:call-template>
        </xsl:variable>       
        <xsl:if test="string-length(normalize-space($argument))>0">1</xsl:if>
       </xsl:otherwise>   
      </xsl:choose>        
     </xsl:variable>
     <xsl:if test="$check='1'">
      <xsl:attribute name="checked">checked</xsl:attribute>
     </xsl:if>
     
    </xsl:copy>        
   </xsl:when>
   
   <xsl:when test="$chooser='testAttribute'">
    <xsl:copy>
     <xsl:for-each select="@*[name()!='id']">
      <xsl:call-template name="stringparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      </xsl:call-template>
     </xsl:for-each>

     <xsl:variable name="result">
      <!--
      <xsl:choose>
       <xsl:when test="contains($blockPath,$noparse)"/>
       <xsl:otherwise>
        -->       
        <xsl:call-template name="hxp-core-string">
         <xsl:with-param name="block-path" select="$blockPath"/>
         <xsl:with-param name="block-data" select="$blockData"/>
         <xsl:with-param name="the-string" select="substring-after($param,'-')" />
        </xsl:call-template>
      <!-- 
       </xsl:otherwise>
      </xsl:choose>
      -->
     </xsl:variable>

     <xsl:if test="contains($result,'=')">
      <xsl:attribute name="{substring-before($result,'=')}">
       <xsl:value-of select="substring-after($result,'=')"/>
      </xsl:attribute>
     </xsl:if>
     
     <xsl:apply-templates mode="template">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     </xsl:apply-templates>
     
    </xsl:copy>
   </xsl:when>
   
   <xsl:when test="$chooser='name'">
    <xsl:value-of select="name($blockData)"/>
   </xsl:when>
     
   <xsl:when test="$chooser='callTemplate'">
    <xsl:apply-templates select="//*[@id=concat('dataTemplate_',substring-after($param,'-'))]/node()" mode="template">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
    </xsl:apply-templates>
   </xsl:when>
   
   <xsl:when test="$chooser='testTemplate'">
    <xsl:variable name="result">
     <xsl:choose>
		<!--
      <xsl:when test="ancestor::*[@id=$noParseContainerId]"/>
        -->
      <xsl:when test="contains($blockPath,$noparse)"/>
      <xsl:otherwise>
       <xsl:call-template name="hxp-core-content">
        <xsl:with-param name="path" select="substring-after($param,'-')"/>
        <xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="blockPath" select="$blockPath"/>
        <xsl:with-param name="mode" select="'t'"/><!--test-->
       </xsl:call-template>
      </xsl:otherwise>
     </xsl:choose> 
    </xsl:variable>
    <xsl:copy>
     <xsl:call-template name="attrparser">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
     <xsl:choose>
      <xsl:when test="contains($result,'1')">
       <xsl:apply-templates select="//*[@id=concat('dataTemplate_',substring-after($param,'-'))]/node()" mode="template">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
       <xsl:apply-templates mode="template">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       </xsl:apply-templates>
      </xsl:otherwise>
     </xsl:choose>
    </xsl:copy>

   </xsl:when>
   <xsl:when test="$param='ignore'"/>
   <xsl:when test="$param='noparse'">
    <xsl:apply-templates mode="template">
     <xsl:with-param name="blockPath" select="concat($noparse,$blockPath)"/><xsl:with-param name="blockData" select="$blockData"/>
    </xsl:apply-templates>
    <!--
    <xsl:apply-templates select="node()" mode="noparse"/>
    -->
   </xsl:when>
   <xsl:otherwise>
    <xsl:text>unhandled core id:</xsl:text>
    <xsl:value-of select="$chooser"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

<!-- modo noparse: era utilizzato dall'editor per contenere i template degli elementi per la costruzione dinamica 
     il modo "noparse" elimina le parti non necessarie o di disturbo all'utilizzo dinamico sul browser 
 <xsl:template match="@*[starts-with(.,'$hxp_core_content')]" mode="noparse"/>
 <xsl:template match="@id[starts-with(.,'hxp-core-test-attribute-$hxp_core_testElements')]" mode="noparse"/>
 <xsl:template match="@style[starts-with(.,'display:$hxp_core_testElements')]" mode="noparse">
  <xsl:attribute name="style">
   <xsl:text>display:</xsl:text><xsl:value-of select="substring-before(substring-after(substring-after(substring-after(substring-after(.,','),','),','),','),$stop-parameters)"/>
  </xsl:attribute>
 </xsl:template>
 <xsl:template match="node()|@*" mode="noparse">
  <xsl:copy><xsl:apply-templates select="node()|@*" mode="noparse"/></xsl:copy>
 </xsl:template>
-->

</xsl:stylesheet>
