<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Gestione di azioni particolari da una pagina che permette di operare azioni dalla pagina del documento, come
     ad esempio la cancellazione dei documenti -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<xsl:include href="filelist_embedded.xsl"/> <!--  Per l'utilizzo di iw -->

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<xsl:call-template name="jslist_embedded"/> <!-- per iw -->
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/doc_response.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/msg/doc_responseMSG.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:call-template name="bodyattributes_embedded"/>
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" enctype="multipart/form-data" id="hxpForm" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
			<input type="hidden" name="doc_responseText" value="{$hxpdata/@doc_responseText}" /> <!-- testo -->
			<input type="hidden" name="attach" value="{$hxpdata/@attach}" /> <!-- esclusivo per allegati -->
			<input type="hidden" name="name" value="{$hxpdata/@name}" /> <!-- esclusivo per allegati -->
			<input type="hidden" name="loadAttach" value="{$hxpdata/@loadAttach}" /> <!-- esclusivo per chkin -->
			<input type="hidden" name="convReq" value="{$hxpdata/@convReq}" /> <!-- richiesta conversioni (mbussetti,21/03/2005)-->

            <!-- simone - 20 Giu 2005 -->
		    <input type="hidden" name="sizeMaxFile" value="{$hxpdata/@sizeMaxFile}" />
		    <input type="hidden" name="filesWithSize" value="" />

		    <!--
		    	Federico 02/08/07: introdotta possibilita' di controllo dell'estensione dell'allegato
        		indicato nella pagina di chkin [RW 0046080]
        	-->
			<input type="hidden" name="allowedChkinExtensions" value="{$hxpdata/@allowedChkinExtensions}"/>

			<xsl:call-template name="beforeend_embedded"/>
		</form>
	</xsl:template>


	<!--

   Implementazione dei singoli template action

	-->


	<!-- Chiude la finestra
	   id="hxp-doc_response-action-close" -->
	<xsl:template name="doc_responseClose">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return closeDoc_response();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Pulsante di conferma annullamento documento
	   id="hxp-doc_response-action-confirmAnnul" -->
	<xsl:template name="doc_responseConfirmAnnul">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return confirmAnnulDoc_response();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>


	<!-- Info su chkin
	   id="hxp-doc_response-data-infoChkin" -->
	<xsl:template name="doc_responseinfochkin">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onmouseover">
				<xsl:text>window.status='A cura di </xsl:text>
				<xsl:value-of select="$blockData/chkin/@operatore"/>
				<xsl:text>';return true;</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onmouseout">
				<xsl:text>window.status=window.defaultStatus</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		introdotto da mbussetti il 30/03/2005
		id="hxp-doc_response-data-metadata"
		Inserisce nella pagina di visualizzazione i metadati delle versioni un allegato (in un div nascosto)
	-->
	<xsl:template name="doc_responsemetadata">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="id">
				<xsl:text>metaView_</xsl:text>
				<xsl:value-of select="$blockData/../@name"/>
			</xsl:attribute>
			<xsl:element name="p">
				<xsl:apply-templates select="$blockData/*" mode="editXmlAsHtml">
		  		</xsl:apply-templates>
	  		</xsl:element>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-doc_response-data-... -->
	<xsl:template name="doc_responsedata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='css'"> <!-- css -->
				<!-- Federico 15/12/06: eliminato '//' inutile [RW 0040831] -->
				<xsl:if test="$hxpdata/@dbTable=substring-after($value,'-')">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='infoChkin'">
				<xsl:call-template name="doc_responseinfochkin">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!--
				inserito da mbussetti il 30/03/2005: visualizzazione dei metadati delle versioni di un allegato
			-->
			<xsl:when test="$value='metadata'">
				<xsl:call-template name="doc_responsemetadata">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Pulsante di conferma operazione di chkin
	   id="hxp-doc_response-action-commitChkin" -->
	<xsl:template name="doc_responseCommitChkin">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return commitChkin('</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata/@name"/>
					</xsl:call-template>
					<xsl:text>');</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>


	<!-- Copia elemento contenente l'id se il file  firmato
	   id="hxp-doc-action-fileIsSigned"
	   -->
	<xsl:template name="docfileissigned">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="contains($blockData/@name,'.p7m') or
                              contains($blockData/@name,'.s@s')">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="docfileiscrypted">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="contains($blockData/@name,'.c@s')">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Mostra le informazioni sulla firma di un file
	   id="hxp-doc-action-fileIsSigned"
	   -->
	<xsl:template name="docshowsign">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraFirma(false,'</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="docshowreaders">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraLettori(false,'</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-doc_response-action-... -->
	<xsl:template name="doc_responseaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$value='showSign'">
				<xsl:call-template name="docshowsign">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showReaders'">
				<xsl:call-template name="docshowreaders">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileIsSigned'">
				<xsl:call-template name="docfileissigned">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileIsEncrypted'">
				<xsl:call-template name="docfileiscrypted">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='getfile'">
				<xsl:call-template name="getfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- introdotto da mbussetti il 21/03/2005 -->
			<xsl:when test="substring-before($value,'-')='getfileconversions'">
				<xsl:call-template name="getfileconversions">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- introdotto da mbussetti il 21/03/2005 -->
			<xsl:when test="$value='disappear'">
				<xsl:call-template name="disappear">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='commitChkin'">
				<xsl:call-template name="doc_responseCommitChkin">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='close'">
				<xsl:call-template name="doc_responseClose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirmAnnul'">
				<xsl:call-template name="doc_responseConfirmAnnul">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='doc_response'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-doc_response-action-... -->
								<xsl:call-template name="doc_responseaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-doc_response-data-... -->
								<xsl:call-template name="doc_responsedata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxparser_embedded">
							<xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="$disable" />
						</xsl:call-template>
<!--						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>-->
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
