<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
 * Created on.....: 28/08/2004
 * by.............: Federico Grillini
 * organization...: 3D Informatica
 *
 *
 * Gestione delle informazioni relative alla document type definition dell'output finale.
 * Vengono inizializzate due variabili globali:
 *	   
 *	   		- "_docTypePublic": indica l'identificatore pubblico della document type
 *	   							definition utilizzata. Il valore di default  
 *	   							"-//W3C//DTD HTML 3.2 Final//EN". 
 *	   		- "_docTypeSystem": indica il secondo identificatore (che  opzionale) del tag
 *	   							<!Doctype ....>. Tipicamente esso  un url.
 *	   
 * I valori di tali variabili vengono prelevati dal template html utilizzato (identificato
 * dalla variabile "hxptemplate"), andando a leggere gli attributi - se presenti - del
 * tag "head". Tali attributi sono "docTypePublic" e "docTypeSystem".
 * E', quindi, possibile utilizzare dei valori di doctype definition differenti da quelli di
 * default inserendo nel template html gli attributi menzionati. Per esempio si pu scrivere:
 *
 * <head docTypePublic="-//W3C//DTD XHTML 1.0 Strict//EN"
 * 		 docTypeSystem="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
 *	   
 * Una volta inizializzate, queste variabili vengono impiegate nell'elemento
 * "<xsl:output>" presente in fondo a questo file.
 *
 * Se si vuole utilizzare questo file per gestire la document type definition, occorre includerlo
 * nel file xsl specifico dell'applicazione che viene invocato per primo (dove, cio, deve essere
 * presente l'istruzione <xsl:output...>).
 * Ovviamente, in tale file non devono essere presenti altre istruzioni <xsl:output>.
-->  
  
<!--
	 La versione di "xsl:stylesheet" deve essere "1.1" affinch vengano gestite
	 correttamente le informazioni relative alla document type definition dell'html finale.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1">
  
  <xsl:variable name="_docTypePublic">
  	<xsl:choose>
  		<xsl:when test="$hxptemplate//head/@docTypePublic != ''">
  			<xsl:value-of select="$hxptemplate//head/@docTypePublic"/>
  		</xsl:when>
  		<xsl:otherwise>-//W3C//DTD HTML 3.2 Final//EN</xsl:otherwise>
  	</xsl:choose>
  </xsl:variable>
  
  <xsl:variable name="_docTypeSystem">
  		<xsl:value-of select="$hxptemplate//head/@docTypeSystem"/>
  </xsl:variable>
  
  <xsl:output method="html" indent="yes" encoding="iso-8859-1" doctype-public='{$_docTypePublic}' doctype-system='{$_docTypeSystem}'/>
  
</xsl:stylesheet>
