<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina di visualizzazione di errore
Sono previsti due meccanismi per ripristinare la situazione prima del verificarsi dell'errore.
La decisione spetta comunque al java: chi implementa la gestione in java di un determinato errore a
seconda che passi o meno tutte le informazioni (tuple) per il ripristino pre-errore puo' scegliere il
tipo di gestione: 'history' se usare history.back() di javascript, ogni altro valore per usare il
classico submit()
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/errorMsg.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
	</xsl:template>

	<!-- hxpForm (form nascosta - aggiungere ogni tupla che serve per ripristinare il tipo di errore) -->
	<xsl:template name="beforeend">
		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<div>
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="xverb" value="" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="query" value="{$hxpdata/@query}" />

            <!-- Federico 10/03/09: aggiunte tuple 'selid' e 'physDoc' [M 0000174] -->
            <input type="hidden" name="selid" value="{$hxpdata/@selid}" />
            <input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
			</div>
		</form>
	</xsl:template>


	<!--

   Implementazione dei singoli template action

	-->


	<!-- Chiude la pagina di errore: id="hxp-errormsg-action-close" -->
	<xsl:template name="errmsgclose">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:if test="name()='a' or name='A'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>return back('</xsl:text>
				<xsl:value-of select="$hxpdata/@destPage"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$hxpdata//errore/@handType"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!--

   Implementazione dei singoli template data

	-->

	<!-- Nome del nodo: id="hxp-errormsg-data-name" -->
	<xsl:template name="nodename">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="name">nodeName</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$hxpdata/@name" />
			</xsl:attribute>
		</xsl:copy>
	</xsl:template>



	<!-- Smistamento dei template hxp-errormsg-data-...
	id="hxp-errormsg-data-errtype" tipo di errore
	id="hxp-errormsg-data-extra"   messaggio specifico di errore
	-->
	<xsl:template name="nodedata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />

        <!--
            Federico 27/05/08: introdotto stack dell'eccezione (eventualmente "troncato" alla causa primaria dell'errore)
            nei dettagli dell'errore, pertanto e' necessario l'unescaping di eventuali BR presenti [RW 0052239]
        -->
        <xsl:choose>
			<xsl:when test="$value='errtype'">
				<xsl:value-of select="$hxpdata//errtype" disable-output-escaping = "yes"/>
			</xsl:when>
			<xsl:when test="$value='extra'">
				<xsl:value-of select="$hxpdata//extra" disable-output-escaping = "yes"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Smistamento dei template hxp-errormsg-action-... -->
	<xsl:template name="nodeaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='close'">
				<xsl:call-template name="errmsgclose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='errormsg'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-errmsg-action-... -->
								<xsl:call-template name="nodeaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-errmsg-data-... -->
								<xsl:call-template name="nodedata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
