<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Gestione del plugin IW -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:xw="http://www.3di.it/ns/xw-200203121136" 
                xmlns:h="http://www.w3.org/HTML/1998/html4"
                exclude-result-prefixes="xw h"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->
	
	<!-- Javascript da includere -->
	<xsl:template name="jslist_embedded">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/filelist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/msg/filelist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/iw.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		
		<!-- gestione avanzata di allegati -->
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/filelist_x.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
  <!--
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/msg/filelist_x.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
  -->
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes_embedded">
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend_embedded">
		<input type="hidden" name="fileList" value="{$hxpdata/@fileList}" />
		<input type="hidden" name="extraView" value="" />
		<input type="hidden" name="selectedIndex" value="{$hxpdata/@selectedIndex}" />
	</xsl:template>


	<!--
 
   Implementazione dei singoli template data
 
	-->
	
	<!-- Inserimento nella pagina html dell'activeX di IW
	     id="hxp-filelist-data-iw-(width),(height),(background color)" 
	     I parametri sono espressi in stile html, ad esempio width pu essere 100% o 100px...
	-->
	<xsl:template name="filelistiw">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:param name="eventi" select="''"/>
		<xsl:variable name="width" select="substring-before($params,',')"/>
		<xsl:variable name="height" select="substring-before(substring-after($params,','),',')"/>
		<xsl:variable name="bgcolor" select="substring-after(substring-after($params,','),',')"/>				

		<xsl:if test="$eventi!='no'">
			<script FOR="IW" EVENT="OnAcquire(filelist)" LANGUAGE="JavaScript">
	              DoneWithAcquire(filelist);
			</script>
			<script FOR="IW" EVENT="OnUpload(data, param, status)" LANGUAGE="JavaScript">
	              DoneWithUpload(data, param, status);
			</script>
			<script FOR="IW" EVENT="OnDownload(param, filename, status)" LANGUAGE="JavaScript">
	              DoneWithDownload(param, filename, status);
			</script>
		</xsl:if>
		
		<xsl:variable name="name">
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:element name="object">
			<xsl:attribute name="id">
				<xsl:text>IW</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>.</xsl:text>
					<xsl:for-each select="$blockData">
						<xsl:call-template name="matchcontent">
							<xsl:with-param name="elemName" select="$name" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="style">
			  <xsl:text>width:</xsl:text>
			  <xsl:value-of select="$width"/>
			  <xsl:text>;height:</xsl:text>
			  <xsl:value-of select="$height"/>
			  <xsl:text>;margin:0 0 0 0;</xsl:text>
			 </xsl:attribute>
			<xsl:attribute name="classid">clsid:ED5D2306-0FF4-11D2-B37C-0000C000D50D</xsl:attribute>
			<xsl:attribute name="codebase">../../../formatter/html/data/iw/iwfull.cab#Version=1,3,148,590</xsl:attribute>
			<xsl:element name="param">
				<xsl:attribute name="name">mode</xsl:attribute>
				<xsl:attribute name="value">1</xsl:attribute>
			</xsl:element>
			<xsl:element name="param">
				<xsl:attribute name="name">bgcolor</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$bgcolor"/></xsl:attribute>
			</xsl:element>
		</xsl:element>
	</xsl:template>


	<!-- Inserimento nella pagina html dell'activeX di IW
	     id="hxp-filelist-iw_x-(width),(height),(background color)" 
	     I parametri sono espressi in stile html, ad esempio width pu' essere 100% o 100px...
	-->
	<xsl:template name="filelistiw_x">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:variable name="width" select="substring-before($params,',')"/>
		<xsl:variable name="height" select="substring-before(substring-after($params,','),',')"/>
		<xsl:variable name="bgcolor" select="substring-after(substring-after($params,','),',')"/>				

      <script FOR="IW"
              EVENT="OnAcquire(filelist)"
              LANGUAGE="JavaScript">
              DoneWithAcquire(filelist);
      </script>
      <script FOR="IW"
              EVENT="OnUpload(data, param, status)"
              LANGUAGE="JavaScript">
              DoneWithUpload(data, param, status);
      </script>
		<xsl:variable name="name">
			<xsl:value-of select="@name"/>
		</xsl:variable>
		<xsl:element name="object">
			<xsl:attribute name="id">
				<xsl:text>IW</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>.</xsl:text>
					<xsl:value-of select="$name" />
					<xsl:variable name="numeroPosizione">
						<xsl:for-each select="$blockData">
							<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$numeroPosizione" />				
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="style">
			  <xsl:text>width:</xsl:text>
			  <xsl:value-of select="$width"/>
			  <xsl:text>;height:</xsl:text>
			  <xsl:value-of select="$height"/>
			  <xsl:text>;margin:0 0 0 0;</xsl:text>
			 </xsl:attribute>
			<xsl:attribute name="classid">clsid:ED5D2306-0FF4-11D2-B37C-0000C000D50D</xsl:attribute>
			<xsl:attribute name="CODEBASE">../../../formatter/html/data/iw/iwfull.cab#Version=1,3,148,590</xsl:attribute>
			<xsl:element name="param">
				<xsl:attribute name="name">mode</xsl:attribute>
				<xsl:attribute name="value">0</xsl:attribute>
			</xsl:element>
			<xsl:element name="param">
				<xsl:attribute name="name">bgcolor</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$bgcolor"/></xsl:attribute>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<!-- Inserimento nella pagina html dell'activeX di IW
	     id="hxp-filelist-iw_preview-(width),(height),(background color)" 
	     I parametri sono espressi in stile html, ad esempio width pu' essere 100% o 100px...
	     Per effettuare il preview delle immagini prima dell' uploal
	-->
	<xsl:template name="filelistiw_preview">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:param name="instPosDep" select="''"/>

		<xsl:variable name="width" select="substring-before($params,',')"/>
		<xsl:variable name="height" select="substring-before(substring-after($params,','),',')"/>
		<xsl:variable name="bgcolor" select="substring-before(substring-after(substring-after($params,','),','),',')"/>
		<xsl:variable name="theimage">
						
       <xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="substring-before(substring-after(substring-after(substring-after($params,','),','),','),',')"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
    
       <xsl:variable name="source">
      
       <xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="substring-after(substring-after(substring-after(substring-after($params,','),','),','),',')"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
      
    	<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="@name"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
    
    
      
      <xsl:variable name="id">
			<xsl:if test="@name!=''">	
					<xsl:value-of select="$name" />
			</xsl:if>
	  </xsl:variable>

	
		<xsl:element name="object">
				
		      <xsl:attribute name="id">
				<xsl:value-of select="$id"/>
			</xsl:attribute>
				
			<xsl:attribute name="style">
			  <xsl:text>width:</xsl:text>
			  <xsl:value-of select="$width"/>
			  <xsl:text>;height:</xsl:text>
			  <xsl:value-of select="$height"/>
			  <xsl:text>;margin:0 0 0 0;</xsl:text>
		 </xsl:attribute>
			<xsl:attribute name="classid">clsid:ED5D2306-0FF4-11D2-B37C-0000C000D50D</xsl:attribute>
			<xsl:attribute name="CODEBASE">../../../formatter/html/data/iw/iwfull.cab#Version=1,3,148,590</xsl:attribute>
			
			
			
			<xsl:element name="param">
				<xsl:attribute name="name">mode</xsl:attribute>
				<xsl:attribute name="value">0</xsl:attribute>
			</xsl:element>
			
			<xsl:element name="param">
				<xsl:attribute name="name">bgcolor</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$bgcolor"/></xsl:attribute>
			</xsl:element>
			

				<xsl:element name="param">
				<xsl:attribute name="name">source</xsl:attribute>
				<xsl:attribute name="value">
				
				<xsl:value-of select="$source"/>
				
				</xsl:attribute>
			</xsl:element>
		

			
		</xsl:element>

		
					      <!--scanner-->
      <script FOR="{$id}"
              EVENT="OnAcquire(filelist)"
              LANGUAGE="JavaScript">
              DoneWithAcquire(filelist,'<xsl:value-of select="$theimage"/>','<xsl:value-of select="$id"/>');
      </script>
<!--
			<script>	
	   loadIWobject('<xsl:value-of select="$id"/>','<xsl:value-of select="$source"/>');
		</script>	
-->
		
	</xsl:template>	
	
	
	<!-- Inserimento nella pagina html dell'activeX di IW
	     id="hxp-filelist-iw_preview-(width),(height),(background color)" 
	     I parametri sono espressi in stile html, ad esempio width pu' essere 100% o 100px...
	     Per effettuare il preview delle immagini prima dell'upload
	-->
	<xsl:template name="filelistiw_preview_reload">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:param name="instPosDep" select="''"/>

		<xsl:variable name="width" select="substring-before($params,',')"/>
		<xsl:variable name="height" select="substring-before(substring-after($params,','),',')"/>
		<xsl:variable name="bgcolor" select="substring-before(substring-after(substring-after($params,','),','),',')"/>
		<xsl:variable name="theimage">
						
       <xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="substring-before(substring-after(substring-after(substring-after($params,','),','),','),',')"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
    
       <xsl:variable name="source">
      
       <xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="substring-after(substring-after(substring-after(substring-after($params,','),','),','),',')"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
      
    	<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="@name"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable> 
    
    
      
      <xsl:variable name="id">
			<xsl:if test="@name!=''">	
					<xsl:value-of select="$name" />
			</xsl:if>
	  </xsl:variable>

	<!--
		<xsl:element name="object">
				
		      <xsl:attribute name="id">
				<xsl:value-of select="$id"/>
			</xsl:attribute>
				
			<xsl:attribute name="style">
			  <xsl:text>width:</xsl:text>
			  <xsl:value-of select="$width"/>
			  <xsl:text>;height:</xsl:text>
			  <xsl:value-of select="$height"/>
			  <xsl:text>;margin:0 0 0 0;</xsl:text>
		 </xsl:attribute>
			<xsl:attribute name="classid">clsid:ED5D2306-0FF4-11D2-B37C-0000C000D50D</xsl:attribute>
			<xsl:attribute name="CODEBASE">../../../formatter/html/data/iw/iwfull.cab#Version=1,3,148,590</xsl:attribute>
			
			
			
			<xsl:element name="param">
				<xsl:attribute name="name">mode</xsl:attribute>
				<xsl:attribute name="value">0</xsl:attribute>
			</xsl:element>
			
			<xsl:element name="param">
				<xsl:attribute name="name">bgcolor</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="$bgcolor"/></xsl:attribute>
			</xsl:element>
			

				<xsl:element name="param">
				<xsl:attribute name="name">source</xsl:attribute>
				<xsl:attribute name="value">
				
				<xsl:value-of select="$source"/>
				
				</xsl:attribute>
			</xsl:element>
		

			
		</xsl:element>
 -->
		
					      <!--scanner-->
 <!--
      <script FOR="{$id}"
              EVENT="OnAcquire(filelist)"
              LANGUAGE="JavaScript">
              DoneWithAcquire(filelist,'<xsl:value-of select="$theimage"/>','<xsl:value-of select="$id"/>');
      </script>
     --> 
      

			<script>	
	   loadIWobject('<xsl:value-of select="$id"/>','<xsl:value-of select="$source"/>',true);
		</script>	

		
	</xsl:template>	
	
	
	<!-- Smistamento dei template hxp-filelist-data-... -->
	<xsl:template name="listdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="instPosDep" select="''"/>
		<xsl:copy>
		
		<xsl:for-each select="@*[name()!='id']">
			<xsl:call-template name="stringparser">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:for-each>
	
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			
			<xsl:choose>
				<xsl:when test="$value='numberofpages'">
					<xsl:number value="1 + string-length($hxpdata/@fileList) - string-length(translate($hxpdata/@fileList,' ',''))" format="1" />
				</xsl:when>
				<xsl:when test="$value='numberofgroups'">
					<xsl:number value="1 + string-length($hxpdata/@fileList) - string-length(translate($hxpdata/@fileList,',',''))" format="1" />
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='iw'">
					<xsl:call-template name="filelistiw">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="params" select="substring-after($value,'-')"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='iw_only_show'">
					<xsl:call-template name="filelistiw">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="params" select="substring-after($value,'-')"/>
						<xsl:with-param name="eventi" select="'no'"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='iw_x'">
					<xsl:call-template name="filelistiw_x">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="params" select="substring-after($value,'-')"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='iw_preview'">
					<xsl:call-template name="filelistiw_preview">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="params" select="substring-after($value,'-')"/>
						<xsl:with-param name="instPosDep" select="''" />
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='iw_preview_reload'">
					<xsl:call-template name="filelistiw_preview_reload">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="params" select="substring-after($value,'-')"/>
						<xsl:with-param name="instPosDep" select="''" />
					</xsl:call-template>					
				</xsl:when>				
				<xsl:when test="$value='countImmagini'">
					<xsl:value-of select="count($blockData//immagini/xw:file[@name!=''])"/>
				</xsl:when>
				<xsl:when test="substring-before($value,'-')='countImmagini_x'">
					<xsl:variable name="params" select="substring-after($value,'-')"/>
					<xsl:value-of select="count($blockData//xw:file[@name!='' and contains($params,name(..))])"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>					
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->
 
 	<!-- Visualizza la prima pagina: id="hxp-filelist-action-first" -->
	<xsl:template name="listfirst">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,' ',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return primaPagina();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

 	<!-- Visualizza la pagina precedente: id="hxp-filelist-action-prev" -->	
	<xsl:template name="listprev">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,' ',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
 	<!-- Visualizza la pagina successiva: id="hxp-filelist-action-next" -->
	<xsl:template name="listnext">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,' ',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
 	<!-- Visualizza il gruppo precedente: id="hxp-filelist-action-gprev" -->
	<xsl:template name="listgprev">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,',',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return gruppoPrecedente();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
 	<!-- Visualizza il gruppo precedente: id="hxp-filelist-action-gnext" -->
	<xsl:template name="listgnext">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,',',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return gruppoSuccessivo();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
 	<!-- Visualizza l'ultima pagina: id="hxp-filelist-action-last" -->
	<xsl:template name="listlast">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="string-length($hxpdata/@fileList) != string-length(translate($hxpdata/@fileList,' ',''))">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return ultimaPagina();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
 	<!-- Chiude la pagina di filelist: id="hxp-filelist-action-close" -->
	<xsl:template name="listclose">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return listClose();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


 	<!-- Gestisce la scansione di immagini tramite iw: 
 	     id="hxp-filelist-action-scan" oppure 
 	     id="hxp-filelist-action-quickscan" nel caso di scansione veloce -->
	<xsl:template name="listscan">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:param name="insertBefore" select="'false'" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>										
				<xsl:text>return scan('</xsl:text>
				<xsl:value-of select="$params"/>
				<xsl:text>'</xsl:text>
				<xsl:if test="$insertBefore='true'">
					<xsl:text>,this</xsl:text>
				</xsl:if>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Inserisce in una select i tag option corrispondenti alle immagini allegate al documento 
	     id="hxp-filelist-action-selectImmagine" se si vuole visualizzare il title dell'immagine
	     id="hxp-filelist-action-selectImmagineWithPosition" se si vuole visualizzare la posizione
	-->
	<xsl:template name="listselectImmagine">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="''" />		
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
		<!--	<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>-->
			<xsl:attribute name="name">
				<xsl:text>selezionaImmagine</xsl:text>
			</xsl:attribute>			
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$hxpdata//immagini/xw:file[@name!='']">
				
				//aggiunta di mbussetti del 25/05/2005: aggiunta l'indicazione della size accanto alle immagini (tif)				
				<xsl:variable name="sizeNodes" select="./metadata//*[name()='FileSize' or name()='fileSize' or name()='filesize']"/>
				<xsl:variable name="sizeIndicator">
					<xsl:for-each select="$sizeNodes[1]">
						<xsl:text>(</xsl:text>
						<xsl:value-of select="round(text() div 1024)"/>
						<xsl:text> KB)</xsl:text>
					</xsl:for-each>
				</xsl:variable>
				
				<xsl:choose>
					<xsl:when test="$tipo='posizione'">
						<option value="{./@name}"><xsl:value-of select="position()"/></option>
					</xsl:when>
					<xsl:otherwise>
						<option value="{./@name}">
							<xsl:value-of select="./@title"/>
							<xsl:text>&#32;</xsl:text>
							<xsl:value-of select="$sizeIndicator"/>
						</option>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- 
		id="hxp-filelist-action-selectPdf"
		Inserisce in una select i tag option corrispondenti ai pdf prodotti raccogliendo le 
		immagini allegate al documento 
	-->
	<xsl:template name="listselectPdf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="''" />		
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="name">
				<xsl:text>selezionaPdf</xsl:text>
			</xsl:attribute>
			<!-- per ogni file allegato -->
			<xsl:for-each select="$hxpdata//files/xw:file[@name!='']">
				<xsl:variable name="estensione">
					<xsl:call-template name="splitLast">
						<xsl:with-param name="salsiccia" select="./@name"/>
						<xsl:with-param name="nodino" select="'.'"/>
					</xsl:call-template>
				</xsl:variable>
				<!-- se  un pdf -->
				<xsl:if test="$estensione='pdf'">
					<!-- se  un file derivato -->
					<xsl:if test="./@der_from and ./@der_from!=''">
						<xsl:variable name="riferimento_incrociato">
							<xsl:choose>
								<xsl:when test="contains(./@der_from,';')">
									<xsl:value-of select="substring-before(./@der_from,';')"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="./@der_from"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<!-- se  prodotto da un'immagine -->
						<xsl:if test="$hxpdata//immagini/xw:file[@name=$riferimento_incrociato]">
							<xsl:variable name="nomeDoro">
								<xsl:value-of select="./@name"/>
							</xsl:variable>
							
							<xsl:element name="option">
								<xsl:attribute name="value">
									<xsl:text>%ID|</xsl:text>
									<xsl:value-of select="$nomeDoro"/>
									
									<xsl:text>%HREF|</xsl:text>
									<xsl:value-of select="$hxpdata/@uri"/>
									<xsl:text>?verbo=attach&#38;db=</xsl:text>
									<xsl:value-of select="$hxpdata/@db"/>
									<xsl:text>&#38;id=</xsl:text>
									<xsl:value-of select="$nomeDoro"/>
									<xsl:text>&#38;host=</xsl:text>
									<xsl:value-of select="$hxpdata/@host"/>
									<xsl:text>&#38;port=</xsl:text>
									<xsl:value-of select="$hxpdata/@port"/>
									<xsl:text>&#38;name=</xsl:text>
									<xsl:value-of select="./@title"/>
									<xsl:call-template name="aclparams">
									</xsl:call-template>
									
									<xsl:text>%DER|</xsl:text>
									<xsl:for-each select="$hxpdata//immagini/xw:file[@der_to=$nomeDoro]">
										<xsl:value-of select="./@name"/>
										<xsl:text>;</xsl:text>
									</xsl:for-each>
								</xsl:attribute>
								<xsl:value-of select="./@title"/>
							</xsl:element>
						</xsl:if>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Inserisce in una select i tag option corrispondenti alle immagini allegate al documento 
	     id="hxp-filelist-action-selectImmagine-(containers name)"
	     (containers name) rappresenta la lista dei nomi degli elemeneti contenitore degli xw:file che si desidera
	     visualizzare. La sua sintassi: 'ELEMENT','ELEMENT1'...
	-->
	<xsl:template name="listselectImmagine_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="''" />		
		<xsl:param name="params" select="''" />				
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="name">
				<xsl:text>selezionaImmagine</xsl:text>
			</xsl:attribute>			
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//xw:file[@name!='' and contains($params,name(..))]">
				<option value="{./@name}"><xsl:value-of select="./@title"/></option>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	

	<!-- Inserisce in una select i tag option corrispondenti alle immagini thumbnail dell'elemento del contesto corrente
	     id="hxp-filelist-action-selectThumbnail" se si vuole visualizzare il title dell'immagine
	     id="hxp-filelist-action-selectThumbnailWithPosition" se si vuole visualizzare la posizione
	     
	     In inserimento la presenza di un input con name 
	     L'input corrispondente al salvataggio del thumbnail deve possedere un id cos fatto:
	     id="iw.imgconv.width=<width>,height=<height>,format=<vedi iw documentation>,compression=<iw documentation>,flags=<iw documentation>"
	-->
	<xsl:template name="listselectThumbnail">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>selezionaImmagine</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>-</xsl:text>
					<xsl:for-each select="$blockData">
						<xsl:call-template name="matchcontent">
							<xsl:with-param name="elemName" select="$name" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//immagini/xw:file[@name!='']">
				<xsl:choose>
					<xsl:when test="./thumb/@name!=''">
						<xsl:choose>
							<xsl:when test="$tipo='posizione'">
								<option value="{./thumb/@name}"><xsl:value-of select="position()"/></option>
							</xsl:when>
							<xsl:otherwise>
								<option value="{./thumb/@name}"><xsl:value-of select="./@title"/></option>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$tipo='posizione'">
								<option value="{./@name}"><xsl:value-of select="position()"/></option>
							</xsl:when>
							<xsl:otherwise>
								<option value="{./@name}"><xsl:value-of select="./@title"/></option>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>										
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Inserisce in una select i tag option corrispondenti alle immagini thumbnail dell'elemento specificato del contesto corrente
	     id="hxp-filelist-action-selectThumbnail-(lista di elementi containers delimitati da apice e separati da virgola)" 
	-->
	<xsl:template name="listselectThumbnail_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>selezionaImmagine</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$name" />
					<xsl:variable name="numeroPosizione">
						<xsl:for-each select="$blockData">
							<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$numeroPosizione" />				
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//xw:file[@name!='' and contains($params,name(..))]">			
				<xsl:choose>
					<xsl:when test="./thumb/@name!=''">
						<option value="{./thumb/@name}"><xsl:value-of select="./@title"/></option>
					</xsl:when>
					<xsl:otherwise>
						<option value="{./@name}"><xsl:value-of select="./@title"/></option>
					</xsl:otherwise>
				</xsl:choose>										
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

<!-- Inserisce in una select i tag option corrispondenti alle immagini thumbnail dell'elemento specificato del contesto corrente
	     id="hxp-filelist-action-selectThumbnail-(lista di elementi containers delimitati da apice e separati da virgola)" 
	-->
	
<xsl:template name="listselectThumbnail_LI_x">

<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:copy>
			<!--<xsl:copy-of select="@*[name()!='id']"
			<xsl:variable name="name">
				<xsl:value-of select="@name"/> 
			</xsl:variable>-->
			<xsl:attribute name="id">
				<xsl:text>selezionaImmagine</xsl:text>
				<xsl:if test="$params!=''">
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$params" />
					<xsl:text>-</xsl:text>
					<xsl:variable name="numeroPosizione">
						<xsl:for-each select="$blockData">
							<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$numeroPosizione+1" />				
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//xw:file[@name!='' and contains($params,name(..))]">			
				<xsl:choose>
					<xsl:when test="../thumb/xw:file/@name!=''">
						<option value="{../thumb/xw:file/@name}"><xsl:value-of select="./@title"/></option>
					</xsl:when>
					<xsl:otherwise>
						<option value="{./@name}"><xsl:value-of select="./@title"/></option>
					</xsl:otherwise>
				</xsl:choose>										
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	
	</xsl:template>
	
	
	
	<xsl:template name="listselectThumbnail_LII_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:copy>
		<!--	<xsl:copy-of select="@*[name()!='id']" />
		
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>-->
			<xsl:attribute name="id">
				<xsl:text>selezionaImmagine</xsl:text>
				<xsl:if test="$params!=''">
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$params" />
					<xsl:text>-</xsl:text>
					<xsl:variable name="numeroPosizione">
						<xsl:for-each select="$blockData">
							<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$numeroPosizione+1" />				
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//xw:file[@name!='' and contains($params,name(..))]">
				<xsl:choose>
					<xsl:when test="string-length(../thumb/xw:file/@name)>0">
						<option value="{../thumb/xw:file/@name}"><xsl:value-of select="./@title"/></option>
					</xsl:when>
					<xsl:otherwise>
						<option value="{./@name}"><xsl:value-of select="./@title"/></option>
					</xsl:otherwise>
				</xsl:choose>										
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Visualizza la prima, ultima, prossima o precedente immagine.
	     Richiede la presenza della select option con name="selezionaImmagine"
	     id="hxp-filelist-action-firstImg" 
	     id="hxp-filelist-action-lastImg" 
	     id="hxp-filelist-action-prevImg" 
	     id="hxp-filelist-action-nextImg" 	     	     
	     -->
	<xsl:template name="listimg">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="pos" select="''" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>listimg</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>.</xsl:text>
					<xsl:value-of select="@name"/>
					<xsl:text>.</xsl:text>
					<xsl:for-each select="$blockData">
						<xsl:call-template name="matchcontent">
							<xsl:with-param name="elemName" select="$name" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</xsl:attribute>			
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return selectImage(this,'</xsl:text>
				<xsl:value-of select="$pos"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>




<xsl:template name="noIWlistimg">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
	<xsl:param name="pos" select="''" />
	<xsl:param name="myname" select="''" />
	

	<xsl:variable name="numeroPosizione" select="count($blockData//xw:file)"/>
	
	<xsl:choose>
		<xsl:when test="$numeroPosizione>1">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:variable name="name">
						<xsl:value-of select="@name"/>
					</xsl:variable>
					<xsl:attribute name="name">
						<xsl:text>listimg</xsl:text>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>
					</xsl:attribute>
					<xsl:attribute name="id">
					    <xsl:value-of select="$pos"/>
						<xsl:text>noIwImg</xsl:text>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>
					</xsl:attribute>			
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return noIWselectImage(this,'</xsl:text>
						<xsl:value-of select="$pos"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>

<xsl:template name="noIWlistimgLI">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
	<xsl:param name="pos" select="''" />
	<xsl:param name="myname" select="''" />

<!--
		<xsl:variable name="numeroPosizione">
		
			<xsl:value-of select="count($blockData/preceding-sibling::*[name()=name($blockData)])+1" />
		</xsl:variable>
-->
	
			<xsl:variable name="numeroPosizione">
			<!-- Indice dell'elemento corrente/contenitore (RIC) in base 0 -->
			<xsl:value-of select="count($blockData//xw:file/@name)" />
		</xsl:variable>
	
	<xsl:choose>
		<xsl:when test="$numeroPosizione>1">
				<xsl:copy>
					
					<xsl:copy-of select="@*[name()!='id']" />
					<!--
					<xsl:variable name="name">
						<xsl:value-of select="@name"/>
					</xsl:variable>
					-->
					<!--
					<xsl:attribute name="name">
						<xsl:text>listimg</xsl:text>
						<xsl:if test="$myname!=''">
							<xsl:text>.1</xsl:text>
						-->	
							<!--<xsl:value-of select="$numeroPosizione"/>-->					
						<!--
						</xsl:if>
					</xsl:attribute>
					-->
					
					<xsl:attribute name="id">
					    <xsl:value-of select="$pos"/>
						<xsl:text>noIwImg-</xsl:text>
						<xsl:value-of select="$myname"/>
						<xsl:text>-1</xsl:text>
					
					<!--
						<xsl:if test="@name!=''">
							<xsl:text>.1</xsl:text> -->
						<!--<xsl:value-of select="$numeroPosizione"/>-->
					<!--	</xsl:if>-->
					</xsl:attribute>			
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return noIWselectImage(this,'</xsl:text>
						<xsl:value-of select="$pos"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


<xsl:template name="noIWlistimgLII">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
	<xsl:param name="pos" select="''" />
	<xsl:param name="myname" select="''" />

		<xsl:variable name="numeroPosizione">
			<!-- Indice dell'elemento corrente/contenitore (RIC) in base 0 -->
			<xsl:value-of select="count($blockData/preceding-sibling::*[name()=name($blockData)])+1" />
		</xsl:variable>
	<xsl:choose>
		<xsl:when test="$numeroPosizione>=1">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:variable name="name">
						<xsl:value-of select="@name"/>
					</xsl:variable>
					<!--
					<xsl:attribute name="name">
						<xsl:text>listimg</xsl:text>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:value-of select="$numeroPosizione"/>					
						</xsl:if>
					</xsl:attribute>
					-->
					<xsl:attribute name="id">
					    <xsl:value-of select="$pos"/>
						<xsl:text>noIwImg-</xsl:text>
						<!--<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
						<xsl:value-of select="$numeroPosizione"/>
						</xsl:if>-->
						<xsl:value-of select="$myname"/>
						<xsl:text>-</xsl:text>
						<xsl:value-of select="$numeroPosizione"/>
					</xsl:attribute>			
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return noIWselectImage(this,'</xsl:text>
						<xsl:value-of select="$pos"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


	<!-- Visualizza la prima, ultima, prossima o precedente immagine.
	     Richiede la presenza della select option con name="selezionaImmagine"
	     id="hxp-filelist-action-firstImg_x" 
	     id="hxp-filelist-action-lastImg_x" 
	     id="hxp-filelist-action-prevImg_x" 
	     id="hxp-filelist-action-nextImg_x" 	     	     
	     -->
	<xsl:template name="listimg_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="pos" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>listimg</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>.</xsl:text>
					<xsl:value-of select="$name" />
					<xsl:variable name="numeroPosizione">
						<xsl:for-each select="$blockData">
							<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$numeroPosizione" />				
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return selectImage(this,'</xsl:text>
				<xsl:value-of select="$pos"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	

	<!-- ZOOm IN e OUT di immagine.
	     id="hxp-filelist-action-zoomIn" 
	     id="hxp-filelist-action-zoomOut" 
	     -->
	<xsl:template name="listzoom">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="'IN'" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return zoom(this,'</xsl:text>
				<xsl:value-of select="$tipo"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Fill dell'immagine (Riempimento).
	     id="hxp-filelist-action-fill" 
	     -->
	<xsl:template name="listfill">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return fill();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Fit dell'immagine (Adattamento).
	     id="hxp-filelist-action-fit" 
	     -->
	<xsl:template name="listfit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return fit();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	

	<!-- Rotazione dell'immagine (idi 90 gradi in senso orario o antiorario).
	     id="hxp-filelist-action-rotateSx" 
	     id="hxp-filelist-action-rotateDx" 
	     -->
	<xsl:template name="listrotate">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="degree" select="'0'" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return rotate(</xsl:text>
				<xsl:value-of select="$degree"/>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Salva immagine con nome
	     id="hxp-filelist-action-saveAs" 
	     -->
	<xsl:template name="listsaveAs">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return saveAs();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Salva tutte le immagine con nome
	     id="hxp-filelist-action-saveMultiAs" 
	     -->
	<xsl:template name="listsaveMultiAs">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM -05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return saveMultiAs();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	

	<!-- Stampa delle immagini
	     id="hxp-filelist-action-print" 
	     -->
	<xsl:template name="listprint">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM - 05/10/2005 -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return print();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>	
	

	<!-- Visualizza la firma
	     id="hxp-filelist-action-mostraFirma" 
	     -->
	<xsl:template name="listShowSign">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraFirma(true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="listShowReaders">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraLettori(true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Rimozione dell'immagine selezionata
	     id="hxp-filelist-action-removeImmagine" 
	     -->
	<xsl:template name="listremoveImmagine">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return iwRemoveImmagine('</xsl:text>
				<xsl:for-each select="$blockData//xw:file">
					<xsl:text>|</xsl:text>
					<xsl:value-of select="@name"/>
				</xsl:for-each>				
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Apre l'immagine corrente in una nuova finestra
	     id="hxp-filelist-action-openInNewWindow" 
	     -->
	<xsl:template name="listopenInNewWindow">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>openBig</xsl:text>
				<xsl:if test="@name!=''">
					<xsl:text>.</xsl:text>
					<xsl:for-each select="$blockData">
						<xsl:call-template name="matchcontent">
							<xsl:with-param name="elemName" select="$name" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</xsl:attribute>					
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return openInNewWindow(this,</xsl:text>
				<xsl:value-of select="number($blockData/@indice) - 1" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Apre l'immagine corrente in una nuova finestra
	     id="hxp-filelist-action-openInNewWindow_x" 
	     -->
	<xsl:template name="listopenInNewWindow_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />	
	
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			<xsl:attribute name="name">
				<xsl:text>openBig</xsl:text>
				<xsl:choose>				
					<xsl:when test="$params='forTitles'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:value-of select="$name" />
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione" />				
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return openInNewWindow_x(this,</xsl:text>
				<xsl:text>'</xsl:text>
				<xsl:for-each select="$blockData//xw:file">
					<xsl:text>|</xsl:text>
					<xsl:value-of select="@name"/>
				</xsl:for-each>
				<xsl:if test="$params='forTitles'">
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$blockData/@indice - 1"/>
				</xsl:if>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		
	</xsl:template>
	

	<xsl:template name="noIWlistopenInNewWindow_x">
				<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:param name="myname" select="''" />		
		


		
		
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>


			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			
			<!--
			
			<xsl:attribute name="name">
				<xsl:text>openBig</xsl:text>
				<xsl:choose>				
				-->	
					<!--
					<xsl:when test="$params='forTitles'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>
					</xsl:when>
					-->
					<!--
					<xsl:when test="$params='forLIDocs'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
						
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />	
						</xsl:if>
					
					</xsl:when>
					
					<xsl:when test="$params='forLIIDocs'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
						
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />				
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>

					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			-->
	<!--
           	<xsl:attribute name="id">
				<xsl:text>OnoIwImg</xsl:text>
				<xsl:choose>
				-->
				<!--				
					<xsl:when test="$params='forTitles'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>

					</xsl:when>
				-->
					<!--
					<xsl:when test="$params='forLIDocs'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />				
						</xsl:if>
					</xsl:when>
					
					<xsl:when test="$params='forLIIDocs'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />				
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>

					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			
-->
			
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return openInNewWindow_xpreview('</xsl:text>
				<xsl:for-each select="$blockData//*[name()=$myname]/thumb/xw:file">
					<xsl:text>|</xsl:text>
					<xsl:value-of select="@srn"/>
				</xsl:for-each>
				<!--
				<xsl:if test="$params='forTitles'">
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$blockData/@indice"/>
				</xsl:if>
				-->
				<xsl:if test="$params='forLIDocs'">

							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$myname" />
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$numeroPosizione+1" />
				</xsl:if>

				<xsl:if test="$params='forLIIDocs'">
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$myname" />
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$numeroPosizione+1" />
				</xsl:if>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Per il caricamento di immagini
	   id="hxp-filelist-action-list
-'(input)','estensioni abilitate','bits'" -->	
	<xsl:template name="listgetfiles_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''"/>
		<xsl:param name="instPosDep" select="''"/>
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>								
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="onclick">
					<xsl:text>return getFiles_x(this,</xsl:text>
					<xsl:value-of select="$params"/>
<!--
					<xsl:call-template name="hxpstring">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="thestring" select="$params" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>					
					</xsl:call-template>
					-->
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Per il caricamento di immagini con preview
	   id="hxp-filelist-action-listgetfiles_preview-'(input)','estensioni abilitate','bits'" -->	
	<xsl:template name="listgetfiles_preview">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''"/>
		<xsl:param name="instPosDep" select="''"/>
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>								
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="onclick">
					<xsl:text>return getFiles_x(this,</xsl:text>
				<!--	<xsl:value-of select="$params"/>-->

					<xsl:call-template name="hxpstring">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="thestring" select="$params" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>					
					</xsl:call-template>
					
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Rimozione di una singola istanza immagine (svuota semplicemente il name in maniera che al salvataggio
	l'xw:file non venga riportato nel documento modificato)
	id="hxp-filelist-action-deleteSingleImstance_x"
	-->
    <xsl:template name="listdeleteSingleImstance_x">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="instPosDep" select="''"/>
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>								
					</xsl:call-template>
				</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return deleteSingleImstance_x(this);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Rimozione di una singola istanza immagine (svuota semplicemente il name in maniera che al salvataggio
	l'xw:file non venga riportato nel documento modificato)
	id="hxp-filelist-action-deleteSingleImstance_preview"
	versione con preview
	-->
	
	<xsl:template name="listdeleteSingleImstance_preview">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parms" select="''"/>
		<xsl:param name="instPosDep" select="''"/>
		
		<xsl:variable name="objectid" >
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$parms"/>
				<xsl:with-param name="instPosDep" select="$instPosDep"/>								
			</xsl:call-template>
		</xsl:variable>
		
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>								
					</xsl:call-template>
				</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return deleteSingleImstance_xpreview(this,'</xsl:text>
				
		       <xsl:value-of select="$objectid"/>
					<xsl:text>');</xsl:text>
				
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Carica la pagina successiva nel caso di tiff multipagina
	     id="hxp-filelist-action-nextTifPage" 
	     -->
	<xsl:template name="listnexttifpage">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return nextTifPage();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Carica la pagina precedente nel caso di tif multipagina
	     id="hxp-filelist-action-prevTifPage" 
	     -->
	<xsl:template name="listprevtifpage">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return prevTifPage();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Visualizza il dialogo delle impostazioni della pagina di stampa
	     id="hxp-filelist-action-impoStampante"
	     -->
	<xsl:template name="setPrint">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return printParameters();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- id="hxp-filelist-action-listIwGetfileIns" 
	 -->
	<xsl:template name="listIwGetfileIns">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="instancePrefix" select="''" />		
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>			
				<xsl:text>return iwGetfileIns('</xsl:text>
				<xsl:call-template name="hxpstring">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
					<xsl:with-param name="thestring" select="$instancePrefix" />
				</xsl:call-template>				
				<xsl:text>',this);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Smistamento dei template hxp-filelist-action-... -->
	<xsl:template name="listaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''" />
		<xsl:param name="instPosDep" select="''" />						
		<xsl:choose>
			<xsl:when test="$value='prevTifPage'">
				<xsl:call-template name="listprevtifpage">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>	
			<xsl:when test="$value='nextTifPage'">
				<xsl:call-template name="listnexttifpage">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>		
			<xsl:when test="$value='deleteSingleImstance_x'">
				<xsl:call-template name="listdeleteSingleImstance_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="instPosDep" select="$instPosDep"/>
				</xsl:call-template>
			</xsl:when>
		<xsl:when test="starts-with($value,'deleteSingleImstance_preview')">
  				<xsl:call-template name="listdeleteSingleImstance_preview">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="instPosDep" select="$instPosDep"/>													
					<xsl:with-param name="parms" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>						
			<xsl:when test="substring-before($value,'-')='getFiles_x'">
				<xsl:call-template name="listgetfiles_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
					<xsl:with-param name="instPosDep" select="$instPosDep"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='getFiles_preview'">
				<xsl:call-template name="listgetfiles_preview">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
					<xsl:with-param name="instPosDep" select="''"/>
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='openInNewWindow'">
				<xsl:call-template name="listopenInNewWindow">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='openInNewWindow_x' or substring-before($value,'-')='openInNewWindow_x'">
				<xsl:call-template name="listopenInNewWindow_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>			
			<!--<xsl:when test="$value='noIWopenInNewWindow_x' or substring-before($value,'-')='noIWopenInNewWindow_x'">-->
				<xsl:when test="starts-with($value,'noIWopenInNewWindow_x')">
				<xsl:call-template name="noIWlistopenInNewWindow_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-before(substring-after($value,'noIWopenInNewWindow_x-'),'-')" />
					<xsl:with-param name="myname" select="substring-after(substring-after($value,'noIWopenInNewWindow_x-'),'-')" />
					
				</xsl:call-template>
			</xsl:when>				
			<xsl:when test="$value='removeImmagine'">
				<xsl:call-template name="listremoveImmagine">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='print'">
				<xsl:call-template name="listprint">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='mostraFirma'">
				<xsl:call-template name="listShowSign">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='mostraLettori'">
				<xsl:call-template name="listShowReaders">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='saveMultiAs'">
				<xsl:call-template name="listsaveMultiAs">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='saveAs'">
				<xsl:call-template name="listsaveAs">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
		    <xsl:when test="$value='imgsNOIW'">
				<xsl:call-template name="imgsNOIW">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='dinamicIWcheck'">
				<xsl:call-template name="dinamicIWcheck">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='dinamicNOIWcheck'">
				<xsl:call-template name="dinamicNOIWcheck">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'browserCut')">
				<xsl:call-template name="browserCut">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="browser" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>				
			<xsl:when test="$value='rotateSx'">
				<xsl:call-template name="listrotate">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="degree" select="'90'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rotateDx'">
				<xsl:call-template name="listrotate">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="degree" select="'270'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fill'">
				<xsl:call-template name="listfill">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fit'">
				<xsl:call-template name="listfit">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='zoomIn'">
				<xsl:call-template name="listzoom">
					<xsl:with-param name="tipo" select="'IN'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='zoomOut'">
				<xsl:call-template name="listzoom">
					<xsl:with-param name="tipo" select="'OUT'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='lastImg'">
				<xsl:call-template name="listimg">
					<xsl:with-param name="pos" select="'L'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='firstImg'">
				<xsl:call-template name="listimg">
					<xsl:with-param name="pos" select="'F'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prevImg'">
				<xsl:call-template name="listimg">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='NoiwThumb'">
				<xsl:call-template name="NoiwThumb">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />	
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='NoiwThumbLI'">
				<xsl:call-template name="NoiwThumbLI">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="relpath" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='NoiwThumbLII'">
				<xsl:call-template name="NoiwThumbLII">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="relpath" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='NoiwThumbLIIsimple'">
				<xsl:call-template name="NoiwThumbLIIsimple">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="relpath" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='NoiwThumbLIsimple'">
				<xsl:call-template name="NoiwThumbLIsimple">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="relpath" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='NoiwThumbsimple'">
				<xsl:call-template name="NoiwThumbsimple">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />	
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='noIWprevImg'">
				<xsl:call-template name="noIWlistimg">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />	
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='noIWprevImgLII'">
			<!--<xsl:when test="$value='noIWprevImgLII'">-->
				<xsl:call-template name="noIWlistimgLII">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="myname" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />	
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='noIWprevImgLI'">
			<!--<xsl:when test="$value='noIWprevImgLI'">-->
				<xsl:call-template name="noIWlistimgLI">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="myname" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />	
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='nextImg'">
				<xsl:call-template name="listimg">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='noIWnextImg'">
				<xsl:call-template name="noIWlistimg">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />		
				</xsl:call-template>
			</xsl:when>
			<!--<xsl:when test="$value='noIWnextImgLII'">-->
			<xsl:when test="substring-before($value,'-')='noIWnextImgLII'">
				<xsl:call-template name="noIWlistimgLII">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="myname" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />		
				</xsl:call-template>
			</xsl:when>		
			<!--<xsl:when test="$value='noIWnextImgLI'">-->
			<xsl:when test="substring-before($value,'-')='noIWnextImgLI'">
				<xsl:call-template name="noIWlistimgLI">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="myname" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />		
				</xsl:call-template>
			</xsl:when>				
			<xsl:when test="$value='lastImg_x'">
				<xsl:call-template name="listimg_x">
					<xsl:with-param name="pos" select="'L'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='firstImg_x'">
				<xsl:call-template name="listimg_x">
					<xsl:with-param name="pos" select="'F'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prevImg_x'">
				<xsl:call-template name="listimg_x">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='nextImg_x'">
				<xsl:call-template name="listimg_x">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='selectImmagine'">
				<xsl:call-template name="listselectImmagine">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='selectPdf'">
				<xsl:call-template name="listselectPdf">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='selectImmagine_x'">
				<xsl:call-template name="listselectImmagine_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />					
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='selectImmagineWithPosition'">
				<xsl:call-template name="listselectImmagine">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tipo" select="'posizione'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='selectThumbnail'">
				<xsl:call-template name="listselectThumbnail">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='selectThumbnail_x'">
				<xsl:call-template name="listselectThumbnail_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='selectThumbnail_LI_x'">
				<xsl:call-template name="listselectThumbnail_LI_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>	
			<xsl:when test="substring-before($value,'-')='selectThumbnail_LII_x'">
				<xsl:call-template name="listselectThumbnail_LII_x">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='selectThumbnailWithPosition'">
				<xsl:call-template name="listselectThumbnail">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tipo" select="'posizione'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='scan'">
				<xsl:call-template name="listscan">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='scanPre'">
				<xsl:call-template name="listscan">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="insertBefore" select="'true'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='quickscan'">
				<xsl:call-template name="listscan">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="'quick'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='quickscanPre'">
				<xsl:call-template name="listscan">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="'quick'" />
					<xsl:with-param name="insertBefore" select="'true'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='first'">
				<xsl:call-template name="listfirst">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='gprev'">
				<xsl:call-template name="listgprev">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='gnext'">
				<xsl:call-template name="listgnext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="listprev">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="listnext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last'">
				<xsl:call-template name="listlast">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='close'">
				<xsl:call-template name="listclose">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='impoStampante'">
				<xsl:call-template name="setPrint">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='iwGetfileIns'">
				<xsl:call-template name="listIwGetfileIns">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="instancePrefix" select="substring-after($value,'-')" />					
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='countImg'">
			   <xsl:value-of select="count($hxpdata//immagini/xw:file)" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template name="hxparser_embedded">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:param name="instPosDep" select="''"/>		
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='filelist'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-filelist-action-... -->
								<xsl:call-template name="listaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/>
									<xsl:with-param name="blockData" select="$blockData" />
									<xsl:with-param name="instPosDep" select="$instPosDep"/>
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-filelist-data-... -->
								<xsl:call-template name="listdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/>
									<xsl:with-param name="blockData" select="$blockData" />
									<xsl:with-param name="instPosDep" select="$instPosDep"/>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
 							<xsl:with-param name="disable" select="$disable" />
							<xsl:with-param name="instPosDep" select="$instPosDep"/>							
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>							
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
