<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 22/11/2004
	* by................: Federico Grillini (fgr)
	* organization......: 3D Informatica
	*
	* Questo file contiene l'inizializzazione della variabile "hxpresource_generic" e il template 
 	* "hxpGenericResource" per la gestione delle etichette generiche.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" 
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				exclude-result-prefixes="fo"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->
	 <!--
		Se la tupla "language" contiene la lingua scelta per l'applicazione, deve essere istanziato il corretto file
		di risorse.
		I file di risorse delle lingue hanno il seguente nome: "generic.resource.<lingua>.xml", dove <lingua>
		rappresenta la lingua specificata nell'attributo "/response/@language".
		Se il file della lingua scelta non viene trovato, viene scelto il file di default "generic.resource.xml".
	 -->
	 <xsl:variable name="generic_resource_path">
		<xsl:variable name="generic_resource_name">
			<xsl:text>generic.resource</xsl:text>
			<xsl:if test="$hxpdata/@language!=''">
				<xsl:text>.</xsl:text>
				<xsl:value-of select="$hxpdata/@language"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="generic_resource_file" select="document(concat('../html/templates/',$generic_resource_name,'.xml'))"/>
	 	<xsl:choose>
	 		<xsl:when test="$generic_resource_file!=''">
	 			<xsl:value-of select="concat('../html/templates/',$generic_resource_name,'.xml')"/>
	 		</xsl:when>
	 	  	<xsl:otherwise>
	         	<xsl:text>../html/templates/generic.resource.xml</xsl:text>
	        </xsl:otherwise>
	    </xsl:choose>
	 </xsl:variable>
			
	 <xsl:variable name="hxpresource_generic" select="document(string($generic_resource_path))"/>
 
	 <!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Questo template  necessario per gestire le etichette mediante il file di risorse generico contenuto in
		* "hxpresource_generic".
	 -->
	 <xsl:template name="hxpGenericResource">
	  	<xsl:param name="resourceName" select="''"/>
	  	<xsl:copy>
	     	<xsl:copy-of select="@*[name()!='id']" />
	    	<xsl:value-of select="$hxpresource_generic//*[@id=$resourceName]/@value"/>
	 	</xsl:copy>
	 </xsl:template>
</xsl:stylesheet>
	