<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Gestione gerarchica dei documenti -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />
	<xsl:include href="btree.xsl" />
	
	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/hierBrowser.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:attribute name="scroll">auto</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="docCurrent" value="{$hxpdata/@docCurrent}" />
			<input type="hidden" name="docTitle" value="{$hxpdata/@docTitle}" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="docToggle" value="{$hxpdata/@docToggle}" /> <!-- il doc da espandere/contrarre -->
			<input type="hidden" name="backward" value="" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />

			<!-- specifici -->
			<xsl:call-template name="contextcustom">
				<xsl:with-param name="specName" select="'beforeend'"/>
			</xsl:call-template>				
		</form>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->
 
	<!-- Pagina precedente: id="hxp-hb-action-prev" -->
	<xsl:template name="hbprev">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente(</xsl:text>
						<xsl:value-of select="$hxpdata/hier[1]/@ndoc" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Pagina successiva: id="hxp-hb-action-next" -->
	<xsl:template name="hbnext">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+count($hxpdata/hier)">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/hier[last()]/@ndoc" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Pagina precedente: id="hxp-hb-action-toggle" -->
	<xsl:template name="hbtoggle">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return docToggle(</xsl:text>
				<xsl:value-of select="$blockData/@ndoc" />
				<xsl:text>,</xsl:text>
				<xsl:value-of select="$hxpdata/hier[1]/@ndoc" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="hbshowsel">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraSelezione()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="hbopendoc">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return apriDocumento(</xsl:text>
				<xsl:value-of select="$blockData/@ndoc" />
				<xsl:text>-1);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="hbshowdoc">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraDocumento(</xsl:text>
				<xsl:value-of select="$blockData/@ndoc" />
				<xsl:text>-1);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="hbsetdoc">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return impostaDocumentoCorrente(</xsl:text>
				<xsl:value-of select="$blockData/@ndoc" />
				<xsl:text>,'</xsl:text>
				<xsl:apply-templates select="$blockData/@title" mode="quoted-value-of" />
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Torna alla pagina di ricerca: id="hxp-hb-action-close -->
	<xsl:template name="hbclose">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return nuovaRicerca();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Smistamento dei template hxp-hb-action-... -->
	<xsl:template name="hbaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="hbprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="hbnext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='toggle'">
				<xsl:call-template name="hbtoggle">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showdoc'">
				<xsl:call-template name="hbshowdoc">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='opendoc'">
				<xsl:call-template name="hbopendoc">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showsel'">
				<xsl:call-template name="hbshowsel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='setdoc'">
				<xsl:call-template name="hbsetdoc">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='close'">
				<xsl:call-template name="hbclose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='hb'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')">
								<xsl:call-template name="hbaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" /> <!-- hxp-hb-action-... -->
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'tree-')"> <!-- hxp-hb-tree-... -->
								<xsl:call-template name="hbtree">
									<xsl:with-param name="value" select="substring-after($value,'tree-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
