<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                              xmlns:xw="http://www.3di.it/ns/xw-200203121136"
                              exclude-result-prefixes="xw"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->
    
    <xsl:variable name="jscode">
        <xsl:apply-templates select="//ArchiveSelection" mode="selection" />
    </xsl:variable>
        
    <xsl:template match="ArchiveSelection" mode="selection">
        <xsl:variable name="apos"><xsl:text>'</xsl:text></xsl:variable>
        <xsl:variable name="apos_r"><xsl:text></xsl:text></xsl:variable>
        <xsl:variable name="showHier">
            <xsl:choose>
                <xsl:when test="/response/@hierSearchShow='none'">
                    <xsl:value-of select="/response/@hierSearchShow" />
                </xsl:when>
                <xsl:otherwise>
                    <xsl:text>block</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:variable>
        <xsl:text>
        hierarchy = new HierMenu(true);
        hierarchy.addItem(new HierMenuItem('</xsl:text><xsl:value-of select="@name" /><xsl:text>', </xsl:text><xsl:value-of select="@size" /><xsl:text>, '', '</xsl:text><xsl:value-of select="@name" /><xsl:text>', true))
        .parent
        </xsl:text>
        <xsl:for-each select="Selection">
            <xsl:variable name="explode">
                <xsl:choose>
                    <xsl:when test="@explode">
                        <xsl:value-of select="@explode" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>true</xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:variable name="active">
                <xsl:choose>
                    <xsl:when test="@active">
                        <xsl:value-of select="@active" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>false</xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:text>.addItem(new HierMenuItem('</xsl:text><xsl:value-of select="@id" /><xsl:text>', </xsl:text><xsl:value-of select="@size" /><xsl:text>, '</xsl:text><xsl:value-of select="@name" /><xsl:text>', '</xsl:text><xsl:value-of select="translate(Query, $apos, $apos_r)" /><xsl:text>', </xsl:text><xsl:value-of select="$active" /><xsl:text>))</xsl:text>
            <xsl:if test="Selection">
                <xsl:text>.createSubmenu(new HierMenu(</xsl:text><xsl:value-of select="$explode" /><xsl:text>))</xsl:text>
                <xsl:call-template name="selection">
                    <xsl:with-param name="selection" select="." />
                </xsl:call-template>
            </xsl:if>
            <xsl:if test="not(position()=last())">
                <xsl:text>.parent</xsl:text>
            </xsl:if>
        </xsl:for-each>
        <xsl:text>;preloader();</xsl:text>
        <xsl:choose>
            <xsl:when test="//Selection/@active='true'">
                <xsl:text>
                setCurrentSet('</xsl:text><xsl:value-of select="//Selection/@id[../@active='true']" /><xsl:text>');
                </xsl:text>
            </xsl:when>
            <xsl:otherwise>
                <xsl:text>
                 setTimeout('displayHierarchy()', 10);
                </xsl:text>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:text>setTimeout('resumePanelState(\'</xsl:text><xsl:value-of select="$showHier" /><xsl:text>\')', 10);</xsl:text>
    </xsl:template>
    
    <xsl:template name="selection">
        <xsl:param name="selection" />
        <xsl:param name="query">
            <xsl:text>(</xsl:text><xsl:value-of select="$selection/@name" /><xsl:text>) AND </xsl:text>
        </xsl:param>
        <xsl:variable name="apos"><xsl:text>'</xsl:text></xsl:variable>
        <xsl:variable name="apos_r"><xsl:text></xsl:text></xsl:variable>
        <xsl:for-each select="$selection/Selection">
            <xsl:variable name="explode">
                <xsl:choose>
                    <xsl:when test="@explode">
                        <xsl:value-of select="@explode" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>true</xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:variable name="active">
                <xsl:choose>
                    <xsl:when test="@active">
                        <xsl:value-of select="@active" />
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:text>false</xsl:text>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            <xsl:text>.addItem(new HierMenuItem('</xsl:text><xsl:value-of select="@id" /><xsl:text>', </xsl:text><xsl:value-of select="@size" /><xsl:text>, '</xsl:text><xsl:value-of select="@name" /><xsl:text>', '</xsl:text><xsl:value-of select="translate(concat($query, Query), $apos, $apos_r)" /><xsl:text>', </xsl:text><xsl:value-of select="$active" /><xsl:text>))</xsl:text>
            <xsl:if test="Selection">
                <xsl:text>.createSubmenu(new HierMenu(</xsl:text><xsl:value-of select="$explode" /><xsl:text>))</xsl:text>
                <xsl:call-template name="selection">
                    <xsl:with-param name="selection" select="." />
                </xsl:call-template>
            </xsl:if>
            <xsl:text>.parent</xsl:text>
        </xsl:for-each>
    </xsl:template>

</xsl:stylesheet>
