<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 08/10/2004
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene dei template per la visualizzazione di testo formattato nei pdf generati con FOP.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.1" 
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				exclude-result-prefixes="fo"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->
	<!-- Foglio di stile che contiene i template per la conversione xhtml to xslfo -->
	<xsl:include href="xhtml-to-xslfo.xsl"/>
	
	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Questo template fa match con tutti gli elementi del template .fo il cui id comincia con
		* 'hxp-htmlNodes4fop-showHtmlContent-'. La struttura di questi id  la seguente:
		*
		*				'hxp-htmlNodes4fop-showHtmlContent-nome_nodo'
		*
		* dove 'nome_nodo' rappresenta il nome dell'elemento xml che contiene del codice html.
		* Tale codice viene convertito il linguaggio xsl-fo, in modo che sia possibile visualizzare
		* del testo formattato nei pdf generati con FOP.
	-->
	<xsl:template match="*[starts-with(@id,'hxp-htmlNodes4fop-showHtmlContent-')]">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="elemName">
      		<xsl:value-of select="substring-after(@id,'hxp-htmlNodes4fop-showHtmlContent-')"/>
     	</xsl:variable>
     	
     	<xsl:variable name="nodeName">
		  	<xsl:choose>
		  		<xsl:when test="contains($elemName, '.$lang')">
		  			<xsl:value-of select="substring-before($elemName, '.$lang')"/>
		  			<xsl:value-of select="substring-after($elemName, '.$lang')"/>
		  		</xsl:when>
		  		<xsl:otherwise>
		  			<xsl:value-of select="$elemName"/>
		  		</xsl:otherwise>
		  	</xsl:choose>
		</xsl:variable>
		
     	<!--
		  	Nota di Federico del 18/11/2004: il parametro "blockData" contiene il contesto corrente. Quando viene 
		  	passato come parametro,  importante usare tale contesto al posto di "hxpdata", poich, se l'xml prodotto
		  	da java  una lista di documenti (caso, per es., della stampa di una selezione di documenti), iterare su
		  	tutti i nodi alla ricerca di "elemName" porta a selezionare tutti i nodi "nodeName" di tutti i documenti
		  	e non di quello che si sta analizzando.
		  	Nell'uso di "blockData" si  reso necessario specificare l'XPath "$blockData/..//", poich l'elemento
		  	con l'id esaminato potrebbe essere contenuto in un "hxp-notEmptyIterator-nodo" che, come ogni
		  	iteratore, fissa il contesto a "nodo" (caso riscontrato in visualizzazione).
		  	Qualora il contesto fosse corretto (cio fosse il padre di "nodo"), non ci sarebbero comunque problemi
		  	(questo grazie alla presenza di "//").
		-->
     	<xsl:for-each select="$blockData/..//*[name()=$nodeName]">
  		    <!-- debug -->
  		    <!--
  		    <fo:block> 	
  		    	<xsl:text>Nodo: "</xsl:text><xsl:value-of select="name()"/><xsl:text>"</xsl:text>
  		    </fo:block>
  		    -->
  		    <!-- fine debug -->
			
			<!-- forza il matching con i template contenuti nel file 'xhtml-to-xslfo.xsl' -->
   			<xsl:choose>
   				<xsl:when test="count(./jsEditorContent) = 0">
   					<xsl:apply-templates select="."/>
   				</xsl:when>
   				<xsl:otherwise>
   					<!--
						Modifica di Federico del 18/11/2004:
						Per gestire i campi multifont e multilingua  stata inserita una chiamata al template
						di visualizzazione di un campo multilingua.
						Nota:  importante specificare il tipo di output (pdf) mediante "outContentType".
					-->
   					<xsl:call-template name="hxpshowHtmlNode">
   						<!--  importante usare "elemName" perch contiene la dichiarazione ".$lang" -->
   						<xsl:with-param name="elemName" select="$elemName"/>
   						<xsl:with-param name="blockData" select="."/>
   						<xsl:with-param name="outContentType" select="'pdf'" />
   					</xsl:call-template>
   					<!--<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text()"/>-->
   				</xsl:otherwise>
   			</xsl:choose>
  		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
	