<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina degli indici 
Occorre una form con name="vocab" per la visualizzazione delle chiavi del vocabolario
e una forma con name="seek" che contiene la pulsantiera o almeno il campo di posizionamento
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/keylist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/index.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<!-- XHTML Strict non supporta l'attributo scroll nel body -->
		<!-- xsl:attribute name="scroll">auto</xsl:attribute -->
		<xsl:attribute name="onkeypress">submitOnEnter(event)</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<div>
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="startkey" value="" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="xMode" value="{$hxpdata/@xMode}" />
			<input type="hidden" name="keypath" value="{$hxpdata/@keypath}" /> <!-- la chiave -->
			<input type="hidden" name="fillField" value="{$hxpdata/@fillField}" />	<!--campo da riempire -->
			<input type="hidden" name="cPath" value="{$hxpdata/@cPath}" /> <!-- parte comune -->
			<input type="hidden" name="keylower" value="" /> <!-- se leggere verso minore (pagina precedente) -->
			<input type="hidden" name="minFreq" value="{$hxpdata/@minFreq}" /> <!-- frequenza minima -->
			<input type="hidden" name="maxFreq" value="{$hxpdata/@maxFreq}" /> <!-- frequenza massima -->
			<input type="hidden" name="minRes" value="{$hxpdata/@minRes}" /> <!-- risoluzione minima -->
			<!-- specifiche x idx -->
			<input type="hidden" name="doubleKey" value="{$hxpdata/@doubleKey}" /> <!-- chiave a doppia indicizzazione -->
			<input type="hidden" name="threl" value="{$hxpdata/@threl}" /> <!-- relazione da cui attingere la descrizione del codice prelevato dagli indici (classificazione) -->
			<input type="hidden" name="shwMode" value="{$hxpdata/@shwMode}" /> <!-- modalit di presentazione: codice a 2 byte 'dt' se  una data -->
			<!-- specifiche x ths, usate per passare da una vista all'altra -->
			<input type="hidden" name="xRels" value="{$hxpdata/@xRels}" /> <!-- relazioni espandibili -->
			<input type="hidden" name="vRels" value="{$hxpdata/@vRels}" /> <!-- relazioni visualizzabili -->
			<input type="hidden" name="lRel" value="{$hxpdata/@lRel}" /> <!-- ultima relazione -->
			</div>
		</form>
	</xsl:template>
	
	<!-- Serve per formattare la chiave del vocabolario nel caso si tratti di una data.
	Solitamente un template di questo tipo viene messo nell'xsl specifico ma in questo caso
	vocabolario/@chiave e' genericamente inserito dal java e quindi si puo' considerare una operazione utile
	in genere.-->
	<xsl:template match="vocabolario/@chiave">
		<xsl:choose>
			<xsl:when test="$hxpdata/@shwMode='dt'">
				<xsl:call-template name="dateformatter" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="."/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>	
	
	<!-- Gestisce il posizionamento -->
	<xsl:template name="idxSeekJsAction">
		<xsl:text>return posiziona(getForm('seek').seektext.value,'</xsl:text>
		<xsl:value-of select="$hxpdata/@keypath" />
		<xsl:text>');</xsl:text>
	</xsl:template>
	
	<!-- Quando si fa submit della form si gestisce anche il posizionamento -->
	<xsl:template match="form[//@id='hxp-idx-action-next']" mode="template">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="action">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onsubmit">
				<xsl:call-template name="idxSeekJsAction" />
			</xsl:attribute>
			<xsl:apply-templates select="node()" mode="template" />
		</xsl:copy>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->
 
	<!-- Refresh della pagina degli indici: id="hxp-idx-action-refresh"  -->
	<xsl:template name="idxrefresh">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="count($hxpdata/vocabolario)>0">
				<xsl:copy>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return aggiornaPagina('</xsl:text>
						<xsl:apply-templates select="$hxpdata/vocabolario[1]/@chiave" mode="quoted-value-of" />
						<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Pagina degli indici precedente: id="hxp-idx-action-prev" -->
	<xsl:template name="idxprev">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente('</xsl:text>
						<xsl:apply-templates select="$hxpdata/vocabolario[1]/@chiave" mode="quoted-value-of" />
						<xsl:text>','</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 03/11/2005 VM - Se disabilita_ritorno_etichetta  vuoto viene 
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Pagina degli indici successiva: id="hxp-idx-action-next" -->
	<xsl:template name="idxnext">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+count($hxpdata/vocabolario)">
				<xsl:copy>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva('</xsl:text>
						<xsl:apply-templates select="$hxpdata/vocabolario[last()]/@chiave" mode="quoted-value-of" />
						<xsl:text>','</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>','</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 03/11/2005 VM - Se disabilita_ritorno_etichetta  vuoto viene 
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Posizionamento: id="hxp-idx-action-seek" 
	Il Posizionamento viene gestito in base a un campo di tipo
	text che deve avere name="seektext".
	-->
	<xsl:template name="idxseek">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:call-template name="idxSeekJsAction" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Posizionamento tramite prompt: id="hxp-idx-goto" 
	Il Posizionamento sfrutta comunque quanto detto sopra nella "hxp-idx-action-seek"
	ma chiedendo tramite promp un input all'utente.
	-->
	<xsl:template name="idxgoto">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+count($hxpdata/vocabolario) or $hxpdata/@pos>0">
				<xsl:copy>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>PosizionamentoTermineVocabolario();return false</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 03/11/2005 VM - Se disabilita_ritorno_etichetta  vuoto viene 
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Chiusura della pagina degli indici: id="hxp-idx-action-close" -->
	<xsl:template name="idxclose">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>closeIndex(false);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Chiusura della pagina degli indici: id="hxp-idx-action-closewindow" 
	A differenza della precedente "idxclose" qui si chiude brutalmente la
	pagina di visualizzazione vocabolario scartando il termine/i termini
	selezionati -->
	<xsl:template name="idxclosewindow">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>closeIndex(true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Chiusura della pagina degli indici: id="hxp-idx-action-riporta" 
	A differenza della precedente "idxclose" qui si chiude la pagina di
	visualizzazione vocabolario solo se sono stati selezionati dei termini
	da riportare; in caso contrario non si fa nulla -->
	<xsl:template name="idxriporta">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>riportaFromIndex();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Chiusura della pagina degli indici: id="hxp-idx-action-closeForViewer" -->
	<xsl:template name="idxcloseForViewer">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>closeIndexForViewer(false);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
		
	
	<!-- Chiusura della pagina degli indici scartando chiavi selezionate: id="hxp-idx-action-cancel" -->
	<xsl:template name="idxcancel">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>closeIndex(true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>	
	
	<!-- Gestione del checkbox della voce di indice: id="hxp-idx-action-check" -->
	<xsl:template name="idxcheck">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="number($blockData/@frequenza)>0">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<!-- GMG, VM - 13/10/2005 Introdotto per conformit con i criteri di accessibilit,
					poich nel template di vocabolario si utilizza il tag label associato ad un input.
					Il tag label disponde dell'attributo for che deve assumere lo stesso valore dell'attributo id dell'input.
					Per l'input checkbox o radio del vocabolario si  scelto di generare un id numerico. -->
					<xsl:attribute name="id">
						<xsl:text>voce-</xsl:text>
						<xsl:value-of select="count($blockData/preceding-sibling::*)+1"/>
					</xsl:attribute>
					<xsl:attribute name="type">
						<xsl:text>checkbox</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>checkSele(this,event)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:choose>
							<xsl:when test="contains($blockData/@chiave,'|^|')">
								<xsl:value-of select="substring-after($blockData/@chiave,'|^|')" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$blockData/@chiave" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Gestione del radio della voce di indice: id="hxp-idx-action-radio" -->
	<xsl:template name="idxradio">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="number($blockData/@frequenza)>0">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="type">
						<xsl:text>radio</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>checkRadioSele(this,event)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="value">
						<xsl:choose>
							<xsl:when test="contains($blockData/@chiave,'|^|')">
								<xsl:value-of select="substring-after($blockData/@chiave,'|^|')" />
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$blockData/@chiave" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="idxfullist">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="jcode"><xsl:text>return listaCompleta();changeIconPop(this)</xsl:text></xsl:variable>
		<xsl:call-template name="hxpjhandler">
			<xsl:with-param name="blockData" select="$blockData"/>
			<xsl:with-param name="jcode" select="$jcode"/>
			<xsl:with-param name="benable" select="$isAdmin = '1'"/>
			<xsl:with-param name="hidedisabled" select="'true'"/>
		</xsl:call-template>
	</xsl:template>
 

	<xsl:template name="idxtotalize">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="jcode"><xsl:text>return totalizzaChiavi();changeIconPop(this)</xsl:text></xsl:variable>
		<xsl:call-template name="hxpjhandler">
			<xsl:with-param name="blockData" select="$blockData"/>
			<xsl:with-param name="jcode" select="$jcode"/>
			<xsl:with-param name="benable" select="$isAdmin = '1'"/>
			<xsl:with-param name="hidedisabled" select="'true'"/>
		</xsl:call-template>
	</xsl:template>

	
	<!-- Smistamento dei template hxp-idx-action-... -->
	<xsl:template name="idxaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='refresh'">
				<xsl:call-template name="idxrefresh">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='totalize'">
				<xsl:call-template name="idxtotalize">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fulllist'">
				<xsl:call-template name="idxfullist">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='prev'">
				<xsl:call-template name="idxprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev_no_label'">
				<xsl:call-template name="idxprev">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="idxnext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next_no_label'">
				<xsl:call-template name="idxnext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='goto'">
				<xsl:call-template name="idxgoto">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='goto_no_label'">
				<xsl:call-template name="idxgoto">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='seek'">
				<xsl:call-template name="idxseek">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='close'">
				<xsl:call-template name="idxclose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='closeForViewer'">
				<xsl:call-template name="idxcloseForViewer">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='cancel'">
				<xsl:call-template name="idxcancel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='check'">
				<xsl:call-template name="idxcheck">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='closewindow'">
				<xsl:call-template name="idxclosewindow">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='riporta'">
				<xsl:call-template name="idxriporta">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='radio'">
				<xsl:call-template name="idxradio">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='check_or_radio'">
				<xsl:choose>
					<xsl:when test="$hxpdata/@destPage='docEdit'">
						<xsl:call-template name="idxradio">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
			<xsl:otherwise>
						<xsl:call-template name="idxcheck">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>

			</xsl:when>
			<xsl:when test="$value='voctitle'"> <!-- visualizzazione del titolo del vocabolario -->
				<xsl:value-of select="$hxpdata/@view"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='idx'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-idx-action-... -->
								<xsl:call-template name="idxaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
