<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Gestione di azioni particolari da una pagina che permette di operare azioni sugli allegati di un documento, 
	 tramite plugin iw
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<xsl:include href="filelist_embedded.xsl"/> <!--  Per l'utilizzo di iw -->
	
	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<xsl:call-template name="jslist_embedded"/> <!-- per iw -->
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:call-template name="bodyattributes_embedded"/>		
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" enctype="multipart/form-data" id="hxpForm" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />			
			<input type="hidden" name="doc_responseText" value="{$hxpdata/@doc_responseText}" /> <!-- testo -->
			<input type="hidden" name="attach" value="{$hxpdata/@attach}" /> <!-- esclusivo per allegati -->
			<input type="hidden" name="name" value="{$hxpdata/@name}" /> <!-- esclusivo per allegati -->		
			<input type="hidden" name="loadAttach" value="{$hxpdata/@loadAttach}" /> <!-- esclusivo per chkin -->
			<input type="hidden" name="convReq" value="{$hxpdata/@convReq}" /> <!-- richiesta conversioni (mbussetti,21/03/2005)-->
			
			<xsl:call-template name="beforeend_embedded"/>
		</form>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->


	<!-- Chiude la finestra
	   id="hxp-iw_response-action-close" -->
	<xsl:template name="iw_responseClose">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return closeDoc_response();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>		

	<!-- Pulsante di conferma annullamento documento
	   id="hxp-iw_response-action-confirmAnnul" -->
	<xsl:template name="iw_responseConfirmAnnul">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return confirmAnnulDoc_response();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>		

	<!-- Copia elemento contenente l'id se il file  firmato
	   id="hxp-iw-action-fileIsSigned"
	   -->	
	<xsl:template name="iwfileissigned">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="contains($blockData/@name,'.p7m')">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>				
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Mostra le informazioni sulla firma di un file
	   id="hxp-iw-action-fileIsSigned"
	   -->	
	<xsl:template name="iwshowsign">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraFirma(false,'</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>			
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>	
	
	<!-- Smistamento dei template hxp-iw_response-action-... -->
	<xsl:template name="doc_responseaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$value='showSign'">
				<xsl:call-template name="iwshowsign">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileIsSigned'">
				<xsl:call-template name="iwfileissigned">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>		
			<xsl:when test="$value='close'">
				<xsl:call-template name="iw_responseClose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirmAnnul'">
				<xsl:call-template name="iw_responseConfirmAnnul">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>										
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='iw_response'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-iw_response-action-... -->
								<xsl:call-template name="doc_responseaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxparser_embedded">
							<xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="$disable" />
						</xsl:call-template>					
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
