<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 17/12/2004
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene i template relativi al calendario javascript.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
		* @author Federico Grillini
		*
		* Created on 17/12/2004
		*
		* @version 1.0
		*
		* Questo template, invocato in hxp.xsl dal template che fa match con l'elemento head, se rileva la presenza
		* di id 'hxp-includeJsCalendar', inserisce il codice javascript del calendario.
		*
	-->
	<xsl:template name="includeJsForCalendar">
		<xsl:if test="count(//*[@id='hxp-includeJsCalendar'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/Calendar/funzioni.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<!--<xsl:text>;</xsl:text>-->
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/Calendar/chkform0.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<!--<xsl:text>;</xsl:text>-->
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/Calendar/cal.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<!--<xsl:text>;</xsl:text>-->
			</script>
		</xsl:if>
	</xsl:template>
	
	<!--
		* @author Federico Grillini
		*
		* Created on 17/12/2004
		*
		* @version 1.0
		*
		* Questo template, invocato in hxp.xsl subito prima della chiamata al template "beforeend" e invocato anche
		* in docEdit.xsl alla fine del template "beforeend", se rileva la presenza di id 'hxp-includeJsCalendar',
		* inserisce il div nascosto del calendario.
		*
	-->
	<xsl:template name="includeCalendarDiv">
		<xsl:if test="count(//*[@id='hxp-includeJsCalendar'])>0">
			<!--
			 	Modifica di Federico del 22/11/2004:
			 	l'inizializzazione di "hxpresource_generic"  stata spostata qui per evitare di effettuare tale
			 	operazione inutilmente.
			 	
			 	Nota: non includere il file "genericResourceHandler.xsl"; qualora tale file fosse necessario per il
			 	template in esso contenuto ("hxpGenericResource"), rimuovere
			 	l'inizializzazione della var. "hxpresource_generic", dato che  presente anche nel file xsl menzionato.
			 	
				Se la tupla "language" contiene la lingua scelta per l'applicazione, deve essere istanziato il corretto file
				di risorse.
				I file di risorse delle lingue hanno il seguente nome: "generic.resource.<lingua>.xml", dove <lingua>
				rappresenta la lingua specificata nell'attributo "/response/@language".
				Se il file della lingua scelta non viene trovato, viene scelto il file di default "generic.resource.xml".
			-->
			<xsl:variable name="generic_resource_path">
				<xsl:variable name="generic_resource_name">
					<xsl:text>generic.resource</xsl:text>
					<xsl:if test="$hxpdata/@language!=''">
						<xsl:text>.</xsl:text>
						<xsl:value-of select="$hxpdata/@language"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="generic_resource_file" select="document(concat('../html/templates/',$generic_resource_name,'.xml'))"/>
			 	<xsl:choose>
			 		<xsl:when test="$generic_resource_file!=''">
			 			<xsl:value-of select="concat('../html/templates/',$generic_resource_name,'.xml')"/>
			 		</xsl:when>
			 	  	<xsl:otherwise>
			         	<xsl:text>../html/templates/generic.resource.xml</xsl:text>
			        </xsl:otherwise>
			    </xsl:choose>
			</xsl:variable>
					
			<xsl:variable name="hxpresource_generic" select="document(string($generic_resource_path))"/>
			
			<DIV ID="cal" STYLE="position: absolute; visibility: hidden; border: solid; border-width: 1px; border-color: #6666ff;">
				<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0">
					<FORM NAME="cal">
						<STYLE>
							INPUT.inattivo {
								background-color: #cccccc;
								width: 25px;
							}
							INPUT.attivo {
								background-color: #9999cc;
								width: 25px;
							}
							INPUT.selezionato {
								background-color: #ff6666;
								width: 25px;
							}
						</STYLE>
						<TR>
							<TD COLSPAN="7">
								<INPUT TYPE="button" STYLE="width: 25px; background-color = '#9999cc';" VALUE="&lt;" onClick="Prev()"/>
								<INPUT TYPE="button" NAME="mese" STYLE="width: 125px; background-color = '#cccccc';" VALUE="" onClick="CloseCal()"/>
								<INPUT TYPE="button" STYLE="width: 25px; background-color = '#9999cc';" VALUE="&gt;" onClick="Next()"/>
							</TD>
						</TR>
						<TR>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_lunedi']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_martedi']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_mercoledi']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_giovedi']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_venerdi']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<xsl:value-of select="$hxpresource_generic//*[@id='calendar_sabato']/@value"/>
							</TH>
							<TH BGCOLOR="#cccccc">
								<FONT COLOR="#ee0000">
									<xsl:value-of select="$hxpresource_generic//*[@id='calendar_domenica']/@value"/> 
								</FONT>
							</TH>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg1-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg1-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg2-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg2-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg3-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg3-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg4-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg4-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg5-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg5-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
						<TR>
							<TD>
								<INPUT TYPE="button" NAME="gg6-1" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-2" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-3" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-4" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-5" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-6" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
							<TD>
								<INPUT TYPE="button" NAME="gg6-7" CLASS="inattivo" VALUE="" onClick="Select(this)"/>
							</TD>
						</TR>
					</FORM>
				</TABLE>
			</DIV>
		</xsl:if>
	</xsl:template>
	
	<!--
		* @author Federico Grillini
		*
		* Created on 14/03/2005
		*
		* @version 1.0
		*
		* Questo template, invocato in hxp.xsl quando si gestisce l'id 'hxp-showJsCalendar-...',
		* inserisce la chiamata javascript per mostrare il calendario.
		* L'introduzione di questo meccanismo e' stata necessaria per gestire correttamente l'assegnamento
		* dei numeri di istanza in caso di elementi multistanza.
		*
		* @param blockData Contesto corrente su cui operare.
		* @param params Parametri da passare alla chiamata javascript (attualmente ci si aspetta solo il nome
		* 				dell'input in cui il calendario deve inserire la data selezionata).
	-->
	<xsl:template name="showJsCalendar">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
			<xsl:copy>
				<!--xsl:copy-of select="@*[name()!='id']" /-->
				<xsl:call-template name="attrparser">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:if test="@onclick!=''">
						<xsl:value-of select="@onclick"/>
						<xsl:text>;</xsl:text>				
					</xsl:if>
					<xsl:text>return ShowCalByName(this,</xsl:text>
					<xsl:value-of select="$params"/> 			
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>	
</xsl:stylesheet>
	