<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

 <xsl:include href="hxp.xsl"/>

 <xsl:template name="jslist">
  <script>
  <xsl:attribute name="src">../../../formatter/html/data/js/keyNav.js</xsl:attribute>
  <xsl:attribute name="type">text/javascript</xsl:attribute>
  <xsl:text>;</xsl:text>
  </script>
  <script>
  <xsl:attribute name="src">../../../formatter/html/data/js/lookup_fabio.js</xsl:attribute>
  <xsl:attribute name="type">text/javascript</xsl:attribute>
  <xsl:text>;</xsl:text>
  </script>
  <script>
  <xsl:attribute name="src">../../../formatter/html/data/js/iduid.js</xsl:attribute>
  <xsl:attribute name="type">text/javascript</xsl:attribute>
  <xsl:text>;</xsl:text>
  </script>
 </xsl:template>

 <xsl:template name="bodyattributes">
  <xsl:attribute name="scroll">auto</xsl:attribute>
 </xsl:template>

 <xsl:template name="beforeend">
  <form method="post" name="indexForm" target="indexWindow" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
   <xsl:call-template name="sessiondata"/>
   <input type="hidden" name="verbo"     value="showindex"/>
   <input type="hidden" name="keypath"   value=""/>
   <input type="hidden" name="startkey"  value=""/>
   <input type="hidden" name="threl"     value=""/>
   <input type="hidden" name="doubleKey" value=""/> 
   <input type="hidden" name="shwMode"   value=""/>
   <input type="hidden" name="xMode"     value=""/>
   <input type="hidden" name="minf"      value="{$hxpdata/@minf}"/> <!-- frequenza minima -->
   <input type="hidden" name="maxf"      value="{$hxpdata/@maxf}"/> <!-- frequenza massima -->
   <input type="hidden" name="xRels"     value=""/>
   <input type="hidden" name="vRels"     value=""/>
   <input type="hidden" name="cPath"     value=""/>
   <input type="hidden" name="lRel"      value=""/>
   <input type="hidden" name="sele"      value=""/>
   <input type="hidden" name="result"    value=""/>
  </form>
  <form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
   <xsl:call-template name="sessiondata"/>
   <input type="hidden" name="verbo"     value=""/>
   <input type="hidden" name="xverb"     value="{$hxpdata/@xverb}"/>
   <input type="hidden" name="nextVerb"  value=""/>
   <input type="hidden" name="nextXVerb" value=""/>
   <input type="hidden" name="sele"      value=""/>
   <input type="hidden" name="qord"      value=""/>
   <input type="hidden" name="soTitles"  value=""/>
  </form>
 </xsl:template>

 <xsl:template name="keynavidx">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:variable name="skip">
   <xsl:if test="string-length($blockData/@idxmode)>1">
    <xsl:value-of select="substring($blockData/@idxmode,string-length($blockData/@idxmode) - 1, 1)"/>
   </xsl:if>
  </xsl:variable>
  <xsl:variable name="tran">
   <xsl:if test="string-length($blockData/@idxmode)>7">
    <xsl:value-of select="substring($blockData/@idxmode,string-length($blockData/@idxmode) - 7, 1)"/>
   </xsl:if>
  </xsl:variable>
  <xsl:choose>
   <xsl:when test="$skip='2' or $skip='3' or $skip='6' or $skip='a' or $skip='7' or $skip='b' or $skip='e' or $skip='f' or
                   $tran='4' or $tran='5' or $tran='7' or $tran='6' or $tran='c' or $tran='d' or $tran='e' or $tran='f'">
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:if test="name()='a'">
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     </xsl:if>
     <xsl:attribute name="onclick"><xsl:value-of select="./@onclick"/><xsl:text>;keynavOpenIndex(document.indexForm,'</xsl:text><xsl:value-of select="$blockData/ancestor::*[name()='field']/@name"/>,<xsl:value-of select="$blockData/@value"/><xsl:text>','','','','','result');</xsl:text></xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="keynavfind">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick"><xsl:value-of select="./@onclick"/><xsl:text>;getTitles();</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavlastquerycheck">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">lastquerycheck</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
  <input type="hidden" name="lastqueryid"/>
 </xsl:template>

 <xsl:template name="keynavquerysqlsyntax">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">querysqlsyntax</xsl:attribute>
   <xsl:attribute name="onclick">onSQLSyntaxChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavqueryoutputxml">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">queryoutputxml</xsl:attribute>
   <xsl:attribute name="onclick">onXMLOutputChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavqueryoutput">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">queryoutput</xsl:attribute>
   <xsl:attribute name="onclick">onOutputChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>
 <xsl:template name="keynavqueryprob">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">queryprob</xsl:attribute>
   <xsl:attribute name="onclick">onQueryProbChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavtextlike">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">textlike</xsl:attribute>
   <xsl:attribute name="onclick">onTextLikeChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavsotitles">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="type">checkbox</xsl:attribute>
   <xsl:attribute name="name">sotitles</xsl:attribute>
   <xsl:attribute name="onclick">onSoTitlesChecked(this)</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavaction">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$value='idx'">
    <xsl:call-template name="keynavidx">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='find'">
    <xsl:call-template name="keynavfind">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='lastquerycheck'">
    <xsl:call-template name="keynavlastquerycheck">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='querysqlsyntax'">
    <xsl:call-template name="keynavquerysqlsyntax">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='queryoutputxml'">
    <xsl:call-template name="keynavqueryoutputxml">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='queryoutput'">
    <xsl:call-template name="keynavqueryoutput">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='queryprob'">
    <xsl:call-template name="keynavqueryprob">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='textlike'">
    <xsl:call-template name="keynavtextlike">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='sotitles'">
    <xsl:call-template name="keynavsotitles">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="keynavkeyvalue">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:value-of select="$blockData/@value"/>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavkeyname">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:value-of select="$blockData/@name"/>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavkeyattributes">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:for-each select="$blockData/@*[name()!='id' and name()!='name' and name()!='value']">
    <xsl:text> </xsl:text>
    <xsl:value-of select="name()"/>
    <xsl:text>="</xsl:text>
    <xsl:value-of select="."/>
    <xsl:text>" </xsl:text>
   </xsl:for-each>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavqform">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">theForm</xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavqdata">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="parms" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name"><xsl:text>qlphrase</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="keynavdata">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$value='keyvalue'">
    <xsl:call-template name="keynavkeyvalue">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='keyname'">
    <xsl:call-template name="keynavkeyname">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='keyattributes'">
    <xsl:call-template name="keynavkeyattributes">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='qform'">
    <xsl:call-template name="keynavqform">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='qdata'">
    <xsl:call-template name="keynavqdata">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="keynavparser">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="substring-before($value,'-')='action'">
    <xsl:call-template name="keynavaction">
     <xsl:with-param name="value" select="substring-after($value,'-')"/>
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='data'">
    <xsl:call-template name="keynavdata">
     <xsl:with-param name="value" select="substring-after($value,'-')"/>
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="*[@id][starts-with(@id,'hxp')]" mode="template" name="hxparser">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="disable" select="''"/>
   <!--
  <xsl:choose>
   <xsl:when test="starts-with(@id,'hxp')">
   -->
    <xsl:variable name="value" select="substring-after(@id,'-')"/>
    <xsl:choose>
     <xsl:when test="substring-before($value,'-')='keynav'">
      <xsl:call-template name="keynavparser">
       <xsl:with-param name="value" select="substring-after($value,'-')"/>
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpidhandler">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
    <!--
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy>
     <xsl:copy-of select="@*"/>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="disable" select="$disable"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:otherwise>
  </xsl:choose>
  -->
 </xsl:template>

</xsl:stylesheet>


