<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:include href="hxp.xsl" />

 <xsl:template name="jslist">
  <script>
   <xsl:attribute name="src">../../../formatter/html/data/js/loadingbar.js</xsl:attribute>
   <xsl:attribute name="type">text/javascript</xsl:attribute>
   <!--
   	Federico 07/07/05: il contenuto di un nodo deve essere scritto dopo tutti gli attributi, se no il parser
   	non scrive gli attributi successivi.
   -->
   <xsl:text>;</xsl:text>
  </script>
 </xsl:template>

 <xsl:template name="bodyattributes">
 </xsl:template>

 <xsl:template name="beforeend">
  <form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
    <xsl:call-template name="sessiondata"/>
    <input type="hidden" name="verbo" value="{$hxpdata/@verbo}"/>
    <input type="hidden" name="xverb" value="{$hxpdata/@xverb}"/>
    <input type="hidden" name="observerId" value="{$hxpdata/@observerId}"/>

    <!--
    	Federico 25/07/08: introdotta tupla per eventuali parametri da passare ai report Jasper [RW 0052908]
    -->
	<input type="hidden" name="jReportParams" value="{$hxpdata/@jReportParams}" />

	<!-- specifici -->
	<xsl:call-template name="contextcustom">
		<xsl:with-param name="specName" select="'beforeend'"/>
	</xsl:call-template>
  </form>
 </xsl:template>


	<!-- Vai alla pagina di query specifica di tabella: id="hxp-query-action-gototableq-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="loadingbargototableq">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Torna alla pagina di ricerca
	id="hxp-loadingbar-action-querypage" -->
	<xsl:template name="loadingbarquerypage">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryPage()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Get di un file esportato
		da xw id="hxp-loadingbar-action-getExpFile-(xpath del nome del file)" -->
	<xsl:template name="loadingbarGetExpFile">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="pathFiles" select="''"/>
		<xsl:variable name="theid">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="concat('$hxp_data(',substring-before($pathFiles,','),')')"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="theattachments">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="concat('$hxp_data(',substring-after($pathFiles,','),')')"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedAttachments">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theattachments"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=Exportdocs_response&#38;xverb=@getfile&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;attachments=</xsl:text>
				<xsl:value-of select="$escapedAttachments"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-loadingbar-action-... -->
	<xsl:template name="loadingbaraction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='getfile'">
				<xsl:call-template name="getfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='gototableq'">
				<xsl:call-template name="loadingbargototableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="$value='querypage'">
				<xsl:call-template name="loadingbarquerypage">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="substring-before($value,'-')='getExpFile'">
				<xsl:call-template name="loadingbarGetExpFile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="pathFiles" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Smistamento dei template hxp-loadingbar-data-... -->
	<xsl:template name="loadingbardata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
	</xsl:template>


	<xsl:template name="loadingbarparser">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='action'"> <!-- hxp-loadingbar-action-... -->
				<xsl:call-template name="loadingbaraction">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='data'"> <!-- hxp-loadingbar-data-... -->
				<xsl:call-template name="loadingbardata">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


 <xsl:template match="*[@id][starts-with(@id,'hxp-')]" mode="template" name="hxparser">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="disable" select="''"/>
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='loadingbar'"> <!-- hxp-loadingbar-... -->
						<xsl:call-template name="loadingbarparser">
							<xsl:with-param name="value" select="substring-after($value,'-')" />
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:for-each select="@*">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>

 </xsl:template>

</xsl:stylesheet>
