<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet 
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
 xmlns:xw="http://www.3di.it/ns/xw-200203121136"
 exclude-result-prefixes="xw"> 
 <!-- elaborazione titoli per alimentazione mapworld -->
 <xsl:include href="../hxp.xsl" />
 <xsl:include href="./titleData.xsl" />
 <!-- separatore dei dati oggetto notificati dal plugin 
      @see /templateEditorPresentation/application/editor/addon/mapworld/webapp/formatter/html/data/map/js/map.js -->
 <xsl:variable name="pluginEventDataSeparator" select="';%'"/>
 <!-- Javascript da includere -->
 <xsl:template name="jslist">
  <script>
   <xsl:attribute name="src">../../../formatter/html/data/map/js/showtitles@map.js</xsl:attribute>
   <xsl:attribute name="type">text/javascript</xsl:attribute>
   <xsl:text>;</xsl:text>
  </script>
  <script>
   <xsl:attribute name="src">../../../formatter/html/data/js/common.js</xsl:attribute>
   <xsl:attribute name="type">text/javascript</xsl:attribute>
   <xsl:text>;</xsl:text>
  </script>
 </xsl:template>

 <xsl:template name="bodyattributes"/>

 <xsl:template name="beforeend">
  <form name="hxpForm" id="hxpForm" action="{$hxpdata/@uri}">
   <input type="hidden" name="_cd" value="{$hxpdata/@_cd}"/>
   <input type="hidden" name="selid" value="{$hxpdata/@selid}"/>
  </form>
  <script>
   <xsl:attribute name="type">text/javascript</xsl:attribute>
   <xsl:call-template name="prepareData"/>
  </script>
 </xsl:template>
 
 <xsl:variable name="idDelim" select="' $ '"/>
 
 <xsl:template name="beforeLast">
  <xsl:param name="string" select="''"/>
  <xsl:param name="delim" select="$idDelim"/>
  <xsl:if test="contains($string,$delim)">
   <xsl:value-of select="substring-before($string,$delim)"/>
   <xsl:variable name="next" select="substring-after($string,$delim)"/>
   <xsl:if test="contains($next,$delim)">
    <xsl:value-of select="$delim"/>
    <xsl:call-template name="beforeLast">
     <xsl:with-param name="string" select="$next"/>
     <xsl:with-param name="delim" select="$delim"/>
    </xsl:call-template>     
   </xsl:if>  
  </xsl:if>
 </xsl:template>
 
 <!--
    se item[@n=$id] -> $id
    se $id contiene ' $ ' e item[@n=<parte di $id che precede l'ultimo $>] -> <parte di $id che precede l'ultimo $>
    altrimenti 'default'        
 -->

 <xsl:template name="projDataId">
  <xsl:param name="id"/>
  <xsl:param name="mapFeeder"/>
  <xsl:choose>
   <xsl:when test="$mapFeeder/item[@n=$id]"><xsl:value-of select="$id"/></xsl:when>
   <xsl:otherwise>
    <xsl:choose>    
     <xsl:when test="contains($id,$idDelim)">
      <xsl:variable name="paramId">
       <xsl:call-template name="beforeLast">
        <xsl:with-param name="string" select="$id"/>
       </xsl:call-template> 
      </xsl:variable>  
      <xsl:call-template name="projDataId">
       <xsl:with-param name="id" select="$paramId"/>
       <xsl:with-param name="mapFeeder" select="$mapFeeder"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="'default'"/>
     </xsl:otherwise>
    </xsl:choose>    
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <!-- i dati passati al plugin che vengono notificati onclick -->
 <xsl:template name="mapObjectData">
  <xsl:call-template name="docId"/>                 <!-- 0 -->
  <xsl:value-of select="$pluginEventDataSeparator"/>
  <xsl:value-of select="$hxpdata/@selid"/>          <!-- 1 -->
  <xsl:value-of select="$pluginEventDataSeparator"/>
  <xsl:call-template name="cData"/>                 <!-- 2 -->
  <xsl:value-of select="$pluginEventDataSeparator"/>
  <xsl:text>"+_hxc+"</xsl:text><!-- 3 -->
  <!--
  <xsl:call-template name="hxCoords"/>              
  -->
  <xsl:value-of select="$pluginEventDataSeparator"/>
  <!--
  <xsl:call-template name="projId"/>
  <xsl:value-of select="$pluginEventDataSeparator"/>
  -->
 </xsl:template>
 
 <xsl:template name="readParameter">
  <xsl:param name="defaultValue"/>
  <xsl:param name="parameterName"/>
  <xsl:variable name="probe">
   <xsl:call-template name="getcustomparam"><xsl:with-param name="param" select="$parameterName"/></xsl:call-template>
  </xsl:variable>
  <xsl:choose>
   <xsl:when test="$probe=''"><xsl:value-of select="$defaultValue"/></xsl:when>
   <xsl:otherwise><xsl:value-of select="$probe"/></xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 <xsl:template name="projId">
  <xsl:variable name="probe">
   <xsl:call-template name="getcustomparam"><xsl:with-param name="param" select="'p'"/></xsl:call-template>
  </xsl:variable>
  <xsl:choose>
   <!-- <xsl:when test="$probe=''"><xsl:value-of select="'0'"/></xsl:when> -->
   <xsl:when test="$probe='' or count($projData//map-feeder[@id=$probe])=0"><xsl:value-of select="'0'"/></xsl:when>
   <xsl:otherwise><xsl:value-of select="$probe"/></xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 <xsl:template name="getPart">
  <xsl:param name="part"/>
  <xsl:param name="where"/>
  
  <xsl:choose>
   <xsl:when test="$part = 1">
    <xsl:choose>    
     <xsl:when test="contains($where,$idDelim)">
      <xsl:value-of select="substring-before($where,$idDelim)"/>  
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$where"/>
     </xsl:otherwise>   
    </xsl:choose>    
   </xsl:when>     
   <xsl:otherwise>
    <xsl:call-template name="getPart">
     <xsl:with-param name="part" select="$part - 1"/>
     <xsl:with-param name="where" select="substring-after($where,$idDelim)"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 <xsl:variable name="toParsePrefix" select="'$(n'"/>
 <xsl:variable name="toParseSuffix" select="')'"/>
 <xsl:template name="parseItemData">
  <xsl:param name="data"/><!-- il dato da 'analizzare' -->
  <xsl:param name="itemId"/><!-- #%s: nel titolo -->
  <xsl:choose>
   <xsl:when test="contains($data,$toParsePrefix)">
    <xsl:value-of select="substring-before($data,$toParsePrefix)"/>
    <xsl:call-template name="getPart">
     <xsl:with-param name="part" select="number(substring-before(substring-after($data,$toParsePrefix),$toParseSuffix))"/>
     <xsl:with-param name="where" select="$itemId"/>
    </xsl:call-template>
    <xsl:call-template name="parseItemData">
     <xsl:with-param name="data" select="substring-after(substring-after($data,$toParsePrefix),$toParseSuffix)"/>
     <xsl:with-param name="itemId" select="$itemId"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$data"/>
   </xsl:otherwise>
  </xsl:choose>        
 </xsl:template>

 <!-- client webapp -->
 <xsl:template name="webapp"><xsl:param name="path"/>
  <xsl:value-of select="concat(substring-before($path,'/'),'/',substring-before(substring-after($hxpdata/@uri,'/'),'/'),'/',substring-after(substring-after($path,'/'),'/'))"/>
 </xsl:template>
 
 <!--
   nella elaborazione del nome del simbolo e della descrizione 
   possono essere referenziate parti della componente del titolo
   identificata da #%s: con espressioni $(n<parte base 1>)
   essendo le parti delimitate con ' $ '
 -->        
 
 <xsl:template name="prepareData">
  <xsl:variable name="feederId">
   <xsl:call-template name="projId"/>
  </xsl:variable>
  
  <xsl:variable name="lineColor">
   <xsl:call-template name="getcustomparam"><xsl:with-param name="param" select="'p'"/></xsl:call-template>
        customParam
        
  </xsl:variable>
  
  <xsl:variable name="mapFeeder" select="$projData//map-feeder[@id=$feederId]"/>
  <!--
  <xsl:if test="count($mapFeeder)=0">
   <xsl:text>alert('unable to select "map-feeder[@projId=</xsl:text><xsl:value-of select="$feederId"/><xsl:text>"');&#xa;</xsl:text>
  </xsl:if>
  -->
  
  <xsl:text>function titleData2Map(){&#xa;</xsl:text>
  <xsl:text>initialize()&#xa;</xsl:text>
  <xsl:for-each select="$hxpdata//titolo">

   <xsl:variable name="hxc"><xsl:call-template name="hxCoords"/></xsl:variable>
   var _hxc='<xsl:value-of select="$hxc"/>';
   <xsl:variable name="x">
    <xsl:choose>
     <xsl:when test="$hxc=''"><xsl:call-template name="xCoord"/></xsl:when>
     <xsl:otherwise><xsl:call-template name="hxXCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template></xsl:otherwise>
    </xsl:choose>
   </xsl:variable>
   <xsl:if test="not($x='')">
     
    <!-- $itemId identifica l'oggetto al livello di dettaglio deciso per la proiezione -->
    <xsl:variable name="itemId"><xsl:call-template name="shapeId"/></xsl:variable>
    <!-- $shape viene usato per leggere i dati relativi all'oggetto in proj.xml -->
    <xsl:variable name="shape">
     <xsl:call-template name="projDataId">
      <xsl:with-param name="id" select="$itemId"/>
      <xsl:with-param name="mapFeeder" select="$mapFeeder"/>
     </xsl:call-template>
    </xsl:variable>
    
    <xsl:variable name="item" select="$mapFeeder/item[@n=$shape]"/>
    <xsl:text>title2Map(</xsl:text>
    <!-- preparazione dei dati da passare al plugin -->
    <xsl:choose>
    
     <xsl:when test="$hxc=''"><!-- x y -->
      <xsl:text>'poi',"</xsl:text>
      <!--
      <xsl:call-template name="docId"/>
      -->
      <xsl:call-template name="mapObjectData"/>
      <xsl:value-of select="$poiDataSep"/>
      <xsl:call-template name="jText"/>
      <xsl:value-of select="$poiDataSep"/>
      <xsl:value-of select="$x"/>
      <xsl:value-of select="$poiDataSep"/>
      <xsl:call-template name="yCoord"/>
      <xsl:value-of select="$poiDataSep"/>
      <xsl:text>0#%255#%0#%</xsl:text> <!-- ??? -->
        <xsl:call-template name="webapp"><xsl:with-param name="path" select="$mapFeeder/@path"/></xsl:call-template>
        <!-- <xsl:value-of select="$mapFeeder/@path"/> -->
      <xsl:call-template name="parseItemData">
        <xsl:with-param name="data" select="$item/@v"/>
        <xsl:with-param name="itemId" select="$itemId"/>
      </xsl:call-template>
      <!--
      <xsl:value-of select="$item/@v"/>
      -->
      <xsl:text>",</xsl:text>
     </xsl:when>
    
     <xsl:otherwise>
      <xsl:choose>
    
       <xsl:when test="starts-with($hxc,'HxP')"> <!-- POI -->
        <xsl:text>'poi',"</xsl:text>
        <!--
        <xsl:call-template name="docId"/>
        -->
        <xsl:call-template name="mapObjectData"/>
        <xsl:value-of select="$poiDataSep"/>
        <xsl:call-template name="jText"/>
        <xsl:value-of select="$poiDataSep"/>
        <xsl:text>"+(</xsl:text>
        <xsl:value-of select="$x"/>
        <xsl:text>)+'</xsl:text>
        <xsl:value-of select="$poiDataSep"/>
        <xsl:text>'+(</xsl:text>
        <xsl:call-template name="hxYCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template>
        <xsl:text>)+"</xsl:text>
        <xsl:value-of select="$poiDataSep"/>
        <xsl:call-template name="readParameter"><!-- rotation -->
         <xsl:with-param name="defaultValue" select="'0'"/><xsl:with-param name="parameterName" select="'mapRotation'"/>
        </xsl:call-template>        
        <xsl:text>#%255#%0#%</xsl:text> <!-- ??? -->
        <xsl:call-template name="webapp"><xsl:with-param name="path" select="$mapFeeder/@path"/></xsl:call-template>
        <!-- <xsl:value-of select="$mapFeeder/@path"/> -->
        <xsl:call-template name="parseItemData">
          <xsl:with-param name="data" select="$item/@v"/>
          <xsl:with-param name="itemId" select="$itemId"/>
        </xsl:call-template>
        <!--
        <xsl:value-of select="$item/@v"/>
        -->
        <xsl:text>",</xsl:text>
       </xsl:when>
       
       <xsl:otherwise><!-- PATH: linee, poligoni... -->
        <xsl:text>'pat',"</xsl:text>
        <xsl:value-of select="$patDataSep"/>
        <xsl:call-template name="readParameter"><!-- line color -->
         <xsl:with-param name="defaultValue" select="$item/@lc"/><xsl:with-param name="parameterName" select="'lineColor'"/>
        </xsl:call-template>        
        <xsl:value-of select="$patDataSep"/>
        <xsl:call-template name="readParameter"><!-- fill color -->
         <xsl:with-param name="defaultValue" select="$item/@fc"/><xsl:with-param name="parameterName" select="'fillColor'"/>
        </xsl:call-template>        
        <xsl:value-of select="$patDataSep"/>
        
    <xsl:call-template name="readParameter"><!-- line alpha -->
     <xsl:with-param name="defaultValue" select="$item/@la"/><xsl:with-param name="parameterName" select="'lineAlpha'"/>
    </xsl:call-template>
        
        <xsl:value-of select="$patDataSep"/>
        
    <xsl:call-template name="readParameter"><!-- fill alpha -->
     <xsl:with-param name="defaultValue" select="$item/@fa"/><xsl:with-param name="parameterName" select="'fillAlpha'"/>
    </xsl:call-template>
        
        <xsl:value-of select="$patDataSep"/>
        <xsl:value-of select="$item/@lw"/><!-- line width -->
        <xsl:value-of select="$patDataSep"/>
        <xsl:text>"+_hxc+"</xsl:text>
        <!--
        <xsl:value-of select="$hxc"/>
        -->
        <xsl:value-of select="$patDataSep"/>
        <xsl:call-template name="jText"/>
<!--        
<xsl:value-of select="' '"/>
-->
        <xsl:value-of select="$patDataSep"/>
        <!--
        <xsl:call-template name="docId"/>
        -->
        <xsl:call-template name="mapObjectData"/>
        <xsl:value-of select="$patEnd"/>
        <xsl:text>",</xsl:text>
       </xsl:otherwise>
    
      </xsl:choose>
     </xsl:otherwise>
    </xsl:choose>
    
    <xsl:text>'</xsl:text>
    <!--
    <xsl:value-of select="$shape"/>
    -->
    <xsl:value-of select="$itemId"/>
    <xsl:text>','</xsl:text>
    <!-- descrizione per legenda -->
    <!--
    <xsl:variable name="dvalue" select="$item/@d"/>
    -->
    <xsl:variable name="dvalue">
      <xsl:call-template name="parseItemData">
        <xsl:with-param name="data" select="$item/@d"/>
        <xsl:with-param name="itemId" select="$itemId"/>
      </xsl:call-template>
    </xsl:variable>
    
    <xsl:variable name="shapeDescr">
     <xsl:choose>
      <xsl:when test="$dvalue=''"><xsl:value-of select="$shape"/></xsl:when>
      <xsl:otherwise><xsl:value-of select="$dvalue"/></xsl:otherwise>
     </xsl:choose>
    </xsl:variable>
    <xsl:call-template name="quoteString">
     <xsl:with-param name="stringa" select="$shapeDescr"/>
     <xsl:with-param name="occurrent">'</xsl:with-param>
    </xsl:call-template>
    
    <xsl:text>','</xsl:text>
    <!-- colore per legenda -->
    <xsl:call-template name="readParameter">
     <xsl:with-param name="defaultValue" select="$item/@c"/><xsl:with-param name="parameterName" select="'fillColor'"/>
    </xsl:call-template>        
    <xsl:text>','</xsl:text>
    <xsl:call-template name="readParameter"><!-- line color -->
     <xsl:with-param name="defaultValue" select="$item/@lc"/><xsl:with-param name="parameterName" select="'lineColor'"/>
    </xsl:call-template>
    
    <xsl:call-template name="readParameter"><!-- line alpha -->
     <xsl:with-param name="defaultValue" select="$item/@la"/><xsl:with-param name="parameterName" select="'lineAlpha'"/>
    </xsl:call-template>
    
    <xsl:text>','</xsl:text>
    <xsl:call-template name="readParameter"><!-- fill color -->
     <xsl:with-param name="defaultValue" select="$item/@fc"/><xsl:with-param name="parameterName" select="'fillColor'"/>
    </xsl:call-template>        
    
    <xsl:call-template name="readParameter"><!-- fill alpha -->
     <xsl:with-param name="defaultValue" select="$item/@fa"/><xsl:with-param name="parameterName" select="'fillAlpha'"/>
    </xsl:call-template>
    
    <xsl:text>','</xsl:text>
    <!-- custom data -->
    <xsl:call-template name="cData"/>
    <xsl:text>');&#xa;</xsl:text>
    
    <!-- disattivato -->
    <xsl:if test="false() and starts-with($hxc,'HxP') and $item/@b"> <!-- POI background -->
     
     <xsl:text>title2Map(</xsl:text>
     <xsl:text>'poi',"</xsl:text>
     <!-- '0#%'+text+'#%'+hxCoord.x+'#%'+hxCoord.y+'#%'+'0#%100#%FF0000#%Pois/Symbol.swf'; -->
     <xsl:call-template name="mapObjectData"/>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:call-template name="jText"/>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:text>"+(</xsl:text>
     <xsl:call-template name="hxXCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template>
     <xsl:text>)+'</xsl:text>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:text>'+(</xsl:text>
     <xsl:call-template name="hxYCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template>
     <xsl:text>)+"</xsl:text>
     <xsl:value-of select="$poiDataSep"/>

     <xsl:text>0#%100#%</xsl:text>
     <xsl:value-of select="substring-after($item/@c,'0x')"/>
     <xsl:text>#%</xsl:text>
     <!--
     <xsl:text>0#%255#%0#%</xsl:text>
     <xsl:value-of select="$item/@b"/>
     -->
     
     <xsl:text>",</xsl:text>
     <xsl:text>'</xsl:text>
     <xsl:value-of select="$itemId"/>
     <xsl:text>','</xsl:text>
     <!-- descrizione per legenda -->
     <xsl:call-template name="quoteString">
      <xsl:with-param name="stringa" select="$shapeDescr"/>
      <xsl:with-param name="occurrent">"</xsl:with-param>
     </xsl:call-template>
     <xsl:text>','</xsl:text>
     <!-- colore per legenda -->
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@c"/><xsl:with-param name="parameterName" select="'fillColor'"/>
     </xsl:call-template>        
     <xsl:text>','</xsl:text>
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@lc"/><xsl:with-param name="parameterName" select="'lineColor'"/>
     </xsl:call-template>
     
    <xsl:call-template name="readParameter"><!-- line alpha -->
     <xsl:with-param name="defaultValue" select="$item/@la"/><xsl:with-param name="parameterName" select="'lineAlpha'"/>
    </xsl:call-template>
     
     <xsl:text>','</xsl:text>
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@fc"/><xsl:with-param name="parameterName" select="'fillColor'"/>
     </xsl:call-template>
     
    <xsl:call-template name="readParameter"><!-- fill alpha -->
     <xsl:with-param name="defaultValue" select="$item/@fa"/><xsl:with-param name="parameterName" select="'fillAlpha'"/>
    </xsl:call-template>
     
     <xsl:text>','</xsl:text>
     <!-- custom data -->
     <xsl:call-template name="cData"/>
     <xsl:text>');&#xa;</xsl:text>
        
    </xsl:if>
    
    <!-- se la geometria  POLYGON o LINE ed  impostato l'attributo di scala
         genera un layer di POI agganciati al primo punto della geometria -->
    <xsl:if test="(starts-with($hxc,'HxA') or starts-with($hxc,'HxL')) and $item/@s">

     <xsl:text>childTitle2Map(</xsl:text>
     <xsl:text>'poi',"</xsl:text>
     <!--
     <xsl:call-template name="docId"/>
     -->
     <xsl:call-template name="mapObjectData"/>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:call-template name="jText"/>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:text>"+(</xsl:text>
     <xsl:call-template name="hxXCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template>
     <xsl:text>)+'</xsl:text>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:text>'+(</xsl:text>
     <xsl:call-template name="hxYCoord"><xsl:with-param name="hxc" select="$hxc"/></xsl:call-template>
     <xsl:text>)+"</xsl:text>
     <xsl:value-of select="$poiDataSep"/>
     <xsl:text>0#%255#%0#%</xsl:text> <!-- ??? -->
     <xsl:call-template name="webapp"><xsl:with-param name="path" select="$mapFeeder/@path"/></xsl:call-template>
     <!-- <xsl:value-of select="$mapFeeder/@path"/> -->
     <xsl:call-template name="parseItemData">
       <xsl:with-param name="data" select="$item/@v"/>
       <xsl:with-param name="itemId" select="$itemId"/>
     </xsl:call-template>
     <!--
     <xsl:value-of select="$item/@v"/>
     -->
     <xsl:text>",</xsl:text>
     <xsl:text>'</xsl:text>
     <xsl:value-of select="$itemId"/>
     <xsl:text>','</xsl:text>
     <!-- descrizione per legenda -->
     <xsl:call-template name="quoteString">
      <xsl:with-param name="stringa" select="$shapeDescr"/>
      <xsl:with-param name="occurrent">"</xsl:with-param>
     </xsl:call-template>
     <xsl:text>','</xsl:text>
     <!-- colore per legenda -->
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@c"/><xsl:with-param name="parameterName" select="'fillColor'"/>
     </xsl:call-template>        
     <xsl:text>','</xsl:text>
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@lc"/><xsl:with-param name="parameterName" select="'lineColor'"/>
     </xsl:call-template>
     
    <xsl:call-template name="readParameter"><!-- line alpha -->
     <xsl:with-param name="defaultValue" select="$item/@la"/><xsl:with-param name="parameterName" select="'lineAlpha'"/>
    </xsl:call-template>
     
     <xsl:text>','</xsl:text>
     <xsl:call-template name="readParameter">
      <xsl:with-param name="defaultValue" select="$item/@fc"/><xsl:with-param name="parameterName" select="'fillColor'"/>
     </xsl:call-template>
     
    <xsl:call-template name="readParameter"><!-- fill alpha -->
     <xsl:with-param name="defaultValue" select="$item/@fa"/><xsl:with-param name="parameterName" select="'fillAlpha'"/>
    </xsl:call-template>
     
     <xsl:text>','</xsl:text>
     <!-- custom data -->
     <xsl:call-template name="cData"/>
     <xsl:text>','pat',</xsl:text>
     <xsl:value-of select="$item/@s"/>
     <xsl:text>);&#xa;</xsl:text>
        
    </xsl:if>    
    
   </xsl:if>

  </xsl:for-each>
    
  <xsl:text>}&#xa;</xsl:text><!-- function -->
  <xsl:text>titleData2Map();</xsl:text>
  
 </xsl:template>
 
 <xsl:template match="*[starts-with(@id,'hxp')]" mode="template" name="hxparser">
  <xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" />
  <xsl:variable name="value" select="substring-after(@id,'-')" />
  <xsl:choose>
   <xsl:when test="substring-before($value,'-')='titlemap'">
        <!--
    <xsl:choose>
     <xsl:when test="substring-after($value,'-')='load'">
      <xsl:call-template name="prepareData">
      <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
        -->
      <xsl:value-of select="'unhandled id'"/>
      <xsl:value-of select="@id"/>
      <!--
     </xsl:otherwise>     
    </xsl:choose> 
       -->
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpidhandler">
     <xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

</xsl:stylesheet>
