<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina di visualizzazione di messaggi
Sono previsti due meccanismi per ripristinare la situazione prima del messaggio.
La decisione spetta comunque al java: chi implementa la gestione in java del messaggio a
seconda che passi o meno tutte le informazioni (tuple) per il ripristino pre-messaggio puo' scegliere il 
tipo di gestione: 'history' se usare history.back() di javascript, ogni altro valore per usare il
classico submit().
Nel caso in cui handType assuma il valore "close" la pagina con il messaggio verr chiusa
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/Messaggio.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
	</xsl:template>
	
	<!-- hxpForm (form nascosta - aggiungere ogni tupla che serve per ripristinare la situazione 
	antecedente al messaggio) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="xverb" value="" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="query" value="{$hxpdata/@query}" />
		</form>
	</xsl:template>



	<!--
 
   Implementazione dei singoli template data
 
	-->


	<!-- Smistamento dei template hxp-msg-data-... -->
	<xsl:template name="msgdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='title'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:value-of select="$blockData/msg/title"/>
				</xsl:copy>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='icon'"> <!-- icona -->
				<xsl:if test="$hxpdata/msg/type=substring-after($value,'-')">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->
 
	
	<!-- Chiude la pagina di errore: id="hxp-msg-action-close" -->
	<xsl:template name="msgclose">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="value">
				<xsl:value-of select="$hxpdata/msg/button"/>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return back('</xsl:text>
				<xsl:value-of select="$hxpdata/@destPage"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$hxpdata//msg/@handType"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
 
	
	<!-- Smistamento dei template hxp-msg-action-... -->
	<xsl:template name="msgaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='close'">
				<xsl:call-template name="msgclose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='msg'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-msg-action-... -->
								<xsl:call-template name="msgaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-msg-data-... -->
								<xsl:call-template name="msgdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
