<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Visualizzazione di un documento -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
        xmlns:xw="http://www.3di.it/ns/xw-200203121136"
        xmlns:h="http://www.w3.org/HTML/1998/html4"
        xmlns:str="http://xsltsl.org/string"
        exclude-result-prefixes="xw h str"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->

	<xsl:variable name="linkpagnum" select="10"/>
	<xsl:variable name="linkdocnum" select="20"/>

	<xsl:template name="numtitnavbarcode">
		<xsl:param name="pos" select="floor($hxpdata/@pos)"/>
		<xsl:param name="count" select="floor($hxpdata/@count)"/>
		<xsl:param name="pageCount" select="floor($hxpdata/@pageCount)"/>
		<xsl:variable name="curPage" select="floor($pos div $pageCount)"/>
		<xsl:variable name="numPages" select="floor( ( ($count) + ($pageCount) - 1 ) div ($pageCount))"/>
		<xsl:variable name="startprint">
			<xsl:choose>
				<xsl:when test="($numPages &lt;= $linkpagnum) ">
					<xsl:value-of select="0"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="($curPage - (floor( $linkpagnum div 2 )))&gt;0">
							<xsl:value-of select="($curPage - (floor( $linkpagnum div 2 )))"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="0"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="endprint">
			<xsl:choose>
				<xsl:when test="($numPages &lt;= $linkpagnum) ">
					<xsl:value-of select="$numPages"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="($curPage + (floor( $linkpagnum div 2 )))&lt;$numPages">
							<xsl:value-of select="($curPage + (floor( $linkpagnum div 2 )))"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$numPages"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="startprint1">
			<xsl:choose>
				<xsl:when test="(($endprint) - ($startprint)) &lt; $linkpagnum">
					<xsl:call-template name="largeleft">
						<xsl:with-param name="startprint" select="$startprint"/>
						<xsl:with-param name="endprint" select="$endprint"/>
						<xsl:with-param name="numpages" select="$numPages"/>
						<xsl:with-param name="linkpagnum" select="$linkpagnum"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$startprint"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="endprint1">
			<xsl:choose>
				<xsl:when test="(($endprint)-($startprint))&lt;$linkpagnum">
					<xsl:call-template name="largeright">
						<xsl:with-param name="startprint" select="$startprint"/>
						<xsl:with-param name="endprint" select="$endprint"/>
						<xsl:with-param name="numpages" select="$numPages"/>
						<xsl:with-param name="linkpagnum" select="$linkpagnum"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$endprint"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:call-template name="printtitnavbarcode">
			<xsl:with-param name="curPage" select="$curPage"/>
			<xsl:with-param name="curPrintPage" select="$startprint1"/>
			<xsl:with-param name="totPage" select="$endprint1"/>
			<xsl:with-param name="pageCount" select="$pageCount"/>
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="largeleft">
		<xsl:param name="startprint"/>
		<xsl:param name="endprint"/>
		<xsl:param name="numpages"/>
		<xsl:param name="linkpagnum"/>
		<xsl:choose>
			<xsl:when test="(($startprint)-1 &gt; 0 ) and ( $endprint - $startprint &lt; $linkpagnum )">
				<xsl:call-template name="largeleft"> 
					<xsl:with-param name="startprint" select="($startprint)-1"/>
					<xsl:with-param name="endprint" select="$endprint"/>
					<xsl:with-param name="numpages" select="$numpages"/>
					<xsl:with-param name="linkpagnum" select="$linkpagnum"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$startprint"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="largeleftdoc">
		<xsl:param name="startprint"/>
		<xsl:param name="endprint"/>
		<xsl:param name="count"/>
		<xsl:param name="linkdocnum"/>
		<xsl:choose>
			<xsl:when test="(($startprint)-1 &gt; 0 ) and ( $endprint - $startprint &lt; $linkdocnum )">
				<xsl:call-template name="largeleftdoc"> 
					<xsl:with-param name="startprint" select="($startprint)-1"/>
					<xsl:with-param name="endprint" select="$endprint"/>
					<xsl:with-param name="count" select="$count"/>
					<xsl:with-param name="linkdocnum" select="$linkdocnum"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$startprint"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="largeright">
		<xsl:param name="startprint"/>
		<xsl:param name="endprint"/>
		<xsl:param name="numpages"/>
		<xsl:param name="linkpagnum"/>
		<xsl:choose>
			<xsl:when test="(($endprint+1)&lt;$numpages) and ((($endprint)-($startprint))&lt;$linkpagnum)">
				<xsl:call-template name="largeright"> 
					<xsl:with-param name="startprint" select="$startprint"/>
					<xsl:with-param name="endprint" select="$endprint+1"/>
					<xsl:with-param name="numpages" select="$numpages"/>
					<xsl:with-param name="linkpagnum" select="$linkpagnum"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$endprint"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="largerightdoc">
		<xsl:param name="startprint"/>
		<xsl:param name="endprint"/>
		<xsl:param name="count"/>
		<xsl:param name="linkdocnum"/>
		<xsl:choose>
			<xsl:when test="(($endprint+1)&lt;$count) and ((($endprint)-($startprint))&lt;$linkdocnum)">
				<xsl:call-template name="largerightdoc"> 
					<xsl:with-param name="startprint" select="$startprint"/>
					<xsl:with-param name="endprint" select="$endprint+1"/>
					<xsl:with-param name="count" select="$count"/>
					<xsl:with-param name="linkdocnum" select="$linkdocnum"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$endprint"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="printtitnavbarcode">
		<xsl:param name="curPage"/>
		<xsl:param name="curPrintPage"/>
		<xsl:param name="totPage"/>
		<xsl:param name="pageCount"/>
		<xsl:choose>
			<xsl:when test="$curPage=$curPrintPage">
				<xsl:element name="span">
					<xsl:attribute name="class">evidence_number</xsl:attribute>
					<xsl:value-of select="concat($curPage+1,'&#160;')"/>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="a">
					<xsl:attribute name="title">
						<xsl:call-template name="FillerNavNumberAnchorAttributeTitle">
							<xsl:with-param name="TypeOfView" select="'Title'"/>
							<xsl:with-param name="CurrentLanguage" select="$hxpdata/@language"/>
							<xsl:with-param name="FillerNumber" select="$curPrintPage+1"/>
						</xsl:call-template>
					</xsl:attribute>
					<xsl:attribute name="href">javascript:void(0)</xsl:attribute>
					<xsl:attribute name="onclick">
					<xsl:text>return numnav2page('</xsl:text>
						<xsl:value-of select="$curPrintPage * $pageCount"/>
					<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:value-of select="$curPrintPage+1"/>
				</xsl:element>
				<xsl:value-of select="'&#160;'"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="($curPrintPage+1) &lt; $totPage">
			<xsl:call-template name="printtitnavbarcode">
				<xsl:with-param name="curPage" select="$curPage"/>
				<xsl:with-param name="curPrintPage" select="$curPrintPage+1"/>
				<xsl:with-param name="totPage" select="$totPage"/>
				<xsl:with-param name="pageCount" select="$pageCount"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template name="numdocnavbarcode">
		<xsl:param name="pos" select="floor($hxpdata/@pos)"/>
		<xsl:param name="count" select="floor($hxpdata/@count)"/>
		<xsl:variable name="startprint">
			<xsl:choose>
				<xsl:when test="($count &lt;= $linkdocnum)">
					<xsl:value-of select="0"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="($pos - (floor( $linkdocnum div 2 )))&gt;0">
							<xsl:value-of select="($pos - (floor( $linkdocnum div 2 )))"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="0"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="endprint">
			<xsl:choose>
				<xsl:when test="($count &lt;= $linkdocnum)">
					<xsl:value-of select="$count"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="($pos + (floor( $linkdocnum div 2 )))&lt;$count">
							<xsl:value-of select="($pos + (floor( $linkdocnum div 2 )))"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="$count"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="startprint1">
			<xsl:choose>
				<xsl:when test="(($endprint) - ($startprint)) &lt; $linkdocnum">
					<xsl:call-template name="largeleftdoc">
						<xsl:with-param name="startprint" select="$startprint"/>
						<xsl:with-param name="endprint" select="$endprint"/>
						<xsl:with-param name="count" select="$count"/>
						<xsl:with-param name="linkdocnum" select="$linkdocnum"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$startprint"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="endprint1">
			<xsl:choose>
				<xsl:when test="(($endprint)-($startprint))&lt;$linkdocnum">
					<xsl:call-template name="largerightdoc">
						<xsl:with-param name="startprint" select="$startprint"/>
						<xsl:with-param name="endprint" select="$endprint"/>
						<xsl:with-param name="count" select="$count"/>
						<xsl:with-param name="linkdocnum" select="$linkdocnum"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$endprint"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:call-template name="printdocnavbarcode">
			<xsl:with-param name="curDoc" select="$pos"/>
			<xsl:with-param name="curPrintDoc" select="$startprint1"/>
			<xsl:with-param name="totDoc" select="$endprint1"/>
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="printdocnavbarcode">
		<xsl:param name="curDoc"/>
		<xsl:param name="curPrintDoc"/>
		<xsl:param name="totDoc"/>
		<xsl:choose>
			<xsl:when test="$curDoc=$curPrintDoc">
				<xsl:element name="span">
					<xsl:attribute name="class">evidence_number</xsl:attribute>
					<xsl:value-of select="concat($curDoc+1,'&#160;')"/>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:element name="a">
					<xsl:attribute name="title">
						<xsl:call-template name="FillerNavNumberAnchorAttributeTitle">
							<xsl:with-param name="TypeOfView" select="'Document'"/>
							<xsl:with-param name="CurrentLanguage" select="$hxpdata/@language"/>
							<xsl:with-param name="FillerNumber" select="$curPrintDoc+1"/>
						</xsl:call-template>
					</xsl:attribute>
					<xsl:attribute name="href">javascript:void(0)</xsl:attribute>
					<xsl:attribute name="onclick">
					<xsl:text>return numnav2pagefd('</xsl:text>
						<xsl:value-of select="$curPrintDoc"/>
					<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:value-of select="$curPrintDoc+1"/>
				</xsl:element>
				<xsl:value-of select="'&#160;'"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="($curPrintDoc+1) &lt; $totDoc">
			<xsl:call-template name="printdocnavbarcode">
				<xsl:with-param name="curDoc" select="$curDoc"/>
				<xsl:with-param name="curPrintDoc" select="$curPrintDoc+1"/>
				<xsl:with-param name="totDoc" select="$totDoc"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<xsl:template name="FillerNavNumberAnchorAttributeTitle">
		<xsl:param name="TypeOfView" select="''"/>
		<xsl:param name="CurrentLanguage" select="''"/>
		<xsl:param name="FillerNumber" select="''"/>
		<xsl:variable name="FillerLanguage">
			<xsl:choose>
				<xsl:when test="$CurrentLanguage='it'">
					<xsl:value-of select="$CurrentLanguage"/>
				</xsl:when>
				<xsl:when test="$CurrentLanguage='en'">
					<xsl:value-of select="$CurrentLanguage"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'it'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$FillerLanguage='it'">
				<xsl:choose>
					<xsl:when test="$TypeOfView='Title'">
						<xsl:value-of select="concat('Mostra la pagina dei risultati numero ', $FillerNumber)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat('Mostra la scheda numero ', $FillerNumber)"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$TypeOfView='Title'">
						<xsl:value-of select="concat('Show headings page number ', $FillerNumber)"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="concat('Show document number ', $FillerNumber)"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>