<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

 <xsl:template name="hxpcontent_nei">
  <xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="elemName" select="''" />
  <xsl:param name="instPosDep" select="''"/>  
  <xsl:copy>
   <xsl:for-each select="@*[name()!='id']">
    <xsl:call-template name="stringparser">
     <xsl:with-param name="data" select="$blockData" />
     <xsl:with-param name="instPosDep" select="$instPosDep"/>     
    </xsl:call-template>
   </xsl:for-each>
   <xsl:for-each select="$blockData">
    <xsl:call-template name="matchcontent_nei">
     <xsl:with-param name="elemName" select="$elemName" />
    </xsl:call-template>
   </xsl:for-each>
  </xsl:copy>
 </xsl:template>


 <xsl:template name="matchcontent_nei">
  <xsl:param name="elemName" select="''"/>
  <xsl:param name="copy" select="''"/>
  <xsl:choose>
   <xsl:when test="starts-with($elemName,'pi-')">
    <xsl:call-template name="showpi">
     <xsl:with-param name="attrib" select="substring-after($elemName,'pi-')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="starts-with($elemName,'@')">
    <xsl:call-template name="showtext_nei">
     <xsl:with-param name="attrib" select="substring-after($elemName,'@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="name()=$elemName or name()=substring-before($elemName,'/@')">
    <xsl:call-template name="showtext_nei">
     <xsl:with-param name="attrib" select="substring-after($elemName,'/@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:for-each select="*">
  <!--  <xsl:for-each select="@*">
pippo
    </xsl:for-each>-->
     <xsl:call-template name="matchcontent_nei">
      <xsl:with-param name="elemName" select="$elemName"/>
      <xsl:with-param name="copy" select="$copy"/>
     </xsl:call-template>
    </xsl:for-each>

   </xsl:otherwise>
  </xsl:choose>
 </xsl:template> 
 
 
  <xsl:template name="showtext_nei">
  <xsl:param name="attrib" select="''"/>
  <xsl:param name="copy" select="''"/>
  <xsl:choose>
   <xsl:when test="$copy=''">
    <xsl:choose>
     <xsl:when test="$attrib=''">
      <xsl:for-each select=".">
       <xsl:apply-templates/>
      </xsl:for-each>
     </xsl:when>
     <xsl:otherwise>
       <xsl:apply-templates select="@*[name()=$attrib]"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:choose>
     <xsl:when test="$attrib=''">
      <xsl:for-each select="./node()">
       <xsl:copy-of select="."/>
      </xsl:for-each>
     </xsl:when>
     <xsl:otherwise>
      <xsl:copy-of select="@*[name()=$attrib]"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 
 </xsl:stylesheet>