<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 28/10/2004
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene i template relativi alla pagina dei profili di stampa.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Javascript da includere
	-->
	<xsl:template name="jslist">
		<!--
			Federico 01/04/2005: aggiunta inclusione del file 'errorMsg.js' qualora venga rilevato almeno
			un id 'hxp-prints-action-back' (gestione del pulsante 'Indietro').

			NOTA: Dato che questo file contiene una funzione 'loadHandler()', e' necessario includere
				  'errorMsg.js' PRIMA di 'print_profiles.js', in modo che venga utilizzata la 'loadHandler()'
				  di quest'ultimo.
		-->
		<xsl:if test="count(//*[@id='hxp-prints-action-back'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/errorMsg.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/print_profiles.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Attributi del body.
	-->
	<xsl:template name="bodyattributes">
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Tuple di hxpForm (form nascosta).
	-->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1" enctype="multipart/form-data">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="childLast" value="1" />
			<input type="hidden" name="qord" value="" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
			<input type="hidden" name="userInfo" value="{$hxpdata/@userInfo}" />
			<input type="hidden" name="pwdLock" value="{$hxpdata/@pwdLock}" />
			<input type="hidden" name="pwdPhysdoc" value="{$hxpdata/@pwdPhysdoc}" />
			<input type="hidden" name="pwdChangeInfo" value="" />

			<!-- template per la generazione del pdf -->
			<input type="hidden" name="printTemplate" value="" />

			<!-- specifici -->
			<xsl:call-template name="contextcustom">
				<xsl:with-param name="specName" select="'beforeend'"/>
			</xsl:call-template>
		</form>
	</xsl:template>

	<!-- Implementazione dei singoli template action -->

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Torna alla pagina di ricerca: id "hxp-prints-action-querypage".
	-->
	<xsl:template name="goto_querypage">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryPage()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Restituisce la pagina dei titoli: id="hxp-prints-action-titles".
	-->
	<xsl:template name="printstitles">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="selid" select="$hxpdata/@selid" />
		<xsl:choose>
			<xsl:when test="$selid!='' and $hxpdata/@count>1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
						<xsl:text>return paginaTitoli(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare.
		*
		* Inserisce la chiamata javascript per l'avvio della stampa della selezione o del singolo documento.
		* Gestisce l'id "hxp-prints-action-print".
	-->
	<xsl:template name="start_print">
		<xsl:param name="blockData" select="$hxpdata" />
		<!-- Federico 17/10/05: l'indicazione del tipo di output e' stata spostata nel file dei profili [RW 0030160] -->
		<!--<xsl:param name="outType" select="''"/>-->

		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return startPrint();</xsl:text>
				<!--<xsl:text>return startPrint('</xsl:text>
				<xsl:value-of select="$outType"/>
				<xsl:text>');</xsl:text>-->
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Gestisce il radiobutton associato a un profilo di stampa (id = "hxp-prints-action-radio"). Il name dei
		* radio button deve essere "profile". La form che contiene i radio si deve chiamare "theForm".
	-->
	<xsl:template name="printsradio">
		<xsl:param name="blockData" select="''" />

		<!--
			Modifica di Federico del 25/11/2004:
			occorre mostrare il radio button del profilo solo se questo corrisponde alla lingua selezionata
			dall'utente.
		-->
		<xsl:if test="string($blockData/@lang)=$hxpdata/@language">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<!-- 15/03/2006 Gregorio
					Introdotto per conformit con i criteri di accessibilit,
					poich nel template si utilizza il tag label associato ad un input.
					Il tag label disponde dell'attributo for che deve assumere lo stesso valore dell'attributo id dell'input.
					Per radio del print profiles si  scelto di generare un id numerico
				-->
				<xsl:attribute name="id">
					<xsl:text>profilo-</xsl:text>
					<xsl:value-of select="count($blockData/preceding-sibling::*)"/>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>setTemplate(this);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:value-of select="$blockData/@template"/>
				</xsl:attribute>
				<xsl:if test="$blockData/@default = 'yes'">
					<xsl:attribute name="checked">
						<xsl:text>checked</xsl:text>
					</xsl:attribute>
				</xsl:if>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
		* @author Gregorio Gelli
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Gestisce la label associata ai radio. Il name dei
		* radio button deve essere "profile". La form che contiene i radio si deve chiamare "theForm".
	-->
	<xsl:template name="printslabel">
		<xsl:param name="blockData" select="''" />
		<!-- 15/03/2006 Gregorio
			Introdotto per conformit con i criteri di accessibilit,
			poich nel template si utilizza il tag label associato ad un input.
			Il tag label disponde dell'attributo for che deve assumere lo stesso valore dell'attributo id dell'input.
			Per radio del print profiles si  scelto di generare un id numerico
		-->
		<xsl:if test="string($blockData/@lang)=$hxpdata/@language">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="for">
					<xsl:text>profilo-</xsl:text>
					<xsl:value-of select="count($blockData/preceding-sibling::*)"/>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Gestione id 'hxp-prints-action-back' (pulsante 'Indietro'). Al posto di questo id viene inserita
		* una chiamata js alla funzione 'back('', 'history')' contenuta nel file 'errorMsg.js'.
	-->
	<xsl:template name="printsback">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:if test="name()='a' or name='A'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>return back('', 'history');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param value azione
		*
		* Smistamento dei template hxp-prints-action-...
	-->
	<xsl:template name="printsaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='print'">
				<xsl:call-template name="start_print">
					<xsl:with-param name="blockData" select="$blockData" />
					<!-- Federico 17/10/05: l'indicazione del tipo di output e' stata spostata nel file dei profili [RW 0030160] -->
					<!--<xsl:with-param name="outType" select="substring-after($value, 'print-')" />-->
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='querypage'">
				<xsl:call-template name="goto_querypage">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='titles'">
				<xsl:call-template name="printstitles">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='radio'">
				<xsl:call-template name="printsradio">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio 15/03/2006: gestione 'hxp-prints-action-label' (label associata ad input radio) -->
			<xsl:when test="$value='label'">
				<xsl:call-template name="printslabel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 01/04/2005: gestione 'hxp-prints-action-back' (pulsante 'Indietro') -->
			<xsl:when test="$value='back'">
				<xsl:call-template name="printsback">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param value dato da visualizzare
		*
		* Smistamento dei template hxp-prints-data-...
	-->
	<xsl:template name="printsdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />

		<xsl:choose>
			<xsl:when test="$value='tittext'"> <!-- visualizzazione del titolo del profilo -->
				<!--
					Modifica di Federico del 25/11/2004:
					occorre mostrare il titolo del profilo solo se questo corrisponde alla lingua selezionata
					dall'utente.
				-->
				<xsl:if test="string($blockData/@lang)=$hxpdata/@language">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:value-of select="$blockData/@title"/>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param value ci che deve essere visualizzato
		*
		* Smistamento dei template hxp-prints-show-...
	-->
	<xsl:template name="prints_show">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='header'">
				<!--
					Modifica di Federico del 25/11/2004:
					occorre mostrare l'header della pagina dei profili che corrisponde alla lingua
					selezionata dall'utente.
				-->
				<xsl:for-each select="$hxpdata/page_header">
					<xsl:if test="string(@lang)=$hxpdata/@language">
						<xsl:copy-of select="./* | ./text()"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="$value='footer'">
				<!--
					Modifica di Federico del 25/11/2004:
					occorre mostrare il footer della pagina dei profili che corrisponde alla lingua
					selezionata dall'utente.
				-->
				<xsl:for-each select="$hxpdata/page_footer">
					<xsl:if test="string(@lang)=$hxpdata/@language">
						<xsl:copy-of select="./* | ./text()"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="$value='ifErrorMsg'"> <!-- mostro nel caso in cui si siano verificati errori -->
				<xsl:if test="count($hxpdata/error_msg) > 0">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='onlyIfNoErrors'"> <!-- mostro nel caso in cui non si siano verificati errori -->
				<xsl:if test="count($hxpdata/error_msg) = 0">
					<xsl:choose>
						<xsl:when test="name() != 'span' or count(./@*) > 1">
						<!-- ricopio il nodo se non  uno span o se ha altri attributi oltre all'id -->
							<xsl:copy>
								<xsl:copy-of select="@*[name()!='id']"/>
								<xsl:call-template name="hxpcontinuecontext">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:copy>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='errorMsg'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']"/>
					<xsl:copy-of select="$hxpdata/error_msg/* | $hxpdata/error_msg/text()"/>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param value template da eseguire
		*
		* Cerca il template xsl hxp-prints-... da eseguire.
	-->
	<xsl:template name="prints_parser">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='action'"> <!-- hxp-prints-action-... -->
				<xsl:call-template name="printsaction">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='show'"> <!-- hxp-prints-show-... -->
				<xsl:call-template name="prints_show">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='data'"> <!-- hxp-prints-data-... -->
				<xsl:call-template name="printsdata">
					<xsl:with-param name="value" select="substring-after($value,'data-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='showif'"> <!-- hxp-prints-showif-... -->
				<xsl:variable name="respAttr">
					<xsl:value-of select="substring-after(@id,'hxp-prints-showif-')"/>
				</xsl:variable>
				<xsl:if test="$hxpdata/@*[name()=$respAttr] and $hxpdata/@*[name()=$respAttr]!=''">
					<xsl:choose>
						<!--
							Federico 06/07/07: se si proviene dalla pagina dei titoli e nella selezione c'e' un solo documento
							(tipo la pagina dei titoli raggiunta visualizzando i documenti di un fascicolo di docway), nella pagina
							dei profili di stampa deve comparire il radio button di stampa della selezione corrente in modo che, al
							caricamento della pagina, venga impostato il corretto verbo per avviare la stampa [RW 0039540]
						-->
						<xsl:when test="$respAttr='selid' and $hxpdata/@count=1 and $hxpdata/@physDoc!=''">
							<!-- Vedi scheda RW 0039540 -->
						</xsl:when>
						<xsl:otherwise>
    					<xsl:copy>
    						<xsl:copy-of select="@*[name()!='id']" />
    						<xsl:call-template name="hxpcontinuecontext">
    						<xsl:with-param name="blockData" select="$hxpdata"/>
    						</xsl:call-template>
    					</xsl:copy>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='showifOneDoc'"> <!-- hxp-prints-showifOneDoc -->
				<xsl:if test="$hxpdata/@physDoc != ''">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$hxpdata"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param disable indica se disabilitare o meno il contenuto dell'elemento esplorato.
		*
		* Cerca il template xsl generico da eseguire.
	-->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='prints'"> <!-- hxp-prints-... -->
						<xsl:call-template name="prints_parser">
							<xsl:with-param name="value" select="substring-after($value,'-')" />
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:for-each select="@*">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
