<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina di gestione delle ricerche frequenti -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/qlist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:attribute name="scroll">auto</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="appData" value="{$hxpdata/@appData}" />
			<!-- altri parametri in hxp -->
		</form>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template action
 
	-->
 
	<!-- Esegue una ricerca frequente: id="hxp-qlist-action-show" -->
	<xsl:template name="qShow">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:if test="name()='a'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>GoTo_(this.name);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>show</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Aggiunta di una ricerca frequente: id="hxp-qlist-action-add" -->
	<xsl:template name="qAdd">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:if test="name()='a'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>GoTo_(this.name);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>add</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Rimozione di una ricerca frequente: id="hxp-qlist-action-remove" -->
	<xsl:template name="qRemove">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>

			<xsl:if test="name()='a'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>GoTo_(this.name);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>erase</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Chiusura della finestra delle ricerche frequenti senza salvare
	le modifiche: id="hxp-qlist-action-cancel" -->
	<xsl:template name="qCancel">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:if test="name()='a'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>GoTo_(this.name);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>cancel</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Salvataggio delle ricerche frequenti: id="hxp-qlist-action-confirm" -->
	<xsl:template name="qConfirm">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:if test="name()='a'">
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="onclick">
				<xsl:text>GoTo_(this.name);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>confirm</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Smistamento dei template hxp-qlist-action-... -->
	<xsl:template name="qAction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='show'">
				<xsl:call-template name="qShow">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='add'">
				<xsl:call-template name="qAdd">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='remove'">
				<xsl:call-template name="qRemove">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='cancel'">
				<xsl:call-template name="qCancel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirm'">
				<xsl:call-template name="qConfirm">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	
	<!--
 
   Implementazione dei singoli template data
 
 -->
 
	<!-- Nome della ricerca frequente: id="hxp-qlist-data-titleSelsct" -->
	<xsl:template name="qTitleSelect">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:attribute name="onchange">
				<xsl:text>selectHasChanged()</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>qTitle</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Frase di ricerca della ricerca frequente: id="hxp-qlist-data-querytext" -->
	<xsl:template name="qDataText">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:attribute name="onchange">
				<xsl:text>;</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>qData</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Gestione del checkbox per la ricezione periodica della notifica 
	delle variazioni: id="hxp-qlist-data-push" -->
	<xsl:template name="qPushCheck">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
                        <!--
			<xsl:copy-of select="@*[name()!='id']" />
                        -->
	  <xsl:for-each select="@*[name()!='id']">
	  	<xsl:call-template name="stringparser">
	    	<xsl:with-param name="data" select="$blockData"/>
	    </xsl:call-template>
	  </xsl:for-each>
			<xsl:attribute name="onchange">
				<xsl:text>PushHasChanged()</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:text>qPush</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Smistamento dei template hxp-qlist-data-... -->
	<xsl:template name="qData">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='querytext'">
				<xsl:call-template name="qDataText">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='titleSelect'">
				<xsl:call-template name="qTitleSelect">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='push'">
				<xsl:call-template name="qPushCheck">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='qlist'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')">
								<xsl:call-template name="qAction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" /> <!-- hxp-qlist-action-... -->
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-qlist-data-... -->
								<xsl:call-template name="qData">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
