<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--

	Pagina di ricerca:

	Se si vuole eseguire una ricerca semplice utilizzare id="hxp-query-action-findplain".
	Tutti i campi del template html devono essere contenuti in una form chiamata "theForm".
	Tutti i campi di ricerca devono avere il name indicato tra parentesi quadre.

	E' possibile che un campo di ricerca sia in adiacenza con un alias avente valore fisso. La
	   sintassi da usare per il name e' (esempio comprendente frase ottenuta):
	   	[alias1|adj|alias2|val]
			([alias1]=valore_del_campo) adj ([alias2]=val)

	Nel caso in cui la frase di ricerca e' nulla e' possibile specificare una frase di ricerca
	di default mediante un campo hidden con name='default_query' e con value la frase desiderata.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

    <xsl:include href="hierarchy.xsl"/>

	<!--
		Javascript da includere
		Nel caso di checkbox per la restrizione della query occorre che il primo checkbox abbia
			id="hxp-query-include-query_chk_restriction". Il name del checkbox deve invece avere
			la forma "chkres_(nome alias campo o chiave di restrizione)_#progressivo" e deve essere
			contenuto in una form chiamata "theForm".
			E' anche possibile esprimere una restrizione sempre valida per un dato template di ricerca
			utilizzando un campo hidden con name (sintassi identica a quella del checkbox).
	-->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/query.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/iduid.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/formTupleRestore.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<xsl:if test="count(//*[@id='hxp-query-include-query_chk_restriction'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/query_chk_restriction.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
	</xsl:template>

	<!-- indexForm, hxpForm, saveLastQuery (form nascoste) -->
	<xsl:template name="beforeend">

		<!--
			Aggiunto da Federico il 19/08/2004.
			Se vengono rilevati degli id 'hxp-range-include-daterange' (si veda building block "inputDate_q"),
			viene inserito, alla fine della pagina, il <div> nascosto per la ricerca per intervallo di date.
		-->
		<xsl:if test="count(//*[@id='hxp-range-include-daterange'])>0">
			<!--
			 	Modifica di Federico del 22/11/2004:
			 	l'inizializzazione di "hxpresource_generic"  stata spostata qui per evitare di effettuare tale
			 	operazione inutilmente.

			 	Nota: non includere il file "genericResourceHandler.xsl"; qualora tale file fosse necessario per il
			 	template in esso contenuto ("hxpGenericResource"), rimuovere
			 	l'inizializzazione della var. "hxpresource_generic", dato che  presente anche nel file xsl menzionato.

				Se la tupla "language" contiene la lingua scelta per l'applicazione, deve essere istanziato il corretto file
				di risorse.
				I file di risorse delle lingue hanno il seguente nome: "generic.resource.<lingua>.xml", dove <lingua>
				rappresenta la lingua specificata nell'attributo "/response/@language".
				Se il file della lingua scelta non viene trovato, viene scelto il file di default "generic.resource.xml".
			-->
			<xsl:variable name="generic_resource_path">
				<xsl:variable name="generic_resource_name">
					<xsl:text>generic.resource</xsl:text>
					<xsl:if test="$hxpdata/@language!=''">
						<xsl:text>.</xsl:text>
						<xsl:value-of select="$hxpdata/@language"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="generic_resource_file" select="document(concat('../html/templates/',$generic_resource_name,'.xml'))"/>
			 	<xsl:choose>
			 		<xsl:when test="$generic_resource_file!=''">
			 			<xsl:value-of select="concat('../html/templates/',$generic_resource_name,'.xml')"/>
			 		</xsl:when>
			 	  	<xsl:otherwise>
			         	<xsl:text>../html/templates/generic.resource.xml</xsl:text>
			        </xsl:otherwise>
			    </xsl:choose>
			</xsl:variable>

			<xsl:variable name="hxpresource_generic" select="document(string($generic_resource_path))"/>

			<div id="DateRange" style="position:absolute; width:400px; z-index:1; left: 5px; top: 41px; height:350px; display:none;">
	    		<form method="post" name="dateRangeForm">
    				<input type="hidden" name="returnField" value=""/>
		    		<table border="1" width="100%" cellspacing="0" cellpadding="0"  bgcolor="#ffffff">
		      			<tr bgcolor="#3333FF" valign="BASELINE">
		        			<td>
		          				<div align="left">
		          					<font size="4" face="Times New Roman, Times, serif" color="#ffffff">
		          						<b>&#160;
		          						<!-- Modifica di Federico del 10/11/2004: per la gestione delle lingue  necessario utilizzare il file di risorse -->
		          						<xsl:value-of select="$hxpresource_generic//*[@id='Ricerca per intervallo di date']/@value"/>
		          						</b>
		          					</font>
		          				</div>
		        			</td>
		      			</tr>
		      			<tr>
		      				<td>
			      				<table border="0" width="100%" cellspacing="0" cellpadding="0"  bgcolor="#ffffff">
			      					<tr>
	                  					<td colspan="2">&#160;</td>
	                				</tr>
	                				<tr colspan="2">
	                  					<td colspan="2">&#160;</td>
	                				</tr>
			      					<tr width="40%" bgcolor="#FEFEFE">
			        					<td align="center" valign="top" width="30%">
			        						<!-- pulsanti -->
			        						<div align="right" style="margin-top: 3px">
                								<a tabindex="-1" href="javascript:void(0);" onclick="ConfirmDateRangeDiv();return false;">
                									<div style="font-size:80%" class="uniform_emula_bottone">
                										<!-- Modifica di Federico del 10/11/2004: per la gestione delle lingue  necessario utilizzare il file di risorse -->
                										<xsl:value-of select="$hxpresource_generic//*[@id='Ok']/@value"/>
                									</div>
                								</a>
                							</div>
			        						<div align="right" style="margin-top: 3px">
                								<a tabindex="-1" href="javascript:void(0);" onclick="CloseDateRangeDiv();return false;">
                									<div style="font-size:80%" class="uniform_emula_bottone">
                										<!-- Modifica di Federico del 10/11/2004: per la gestione delle lingue  necessario utilizzare il file di risorse -->
                										<xsl:value-of select="$hxpresource_generic//*[@id='Annulla']/@value"/>
                									</div>
                								</a>
                							</div>
				    					</td>
				    					<td align="center" valign="top" width="60%">
				    						<!-- campi -->
				    						<table border="0" width="80%" cellpadding="0" cellspacing="0">
  												<tr>
  													<td class="Paragraph_Descr">
  														<!-- Modifica di Federico del 10/11/2004: per la gestione delle lingue  necessario utilizzare il file di risorse -->
  														<xsl:value-of select="$hxpresource_generic//*[@id='DateRangeDiv_Da']/@value"/>
  														&#160;
  													</td>
  													<td nowrap="nowrap"  class="Paragraph_Data">
  														<input type="text" name="date_range_from" class="Paragraph_Input_Big" href="javascript:void(0);" onblur="return dateRangeChkDate(this, true);"/>
  														<!-- Modifica di Federico del 20/12/2004: inserimento di un calendario javascript. -->
														<span id="hxp-includeJsCalendar"/> <!-- inclusione javascript e div nascosto del calendario -->
														<a href="javascript:void(0);" onclick="ShowCalByName(this, 'date_range_from');">
															<img src="../../../formatter/html/data/img/img_calendar/calendar.gif" alt="Calendario" border="0" align="absmiddle"/>
														</a>
 													</td>
  												</tr>
  												<tr>
	                  								<td colspan="2">&#160;</td>
	                							</tr>
  												<tr>
  													<td class="Paragraph_Descr">
  														<!-- Modifica di Federico del 10/11/2004: per la gestione delle lingue  necessario utilizzare il file di risorse -->
  														<xsl:value-of select="$hxpresource_generic//*[@id='DateRangeDiv_A']/@value"/>
  														&#160;
  													</td>
  													<td nowrap="nowrap" class="Paragraph_Data">
  														<input type="text" name="date_range_to" class="Paragraph_Input_Big" href="javascript:void(0);" onblur="return dateRangeChkDate(this, true);"/>
  														<!-- Modifica di Federico del 20/12/2004: inserimento di un calendario javascript. -->
														<a href="javascript:void(0);" onclick="ShowCalByName(this, 'date_range_to');">
															<img src="../../../formatter/html/data/img/img_calendar/calendar.gif" alt="Calendario" border="0" align="absmiddle"/>
														</a>
													</td>
  												</tr>
  											</table>
				    					</td>
			      					</tr>
			      					<tr>
	                  					<td colspan="2">&#160;</td>
	                				</tr>
	                				<tr>
	                  					<td colspan="2">&#160;</td>
	                				</tr>
			    				</table>
		    				</td>
		    			</tr>
		    		</table>
	    		</form>
   			</div>
		</xsl:if>
		<!-- fine div per la ricerca per intervallo di date -->

		<form method="post" id="indexForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<div>
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="showindex" />
			<input type="hidden" name="xverb" value="" />
			<input type="hidden" name="keypath" value="" />
			<input type="hidden" name="fillField" value="" />
			<input type="hidden" name="startkey" value="" />
			<input type="hidden" name="keyCount" value="{$hxpdata/@keyCount}" />
			<input type="hidden" name="threl" value="" />
			<input type="hidden" name="doubleKey" value="" />
			<input type="hidden" name="shwMode" value="" />
			<input type="hidden" name="xMode" value="" />
			<input type="hidden" name="minf" value="{$hxpdata/@minf}" /> <!-- frequenza minima -->
			<input type="hidden" name="maxf" value="{$hxpdata/@maxf}" /> <!-- frequenza massima -->
			<input type="hidden" name="xRels" value="" />
			<input type="hidden" name="vRels" value="" />
			<input type="hidden" name="cPath" value="" />
			<input type="hidden" name="lRel" value="" />
			<input type="hidden" name="sele" value="" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="winTarget" value="indexWindow" />
			</div>
		</form>
		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1" enctype="multipart/form-data">
			<div>
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="query" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="childLast" value="1" />
			<input type="hidden" name="qord" value="" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />

            <!-- memorizza lo stato di esplosione dell'albero gerarchico -->
			<input type="hidden" name="hierSearchList" value="" />
			<input type="hidden" name="hierSearchShow" value="{$hxpdata/@hierSearchShow}" />
			<input type="hidden" name="cuttingBranch"  value="" />

			<!-- per i repertori su cui ho visione completa -->
			<input type="hidden" name="repVisComp" value="" />

			<!-- per navigazione su thesauro -->
			<input type="hidden" name="keypath" value="''" />
			<input type="hidden" name="startkey" value="''" />
			<input type="hidden" name="relation" value="''" />
			<input type="hidden" name="xMode" value="" />

			<!-- per navigazione su thesauro vincolato -->
			<input type="hidden" name="lookup_new" value="" />
			<input type="hidden" name="lookup_campi" value="" />
			<input type="hidden" name="lookup_fieldVal" value="" />

			<!-- management export documents -->
			<input type="hidden" name="exclusionFields" value="" />
			<input type="hidden" name="inclusionFields" value="" />
			<input type="hidden" name="rangeDocs" value="" />
			<input type="hidden" name="pathFiles" value="" />

			<!-- uso speciale per upload di file da strumenti di amministrazione -->
			<input type="hidden" name="propertyEntry" value="" />

			<!-- simone - 12 ott 2004
			Per ultimo accesso e cambio password -->
			<xsl:element name="input">
				<xsl:attribute name="type">
					<xsl:text>hidden</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="name">
					<xsl:text>pwdInfo</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="value">
					<xsl:if test="$hxpdata/@lastLoginDate!='' or $hxpdata/@pwdLeftTime!=''">
						<xsl:value-of select="$hxpdata/@lastLoginDate"/>
						<xsl:text>|</xsl:text>
						<xsl:value-of select="$hxpdata/@lastLoginTime"/>
						<xsl:text>|</xsl:text>
						<xsl:value-of select="$hxpdata/@pwdLeftTime"/>
					</xsl:if>
				</xsl:attribute>
			</xsl:element>
			<input type="hidden" name="userInfo" value="{$hxpdata/@userInfo}" />
			<input type="hidden" name="pwdLock" value="{$hxpdata/@pwdLock}" />
			<input type="hidden" name="pwdPhysdoc" value="{$hxpdata/@pwdPhysdoc}" />
			<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
			<input type="hidden" name="pwdChangeInfo" value="" />

			<!-- per inserimento/modifica di repertori -->
			<input type="hidden" name="codice_rep" value="" />
			<input type="hidden" name="descrizione_rep" value="" />

			<!-- Debug Fede: decommentare il codice seguente per debuggare il
			 	 pulsante back del thesauro gerarchico (si veda anche file query.xml di XSpring e query.js generico).
	 		-->
			<!--<input type="hidden" name="cPath" value="" />-->

			<!-- Aggiunto da Federico il 05/10/2004: tupla per il pulsante 'back' del thesauro gerarchico -->
   			<input type="hidden" name="thBackPage" value="{$hxpdata/@thBackPage}"/>

            <!-- simone - 3 Dic 2004 -->
		    <input type="hidden" name="personalView" value="" />

		    <!--
		    	Federico 17/10/06: introdotta tupla per informazioni di avviamento delle stampe Jasper [RW 0039816]
		    -->
			<input type="hidden" name="jReportInfo" value="" />

		    <!--
		    	Federico 17/10/06: introdotta tupla per eventuali parametri da passare ai report Jasper [RW 0039816]
		    -->
			<input type="hidden" name="jReportParams" value="" />

			<!--
				Federico 25/10/07: introdotta possibilita' di indicare un file xsl da usare per filtrare i
        		documenti esportati [RW 0047738]
        	-->
			<input type="hidden" name="xslExportFilterName" value="" />

			<!-- specifici -->
			<xsl:call-template name="contextcustom">
				<xsl:with-param name="specName" select="'beforeend'"/>
			</xsl:call-template>
			</div>
		</form>
		<!-- form per il salvataggio dell'ultima query effettuata -->
		<form id="saveLastQuery" action="{$hxpdata/@uri}">
			<div>
			<input type="hidden" name="save0" value="" />
			<input type="hidden" name="save1" value="" />
			<input type="hidden" name="save2" value="" />
			<input type="hidden" name="save3" value="" />
			<input type="hidden" name="save4" value="" />
			<input type="hidden" name="save5" value="" />
			<input type="hidden" name="save6" value="" />
			<input type="hidden" name="save7" value="" />
			<input type="hidden" name="save8" value="" />
			<input type="hidden" name="save9" value="" />
			<input type="hidden" name="save10" value="" />
			<input type="hidden" name="save11" value="" />
			<input type="hidden" name="save12" value="" />
			<input type="hidden" name="save13" value="" />
			<input type="hidden" name="save14" value="" />
			<input type="hidden" name="save15" value="" />
			<input type="hidden" name="save16" value="" />
			<input type="hidden" name="save17" value="" />
			<input type="hidden" name="save18" value="" />
			<input type="hidden" name="save19" value="" />
			<input type="hidden" name="save20" value="" />
			<input type="hidden" name="save21" value="" />
			<input type="hidden" name="save22" value="" />
			<input type="hidden" name="save23" value="" />
			<input type="hidden" name="save24" value="" />
			<input type="hidden" name="save25" value="" />
			<input type="hidden" name="save26" value="" />
			<input type="hidden" name="save27" value="" />
			<input type="hidden" name="save28" value="" />
			<input type="hidden" name="save29" value="" />
			<input type="hidden" name="save30" value="" />
			</div>
		</form>
	</xsl:template>


	<!--

   Implementazione dei singoli template action

 -->

	<!-- ???Esegue una ricerca senza riferimenti???: id="hxp-query-action-findplain" -->
	<xsl:template name="queryplain">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="rep_visione_completa">
			<xsl:for-each select="$hxpdata//repertorio/tabella[@vis='completa']">
				<xsl:value-of select="concat(current()/../@codice,'-',current()/@tipo,'|')" />
			</xsl:for-each>
		</xsl:variable>
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<!-- Modifica richiesta da Gregorio in data 10/08/2004 -->
				<xsl:value-of select="@onclick" /><xsl:text>;</xsl:text>
				<xsl:choose>
					<xsl:when test="$rep_visione_completa">
						<xsl:text>return queryplain('</xsl:text>
						<xsl:value-of select="$rep_visione_completa" />
						<xsl:text>');</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>return queryplain();</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		Federico 25/08/09: introdotto id ("hxp-query-action-findplain_no_refine") per ricerche senza raffinamento (anche se selId  valorizzata) [EB 116]
	-->
	<xsl:template name="findplain_no_refine">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="rep_visione_completa">
			<xsl:for-each select="$hxpdata//repertorio/tabella[@vis='completa']">
				<xsl:value-of select="concat(current()/../@codice,'-',current()/@tipo,'|')" />
			</xsl:for-each>
		</xsl:variable>

		<xsl:copy>
            <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']">
            	<xsl:with-param name="blockPath" select="$blockPath"/>
            	<xsl:with-param name="blockData" select="$blockData" />
            </xsl:apply-templates>

			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick" /><xsl:text>;</xsl:text>
				<xsl:choose>
					<xsl:when test="$rep_visione_completa">
						<xsl:text>return findplain('</xsl:text>
						<xsl:value-of select="$rep_visione_completa" />
						<xsl:text>');</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>return findplain();</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="refinequeryplain">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return refineQuery();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Reset della form di ricerca: id="hxp-query-action-resetq" -->
	<xsl:template name="queryreset">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return resetQuery();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Ricerca su intero archivio: id="hxp-query-action-findq" -->
	<xsl:template name="queryq">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                         -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryq();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Ricerca sulla selezione corrente (query and sele): id="hxp-query-action-findqas" -->
	<xsl:template name="queryqas">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>save_last_query();return queryqas();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Ricerca escludendo i risultati precedenti (query and not sele): id="hxp-query-action-findqans" -->
	<xsl:template name="queryqans">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryqans();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Ricerca escludendo i nuovi termini (not query and sele): id="hxp-query-action-findnqas" -->
	<xsl:template name="querynqas">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return querynqas();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Per uso interno (rimozione di un ramo dell'albero di ricerca) -->
	<xsl:template name="removebranch">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="noRedraw" select="0" />
		<xsl:choose>
			<xsl:when test="$noRedraw or (count($hxpdata//ricerca)>1)">
				<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
					<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
					</xsl:for-each>
                                -->
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return queryerase();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Taglio dell'albero di ricerca: id="hxp-query-action-removebranch-noredraw" -->
	<xsl:template name="removebranch-noredraw">
		<xsl:call-template name="removebranch">
			<xsl:with-param name="noRedraw" select="1" />
		</xsl:call-template>
	</xsl:template>

	<!-- Per uso interno (undo della rimozione di un ramo dell'albero di ricerca) -->
	<xsl:template name="undoremovebranch">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return undoerase();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Undo del taglio dell'albero di ricerca: id="hxp-query-action-removebranch-undoredraw" -->
	<xsl:template name="removebranch-undoredraw">
		<xsl:call-template name="undoremovebranch" />
	</xsl:template>

	<!-- Per uso interno (rimozione di un ramo dell'albero di ricerca - con undo) -->
	<xsl:template name="doundoremovebranch">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return doundoerase(event);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Taglio dell'albero di ricerca - con undo: id="hxp-query-action-removebranch-doundoredraw" -->
	<xsl:template name="removebranch-doundoredraw">
		<xsl:call-template name="doundoremovebranch" />
	</xsl:template>

	<!-- Apre la finestra dei titoli: id="hxp-query-action-titles" -->
	<xsl:template name="querytitles">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="selid" select="$blockData/@uid" />
		<xsl:choose>
			<xsl:when test="$selid!='' and number($blockData/@totale)>0">
				<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
					<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
					</xsl:for-each>
                                -->
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return mostraTitoli('</xsl:text>
						<xsl:value-of select="$selid" />
						<xsl:text>',false,'</xsl:text>
						<xsl:apply-templates select="$blockData" mode="getArch" />
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Apre la finestra dei titoli in una nuova finestra: id="hxp-query-action-childtitles" -->
	<xsl:template name="querychildtitles">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="selid" select="$blockData/@uid" />
		<xsl:choose>
			<xsl:when test="$selid!='' and number($blockData/@totale)>0">
				<!-- <xsl:text>[</xsl:text> -->
				<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
					<!-- 23/09/2005 Gregorio -->
					<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
					<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
					</xsl:for-each>
                                -->
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return mostraTitoli('</xsl:text>
						<xsl:value-of select="$selid" />
						<xsl:text>',true,'</xsl:text>
						<xsl:apply-templates select="$blockData" mode="getArch" />
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
				<!-- <xsl:text>]</xsl:text> -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="number($blockData/@totale)>0">
					<xsl:text>[</xsl:text>
				</xsl:if>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
				<xsl:if test="number($blockData/@totale)>0">
					<xsl:text>]</xsl:text>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Apertura della pagina degli indici(vocabolario):
	id="hxp-query-action-idx-'nome'-
	'posizionamento',
	'aspetto finestra'"
	Per la lista delle configurazioni predefinite dell'aspetto finestra consultare la funzione
	getAppearance() in query.js
	-->
	<xsl:template name="queryidx">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parms" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="./@onclick" />
				<xsl:text>;openIndex(getForm('theForm'),</xsl:text>

				<xsl:call-template name="hxpstring">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
					<xsl:with-param name="thestring" select="$parms"/>
				</xsl:call-template>
<!--
				<xsl:value-of select="$parms" />
-->
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- ??? -->
	<xsl:template name="querylookup">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parms" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>queryLookup(</xsl:text>
				<xsl:value-of select="$parms" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Per utilizzare il browser gerarchico dalla pagina di ricerca e' obbligatorio
	   aggiungere questo id in una form chiamata hbfeeder
		id="hxp-query-action-hbfeeder"
	 -->
	<xsl:template name="queryhbfeeder">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='action']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="action" />
			<input type="hidden" name="verbo" value="hierBrowser" />
			<input type="hidden" name="hierStatus" value="{$hxpdata/@hierStatus}" />
			<input type="hidden" name="host" value="{$hxpdata/@host}" />
			<input type="hidden" name="port" value="{$hxpdata/@port}" />
			<input type="hidden" name="db" value="{$hxpdata/@db}" />
			<input type="hidden" name="user" value="{$hxpdata/@user}" />
			<input type="hidden" name="pwd" value="{$hxpdata/@pwd}" />
			<input type="hidden" name="docStart" value="{$hxpdata/@docStart}" />
			<input type="hidden" name="opt" value="{$hxpdata/@opt}" />
			<input type="hidden" name="docToggle" value="0" />
			<input type="hidden" name="hierCount" value="{$hxpdata/@hierCount}" />
			<input type="hidden" name="transformJava" value="{$hxpdata/@transformJava}" />
			<!-- specifici -->
			<xsl:call-template name="contextcustom">
				<xsl:with-param name="specName" select="'beforeend'"/>
			</xsl:call-template>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Apertura pagina scelta multiarchivio: id="hxp-query-action-multiarch" -->
	<xsl:template name="querymultiarch">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return chooseArchs(document['indexForm']);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Apertura pagina raccolte: id="hxp-query-action-raccolte" -->
	<xsl:template name="queryraccolte">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>openCollections()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Torna alla pagina di ricerca (utile se si e' in pagina di ricerca specifica di tabella):
	id="hxp-query-action-querypage" -->
	<xsl:template name="querypage">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryPage()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Vai alla pagina di query specifica di tabella: id="hxp-query-action-gototableq-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="querygototableq">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                                <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<!-- Modifica richiesta da Gregorio in data 10/08/2004 -->
				<xsl:value-of select="@onclick" /><xsl:text>;</xsl:text>
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


		<xsl:template name="querygototablegen">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<!-- Modifica richiesta da Gregorio in data 10/08/2004 -->
				<xsl:value-of select="@onclick" /><xsl:text>;</xsl:text>
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>','true')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vai alla pagina di inserimento specifico di tabella: id="hxp-query-action-instabledoc-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di inserimento della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="queryinstabledoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
            <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                          <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
				<xsl:text>return insTableDoc('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Apre la pagina del browser gerarchico
	id="hxp-query-action-hier-(radice),(toggle),(ndocs)"
	(radice) = numero fisico del documento radice
	(toggle) = true, se si vuole espandere subito la radice, false altrimenti
	(ndocs) = numero di righe max per pagina
	-->
	<xsl:template name="queryhier">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="physDoc" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return paginaBrowse(</xsl:text><xsl:value-of select="$physDoc"/><xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Apertura pagina thesaurus: id="hxp-query-action-ths" -->
	<xsl:template name="queryths">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parms" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="./@onclick" />
				<xsl:text>;openThes(document.theForm,</xsl:text>

				<xsl:call-template name="hxpstring">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
					<xsl:with-param name="thestring" select="$parms"/>
				</xsl:call-template>
<!--
				<xsl:value-of select="$parms" />
-->
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- ??? -->
	<xsl:template name="queryrange">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parms" select="''" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>ActivateRange(document.theForm,</xsl:text>
				<xsl:value-of select="$parms" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Per uso interno -->
	<xsl:template match="*" mode="getArch">
		<xsl:choose>
			<xsl:when test="(''=normalize-space(@riferimento)) and (''=normalize-space(@descr))">
				<xsl:value-of select="normalize-space(*[1]/@descr)" />
				<xsl:for-each select="*[1&lt;position()]">
					<xsl:text>,</xsl:text>
					<xsl:value-of select="normalize-space(@descr)" />
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="normalize-space(ancestor-or-self::*[(''=normalize-space(@riferimento)) and (''!=normalize-space(@descr))]/@descr)" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Imposta la selezione corrente (albero di ricerca): id="hxp-query-action-setsel" -->
	<xsl:template name="querysetsel">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:variable name="selid" select="$blockData/@uid" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return impostaSelezioneCorrente('</xsl:text>
				<xsl:value-of select="$selid" />
				<xsl:text>',event,'</xsl:text>
				<xsl:apply-templates select="$blockData" mode="getArch" />
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-query-data-insrep", che stabilisce se l'utente ha diritto di Inserimento su almeno
			 un repertorio
	-->
	<xsl:template name="queryinsrep">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:if test="$hxpdata//funzionalita_disponibili/@inserimento_rep='true'">
			<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
				<!-- 23/09/2005 Gregorio -->
				<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
				<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
				</xsl:for-each>
                                -->
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-query-data-visrep", che stabilisce se l'utente ha diritto di Visione o
			 Visione completa su almeno un repertorio
	-->
	<xsl:template name="queryvisrep">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:if test="$hxpdata//funzionalita_disponibili/@visione_rep='true'">
			<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
				<!-- 23/09/2005 Gregorio -->
				<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
				<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
				</xsl:for-each>
                                -->
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-query-data-rep@<nometabella>-<tag>":
		 se <tag> = 'option', crea una option per ogni repertorio su cui l'utente ha diritto
			 di visione/visione completa e che appartiene alla tabella specificata da <nometabella>.
			 Se <nometabella> = 'globale', non vengono di fatto applicate restrizioni di tabella.
			 L'option creata ha come nome la descrizione del repertorio comprensiva di eventuale specificazione
			 legata alla tabella di appartenenza, e come valore il 'codice_rep-codice_tabella'.
		 se <tag> = 'checkbox', replica il campo di input cui  applicato per ogni repertorio su cui l'utente
		 	 ha diritto di visione/visione completa e che appartiene alla tabella specificata da <nometabella>.
			 Se <nometabella> = 'globale', non vengono di fatto applicate restrizioni di tabella.
			 L'input creato  affiancato dalla descrizione del repertorio comprensiva di eventuale specificazione
			 legata alla tabella di appartenenza, e come valore il 'codice_rep-codice_tabella'.
	-->
	<xsl:template name="queryreptag">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="ambito" select="''" />
		<xsl:param name="tag" select="''" />
		<xsl:variable name="tableRep">
			<xsl:choose>
				<xsl:when test="$blockData/@tipo='P'">
					<xsl:text>partenza</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='A'">
					<xsl:text>arrivo</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='I'">
					<xsl:text>interno</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='V'">
					<xsl:text>varie</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$ambito='globale' or $ambito=$tableRep">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="value">
					<xsl:value-of select="concat($blockData/../@codice,'-',$blockData/@tipo)" />
				</xsl:attribute>
				<xsl:if test="$tag='checkbox'">
					<xsl:variable name="functionArg">
						<xsl:text>custom_rep_da,custom_rep_a,custom_numeri_rep</xsl:text>
					</xsl:variable>
					<!--RW0052633 - fcossu - Campi ricerca per tipo repertorio -->
					<xsl:attribute name="onclick">
						<xsl:text>checkTipo(this); return disableRepNumber(this,'</xsl:text>
						<xsl:call-template name="toJSParam">
							<xsl:with-param name="testo" select="$functionArg" />
						</xsl:call-template>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
				</xsl:if>
				<xsl:value-of select="$blockData/../descrizione" />
				<xsl:if test="$blockData!=''">
					<xsl:value-of select="concat(' ',$blockData)" />
				</xsl:if>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-query-data-rep@<nometabella>-half<num>": seleziona, tra i
		 repertori che appartengono alla tabella specificata ('globale' per nessuna specificazione)
		 e su cui l'utente ha diritto di visione o visione completa, quelli che appartengono alla
		 <num> met dell'elenco.
		 <num> pu assumere solo i valori 1 e 2.
	-->
	<xsl:template name="queryrephalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="ambito" select="''" />
		<xsl:param name="side" select="''" />
		<xsl:variable name="tableRep">
			<xsl:choose>
				<xsl:when test="$blockData/@tipo='P'">
					<xsl:text>partenza</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='A'">
					<xsl:text>arrivo</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='I'">
					<xsl:text>interno</xsl:text>
				</xsl:when>
				<xsl:when test="$blockData/@tipo='V'">
					<xsl:text>varie</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="where">
			<xsl:choose>
				<xsl:when test="$ambito='globale'">
					<xsl:apply-templates mode="count" select="$hxpdata//listof_rep/repertorio/tabella">
						<xsl:with-param name="target" select="$blockData"/>
					</xsl:apply-templates>
				</xsl:when>
				<xsl:when test="$ambito=$tableRep">
					<xsl:apply-templates mode="count" select="$hxpdata//listof_rep/repertorio/tabella[@tipo=$blockData/@tipo]">
						<xsl:with-param name="target" select="$blockData"/>
					</xsl:apply-templates>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$ambito='globale' or $ambito=$tableRep">
			<xsl:variable name="actualSide">
				<xsl:choose>
					<xsl:when test="string-length(substring-before($where,'1+')) > string-length(substring-after($where,'1+'))">
						<xsl:text>2</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>1</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="$actualSide=$side">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
			</xsl:copy>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Copia l'elemento contenente l'id se la funzionalit specifica
	     corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	     id="hxp-query-action-enableFunctionality-(attributo da testare)"
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
				<!-- 23/09/2005 Gregorio -->
				<!--xsl:copy-of select="@*[name()!='id']" /-->
                         <!--
				<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
				</xsl:for-each>
                                -->
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 30/11/2005
		*
	 	* @param blockPath
	 	* @param blockData	contesto corrente nell'xml.
	 	* @param attrVal	valore dell'attributo da testare.
	 	*
	 	* Questo template copia l'elemento contenente l'id se la funzionalit specifica
	    * corrispondente non deve essere abilitata, ovvero se l'attributo da testare vale 'false' o non c'e'.
	    *
	    * id="hxp-query-action-disableFunctionality-(attributo da testare)"
	    *
	-->
	<xsl:template name="disableFunctionality">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />

		<xsl:if test="$attrVal='false' or $attrVal=''">
			<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
                         <!--
				<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
				</xsl:for-each>
                                -->
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Importazione di documenti: id="hxp-query-action-importDocs"
	La form che contiene questo id si deve chiamare hxpForm e il name e l'id dell'input type-file
	associato devono essere "importFile"
	-->
	<xsl:template name="queryimportdocs">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return importDocs();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Esportazione di documenti: id="hxp-query-action-exportDocs"
	La form che contiene questo id si deve chiamare hxpForm e il name e l'id dell'input type-file
	associato devono essere "exportDocs"
	-->
	<xsl:template name="queryexportdocs">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return exportDocs();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Ritorno dei path dei files "export & attachment":
		id="hxp-query-action-pathExpFiles"
	-->
	<xsl:template name="querypathexpfiles">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return getPathExpFiles();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Importazione del thesaurus: id="hxp-query-action-import TH"
	La form che contiene questo id si deve chiamare hxpForm e il name e l'id dell'input type-file
	associato devono essere "xxxx"
	-->
	<xsl:template name="queryimportth">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return importTH();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Esportazione del thesaurus: id="hxp-query-action-export TH"
	La form che contiene questo id si deve chiamare hxpForm e il name e l'id dell'input type-file
	associato devono essere "xxxx"
	-->
	<xsl:template name="queryexportth">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return exportTH();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Visualizza il thesauro: tutti in termini in relazione (secondo la relazione specificata)
	   	id="hxp-query-action-showthesrel-
	   	'(Relazione)',
	   	'(chiave),'
	   	'(primo termine della relazione)',
	   	'(alias)',
	   	'(estensione al thesauro facoltativo)',
	   	'(finestra apertura thesauro facoltativa, oppure:= 'SAME_WINDOW'o 'NEW_WINDOW')'"
	-->
	<xsl:template name="queryshowthesrel">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parameters" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return showthesRel(this,</xsl:text>
					<xsl:value-of select="$parameters" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Effettua un lookup su tesauro vincolato
	   	id="hxp-docedit-action-thVincolato-
	   	'(numero di titoli per pagina)',
	   	'(campo da cui prelevare valore)',
	   	'(radice)',
	   	'(relazione)',
	   	'(chiave)',
	   	'(codice del diritto di inserimento)',
	   	'(codice del diritto di cancellazione)'
	   	'(titolo della finestra)'"

		I codici dei diritti sono facoltativi, nel caso in cui ne venga specificato uno solo si assume che sia di inserimento
		Il numero di titoli per pagina puo' assumere il valore 'DEF' ovvero il valore di default.

		N.B il campo text (con onblur) e il pulsante che scatena il lookup devono essere fratelli (nell'html) e il campo
		deve essere il primo figlio del loro padre (neanche commenti prima sono permessi)
	-->
	<xsl:template name="querythvincolato">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parameters" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return thVincolato(this,</xsl:text>
				<xsl:call-template name="hxpstring">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
					<xsl:with-param name="thestring" select="$parameters"/>
				</xsl:call-template>
<!--
				<xsl:value-of select="$parameters"/>
-->
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Switch da modalit classica qbe alla modalit di ricerca tramite ql
	   id="hxp-query-action-qbeToQl'" -->
	<xsl:template name="queryqbetoql">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parameters" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return qbeToQl();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Switch da modalit di ricerca tramite ql alla modalit classica qbe
	   id="hxp-query-action-qlToQbe'" -->
	<xsl:template name="queryqltoqbe">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parameters" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return qlToQbe();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Switch da modalit di ricerca tramite ql alla modalit classica qbe
	   id="hxp-query-action-findplainWithPreviousBuiltPhrase'" -->
	<xsl:template name="queryplainWithPreviousBuiltPhrase">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="parameters" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return queryplainWithPreviouslyBuiltPhrase();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Coatruisce la frase di ricerca tramite findplain e effettua la stampa della selezione ottenuta
	   id="hxp-query-action-findAndPrint'" -->
	<xsl:template name="queryfindAndPrint">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return findAndPrint();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Nella visualizzazione delle tendine automatiche seleziona l'option corrente(elemento che contiene id)
	  nel caso in cui l'elemento option del contesto corrente ha attributo selected="selected"
	  id="hxp-query-action-tendinaSelectIfSelected"
	 -->
	<xsl:template name="queryTendinaSelectIfSelected">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
                         <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                                -->
			<xsl:if test="$blockData/@selected='selected'">
				<xsl:attribute name="selected">
					<xsl:text>selected</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Annulla il cambio password (esegue unlock del documento)
	   id="hxp-query-action-annulChangePwd'" -->
	<xsl:template name="queryAnnulChangePwd">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return annulChangePwd();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Conferma il cambio password
	   id="hxp-query-action-annulChangePwd'" -->
	<xsl:template name="queryConfirmChangePwd">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return confirmChangePwd();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Va alla pagina di cambio password
	   id="hxp-query-action-goToChangePwd'" -->
	<xsl:template name="querygoToChangePwd">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return goToChangePwd();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData xml generato dalla Response.
		* @param language lingua che deve essere selezionata.
		*
		* Template aggiunto da Federico il 10/11/2004: questo template  necessario per gestire gli id
		* "hxp-query-action-changeLanguage-<lingua>". Al posto dell'id viene inserita la chiamata alla
		* funzione javascript "changeLanguage" (definita nel file generico "query.js") che consente di
		* impostare la lingua specificata ("<lingua>").
	-->
	<xsl:template name="queryChangeLanguage">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="language" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return changeLanguage('</xsl:text>
				<xsl:value-of select="$language"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-query-action-... -->
	<xsl:template name="queryaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='getfile'">
				<xsl:call-template name="getfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='gotoPersonalView'">
				<xsl:call-template name="querygototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName">
						<xsl:choose>
							<xsl:when test="$blockData/@tipo='A'" >arrivo</xsl:when>
							<xsl:when test="$blockData/@tipo='P'" >partenza</xsl:when>
							<xsl:when test="$blockData/@tipo='I'" >interno</xsl:when>
							<xsl:when test="$blockData/@tipo='V'" >varie</xsl:when>
						</xsl:choose>#personalView=<xsl:value-of select="$blockData/../template"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<!-- RW0052062 - Raccomandate -->
			<xsl:when test="$value='gotoRep'">
				<xsl:call-template name="querygototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName">
						<xsl:choose>
							<xsl:when test="$blockData/@tipo='A'" >arrivo</xsl:when>
							<xsl:when test="$blockData/@tipo='P'" >partenza</xsl:when>
							<xsl:when test="$blockData/@tipo='I'" >interno</xsl:when>
							<xsl:when test="$blockData/@tipo='V'" >varie</xsl:when>
						</xsl:choose>#personalView=<xsl:value-of select="$blockData/../@template"/>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='goToChangePwd'">
				<xsl:call-template name="querygoToChangePwd">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='annulChangePwd'">
				<xsl:call-template name="queryAnnulChangePwd">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirmChangePwd'">
				<xsl:call-template name="queryConfirmChangePwd">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='tendinaSelectIfSelected'">
				<xsl:call-template name="queryTendinaSelectIfSelected">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findAndPrint'">
				<xsl:call-template name="queryfindAndPrint">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findplainWithPreviousBuiltPhrase'">
				<xsl:call-template name="queryplainWithPreviousBuiltPhrase">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='qlToQbe'">
				<xsl:call-template name="queryqltoqbe">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='qbeToQl'">
				<xsl:call-template name="queryqbetoql">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='showthesrel'">
				<xsl:call-template name="queryshowthesrel">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parameters" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='thVincolato'">
				<xsl:call-template name="querythvincolato">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parameters" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='gotoAdmTools'">
				<xsl:call-template name="querygototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="'adm_tools'" />
				</xsl:call-template>
			</xsl:when>

			<!-- import documents -->
			<xsl:when test="$value='importDocs'">
				<xsl:call-template name="queryimportdocs">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!-- export documents -->
			<xsl:when test="$value='exportDocs'">
				<xsl:call-template name="queryexportdocs">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!-- export documents ( path files "export & attachment" )-->
			<xsl:when test="$value='pathExpFiles'">
				<xsl:call-template name="querypathexpfiles">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!-- import thesaurus -->
			<xsl:when test="$value='importTH'">
				<xsl:call-template name="queryimportth">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!-- export thesaurus -->
			<xsl:when test="$value='exportTH'">
				<xsl:call-template name="queryexportth">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="substring-before($value,'-')='enableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 30/11/05: gestione id 'hxp-query-action-disableFunctionality-(attributo da testare)' -->
			<xsl:when test="substring-before($value,'-')='disableFunctionality'">
				<xsl:call-template name="disableFunctionality">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='blockDataEnableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$blockData">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findplain'">
				<xsl:call-template name="queryplain">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Federico 25/08/09: introdotto id ("hxp-query-action-findplain_no_refine") per ricerche senza raffinamento (anche se selId  valorizzata) [EB 116]
			-->
			<xsl:when test="$value='findplain_no_refine'">
				<xsl:call-template name="findplain_no_refine">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='refine'">
				<xsl:call-template name="refinequeryplain">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='resetq'"> <!-- reset della form di ricerca -->
				<xsl:call-template name="queryreset">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findq'"> <!-- query su tutto l'archivio -->
				<xsl:call-template name="queryq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findqas'"> <!-- query and sele (contorna selezione) -->
				<xsl:call-template name="queryqas">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findqans'"> <!-- query and not sele (esclude selezione) -->
				<xsl:call-template name="queryqans">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='findnqas'"> <!-- not query and sele -->
				<xsl:call-template name="querynqas">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='querylookup'"> <!-- hxp-query-action-querylookup-... -->
				<xsl:call-template name="querylookup">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parms" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='idx'"> <!-- hxp-query-action-idx-... -->
				<xsl:call-template name="queryidx">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parms" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='ths'"> <!-- hxp-query-action-ths-... -->
				<xsl:call-template name="queryths">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parms" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='range'"> <!-- hxp-query-action-range-... -->
				<xsl:call-template name="queryrange">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="parms" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='titles'">
				<xsl:call-template name="querytitles">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='childtitles'">
				<xsl:call-template name="querychildtitles">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removebranch'">
				<xsl:call-template name="removebranch">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removebranch-noredraw'">
				<xsl:call-template name="removebranch-noredraw">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removebranch-undoredraw'">
				<xsl:call-template name="removebranch-undoredraw">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removebranch-doundoredraw'">
				<xsl:call-template name="removebranch-doundoredraw">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='setsel'">
				<xsl:call-template name="querysetsel">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='hbfeeder'">
				<xsl:call-template name="queryhbfeeder">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='multiarch'">
				<xsl:call-template name="querymultiarch">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='raccolte'">
				<xsl:call-template name="queryraccolte">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='querypage'">
				<xsl:call-template name="querypage">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='gototableq'">
				<!--<xsl:variable name="whereToGo" select="substring-after($value,'-')" />
				<xsl:choose>
					<xsl:when test="contains($whereToGo,'@')">
						<xsl:call-template name="customgoto">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="modus" select="substring-before($whereToGo,'@')" />
							<xsl:with-param name="locus" select="substring-after($whereToGo,'@')" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>-->
						<xsl:call-template name="querygototableq">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="tableName" select="substring-after($value,'-')" />
						</xsl:call-template>
					<!--</xsl:otherwise>
				</xsl:choose>-->
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='gototablegen'">
						<xsl:call-template name="querygototablegen">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="tableName" select="substring-after($value,'-')" />
						</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='instabledoc'">
				<xsl:call-template name="queryinstabledoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='hier'">
				<xsl:call-template name="queryhier">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="physDoc" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Codice aggiunto da Federico il 10/11/2004: id per il cambiamento della lingua
				("hxp-query-action-changeLanguage-<lingua>").
			-->
			<xsl:when test="substring-before($value,'-')='changeLanguage'">
				<xsl:call-template name="queryChangeLanguage">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="language" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Smistamento dei template hxp-query-data-... -->
	<xsl:template name="querydata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='insrep'">
				<xsl:call-template name="queryinsrep">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='visrep'">
				<xsl:call-template name="queryvisrep">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'rep@') and contains($value,'-')">
				<xsl:variable name="specific" select="substring-after($value,'-')" />
				<xsl:choose>
					<xsl:when test="$specific='option' or $specific='checkbox'">
						<xsl:call-template name="queryreptag">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="ambito" select="substring-before(substring-after($value,'rep@'),'-')" />
							<xsl:with-param name="tag" select="$specific" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="starts-with($specific,'half')">
						<xsl:call-template name="queryrephalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="ambito" select="substring-before(substring-after($value,'rep@'),'-')" />
							<xsl:with-param name="side" select="substring-after($specific,'half')" />
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="$value='personalViewDescr'">
				<xsl:choose>
					<xsl:when test="name(current())='img'">
						<xsl:copy>
							<xsl:call-template name="attrparser">
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
							<xsl:if test="$blockData/../icona!=''">
								<xsl:attribute name="src">
									<xsl:value-of select="$blockData/../icona"/>
								</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="alt">
								<xsl:text>Ricerca </xsl:text>
								<xsl:value-of select="$blockData/../descrizione" />
								<xsl:if test="$blockData!=''">
									<xsl:text> </xsl:text>
									<xsl:value-of select="$blockData" />
								</xsl:if>
							</xsl:attribute>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy>
							<xsl:call-template name="attrparser">
								<xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
							<xsl:value-of select="$blockData/../descrizione" />
							<xsl:if test="$blockData!=''">
								<xsl:text> </xsl:text>
								<xsl:value-of select="$blockData" />
							</xsl:if>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- RW0052062 - Raccomandate -->
			<xsl:when test="$value='repDescr'">
				<xsl:choose>
					<xsl:when test="name(current())='img'">
						<xsl:copy>
							<!--xsl:copy-of select="@*[not(name()='id')]"/-->
							<xsl:call-template name="attrparser">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
							<xsl:if test="$blockData/../icona!=''">
								<xsl:attribute name="src">
									<xsl:value-of select="$blockData/../icona"/>
								</xsl:attribute>
							</xsl:if>
							<xsl:attribute name="alt">
								<xsl:text>Inserimento </xsl:text>
								<xsl:if test="$hxpdata/@dbTable!='@personalView'">
									<xsl:text>repertorio </xsl:text>
								</xsl:if>
								<xsl:value-of select="$blockData/../descrizione" />
								<xsl:if test="$blockData!=''">
									<xsl:text> </xsl:text>
									<xsl:value-of select="$blockData" />
								</xsl:if>
							</xsl:attribute>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:when>
					<xsl:otherwise>
						<xsl:copy>
							<!--xsl:copy-of select="@*[not(name()='id')]"/-->
							<xsl:call-template name="attrparser">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
							</xsl:call-template>
							<xsl:value-of select="$blockData/../descrizione" />
							<xsl:if test="$blockData!=''">
								<xsl:text> </xsl:text>
								<xsl:value-of select="$blockData" />
							</xsl:if>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl hxp-query-... da eseguire -->
	<xsl:template name="queryparser">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='action'"> <!-- hxp-query-action-... -->
				<xsl:call-template name="queryaction">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='data'"> <!-- hxp-query-data-... -->
				<!--
				<xsl:call-template name="hxpformatter">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
				-->
				<xsl:call-template name="querydata">
					<xsl:with-param name="value" select="substring-after($value,'-')" />
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='include'"> <!-- hxp-query-include-... -->
				<!-- non fa nulla (servono solo per includere un js solo se occorre) -->
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[starts-with(@id,'hxp')]" mode="template" name="hxparser">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='query'"> <!-- hxp-query-... -->
						<xsl:call-template name="queryparser">
							<xsl:with-param name="value" select="substring-after($value,'-')" />
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
                                        <xsl:apply-templates mode="template" select="@*"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /></xsl:apply-templates>
                                        <!--
					<xsl:for-each select="@*">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
                                        -->
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="*//*" mode="count">
		<xsl:param name="target" select="''"/>
			<xsl:choose>
				<xsl:when test="generate-id(current())=generate-id($target)">
					<xsl:text>1+</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>0+</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
	</xsl:template>


    <xsl:template match="*[@id='hxp-custom-hierarchy']">
		<script language="JavaScript"><xsl:value-of select="$jscode" /></script>
	</xsl:template>

</xsl:stylesheet>
