<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
				xmlns:fo="http://www.w3.org/1999/XSL/Format"
				xmlns:xw="http://www.3di.it/ns/xw-200203121136"
				xmlns:h="http://www.w3.org/HTML/1998/html4"
				exclude-result-prefixes="fo xw h"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->

	<!-- Escapa il carattere ' nella stringa selezionata (richiamato da xsl speficici)  -->
	<xsl:template match="@*" mode="quoted-value-of">
		<xsl:variable name="x">
			<xsl:call-template name="quote-occurrences">
				<xsl:with-param name="unquoted" select="string()" />
			</xsl:call-template>
		</xsl:variable>
		<xsl:call-template name="quote-occurrences">
			<xsl:with-param name="unquoted" select="$x" />
			<xsl:with-param name="occurrent">'</xsl:with-param>
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="quoteString">
		<xsl:param name="stringa" select="''" />
		<xsl:param name="occurrent">'</xsl:param>
		<xsl:variable name="x">
			<xsl:call-template name="quote-occurrences">
				<xsl:with-param name="unquoted" select="$stringa" />
			</xsl:call-template>
		</xsl:variable>
		<xsl:call-template name="quote-occurrences">
			<xsl:with-param name="unquoted" select="$x" />
			<xsl:with-param name="occurrent" select="$occurrent" />
		</xsl:call-template>
	</xsl:template>

	<xsl:template name="quote-occurrences">
		<xsl:param name="unquoted" />
		<xsl:param name="occurrent">\</xsl:param>
		<xsl:choose>
			<xsl:when test="contains($unquoted, $occurrent)">
				<xsl:value-of select='substring-before($unquoted, $occurrent)' />
				<xsl:text>\</xsl:text>
				<xsl:value-of select="$occurrent" />
				<xsl:call-template name="quote-occurrences">
					<xsl:with-param name="unquoted" select="substring-after($unquoted, $occurrent)" />
					<xsl:with-param name="occurrent" select="$occurrent" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$unquoted" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Trasforma $testo in una stringa valida come parametro Javasript (escapa ' e il newline) -->
	<xsl:template name="toJSParam">
		<xsl:param name="testo"/>
		<xsl:variable name="testoQuoted">
			<xsl:call-template name="quoteString">
				<xsl:with-param name="stringa" select="$testo"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:call-template name="do-replace">
			<xsl:with-param name="text" select="$testoQuoted"/>
			<xsl:with-param name="replace" select="'&#xa;'"/>
			<xsl:with-param name="by" select="'\n'"/>
		</xsl:call-template>
	</xsl:template>


	<!-- Trasforma $testo in una stringa formattata html(trasforma il newline in <br/> e mantiene gli spazi) -->
	<xsl:template name="toHtmlFormatted">
		<xsl:param name="testo"/>
		<xsl:variable name="spaced">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$testo"/>
				<xsl:with-param name="replace" select="'   '"/>
				<xsl:with-param name="by" select="'&#160;&#160;&#160;'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="newspaced">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$spaced"/>
				<xsl:with-param name="replace" select="'  '"/>
				<xsl:with-param name="by" select="'&#160;&#160;'"/>
			</xsl:call-template>
		</xsl:variable>

		<!--
			Federico 28/01/2005: in caso di generazione di un pdf ($hxpdata/@outContent='pdf') occorre
			chiamare il template 'newlineForFop' che sostituisce gli a capo con gli opportuni tag fop.
		-->
		<xsl:choose>
			<xsl:when test="$hxpdata/@outContent='pdf'">
				<xsl:call-template name="newlineForFop">
			  		<xsl:with-param name="text" select="$newspaced"/>
			 	</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<!--
					Federico 24/08/2004 (intervento per evidenziare i termini cercati in una query):
					occorre disabilitare l'escaping in output poich i br inseriti sono nella forma '&lt;br/&gt;' e
					il testo che si sta elaborando potrebbe contenere dell'html (per esempio degli <span class="">
					se viene effettuato l'highlighting dei termini cercati in una query).

					Federico 30/05/07: il 'disable-output-escaping="yes"' e' fonte di numerosi problemi,
					tra cui l'errata visualizzazione dei caratteri unicode.
					E' necessario eliminarlo ==> l'highlighting dei termini cercati dovra' essere rivisto
					(radicalmente...) [RW 0044555]
				-->
				<!--<xsl:variable name="textWithBr">-->
					<xsl:call-template name="newlineToBr">
						<xsl:with-param name="text" select="$newspaced"/>
					</xsl:call-template>
				<!--</xsl:variable>-->
				<!--<xsl:value-of select="$textWithBr" disable-output-escaping="yes"/>-->
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Rimpiazza il newline con un elemento html <br/> -->
	<xsl:template name="newlineToBr">
		<xsl:param name="text"/>
		<xsl:param name="replace" select="'&#xa;'"/>
		<xsl:choose>
			<xsl:when test="contains($text,$replace)">
				<xsl:value-of select="substring-before($text,$replace)"/>
				<!--
					Federico 24/08/2004 (intervento per evidenziare i termini cercati in una query):
					avendo disabilitato l'escaping in output (vedi template precedente), i br inseriti devono essere
					nella forma '&lt;br/&gt;' se no non vengono interpretati correttamente dal browser.

					Federico 30/05/07: il 'disable-output-escaping="yes"' (vedi template precedente) e'
					fonte di numerosi problemi, tra cui l'errata visualizzazione dei caratteri unicode.
					E' necessario eliminarlo ==> l'highlighting dei termini cercati dovra' essere rivisto
					(radicalmente...) [RW 0044555]
				-->
				<br/>
				<!--&lt;br/&gt;-->
				<xsl:call-template name="newlineToBr">
					<xsl:with-param name="text" select="substring-after($text,$replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini - fgr
		*
		* @version 1.0
		*
		* @param text testo da esaminare
		* @param replace (opzionale) stringa di a capo da sostituire
		*
		* Questo template sostituisce tutti gli a capo con gli opportuni tag FOP.
	-->
	<xsl:template name="newlineForFop">
		<xsl:param name="text"/>
		<xsl:param name="replace" select="'&#xa;'"/>

		<xsl:choose>
			<xsl:when test="contains($text,$replace)">
				<xsl:value-of select="substring-before($text,$replace)"/>
				<!--
					i seguenti tag sostituiscono '<fo:block role="html:br"/>' che inspiegabilmente non
					fa quello che dovrebbe.
				-->
                <fo:block role="html:div">
					<fo:inline role="html:span">&#160;</fo:inline>
				</fo:block>
				<xsl:call-template name="newlineForFop">
					<xsl:with-param name="text" select="substring-after($text,$replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Escapa una stringa in maniera che sia una URL valida -->
	<xsl:template name="escapeURL">
		<xsl:param name="url"/>
        <!-- fabio -->
		<xsl:variable name="escapedId-1">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$url"/>
				<xsl:with-param name="replace" select="'%'"/>
				<xsl:with-param name="by" select="'%25'"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedId0">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId-1"/>
				<xsl:with-param name="replace" select="'&amp;'"/>
				<xsl:with-param name="by" select="'%26'"/>
			</xsl:call-template>
		</xsl:variable>
        <!-- /fabio -->
		<xsl:variable name="escapedId">
			<xsl:call-template name="do-replace">
                                <!--
				<xsl:with-param name="text" select="$url"/>
                                -->
				<xsl:with-param name="text" select="$escapedId0"/>
				<xsl:with-param name="replace" select="'+'"/>
				<xsl:with-param name="by" select="'%2b'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId1">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId"/>
				<xsl:with-param name="replace" select="'*'"/>
				<xsl:with-param name="by" select="'%2a'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId2">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId1"/>
				<xsl:with-param name="replace" select="'@'"/>
				<xsl:with-param name="by" select="'%40'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId3">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId2"/>
				<xsl:with-param name="replace" select="'-'"/>
				<xsl:with-param name="by" select="'%2d'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId4">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId3"/>
				<xsl:with-param name="replace" select="'_'"/>
				<xsl:with-param name="by" select="'%5f'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId5">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId4"/>
				<xsl:with-param name="replace" select="'.'"/>
				<xsl:with-param name="by" select="'%2e'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId6">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId5"/>
				<xsl:with-param name="replace" select="'='"/>
				<xsl:with-param name="by" select="'%3d'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId7">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId6"/>
				<xsl:with-param name="replace" select="'?'"/>
				<xsl:with-param name="by" select="'%3f'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="escapedId8">
			<xsl:call-template name="do-replace">
				<xsl:with-param name="text" select="$escapedId7"/>
				<xsl:with-param name="replace" select="' '"/>
				<xsl:with-param name="by" select="'%20'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:value-of select="$escapedId8"/>
	</xsl:template>

 <!-- Effettua il replace di una stringa -->
 <xsl:template name="do-replace">
  <xsl:param name="text"/>
  <xsl:param name="replace"/>
  <xsl:param name="by"/>
  <xsl:choose>
   <xsl:when test="contains($text,$replace)">
    <xsl:value-of select="substring-before($text,$replace)"/>
    <xsl:value-of select="$by"/>
    <xsl:call-template name="do-replace">
     <xsl:with-param name="text" select="substring-after($text,$replace)"/>
     <xsl:with-param name="replace" select="$replace"/>
     <xsl:with-param name="by" select="$by"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$text"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="qunescape">
  <xsl:param name="data" select="''"/>
  <xsl:variable name="after" select="substring-after($data,'%')"/>
  <xsl:choose>
   <xsl:when test="string-length($after)=0"><xsl:value-of select="$data"/></xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="substring-before($data,'%')"/>
    <xsl:variable name="digits" select="substring($after,1,2)"/>
    <xsl:choose>
     <xsl:when test="$digits='29'">)</xsl:when>
     <xsl:when test="$digits='2C' or $digits='2c'">,</xsl:when>
     <xsl:when test="$digits='3A' or $digits='3a'">:</xsl:when>
     <xsl:otherwise><xsl:value-of select="concat('&amp;#x',$digits,';')" disable-output-escaping="yes"/></xsl:otherwise>
    </xsl:choose>
    <xsl:call-template name="qunescape">
     <xsl:with-param name="data" select="substring($after,3)"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="getcustomparam">
  <xsl:param name="param" select="''"/>
   <xsl:call-template name="qunescape">
    <xsl:with-param name="data" select="substring-before(substring-after($hxpdata/@_cd,concat('&amp;',$param,'=')),'&amp;')"/>
   </xsl:call-template>
 </xsl:template>

 <!-- Formattazione della data.
 Formati di input riconosciuti: aaaammgg, ggmmaaaa, aaaa/mm/gg, gg/mm/aaaa
 Restituisce la data nel formato aaaammgg -->
 <xsl:template name="datenormalizer">
  <xsl:param name="mode" select="''" />
  <xsl:param name="datas" select="." />
  <xsl:if test="string-length($datas) > 0">
     <xsl:choose>
      <xsl:when test="string-length($datas)=10"> <!-- ci sono separatori -->
       <xsl:choose>
        <xsl:when test="string-length(substring-before($datas,'/'))=4
                        or string-length(substring-before($datas,'/'))=4">
         <!-- data in formato aaaa/mm/gg -->
         <xsl:value-of select="substring($datas,1,4)" />
         <xsl:value-of select="substring($datas,6,2)" />
         <xsl:value-of select="substring($datas,9,2)" />
        </xsl:when>
        <xsl:otherwise>
         <!-- data in formato gg/mm/aaaa -->
         <xsl:value-of select="substring($datas,7,4)" />
         <xsl:value-of select="substring($datas,4,2)" />
         <xsl:value-of select="substring($datas,1,2)" />
        </xsl:otherwise>
       </xsl:choose>
      </xsl:when>
      <xsl:when test="13>number(substring($datas,5,2))">
       <!-- data in formato aaaammgg -->
       <xsl:value-of select="$datas" />
      </xsl:when>
      <xsl:otherwise>
       <!-- data in formato ggmmaaaa -->
       <xsl:value-of select="substring($datas,5,4)" />
       <xsl:value-of select="substring($datas,3,2)" />
       <xsl:value-of select="substring($datas,1,2)" />
      </xsl:otherwise>
     </xsl:choose>
  </xsl:if>
 </xsl:template>

</xsl:stylesheet>
