<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<!-- Gestione del range -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<!-- 
		Javascript da includere
		Nel caso di range di tipo text occorre inserire un id in uno span con la seguente forma:
			id="hxp-range-include-range". Il name del text deve essere 
			"range_(nome alias campo o chiave)_from" o 
			"range_(nome alias campo o chiave)_to" a seconda del tipo di estremo.
			(rangenum_ ... nel caso di range su campo numerico )
			Nel caso si voglia specificare il tipo di inclusione estremi dell'intervallo occorre inserire un
			campo hidden chiamato "range_(nome alias campo o chiave)_side" con value "incl" o "escl" per includere
			o meno gli estremi. E' possibile lasciare la scelta all'utente tramite un checkbox: se clicked 
			gli estremi vengono esclusi.
			Ad ogni modo (se non si inserisce questo campo) il valore di default e' estremi compresi.
			Per inserire il controllo della correttezza e consistenza dei valori inserire occorre aggiungere
			un id="hxp-range-rangedatacheck" o id="hxp-range-rangenumcheck" (a seconda che il range sia di tipo
			data o semplicemente numerico) a ogni text range.
	-->
	<xsl:template name="rangejslist">
		<xsl:if test="count(//*[@id='hxp-range-include-range'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/range.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/chkdate.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/isNumeric.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>						

			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/msg/rangeMSG.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/msg/chkdateMSG.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/msg/isNumericMSG.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>
		
		<!--
			Aggiunto da Federico il 18/08/2004.
			Se vengono rilevati degli id 'hxp-range-include-daterange' (si veda building block "inputDate_q"),
			viene incluso nell'head della pagina il file javascript per la gestione del div della ricerca per
			intervallo di date.
		-->
		<xsl:if test="count(//*[@id='hxp-range-include-daterange'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/date_range.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>
	</xsl:template>

	<!-- Controllo sui dati per range di tipo data -->
	<xsl:template name="rangedatacheck">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'data', true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Controllo sui dati per range di tipo data ma con campi di nome diverso -->
	<xsl:template name="rangedatadifferentfieldcheck">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'data', true, true, true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Controllo sui dati per range di tipo data ma con campi di nome diverso ma senza ripetizione -->
	<xsl:template name="rangedatadifferentfieldchecknorepetition">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'data', true, true, true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Controllo sui dati per range di tipo numerico -->	
	<xsl:template name="rangenumcheck">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'num', true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Controllo sui dati per range di tipo numerico ma con campi di nome diverso -->
	<xsl:template name="rangenumdifferentfieldcheck">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'num', true, true, true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Controllo sui dati per range di tipo numerico ma con campi di nome diverso ma senza ripetizione -->
	<xsl:template name="rangenumdifferentfieldchecknorepetition">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onblur">
				<xsl:text>return chkRange(this, 'num', true, true, true);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath" />
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template name="hxprangehandler">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$value='rangedatacheck'"> <!-- hxp-range-rangedatacheck -->
				<xsl:call-template name="rangedatacheck">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rangedatadifferentfieldcheck'"> <!-- hxp-range-rangedatadifferentfieldcheck -->
				<xsl:call-template name="rangedatadifferentfieldcheck">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rangedatadifferentfieldcheck'"> <!-- hxp-range-rangedatadifferentfieldchecknorepetition -->
				<xsl:call-template name="rangedatadifferentfieldchecknorepetition">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rangenumcheck'"> <!-- hxp-range-rangenumcheck -->
				<xsl:call-template name="rangenumcheck">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rangenumdifferentfieldcheck'"> <!-- hxp-range-rangenumdifferentfieldcheck -->
				<xsl:call-template name="rangenumdifferentfieldcheck">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rangenumdifferentfieldchecknorepetition'"> <!-- hxp-range-rangenumdifferentfieldchecknorepetition -->
				<xsl:call-template name="rangenumdifferentfieldchecknorepetition">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='include'"> <!-- hxp-range-include-... -->
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="blockPath" select="$blockPath" />
					</xsl:call-template>					
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="blockPath" select="$blockPath" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
