<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Aggiunta di riferimenti interni -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<!-- importante che sia primo js incluso!!! -->
			<xsl:attribute name="src">../../../formatter/html/data/js/docEdit.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/msg/rifinterniMSG.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/rifinterni.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/xml.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/dom-drag.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<!--
			Federico 11/05/07: SOVRASCRIVE le function di lookup generico definite in docEdit.js per
			avere un lookup generico per i ruoli [RW 0043770]
		-->
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/rifinterni-lookup-generico.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" id="hxpForm" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
			<input type="hidden" name="rifInt" value="{$hxpdata/@rifInt}" /> <!-- esclusivo per i riferimenti interni -->

			<!-- Federico 10/05/07: aggiunte tuple per il lookup [RW 0043770] -->
			<input type="hidden" name="lookup_titolo" value="" />
			<input type="hidden" name="lookup_campi" value="" />
			<input type="hidden" name="lookup_fieldVal" value="" />
			<input type="hidden" name="lookup_alias" value="" />
			<input type="hidden" name="lookup_xq" value="" />
			<input type="hidden" name="lookup_new" value="{$hxpdata/@lookup_new}" />
			<input type="hidden" name="lookup_db" value="" />
			<input type="hidden" name="qord" value="" /> <!-- per lookup -->
			<input type="hidden" name="sendMail" value="" /> <!-- sendMail -->
			<!-- RW0054196 - fcossu - Dexia -->
			<input type="hidden" name="qext_rifint_lookup" value="{$hxpdata/@qext_rifint_lookup}" />

			<!-- per rif_interni -->
			<xsl:element name="input">
				<xsl:attribute name="type">hidden</xsl:attribute>
				<xsl:attribute name="name">countRifs</xsl:attribute>
				<xsl:attribute name="value"><xsl:value-of select="count($hxpdata//rif_interni/rif)"/></xsl:attribute>
			</xsl:element>
		</form>
	</xsl:template>

	<!--

   Implementazione dei singoli template action

	-->


	<!-- Chiude la finestra dei riferimenti interni
	   id="hxp-rifint-action-closeRifInt" -->
	<xsl:template name="rifintcloseRifInt">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return closeRifInt();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Conferma l'aggiunta dei riferimenti interni
	   id="hxp-rifint-action-confirmRifInt" -->
	<xsl:template name="rifintconfirmRifInt">
		<xsl:param name="blockData" select="$hxpdata" />
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return confirmRifInt();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Aggiunge una istanza: id="hxp-rifint-action-addinstance"-->
	<xsl:template name="rifintaddinstance">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="instancePrefix" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
				<xsl:text>return addInstance('</xsl:text>
				<xsl:value-of select="$instancePrefix" />
				<xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Rimuove una istanza: id="hxp-rifint-action-removeinstance"-->
	<xsl:template name="rifintremoveinstance">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="instanceId" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
				<xsl:text>return removeInstance('</xsl:text>
				<xsl:value-of select="$instanceId" />
				<xsl:text>',this)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Effettua lookup su ufficio nel caso di riferimento_interno
	id="hxp-rifint-rifintlookup-'(nome input html corrispondente)','(ordinamento)','(tipo)'"
	(tipo) assume i valori 'nome_uff' o 'nome_persona'.

	Occorre inserire nel template html per ogni elemento di lookup 3 input hidden:
	1) Costruzione del titolo da visualizzare nella pagina del lookup.
      name="lookup_titolo_(nome corrispondente input)" value="(costruzione titolo per xw)"
	-->
	<xsl:template name="rifintrifintlookup">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
					<xsl:text>return rifintLookup(this,</xsl:text>
					<xsl:value-of select="$params"/>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Effettua lookup su ufficio nel caso di riferimento_interno  e di evento onblur
	id="hxp-rifint-rifintonblurlookup-(tipo)"
	(tipo) assume i valori 'nome_uff' o 'nome_persona'.
	-->
	<xsl:template name="rifintrifintonblurlookup">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onblur">
					<xsl:text>return rifintOnblurLookup(this,</xsl:text>
					<xsl:value-of select="$params"/>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>


	<!-- Copia l'elemento contenente l'id se la funzionalit specifica
	     corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	     id="hxp-rifint-action-enableFunctionality-(attributo da testare)"
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
					<xsl:if test="contains(../@name,'@intervento') and $blockData/@intervento='si'">
						<xsl:attribute name="checked">checked</xsl:attribute>
					</xsl:if>
				</xsl:for-each>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Smistamento dei template hxp-rifint-data-... -->
	<xsl:template name="rifintdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
	</xsl:template>


	<xsl:template name="rifintufficiocompleto">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:copy>
			<xsl:call-template name="attrparser">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
			<xsl:attribute name="href">javascript:void(0);</xsl:attribute>
			<xsl:attribute name="onclick">
				<!-- RW0047596 fcossu 06/12/2007 -->
				<xsl:text>checkTutti(this);</xsl:text>
				<xsl:text>return ufficioCompleto(this);</xsl:text>
			</xsl:attribute>
			<xsl:if test="starts-with($blockData/@cod_persona,'tutti')">
				<xsl:attribute name="checked">
					<xsl:text>cheked</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* Gestione id "hxp-docedit-action-rifint_block_display-TIPO_UFF_VALUE$NEW_DIV_ID".
		* Il template consente di mostrare/nascondere le sezioni relative a Ufficio-persona/Ruolo
		* a seconda di cosa contiene l'ufficio di un riferimento interno (un ufficio o un ruolo) [RW 0043770].
		*
		* @param tipoUff-id E' la parte "TIPO_UFF_VALUE$NEW_DIV_ID".
		* @param blockData  E' il contesto xml corrente.
		*
	-->
	<xsl:template name="rifintBlockDisplay">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tipoUff-id" select="''"/>

		<xsl:variable name="tipoUffTestVal" select="substring-before($tipoUff-id,'$')"/>
		<xsl:variable name="newId" select="substring-after($tipoUff-id,'$')"/>
		<xsl:variable name="tipoUffVal" select="$blockData/@tipo_uff"/>

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>

			<xsl:attribute name="id">
				<xsl:value-of select="$newId"/>
			</xsl:attribute>

			<xsl:choose>
				<xsl:when test="$tipoUffVal=$tipoUffTestVal or ($tipoUffTestVal='ufficio' and string-length($tipoUffVal)=0)">
					<xsl:attribute name="style">
						<xsl:text>display: block;</xsl:text>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="style">
						<xsl:text>display: none;</xsl:text>
					</xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>

			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		Federico 10/05/07: ricopiato da docEdit.xsl per lookup sui ruoli [RW 0043770]

		Apre una finestra di lookup:

			Caso multistanza:
				1) il campo di input e il pulsante di lookup devono essere FRATELLI
				2) il campo di input deve essere il primo figlio del proprio padre
				3) tutti i campi di riempimento devono essere fratelli


	     id="hxp-docedt-action-lookup-'(nome alias)','(nome input html corrispondente)','(ordinamento)'"
	         oppure
	     id="hxp-docedt-action-lookup-'(nome alias)','(nome input html corrispondente)','(ordinamento)','(nome alias1)'"
	     Questa seconda forma  da utilizzare nel caso in cui nel lookup la prima ricerca utilizza (nome alias)
	     e la seconda e la terza utilizzano (nome alias1). Ad esempio se (nome alias)  una chiave concatenata
	     e (nome alias1) e' una chiave in cui confluisce il contenuto di un'altra chiave.

	     N.B: (nome alias) e (nome alias1) possono essere alias separati dal carattere virgola ','

	Occorre inserire nel template html per ogni elemento di lookup 3 input hidden:
	1) Costruzione del titolo da visualizzare nella pagina del lookup.
      name="lookup_titolo_(nome corrispondente input)" value="(costruzione titolo per xw)"
	2) Costruzione del titolo per gli elementi da restituire (non visualizzati)
      name="lookup_campi_(nome corrispondente input)" value="(nome_input)=(titolo xw) ; (nome_input)=(titolo xw)..."
	3 - facoltativo) Extra query
      name="lookup_xq_(nome corrispondente input)"	value="(query)" query che viene messa in and con la ricerca
      sull'alias
	4 - facoltativo) db da utilizzare
      name="lookup_db_(nome corrispondente input)"	value="(db)" se non presente si utilizza il db corrente
   5 - facoltativo ) eventuale possibilit di inserire record da maschera di lookup
      name="lookup_new_(nome corrispondente input)"
      value="db=(db);dbTable=(dbTable);fillField=(path);rightCode=(code)" con
      (db) = nome del db della tabella da inserire
      (dbTable) = nome della tabella da inserire ...deve corrispondere alla parte del template html...
      (path) = nome del campo da riempire in automatico in inserimento (deve corrispondere al name di un qualche
               campo del template di inserimento che si utilizza, con in testa il nome del nodo primario).
               Ad esempio se nel template html per l'inserimento di un comnue esiste il campo '.@nome' e se il nodo
               primario di un documento comune  'comune' allora (path) assumen il valore 'comune.@nome'
      (code) = FACOLTATIVO serve per la abilitazione del pulsante di inserimento solo se utente dispone
               del codice del diritto indicato.
      N.B -> l'ordine dei parametri e' importante e sono tutti obbligatori.

		E' assolutamente consigliato che il pulsante per tornare al menu principale sia disabilitato nel caso di
		inserimento proveniente da maschera di lookup (magari rimpiazzato da un pulsante per chiudere la finestra).
		Per questo scopo si utilizzino gli id="hxp-docedit-data-notFromLookup" e id="hxp-docedit-data-fromLookup".
   -->
	<xsl:template name="lookup">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="$hxpdata" />
			<xsl:copy>
				<!--xsl:copy-of select="@*[name()!='id']" /-->
				<xsl:call-template name="attrparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick"/><xsl:text>;</xsl:text>
					<xsl:text>return lookup(this,</xsl:text>

				<xsl:choose>
					<xsl:when test="contains($params,'$hxp_instance()') or contains($params,'$hxp_fatherinstance()')">
						<xsl:value-of select="$params"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpstring">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
							<xsl:with-param name="thestring" select="$params"/>
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>

					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>


	<!--
		Federico 10/05/07: ricopiato da docEdit.xsl per lookup sui ruoli [RW 0043770]

		Gestione del lookup per un campo di input nel caso di onblur.

			Caso multistanza:
				1) il campo di input e il pulsante di lookup devono essere FRATELLI
				2) il campo di input deve essere il primo figlio del proprio padre
				3) tutti i campi di riempimento devono essere fratelli


		  id="hxp-docedt-action-onblurlookup-'(nome alias)','(nome input html corrispondente)','(ordinamento)'"
	        oppure
	     id="hxp-docedt-action-onblurlookup-'(nome alias)','(nome input html corrispondente)','(ordinamento)','(nome alias1)'"
	     Questa seconda forma  da utilizzare nel caso in cui nel lookup la prima ricerca utilizza (nome alias)
	     e la seconda e la terza utilizzano (nome alias1). Ad esempio se (nome alias)  una chiave concatenata
	     e (nome alias1) e' una chiave in cui confluisce il contenuto di un'altra chiave.

        N.B: (nome alias) e (nome alias1) possono essere alias separati dal carattere virgola ','

	     Vedi "doceditlookup" per ulteriori informazioni.
	-->
	<xsl:template name="onblurlookup">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="$hxpdata" />
		<xsl:param name="instPosDep" select="''"/>
			<xsl:copy>
				<!--
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="instPosDep" select="$instPosDep"/>
					</xsl:call-template>
				</xsl:for-each>
				-->
				<xsl:call-template name="attrparser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="instPosDep" select="$instPosDep"/>
				</xsl:call-template>
				<xsl:attribute name="onblur">
					<xsl:text>return onblurLookup(this,</xsl:text>
					<xsl:value-of select="$params"/>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-rifint-action-... -->
	<xsl:template name="rifintaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="instPosDep" select="''"/>

		<xsl:choose>
			<xsl:when test="$value='ufficioCompleto'">
				<xsl:call-template name="rifintufficiocompleto">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='enableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='closeRifInt'">
				<xsl:call-template name="rifintcloseRifInt">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirmRifInt'">
				<xsl:call-template name="rifintconfirmRifInt">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='rifintlookup'">
				<xsl:call-template name="rifintrifintlookup">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='rifintonblurlookup'">
				<xsl:call-template name="rifintrifintonblurlookup">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='addinstance'">
				<xsl:call-template name="rifintaddinstance">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="instancePrefix" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='removeinstance'">
				<xsl:variable name="remainder">
					<xsl:call-template name="hxpstring">
						<xsl:with-param name="data" select="$blockData" />
						<xsl:with-param name="thestring" select="substring-after($value,'-')" />
					</xsl:call-template>
				</xsl:variable>
				<xsl:call-template name="rifintremoveinstance">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="instanceId" select="$remainder" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 10/05/07: introdotta gestione dei ruoli [RW 0043770] -->
			<xsl:when test="substring-before($value,'-')='rifint_block_display'">
				<xsl:call-template name="rifintBlockDisplay">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tipoUff-id" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 10/05/07: ricopiato da docEdit.xsl per la gestione dei ruoli [RW 0043770] -->
			<xsl:when test="substring-before($value,'-')='lookup'">
				<xsl:call-template name="lookup">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 10/05/07: ricopiato da docEdit.xsl per la gestione dei ruoli [RW 0043770] -->
			<xsl:when test="substring-before($value,'-')='onblurlookup'">
				<xsl:call-template name="onblurlookup">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
					<xsl:with-param name="instPosDep" select="$instPosDep"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='rifint'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-rifint-action-... -->
								<xsl:call-template name="rifintaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-rifint-data-... -->
								<xsl:call-template name="rifintdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- RW0054196 - fcossu - Dexia -->
	<xsl:template match="*[@id='hxp-custom-title']">
	  <xsl:value-of select="$hxpdata/coming_from/description"/>
	</xsl:template>

</xsl:stylesheet>
