<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina di lookup.
Se si vuole che il riempimento dei campi della form opener avvenga in automatico nel caso in cui
sia stata trovata una sola vole di lookup (saltando la paigina di visualizzazione e scelta della voci trovate)
occorre inserire id="hxp-lookup-action-oneSkipPage" direttamente nel tag <html> iniziale del template
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/rifintlookup.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<!--<xsl:attribute name="onblur">self.close();</xsl:attribute>-->
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="lookup" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="ripropz" value="{$hxpdata/@ripropz}" /> <!-- riproduzioni opzionali -->

			<!--
				Federico 02/07/08: l'opzione "(lt:1)" in xDoc non viene piu' usata dai tempi del Nif e degrada pure le prestazioni,
				oltre a creare problemi con le eventuali entity &#... a causa delle processing instruction inserite da xw [RW 0052875]
			 -->
			<input type="hidden" name="xDoc" value="" />

			<input type="hidden" name="qord" value="{$hxpdata/@qord}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="lookup_titolo" value="{$hxpdata/@lookup_titolo}" />
			<input type="hidden" name="lookup_campi" value="{$hxpdata/@lookup_campi}" />
			<input type="hidden" name="selected_campi" value="{$hxpdata/@selected_campi}" />
			<input type="hidden" name="lookup_alias" value="{$hxpdata/@lookup_alias}" />
			<input type="hidden" name="lookup_fieldVal" value="{$hxpdata/@lookup_fieldVal}" />
		</form>
	</xsl:template>

	<!-- Smistamento dei template hxp-lookup-data-...
		Numero di pagina: id="hxp-lookup-data-pagenumber"
		Numero totale di pagine: id="hxp-lookup-data-numberofpages"
		Posizione del primo titolo della pagina: id="hxp-lookup-data-firstposition"
		Posizione dell'ultimo titolo della pagina: id="hxp-lookup-data-lastposition"
		Numero totale di titoli: id="hxp-lookup-data-count"
		Barra di navigazione tra i documenti:
			id="hxp-lookup-data-navbar" - le immagini della barra di navigazione sono prese dal path di default.
			id="hxp-lookup-data-navbar-(path)" - le immagini della barra di navigazione sono prese dal path indicato.
			In ogni caso le immagini devono chiamarsi:
				"a_rr.gif" : indicatore di ultima pagina selezionata
				"a_rl.gif" : indicatore di pagina selezionata
				"a_gr.gif" : indicatore di scelta pagina successiva
				"a_gl.gif" : indicatore di scelta pagina precedente
		Testo del titolo: id="hxp-lookup-data-tittext"
	-->
	<xsl:template name="rifintlookupdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$value='pagenumber'">
					<xsl:number value="floor($hxpdata/@pos div $hxpdata/@pageCount + 1)" format="1" /> <!-- numero di pagina -->
				</xsl:when>
				<xsl:when test="$value='numberofpages'">
					<xsl:number value="floor(($hxpdata/@count + $hxpdata/@pageCount - 1) div $hxpdata/@pageCount)" format="1" /> <!-- numero totale di pagine -->
				</xsl:when>
				<xsl:when test="$value='firstposition'"> <!-- posizione del primo titolo della pagina -->
					<xsl:number value="$hxpdata/@pos + 1" format="1" />
				</xsl:when>
				<xsl:when test="$value='lastposition'"> <!-- posizione dell'ultimo titolo della pagina -->
					<xsl:choose>
						<xsl:when test="$hxpdata/@pos + $hxpdata/@pageCount > $hxpdata/@count">
							<xsl:number value="$hxpdata/@count" format="1" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:number value="$hxpdata/@pos + $hxpdata/@pageCount" format="1" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:when test="$value='count'"> <!-- numero totale di titoli -->
					<xsl:number value="$hxpdata/@count" format="1" />
				</xsl:when>
				<xsl:when test="starts-with($value,'navbar')"> <!-- barra di navigazione -->
					<script>                                    <!-- se nella forma hxp-lookup-data-navbar-(path) cerca -->
						<xsl:text>document.write(titnavbarcode(</xsl:text>  <!-- le immagini in (path) altrimenti se nella forma hxp-lookup-data-navbar usa path di default -->
						<xsl:value-of select="$hxpdata/@pos"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount"/>
						<xsl:if test="substring-after($value,'-')!=''">
							<xsl:text>,'</xsl:text>
							<xsl:value-of select="substring-after($value,'-')"/>
							<xsl:text>'</xsl:text>
						</xsl:if>
						<xsl:text>))</xsl:text>
					</script>
				</xsl:when>
				<xsl:when test="$value='tittext'"> <!-- visualizzazione del testo del titolo -->
					<xsl:value-of select="$blockData/@testo"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<!-- Smistamento dei template hxp-lookup-data-... Di default non si fa la copia dell'element
		Visualizzazione dell'icona tipica di tabella: id="hxp-lookup-datanocopy-(nome tabella)"
			Se il titolo e della tabella (tabella) copia l'element altrimenti lo ignora
	-->
	<xsl:template name="rifintlookupdatanocopy">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='tabicon'"> <!-- icona di tabella -->
				<xsl:if test="$blockData/@db=substring-after($value,'-')">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!--

	  Implementazione dei singoli template action

	-->

	<!-- Vai alla prima pagina dei titoli: id="hxp-lookup-action-first" -->
	<xsl:template name="rifintlookupfirst">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return primaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina dei titoli precedente: id="hxp-lookup-action-prev" -->
	<xsl:template name="rifintlookupprev">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina dei titoli successiva: id="hxp-lookup-action-next" -->
	<xsl:template name="rifintlookupnext">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@pageCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai all'ultima pagina dei titoli: id="hxp-lookup-action-last" -->
	<xsl:template name="rifintlookuplast">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@pageCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return ultimaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Chiudi la pagina di lookup: id="hxp-lookup-action-cancel" -->
	<xsl:template name="rifintlookupcancel">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return closeLookup();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Conferma il riempimento della form: id="hxp-lookup-action-confirm" -->
	<xsl:template name="rifintlookupconfirm">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return confirmLookup();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gestisce il radiobutton associato a un titolo: id="hxp-rifintlookup-action-radio"
	Il name dei radio button deve essere "lookup".
	La form che contiene i radio si deve chiamare "theForm".
	-->
	<xsl:template name="rifintlookupradio">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>radioSele(this,event);setFields(</xsl:text>
				<xsl:text>'</xsl:text>
				<xsl:value-of select="$blockData/@extra"/>
				<xsl:text>',</xsl:text>
				<xsl:for-each select="$blockData/campo">
					<xsl:text>'</xsl:text>
					<xsl:value-of select="./@nome" />
					<xsl:text>=</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="./text()" />
					</xsl:call-template>
					<xsl:text>'</xsl:text>
					<xsl:if test="position() != last()">
						<xsl:text>,</xsl:text>
					</xsl:if>
				</xsl:for-each>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$blockData/@indice" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Per evitare la visualizzazione dei titoli nel caso in cui venga restituita una sola vole di lookup
	trovata. Il riempimento dei campi avviene in automatico.
		id="hxp-lookup-action-doceditoneSkipPage"
	-->
	<xsl:template name="rifintlookuponeSkipPage">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$hxpdata/@count = 1">


					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>

					<script>
						<xsl:text>setFields(</xsl:text>
						<xsl:text>'</xsl:text>
						<xsl:value-of select="$hxpdata/titolo/@extra"/>
						<xsl:text>',</xsl:text>
						<xsl:for-each select="$hxpdata/titolo/campo">
							<xsl:text>'</xsl:text>
							<xsl:value-of select="./@nome" />
							<xsl:text>=</xsl:text>
							<xsl:call-template name="quoteString">
								<xsl:with-param name="stringa" select="./text()" />
							</xsl:call-template>
							<xsl:text>'</xsl:text>
							<xsl:if test="position() != last()">
								<xsl:text>,</xsl:text>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>);</xsl:text>
						opener.lookupInAtto = false;
						confirmLookup();
					</script>

				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<!-- Smistamento dei template hxp-lookup-action-... -->
	<xsl:template name="rifintlookupaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$value='first'">
				<xsl:call-template name="rifintlookupfirst">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="rifintlookupprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="rifintlookupnext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last'">
				<xsl:call-template name="rifintlookuplast">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='cancel'">
				<xsl:call-template name="rifintlookupcancel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirm'">
				<xsl:call-template name="rifintlookupconfirm">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='radio'">
				<xsl:call-template name="rifintlookupradio">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='oneSkipPage'">
				<xsl:call-template name="rifintlookuponeSkipPage">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template match="key-hit">
		<span class="key-hit">
			<xsl:apply-templates />
		</span>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='rifintlookup'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-lookup-action-... -->
								<xsl:call-template name="rifintlookupaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-lookup-data-... -->
								<xsl:call-template name="rifintlookupdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'datanocopy-')"> <!-- hxp-lookup-datanocopy-... -->
								<xsl:call-template name="rifintlookupdatanocopy">
									<xsl:with-param name="value" select="substring-after($value,'datanocopy-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
