<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Suggerimenti -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:attribute name="scroll">auto</xsl:attribute>
		<xsl:attribute name="onKeyPress">submitOnEnter(event)</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" target="indexWindow" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="startkey" value="" />
			<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
			<input type="hidden" name="keypath" value="{$hxpdata/@keypath}" /> <!-- la chiave -->
			<input type="hidden" name="cPath" value="{$hxpdata/@cPath}" /> <!-- parte comune -->
			<input type="hidden" name="keylower" value="" /> <!-- se leggere verso minore (pagina precedente) -->
			<input type="hidden" name="minFreq" value="{$hxpdata/@minFreq}" /> <!-- frequenza minima -->
			<input type="hidden" name="maxFreq" value="{$hxpdata/@maxFreq}" /> <!-- frequenza massima -->
			<input type="hidden" name="minRes" value="{$hxpdata/@minRes}" /> <!-- risoluzione minima -->
			<!-- specifiche x idx -->
			<input type="hidden" name="threl" value="{$hxpdata/@threl}" /> <!-- relazione da cui attingere la descrizione del codice prelevato dagli indici (classificazione) -->
			<input type="hidden" name="shwMode" value="{$hxpdata/@shwMode}" /> <!-- modalit di presentazione: codice a 2 byte 'dt' se  una data -->
			<!-- specifiche x ths, usate per passare da una vista all'altra -->
			<input type="hidden" name="xRels" value="{$hxpdata/@xRels}" /> <!-- relazioni espandibili -->
			<input type="hidden" name="vRels" value="{$hxpdata/@vRels}" /> <!-- relazioni visualizzabili -->
			<input type="hidden" name="lRel" value="{$hxpdata/@lRel}" /> <!-- ultima relazione -->
		</form>
	</xsl:template>
	
	<xsl:template match="term" mode="suggest-term">
		<xsl:param name="sample_node" select="/.." />
		<xsl:if test="alternate">
			<xsl:element name="{local-name($sample_node)}">
				<xsl:copy-of select="$sample_node/@*[name() != 'id']" />
				<xsl:text>in </xsl:text>
				<span class="suggestion-attribute">
					<xsl:value-of select="../@name" />
				</span>
				<xsl:text>, invece del termine </xsl:text>
				<span class="suggestion-term">
					<xsl:value-of select="@word" />
				</span>
				<xsl:if test="@occurs_total = 0 or @occurs = 0">
					<xsl:text> (che non  presente</xsl:text>
					<xsl:choose>
						<xsl:when test="@occurs_total = 0">
							<xsl:text> nel vocabolario)</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text> nei documenti su cui si opera)</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
				<xsl:text>, provare con </xsl:text>
				<xsl:for-each select="alternate">
					<span class="suggestion-term">
						<xsl:value-of select="." />
					</span>
					<xsl:choose>
						<xsl:when test="count(following-sibling::alternate) &gt; 1">
							<xsl:text>, </xsl:text>
						</xsl:when>
						<xsl:when test="count(following-sibling::alternate) &gt; 0">
							<xsl:text> oppure </xsl:text>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:element>
		</xsl:if>
		<xsl:if test="association[string-length() &gt; 0]">
			<xsl:element name="{local-name($sample_node)}">
				<xsl:copy-of select="$sample_node/@*[name() != 'id']" />
				<xsl:text>per </xsl:text>
				<span class="suggestion-attribute">
					<xsl:value-of select="../@name" />
				</span>
				<xsl:text>, provare ad associare al termine </xsl:text>
				<span class="suggestion-term">
					<xsl:value-of select="@word" />
				</span>
				<xsl:if test="@occurs = 0">
					<xsl:text> (non presente nei documenti su cui si opera)</xsl:text>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="count(association[string-length() &gt; 0]) &gt; 1">
						<xsl:text> i termini </xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text> il termine </xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:for-each select="association[string-length() &gt; 0]">
					<span class="suggestion-term">
						<xsl:value-of select="." />
					</span>
					<xsl:if test="@relation">
						<xsl:text> (in </xsl:text>
						<span class="suggestion-relation">
							<xsl:value-of select="@relation" />
						</span>
						<xsl:text>)</xsl:text>
					</xsl:if>
					<xsl:choose>
						<xsl:when test="count(following-sibling::association[string-length() &gt; 0]) &gt; 1">
							<xsl:text>, </xsl:text>
						</xsl:when>
						<xsl:when test="count(following-sibling::association[string-length() &gt; 0]) &gt; 0">
							<xsl:text> oppure </xsl:text>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:element>
		</xsl:if>
		<xsl:if test="association[string-length() = 0]">
			<xsl:element name="{local-name($sample_node)}">
				<xsl:copy-of select="$sample_node/@*[name() != 'id']" />
				<xsl:text>per </xsl:text>
				<span class="suggestion-attribute">
					<xsl:value-of select="../@name" />
				</span>
				<xsl:text>, provare ad associare al termine </xsl:text>
				<span class="suggestion-term">
					<xsl:value-of select="@word" />
				</span>
				<xsl:if test="@occurs = 0">
					<xsl:text> (non presente nei documenti su cui si opera)</xsl:text>
				</xsl:if>
				<xsl:text> termini scelti</xsl:text>
				<xsl:for-each select="association[string-length() = 0 and @relation]">
					<xsl:sort select="@relation" data-type="text" order="ascending" />
					<xsl:variable name="current" select="@relation" />
					<xsl:if test="count(preceding-sibling::association[string-length() = 0 and @relation = $current]) = 0">
						<xsl:text> dalla relazione </xsl:text>
						<span class="suggestion-relation">
							<xsl:value-of select="@relation" />
						</span>
						<xsl:choose>
							<xsl:when test="count(following-sibling::association[string-length() = 0 and @relation = $current]) &gt; 1">
								<xsl:text>, </xsl:text>
							</xsl:when>
							<xsl:when test="count(following-sibling::association[string-length() = 0 and @relation = $current]) &gt; 0">
								<xsl:text> oppure </xsl:text>
							</xsl:when>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:element>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggest-attribute']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:if test="count($xml_data/../attribute) &gt; 1 and $xml_data/../operator/@suggested and count($xml_data/preceding-sibling::attribute) = 0">
			<xsl:copy>
				<xsl:copy-of select="@*[name() != 'id']" />
				<xsl:text>richiedere che la ricerca utilizzi l'operatore "</xsl:text>
				<xsl:value-of select="$xml_data/../operator/@suggested" />
				<xsl:text>"</xsl:text>
			</xsl:copy>
		</xsl:if>
		<xsl:if test="$xml_data/focus[@suggested]">
			<xsl:copy>
				<xsl:copy-of select="@*[name() != 'id']" />
				<xsl:if test="$xml_data/focus/@disposition = 'increase'">
					<xsl:text>allargare</xsl:text>
				</xsl:if>
				<xsl:if test="$xml_data/focus/@disposition = 'decrease'">
					<xsl:text>restringere</xsl:text>
				</xsl:if>
				<xsl:text> il contesto di ricerca per </xsl:text>
				<span class="suggestion-attribute">
					<xsl:value-of select="$xml_data/@name" />
				</span>
				<xsl:text> a "</xsl:text>
				<xsl:value-of select="$xml_data/focus/@suggested" />
				<xsl:text>"</xsl:text>
			</xsl:copy>
		</xsl:if>
		<xsl:if test="$xml_data/adjacency[distance or order]">
			<xsl:variable name="distance" select="$xml_data/adjacency/distance/@suggested" />
			<xsl:variable name="order" select="$xml_data/adjacency/order/@suggested" />
			<xsl:copy>
				<xsl:copy-of select="@*[name() != 'id']" />
				<xsl:text>impostare, per la ricerca in </xsl:text>
				<span class="suggestion-attribute">
					<xsl:value-of select="$xml_data/@name" />
				</span>
				<xsl:text>, </xsl:text>
				<xsl:choose>
					<xsl:when test="$distance &gt; 0">
						<xsl:text> adiacenza entro </xsl:text>
						<xsl:value-of select="$distance" />
						<xsl:choose>
							<xsl:when test="$distance &gt; 1">
								<xsl:text> parole</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text> parola</xsl:text>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:if test="$order = 1">
							<xsl:text> e parole nello stesso ordine</xsl:text>
						</xsl:if>
						<xsl:if test="$order = 0">
							<xsl:text> e parole anche non nello stesso ordine</xsl:text>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>la ricerca di parole anche non in adiacenza (adiacenza 0)</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:copy>
		</xsl:if>
		<xsl:if test="$xml_data/term">
			<xsl:variable name="sample_node" select="." />
			<xsl:for-each select="$xml_data/term">
				<xsl:apply-templates select="." mode="suggest-term">
					<xsl:with-param name="sample_node" select="$sample_node" />
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
		<xsl:if test="$xml_data/../attribute/*/extension and count($xml_data/following-sibling::attribute) = 0">
			<xsl:copy>
				<xsl:copy-of select="@*[name() != 'id']" />
				<xsl:for-each select="$xml_data/../attribute/*/extension">
					<xsl:sort select="@relation" data-type="text" order="ascending" />
					<xsl:variable name="current" select="@relation" />
					<xsl:if test="position() = 1">
						<xsl:choose>
							<xsl:when test="count(../extension[@relation != $current])">
								<xsl:text>estendere la ricerca alle relazioni </xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:text>estendere la ricerca alla relazione </xsl:text>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="count(preceding::extension[@relation = $current]) = 0">
						<span class="suggestion-relation">
							<xsl:value-of select="@relation" />
						</span>
						<xsl:choose>
							<xsl:when test="count(following::extension[@relation != $current]) &gt; 1">
								<xsl:text>, </xsl:text>
							</xsl:when>
							<xsl:when test="count(following::extension[@relation != $current]) &gt; 0">
								<xsl:text> oppure </xsl:text>
							</xsl:when>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</xsl:copy>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggest-all-attributes']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:variable name="html_fragment" select="./*" />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:for-each select="$xml_document//attribute">
				<xsl:apply-templates select="$html_fragment" mode="sample">
					<xsl:with-param name="xml_data" select="." />
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-disposition']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:variable name="disposition" select="$xml_document/response/suggestions/@disposition" />
			<xsl:if test="$disposition = 'increase'">
				<xsl:text>aumentare</xsl:text>
			</xsl:if>
			<xsl:if test="$disposition = 'decrease'">
				<xsl:text>diminuire</xsl:text>
			</xsl:if>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-found-count']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:value-of select="$xml_data/response/suggestions/@count" />
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-thesaurus']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:text>l'estensione alla relazione </xsl:text>
			<span class="suggestion-relation">
				<xsl:value-of select="$xml_data/@used" />
			</span>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-if-any-options']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:if test="count($xml_data//thesaurus)">
			<xsl:copy>
				<xsl:copy-of select="@*[name() != 'id']" />
				<xsl:text>richiedendo</xsl:text>
			</xsl:copy>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-operator-phrase']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:if test="$xml_document//suggestions/operator[@used = 'Or'] and count($xml_data/following-sibling::*)">
				<xsl:text>, oppure</xsl:text>
			</xsl:if>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-attribute']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<span class="suggestion-attribute">
				<xsl:value-of select="$xml_data/@name" />
			</span>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id='hxp-suggestions-words']" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:choose>
				<xsl:when test="count($xml_data/term) &gt; 1">
					<xsl:text>i termini </xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>il termine </xsl:text>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:for-each select="$xml_data/term">
				<span class="suggestion-term">
					<xsl:value-of select="@word" />
				</span>
				<xsl:if test="position() &lt; last()">
					<xsl:text>, </xsl:text>
				</xsl:if>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[starts-with(@id, 'hxp-foreach-')]" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:variable name="html_fragment" select="./*" />
		<xsl:variable name="what" select="substring-after(@id, 'hxp-foreach-')" />
		<xsl:copy>
			<xsl:copy-of select="@*[name() != 'id']" />
			<xsl:for-each select="$xml_document//*[name() = $what]">
				<xsl:apply-templates select="$html_fragment" mode="sample">
					<xsl:with-param name="xml_data" select="." />
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*" mode="sample">
		<xsl:param name="xml_data" select="/.." />
		<xsl:copy>
			<xsl:apply-templates mode="sample">
				<xsl:with-param name="xml_data" select="$xml_data" />
			</xsl:apply-templates>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:apply-templates select="." mode="sample">
			<xsl:with-param name="xml_data" select="$xml_document" />
		</xsl:apply-templates>
	</xsl:template>

</xsl:stylesheet>
