<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet 
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
>
 <xsl:include href="hxp.xsl"/>

 <xsl:template name="jslist">
  <script>
  <xsl:attribute name="src">../../../formatter/html/data/js/thEdit.js</xsl:attribute>
  <xsl:attribute name="type">text/javascript</xsl:attribute>
  <xsl:text>;</xsl:text>
  </script>
 </xsl:template>

 <xsl:template name="bodyattributes">
  <xsl:attribute name="scroll">auto</xsl:attribute>
 </xsl:template>

 <xsl:template name="beforeend">
  <form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
   <xsl:call-template name="sessiondata"/>
   <input type="hidden" name="keypath"  value="{$hxpdata/@keypath}"/>
   <input type="hidden" name="name"     value="{$hxpdata/@name}"/>
   <input type="hidden" name="prev"     value="{$hxpdata/@prev}"/>
   <input type="hidden" name="next"     value="{$hxpdata/@next}"/>
   <input type="hidden" name="rels"     value="{$hxpdata/@rels}"/>
   <input type="hidden" name="relDescr" value="{$hxpdata/@relDescr}"/>
   <input type="hidden" name="relRules" value="{$hxpdata/@relRules}"/>
   <input type="hidden" name="relIndex" value="{$hxpdata/@relIndex}"/>
   <input type="hidden" name="xverb"    value=""/>
   <input type="hidden" name="verbo"    value="{$hxpdata/@verbo}"/>
   <input type="hidden" name="vRels"    value=""/>
   <input type="hidden" name="xRels"    value=""/>
   <input type="hidden" name="startkey" value=""/>   
  </form>
 </xsl:template>

 <xsl:template name="nodeprev">
  <xsl:param name="blockData" select="''"/>
  <xsl:choose>
   <xsl:when test="$hxpdata/@prev!=''">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:if test="name()='a' or name='A'">
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     </xsl:if>
     <xsl:attribute name="onclick">
      <xsl:text>return cambiaNodo('</xsl:text>
      <xsl:apply-templates select="$hxpdata/@prev" mode="quoted-value-of" />
      <xsl:text>');</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="nodenext">
  <xsl:param name="blockData" select="''"/>
  <xsl:choose>
   <xsl:when test="$hxpdata/@next!=''">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:if test="name()='a' or name='A'">
      <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     </xsl:if>
     <xsl:attribute name="onclick">
      <xsl:text>return cambiaNodo('</xsl:text>
      <xsl:apply-templates select="$hxpdata/@next" mode="quoted-value-of" />
      <xsl:text>');</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="nodeseek">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a' or name='A'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick">
    <xsl:text>return cercaNodo()</xsl:text>
   </xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodesave">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a' or name='A'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick">
    <xsl:text>return salvaNodo()</xsl:text>
   </xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodehier">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a' or name='A'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick">
    <xsl:text>return nodeHier()</xsl:text>
   </xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodenew">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a' or name='A'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick">
    <xsl:text>return nuovoNodo()</xsl:text>
   </xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodeclose">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:if test="name()='a' or name='A'">
    <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   </xsl:if>
   <xsl:attribute name="onclick"><xsl:text>return chiudiNodo();</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodename">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">nodeName</xsl:attribute>
   <xsl:attribute name="value"><xsl:value-of select="$hxpdata/@name"/></xsl:attribute>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="noderel">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">nodeRel</xsl:attribute>
   <xsl:attribute name="onchange"><xsl:text>cambiaRelazione(this)</xsl:text></xsl:attribute>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodeto">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">nodeTo</xsl:attribute>
   <xsl:attribute name="onchange"><xsl:text>form2rels(this.value)</xsl:text></xsl:attribute>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodesource">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">nodeSource</xsl:attribute>
   <xsl:attribute name="onchange"><xsl:text>impostaFonte(this.options[this.selectedIndex].value)</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodechannel">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="name">nodeChannel</xsl:attribute>
   <xsl:attribute name="onchange"><xsl:text>impostaCanale(this.options[this.selectedIndex].value)</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="nodedata">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$value='name'">
    <xsl:call-template name="nodename">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='rel'">
    <xsl:call-template name="noderel">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='to'">
    <xsl:call-template name="nodeto">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='source'">
    <xsl:call-template name="nodesource">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='channel'">
    <xsl:call-template name="nodechannel">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="nodeaction">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$value='prev'">
    <xsl:call-template name="nodeprev">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='next'">
    <xsl:call-template name="nodenext">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='seek'">
    <xsl:call-template name="nodeseek">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='save'">
    <xsl:call-template name="nodesave">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='new'">
    <xsl:call-template name="nodenew">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='close'">
    <xsl:call-template name="nodeclose">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='hier'">
    <xsl:call-template name="nodehier">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="*[@id]" mode="template" name="hxparser">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="disable" select="''"/>
  <xsl:choose>
   <!--xsl:when test="substring-before(@id,'-')='hxp'"-->
   <xsl:when test="starts-with(@id,'hxp')">
    <xsl:variable name="value" select="substring-after(@id,'-')"/>
    <xsl:choose>
     <xsl:when test="substring-before($value,'-')='thnode'">
      <xsl:choose>
       <xsl:when test="starts-with(substring-after($value,'-'),'action-')">
        <xsl:call-template name="nodeaction">
         <xsl:with-param name="value" select="substring-after($value,'action-')"/>
         <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:when test="starts-with(substring-after($value,'-'),'data-')">
        <xsl:call-template name="nodedata">
         <xsl:with-param name="value" select="substring-after($value,'data-')"/>
         <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:otherwise>
        <xsl:call-template name="hxperrorhandler">
         <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpidhandler">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy>
     <xsl:copy-of select="@*"/>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="disable" select="$disable"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

</xsl:stylesheet>
