<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet 
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
>
 <xsl:include href="hxp.xsl"/>

 <xsl:template name="jslist">
  <script>
	  <xsl:attribute name="src">../../../formatter/html/data/js/thes.js</xsl:attribute>
	  <xsl:attribute name="type">text/javascript</xsl:attribute>
	  <xsl:text>;</xsl:text>
  </script> 
  <script>
	  <xsl:attribute name="src">../../../formatter/html/data/js/keylist.js</xsl:attribute>
	  <xsl:attribute name="type">text/javascript</xsl:attribute>
	  <xsl:text>;</xsl:text>
  </script>  
  <script>
	  <xsl:attribute name="src">../../../formatter/html/data/js/index.js</xsl:attribute>
	  <xsl:attribute name="type">text/javascript</xsl:attribute>
	  <xsl:text>;</xsl:text>
  </script>
  <!--
  	Federico 15/04/2005: probabilmente in qualche file js specifico (tipo 'thes_funzioni_aggiuntive.js'
    di XSpring) viene effettuata una 'setGlobalFormRestore(...)' per la gestione del tasto back.
    Inoltre, il loadhandler di 'thes.js' generico chiama 'restoreTuple()'.
  -->
  <script>
	  <xsl:attribute name="src">../../../formatter/html/data/js/formTupleRestore.js</xsl:attribute>
	  <xsl:attribute name="type">text/javascript</xsl:attribute>
	  <xsl:text>;</xsl:text>
  </script>
 </xsl:template>

 <xsl:template name="bodyattributes">
  <xsl:attribute name="scroll">auto</xsl:attribute>
  <xsl:attribute name="onKeyPress">submitOnEnter(event)</xsl:attribute>
 </xsl:template>

 <xsl:template name="beforeend">
  <form method="post" name="hxpForm" _target="thesWindow" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
   <xsl:call-template name="sessiondata"/>
   <input type="hidden" name="startkey" value="{$hxpdata/@startkey}"/>
   <input type="hidden" name="verbo"    value="{$hxpdata/@verbo}"/>
   <input type="hidden" name="xverb"    value="{$hxpdata/@xverb}"/>
   <input type="hidden" name="keypath"  value="{$hxpdata/@keypath}"/> <!-- la chiave -->
   <input type="hidden" name="minFreq"  value="{$hxpdata/@minFreq}"/> <!-- frequenza minima -->
   <input type="hidden" name="maxFreq"  value="{$hxpdata/@maxFreq}"/> <!-- frequenza massima -->
   <input type="hidden" name="cPath"    value="{$hxpdata/@cPath}"/>   <!-- percorso comune -->
   <input type="hidden" name="keylower" value=""/>                    <!-- se leggere verso minore (pagina precedente) -->
   <!-- specifiche x ths -->
   <input type="hidden" name="xRels"    value="{$hxpdata/@xRels}"/>   <!-- relazioni espandibili -->
   <input type="hidden" name="vRels"    value="{$hxpdata/@vRels}"/>   <!-- relazioni visualizzabili -->
   <input type="hidden" name="lRel"     value="{$hxpdata/@lRel}"/>    <!-- ultima relazione -->
   <!-- specifiche x idx, usate per passare da una vista all'altra -->
   <input type="hidden" name="threl"    value="{$hxpdata/@threl}"/>   <!-- relazione da cui attingere la descrizione del codice prelevato dagli indici (classificazione) --> 
   <input type="hidden" name="shwMode"  value="{$hxpdata/@shwMode}"/> <!-- modalit di presentazione: codice a 2 byte 'dt' se  una data -->
   <input type="hidden" name="xMode"    value="{$hxpdata/@xMode}"/>   <!-- unused -->
   <!-- per vista gerarchica della classificazione -->
   <input type="hidden" name="relation"    value="{$hxpdata/@relation}"/>   <!-- stringa che identifica la relazione richiesta -->
   
   <!-- Aggiunto da Federico il 05/10/2004: tupla per il pulsante 'back' del thesauro gerarchico -->
   <input type="hidden" name="thBackPage" value="{$hxpdata/@thBackPage}"/>
   
  		<!--ctsep gestione in/out termini-->
			<input type="hidden" name="newTerm" value="{$hxpdata/@newTerm}" />
                        <input type="hidden" name="mycPath" value="{$hxpdata/@mycPath}" />
                        <!--fine ctsep gestione in/out termini-->


	<!-- specifici -->
	<xsl:call-template name="contextcustom">
		<xsl:with-param name="specName" select="'beforeend'"/>
	</xsl:call-template>	   
  </form>
 </xsl:template>

 <xsl:template name="idxSeekJsAction">
  <xsl:text>return posiziona(getForm('seek').seektext.value,'</xsl:text>
  <xsl:value-of select="$hxpdata/@keypath"/>
  <xsl:text>');</xsl:text>
 </xsl:template>

 <xsl:template match="form[//@id='hxp-idx-action-next']" mode="template">
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="action"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   <xsl:attribute name="onsubmit"><xsl:call-template name="idxSeekJsAction"/></xsl:attribute>
   <xsl:apply-templates select="node()" mode="template"/>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="idxrefresh">
  <xsl:param name="blockData" select="''"/>
  <xsl:choose>
   <xsl:when test="count($hxpdata/thes)>0">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     <xsl:attribute name="onclick"><xsl:text>return aggiornaPagina('</xsl:text>
     <xsl:apply-templates select="$hxpdata/descendant::thes[position()=1]/@coord" mode="quoted-value-of" />
     <xsl:text>');</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="idxprev">
  <xsl:param name="blockData" select="''"/>
  <xsl:choose>
   <xsl:when test="$hxpdata/@pos>0">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     <xsl:attribute name="onclick">
     <xsl:text>return paginaPrecedente('</xsl:text>
     <xsl:apply-templates select="$hxpdata/descendant::thes[position()=1]/@coord" mode="quoted-value-of"/>
     <xsl:text>','</xsl:text><xsl:value-of select="$hxpdata/@pos"/><xsl:text>');</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="idxnext">
  <xsl:param name="blockData" select="''"/>

  <xsl:choose>
   <xsl:when test="$hxpdata/@count>$hxpdata/@pos+count($hxpdata/descendant::thes)">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
     <xsl:attribute name="onclick"><xsl:text>return paginaSuccessiva('</xsl:text>
     <xsl:apply-templates select="$hxpdata/descendant::thes[position()=last()]/@coord" mode="quoted-value-of" />
     <xsl:text>','</xsl:text><xsl:value-of select="$hxpdata/@pos"/>
     <xsl:text>','</xsl:text><xsl:value-of select="$hxpdata/@count"/><xsl:text>');</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="idxseek">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   <xsl:attribute name="onclick"><xsl:call-template name="idxSeekJsAction"/></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="idxcloseonly">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   <xsl:attribute name="onclick"><xsl:text>closeOnly();</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="idxclose">
  <xsl:param name="blockData" select="''"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']"/>
   <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
   <xsl:attribute name="onclick"><xsl:text>closeIndex();</xsl:text></xsl:attribute>
   <xsl:call-template name="hxpcontinuecontext">
    <xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="idxcheck">
  <xsl:param name="blockData" select="''"/>
  <xsl:choose>
   <xsl:when test="number($blockData/@frequenza)>0">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:attribute name="onclick"><xsl:text>checkSele(this)</xsl:text></xsl:attribute>
     <xsl:attribute name="value"><xsl:value-of select="$blockData/@chiave"/></xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
 

	<!-- Visualizza il thesauro: tutti in termini in relazione (secondo la relazione specificata)
		con l'elemento response/@startkey nel campo (chiave)
	   id="hxp-docedit-action-showthesrel-'(Relazione)','(chiave)'" -->
	<xsl:template name="idxshowthesrel">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="relation_key" select="''" />
			
		<!--
			Federico 16/06/05:
			se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
			per aprire il th. gerarchico (in caso di url alcune funzionalita' del js vengono perse,
			come la gestione della tupla 'thBackPage').
		-->
		<xsl:choose>
			<xsl:when test="$nojs!='1'">
				<xsl:copy>
					<xsl:attribute name="onclick">
						<xsl:text>return showthesRel(</xsl:text>
						<xsl:value-of select="$relation_key"/>
						<xsl:text>,'</xsl:text>
						<xsl:call-template name="toJSParam">
							<xsl:with-param name="testo" select="$blockData/@chiave"/>
						</xsl:call-template>
						<xsl:text>','</xsl:text>
						<xsl:call-template name="toJSParam">
							<xsl:with-param name="testo" select="$blockData/@nome"/> <!-- nome e' valorizzato se si vuole tornare indietro ovvero risalire nella gerarchia -->
						</xsl:call-template>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- inserimento dell'url al posto della chiamata js -->
				<div class="ThButtons">
					<a>
						<xsl:attribute name="href">
							<xsl:value-of select="$hxpdata/@uri"/>
								<xsl:text>?db=</xsl:text>
								<xsl:value-of select="$hxpdata/@db"/>
								<xsl:text>&amp;transformJava=</xsl:text>
								<xsl:value-of select="$hxpdata/@transformJava"/>
								<xsl:text>&amp;verbo=showthes&amp;xverb=@</xsl:text>
								<xsl:value-of select="substring($relation_key,2,2)"/>
								<xsl:text>&amp;view=</xsl:text>
								<xsl:value-of select="$hxpdata/@view"/>
								<xsl:text>&amp;enableIW=</xsl:text>
								<xsl:value-of select="$hxpdata/@enableIW"/>
								<xsl:text>&amp;toDo=set_minFreq_for_TH_navigation:1&amp;keypath=</xsl:text>
								<xsl:value-of select="$hxpdata/@keypath"/>
								<xsl:text>&amp;startkey=</xsl:text>
								<xsl:value-of select="$blockData/@chiave"/>
								<xsl:text>&amp;relation=</xsl:text>
								<xsl:value-of select="$hxpdata/@relation"/>
								<xsl:text>&amp;xMode=</xsl:text>
								<xsl:value-of select="$hxpdata/@xMode"/>
								<xsl:text>&amp;cPath=</xsl:text>
								
								<xsl:choose>
									<xsl:when test="string-length($blockData/@nome)=0">
										<!-- pulsante avanti -->
										<xsl:value-of select="$hxpdata/@cPath"/>
									</xsl:when>
									<xsl:otherwise>
										<!-- pulsante indietro: occorre rimuovere gli ultimi due termini di cPath -->
										<!-- rimozione primo termine -->
										<xsl:variable name="lastPipe1">
											<xsl:call-template name="lastIndexOf">
												<xsl:with-param name="string" select="$hxpdata/@cPath" />
              									<xsl:with-param name="char" select="'|'" />
											</xsl:call-template>
										</xsl:variable>
										<xsl:variable name="newCPath1">
											<xsl:value-of select="substring($hxpdata/@cPath,1,number($lastPipe1)-1)"/>
										</xsl:variable>
										<!-- rimozione secondo termine -->
										<xsl:variable name="lastPipe2">
											<xsl:call-template name="lastIndexOf">
												<xsl:with-param name="string" select="$newCPath1" />
              									<xsl:with-param name="char" select="'|'" />
											</xsl:call-template>
										</xsl:variable>
										<xsl:variable name="newCPath2">
											<xsl:value-of select="substring($newCPath1,1,number($lastPipe2)-1)"/>
										</xsl:variable>
										<xsl:value-of select="$newCPath2"/>
									</xsl:otherwise>
								</xsl:choose>
								
								<!-- dati di autenticazione -->
								<xsl:call-template name="aclparams"/>
						</xsl:attribute>
						<!-- il contenuto dell'ancora  e' lo stesso del button -->
						<xsl:value-of select="."/>
					</a>
				</div>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	
	
	<!-- id="hxp-idx-action-removethesrel-'(Relazione)','(chiave)'" -->
	<xsl:template name="removethesrel">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="relation_key" select="''" />		
		<xsl:copy>
			<xsl:attribute name="onclick">
				<xsl:text>return removethesrel(</xsl:text>
				<xsl:value-of select="$relation_key"/>
				<xsl:text>,'</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@chiave"/>
				</xsl:call-template>
				<xsl:text>','</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@nome"/> <!-- nome e' valorizzato se si vuole tornare indietro ovvero risalire nella gerarchia -->
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>		
    
	<!-- Inserisce un nuovo termine nel thesauro: id="hxp-thesauro-action-newthesrel" -->
	<xsl:template name="thesauronew">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return newTermine();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
 
 	<xsl:template name="thesauronewson">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return newTermineSon(</xsl:text>
				<xsl:text>'</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@chiave"/> <!-- nome e' valorizzato se si vuole tornare indietro ovvero risalire nella gerarchia -->
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>	
 
 	<!-- Selezione di una chiave intermedia nella visualizzazione gerarchica  -->
	<xsl:template name="idxcommitselection">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
   		<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>		
			<xsl:attribute name="onclick">
				<xsl:text>return commit('</xsl:text>
				<!--
					Modifica di Federico del 30/11/2004:
					se presente, visualizzo il contenuto dell'elemento corrente, che rappresenta la
					traduzione nella lingua corrente corrispondente alla chiave '@chiave'.
				-->
				<xsl:variable name="thKey">
					<xsl:value-of select="$blockData/@chiave"/>
					<xsl:if test="$blockData/text()!=''">
						<xsl:text> - </xsl:text>
						<xsl:value-of select="$blockData/text()"/>
					</xsl:if>
				</xsl:variable>
				<xsl:call-template name="toJSParam">
					<!--<xsl:with-param name="testo" select="$blockData/@chiave"/>-->
					<xsl:with-param name="testo" select="$thKey"/>
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


 	<!-- Selezione di una chiave intermedia nella visualizzazione gerarchica scatena ricerca su
 	      tutto il sottoalbero corrente -->
	<xsl:template name="idxcommitqueryselection">
		<xsl:param name="params" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
	   		<xsl:attribute name="href">
	   			<!--
					Federico 16/06/05:
					se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
					per scatenare la ricerca.
				-->
				<xsl:choose>
					<xsl:when test="$nojs!='1'">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<!-- inserimento dell'url al posto della chiamata js -->
						<xsl:value-of select="$hxpdata/@uri"/>
						<xsl:text>?db=</xsl:text>
						<xsl:value-of select="$hxpdata/@db"/>
						<xsl:text>&amp;transformJava=</xsl:text>
						<xsl:value-of select="$hxpdata/@transformJava"/>
						<xsl:text>&amp;verbo=queryplain&amp;xverb=</xsl:text>
						<xsl:text>&amp;view=</xsl:text>
						<xsl:value-of select="$hxpdata/@view"/>
						<xsl:text>&amp;enableIW=</xsl:text>
						<xsl:value-of select="$hxpdata/@enableIW"/>
						<xsl:text>&amp;query=([</xsl:text>
						
						<!--
							preparazione della query:
							analisi di 'params': essendo stato pensato come un parametro js, esso o
							e' vuoto (stringa '') o contiene l'alias per la ricerca compreso tra apici.
							Quindi, occorre eliminare gli apici.
						-->
						<xsl:choose>
							<xsl:when test="string-length($params)&gt;2">
								<!-- 'params' contiene l'alias tra apici -->
								<xsl:value-of select="substring($params,2,string-length($params)-2)"/>
							</xsl:when>
							<xsl:otherwise>
								<!-- 'params' e' vuoto: prendo la tupla xMode -->
								<xsl:value-of select="$hxpdata/@xMode"/>
							</xsl:otherwise>
						</xsl:choose>
						
						<xsl:text>]="</xsl:text>
						<xsl:value-of select="$blockData/@chiave"/>
						<xsl:text>")</xsl:text>
						
						<!-- append di un'eventuale parte extra -->
						<xsl:if test="string-length($hxpdata/@qext)&gt;0">
							<xsl:text> AND (</xsl:text>
							<xsl:value-of select="$hxpdata/@qext"/>
							<xsl:text>)</xsl:text>
						</xsl:if>
						
						<!-- dati di autenticazione -->
						<xsl:call-template name="aclparams"/>
					</xsl:otherwise>
				</xsl:choose>
	   		</xsl:attribute>
			
			<!--
				Federico 16/06/05:
				se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
				per scatenare la ricerca.
			-->
			<xsl:if test="$nojs!='1'">
				<xsl:attribute name="onclick">
					<xsl:text>return commitQuery('</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$blockData/@chiave"/>
					</xsl:call-template>
					<xsl:text>',</xsl:text>				
					<xsl:value-of select="$params"/>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Torna al menu principale (pagina di ricerca): 
	id="hxp-idx-action-query" -->
	<xsl:template name="idxquery">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return nuovaRicerca();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>	
 

 <xsl:template name="idxaction">
  <xsl:param name="value" select="''"/>
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$value='query'">
    <xsl:call-template name="idxquery">
     <xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:when>  
   <xsl:when test="substring-before($value,'-')='commitqueryselection'">
    <xsl:call-template name="idxcommitqueryselection">
     <xsl:with-param name="params" select="substring-after($value,'-')"/>
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='commitselection'">
    <xsl:call-template name="idxcommitselection">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
	<xsl:when test="substring-before($value,'-')='showthesrel'">
		<xsl:call-template name="idxshowthesrel">
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="relation_key" select="substring-after($value,'-')" />					
		</xsl:call-template>
	</xsl:when>
    <xsl:when test="substring-before($value,'-')='removethesrel'">
		<xsl:call-template name="removethesrel">
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="relation_key" select="substring-after($value,'-')" />					
		</xsl:call-template>
	</xsl:when>
	<xsl:when test="$value='newthesrel'">
		<xsl:call-template name="thesauronew">
			<xsl:with-param name="blockData" select="$blockData" />
			<!--<xsl:with-param name="relation_key" select="substring-after($value,'-')" /> -->					
		</xsl:call-template>
	</xsl:when>
     <xsl:when test="substring-before($value,'-')='newthesrelson'">
		<xsl:call-template name="thesauronewson">
			<xsl:with-param name="blockData" select="$blockData" />
			<!--<xsl:with-param name="relation_key" select="substring-after($value,'-')" /> -->					
		</xsl:call-template>
	</xsl:when>
   <xsl:when test="$value='refresh'">
    <xsl:call-template name="idxrefresh">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='prev'">
    <xsl:call-template name="idxprev">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='next'">
    <xsl:call-template name="idxnext">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='seek'">
    <xsl:call-template name="idxseek">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='closeonly'">
    <xsl:call-template name="idxcloseonly">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='close'">
    <xsl:call-template name="idxclose">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="$value='check'">
    <xsl:call-template name="idxcheck">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template match="*[@id]" mode="template" name="hxparser">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="disable" select="''"/>
  <xsl:choose>
   <!--xsl:when test="substring-before(@id,'-')='hxp'"-->
   <xsl:when test="starts-with(@id,'hxp')">
    <xsl:variable name="value" select="substring-after(@id,'-')"/>
    <xsl:choose>
     <xsl:when test="substring-before($value,'-')='idx'">
      <xsl:choose>
       <xsl:when test="starts-with(substring-after($value,'-'),'action-')">
        <xsl:call-template name="idxaction">
         <xsl:with-param name="value" select="substring-after($value,'action-')"/>
         <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
       </xsl:when>
       <xsl:otherwise>
        <xsl:call-template name="hxperrorhandler">
         <xsl:with-param name="blockData" select="$blockData"/>
        </xsl:call-template>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpidhandler">
       <xsl:with-param name="blockData" select="$blockData"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy>
     <xsl:copy-of select="@*"/>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
      <xsl:with-param name="disable" select="$disable"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

</xsl:stylesheet>
