<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina per lookup su thesauro vincolato
Se si vuole che il riempimento dei campi della form opener avvenga in automatico nel caso in cui
sia stata trovata una sola vole di lookup (saltando la paigina di visualizzazione e scelta della voci trovate)
occorre inserire id="hxp-thesauro-action-oneSkipPage" direttamente nel tag <html> iniziale del template 
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/thesauro.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/keylist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<!--<xsl:attribute name="onblur">self.close();</xsl:attribute>-->
		<xsl:attribute name="onKeyPress">submitOnEnter(event)</xsl:attribute> <!-- necessario per il posizionamento -->
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="thesauro_response" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="lookup_new" value="{$hxpdata/@lookup_new}" />
			<input type="hidden" name="lookup_campi" value="{$hxpdata/@lookup_campi}" />				
			<input type="hidden" name="lookup_fieldVal" value="{$hxpdata/@lookup_fieldVal}" />
			<input type="hidden" name="selected_campi" value="{$hxpdata/@selected_campi}" />			
   			<input type="hidden" name="relRules" value="{$hxpdata/@relRules}"/>
	   		<input type="hidden" name="firstKey" value="{$hxpdata/@firstKey}"/>
   			<input type="hidden" name="lastKey" value="{$hxpdata/@lastKey}"/>   		
   			<!-- Gestione posizionamento (Fede) -->
   			<input type="hidden" name="shwMode"  value="{$hxpdata/@shwMode}"/>  <!-- modalit di presentazione: codice a 2 byte 'dt' se  una data -->
   			<input type="hidden" name="cPath"    value="{$hxpdata/@cPath}"/>    <!-- percorso comune -->
   			<input type="hidden" name="startkey" value="{$hxpdata/@startkey}"/> <!-- chiave su cui posizionarsi -->
   			<input type="hidden" name="keylower" value=""/>                     <!-- se leggere verso minore (pagina precedente) -->
   			<input type="hidden" name="keypath" value="{$hxpdata/@keypath}" />  <!-- la chiave -->
   			<input type="hidden" name="minFreq" value="{$hxpdata/@minFreq}" />  <!-- frequenza minima -->
			<input type="hidden" name="maxFreq" value="{$hxpdata/@maxFreq}" />  <!-- frequenza massima -->
			<input type="hidden" name="minRes" value="{$hxpdata/@minRes}" />    <!-- risoluzione minima -->
   			<!-- Fine gestione posizionamento (Fede) -->
		</form>
	</xsl:template>

	<!-- Smistamento dei template hxp-thesauro-data-...
	-->
	<xsl:template name="thesaurodata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$value='tittext'"> <!-- visualizzazione del testo del titolo -->
					<xsl:value-of select="$blockData/@testo"/>
				</xsl:when>
				<xsl:when test="$value='thestitle'"> <!-- visualizzazione del tipo di thesauro -->
					<xsl:value-of select="$hxpdata/@view"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<!-- Smistamento dei template hxp-thesauro-data-... Di default non si fa la copia dell'element
		Visualizzazione dell'icona tipica di tabella: id="hxp-thesauro-datanocopy-(nome tabella)"
			Se il titolo e della tabella (tabella) copia l'element altrimenti lo ignora
	-->
	<xsl:template name="thesaurodatanocopy">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
	</xsl:template>


	<!--
	
	  Implementazione dei singoli template action
	
	-->


	<!-- Vai alla pagina dei titoli precedente: id="hxp-thesauro-action-prev" -->
	<xsl:template name="thesauroprev">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@enablePrev='true'">
				<xsl:copy>
					<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina dei titoli successiva: id="hxp-thesauro-action-next" -->
	<xsl:template name="thesauronext">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@enableNext='true'">
				<xsl:copy>
					<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Posizionamento tramite prompt: id="hxp-thesaurogoto" 
	Il Posizionamento sfrutta comunque quanto detto nella "seek"
	ma chiedendo tramite promp un input all'utente.
	-->
	<xsl:template name="thesaurogoto">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@enableNext='true' or $hxpdata/@enablePrev='true'">
				<xsl:copy>
					<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0)</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>PosizionamentoTermineThesauro();return false</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Chiudi la pagina di thesauro: id="hxp-thesauro-action-cancel" -->
	<xsl:template name="thesaurocancel">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return closeLookup();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Conferma il riempimento della form: id="hxp-thesauro-action-confirm" -->
	<xsl:template name="thesauroconfirm">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return confirmLookup();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gestisce il radiobutton associato a un titolo: id="hxp-thesauro-action-radio" 
	Il name dei radio button deve essere "lookup".
	La form che contiene i radio si deve chiamare "theForm".
	-->
	<xsl:template name="thesauroradio">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>radioSele(this,event); setFields('</xsl:text>
				<xsl:call-template name="quoteString">
					<xsl:with-param name="stringa" select="$blockData/@campo" />
				</xsl:call-template>
				<xsl:text>=</xsl:text>
				<xsl:call-template name="quoteString">
					<xsl:with-param name="stringa" select="$blockData/@testo" />
				</xsl:call-template>
				<xsl:text>'</xsl:text>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="value">
				<!-- Gregorio RW 0034473 xsl:value-of select="$blockData/@indice" / -->
				<xsl:value-of select="$blockData/@testo" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Gestisce il checkbox associato a un titolo: id="hxp-thesauro-action-checkbox" 
	La form che contiene i checkbox si deve chiamare "theForm".
	-->
	<xsl:template name="thesaurocheckbox">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>checkSele(this,event); setFields('</xsl:text>
				<xsl:call-template name="quoteString">
					<xsl:with-param name="stringa" select="$blockData/@campo" />
				</xsl:call-template>
				<xsl:text>=');</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$blockData/@testo" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Per evitare la visualizzazione dei titoli nel caso in cui venga restituita una sola voce di lookup
	trovata. Il riempimento dei campi avviene in automatico.
		id="hxp-thesauro-action-doceditoneSkipPage" 
	-->
	<xsl:template name="thesaurooneSkipPage">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$hxpdata/@count = 1">

					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				
					<script>
						<xsl:text>setFields('</xsl:text>
						<xsl:call-template name="quoteString">
							<xsl:with-param name="stringa" select="$hxpdata/titolo/@campo" />
						</xsl:call-template>
						<xsl:text>=</xsl:text>
						<xsl:call-template name="quoteString">
							<xsl:with-param name="stringa" select="$hxpdata/titolo/@testo" />
						</xsl:call-template>
						<xsl:text>'</xsl:text>
						<xsl:text>);</xsl:text>
						confirmLookup();
						//self.close();
					</script>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>		


	<!-- Inserisce un nuovo termine nel thesauro: id="hxp-thesauro-action-new" -->
	<xsl:template name="thesauronew">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return newTermine();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!-- Rinomina un termine nel thesauro: id="hxp-thesauro-action-rename" (Federico) -->
	<xsl:template name="thesaurorename">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return renameTermine();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	

	<!-- Elimina un termine dal thesauro: id="hxp-thesauro-action-remove" -->
	<xsl:template name="thesauroremove">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return removeTermine();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Copia l'elemento contenente l'id se la funzionalit specifica 
	     corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	     id="hxp-thesauro-action-enableFunctionality-(attributo da testare)"
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>	
	
	<!-- 
		Modifica di Federico del 15/10/2004:
	 	al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
	 	radio button nel thesauro vincolato (si veda anomalia 0022367).
	 	Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
	 	che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
	 	(possibili usi futuri).
		
		Copia l'elemento contenuto nell'id a seconda del valore di thVOptions.

	    id="hxp-thesauro-action-testThVOptions-(valore da confrontare con thVOptions)"
	     
	    (template aggiunto per consentire di avere una selezione multipla di valori nel 
	    th vincolato in fase di ricerca. Funzionalit richiesta per XSpring)
	-->
	<xsl:template name="testThVOptions">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal=$hxpdata/@thVOptions">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>	
	
	<!-- Smistamento dei template hxp-thesauro-action-... -->
	<xsl:template name="thesauroaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='enableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">					
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>	
			<!-- 
				Modifica di Federico del 15/10/2004:
			 	al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
			 	radio button nel thesauro vincolato (si veda anomalia 0022367).
			 	Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
			 	che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
			 	(possibili usi futuri).
			 -->
			<xsl:when test="substring-before($value,'-')='testThVOptions'">
				<xsl:call-template name="testThVOptions">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>	
			<xsl:when test="$value='remove'">
				<xsl:call-template name="thesauroremove">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='new'">
				<xsl:call-template name="thesauronew">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="thesauroprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="thesauronext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='goto'">
				<xsl:call-template name="thesaurogoto">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='cancel'">
				<xsl:call-template name="thesaurocancel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='confirm'">
				<xsl:call-template name="thesauroconfirm">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- rinomina una chiave del thesaurus (Federico) --> 
			<xsl:when test="$value='rename'">
				<xsl:call-template name="thesaurorename">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>			
			<xsl:when test="$value='radio'">
				<xsl:call-template name="thesauroradio">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkbox'">
				<xsl:call-template name="thesaurocheckbox">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='oneSkipPage'">
				<xsl:call-template name="thesaurooneSkipPage">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>	
			
			<!-- Gestione posizionamento (Fede) -->		
			<xsl:when test="$value='seek'">
		    	<xsl:call-template name="thseek">
			    	<xsl:with-param name="blockData" select="$blockData"/>
			    </xsl:call-template>
		    </xsl:when>
   			<!-- Fine gestione posizionamento (Fede) -->		
			
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
			    	<xsl:with-param name="blockData" select="$blockData"/>
			    </xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	
	<xsl:template match="key-hit">
		<span class="key-hit">
			<xsl:apply-templates />
		</span>
	</xsl:template>
	
	<!-- Gestione posizionamento (Fede) -->
	
	<xsl:template name="thSeekJsAction">
	  <xsl:text>return posiziona(getForm('seek').seektext.value,'</xsl:text>
	  <xsl:value-of select="$hxpdata/@keypath"/>
	  <xsl:text>');</xsl:text>
	</xsl:template>
	
	<xsl:template name="thseek">
	  <xsl:param name="blockData" select="''"/>
	  <xsl:copy>
	   <xsl:copy-of select="@*[name()!='id']"/>
	   <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
	   <xsl:attribute name="onclick">
	   		<xsl:call-template name="thSeekJsAction"/>
	   </xsl:attribute>
	   <xsl:call-template name="hxpcontinuecontext">
	    <xsl:with-param name="blockData" select="$blockData"/>
	   </xsl:call-template>
	  </xsl:copy>
	</xsl:template>
	
	<!-- Fine gestione posizionamento (Fede) -->
	
	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='thesauro'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-thesauro-action-... -->
								<xsl:call-template name="thesauroaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-thesauro-data-... -->
								<xsl:call-template name="thesaurodata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'datanocopy-')"> <!-- hxp-thesauro-datanocopy-... -->
								<xsl:call-template name="thesaurodatanocopy">
									<xsl:with-param name="value" select="substring-after($value,'datanocopy-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
