<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl" />

	<!-- Javascript da includere -->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/keylist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/titleLookup.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:attribute name="scroll">auto</xsl:attribute>
	</xsl:template>
	
	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<form method="post" name="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="titleLookup" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="listCriteria" value="" />
			<input type="hidden" name="listElements" value="" />
			<input type="hidden" name="outBoundary" value="" />
			<input type="hidden" name="inBoundary" value="" />
		</form>
	</xsl:template>
	
	<xsl:template name="titlelookupdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$value='pagenumber'">
					<xsl:number value="floor($hxpdata/@pos div $hxpdata/@keyCount + 1)" format="1" />
				</xsl:when>
				<xsl:when test="$value='numberofpages'">
					<xsl:number value="floor(($hxpdata/@count + $hxpdata/@keyCount - 1) div $hxpdata/@keyCount)" format="1" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
				    	<xsl:with-param name="blockData" select="$blockData"/>
				    </xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="titlelookupSeekJsAction">
		<xsl:text>return posiziona(getForm('seek').seektext.value,'</xsl:text>
		<xsl:value-of select="$hxpdata/@keypath" />
		<xsl:text>');</xsl:text>
	</xsl:template>
	
	<xsl:template match="form[//@id='hxp-titlelookup-action-next']" mode="template">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="action">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onsubmit">
				<xsl:call-template name="titlelookupSeekJsAction" />
			</xsl:attribute>
			<xsl:apply-templates select="node()" mode="template" />
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="titlelookupseek">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:call-template name="titlelookupSeekJsAction" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="titlelookupfirst">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return primaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="titlelookupprev">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaPrecedente(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@keyCount" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="titlelookupnext">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@keyCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@keyCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="titlelookuplast">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@keyCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return ultimaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@keyCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="titlelookupclose">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return closeLookup();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="titlelookupcheck">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>checkSele(this,event)</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$blockData/@ndoc" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<xsl:template name="titlelookupaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$value='first'">
				<xsl:call-template name="titlelookupfirst">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="titlelookupprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="titlelookupnext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last'">
				<xsl:call-template name="titlelookuplast">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='seek'">
				<xsl:call-template name="titlelookupseek">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='close'">
				<xsl:call-template name="titlelookupclose">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='check'">
				<xsl:call-template name="titlelookupcheck">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template match="key-hit">
		<span class="key-hit">
			<xsl:apply-templates />
		</span>
	</xsl:template>
	
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='titlelookup'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')">
								<xsl:call-template name="titlelookupaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')">
								<xsl:call-template name="titlelookupdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

</xsl:stylesheet>
