<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Pagina dei titoli

N.B - E' possibile utilizzare una icona associata a ogni titolo scelta in base alla tabella del
documento. Se si vuole utilizzare questa funzionalit occorre specificare come primo elemento del titolo il
nodo primario del documento con la sintassi:
	UD,/xw/@UdType "epn" (titolo)

	"|epn|" serve per evitare che il nome del nodo primario appaia nel titolo.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
				xmlns:xw="http://www.3di.it/ns/xw-200203121136"
				exclude-result-prefixes="xw"> <!-- Federico 07/07/05: per eliminare "xmlns:*" nell'html finale -->

	<xsl:include href="hxp.xsl" />
	<xsl:include href="filelist_embedded.xsl"/> <!--  Per l'utilizzo di iw -->
	<xsl:include href="navbar.xsl"/> <!--per scorrimento numerico pagina titoli AAA-->

	<!-- Javascript da includere -->
	<xsl:template name="jslist">

		<xsl:call-template name="jslist_embedded"/> <!-- per iw -->

		<!-- Per effettuare ricerche dalla pagina dei titoli -->
		<xsl:if test="count(//*[@id='hxp-title-include-query'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/query.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
			<xsl:if test="count(//*[@id='hxp-query-include-query_chk_restriction'])>0">
				<script>
					<xsl:attribute name="src">../../../formatter/html/data/js/query_chk_restriction.js</xsl:attribute>
					<xsl:attribute name="type">text/javascript</xsl:attribute>
					<xsl:text>;</xsl:text>
				</script>
			</xsl:if>
		</xsl:if>

		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/titles.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/keylist.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/iduid.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/navbar.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/formTupleRestore.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>

		<!-- Federico 28/03/07: librerie per il parsing xml con Ajax e stampa degli allegati [RW 0043253] -->
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/xml.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/dom-drag.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/printFiles.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/base64.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:call-template name="bodyattributes_embedded"/>
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">

		<!-- Per effettuare ricerche dalla pagina dei titoli -->
		<xsl:if test="count(//*[@id='hxp-title-include-query'])>0">
			<form method="post" id="indexForm" target="indexWindow" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
				<div>
				<xsl:call-template name="sessiondata" />
				<input type="hidden" name="verbo" value="showindex" />
				<input type="hidden" name="xverb" value="" />
				<input type="hidden" name="keypath" value="" />
				<input type="hidden" name="fillField" value="" />
				<input type="hidden" name="startkey" value="" />
				<input type="hidden" name="keyCount" value="{$hxpdata/@keyCount}" />
				<input type="hidden" name="threl" value="" />
				<input type="hidden" name="doubleKey" value="" />
				<input type="hidden" name="shwMode" value="" />
				<input type="hidden" name="xMode" value="" />
				<input type="hidden" name="minf" value="{$hxpdata/@minf}" />
				<input type="hidden" name="maxf" value="{$hxpdata/@maxf}" />
				<input type="hidden" name="xRels" value="" />
				<input type="hidden" name="vRels" value="" />
				<input type="hidden" name="cPath" value="" />
				<input type="hidden" name="lRel" value="" />
				<input type="hidden" name="sele" value="" />
				<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
				</div>
			</form>
		</xsl:if>

		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<div>
			<xsl:call-template name="sessiondata" />
			<input type="hidden" name="verbo" value="showtitles" />
			<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
			<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
			<input type="hidden" name="ripropz" value="{$hxpdata/@ripropz}" /> <!-- riproduzioni opzionali -->
			<input type="hidden" name="xDoc" value="" />
			<input type="hidden" name="qord" value="{$hxpdata/@qord}" />
			<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
			<input type="hidden" name="titColOrd" value="{$hxpdata/@titColOrd}" />
			<input type="hidden" name="rifInt" value="{$hxpdata/@rifInt}" /> <!-- esclusivo per i riferimenti interni -->

			<!--
				Modifica di Federico del 07/12/2004:
				tupla necessaria per la visualizzazione (apertura del thesauro dalle molliche relative alla
				classificazione del documento).
			-->
			<input type="hidden" name="cPath" value="{$hxpdata/@cPath}"/>    <!-- percorso comune -->

			<!-- Per effettuare ricerche dalla pagina dei titoli -->
			<xsl:if test="count(//*[@id='hxp-title-include-query'])>0">
				<input type="hidden" name="repVisComp" value="" />
			</xsl:if>

			<!--
				Federico 21/11/05: introdotta gestione della 'personalView' per tornare alla pagina di ricerca da
				cui si e' partiti [RW 0032015].
			-->
			<input type="hidden" name="personalView" value="{$hxpdata/@personalViewToUse}" />

			<!-- specifici -->
			<xsl:call-template name="contextcustom">
				<xsl:with-param name="specName" select="'beforeend'"/>
			</xsl:call-template>

			<xsl:call-template name="beforeend_embedded"/>
			</div>
		</form>
	</xsl:template>


	<!--

	  Implementazione dei singoli template action

	-->


	<!-- id="hxp-title-data-vispart-(num)"
	     Visualizzazione della (num)esima parte di titolo.
	     Si assume che il titolo abbia il '|' come separatore.
	-->
	<xsl:template name="titlevispart">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="partnum" select="'1'" />
		<xsl:param name="iternum" select="'1'" />
		<xsl:param name="testo" select="$blockData/@testo" />
		<xsl:param name="visdata" select="'0'" />
		<!-- RW0047864 - 05/11/2007 - fcossu -->
		<xsl:param name="ln" select="''" />
		<xsl:copy>
			<xsl:choose>
				<xsl:when test="$iternum=$partnum">
					<xsl:choose>
						<xsl:when test="substring-after($testo,'|')!=''">
							<xsl:choose>
								<xsl:when test="$visdata='1'">
									<xsl:if test="not(starts-with($testo,'~'))">  <!-- capita in conversione di doc -->
										<xsl:call-template name="dateformatter">
											<xsl:with-param name="datas" select="substring-before($testo,'|')"/>
										</xsl:call-template>
									</xsl:if>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="substring-before($testo,'|')"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:choose>
								<xsl:when test="$visdata='1'">
									<xsl:if test="not(starts-with($testo,'~'))">  <!-- capita in conversione di doc -->
										<xsl:call-template name="dateformatter">
											<xsl:with-param name="datas" select="$testo"/>
										</xsl:call-template>
									</xsl:if>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="$testo"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
					<!-- RW0047864 - 05/11/2007 - fcossu -->
					<xsl:if test="$ln!='' and not($testo='') and not(starts-with($testo,'|'))">
						<xsl:copy>	
							<br/>
						</xsl:copy>
					</xsl:if>
					<!-- introduced by Mario per la descrizione dei repertori -->
					<xsl:if test="$partnum='12' and not($testo='') and not(starts-with($testo,'|'))">
						<xsl:copy>
							<br/>
						</xsl:copy>
					</xsl:if>
					<!-- end introduced by Mario -->
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="titlevispart">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="partnum" select="$partnum" />
						<xsl:with-param name="iternum" select="$iternum+1" />
						<xsl:with-param name="testo" select="substring-after($testo,'|')" />
						<xsl:with-param name="visdata" select="$visdata" />
						<!-- RW0047864 - 05/11/2007 - fcossu -->
						<xsl:with-param name="ln" select="$ln" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>

	<!-- RW0048021 - 30/11/2007 - fcossu -->
	<xsl:template name="titlevisspecpart">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="partnum" select="''" />
		<xsl:param name="visdata" select="'0'" />
		<!-- RW0047864 - 05/11/2007 - fcossu -->
		<xsl:param name="ln" select="''" />
		<xsl:copy>
			<xsl:variable name="result">
				<xsl:value-of select="substring-before(substring-after(concat($blockData/@testo, '|'), $partnum), '|')"/>
			</xsl:variable>
			<xsl:choose>
				<xsl:when test="$visdata='1'">
					<xsl:if test="not(starts-with($blockData/@testo,'~'))">  <!-- capita in conversione di doc -->
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$result"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$result"/>
				</xsl:otherwise>
			</xsl:choose>
			<!-- RW0047864 - 05/11/2007 - fcossu -->
			<xsl:if test="$ln!='' and not($result='')">
				<xsl:copy>	
					<br/>
				</xsl:copy>
			</xsl:if>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-title-data-...
		Numero di pagina: id="hxp-title-data-pagenumber"
		Numero totale di pagine: id="hxp-title-data-numberofpages"
		Posizione del primo titolo della pagina: id="hxp-title-data-firstposition"
		Posizione dell'ultimo titolo della pagina: id="hxp-title-data-lastposition"
		Numero totale di titoli: id="hxp-title-data-count"
		Barra di navigazione tra i documenti:
			id="hxp-title-data-navbar" - le immagini della barra di navigazione sono prese dal path di default.
			id="hxp-title-data-navbar-(path)" - le immagini della barra di navigazione sono prese dal path indicato.
			In ogni caso le immagini devono chiamarsi:
				"a_rr.gif" : indicatore di ultima pagina selezionata
				"a_rl.gif" : indicatore di pagina selezionata
				"a_gr.gif" : indicatore di scelta pagina successiva
				"a_gl.gif" : indicatore di scelta pagina precedente
		Testo del titolo: id="hxp-title-data-tittext"
	-->
	<xsl:template name="titledata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$value='pagenumber'">
					<xsl:number value="floor($hxpdata/@pos div $hxpdata/@pageCount + 1)" format="1" /> <!-- numero di pagina -->
				</xsl:when>
				<xsl:when test="$value='numberofpages'">
					<xsl:number value="floor(($hxpdata/@count + $hxpdata/@pageCount - 1) div $hxpdata/@pageCount)" format="1" /> <!-- numero totale di pagine -->
				</xsl:when>
				<xsl:when test="$value='firstposition'"> <!-- posizione del primo titolo della pagina -->
					<xsl:number value="$hxpdata/@pos + 1" format="1" />
				</xsl:when>
				<xsl:when test="$value='lastposition'"> <!-- posizione dell'ultimo titolo della pagina -->
					<xsl:choose>
						<xsl:when test="$hxpdata/@pos + $hxpdata/@pageCount > $hxpdata/@count">
							<xsl:number value="$hxpdata/@count" format="1" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:number value="$hxpdata/@pos + $hxpdata/@pageCount" format="1" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:when test="$value='count'"> <!-- numero totale di titoli -->
					<xsl:number value="$hxpdata/@count" format="1" />
				</xsl:when>
				<xsl:when test="starts-with($value,'navbar')"> <!-- barra di navigazione -->
                                        <!-- mozilla hangs with document.write (see titles.js) -->
                                        <span id="titnavbarcode" style="display:none">
					<!--script-->                                    <!-- se nella forma hxp-title-data-navbar-(path) cerca -->
						<xsl:text>/*document.write(*/titnavbarcode(</xsl:text>  <!-- le immagini in (path) altrimenti se nella forma hxp-title-data-navbar usa path di default -->
						<xsl:value-of select="$hxpdata/@pos"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount"/>
						<xsl:if test="substring-after($value,'-')!=''">
							<xsl:text>,'</xsl:text>
							<xsl:value-of select="substring-after($value,'-')"/>
							<xsl:text>'</xsl:text>
						</xsl:if>
						<xsl:text>)/*)*/</xsl:text>
					<!--/script-->
                                        </span>
				</xsl:when>
				<xsl:when test="starts-with($value,'numnavbar')"> <!-- barra di navigazione -->
				<!--
                                        <span id="numtitnavbarcode" style="display:none">

						<xsl:text>numtitnavbarcode(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount"/>
						<xsl:text>)</xsl:text>

                                        </span>
                                -->
                                <xsl:call-template name="numtitnavbarcode"/>
				</xsl:when>
				<xsl:when test="$value='tittext'"> <!-- visualizzazione del testo del titolo -->
					<xsl:value-of select="$blockData/@testo"/>
				</xsl:when>
				<xsl:when test="$value='titheader'"> <!-- visualizzazione dell'eventuale header del titolo (quello visualizzato a rottura)-->
					<xsl:value-of select="$blockData/@header"/>
				</xsl:when>
				<xsl:when test="starts-with($value,'vispart-')">
					<xsl:call-template name="titlevispart">
						<xsl:with-param name="blockData" select="$blockData" />
						<!-- RW0047864 - 05/11/2007 - fcossu -->
						<xsl:with-param name="partnum">
							<xsl:choose>
								<xsl:when test="contains($value, 'ln')">
									<xsl:value-of select="substring-after($value,'-ln-')" />
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="substring-after($value,'-')" />
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
						<xsl:with-param name="ln">
							<xsl:if test="contains($value, 'ln')">
								<xsl:text>yes</xsl:text>
							</xsl:if>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="starts-with($value,'vispartdata-')">
					<xsl:call-template name="titlevispart">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="partnum" select="substring-after($value,'-')" />
						<xsl:with-param name="visdata" select="'1'" />
					</xsl:call-template>
				</xsl:when>
				<!-- RW0048021 - 30/11/2007 - fcossu -->
				<xsl:when test="starts-with($value,'visspecpart-')">
					<xsl:call-template name="titlevisspecpart">
						<xsl:with-param name="blockData" select="$blockData" />
						<!-- RW0047864 - 05/11/2007 - fcossu -->
						<xsl:with-param name="partnum">
							<xsl:choose>
								<xsl:when test="contains($value, 'ln')">
									<xsl:value-of select="substring-after($value,'-ln-')" />
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="substring-after($value,'-')" />
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
						<xsl:with-param name="ln">
							<xsl:if test="contains($value, 'ln')">
								<xsl:text>yes</xsl:text>
							</xsl:if>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="starts-with($value,'visspecpartdata-')">
					<xsl:call-template name="titlevisspecpart">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="partnum" select="substring-after($value,'-')" />
						<xsl:with-param name="visdata" select="'1'" />
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<!-- Smistamento dei template hxp-title-datanocopy-... Di default non si fa la copia dell'element
		Visualizzazione dell'icona tipica di tabella: id="hxp-title-datanocopy-(nome tabella)"
			Se il titolo e della tabella (tabella) copia l'element altrimenti lo ignora
	-->
	<xsl:template name="titledatanocopy">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="substring-before($value,'-')='tabicon'"> <!-- icona di tabella -->
				<xsl:if test="$blockData/@dbTable=substring-after($value,'-')">
					<xsl:copy>
						<xsl:for-each select="@*[name()!='id']">
							<xsl:call-template name="stringparser">
								<xsl:with-param name="data" select="$blockData" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='personalViewIcon'"> <!-- icona di personal view -->
				<xsl:if test="$blockData/@icon!=''">
					<xsl:copy>
						<xsl:for-each select="@*[name()!='id']">
							<xsl:call-template name="stringparser">
								<xsl:with-param name="data" select="$blockData" />
							</xsl:call-template>
						</xsl:for-each>
						<xsl:attribute name="src">
							<xsl:value-of select="$blockData/@icon"/>
						</xsl:attribute>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:when test="$value='personalViewIconAnnullato'">  <!-- icona di personal view per annullato -->
				<xsl:if test="$blockData/@icon!=''">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:attribute name="src">
							<xsl:call-template name="do-replace">
								<xsl:with-param name="text" select="$blockData/@icon"/>
								<xsl:with-param name="replace">.gif</xsl:with-param>
								<xsl:with-param name="by">_annullato.gif</xsl:with-param>
							</xsl:call-template>
						</xsl:attribute>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
				<xsl:when test="$value='stpTitle'">
					<xsl:value-of select="substring-after($hxpdata/@stpTitle,'|')"/>
				</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!--

	  Implementazione dei singoli template action

	-->

	<!-- Inserimento di un documento in una raccolta: id="hxp-title-action-collect" -->
	<xsl:template name="titlecollect">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@cName != '' and $hxpdata/@cId != $hxpdata/@selid">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<!--
							<xsl:text>return collection();</xsl:text>
						-->
						<xsl:text>return gotoTableQ('</xsl:text>
						<xsl:value-of select="$tableName"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Sposta indietro un titolo: id="hxp-title-action-up" -->
	<xsl:template name="titleup">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="$blockData/@indice - 1 > $hxpdata/@pos">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return spostaIndietro(</xsl:text>
						<xsl:value-of select="$blockData/@indice - 1" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Sposta avanti un titolo: id="hxp-title-action-down" -->
	<xsl:template name="titledown">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="($hxpdata/@pos + $hxpdata/@pageCount > $blockData/@indice) and ($hxpdata/@count > $blockData/@indice)">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return spostaAvanti(</xsl:text>
						<xsl:value-of select="$blockData/@indice - 1" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla prima pagina dei titoli: id="hxp-title-action-first" -->
	<xsl:template name="titlefirst">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return primaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina dei titoli precedente: id="hxp-title-action-prev" -->
	<xsl:template name="titleprev">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaPrecedente(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina dei titoli successiva: id="hxp-title-action-next" -->
	<xsl:template name="titlenext">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@pageCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Gregorio_Aggiunta -->
	<!-- completare / verificare: sel la selezione  una raccolta ?? -->
	<!-- Bottone Scarta documento: rimuove il/i documento/i dalla selezione corrente -->
	<xsl:template name="removeDocFromSel">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:if test="name()='a'"><xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute></xsl:if>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return deselect(</xsl:text>
				<xsl:value-of select="$hxpdata/@pos" />
				<xsl:text>, </xsl:text>
				<xsl:value-of select="$hxpdata/@count" />
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Bottone Scarta documento: rimuove il/i documento/i dalla selezione corrente -->
	<xsl:template name="collectionManager">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
				<xsl:with-param name="disable" select="'1'" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="collectionChange">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
				<xsl:with-param name="disable" select="'1'" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vai all'ultima pagina dei titoli: id="hxp-title-action-last" -->
	<xsl:template name="titlelast">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+$hxpdata/@pageCount">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return ultimaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Vai alla pagina ennesima: id="hxp-title-action-goto-->
	<xsl:template name="titlegoto">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:choose>
			<xsl:when test="($hxpdata/@pos>0 or $hxpdata/@count>$hxpdata/@pos+$hxpdata/@pageCount) and ($hxpdata/@count>$hxpdata/@pageCount*2)">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return gotoPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Vai alla pagina degli strumenti di amministrazione: id="hxp-title-action-titleexport-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<!--<xsl:template name="querygototableq">-->
	<xsl:template name="titleexport">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Nuova ricerca (chiudi la pagina dei titoli se esiste): id="hxp-title-action-query" -->
	<xsl:template name="titlequery">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return nuovaRicerca();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* created on: 28/10/2004
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Questo template gestisce l'id 'hxp-title-action-printProfiles', sostituendolo con la chiamata
		* alla funzione javascript che apre la pagina dei profili di stampa.
	-->
	<xsl:template name="titlePrintProfiles">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return printProfiles();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Visualizza un documento: id="hxp-title-action-document" -->
<!--	<xsl:template name="titledoc">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:choose>
				<xsl:when test="$blockData/@db!=''">
					<xsl:choose>
						<xsl:when test="$blockData/@db='titlex' or $blockData/@db='ecogeo'">
							<xsl:attribute name="style">
								<xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onclick">
								<xsl:text>return mostraDocumento(</xsl:text>
								<xsl:value-of select="number($blockData/@indice) - 1" />
								<xsl:text>, '</xsl:text>
								<xsl:value-of select="$blockData/@db" />
								<xsl:text>');</xsl:text>
							</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="string($_doctype)='titlex' or string($_doctype)='ecogeo'">
							<xsl:attribute name="style">
								<xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onclick">
								<xsl:text>return mostraDocumento(</xsl:text>
								<xsl:value-of select="number($blockData/@indice) - 1" />
								<xsl:text>, '</xsl:text>
								<xsl:value-of select="$_doctype" />
								<xsl:text>');</xsl:text>
							</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>-->

	<!--
		DD 20/04/06 aggiunto il parametro nomefunzionejs (default:'mostraDocumento')
		che permette di specificare una funzione js diversa da chiamare (record: 0035917) Visualizzazione immagini su finestra a parte
	-->
	<xsl:template name="titledoc">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:param name="nomefunzionejs" select="'mostraDocumento'"/>
		<xsl:copy>
			<!--
				<xsl:copy-of select="@*[name()!='id']"/>
			-->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>

			<!--
				Federico 31/07/07: se nella tupla 'toDo' e' presente '__DISABLE_TITSHOWDOC__' non bisogna inserire
				i link che consentono di visualizzare i documenti [RW 0046016]
			-->
			<xsl:if test="not(contains($hxpdata/@toDo,'__DISABLE_TITSHOWDOC__'))">
				<xsl:if test="$nomefunzionejs!=''">
	   			<xsl:attribute name="href">
	   				<!--
	   					Federico 16/06/05:
	   					se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
	   					per aprire il doc. che il titolo rappresenta.
	   				-->
	   				<xsl:choose>
	   					<xsl:when test="$nojs!='1'">
	   						<xsl:text>javascript:void(0);</xsl:text>
	   					</xsl:when>
	   					<xsl:otherwise>
	   						<!-- inserimento dell'url al posto della chiamata js -->
	   						<xsl:value-of select="$hxpdata/@uri"/>
	   						<xsl:text>?db=</xsl:text>
	   						<xsl:value-of select="$blockData/@db"/>
	   						<xsl:text>&amp;transformJava=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@transformJava"/>
	   						<xsl:text>&amp;verbo=showdoc&amp;xverb=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@xverb"/>
	   						<xsl:text>&amp;view=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@view"/>
	   						<xsl:text>&amp;enableIW=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@enableIW"/>
	   						<xsl:text>&amp;pos=</xsl:text>
	   						<xsl:value-of select="number($blockData/@indice) - 1"/>
	   						<xsl:text>&amp;count=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@count"/>
	   						<xsl:text>&amp;selid=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@selid"/>
	   						<xsl:text>&amp;pageCount=</xsl:text>
	   						<xsl:value-of select="$hxpdata/@pageCount"/>
	   						<xsl:text>&amp;xDoc=</xsl:text>
	   						<xsl:value-of select="$params"/>
	   						<!-- mbussetti, 20/09/2005: inserita trasmissione di 'dbTable' -->
	   						<xsl:if test="$blockData/@dbTable and $blockData/@dbTable!=''">
	   							<xsl:text>&amp;dbTable=</xsl:text>
	   							<xsl:value-of select="$blockData/@dbTable" />
	   						</xsl:if>

	   						<!-- dati di autenticazione -->
	   						<xsl:call-template name="aclparams"/>
	   					</xsl:otherwise>
	   				</xsl:choose>
	   			</xsl:attribute>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="$blockData/@db!=''">
						<xsl:choose>
							<xsl:when test="$blockData/@db='titlex'"> <!-- or $blockData/@db='ecogeo' -->
								<xsl:attribute name="style"><xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<!--
									Federico 16/06/05:
									se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
									per aprire il th. gerarchico.
								-->
								<xsl:if test="$nojs!='1'">
								  <xsl:if test="$nomefunzionejs!=''">
	   								<xsl:attribute name="onclick">
										<xsl:if test="string-length(@onclick) &gt; 0">
											<xsl:value-of select="@onclick"/>
											<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
												<xsl:text>;</xsl:text>
											</xsl:if>
										</xsl:if>
	   									<!--<xsl:text>return mostraDocumento(</xsl:text>-->
	   									<xsl:value-of select="concat('return ', $nomefunzionejs, '(')"/>
	   									<xsl:value-of select="number($blockData/@indice) - 1"/>
	   									<xsl:text>, '</xsl:text>
	   									<xsl:value-of select="$blockData/@db" />
	   									<xsl:text>',0,'</xsl:text>
	   									<xsl:value-of select="$params" />
	   									<!-- mbussetti, 20/09/2005: inserita trasmissione di 'dbTable' -->
	   									<xsl:if test="$blockData/@dbTable and $blockData/@dbTable!=''">
	   										<xsl:text>', '</xsl:text>
	   										<xsl:value-of select="$blockData/@dbTable" />
	   									</xsl:if>
	   									<xsl:text>');</xsl:text>
	   								</xsl:attribute>
	                              </xsl:if>
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="string($_doctype)='titlex'"> <!-- or string($_doctype)='ecogeo' -->
								<xsl:attribute name="style"><xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<!--
									Federico 16/06/05:
									se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
									per aprire il th. gerarchico.
								-->
								<xsl:if test="$nojs!='1'">
									<xsl:attribute name="onclick">
										<!--<xsl:text>return mostraDocumento(</xsl:text>-->
										<xsl:value-of select="concat('return ', $nomefunzionejs, '(')"/>
										<xsl:value-of select="number($blockData/@indice) - 1"/>
										<xsl:text>, '</xsl:text>
										<xsl:value-of select="$_doctype" />
										<xsl:text>',0,'</xsl:text>
										<xsl:value-of select="$params" />
										<!-- mbussetti, 20/09/2005: inserita trasmissione di 'dbTable' -->
										<xsl:if test="$blockData/@dbTable and $blockData/@dbTable!=''">
											<xsl:text>', '</xsl:text>
											<xsl:value-of select="$blockData/@dbTable" />
										</xsl:if>
										<xsl:text>');</xsl:text>
									</xsl:attribute>
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<xsl:template name="titledoctext">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
			<xsl:choose>
				<xsl:when test="$blockData/@db!=''">
					<xsl:attribute name="onclick"><xsl:text>return mostraDocumento(</xsl:text><xsl:value-of select="number($blockData/@indice) - 1"/><xsl:text>, '</xsl:text><xsl:value-of select="$blockData/@db" /><xsl:text>',0,'</xsl:text><xsl:value-of select="$params" /><xsl:text>');</xsl:text></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="onclick"><xsl:text>return mostraDocumento(</xsl:text><xsl:value-of select="number($blockData/@indice) - 1"/><xsl:text>, '</xsl:text><xsl:value-of select="$_doctype" /><xsl:text>',0,'</xsl:text><xsl:value-of select="$params" /><xsl:text>');</xsl:text></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gestisce il checkbox associato a un titolo: id="hxp-title-action-check" -->
	<xsl:template name="titlecheck">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>checkSele(this,event)</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$blockData/@indice" />
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gregorio_Aggiunta -->
	<!--
	Gestisce il checkbox associato a un titolo: id="hxp-title-action-checkautomatic"
	Il checkbox viene messo con attributo checked=checked senza ausilio di javascript
	 -->
	<xsl:template name="titleautocheck">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="autocheck" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onclick">
				<xsl:text>checkSele(this, event)</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="name">
				<xsl:value-of select="'titleautochecked'" />
			</xsl:attribute>
			<xsl:attribute name="value">
				<xsl:value-of select="$blockData/@indice" />
			</xsl:attribute>
			<xsl:if test="contains($autocheck, concat('{', $blockData/@indice, '}'))">
				<xsl:attribute name="checked">
					<xsl:text>checked</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Vai alla pagina di stampa dei titoli: id="hxp-title-action-print" -->
	<xsl:template name="titleprintitles">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="onclick">
				<xsl:text>return printitles(</xsl:text>
				<xsl:value-of select="$hxpdata/@count" />
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Elimina i titoli selezionati dalla selezione: id="hxp-title-action-deselect" -->
	<!-- cambia anche il baloon nel caso di titoli di raccolta-->
	<xsl:template name="titledeselect">
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count > 1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:choose>
						<xsl:when test="$hxpdata/@cId = $hxpdata/@selid">
							<xsl:attribute name="title">
								<xsl:text>Rimuovi dalla raccolta corrente</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onmouseover">
								<xsl:text>window.status='Rimuovi dalla raccolta corrente';return true</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="title">
								<xsl:text>Rimuovi dalla selezione corrente</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onmouseover">
								<xsl:text>window.status='Rimuovi dalla selezione corrente';return true</xsl:text>
							</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return deselect(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>)</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Scelta di parti di documento da visualizzare nei titoli: id="hxp-title-action-ripropz" -->
	<xsl:template name="titleripropz">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return riprOpzionali(this,event,</xsl:text>
				<xsl:value-of select="$hxpdata/@pos" />
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Eventuale funzionalita' di gestione della casella di selezione di parti di documento da
 visualizzare nei titoli: id="hxp-title-action-selecttitle" -->
	<xsl:template name="titleselecttitle">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="onchange">
				<xsl:text>return selectTitleManager(this,event);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Inversione dell'ordinamento dei titoli: id="hxp-title-action-invertorder" -->
	<xsl:template name="titleinvertordertitle">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return invertOrder();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vai alla pagina di query specifica di tabella: id="hxp-title-action-gototableq-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="titlegototableq">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vai alla pagina di query specifica di tabella e utilizza la selezione corrente per un raffinamento:
	id="hxp-title-action-refinetableq-(nome tabella)"
	(nome tabella)  opzionale. Nel caso in cui venga omesso si suppone che la pagina principale sia quella di ricerca
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="titlerefinetableq">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>','R')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Cancella tutti i documenti di una selezione
	id="hxp-title-action-deleteSel"
	-->
	<xsl:template name="titledeletesel">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return deleteSel();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

 <xsl:template name="titleedit">
  <xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="xparms" select="$hxpdata"/>
  <xsl:choose>
   <xsl:when test="$isAdmin = '1' and $hxpdata/@selid != $hxpdata/@cId">
    <xsl:copy>
     <xsl:copy-of select="@*[name()!='id']"/>
     <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text>
     </xsl:attribute>
     <xsl:attribute name="onclick">
      <xsl:text>return verificaSelezione(</xsl:text>
      <xsl:value-of select="$hxpdata/@pos"/>
      <xsl:text>,</xsl:text><xsl:value-of select="$hxpdata/@count"/>
      <xsl:text>,'</xsl:text><xsl:value-of select="$hxpdata/@selid"/><xsl:text>'</xsl:text>
      <xsl:if test="$xparms!=''">
       <xsl:text>,</xsl:text><xsl:value-of select="$xparms"/>
      </xsl:if>
      <xsl:text>);</xsl:text>
     </xsl:attribute>
     <xsl:call-template name="hxpcontinuecontext">
      <xsl:with-param name="blockData" select="$blockData"/>
     </xsl:call-template>
    </xsl:copy>
   </xsl:when>
   <xsl:otherwise>
    <!--
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="'1'"/>
    </xsl:call-template>
    -->
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

	<!-- Copia l'elemento contenente l'id se la funzionalit specifica
	     corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	     id="hxp-title-action-enableFunctionality-(attributo da testare)"
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Effettua lo store (archiviazione ottica sostitutiva)
	id="hxp-title-action-store"
	-->
	<xsl:template name="titlestore">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return store();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Nella visualizzazione delle tendine automatiche seleziona l'option corrente(elemento che contiene id)
	  nel caso in cui l'elemento option del contesto corrente ha attributo selected="selected"
	  id="hxp-title-action-tendinaSelectIfSelected"
	 -->
	<xsl:template name="titleTendinaSelectIfSelected">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:if test="$blockData/@selected='selected'">
				<xsl:attribute name="selected">
					<xsl:text>selected</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gestisce il checkbox per selezionare tutti i checkbox: id="hxp-title-action-checkAll" -->
	<xsl:template name="titlecheckall">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<!-- 26/07/2006 VMinarini/FOrlandini -->
			<!-- xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="onclick">
				<xsl:text>checkAllSele(this,</xsl:text>
				<xsl:value-of select="$hxpdata/@count"/>
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:if test="$hxpdata/@klAll='true'">
				<xsl:attribute name="checked">
					<xsl:text>checked</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gregorio_Aggiunta -->
	<!-- Gestisce un ancora per deselezionare tutti i checkbox: id="hxp-title-action-checkDeselectAll" -->
	<xsl:template name="titlecheckdeselectall">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>writeKeylist(''); return ricaricaPaginaCorrente(</xsl:text>
				<xsl:value-of select="$hxpdata/@pos"/>
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gregorio_Aggiunta -->
	<!-- Gestisce un ancora per invertire la selezione dei checkbox: id="hxp-title-action-checkReverse" -->
	<xsl:template name="titlecheckreverse">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>writeKeylist(reverseKeylist(getForm('hxpForm').keylist.value, </xsl:text>
				<xsl:value-of select="$hxpdata/@count"/>
				<xsl:text>)); return ricaricaPaginaCorrente(</xsl:text>
				<xsl:value-of select="$hxpdata/@pos"/>
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Gregorio_Aggiunta -->
	<!-- Gestisce un ancora per selezionare tutti i checkbox: id="hxp-title-action-checkSelectAll" -->
	<xsl:template name="titlecheckselectall">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>writeKeylist(generateKeylist(</xsl:text>
				<xsl:value-of select="$hxpdata/@count"/>
				<xsl:text>)); return ricaricaPaginaCorrente(</xsl:text>
				<xsl:value-of select="$hxpdata/@pos"/>
				<xsl:text>)</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Raccoglie tutti i documenti selezionati: id="hxp-title-action-raccogli" -->
	<xsl:template name="titleraccogli">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return raccogli('</xsl:text>
				<xsl:value-of select="$hxpdata/@selid"/>
				<xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Esportazione CSV della selezione (o documenti selezionati): id="hxp-title-action-exportCSV" -->
	<xsl:template name="titleexportCSV">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return esportaCSV();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Ordinamento di una colonna: id="hxp-title-action-sortCol-(criterio di ordinamento)" -->
	<xsl:template name="titleSortCol">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="val" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return sort('</xsl:text>
				<xsl:value-of select="$val"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Copia l'elemento corrente se l'ordinamento per colonna di titolo corrisponde a quello dichiarato nell'id:
	     id="hxp-title-action-arrowSortCol-(criterio di ordinamento)" -->
	<xsl:template name="arrowSortCol">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="val" select="''" />
		<xsl:if test="$val=$hxpdata/@titColOrd">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Inserisce un queryField (campo di ricerca) nella pagina dei titoli
	     id="hxp-title-action-queryFieldNode" -->
	<xsl:template name="titleQueryFieldNode">
		<xsl:param name="blockData" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
            <xsl:apply-templates mode="template" select="$blockData/*" />
		</xsl:copy>
	</xsl:template>


	<!-- Per la visualizzazione dei titoli definiti nel file di property
	-->
	<xsl:template name="titleCells">
		<xsl:param name="blockData" select="''" />
		<xsl:for-each select="$hxpdata/*[starts-with(name(), 'titleCell')]">
			<xsl:variable name="apt">
	   	        <xsl:apply-templates mode="template" select="./*">
	   	        	<xsl:with-param name="blockData" select="$blockData"/>
	   	        </xsl:apply-templates>
			</xsl:variable>
			<xsl:copy>
				<xsl:copy-of select="$apt" />
	        </xsl:copy>
	    </xsl:for-each>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* created on: 07/07/2005
		*
		* @version 1.0
		*
		* @param blockData 	contiene l'xml da esaminare.
		* @param val		stringa "node_name[-id]".
		*
		* Questo template gestisce l'id 'hxp-title-action-fieldNode-node_name[-id]', analizzando tutti i
		* nodi 'node_name' figli di 'blockData' e mostrando il contenuto di quelli con id uguale a 'id'.<br>
		* Se nei parametri viene omesso 'id', viene mostrato il contenuto di tutti i nodi 'node_name'.
	-->
	<xsl:template name="titleFieldNode">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="val" select="''" />

		<xsl:variable name="nodeName">
			<xsl:choose>
				<xsl:when test="contains($val,'-')">
					<xsl:value-of select="substring-before($val,'-')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$val"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="nodeId">
			<xsl:if test="contains($val,'-')">
				<xsl:value-of select="substring-after($val,'-')"/>
			</xsl:if>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="name()='span' and count(@*)=1">
				<xsl:call-template name="showFieldNode">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="nodeName" select="$nodeName" />
					<xsl:with-param name="nodeId" select="$nodeId" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:call-template name="showFieldNode">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="nodeName" select="$nodeName" />
						<xsl:with-param name="nodeId" select="$nodeId" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:copy>

		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* created on: 07/07/2005
		*
		* @version 1.0
		*
		* @param blockData 	contiene l'xml da esaminare.
		* @param nodeName	nome dei nodi da esaminare ed eventualmente mostrare.
		* @param nodeId		id dei nodi da mostrare.
		*
		* Questo template realizza le funzionalita' del template 'titleFieldNode'.
	-->
	<xsl:template name="showFieldNode">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="nodeName" select="''" />
		<xsl:param name="nodeId" select="''" />

		<xsl:copy-of select="@*[name()!='id']" />
		<xsl:for-each select="$blockData/*[name()=$nodeName]">
			<xsl:choose>
				<xsl:when test="$nodeId!=''">
					<xsl:if test="@id=$nodeId">
						<xsl:apply-templates mode="template" select="./*" />
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
        			<xsl:apply-templates mode="template" select="./*" />
        		</xsl:otherwise>
        	</xsl:choose>
        </xsl:for-each>
	</xsl:template>

	<xsl:template name="titlelistselectThumbnail">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tipo" select="''" />
		<xsl:param name="myname" select="''" />

		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<!--<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>-->
			<!--
			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>
			-->
			<xsl:attribute name="id">
				<xsl:text>selezionaImmagine</xsl:text>
				<xsl:if test="$myname!=''">
					<xsl:text>-</xsl:text>
					<xsl:for-each select="$blockData">
						<xsl:call-template name="matchcontent">
							<xsl:with-param name="elemName" select="$myname" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</xsl:attribute>
			<xsl:attribute name="onchange">
				<xsl:text>return selectImage(this);</xsl:text>
			</xsl:attribute>
			<xsl:for-each select="$blockData//immagini/xw:file[@name!='']">
				<xsl:choose>
					<xsl:when test="./thumb/@name!=''">
						<xsl:choose>
							<xsl:when test="$tipo='posizione'">
								<option value="{./thumb/@name}"><xsl:value-of select="position()"/></option>
							</xsl:when>
							<xsl:otherwise>
								<option value="{./thumb/@name}"><xsl:value-of select="./@title"/></option>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$tipo='posizione'">
								<option value="{./@name}"><xsl:value-of select="position()"/></option>
							</xsl:when>
							<xsl:otherwise>
								<option value="{./@name}"><xsl:value-of select="./@title"/></option>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

<xsl:template name="titlenoIWlistopenInNewWindow_x">
				<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="params" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>

			<xsl:variable name="name">
				<xsl:value-of select="@name"/>
			</xsl:variable>

			<xsl:attribute name="name">
				<xsl:text>openBig</xsl:text>
				<xsl:choose>
					<xsl:when test="$params='forTitles'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<!--<xsl:value-of select="$name" />-->
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>


           	<xsl:attribute name="id">
				<xsl:text>OnoIwImg</xsl:text>
				<xsl:choose>
					<xsl:when test="$params='forTitles'">
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<!--<xsl:value-of select="$name" />-->
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
							<xsl:value-of select="$numeroPosizione+1" />
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>



			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return openInNewWindow_xpreview('</xsl:text>
				<xsl:for-each select="$blockData//xw:file">
					<xsl:text>|</xsl:text>
					<xsl:value-of select="@name"/>
				</xsl:for-each>
				<xsl:if test="$params='forTitles'">
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$blockData/@indice"/>
				</xsl:if>
				<xsl:if test="$params='forDocs'">
							<xsl:variable name="numeroPosizione">
								<xsl:for-each select="$blockData">
									<xsl:value-of select="count(preceding-sibling::*[name()=name($blockData)])"/>
								</xsl:for-each>
							</xsl:variable>
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$numeroPosizione+1" />
				</xsl:if>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

<xsl:template name="titlenoIWlistimg">
	<xsl:param name="blockData" select="$hxpdata" />
	<xsl:param name="pos" select="''" />
	<xsl:param name="myname" select="''" />

	<xsl:variable name="numeroPosizione" select="count($blockData//xw:file)"/>

	<xsl:choose>
		<xsl:when test="$numeroPosizione>1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:variable name="name">
						<xsl:value-of select="@name"/>
					</xsl:variable>
					<!--
					<xsl:attribute name="name">
						<xsl:text>listimg</xsl:text>
						<xsl:if test="@name!=''">
							<xsl:text>.</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$name" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>
					</xsl:attribute>
					-->
					<xsl:attribute name="id">
					    <xsl:value-of select="$pos"/>
						<xsl:text>noIwImg</xsl:text>
						<xsl:if test="$myname!=''">
							<xsl:text>-</xsl:text>
							<xsl:for-each select="$blockData">
								<xsl:call-template name="matchcontent">
									<xsl:with-param name="elemName" select="$myname" />
								</xsl:call-template>
							</xsl:for-each>
						</xsl:if>
					</xsl:attribute>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return noIWselectImage(this,'</xsl:text>
						<xsl:value-of select="$pos"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
		</xsl:otherwise>
	</xsl:choose>

</xsl:template>


	<!-- copia l'elemento corrente se la parte partNumber-esima del titolo  uguale a value -->
	<xsl:template name="titleCopyIfPart">
		<xsl:param name="partNumber" select="''"/>
		<xsl:param name="partValue" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="perPosizione">
			<xsl:if test="$partNumber>0">
				<xsl:text>SI</xsl:text>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="testPartValue">
			<xsl:choose>
				<xsl:when test="$perPosizione='SI'">
					<xsl:value-of select="$partValue"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="substring-after($partValue, '!')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="value">
			<xsl:choose>
				<xsl:when test="$perPosizione='SI'">
					<xsl:call-template name="titlevispart">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="partnum" select="$partNumber" />
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:variable name="prefix">
						<xsl:value-of select="substring-before($partValue, '!')"/>
						<xsl:text>!</xsl:text>
					</xsl:variable>
					<xsl:value-of select="substring-before(substring-after(concat($blockData/@testo,'|'), $prefix),'|')"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$testPartValue=$value">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="titleColspanSet">
		<xsl:param name="blockData" select="''" />
		<xsl:param name="num" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="colspan">
				<xsl:value-of select="count($hxpdata/titleHeader) +1 - $num"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-title-action-... -->
	<xsl:template name="titleaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockData" select="''" />
		<xsl:choose>
			<xsl:when test="starts-with($value,'colspanSet-')">
				<xsl:call-template name="titleColspanSet">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="num" select="substring-after($value, 'colspanSet-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'copyIfPart-')">
				<xsl:call-template name="titleCopyIfPart">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="partNumber" select="substring-before(substring-after($value, 'copyIfPart-'),',')" />
					<xsl:with-param name="partValue" select="substring-after(substring-after($value, 'copyIfPart-'),',')" />
				</xsl:call-template>
			</xsl:when>
		    <xsl:when test="$value='NoiwThumb'">
				<xsl:call-template name="NoiwThumb">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='NoiwThumbsimple'">
				<xsl:call-template name="NoiwThumbsimple">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'selectThumbnailWithPosition-')">
				<xsl:call-template name="titlelistselectThumbnail">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tipo" select="'posizione'" />
					<xsl:with-param name="myname" select="substring-after($value,'selectThumbnailWithPosition-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='noIWopenInNewWindow_x' or substring-before($value,'-')='noIWopenInNewWindow_x'">
				<xsl:call-template name="titlenoIWlistopenInNewWindow_x">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!--<xsl:when test="$value='noIWprevImg'">-->
			<xsl:when test="starts-with($value,'noIWprevImg-')">
				<xsl:call-template name="titlenoIWlistimg">
					<xsl:with-param name="pos" select="'P'" />
					<xsl:with-param name="myname" select="substring-after($value,'noIWprevImg-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--<xsl:when test="$value='noIWnextImg'">-->
			<xsl:when test="starts-with($value,'noIWnextImg-')">
				<xsl:call-template name="titlenoIWlistimg">
					<xsl:with-param name="pos" select="'N'" />
					<xsl:with-param name="myname" select="substring-after($value,'noIWnextImg-')" />
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='queryFieldNode'">
				<xsl:call-template name="titleQueryFieldNode">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='titleCells'">
				<xsl:call-template name="titleCells">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 07/07/05: gestione id 'hxp-title-action-fieldNode-node_name[-id]' -->
			<xsl:when test="starts-with($value,'fieldNode-')">
				<xsl:call-template name="titleFieldNode">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="val" select="substring-after($value, 'fieldNode-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'arrowSortCol-')">
				<xsl:call-template name="arrowSortCol">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="val" select="substring-after($value, 'arrowSortCol-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="starts-with($value,'sortCol-')">
				<xsl:call-template name="titleSortCol">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="val" select="substring-after($value, 'sortCol-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='exportCSV'">
				<xsl:call-template name="titleexportCSV">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='raccogli'">
				<xsl:call-template name="titleraccogli">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkAll'">
				<xsl:call-template name="titlecheckall">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio_Aggiunta -->
			<xsl:when test="$value='checkDeselectAll'">
				<xsl:call-template name="titlecheckdeselectall">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio_Aggiunta -->
			<xsl:when test="$value='checkReverse'">
				<xsl:call-template name="titlecheckreverse">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio_Aggiunta -->
			<xsl:when test="$value='checkSelectAll'">
				<xsl:call-template name="titlecheckselectall">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
		   <xsl:when test="$value='getfile'">
				<xsl:call-template name="getfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='getfilethumb'">
				<xsl:call-template name="getfilethumbtitles">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
		    <xsl:when test="$value='noIWgetfilethumb'">
				<xsl:call-template name="noIWgetfilethumbtitles">
					<xsl:with-param name="blockData" select="$blockData"/>
					<!--<xsl:with-param name="fileid" select="substring-after($value,'-')"/>-->
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='imglink'">
				<xsl:call-template name="imglink">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="$value='tendinaSelectIfSelected'">
				<xsl:call-template name="titleTendinaSelectIfSelected">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='store'">
				<xsl:call-template name="titlestore">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
   <xsl:when test="$value='edit' or substring-before($value,'-')='edit'">
    <xsl:call-template name="titleedit">
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="xparms" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
			<xsl:when test="substring-before($value,'-')='enableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='disableFunctionality'">
				<xsl:call-template name="disableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='blockDataEnableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$blockData">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='deleteSel'">
				<xsl:call-template name="titledeletesel">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='refinetableq'">
				<xsl:call-template name="titlerefinetableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @dbTable -->
			<xsl:when test="$value='refinecurrenttableq'">
				<xsl:call-template name="titlerefinetableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @selTable -->
			<xsl:when test="$value='refinestartingtableq'">
				<xsl:call-template name="titlerefinetableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@selTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='gototableq'">
				<xsl:call-template name="titlegototableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @dbTable -->
			<xsl:when test="$value='gotocurrenttableq'">
				<xsl:call-template name="titlegototableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @selTable -->
			<xsl:when test="$value='gotostartingtableq'">
				<xsl:call-template name="titlegototableq">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@selTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='up'">
				<xsl:call-template name="titleup">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='down'">
				<xsl:call-template name="titledown">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='first'">
				<xsl:call-template name="titlefirst">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='first_no_label'">
				<xsl:call-template name="titlefirst">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='collect' or starts-with($value,'collect-')">
				<xsl:call-template name="titlecollect">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'collect-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="titleprev">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev_no_label'">
				<xsl:call-template name="titleprev">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="titlenext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next_no_label'">
				<xsl:call-template name="titlenext">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last'">
				<xsl:call-template name="titlelast">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removeDocFromSel'">
				<xsl:call-template name="removeDocFromSel">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='collMan'">
				<xsl:call-template name="collectionManager">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='collChange'">
				<xsl:call-template name="collectionChange">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last_no_label'">
				<xsl:call-template name="titlelast">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='goto'">
				<xsl:call-template name="titlegoto">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='export'">
				<xsl:call-template name="titleexport">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="'adm_tools'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='query'">
				<xsl:call-template name="titlequery">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='document' or starts-with($value,'document-')">
				<xsl:call-template name="titledoc">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'document-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='documentimgs' or starts-with($value,'documentimgs-')">
   			<xsl:variable name="nomefunzionejs1">
         		<xsl:choose>
         			<xsl:when test="$hxpdata/@enableIW!='false'">
         				<xsl:value-of select="'mostraImmaginiDocumento'"/>
         			</xsl:when>
         			<xsl:otherwise>
         				<xsl:value-of select="''"/>
         			</xsl:otherwise>
         		</xsl:choose>
         	</xsl:variable>
				<xsl:call-template name="titledoc">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'documentimgs-')"/>
					<xsl:with-param name="nomefunzionejs" select="$nomefunzionejs1"/>
				</xsl:call-template>

			</xsl:when>
			<xsl:when test="$value='documentastext' or starts-with($value,'documentastext-')">
				<xsl:call-template name="titledoctext">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="params" select="substring-after($value,'documentastext-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='check'">
				<xsl:call-template name="titlecheck">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio_Aggiunta -->
			<xsl:when test="$value='checkautomatic'">
				<xsl:call-template name="titleautocheck">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="autocheck" select="$hxpdata/@keylist" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='deselect'">
				<xsl:call-template name="titledeselect">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='printitles'">
				<xsl:call-template name="titleprintitles">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='ripropz'">
				<xsl:call-template name="titleripropz">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='selecttitle'">
				<xsl:call-template name="titleselecttitle">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='invertorder'">
				<xsl:call-template name="titleinvertordertitle">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Federico 28/10/04: gestione dell'id 'hxp-title-action-printProfiles'
				per la visualizzazione della pagina dei profili di stampa.
			-->
			<xsl:when test="$value='printProfiles'">
				<xsl:call-template name="titlePrintProfiles">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Gestione dell'id 'hxp-title-action-instabledoc'
				per l'inserimento di nuovi documenti dalla pagina dei titoli.
			-->
			<xsl:when test="substring-before($value,'-')='instabledoc'">
				<xsl:call-template name="docinstabledoc">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>

			<!--830666-->
			<xsl:when test="$value='imglinkwithIW'">
				<xsl:call-template name="imglinkwithIWtitles">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="$value='getfilethumb'">
				<xsl:call-template name="getfilethumbtitles">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>



			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="docinstabledoc">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="tableName" select="''" />
		<!-- inserimento di un nuovo documento della tabella specificata (non un repertorio) -->
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return insTableDoc('</xsl:text>
				<xsl:value-of select="$tableName"/>
				<xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template match="key-hit">
		<span class="key-hit">
			<xsl:apply-templates />
		</span>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='title'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-title-action-... -->
								<xsl:call-template name="titleaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-title-data-... -->
								<xsl:call-template name="titledata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'datanocopy-')"> <!-- hxp-title-datanocopy-... -->
								<xsl:call-template name="titledatanocopy">
									<xsl:with-param name="value" select="substring-after($value,'datanocopy-')" />
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'include-')"> <!-- hxp-title-include-... -->
								<!-- non fa nulla (servono solo per includere i js solo se occorre) -->
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockData" select="$blockData" />
									</xsl:call-template>
								</xsl:copy>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxparser_embedded">
							<xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="$disable" />
						</xsl:call-template>
<!--		<xsl:call-template name="hxpidhandler">
						 <xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template> -->
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
	 	* @author Federico Grillini (copiato qui da DD il 18/04/06)
		*
	 	* Created on: 30/11/2005
		*
	 	* @param blockPath
	 	* @param blockData	contesto corrente nell'xml.
	 	* @param attrVal	valore dell'attributo da testare.
	 	*
	 	* Questo template copia l'elemento contenente l'id se la funzionalit specifica
	    * corrispondente non deve essere abilitata, ovvero se l'attributo da testare vale 'false' o non c'e'.
	    *
	    * id="hxp-title-action-disableFunctionality-(attributo da testare)"
	    *
	-->
	<xsl:template name="disableFunctionality">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />

		<xsl:if test="$attrVal='false' or $attrVal=''">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
