<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 03/07/2006
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene i template relativi alla visualizzazione dei titoli dei workflow attivi [RW 0037103].
	*
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:include href="hxp.xsl"/>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 04/07/2006
		* 	
	 	* Questo template gestisce i javascript da includere.
	    *
	-->
	<xsl:template name="jslist">
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/titles_wfattivi.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/formTupleRestore.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 03/07/2006
		* 	
	 	* @param blockData	contesto corrente nel xml.
	 	* @param disable	parametro da passare al template 'hxpcontinuecontext'.
	 	* @param blockPath
	 	* @param instPosDep parametro da passare al template 'hxpidhandler'.
	 	*
	 	* Questo template gestisce gli id "hxp-activeWfTitles-...".
	    *
	-->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="disable" select="''" />
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="instPosDep" select="''"/>							
		
		<xsl:choose>
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='activeWfTitles'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'enableFunctionality-')">
								<xsl:variable name="xpath" select="substring-after(substring-after($value,'-'),'-')"/>
								
								<xsl:call-template name="enableFunctionality">
									<xsl:with-param name="blockData" select="$blockData" />
									<xsl:with-param name="attrVal">
										<xsl:for-each select="$hxpdata">					
											<xsl:call-template name="matchcontent">
												<xsl:with-param name="elemName" select="$xpath" />
											</xsl:call-template>
										</xsl:for-each>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="substring-after($value,'-')='query'">
								<xsl:call-template name="activeWfTitlequery">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="substring-after($value,'-')='blockDiv'">
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />
									<xsl:attribute name="id">
										<xsl:value-of select="$blockData/@name"/>
									</xsl:attribute>				
									<xsl:attribute name="style">
										<xsl:text>display:block</xsl:text>
									</xsl:attribute>
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockData" select="$blockData" />							
									</xsl:call-template>
								</xsl:copy>
							</xsl:when>
							<xsl:when test="substring-after($value,'-')='openDiv'">
								<xsl:if test="count($blockData/../wfModel) > 0">
									<xsl:copy>
										<xsl:copy-of select="@*[name()!='id']" />
										<xsl:call-template name="hxpcontinuecontext">
											<xsl:with-param name="blockData" select="$blockData" />							
										</xsl:call-template>
									</xsl:copy>
								</xsl:if>	
							</xsl:when>
							<xsl:when test="substring-after($value,'-')='divButton'">
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />
									<xsl:attribute name="href">
										<xsl:text>javascript:void(0);</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="onclick">
										<xsl:text>return hideShowChildrenBranch(this, '</xsl:text>
										<xsl:value-of select="$blockData/@name"/>						
										<xsl:text>');</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="id">						
										<xsl:text>nodeButton</xsl:text>
									</xsl:attribute>
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockData" select="$blockData" />
									</xsl:call-template>
									
									<span style="margin: 3px;"><xsl:value-of select="$blockData/@name"/></span>
								</xsl:copy>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'getInstContent')">
								<xsl:variable name="lastPartId">
									<xsl:value-of select="substring-after($value,'-')"/>
								</xsl:variable>
								<xsl:variable name="WfFunctionInteractionManagerClass">
									<xsl:value-of select="substring-after($lastPartId,'-')"/>
								</xsl:variable>
								
								<!-- Federico 14/09/06: ristrutturato xml titoli wf attivi [RW 0037108] -->
								<xsl:for-each select="$blockData/cstep">
									<xsl:for-each select="./actionsGroup">
										<div>
											<xsl:attribute name="id">
												<xsl:value-of select="../../@name"/>
												<xsl:text>_</xsl:text>
												<xsl:value-of select="../@id"/>
												<!--
													Federico 12/09/06: e' opportuno usare anche l'id dell'actionsGroup, dato che piu'
													action possono appartenere allo stesso step [RW 0037108]
												-->
												<xsl:text>_</xsl:text>
												<xsl:value-of select="./@id"/>
											</xsl:attribute>
											
											<!-- Federico 09/11/06: aggiunto checkbox seleziona/deseleziona tutto [RW 0040278] -->
											<input type="checkbox" name="checkAll">
												<xsl:attribute name="onclick">
													<xsl:text>return selectAllChkbox(this, '</xsl:text>
													<xsl:value-of select="../../@name"/>
													<xsl:text>_</xsl:text>
													<xsl:value-of select="../@id"/>
													<xsl:text>_</xsl:text>
													<xsl:value-of select="./@id"/>
													<xsl:text>');</xsl:text>
												</xsl:attribute>
											</input>
											<!-- Federico 23/11/06: introdotto uso file delle risorse [RW 0040518] -->
											<span style="font-size: 100%; font-style: italic;">
												<xsl:call-template name="customcontent">
						                          <xsl:with-param name="blockPath" select="$blockPath"/>
						                          <xsl:with-param name="blockData" select="$blockData" />
						                          <xsl:with-param name="templatedata" select="'resource-Tutti'"/>
						                        </xsl:call-template>
											</span>
											<br/>
											
											<xsl:for-each select="./title">
												<input type="checkbox">
													<xsl:attribute name="name">
														<xsl:text>chkbox_</xsl:text>
														<xsl:value-of select="../../../@name"/>
														<xsl:text>_</xsl:text>
														<xsl:value-of select="../../@id"/>
														<!--
															Federico 12/09/06: e' opportuno usare anche l'id dell'actionsGroup, dato che piu'
															action possono appartenere allo stesso step [RW 0037108]
														-->
														<xsl:text>_</xsl:text>
														<xsl:value-of select="../@id"/>
													</xsl:attribute>
													<xsl:attribute name="value">
														<xsl:value-of select="./@nrecord"/>
														<xsl:text>|</xsl:text>
														<xsl:value-of select="./@instId"/>
													</xsl:attribute>
													<xsl:attribute name="onclick">
														<xsl:text>return selectWfDoc(this, '</xsl:text>
														<xsl:value-of select="./@nrecord"/>						
														<xsl:text>', '</xsl:text>
														<xsl:value-of select="./@instId"/>
														<xsl:text>');</xsl:text>
													</xsl:attribute>
												</input>
												<xsl:value-of select="."/>
												
												<!--
													Federico 22/11/06: aggiunto link per visualizzare in una nuova finestra 
													il documento corrispondente al titolo [RW 0040518].
												-->
												<xsl:text>&#160;&#160;&#160;(</xsl:text>
												<a href="javascript:void(0);">
													<xsl:attribute name="onclick">
														<xsl:text>return showDoc('</xsl:text>
														<xsl:value-of select="./@nrecord"/>
														<xsl:text>');</xsl:text>
													</xsl:attribute>
													<!-- Federico 23/11/06: introdotto uso file delle risorse [RW 0040518] -->
													<xsl:call-template name="customcontent">
							                          <xsl:with-param name="blockPath" select="$blockPath"/>
							                          <xsl:with-param name="blockData" select="$blockData" />
							                          <xsl:with-param name="templatedata" select="'resource-Visualizza dettagli'"/>
							                        </xsl:call-template>
												</a>
												<xsl:text>)</xsl:text>
												<br/>
											</xsl:for-each>
											<ul>
												<xsl:for-each select="./link">
													<li>
														<a>
															<xsl:attribute name="href">
																<xsl:text>javascript:void(0);</xsl:text>
															</xsl:attribute>
															<xsl:attribute name="onclick">
																<xsl:text>return doAction('</xsl:text>
																<xsl:value-of select="./@action_id"/>
																<xsl:text>', '</xsl:text>
																<xsl:value-of select="../../../@name"/>
																<xsl:text>_</xsl:text>
																<xsl:value-of select="../../@id"/>
																<!--
																	Federico 12/09/06: e' opportuno usare anche l'id dell'actionsGroup,
																	dato che piu' action possono appartenere allo stesso step [RW 0037108]
																-->
																<xsl:text>_</xsl:text>
																<xsl:value-of select="../@id"/>
																<xsl:text>', '</xsl:text>
																<xsl:value-of select="$WfFunctionInteractionManagerClass"/>
																<xsl:text>');</xsl:text>
															</xsl:attribute>
															<xsl:value-of select="."/>
														</a>
													</li>
												</xsl:for-each>
											</ul>
										</div>
									</xsl:for-each>
								</xsl:for-each>
							</xsl:when>
							<xsl:when test="substring-after($value,'-')='setNodeContentId'">
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />
									<xsl:attribute name="id">
										<xsl:text>(</xsl:text>
										<xsl:value-of select="$blockData/@name"/>
										<xsl:text>)_content</xsl:text>
									</xsl:attribute>
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockData" select="$blockData" />
									</xsl:call-template>
								</xsl:copy>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockPath" select="$blockPath"/>
							<xsl:with-param name="blockData" select="$blockData" />
 							<xsl:with-param name="disable" select="$disable" />
							<xsl:with-param name="instPosDep" select="$instPosDep"/>							
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 04/07/2006
		* 
		* @param blockData	contesto corrente nel xml.
		* @param attrVal	valore dell'attributo da testare.
		*	
	 	* Questo template copia l'elemento contenente l'id se la funzionalit specifica 
	    * corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	    * [(id = "hxp-title-action-enableFunctionality-(attributo da testare)"].
	    *
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="attrVal" select="''" />
		
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 03/07/2006
		* 	
	 	* Nuova ricerca: id = "hxp-activeWfTitles-query".
	    *
	-->
	<xsl:template name="activeWfTitlequery">
		<xsl:param name="blockData" select="$hxpdata" />
		
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:value-of select="@onclick" /><xsl:text>;</xsl:text>
				<xsl:text>return nuovaRicerca();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 03/07/2006
		* 	
	 	* Questo template aggiunge gli input hidden alla form 'hxpForm'.
	    *
	-->
	<xsl:template name="beforeend">
		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<div>
				<xsl:call-template name="sessiondata" />
				<input type="hidden" name="verbo" value="{$hxpdata/@verb}" />
				<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />
				<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
				<input type="hidden" name="qord" value="{$hxpdata/@qord}" />
				<input type="hidden" name="personalView" value="{$hxpdata/@personalViewToUse}" />
				
				<!-- specifici -->
				<xsl:call-template name="contextcustom">
					<xsl:with-param name="specName" select="'beforeend'"/>
				</xsl:call-template>
			</div>
		</form>
	</xsl:template>
	
	<!--
	 	* @author Federico Grillini
		*
	 	* Created on: 04/07/2006
		* 	
	 	* Questo template gestisce gli attributi del body.
	    *
	-->
	<xsl:template name="bodyattributes">
	</xsl:template>
</xsl:stylesheet>
