<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Costruzione dell'albero di ricerca (incluso direttamente da hxp.xsl) -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <!-- begin of ttreecontainer handler -->
  
  <!-- Copia un element(compresi tutti i figli e attributi) -->
  <xsl:template name="copyTtreeTemplateElement">
    <xsl:param name="blockData" select="$hxpdata" />
    <xsl:copy>
      <xsl:for-each select="@*[name()!='id']">
        <xsl:call-template name="stringparser">
          <xsl:with-param name="data" select="$blockData" />
        </xsl:call-template>
      </xsl:for-each>
      <xsl:for-each select="node()">
        <xsl:call-template name="copyBlockTemplateElement">
          <xsl:with-param name="blockData" select="$blockData" />
        </xsl:call-template>
      </xsl:for-each>
    </xsl:copy>
  </xsl:template>

  <!-- Formattazione dell'albero di ricerca -->
  <xsl:template name="ttreeFormatter">
    <xsl:param name="ttreeData" select="''" />
    <xsl:param name="ttreeTemplate" select="''" />
    <xsl:variable name="ttreeElemName" select="name(.)" />
    <xsl:choose>
      <xsl:when test="$ttreeElemName!=name(./parent::*[1])"> <!-- radice -->
        <xsl:choose>
          <xsl:when test="count(child::*)!=0"> <!-- radice con figli -->
            <xsl:choose>
              <xsl:when test="$ttreeData/@open='1'"> <!-- aperta -->
                <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-ro']"> <!-- ro: root opened -->
                  <xsl:call-template name="copyTtreeTemplateElement">
                    <xsl:with-param name="blockData" select="$ttreeData" />
                  </xsl:call-template>
                </xsl:for-each>
              </xsl:when>
              <xsl:otherwise> <!-- chiusa -->
                <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-rc']"> <!-- rc: root closed -->
                  <xsl:call-template name="copyTtreeTemplateElement">
                    <xsl:with-param name="blockData" select="$ttreeData" />
                  </xsl:call-template>
                </xsl:for-each>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:when test="count(child::*)=0"> <!-- radice senza figli -->
            <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-ra']"> <!-- ra: root alone -->
              <xsl:call-template name="copyTtreeTemplateElement">
                <xsl:with-param name="blockData" select="$ttreeData" />
              </xsl:call-template>
            </xsl:for-each>
          </xsl:when>
          <!-- old block
          <xsl:when test="count(child::*)!=0 or count($ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-ra'])=0">
            <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-rc']">
              <xsl:call-template name="copyTtreeTemplateElement">
                <xsl:with-param name="blockData" select="$ttreeData" />
              </xsl:call-template>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-ra']">
              <xsl:call-template name="copyTtreeTemplateElement">
                <xsl:with-param name="blockData" select="$ttreeData" />
              </xsl:call-template>
            </xsl:for-each>
          </xsl:otherwise>
          -->
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise> <!-- generico elemento figlio -->
        <xsl:choose>
          <xsl:when test="count(child::*)!=0"> <!-- padre -->
            <xsl:choose>
              <xsl:when test="count(following-sibling::*)!=0"> <!-- not the last son -->
                <xsl:choose>
                  <xsl:when test="$ttreeData/@open='1'"> <!-- aperto -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-fso']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise> <!-- chiuso -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-fsc']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise> <!-- last son -->
                <xsl:choose>
                  <xsl:when test="$ttreeData/@open='1'"> <!-- aperto -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-fo']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise> <!-- chiuso -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-fc']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise> <!-- foglia -->
            <xsl:choose>
              <xsl:when test="count(following-sibling::*)!=0"> <!-- not the last son -->
                <xsl:choose>
                  <xsl:when test="$ttreeData/@explored='0'"> <!-- non esplorato -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-les']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise> <!-- esplorato -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-ls']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise> <!-- last son -->
                <xsl:choose>
                  <xsl:when test="$ttreeData/@explored='0'"> <!-- non esplorato -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-le']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:when>
                  <xsl:otherwise> <!-- esplorato -->
                    <xsl:for-each select="$ttreeTemplate/descendant-or-self::*[@id='hxp-ttree-l']">
                      <xsl:call-template name="copyTtreeTemplateElement">
                        <xsl:with-param name="blockData" select="$ttreeData" />
                      </xsl:call-template>
                    </xsl:for-each>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="hxpttreecontainer">
    <xsl:param name="blockData" select="$hxpdata" />
    <xsl:param name="elemName" select="''" />
    <xsl:copy>
      <xsl:copy-of select="@*[name()!='id']" />
      <xsl:variable name="ttreeTemplate" select="*" />
      <xsl:for-each select="$blockData/*[name()=$elemName]">
        <xsl:call-template name="ttreeFormatter">
          <xsl:with-param name="ttreeData" select="." />
          <xsl:with-param name="ttreeTemplate" select="$ttreeTemplate" />
        </xsl:call-template>
      </xsl:for-each>
    </xsl:copy>
  </xsl:template>
  
  <!-- Richiamato da hxp.xsl: entry point di ttree.xsl -->
  <xsl:template name="hxpttreehandler">
    <xsl:param name="value" select="''" />
    <xsl:param name="blockData" select="$hxpdata" />
    <xsl:choose>
      <xsl:when test="substring-before($value,'-')='containerof'"> <!-- hxp-ttree-containerof-... -->
        <xsl:call-template name="hxpttreecontainer">
          <xsl:with-param name="blockData" select="$blockData" />
          <xsl:with-param name="elemName" select="substring-after($value,'-')" />
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$value='recurse'"> <!-- hxp-ttree-recurse -->
        <xsl:variable name="ttreeTemplate" select="./ancestor::*[@id=concat('hxp-ttree-containerof-',name($blockData))]/*" />
        <xsl:copy>
          <xsl:for-each select="@*[name()!='id']">
            <xsl:call-template name="stringparser">
              <xsl:with-param name="data" select="$blockData" />
            </xsl:call-template>
          </xsl:for-each>
          <xsl:for-each select="$blockData/*">
            <xsl:call-template name="ttreeFormatter">
              <xsl:with-param name="ttreeData" select="." />
              <xsl:with-param name="ttreeTemplate" select="$ttreeTemplate" />
            </xsl:call-template>
          </xsl:for-each>
        </xsl:copy>
      </xsl:when>
      <xsl:when test="substring-before($value,'-')='call'"> <!-- hxp-ttree-call... -->
        <xsl:copy>
          <xsl:for-each select="@*[name()!='id']">
            <xsl:call-template name="stringparser">
              <xsl:with-param name="data" select="$blockData" />
            </xsl:call-template>
          </xsl:for-each>
          <xsl:for-each select="./ancestor::*[@id=concat('hxp-ttree-containerof-',name($blockData))]//*[@id=concat('hxp-ttree-',substring-after($value,'-'))]">
            <xsl:call-template name="copyTtreeTemplateElement">
              <xsl:with-param name="blockData" select="$blockData" />
            </xsl:call-template>
          </xsl:for-each>
        </xsl:copy>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="copyTtreeTemplateElement">
          <xsl:with-param name="blockData" select="$blockData" />
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <!-- end of ttreecontainer handler -->

</xsl:stylesheet>
<!-- Stylus Studio meta-information - (c)1998-2004. Sonic Software Corporation. All rights reserved.
<metaInformation>
<scenarios/><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition></MapperMetaTag>
</metaInformation>
-->