<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!--
	* Created on........: 12/10/2007
	* by................: Federico Grillini
	* organization......: 3D Informatica
	*
	* Questo file contiene dei template per mostrare (con il browser) l'albero xml di un file xml [RW 0047486]
	* Il codice e' stato migrato dal viewer e opportunamente riadattato per essere generico.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <xsl:template match="processing-instruction()" mode="xmlcopy">
   <xsl:if test="name()!='page-title'">
       <xsl:text >&lt;?</xsl:text><xsl:value-of select = "name()" /><xsl:text > </xsl:text><xsl:value-of select = "." /><xsl:text >?&gt;</xsl:text>
       <xsl:apply-templates select="."/>
   </xsl:if>
  </xsl:template>

  <xsl:template match="processing-instruction('page-title')" mode="pagetitle">
    <xsl:variable name="pagetitle">
        <xsl:value-of select="substring-after(., 'value=')"/>
    </xsl:variable>

     <xsl:value-of select="substring($pagetitle, 2,string-length($pagetitle)-2)"/>
  </xsl:template>

  <xsl:template match="*[not(processing-instruction())]" mode="pagetitle">
  </xsl:template>

  <xsl:template name="makeabscoord">
      <!-- costruisce una stringa composta da numeri separati da punto che
         esprimono per ogni livello la posizione del corrispondente ancestor -->
	  <xsl:for-each select="ancestor::*">
	   <xsl:value-of select="concat(string(1+count(preceding-sibling::*)),'.')"/>
	  </xsl:for-each>
	  <xsl:value-of select="string(1+count(preceding-sibling::*))"/>
  </xsl:template>

  <xsl:template match="*[name()!='xw:usr']" mode="xmlcopy">
   <table cellspacing="0" cellpadding="0" border="0">
   <tr>
   <td style="width:8pt" valign="top">
    <xsl:if test="count(*|text()) > 0">
     <xsl:attribute name="rowspan">3</xsl:attribute>
     <a class="tnode" href="javascript:void(0)">
      <xsl:attribute name="onclick">
       <xsl:text>return hideShowBranch(this,'</xsl:text>
       <xsl:call-template name="makeabscoord"/>
       <xsl:text>')</xsl:text>
      </xsl:attribute>
      -
     </a>
    </xsl:if>
   </td>
   <td colspan="2">
    <table cellspacing="0" cellpadding="0" border="0">
    <tr>
    <td valign="top">
     <b>
     <xsl:text>&lt;</xsl:text>
     <xsl:value-of select="name()"/>
     </b>
    </td>
    <xsl:if test="count(@*) > 0">
     <td>&#160;</td>
    </xsl:if>
    <td>
    <xsl:for-each select="@*">
     <xsl:text> </xsl:text>
     <b><i><xsl:value-of select="name()"/></i></b>
     <xsl:text> = "</xsl:text>
     <xsl:value-of select="."/>
     <xsl:text>" </xsl:text><!-- <br/> -->
    </xsl:for-each>
    <xsl:if test="count(*|text()) = 0">/</xsl:if>
    <xsl:text>&gt;</xsl:text>
    </td>
    </tr>
    </table>
   </td>
   </tr>
   <xsl:if test="count(*|text()) > 0">
    <tr>
    <td colspan="2" style="display:">
     <xsl:attribute name="id"><xsl:call-template name="makeabscoord"/></xsl:attribute>
     <table cellspacing="0" cellpadding="0">
      <tr>
       <xsl:if test="count(*) = 0"><td style="width:8pt"></td></xsl:if>
       <td><xsl:apply-templates mode="xmlcopy"/></td>
      </tr>
     </table>
    </td>
    </tr>
    <tr>
    <td colspan="2">
     <b>
     <xsl:text>&lt;/</xsl:text>
     <xsl:value-of select="name()"/>
     <xsl:text>&gt;</xsl:text>
     </b>
    </td>
    </tr>
   </xsl:if>
   </table>
  </xsl:template>

  <xsl:template match="/">
	<html>
	   <head>
	      <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
	      <meta http-equiv="pragma" content="no-cache"/>
	      <meta http-equiv="expires" content="now"/>
	      <link rel="stylesheet" href="../../../formatter/html/data/styles/showXmlTree.css" type="text/css"/>

	      <script>
		    function hideShowBranch(elem,theId)
		    {var isHidden=document.getElementById(theId).style.display=='none';
		     elem.innerHTML=(isHidden?'-':'+');
		     document.getElementById(theId).style.display=(isHidden?'':'none');
		     return false;
		    }
		  </script>

	      <title><xsl:apply-templates select="./*" mode="pagetitle"/></title>
	   </head>

   	   <body>
   	   	<xsl:apply-templates select="/*" mode="xmlcopy"/>
   	   </body>
   	</html>
  </xsl:template>

  <xsl:output method="html" indent="yes"/>
</xsl:stylesheet>

