<?xml version="1.0" encoding="iso-8859-1"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!--
 
     Template per ottenere il 'dump' di un elemento 'xml' (compresi
     discendenti e testo) che, se applicato a '/', diventa il 'dump'
     dell'intero file 'xml'. 

     Esempio d'uso:

    <xsl:comment>
      <xsl:apply-templates select="/" mode="xml-dump"/>
    </xsl:comment>

  -->

  <xsl:template match="@*" mode="xml-dump">
    <xsl:text>@</xsl:text><xsl:value-of select="name()"/>
    <xsl:text>=[</xsl:text>
    <xsl:call-template name="escComment">
      <xsl:with-param name="cont" select="."/>
    </xsl:call-template>
    <xsl:text>]
    </xsl:text>
  </xsl:template>

  <xsl:template match="processing-instruction()" mode="xml-dump">
    <xsl:text>pi()=[</xsl:text>
    <xsl:call-template name="escComment">
      <xsl:with-param name="cont" select="name()"/>
    </xsl:call-template>
    <xsl:text>][</xsl:text>
    <xsl:call-template name="escComment">
      <xsl:with-param name="cont" select="."/>
    </xsl:call-template>
    <xsl:text>]
    </xsl:text>
  </xsl:template>

  <xsl:template match="text()" mode="xml-dump">
    <xsl:text>text()=[</xsl:text>
    <xsl:call-template name="escComment">
      <xsl:with-param name="cont" select="."/>
    </xsl:call-template>
    <xsl:text>]
    </xsl:text>
  </xsl:template>

  <xsl:template match="*" mode="xml-dump">
    <xsl:text>&lt;</xsl:text><xsl:value-of select="name()"/><xsl:text>
    </xsl:text>
    <xsl:apply-templates select="@*" mode="xml-dump"/>
    <xsl:text>&gt;
    </xsl:text>
    <xsl:apply-templates select="node()" mode="xml-dump"/>
    <xsl:text>&lt;/</xsl:text><xsl:value-of select="name()"/><xsl:text>&gt;
    </xsl:text>
  </xsl:template>

  <xsl:template name="escComment">
    <xsl:param name="cont" select="''"/>
    <xsl:variable name="len0" select="string-length($cont)"/>
    <xsl:variable name="val1" select="number(contains($cont,'\'))"/>
    <xsl:variable name="val2" select="number(contains($cont,'-'))"/>
    <xsl:variable name="len1" select="$val1*string-length(substring-before($cont,'\'))+number(not($val1))*$len0"/>
    <xsl:variable name="len2" select="$val2*string-length(substring-before($cont,'-'))+number(not($val2))*$len0"/>
    <xsl:variable name="lMin" select="$len1*number($len2>=$len1)+$len2*number($len1>$len2)"/>

    <xsl:choose>
      <xsl:when test="$len0 > $lMin">
        <xsl:value-of select="substring($cont,1,$lMin)"/>
        <xsl:value-of select="'\'"/>
        <xsl:value-of select="substring($cont,$lMin+1,1)"/>
        <xsl:call-template name="escComment">
          <xsl:with-param name="cont" select="substring($cont,$lMin+2)"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$cont"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>

