<?xml version="1.0"?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->

<xsl:stylesheet
  version="1.0"
  extension-element-prefixes="doc"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:doc="http://xsltsl.org/xsl/documentation/1.0"
  xmlns:eg="http://xsltsl.org/example"
>

  <doc:reference xmlns="">
    <referenceinfo>
      <releaseinfo role="meta">
        $Id: example.xsl,v 1.1 2005/06/30 16:35:08 fgrillini-3di Exp $
      </releaseinfo>
      <author>
        <surname>Ball</surname>
        <firstname>Steve</firstname>
      </author>
      <copyright>
        <year>2001</year>
        <holder>Steve Ball</holder>
      </copyright>
    </referenceinfo>

    <title>Example Stylesheet</title>

    <partintro>
      <section>
        <title>Introduction</title>

        <para>This module provides a template for adding stylesheet modules to the XSLT Standard Library.</para>
        <para>To add a new module to the library, follow these easy steps:</para>
        <orderedlist>
          <listitem>
            <para>Copy this file and replace its contents with the new module templates and documentation.</para>
          </listitem>
          <listitem>
            <para>Copy the corresponding test file in the <filename>test</filename> directory.  Replace its contents with tests for the new module.</para>
          </listitem>
          <listitem>
            <para>Add an include element in the <filename>stdlib.xsl</filename> stylesheet.</para>
          </listitem>
          <listitem>
            <para>Add an entry in the <filename>test/test.xml</filename> file.</para>
          </listitem>
          <listitem>
            <para>Add entries in the <filename>test/test.xsl</filename> stylesheet.</para>
          </listitem>
          <listitem>
            <para>Add an entry in the <filename>doc/build.xml</filename> file.</para>
          </listitem>
        </orderedlist>

        <para>The <filename>example.xsl</filename> stylesheet provides a more extensive example.</para>

      </section>
    </partintro>

  </doc:reference>

  <doc:template name="eg:example" xmlns="">
    <refpurpose>Template Example</refpurpose>

    <refdescription>
      <para>Provides a template for writing templates.  Replace this paragraph with a description of your template</para>
    </refdescription>

    <refparameter>
      <variablelist>
        <varlistentry>
          <term>text</term>
          <listitem>
            <para>The example string</para>
          </listitem>
        </varlistentry>
      </variablelist>
    </refparameter>

    <refreturn>
      <para>Returns nothing.</para>
    </refreturn>
  </doc:template>

  <xsl:template name="eg:example">
    <xsl:param name="text"/>
  </xsl:template>

</xsl:stylesheet>

