/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
// Data: 07/05/2003
// Scopo: Funzioni di gestione di un calendarietto a discesa.

var lay = ((navigator.appName == 'Netscape') && (parseInt(navigator.appVersion.substring(0, 1)) == 4) ? 1 : 0);
var dataAttuale;
var dataMostrata;
var dataInput;
var calAperto = false;

function getdiv(id) {
	if (lay)
		return document.layers[id];
	return document.getElementById(id).style;
}

function Prev() {
	dataMostrata.setMonth(dataMostrata.getMonth() - 1);
	BuildCal();
}

function Next() {
	dataMostrata.setMonth(dataMostrata.getMonth() + 1);
	BuildCal();
}

function Select(theinput) {
	if (theinput.value.length) {
		dataInput.value = (theinput.value.length == 1 ? '0': '') + theinput.value + '/' + (dataMostrata.getMonth() < 9 ? '0': '') + (dataMostrata.getMonth() + 1) + '/' + dataMostrata.getFullYear();
		calAperto = false;
		
		/* Modifica di Federico del 20/12/2004: mostro i select che possono interferire con il calendario
		 * solo se il calendario non  stato aperto a partire dal div della ricerca per range di date.
		 */
		if (typeof(dateRangeDivOpened) != "undefined" && !dateRangeDivOpened) {
			setSelectVisibility('visible');
		}
		else if (typeof(dateRangeDivOpened) == "undefined") {
				setSelectVisibility('visible');
			 }
		
		getdiv('cal').visibility = 'hidden';
	}
}

function BuildCal() {
	var giorni;
	switch (dataMostrata.getMonth()) {
	case 0:
		giorni = 31;
		document.cal.mese.value = 'Gennaio ' + dataMostrata.getFullYear();
		break;
	case 1:
		giorni = 28;
		var test = new Date(dataMostrata);
		test.setDate(29);
		if (test.getDate() == 29)
			giorni = 29;
		document.cal.mese.value = 'Febbraio ' + dataMostrata.getFullYear();
		break;
	case 2:
		giorni = 31;
		document.cal.mese.value = 'Marzo ' + dataMostrata.getFullYear();
		break;
	case 3:
		giorni = 30;
		document.cal.mese.value = 'Aprile ' + dataMostrata.getFullYear();
		break;
	case 4:
		giorni = 31;
		document.cal.mese.value = 'Maggio ' + dataMostrata.getFullYear();
		break;
	case 5:
		giorni = 30;
		document.cal.mese.value = 'Giugno ' + dataMostrata.getFullYear();
		break;
	case 6:
		giorni = 31;
		document.cal.mese.value = 'Luglio ' + dataMostrata.getFullYear();
		break;
	case 7:
		giorni = 31;
		document.cal.mese.value = 'Agosto ' + dataMostrata.getFullYear();
		break;
	case 8:
		giorni = 30;
		document.cal.mese.value = 'Settembre ' + dataMostrata.getFullYear();
		break;
	case 9:
		giorni = 31;
		document.cal.mese.value = 'Ottobre ' + dataMostrata.getFullYear();
		break;
	case 10:
		giorni = 30;
		document.cal.mese.value = 'Novembre ' + dataMostrata.getFullYear();
		break;
	case 11:
		giorni = 31;
		document.cal.mese.value = 'Dicembre ' + dataMostrata.getFullYear();
		break;
	}
	var riga = 1;
	var colonna = dataMostrata.getDay();
	if (colonna == 0)
		colonna = 7;
	for (var i = 1; i < colonna; i++) {
		document.cal['gg1-' + i].value = '';
		document.cal['gg1-' + i].className = 'inattivo';
	}
	var giorno = dataAttuale.getDate();
	var test = new Date(dataAttuale);
	test.setDate(1);
	if (test.getTime() != dataMostrata.getTime())
		giorno = 0;
	for (var i = 1; i <= giorni; i++) {
		document.cal['gg' + riga + '-' + colonna].value = i;
		document.cal['gg' + riga + '-' + colonna].className = 'attivo';
		if (i == giorno)
			document.cal['gg' + riga + '-' + colonna].className = 'selezionato';
		if (colonna++ == 7) {
			colonna = 1;
			riga++;
		}
	}
	for (var i = colonna; i <= 7; i++) {
		document.cal['gg' + riga + '-' + i].value = '';
		document.cal['gg' + riga + '-' + i].className = 'inattivo';
	}
	if (riga == 5) {
		for (var i = 1; i <= 7; i++) {
			document.cal['gg6-' + i].value = '';
			document.cal['gg6-' + i].className = 'inattivo';
		}
	}
}

function CloseCal() {
	calAperto = false;
	
	/* Modifica di Federico del 20/12/2004: mostro i select che possono interferire con il calendario
	 * solo se il calendario non  stato aperto a partire dal div della ricerca per range di date.
	 */
	if (typeof(dateRangeDivOpened) != "undefined" && !dateRangeDivOpened) {
		setSelectVisibility('visible');
	}
	else if (typeof(dateRangeDivOpened) == "undefined") {
			setSelectVisibility('visible');
		 }
	
	getdiv('cal').visibility = 'hidden';
}

// Funzione da chiamare per costruire il calendarietto sotto un determinato input (theinput)
function ShowCal(theinput) {
	if (calAperto && (theinput != dataInput))
		CloseCal();
	calAperto = ! calAperto;
	if (calAperto) {
		dataInput = theinput;
		var stringa = dataInput.value;
		
		/* Modifica di Federico del 17/12/2004:
		 * se 'stringa' contiene '|' significa che  un intervallo di date ==> inizializzo 'dataAttuale'
		 * con la data odierna.
		 */
		if (stringa.length && stringa.indexOf("|") == -1)
			dataAttuale = new Date(stringa.substr(6, 4), stringa.substr(3, 2) - 1, stringa.substr(0, 2));
		else
			dataAttuale = new Date();
		
		dataMostrata = new Date(dataAttuale);
		dataMostrata.setDate(1);
		
		BuildCal();
		
		var top = dataInput.offsetTop + dataInput.offsetHeight;
		var left = dataInput.offsetLeft;
		var oggetto = dataInput.offsetParent;
		
		while (oggetto != null) {
			top += oggetto.offsetTop;
			left += oggetto.offsetLeft;
			oggetto = oggetto.offsetParent;
		}
		
		/* Valuta la direzione di apertura del div (in su o in giu') in base alla dimensione dell schermo e lo
		 * scrolling della finestra (codice modificato da Federico).
		 */
		var height = window.innerHeight + document.body.scrollTop;	// altezza della finestra di visualizzazione
		var divHeight = 200;										// altezza del calendario
		var bottom = top + dataInput.offsetTop + divHeight;			// fondo del calendario
		
		//alert("height:" + height + "   bottom: " + bottom + "  top:" + top);
		
		if (bottom > height) {
			top -= divHeight;
		}
		
		getdiv('cal').top = top;
		getdiv('cal').left = left;
		
		/* Modifica di Federico del 20/12/2004:
		 * impongo un zIndex alto per far aprire il calendario anche sopra il div della ricerca per range di
		 * date.
		 */
		getdiv('cal').zIndex = 1000;
		
		/* Modifica di Federico del 20/12/2004: nascondo i select che possono interferire con il calendario
		 * solo se il calendario non  stato aperto a partire dal div della ricerca per range di date, dato
		 * che sarebbe un'operazione inutile in quanto gi effettuata all'apertura del div per la ricerca.
		 */
		if (typeof(dateRangeDivOpened) != "undefined" && !dateRangeDivOpened) {
			setSelectVisibility('hidden');
		}
		else if (typeof(dateRangeDivOpened) == "undefined") {
				setSelectVisibility('hidden');
			 }
		
		getdiv('cal').visibility = 'visible';
	}
	else {
		/* Modifica di Federico del 28/12/2004:
		 * per chiudere il calendario occorre chiamare 'CloseCal' affinch vengano di nuovo visualizzate
		 * le tendine eventualmente nascoste all'atto della sua apertura.
		 */
		//getdiv('cal').visibility = 'hidden';
		CloseCal();
	}
}

/* 
 * Created on: 17/12/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di visualizzare il calendario mediante il nome dell'input in cui deve essere
 * 				inserita la data selezionata.
 */
function ShowCalByName(currentNode, inputName)
{
	// Federico 14/03/2005: inserita gestione degli elementi multistanza (RW0026114)
    if (inputName.indexOf('[$hxp_instance()]') != -1) {
        var dad = currentNode.parentNode;
        
        var theInputName = currentNode.name;
		var prefix = theInputName.substring(0, theInputName.lastIndexOf('['));
		
		if (prefix.charAt(0) == '.') {
			prefix = prefix.substring(1);
		}
		
		while (typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1) {
			dad = dad.parentNode;
		}
	
		var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);
		
        //caso di istanza figlia di multistanza
        if (inputName.indexOf('$hxp_fatherinstance()') != -1) {
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            inputName = inputName.replace('$hxp_fatherinstance()', fatherInstNumber);
        }
		
		inputName = inputName.replace('$hxp_instance()', instNumber);
		//alert (inputName);
    }

    var theInput = getElementByName(inputName);
	
	if (!theInput) {
		return;
	}
	
	ShowCal(theInput);
}

/* 
 * Created on: 17/12/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di reperire un elemento html dato il suo nome ed eventualmente il suo tipo
 * 				(cio il nome del tag).
 */
function getElementByName(name, tagName)
{	
	if ("undefined" == typeof(tagName)) {
		// tipo di default
		tagName = "input";
	}
	
	var elements = document.getElementsByTagName(tagName);
	
	for (var i = 0; i < elements.length; i++) {
		if (elements[i].name == name) {
			return elements[i];
		}
	}

	return null;			
}

/* 
 * Created on: 20/12/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione che consente di visualizzare/nascondere gli elementi 'select' della pagina html.
 * 				La lista degli elementi da nascondere/mostrare  contenuta nell'array 'selectFieldsToBeHidden',
 * 				che deve essere definito nel javascript specifico dell'applicazione.
 * 				Tale operazione, inoltre, viene eseguita solo se il browser  IE, dato che IE ha un bug che
 * 				comporta la sovrapposizione di tutti i 'select' con i div nascosti, nel senso che mostrando un div
 * 				nascosto sopra un men a tendina, quest'ultimo "fora" il div rimanendo in primo piano.
 * 				All'apertura del div, quindi,  necessario nascondere i possibili elementi select che potrebbero
 * 				dare fastidio.
 */
function setSelectVisibility(vis) {
	if (navigator.userAgent.indexOf('MSIE') >= 0) {
		var selectField;
	
		if (typeof(selectFieldsToBeHidden) != "undefined") {
			for (var j = 0; j < selectFieldsToBeHidden.length; j++) {
				selectField = getElementByName(selectFieldsToBeHidden[j], "select");
			
				if (selectField != null) {
					selectField.style.visibility = vis;
					//alert("selectField: " + selectField.name + "  visibility: " + vis);
				}
			}
		}
	}
}