/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* HTMLElement.js */

 function setInnerHTML (node, str) {
  node.innerHTML=str;
 }
 function getInnerHTML (node) {
  return node.innerHTML;
 }
 function setOuterHTML (node, str) {
  node.outerHTML=str;
 }
 function getOuterHTML (node) {
  return node.outerHTML;
 }
 function _setInnerHTML (node, str) {
  var r = node.ownerDocument.createRange();
  r.selectNodeContents(node);
  r.deleteContents();
  var df = r.createContextualFragment(str);
  node.appendChild(df);
  
  return str;
 }
 function _setOuterHTML (node, str) {
  var r = node.ownerDocument.createRange();
  r.setStartBefore(node);
  if(str=='')
  {node.parentNode.removeChild(node);
  }
  else
  {var df = r.createContextualFragment(str);
   node.parentNode.replaceChild(df, node);
  }
  return str;
 }
 if(typeof HTMLElement!="undefined" && !HTMLElement.prototype.insertAdjacentElement){

  Event.prototype.__defineSetter__("cancelBubble", function (b){if (b) this.stopPropagation();});

  setInnerHTML=_setInnerHTML;
  getInnerHTML=_getInnerHTML;
  setOuterHTML=_setOuterHTML;
  getOuterHTML=_getOuterHTML;

  HTMLElement.prototype.insertAdjacentElement = function(where,parsedNode)
  {
   switch (where){
   case 'beforeBegin':
    this.parentNode.insertBefore(parsedNode,this)
    break;
   case 'afterBegin':
    this.insertBefore(parsedNode,this.firstChild);
    break;
   case 'beforeEnd':
    this.appendChild(parsedNode);
    break;
   case 'afterEnd':
    if (this.nextSibling) this.parentNode.insertBefore(parsedNode,this.nextSibling);
    else this.parentNode.appendChild(parsedNode);
    break;
   }
  }
  HTMLElement.prototype.insertAdjacentHTML = function(where,htmlStr)
  {
   var r = this.ownerDocument.createRange();
   r.setStartBefore(this);
   var parsedHTML = r.createContextualFragment(htmlStr);
   this.insertAdjacentElement(where,parsedHTML)
  }
  HTMLElement.prototype.insertAdjacentText = function(where,txtStr)
  {
   var parsedText = document.createTextNode(txtStr)
   this.insertAdjacentElement(where,parsedText)
  }
 }
 function _getInnerHTML(node) {
  var str = "";
  for (var i=0; i<node.childNodes.length; i++)
   str += _getOuterHTML(node.childNodes.item(i));
  return str;
 }
 function _getOuterHTML(node) {
  var str = "";
  switch (node.nodeType) {
   case 1: // ELEMENT_NODE
    str += "<" + node.nodeName;
    for (var i=0; i<node.attributes.length; i++) {
     if (node.attributes.item(i).value != null) {
      str += " "
       str += node.attributes.item(i).nodeName;
      str += "=\"";
      if(node.attributes.item(i).nodeName.toLowerCase()=='value'&&
         node.nodeName.toLowerCase()=='input' && 
         (node.type.toLowerCase()=='text'||node.type.toLowerCase()=='hidden'))
       str += node.value;
      else
       str += node.attributes.item(i).value;
      str += "\"";
     }
    }
    if(node.nodeName.toLowerCase()=='textarea') {
      str += ">";
      if (node.nodeValue!=null)
        str += node.nodeValue;
      str += "</" + node.nodeName + ">"
    }
    else {
     if (node.childNodes.length == 0 && leafElems[node.nodeName.toUpperCase()]) {
      str += ">";
      //str += "/>";
     }
     else {
      str += ">";
      str += _getInnerHTML(node);
      str += "</" + node.nodeName + ">"
     }
    }
    break;
   case 3: //TEXT_NODE
    str += node.nodeValue;
    break;
   case 4: // CDATA_SECTION_NODE
    str += "<![CDATA[" + node.nodeValue + "]]>";
    break;
   case 5: // ENTITY_REFERENCE_NODE
    str += "&" + node.nodeName + ";"
    break;
   case 8: // COMMENT_NODE
    str += "<!--" + node.nodeValue + "-->"
    break;
  }
  return str;
 }
 var _leafElems = ["IMG", "HR", "BR", "INPUT"];
 var leafElems = {};
 for (var i=0; i<_leafElems.length; i++)
  leafElems[_leafElems[i]] = true;

