<!-- Codice nascosto per browser che non supportano Javascript
/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
//
//  Nomefile: chkdate.js
//            Verifica che la data sia inserita nel formato gg/mm/aaaa
//       Uso: in un campo di tipo data onChange="ChkDate(this)"
//
function trim(str)
{
  if (!str)
    return str;
  while (str.length && (str.substring(0,1) == " " ||
                        str.substring(0,1) == "\t" ))
    str = str.substring(1, str.length);
  while (str.length && (str.substring(str.length - 1, str.length) == " " ||
                        str.substring(str.length - 1, str.length) == "\t"))
    str = str.substring(0, str.length - 1);
  return str;
}

function IsDigit(chr)
{
	if ( chr < '0' || chr > '9' )
		return false;
	else
		return true;
}

function ValidElement(stringa, begin, end, retValue)
{
    var val;

    for ( val = ""; begin <= end; begin++ )  {
    	if ( !IsDigit(stringa.charAt(begin)) )
    		return (typeof(retValue) != 'undefined')? retValue : false;
    	val += stringa.charAt(begin);
    }
    return val;
}

function chkDate(theinput, verbose)
{
 var sData = theinput.value;
 var day, month, year;
 var MaxDay;

	sData = trim(sData);
	if (!sData.length)  {
		theinput.value = "";
		return true;
	}
	if ( sData.length == 8 )  {
        // data nel formato ggmmaaaa
		day = ValidElement(sData, 0, 1);
		month = ValidElement(sData, 2, 3);
		year = ValidElement(sData, 4, 7);

        // Federico 15/04/09: introdotto riconoscimento date "aaaammgg" [RW 0052062 e M 0000297]
        if (year >= 0101 && year <= 1231) {
            // data nel formato aaaammgg
            day = ValidElement(sData, 6, 7);
            month = ValidElement(sData, 4, 5);
            year = ValidElement(sData, 0, 3);

            sData = day + month + year;
        }
	}
	else if ( sData.length == 6 )  {
		day = eval(ValidElement(sData, 0, 1));
		month = eval(ValidElement(sData, 2, 3));
		year = eval(ValidElement(sData, 4, 5));
		if ( year < 70 )
			year += 2000;
		else
			year += 1900;
	}
	else  {
		day = ValidElement(sData, 0, 1);
		month = ValidElement(sData, 3, 4);
		year = ValidElement(sData, 6, 9);
		if ( sData.charAt(2) != sData.charAt(5) &&
		     sData.charAt(2) != ' ' && sData.charAt(2) != '\/' )  {
			if ( verbose == true ) chkdateMSG(dateNotInGGMMAA);
			return false;
		}
	}

	if ( day == 0 || month == 0 || year == 0 )  {
		// Formato data non valido
	    if ( verbose == true ) chkdateMSG(dateNotInGGMMAA);
		return false;
	}

	// Controlli di massima su giorno, mese, anno
	if ( day <= 0 )  {
		if ( verbose == true ) chkdateMSG(dayNotIn1_31);
		return false;
	}
	if ( month < 1 || month > 12 )  {
		if ( verbose == true ) chkdateMSG(monthNotIn1_12);
		return false;
	}
	if ( year < 1 )  {
		if ( verbose == true ) chkdateMSG(yearLessThan1);
		return false;
	}

	// Determino il numero massimo di giorni per il mese in questione
	if ( month == 11 || month == 4 || month == 6 || month == 9 )
		MaxDay = 30;
	else if ( month == 2 )  {
		MaxDay = 28;
		if ( year % 400 == 0 || ((year % 4) == 0 && (year % 100) != 0) )
			MaxDay++;
	}
	else
		MaxDay = 31;

	if ( day > MaxDay )  {
		if ( verbose == true ) chkdateMSG(dayNotIn1_MaxDay, MaxDay);
		return false;
	}

	if ( sData.length == 8 )  {
		// Inserisco il separatore fra giorno, mese ed anno.
		var DataCorretta = sData.substring(0, 2);
		DataCorretta += '\/';
		DataCorretta += sData.substring(2, 4);
		DataCorretta += '\/';
		DataCorretta += sData.substring(4, 8);
		theinput.value = DataCorretta;
	}
	else if ( sData.length == 6 )  {
		// Inserisco il separatore fra giorno, mese ed anno.
		var DataCorretta = sData.substring(0, 2);
		DataCorretta += '\/';
		DataCorretta += sData.substring(2, 4);
		DataCorretta += '\/';
		DataCorretta += year.toString();
		theinput.value = DataCorretta;
	}
	else if ( sData.charAt(2) != '\/' )  {
		// Rimpiazzo nella data il separatore precedente con lo slash.
		var DataCorretta = sData.substring(0, 2);
		DataCorretta += '\/';
		DataCorretta += sData.substring(3, 5);
		DataCorretta += '\/';
		DataCorretta += sData.substring(6, 10);
		theinput.value = DataCorretta;
	}

	return true;
}

/*
 * Verifica che un dato input contenga un dato in formato numerico, comprendente un separatore di migliaia e un
 * separatore per la parte decimale.
 * Se 'verbose' = true, in caso di errore appare un alert con un messaggio esplicativo; altrimenti, viene semplicemente
 * rifiutato il valore.
 */
function chkNumericFormat(theinput, verbose, thousandsSeparator, decimalSeparator)
{
    var sNum = theinput.value;
    sNum = trim(sNum);

    if (!IsNumeric(theinput, false, verbose, thousandsSeparator))
        return false;

    //punto e virgola adiacenti - Errore
    var adi;
    var previousSpecialCharIndex = -2;
    for (adi = 0; adi < sNum.length; adi++){
        if (sNum.charAt(adi) == thousandsSeparator || sNum.charAt(adi) == decimalSeparator){
            if (adi - previousSpecialCharIndex == 1){
                if (verbose == true) chkdateMSG(wrongVicinity);
                theinput.focus();
                return false;
            }
            previousSpecialCharIndex = adi;
        }
    }

    //l'ultimo carattere  una virgola - Aggiungo due zeri in coda
    if (sNum.charAt(sNum.length-1) == decimalSeparator){
        sNum += "00";
    }

    //l'ultimo carattere  un punto - Lo elimino
    if (sNum.charAt(sNum.length-1) == thousandsSeparator){
        var pi;
        for (pi = sNum.length-1; pi > 0 && sNum.charAt(pi) == thousandsSeparator; pi--);
        sNum = sNum.substring(0,pi+1);
    }

    //il primo carattere  un punto - Lo elimino
    if (sNum.charAt(0) == thousandsSeparator){
        var pf;
        for (pf = 0; pf < sNum.length && sNum.charAt(pf) == thousandsSeparator; pf++);
        sNum = sNum.substr(pf);
    }

    //il primo carattere  una virgola - Aggiungo uno zero in testa
    if (sNum.charAt(0) == decimalSeparator){
        sNum = '0' + sNum;
    }

    var commaPosition1 = sNum.indexOf(decimalSeparator);
    if (commaPosition1 != -1){
        //ci sono pi virgole - Errore
        var commaPosition2 = sNum.lastIndexOf(decimalSeparator);
        if (commaPosition1 != commaPosition2){
            if (verbose == true) chkdateMSG(tooManyCommas);
            theinput.focus();
            return false;
        }

        //ci sono dei punti dopo le virgole - Li elimino
        var pac;
        while ((pac = sNum.indexOf(thousandsSeparator,commaPosition1)) != -1){
            sNum = sNum.substring(0,pac) + sNum.substr(pac+1);
        }

        //eliminazione degli zeri inutili in coda; vista la tipica convenzione di indicare, ad es. nei centesimi di
        //euro, 20 anzich 2, applico questa pulizia solo a partire da una certa distanza - configurabile - dalla
        //virgola
        var distanceFromDecimalSeparator = 2;
        var zac;
        for (zac = sNum.length - 1; zac > commaPosition1 + distanceFromDecimalSeparator && sNum.charAt(zac) == '0'; zac--);
        sNum = sNum.substring(0,zac+1);
    }

    //eliminazione degli zeri inutili in testa
    var clean = true;
    while (clean){
        clean = false;
        if (sNum.charAt(0) == '0' && sNum.charAt(1) != decimalSeparator){
            sNum = sNum.substring(1,sNum.length);
            clean = true;
        }
        if (sNum.charAt(0) == thousandsSeparator){
            sNum = sNum.substring(1,sNum.length);
            clean = true;
        }
    }

    theinput.value = sNum;
    return true;
}

/*
 * Created on: 24/12/2004
 * by: Mario Bussetti
 * organization: 3D Informatica
 * description: Dopo aver verificato il formato di una stringa numerica (con eventuale parziale separazione delle
 *              migliaia e separatore della parte decimale), applica alla parte intera la completa separazione delle
 *              migliaia; inoltre, se il parametro 'letterContainer' non  vuot, nell'input avente il nome specificato
 *              viene messa la conversione della stringa numerica in lettere italiane, con la notazione tipo euro per
 *              i centesimi.
 *              'thSep' e 'deSep' indicano rispettivamente il separatore delle migliaia e il separatore della parte
 *              decimale.
 */
function setNumericFormat(theinput,verbose,thSep,deSep,letterContainer){
    //primo controllo e aggiustamento della stringa che rappresenta un valore numerico
    var primaControllo = chkNumericFormat(theinput,verbose,thSep,deSep);
    if (!primaControllo){
        theinput.value = "";
    }
    else {
       //estrazione della parte intera
       var fNum = theinput.value;
       var commaPosition = -1;
       var fNumInt = fNum;
       var fNumDec = "";
       if ((commaPosition = fNum.indexOf(deSep)) != -1){
           fNumInt = fNum.substring(0,commaPosition);
           fNumDec = fNum.substr(commaPosition+1);
       }
       //aggiungo la separazione: gestione anche del caso in cui ce ne sia una parziale (tipo 1.000000)
       var alreadyPunctuated = fNumInt.split(thSep);
       fNumInt = "";
       var si;
       for (si = 0; si < alreadyPunctuated.length; si++){
           var porzione = alreadyPunctuated[si];
           //controllo che un'eventuale separazione parziale sia consistente: altrimenti -> errore (es. 1.00000)
           if (si > 0){
               if (porzione.length % 3 != 0){
                   if (verbose == true) chkdateMSG(uncorrectPointPosition);
                   theinput.value = "";
                   theinput.focus();
                   return false;
               }
           }
           //aggiungo il separatore delle migliaia
           var newPorzione = "";
           var iii;
           for (iii = porzione.length - 1; iii >= 0; iii--){
               newPorzione = porzione.charAt(iii) + newPorzione;
               if (iii > 0 && (porzione.length - iii) % 3 == 0){
                   newPorzione = thSep + newPorzione;
               }
           }
           //ricostruzione progressiva della parte intera a cui  stata aggiunta la separazione
           if (si > 0) fNumInt += thSep;
           fNumInt += newPorzione;
       }

       //ricostruzione dell'intera stringa
       fNum = fNumInt;
       if (fNumDec.length > 0) fNum += deSep + fNumDec;
       theinput.value = fNum;
    }

    //alert(digitation(replaceAll(fNum,'.',''),true,deSep));
    //alert(letterContainer);

    //andiamo a riempire il campo voluto con la traduzione in lettere della stringa numerica
    if (letterContainer.length > 0){
        var traduzione = digitation(replaceAll(fNum,'.',''),true,deSep);
        var inputList = document.getElementsByTagName("input");
        var ti;
        for (ti = 0; ti < inputList.length; ti++){
            if (inputList.item(ti).name == letterContainer){
                inputList.item(ti).value = traduzione;
                break;
            }
        }
    }

    return primaControllo;

}

function chkHour(theinput, verbose)
{
 var sData = theinput.value;
 var hour, minute, second;
 var MaxDay;

    sData = trim(sData);
    if (!sData.length)  {
        theinput.value = "";
        return true;
    }
    if ( sData.length == 4 )  {
        hour = ValidElement(sData, 0, 1, -1);
        minute = ValidElement(sData, 2, 3, -1);
        second = '0';
    }
    else if ( sData.length == 5 )  {
        hour = ValidElement(sData, 0, 1, -1);
        minute = ValidElement(sData, 3, 4, -1);
        second = '0';
    }
    else if ( sData.length == 6 )  {
        hour = eval(ValidElement(sData, 0, 1, -1));
        minute = eval(ValidElement(sData, 2, 3, -1));
        second = eval(ValidElement(sData, 4, 5, -1));
    }
    else if ( sData.length == 8 ) {
        hour = ValidElement(sData, 0, 1, -1);
        minute = ValidElement(sData, 3, 4, -1);
        second = ValidElement(sData, 6, 7, -1);
        if ( sData.charAt(2) != sData.charAt(5) &&
             sData.charAt(2) != ' ' && sData.charAt(2) != ':' )  {
            if ( verbose == true ) chkdateMSG(hourNotInHHmmss);
            return false;
        }
    }
    else {
        chkdateMSG(hourNotInHHmmss);
        return false;
    }

    if ( hour == -1 || minute == -1 || second == -1 )  {
        // Formato data non valido
        if ( verbose == true ) chkdateMSG(hourNotInHHmmss);
        return false;
    }

    // Controlli di massima su ore, minuti, secondi
    if ( hour < 0 || hour > 23 )  {
        if ( verbose == true ) chkdateMSG(hourNotIn0_23);
        return false;
    }
    if ( minute < 0 || minute > 59 )  {
        if ( verbose == true ) chkdateMSG(minuteNotIn0_59);
        return false;
    }
    if ( second < 0 || second > 59 )  {
        if ( verbose == true ) chkdateMSG(secondsNotIn0_59);
        return false;
    }

    if ( sData.length == 4 )  {
        var DataCorretta = sData.substring(0, 2);
        DataCorretta += ':';
        DataCorretta += sData.substring(2, 4);
        DataCorretta += ':00';
        theinput.value = DataCorretta;
    }
    else if ( sData.length == 5 )  {
        var DataCorretta = sData.substring(0, 5);
        DataCorretta += ':00';
        theinput.value = DataCorretta;
    }
    else if ( sData.length == 6 )  {
        var DataCorretta = sData.substring(0, 2);
        DataCorretta += ':';
        DataCorretta += sData.substring(2, 4);
        DataCorretta += ':';
        DataCorretta += sData.substring(4, 6);
        theinput.value = DataCorretta;
    }
    else if ( sData.charAt(2) != ':' )  {
        // Rimpiazzo nell'ora il separatore precedente con i ':'
        var DataCorretta = sData.substring(0, 2);
        DataCorretta += ':';
        DataCorretta += sData.substring(3, 5);
        DataCorretta += ':';
        DataCorretta += sData.substring(6, 10);
        theinput.value = DataCorretta;
    }

    return true;
}

/*
 * Created on: 20/10/2006
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per il controllo dei campi anno di 4 cifre [RW 0040053].
 */
function checkYear(inputToBeChecked) {
    if (inputToBeChecked.value != '') {
        if (inputToBeChecked.value.length != 4) {
            alert("L'anno indicato deve essere di 4 cifre!");
            inputToBeChecked.focus();
            inputToBeChecked.select();
        }
        else if (inputToBeChecked.value.indexOf('.') != -1 || inputToBeChecked.value.indexOf(',') != -1) {
            alert("Attributo di tipo numerico. Prego reimpostare.");
            inputToBeChecked.focus();
            inputToBeChecked.select();
        }
        else {
            if (!IsNumeric(inputToBeChecked, false, true)) inputToBeChecked.select();
        }
    }

    return false;
}
// fine codice -->

