/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* collect.js */

// finestra che ha aperto la finestra delle raccolte
var qWin;

// restituisce la finestra principale
function getQWin() {
        var qWin = opener;
        if (qWin == null || typeof(qWin) == 'undefined') {
                alert("getQWin(): perso il collegamento con la finestra chiamante! [qWin = null]");
        }
        return qWin;
}

// Identificativi selettori
var CollectorId_Datation     = 'selettore-datation';
var CollectorId_Name         = 'selettore-name';
var CollectorId_RecordCounts = 'selettore-recordcounts';

// Funzione per l'allineamento delle 'selectedIndex' dei selettori
function ParificaSelettori(IndiceDiAllineamento, ListaIdSelettori) {
        for (var i=0; i<ListaIdSelettori.split('::').length; i++) {
                if (document.getElementById(ListaIdSelettori.split('::')[i])) {
                        if (document.getElementById(ListaIdSelettori.split('::')[i]).options.selectedIndex != IndiceDiAllineamento) {
                                document.getElementById(ListaIdSelettori.split('::')[i]).options.selectedIndex = IndiceDiAllineamento;
                        }
                }
        }
}

function loadHandler() {
        qWin = getQWin();
        if ( qWin == null ) {
                //  stato perso il riferimento alla finestra chiamante --> errore fatale, chiudo!
                self.close();
                return false;
        }
        qWin.theCollectionWindow = window;

        var xVerb = getForm('hxpForm').xverb.value;
        var sendXVerb;

        if( xVerb == '@open' || xVerb == '@show' || xVerb == '@createAdd' || xVerb == '@openAdd' || xVerb == '@create' || xVerb == '@addDoc' || xVerb == '@disable' ) {
                //alert("opener.name["+opener.name+"]");
                if( ("@create" == xVerb) || ("@openAdd" == xVerb) || ("@createAdd" == xVerb) || ("@addDoc" == xVerb)) {
                        sendXVerb = "open";
                }
                else {
                        sendXVerb = xVerb.substring(1);
                }
                //alert("chiamo collectionHandler");
                qWin.collectionHandler(sendXVerb, getForm('hxpForm').cName.value, getForm('hxpForm').cId.value, getForm('hxpForm').cIsPublic.value, document.getElementById(CollectorId_RecordCounts).options[document.getElementById(CollectorId_RecordCounts).options.selectedIndex].text);
                //getForm('hxpForm').cCount.value);
                /*
                if ( '@show' == xVerb ) {
                        alert("SHOW!!!!");
                        getForm('hxpForm').cName.value = qWin.getForm('hxpForm').cName.value;
                        getForm('hxpForm').cIsPublic.value = qWin.getForm('hxpForm').cIsPublic.value;
                        getForm('hxpForm').cId.value = qWin.getForm('hxpForm').cId.value;
                        getForm('hxpForm').cCount.value = qWin.getForm('hxpForm').cCount.value;
                }
                else
                        if( typeof(parent.frames["queryIFrameDevNull"]) == 'undefined' ) {
                        this.window.close();
                }
                */
        }
}

function unloadHandler() {
        // Federico 04/01/06: corretto errore js dovuto a qWin.theCollectionWindow indefinito
        if (typeof(qWin.theCollectionWindow) != 'undefined') {
                qWin.theCollectionWindow = null;
        }
}

function GoTo_(NomeRichiesta) {
        // ******************************************************************** //
        // 'closedialog'    --> chiusura dialogo                                //
        // 'collclose'      --> chiusura raccolta (deattivazione)               //
        // 'collopen'       --> apertura raccolta (attivazione)                 //
        // 'create'         --> creazione nuova raccolta                        //
        // 'listperiodic'   --> visualizz. lista raccolte periodiche            //
        // 'listprivate'    --> visualizz. lista raccolte private               //
        // 'listpublic'     --> visualizz. lista raccolte pubbliche             //
        // 'listunperiodic' --> visualizz. lista raccolte non periodiche        //
        // 'remove'         --> eliminazione raccolta                           //
        // 'saveasprivate'  --> salvataggio (duplicazione) raccolta privata     //
        // 'saveaspublic'   --> salvataggio (duplicazione) raccolta pubblica    //
        //                      se la raccolta di destinazione  gi presente   //
        //                      la raccolta di destinazione viene sovrascritta  //
        // 'show'           --> visualizzazione contenuto raccolta              //
        // 'showin'         --> visualizzazione raccolta (si differenzia        //
        //                      dal precedente in quanto mi consente di         //
        //                      operare attivamente sulla raccolta e cio       //
        //                      per es. mi consente di scartare documenti       //
        //                      dalla raccolta)                                 //
        // ******************************************************************** //
        if ( NomeRichiesta == 'closedialog' ) {
                this.window.close();
                return false;
        }

        //var oldVerbo = getForm('hxpForm').verbo.value;
        getForm('hxpForm').verbo.value = "collect";

        var CurrentSelectValue = '';
        var DocumentiNellaRaccolta = '';
        var NomeNuovaRaccolta = '';

        if ( NomeRichiesta == 'collclose' ) {
                if ( getForm('hxpForm').cName.value != '' ) {
                        getForm('hxpForm').xverb.value = "@disable";
                        getForm('hxpForm').cName.value = '';
                        getForm('hxpForm').submit();
                }
        }
        else if( NomeRichiesta == 'collopen' ) {
                if ( "3se" == getForm('hxpForm').selid.value.substring(0,3) ) {
                        getForm('hxpForm').xverb.value = "@openAdd";
                }
                else {
                        getForm('hxpForm').xverb.value = "@open";
                }
                getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                //alert("xVerb["+getForm('hxpForm').xverb.value+"]\n"+
                //      "cName["+getForm('hxpForm').cName.value+"]\n"+
                //      "target["+getForm('hxpForm').target+"]");
                getForm('hxpForm').submit();
        }
        else if( NomeRichiesta == 'create' ) {
                // Devo richiedere il nome
                NomeNuovaRaccolta = prompt("Immettere una descrizione da associare alla raccolta!", "Nome Nuova Raccolta");
                if ( NomeNuovaRaccolta != null ) {
                        NomeNuovaRaccolta = NormalizzaNomeRaccolta(NomeNuovaRaccolta);
                        if ( NomeNuovaRaccolta.length > 0 ) {
                                if( NomeRaccoltaUnivoco(NomeNuovaRaccolta) ) {
                                        // Non esiste un duplicato
                                        if ( "3se" == getForm('hxpForm').selid.value.substring(0,3) ) {
                                                getForm('hxpForm').xverb.value = "@createAdd";
                                        }
                                        else {
                                                getForm('hxpForm').xverb.value = "@create";
                                        }
                                        getForm('hxpForm').cName.value = NomeNuovaRaccolta;
                                        // alert("Nuova raccolta=" + NomeNuovaRaccolta + " - verbo=" + getForm('hxpForm').verbo.value + " - xverb=" + getForm('hxpForm').xverb.value);
                                        getForm('hxpForm').submit();
                                }
                                else {
                                        // Esiste un duplicato
                                        alert('Il nome specificato per la raccolta non  univoco.');
                                }
                        }
                        else {
                                alert('Nome Raccolta non valido.\rOperazione annullata.');
                        }
                }
                else {
                        alert('Operazione annullata dall\'utente.');
                }
        }
        else if ( NomeRichiesta == 'listperiodic' ) {
                getForm('hxpForm').xverb.value = "@list";
                getForm('hxpForm').cIsPublic.value = "";
                getForm('hxpForm').pos.value = "1";
                getForm('hxpForm').submit();
        }
        else if ( NomeRichiesta == 'listprivate' ) {
                getForm('hxpForm').xverb.value = "@list";
                getForm('hxpForm').cIsPublic.value = "";
                getForm('hxpForm').submit();
        }
        else if ( NomeRichiesta == 'listpublic' ) {
                getForm('hxpForm').xverb.value = "@list";
                getForm('hxpForm').cIsPublic.value = "1";
                getForm('hxpForm').submit();
        }
        else if ( NomeRichiesta == 'listunperiodic' ) {
                getForm('hxpForm').xverb.value = "@list";
                getForm('hxpForm').cIsPublic.value = "";
                getForm('hxpForm').pos.value = "0";
                getForm('hxpForm').submit();
        }
        else if ( NomeRichiesta == 'remove' ) {
                if ( confirm('Raccolta: "' + document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].text + '".\rConfermi la cancellazione ?') ) {
                        getForm('hxpForm').xverb.value = "@remove";
                        getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                        getForm('hxpForm').submit();
                }
        }
        else if ( NomeRichiesta == 'saveasprivate' ) {
                var privateName = prompt('Nome della raccolta privata:', document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].text);
                privateName = NormalizzaNomeRaccolta(privateName)
                if ( privateName ) {
                        getForm('hxpForm').xverb.value = "@private";
                        getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                        getForm('hxpForm').cParam.value = '(d:' + document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value + ')(c:' + publicName + ')(p:0)(o:0)';
                        getForm('hxpForm').submit();
                }
        }
        else if ( NomeRichiesta == 'saveaspublic' ) {
                var publicName = prompt('Nome della raccolta per la pubblicazione:', document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].text);
                publicName = NormalizzaNomeRaccolta(publicName)
                if ( publicName ) {
                        getForm('hxpForm').xverb.value = "@public";
                        getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                        getForm('hxpForm').cParam.value = '(d:' + document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value + ')(c:' + publicName + ')(p:1)(o:1)';
                        getForm('hxpForm').submit();
                }
        }
        else if( NomeRichiesta == 'show' ) {
                if( parseInt(document.getElementById(CollectorId_RecordCounts).options[document.getElementById(CollectorId_RecordCounts).options.selectedIndex].text, 10) > 0 ) {
                        var oldTarget;
                        oldTarget = getForm('hxpForm').target;
                        getForm('hxpForm').xverb.value = "@show";
                        getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                        getForm('hxpForm').target = qWin.name;
                        getForm('hxpForm').submit();
                        getForm('hxpForm').target = oldTarget;
                }
                else {
                        alert('La raccolta non contiene nessun Documento.\rOperazione annullata.');
                }
        }
        else if( NomeRichiesta == 'showin' ) {
                if( parseInt(document.getElementById(CollectorId_RecordCounts).options[document.getElementById(CollectorId_RecordCounts).options.selectedIndex].text, 10) > 0 ) {
                        var oldTarget;
                        oldTarget = getForm('hxpForm').target;
                        getForm('hxpForm').xverb.value = "@showin";
                        getForm('hxpForm').cName.value = document.getElementById(CollectorId_Name).options[document.getElementById(CollectorId_Name).options.selectedIndex].value;
                        getForm('hxpForm').target = qWin.name;
                        getForm('hxpForm').submit();
                        getForm('hxpForm').target = oldTarget;
                }
                else {
                        alert('La raccolta non contiene nessun Documento.\rOperazione annullata.');
                }
        }
        else {
                alert('unhandled request: ' + NomeRichiesta);
        }

}

function NomeRaccoltaUnivoco(NomeNuovaRaccolta) {
        var RaccoltaDaConfrontare = NomeNuovaRaccolta.toLowerCase();
        var RaccoltaDiRiferimento = '';
        for(var i=0; i<document.getElementById('selettore-name').length; i++) {
                RaccoltaDiRiferimento = document.getElementById('selettore-name').options[i].value;
                if(RaccoltaDiRiferimento.toLowerCase() == RaccoltaDaConfrontare) {
                        return false;
                }
        }
        return true;
}

function NormalizzaNomeRaccolta(NomeRaccolta) {
        var NomeRaccoltaNormalizzata = NomeRaccolta;
        // ******************************** //
        // Il server normalizza i seguenti  //
        // caratteri ad underscore:         //
        // ******************************** //
        // ( x28                            //
        // ) x29                            //
        // \ x5C                            //
        // / x2F                            //
        // [ x5B                            //
        // ] x5D                            //
        // { x7B                            //
        // } x7D                            //
        // @ x40                            //
        // & x26                            //
        // # x23                            //
        // % x25                            //
        // " x22                            //
        // ' x27                            //
        // ! x21                            //
        // = x3D                            //
        // ? x3F                            //
        // ; x3B                            //
        // : x3A                            //
        // . x2E                            //
        // ^ x5E                            //
        //   x20                            //
        // ******************************** //
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x28/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x29/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x5C/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x2F/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x5B/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x5D/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x7B/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x7D/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x40/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x26/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x23/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x25/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x22/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x27/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x21/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x3D/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x3F/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x3B/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x3A/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x2E/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x5E/gi, "_");
        NomeRaccoltaNormalizzata = NomeRaccoltaNormalizzata.replace(/\x20/gi, "_");
        return NomeRaccoltaNormalizzata;
}
