/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* common.js */
 
 function _hxpSession(f)
 {if(f!=0)
  {this.init(f);
  }
 }
 new _hxpSession(0);
 pr=_hxpSession.prototype;
 function __init(f)
 {this.o=f['_cd'];
  this.tuples=new Array();
  var a=this.o.value.split('&');
  for(var j=0;j<a.length;j++)
  {if(a[j]!='')
   {
    var b=a[j].split('=');
    if(b.length==2) {
     //this.tuples[unescape(b[0])]=unescape(b[1]);
     this.tuples[b[0]]=b[1];
    }
    else if(b.length>2) {
     if (b[0] == 'CurrentQueryRequest') {
      var temp_bele = '';
      for (var i=2; i<b.length; i++) {
       temp_bele = temp_bele + '=' + b[i]
      }
      this.tuples[b[0]]=b[1]+temp_bele;
     }
     else {
      alert('unexpected data: '+a[j]);
     }
    }
    else {
     alert('unexpected data: '+a[j]);
    }
   }
  }
 }
 pr.init=__init;
 function _empty()
 {this.o.value='';
 }
 pr.empty=_empty;
 function _setParameter(name,v)
 {
     /* Federico 26/10/05: se v  null, rimuovo il parametro name dall'oggetto (nota: non so perch, ma la funzione
      * 'slice' degli array non funziona con this.tuples...).
      */
     if (v == null) {
         // rimozione del parametro 'name'
         var tmp = this.tuples;
         
         delete this.tuples;
         this.tuples = new Array();
         
         for(var n in tmp) {
             if (n != name) {
                 this.tuples[n]=tmp[n];
             }
         }
     }
     else {
         // aggiungo il parametro 'name'
         this.tuples[name]=escape(v);
     }
     
  var sep='',result='';
  for(var n in this.tuples)
  {
      result+=sep;
      if(sep=='')sep='&';
      result+=n+'='+this.tuples[n];
  }
  this.o.value='&'+result+'&';
 }
 pr.setParameter=_setParameter;
 function _getParameter(n)
 {var result=this.tuples[n]
  if(typeof(this.tuples[n])!='undefined')
  {return unescape(this.tuples[n]);
  }
  return'';    
 }
 pr.getParameter=_getParameter;
 function _setParameters(parameters)
 {for(var i=0;i<parameters.length;i++)
  {this.setParameter(parameters[i][0],parameters[i][1]);
  }
 }
 pr.setParameters=_setParameters;
 function _removeParameters(parameters)
 {for(var i=0;i<parameters.length;i++)
  {this.setParameter(parameters[i][0],null);
  }
 }
 pr.removeParameters=_removeParameters;
 function __push()
 {this.lastData=this.o.value;
 }
 pr.push=__push;
 function __pop()
 {this.o.value=this.lastData;
  this.init(this.o.form);   
 }
 pr.pop=__pop;
 
 function _qEscape(what)
 {return escape(what).replace(/\+/g,'%2B');
 }
 // NB: query MUST starts and ends with '&'
 function _getQueryParameter(query,name)
 {var theKey='&'+name+'=';
  var pos=query.indexOf(theKey);
  if(pos<0)return null;
  return unescape(query.substring(pos+theKey.length,query.indexOf('&',pos+1)));
 }
 pr.getQueryParameter=_getQueryParameter;
 // NB: query MUST starts and ends with '&'
 function _setQueryParameter(query,name,value)
 {var theKey='&'+name+'=';
  var pos=query.indexOf(theKey);
  if(pos<0) // append
  {query+=(name+'='+_qEscape(value)+'&');
  }
  else // replace
  {query=query.substring(0,pos)+theKey+_qEscape(value)+query.substring(query.indexOf('&',pos+1));
  }
  return query;
 }
 pr.setQueryParameter=_setQueryParameter;
 function _getQueryString(verb,xverb,requestParams)
 {var body='&';
  for(var i=0;i<this.o.form.length;i++)
  {body+=(this.o.form.elements[i].name+'='+_qEscape(this.o.form.elements[i].value)+'&');
  }
  if(verb!=null&&typeof(verb)!='undefined')
  {body=this.setQueryParameter(body,'verbo',verb);
  }
  // moz: xverb='' --> false
  if(xverb!=null&&typeof(xverb)!='undefined')
  {body=this.setQueryParameter(body,'xverb',xverb);
  }
  if(requestParams)
  {for(var i=0;i<requestParams.length;i++)
   {body=this.setQueryParameter(body,requestParams[i][0],requestParams[i][1]);
   }
  }
  return body;
 }
 pr.getQueryString=_getQueryString;
 function _getServerResponse(verb,xverb,async,requestParams,callback,callbackParams) // requires XMLRequest.js
 {var body=this.getQueryString(verb,xverb,requestParams);
  var result = Http.get({url: window.location.pathname,
                         callback: callback,
                         cache: Http.Cache.GetNoCache,
                         method: Http.Method.Post,
                         async: async,
                         headers: [["Content-Type", "application/x-www-form-urlencoded"]],
                         body: body
                        }, 
                        callbackParams // optional callback param
                       );
  return result;
 }
 pr.getServerResponse=_getServerResponse;

 delete pr;
 
 function _pushForm(f,action,target,data)
 {var result = new Array();
  result.push(f.action);if(action)f.action = action;   
  result.push(f.target);if(target)f.target = target;
  for(var i=0;data!=null && i<data.length;i++)
  {try
   {result.push([data[i][0],f[data[i][0]].value]);
    f[data[i][0]].value = data[i][1];
   }
   catch(e)
   {alert('_pushFormData caught an exception on '+data[i][0]+' -> '+f[data[i][0]]);
   }
  }
  return result;
 }
 function _popForm(f,data)
 {f.action=data[0],f.target=data[1];   
  for(var i=2;i<data.length;i++)
  {f[data[i][0]].value=data[i][1];
  }
 }
 
 function _jr(id) 
 {if(typeof(_res)!='undefined' && _res[id]) return _res[id];
  return id;   
 }
 