/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
// codice javascript per la gestione del div nascosto per la ricerca per intervalli di date.

var dateRangeDivOpened = false;

/* 
 * Created on: 19/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per la chiusura del div nascosto per la ricerca per intervalli di date.
 */
function CloseDateRangeDiv()
{
	var el = document.getElementById("DateRange");
	
	if ( el != null  && typeof(document.dateRangeForm) != 'undefined' ) {
		document.dateRangeForm.returnField.value = "";
		
		// Modifica di Federico del 20/12/2004: eventuale chiusura di un calendario js aperto 
		if (typeof(CloseCal) != "undefined" && typeof(calAperto) != "undefined" && calAperto) {
			CloseCal();
		}
		
		// Modifica di Federico del 20/12/2004: mostro i select che possono interferire con il calendario
		setSelectVisibility('visible');
		
		el.style.display = "none";
		dateRangeDivOpened = false;
	}
}

/* 
 * Created on: 19/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per l'apertura del div nascosto per la ricerca per intervalli di date.
 * 				Se il browser  IE, il div viene mostrato a partire dalla posizione corrente
 * 				del mouse (a sinistra); se, invece, il browser  diverso da IE, il div viene
 * 				mostrato al centro della pagina (circa...).
 * 				In fase di apertura del div vengono controllate e visualizzate le eventuali
 * 				date specificate nell'input text a cui il div si riferisce. 
 */
function OpenDateRangeDiv(caller)
{
	if ( typeof(caller) == 'undefined' || typeof(getForm('theForm')[caller]) == 'undefined' ) {
		return;
	}
	
	var el = document.getElementById("DateRange");
	
	if ( el != null && typeof(document.dateRangeForm) != 'undefined' ) {
			// inserisco nell'input nascosto 'returnField' il nome dell'input text chiamante
			document.dateRangeForm.returnField.value = caller;
			
			/* controllo e visualizzo le eventuali date specificate nell'input text a cui il div si riferisce.
			 * Il controllo viene saltato se non sono state specificate date e se non ci sono date in or (uso
			 * del vocabolario).
			 */
			var valDate = getForm('theForm')[caller].value;
			
			if ( valDate != "" && valDate.indexOf("or") == -1 ) {
				if ( valDate.charAt(0) == '{' ) {
					valDate = valDate.substring(1);
				}
				
				if ( valDate.charAt(valDate.length - 1) == '}' ) {
					valDate = valDate.substring(0,valDate.length - 1);
				}
				
				if ( valDate.indexOf("|") != -1 ) {
					document.dateRangeForm.date_range_from.value = valDate.substring(0,valDate.indexOf("|"));
					document.dateRangeForm.date_range_to.value = valDate.substring(valDate.indexOf("|") + 1);
					
					dateRangeChkDate(document.dateRangeForm.date_range_from,true);
					dateRangeChkDate(document.dateRangeForm.date_range_to,true);
				}
				else {
					document.dateRangeForm.date_range_from.value = valDate;
					document.dateRangeForm.date_range_to.value = "";
					
					dateRangeChkDate(document.dateRangeForm.date_range_from,true);
				}
			}
			else {
				document.dateRangeForm.date_range_from.value = "";
				document.dateRangeForm.date_range_to.value = "";
			}
			
			// gestione posizione di apertura del div
			
			/* Modifica di Federico del 20/12/2004:
			 * il codice precedente di gestione della posizione di apertura del div  stato sostituito dal
			 * codice seguente, che consente di aprire il div in corrispondenza dell'icona della ricerca
			 * per range di date anche con Mozilla e Opera (prima con questi due browser il div si apriva nel
			 * centro della pagina).
			 */
			var dataInput = getForm('theForm')[caller];
			
			var top = dataInput.offsetTop + dataInput.offsetHeight;
			var left = dataInput.offsetLeft;
			var oggetto = dataInput.offsetParent;
			
			while (oggetto != null) {
				top += oggetto.offsetTop;
				left += oggetto.offsetLeft;
				oggetto = oggetto.offsetParent;
			}
			
			el.style.left = left - 285; // faccio in modo che il div si apra a sinistra dell'icona 
			
			/* Valuta la direzione di apertura del div (in su o in giu') in base alla dimensione dell schermo e lo
			 * scrolling della finestra.
			 */
			var height = window.innerHeight + document.body.scrollTop;	// altezza della finestra di visualizzazione
			var divHeight = 155;										// altezza del calendario
			var bottom = top + dataInput.offsetTop + divHeight;			// fondo del calendario

			//alert("height:" + height + "   bottom: " + bottom + "  top:" + top);

			if (bottom > height) {
				top -= divHeight;
			}
			
			el.style.top = top;
			
			// indica al metodo 'CloseCal()' di non mostrare i select che potrebbero interferire con i div nascosti
			dateRangeDivOpened = true;
			
			// Modifica di Federico del 20/12/2004: eventuale chiusura di un calendario js aperto 
			if (typeof(CloseCal) != "undefined" && typeof(calAperto) != "undefined" && calAperto) {
				CloseCal();
			}
			
			// Modifica di Federico del 20/12/2004: nascondo i select che possono interferire con il calendario
			setSelectVisibility('hidden');
			
			el.style.display = "block";
	}
	
	return;  
}

/* 
 * Created on: 19/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per l'invocazione della funzione 'chkDate' (file chkdate.js) per il controllo
 * 				del formato delle date specificate negli input 'Da' e 'A' del div. 
 */
function dateRangeChkDate(theInput, verbose)
{
	var ret = true;
	lastChkResult = '';
	
	if ( theInput.value == '' )
		return true;
	
	if ( theInput.value.length == 8 &&
			eval(theInput.value.substring(4,6)) < 13 ) {
			
		// ho una data del tipo aaaammgg --> devo convertire in ggmmaaaa
		theInput.value = theInput.value.substring(6) + theInput.value.substring(4,6) + theInput.value.substring(0,4);			
	}
	
	ret = chkDate(theInput, verbose);

	if ( ret == false ) {
		setTimeout(function(){theInput.focus()}, 10);
		theInput.select();
		lastChkResult = theInput;
				
		return false;
	}
	
	return ret;
}

/* 
 * Created on: 19/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione invocata alla pressione del pulsante 'Ok' del div.
 * 				Controlla i valori (o il valore) delle date specificate e li inserisce opportunamente
 * 				nell'input text a cui il div si riferisce. 
 */
function ConfirmDateRangeDiv()
{
	if ( typeof(document.dateRangeForm) != 'undefined' ) {
		
		var retField = getForm('theForm')[document.dateRangeForm.returnField.value];
		
		if ( document.dateRangeForm.date_range_from.value != '' ||
				document.dateRangeForm.date_range_to.value != '' ) {
			
			/*if ( document.dateRangeForm.date_range_from.value != '' &&
					document.dateRangeForm.date_range_to.value != '' ) {*/
						
				retField.value = "{" + 
									document.dateRangeForm.date_range_from.value +
									"|" +
									document.dateRangeForm.date_range_to.value +
									"}";
			/*}
			else
				if ( document.dateRangeForm.date_range_from.value != '' ) {
					retField.value = document.dateRangeForm.date_range_from.value;
				}
				else {
					retField.value = document.dateRangeForm.date_range_to.value;
				}*/
			
			CloseDateRangeDiv();
		}
	}
}

/* 
 * Created on: 20/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione invocata da 'makeBaseQuery()' (file generico query.js).
 * 				Controlla i valori delle date specificate nei range di tutta la pagina e li converte
 * 				nel formato extraway aaaammgg (se no la ricerca per range di date non funziona correttamente).
 * 				Restituisce la query modificata (sostituisce i range aggiornati nella vecchia query passata
 * 				come parametro). 
 * 
 * 				NOTA: Dopo aver dichiarato le chiavi dei campi relativi alle date come chiavi di tipo 'date'
 * 					  (applicazione XSpring), questa conversione si  rivelata inutile, visto che Extraway
 * 					   in grado di gestire date in formati differenti a quello highway ('aaaammgg').
 * 					  Questa funzione, la cui chiamata in 'makeBaseQuery()'  stata disabilitata,  stata
 * 					  lasciata per possibili usi futuri.  
 */
function convertDateRange(query)
{
	var element; // elemento della pagina esplorato
	var date1;	 // prima data del range
	var date2;	 // seconda data del range
	var chk1;
	var chk2;
	var tmpElement = document.createElement("input"); // elemento input temporaneo
	var startElem, stopElem;
	var result = query;
	
	var roundPar = result.indexOf('(') != -1;
	
	//alert(result)
	
	for( var index = 0; index < getForm('theForm').elements.length; index++ ) {
		element = getForm('theForm').elements[index];
		
		if ( element.type == 'text' &&
				element.value != '' &&
				element.value.charAt(0) == '{' &&
				element.value.charAt(element.value.length - 1) == '}' &&
				element.value.indexOf("|") != -1 ) {
			
			date1 = element.value.substring(1, element.value.indexOf("|"));
			date2 = element.value.substring(element.value.indexOf("|") + 1, element.value.length - 1);
			
			//alert(date1 + " " + date2)
			
			// controllo che il formato delle date sia corretto (potrebbe essere un range numerico)
			tmpElement.value = date1;
			chk1 = chkDate(tmpElement, false);
			tmpElement.value = date2;
			chk2 = chkDate(tmpElement, false);
			
			if ( chk1 && chk2 ) {
				date1 = dateFormatted2XW(date1);
				date2 = dateFormatted2XW(date2);
				
				if ( (startElem = result.indexOf(element.name)) != -1 ) {
					// sostituzione dell'elemento presente nella query
					if ( element.name.charAt(0) == '[' &&
							element.name.charAt(element.name.length - 1) == ']' ) {
								
						if ( roundPar ) {
							startElem -= 1;
						}
					}
					else {
						if ( roundPar ) {
							startElem -= 2;
						}
						else {
							startElem -= 1;
						}
					}
					
					if ( roundPar ) {
						stopElem = result.indexOf(")", startElem);
					}
					else {
						stopElem = result.indexOf("}", startElem);
					}
					
					if ( element.name.charAt(0) == '[' &&
							element.name.charAt(element.name.length - 1) == ']' ) {
								
						result = result.substring(0, startElem) + '(' + element.name + '={' + date1 + '|' + date2 + '})' + result.substring(stopElem + 1);
					}
					else {
						result = result.substring(0, startElem) + '([' + element.name + ']={' + date1 + '|' + date2 + '})' + result.substring(stopElem + 1);
					}
				}
				else {
					// append
					if ( result != '' ) {
						result += ' AND ';
					}
					
					if ( element.name.charAt(0) == '[' &&
							element.name.charAt(element.name.length - 1) == ']' ) {
								
						result += '(' + element.name + '={' + date1 + '|' + date2 + '})';
					}
					else {
						result += '([' + element.name + ']={' + date1 + '|' + date2 + '})';
					}
				}
			}
		}
	}
	
	//alert(result)
	
	return result;
}