/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* File migrato da docway 2 il 04/05/2005 da Federico: contiene funzioni per gestire le date sotto forma di numeri, consentendo, quindi,
 * operazioni di somma, sottrazione, ecc.
 */

	function DateToNum(DateStr)
	// Trasforma la data passata come parametro in un numero
	// contenente la data espressa nella forma aaaammgg.
	{
		var num, mm;
		num = eval(DateStr.substring(6, 10));
		num *= 10000;
		mm = eval(DateStr.substring(3, 5));
		num += mm * 100;
		num += eval(DateStr.substring(0, 2));
	
		return num;
	}
	
	function RealDateToNum(DateStr)
	// Trasforma la data passata come parametro in numero di giorni trascorsi
	// dall'1/1/0000.
	{
		var aa = eval(DateStr.substring(6, 10));
		var mm = eval(DateStr.substring(3, 5));
		var gg = eval(DateStr.substring(0, 2));
		var Giorni = 0;
	
		Giorni = gg;
		if      ( mm == 2 )		Giorni += 31;
		else if ( mm == 3 )		Giorni += 59;
		else if ( mm == 4 )		Giorni += 90;
		else if ( mm == 5 )		Giorni += 120;
		else if ( mm == 6 )		Giorni += 151;
		else if ( mm == 7 )		Giorni += 181;
		else if ( mm == 8 )		Giorni += 212;
		else if ( mm == 9 )		Giorni += 243;
		else if ( mm == 10 )		Giorni += 273;
		else if ( mm == 11 )		Giorni += 304;
		else if ( mm == 12 )		Giorni += 334;
		// Aggiorno 365 giorni per ogni anno trascorso per intero
		Giorni += (aa - 1) * 365;
		// Aggiungo al conto tutti i giorni dei vari anni bisestili.
		Giorni += Math.floor(aa / 4) - Math.floor(aa / 100) + Math.floor(aa / 400);
		if ( mm < 3 && (aa % 4) == 0 && ((aa % 100) || ((aa % 400) == 0)) )  {
			// Se l'anno attuale  bisestile ma il mese non  >= a marzo,
			// decremento di uno il numero dei giorni passati dall'anno
			// zero.
			--Giorni;
		}
	
		return Giorni;	
	}
	
	function NumToDate(Num, bFormatoVideo)
	// Trasforma il numero passato come parametro in data. Il numero rappresenta
	// il numero di giorni trascorsi dal 01/01/0000.
	{
		var gg = 0;
		var mm = 0;
		var aa = 0;
	
		// Isolo il secolo in cui  racchiusa la data.
		// In realt la verifica la faccio ogni 5 secoli.
		// Comunque quindi dopo questi test sono in grado
		// di affermare in quale range di anni  racchiusa
		// la data attuale.
		var Days = DaysPerYear(1900);
		if ( Days > Num )  {
			Days = DaysPerYear(1500);
			if ( Days > Num )  {
				Days = DaysPerYear(1000);
				if ( Days > Num )  {
					Days = DaysPerYear(500);
					if ( Days > Num )				aa = 0;
					else								aa = 500;
				}
				else									aa = 1000;
			}
			else										aa = 1500;
		}
		else											aa = 1900;
		// Risalgo all'anno effettivo, verificando anche se il delta dal multiplo
		// di 500 che ho trovato non mi porta ad indietreggiare di un anno.
		aa += Math.floor((Num - Days) / 365);
		Days = Num - DaysPerYear(aa);
		if ( Days < 0 )  {
			--aa;
			Days = Num - DaysPerYear(aa);
		}
		// Risalgo al mese.
		if 		( Days > 334 )	{		mm = 12;	Days -= 334;	}
		else if 	( Days > 304 ) {		mm = 11; Days -= 304;	}
		else if 	( Days > 273 ) {		mm = 10; Days -= 273;	}
		else if 	( Days > 243 ) {		mm =  9;	Days -= 243;	}
		else if 	( Days > 212 ) {		mm =  8;	Days -= 212;	}
		else if 	( Days > 181 ) {		mm =  7;	Days -= 181;	}
		else if 	( Days > 151 ) {		mm =  6;	Days -= 151;	}
		else if 	( Days > 120 ) {		mm =  5;	Days -= 120;	}
		else if 	( Days > 90  ) {		mm =  4;	Days -=  90;	}
		else if 	( Days > 59  ) {		mm =  3;	Days -=  59;	}
		else if 	( Days > 31  ) {		mm =  2;	Days -=  31;	}
		else									mm =  1;
	
		// Se l'anno attuale  bisestile ma il mese non  >= a marzo,
		// decremento di uno il numero dei giorni passati dall'anno
		// zero.
		if ( mm < 3 && (aa % 4) == 0 && ((aa % 100) || ((aa % 400) == 0)) )  {
			++Days;
			if ( mm == 1 && Days > 31 )  {
				++mm;
				Days -= 31;
			}
		}
	
		// La parte restante sono i giorni.
		if ( Days > 0 )
			gg = Days;
		else
			gg = 1;
		
		var DateStr = "";
		if ( bFormatoVideo )  {
			if ( gg < 10 )					DateStr += "0";
			DateStr += trim(gg.toString());
			DateStr += '\/';
			if ( mm < 10 )					DateStr += "0";
			DateStr += trim(mm.toString());
			DateStr += '\/';
			if      ( aa < 1000 )		DateStr += "0";
			else if ( aa < 100 )			DateStr += "00";
			else if ( aa < 10 )			DateStr += "000";
			DateStr += trim(aa.toString());
		}
		else  {
			if      ( aa < 1000 )		DateStr += "0";
			else if ( aa < 100 )			DateStr += "00";
			else if ( aa < 10 )			DateStr += "000";
			DateStr += trim(aa.toString());
			if ( mm < 10 )					DateStr += "0";
			DateStr += trim(mm.toString());
			if ( gg < 10 )					DateStr += "0";
			DateStr += trim(gg.toString());
		}
		return DateStr;
	}
	
	function DaysPerYear(year)
	// Calcola il numero di giorni trascorsi dal 01/01/0000 al primo gennaio
	// dell'anno passato come parametro.
	{
		var Days = 0;
		Days = (year - 1) * 365;
		// Aggiungo al conto tutti i giorni dei vari anni bisestili.
		Days += Math.floor(year / 4) - Math.floor(year / 100) + Math.floor(year / 400);
		return Days;
	}
