/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

/* flap.js */
/* gestione delle linguette */

function openFlapDiv(obj, id)
{
        if ( typeof(customOpenFlapDiv) != 'undefined' ) {
                customOpenFlapDiv(obj, id);
        }
        else {
                if ( id.indexOf('_anchor') > 0 )
                        id = id.substring(0, id.indexOf("_anchor"));

                getForm("hxpForm").flap.value = id + '_anchor';
                var divs = document.getElementsByTagName("div");
                var div;
                var realDiv;
                for ( var i = 0; i < divs.length; i++ ) {
                        div = divs.item(i);
                        if ( div.id.indexOf("flap_") == 0 ) {
                                if ( div.id == id || id == 'ALL') {
                                        realDiv = div;
                                        setVisibility(div, 'block');
                                        if ( typeof(customGetFlapSelectedColor) != 'undefined' ) {
                                        obj.style.color = customGetFlapSelectedColor();
                                        }
                                }
                                else {
                                        setVisibility(div, 'none');
                                }
                        }
                }

                closeFlapNoData();
                if ( id != 'ALL' )
                        ifEmptyOpenFlapNoData(realDiv, id);
                decolorOthers(id + '_anchor');
        }
}

function ifEmptyOpenFlapNoData(div, id)
{
	var el, els;
	var noData = null;
	var trovato = false;
	noData = document.getElementById('NODATA');
	if ( noData != null ) {
		els = div.childNodes;
		for ( var i = 0; i < els.length; i++ ) {
			el = els.item(i);
			if ( el.childNodes.length == 0 )
				continue;
			el = el.childNodes(0);
			if ( typeof(el.id) != 'undefined' &&  el.id == 'ParagraphDiv' && el.style.display != 'none' ) {
				trovato = true;
				break;
			}
		}
		if ( trovato == false )
			noData.style.display = 'block';
	}
}

function closeFlapNoData()
{
	el = document.getElementById('NODATA');
	if ( el != null )
		el.style.display = 'none';
}

// Federico 11/05/07: aggiunto parametro 'containerId' che indica l'id dell'elemento che contiene
// l'elemento da mostrare/nascondere. Se viene passato 'containerId', deve essere passato anche l'elemento
// che contiene la chiamata alla function e si suppone che 'div' sia l'id
// dell'elemento da mostrare/nascondere [RW 0043770].
function setVisibility(div, vis_value, containerId, currentNode)
{
    //alert("div: " + div + " - vis_value: " + vis_value + " - containerId: " + containerId);

    if (typeof(containerId) != 'undefined' && containerId != null &&
            typeof(div) != 'undefined' && div != null &&
            typeof(currentNode) != 'undefined' && currentNode != null) {

        // gestione dei multistanza
        if (containerId.indexOf('$hxp_instance()') != -1) {
            var instNumber = getInstanceNumber(currentNode, containerId);
            containerId = containerId.replace('$hxp_instance()', instNumber);
        }

        var container = document.getElementById(containerId)

        if (container != null) {
            div = getElementByAttrWithRoot(container, div, 'id');
        }
        else {
            div = null;
        }
    }

	if ( div != null )
		if ( vis_value == 'block')
			blockNoneElement(div);
		else
			div.style.display = vis_value;
}

function decolorOthers(id)
{
        if ( typeof(customDecolorOthers) != 'undefined' ) {
                customDecolorOthers(id);
        }
        else {
                var els = document.getElementsByTagName("a");
                var el;
                for ( var i = 0; i < els.length; i++ ) {
                        el = els.item(i);
                        if ( el.id.indexOf("_anchor") > 0 ) {
                                if ( el.id != id ) {
                                        if ( typeof(customGetFlapUnselectedColor) != 'undefined' ) {
                                                el.style.color = customGetFlapUnselectedColor();
                                        }
                                }
                        }
                }
        }
}

function flap_loadHandler()
{
        if ( typeof(customFlap_loadHandler) != 'undefined' ) {
                customFlap_loadHandler();
                return;
        }

	var flapToOpenA = getForm("hxpForm").flap.value;
	if ( flapToOpenA.length == 0 )
		flapToOpenA = 'x';

	var el = document.getElementById(flapToOpenA);

	if ( el == null ) {
		var els = document.getElementsByTagName("a");
		for ( var i = 0; i < els.length; i++ ) {
			el = els.item(i);
			if ( el.id.indexOf("_anchor") > 0 )
				break;
			el = null;
		}
	}

	if ( el != null ) {
		if ( typeof(customGetFlapSelectedColor) != 'undefined' )
			el.style.color = customGetFlapSelectedColor();
		var id_div = el.id.substring(0, el.id.indexOf("_anchor"));
		setVisibility(document.getElementById(id_div), 'block');

		if ( id_div != 'ALL' )
			ifEmptyOpenFlapNoData(document.getElementById(id_div), id_div);
		else {
			var divs = document.getElementsByTagName("div");
			var div;
			for ( var i = 0; i < divs.length; i++ ) {
				div = divs.item(i);
				if ( div.id.indexOf("flap_") == 0 ) {
					setVisibility(div, 'block');
				}
			}
		}
	}
}


// fine flap


//inizio per nascondere righe, sezioni vuote

function showRows()
{
	//Modalit di test. Esco dalla funzione
	if (isTestMode()) return;

	var els = document.getElementsByTagName('span');
	var el, tr, content, section;
	for ( var i = 0; i < els.length; i++ ) {
		el = els.item(i);
        //alert(el.id);
		if ( el.id == 'CellDescrWithDataDiv' ) {
			tr = getAncestor(el, 'ParagraphContentRowDiv');
			tr.style.display = ''; //'block';
			content = getAncestor(tr, 'ParagraphContentDiv');
			content.style.display =''; // 'block';
			paragraph = getAncestor(content, 'ParagraphDiv');
			paragraph.style.display = ''; //'block';
			section = getAncestorSection(content);
			if ( section != null )
				section.style.display = ''; //'block';
		}
	}
}

function getAncestor(el, id)
{
    //alert (id);
    var parent = el.parentNode;
    //alert(parent.id);
	while ( (typeof(parent.id) == 'undefined' || parent.id != id) ){
        //alert("nodo:" + parent.nodeName + " id: " + parent.id);
        parent = parent.parentNode;
    }
	return parent;
}

function getAncestorSection(el)
{
	var parent = el.parentNode;
	while ( typeof(parent.id) == 'undefined' || parent.id != 'ParagraphSectionDiv' ) {
		if ( parent.id == 'ParagraphDiv' )
			return null;
		parent = parent.parentNode;
	}
	return parent;
}


//inizio per sezioni di pagina menu
function SimpleDisplayLayer(layerID)
{
	if (document.getElementById) {
		document.getElementById(layerID).style.display = (document.getElementById(layerID).style.display == 'none') ? 'block' : 'none';
	}
	else if (document.all) {
		document.all(layerID).style.display = (document.all(layerID).style.display == 'none') ? 'block' : 'none';
	}
	else  {
	}
}

function DisplayLayer(layerID, ImgID, ImgName)
{
	if (document.getElementById) {
		document.getElementById(layerID).style.display = document.getElementById(layerID).style.display=='none' ? 'block' : 'none';
		if ( layerID!='DocSection' ) {
			if ( document.getElementById(layerID).style.display=='none' ) {
				MM_swapImage(ImgID,'',ImgName.replace('open', 'close'),1);
			}
			else {
				MM_swapImage(ImgID,'',ImgName.replace('close', 'open'),1);
			}
			// la sezione gestione documenti  differente dalle altre, c' un solo elemento da nascondere.
			var layerID_b=layerID+"Space_b";
			var layerID_a=layerID+"Space_a";
			document.getElementById(layerID_b).style.display=document.getElementById(layerID_a).style.display=document.getElementById(layerID).style.display;
		}
	}
	else if (document.all) {
		document.all(layerID).style.display = document.all(layerID).style.display=='none' ? 'block' : 'none';
		var layerID_b=layerID+"Space_b";
		var layerID_a=layerID+"Space_a";
		document.all(layerID_b).style.display=document.all(layerID_a).style.display=document.all(layerID).style.display;
		if ( document.all(layerID).style.display=='block' ) document.images[ImgID].src = section[i].src;
		else document.images[ImgID].src = section[i+4].src;
	}
}


//inizio per ridimensionamento input per inserimento/modifica

function resizeInputs()
{
//alert(getForm("hxpForm").browser);
//alert(getForm("hxpForm").browser.value);
    //modifica di mbussetti (21/01/2005) legata alla risoluzione dell'anomalia RW25541
    var isExplorer = false;
    if ( getForm("hxpForm").browser.value.indexOf("IE") == -1 ){
        if (navigator.userAgent.indexOf("MSIE") != -1 ){
            isExplorer = true;
        }
    }
    else if ( getForm("hxpForm").browser.value.indexOf("IE") == 0 ) {
        isExplorer = true;
    }

	if ( !isExplorer ){
        //alert("non sono explorer");
		return ;
    }

	var els = document.getElementsByTagName("table");
	var el;
	for ( var i = 0; i < els.length; i++ ) {
		el = els.item(i);
		if ( isDisplayNone(el) == false ) {
			el.style.width = el.clientWidth;
		}
	}

	els = document.getElementsByTagName("input");
	var el, anc, pc_width, res_width;
	for ( var i = 0; i < els.length; i++ ) {
		el = els.item(i);
		if ( el.type != 'hidden' && el.width == '' && isDisplayNone(el) == false ) {
			if ( typeof(el.currentStyle.hx2p_width) != 'undefined' ) {
				pc_width = el.currentStyle.hx2p_width;
				pc_width = pc_width.substring(0, pc_width.length - 1);
				anc = getAncestorTD(el);

				if ( anc != null ) {
					res_width = anc.clientWidth*pc_width/100;
					el.style.width = res_width;
				}
			}
		}
	}

}


function getAncestorTD(el)
{
	var parent = el.parentNode;
	while ( parent.tagName != 'td' && parent.tagName != 'TD' ) {
		if ( parent.tagName == 'form' || parent.tagName == 'FORM' )
			return null;
		parent = parent.parentNode;
	}
	return parent;
}


function isDisplayNone(el)
{
	var parent = el;
	while ( parent != null && parent.tagName != 'form' && parent.tagName != 'FORM' ) {
		if ( typeof(parent.style) != 'undefined' && typeof(parent.style.display) != 'undefined'
		     && parent.style.display == 'none' )
			return true;
		parent = parent.parentNode;
	}
	return false;
}


function blockNoneElement(el)
{
    // Federico 16/02/09: introdotto test sulla nullita' di 'el' [RW 0056907]
    if (el != null) {
    	with ( el.style )
    		display = ''; //sstagni - 2 Nov 2007 TOLGO BLOCK in quanto su Firefox ha dato problemi di stile

        // Federico 30/04/07: al di la' dell'utilita' delle seguenti chiamate (a me ignota), se il browser non e' IE
        // si possono avere problemi di css (per es. la tendina del ContextualMenu perde lo sfondo se contenuta in div
        // mostrati/nascosti dal js) --> se il browser non e' IE non effettuo le chiamate sottostanti [RW 0043770]
        if (getForm("hxpForm").browser.value.indexOf("IE") == 0) {
        	treeVisitFixTableWidth(el);
        	treeVisitResizeTD(el);
        }
    }
}


function treeVisitFixTableWidth(el)
{
	var el1;
	var els = el.childNodes;

	for ( var i = 0; i < els.length; i++ ) {
		el1 = els.item(i);

        if (el1.tagName == 'table' || el1.tagName == 'TABLE') {
            // Federico 15/05/07: se la tabella esaminata possiede l'attributo 'treeVisitFixTableWidth'
            // con valore 'do_not_modify', la sua width non deve essere modificata [RW 0043770]
            var modifyWidth = true;

            if (typeof(el1.treeVisitFixTableWidth) != 'undefined' &&
                    el1.treeVisitFixTableWidth == 'do_not_modify') {

                modifyWidth = false;
            }

            if (modifyWidth) el1.style.width = el1.clientWidth;
        }

		treeVisitFixTableWidth(el1);
	}
}


function treeVisitResizeTD(el)
{
	var el1;
	var els = el.childNodes;
	for ( var i = 0; i < els.length; i++ ) {
		el1 = els.item(i);
		if ( (el1.tagName == 'input' || el1.tagName == 'INPUT' ) &&
		     (el1.type != 'hidden' && el1.width == '' ) ) {
			if ( typeof(el1.currentStyle.hx2p_width) != 'undefined' ) {
				pc_width = el1.currentStyle.hx2p_width;
				pc_width = pc_width.substring(0, pc_width.length - 1);
				anc = getAncestorTD(el1);
				if ( anc != null ) {
					res_width = anc.clientWidth*pc_width/100;
					el1.style.width = res_width;
				}
			}
		}
		treeVisitResizeTD(el1);
	}
}


//inizio per menu contestuale
var openDelay = 0;
var theMenu = null;
function openOptsMenu(obj, stopPolicy, delay)
{
	var el, els;

	els = document.getElementsByTagName("table");//first close all
	for ( var i = 0; i < els.length; i++ ) {
		el = els.item(i);
		if ( typeof(el.id) != 'undefined' && el.id == 'optsMenu' ) {
			el.style.display = "none";
		}
	}

	if ( typeof(stopPolicy) != 'undefined' && stopPolicy == 'UP_TO_TD' )
		els = getAncestorTD(obj).childNodes;
	else
		els = obj.parentNode.childNodes;

	for ( var i = 0; i < els.length; i++ ) {
		el = els.item(i);
		if ( typeof(el.id) != 'undefined' && el.id == 'optsMenu' ) {
			theMenu = el;
			setTimeout('delayedOpenOptsMenu()', typeof(delay) == 'undefined' ? openDelay : delay);
		}
	}

	return false;
}


function delayedOpenOptsMenu()
{
	if ( theMenu != null ) {
		theMenu.style.display = "block";

        if ( typeof(theMenu.currentStyle)!='undefined')
    		if ( typeof(theMenu.currentStyle.hx2p_moveup) != 'undefined' && theMenu.currentStyle.hx2p_moveup == 'true' ) {
    			var els = theMenu.parentNode.childNodes;
    			var p;
    			for ( var i = 0; i < els.length; i++ )
    				if ( els.item(i).id == 'fixedEl' )
    					p = els.item(i);
    			theMenu.style.top = p.offsetTop - theMenu.clientHeight + 10;
    		}
	}
}


function closeOptsMenu(obj)
{
	//Esce se  attivo il TEST MODE
	if (isTestMode()) return;

	var anc = getAncestor(obj, 'optsMenu');
	anc.style.display = "none";
}

function annulOpenOptsMenu()
{
	theMenu = null;
	return false;
}


/*
DD 21/02/2006 - Visualizzazione gerarchica del titolario di classificazione (RW: 0033793)
Gestisce l'apertura/chiusura degliu elementi nascosti, nella visualizzazione di uno specifico albero gerarchico.
PARAM:
elem 			= l'elemento del 'bottone' che espande/contrae un ramo. QUesto contiene al suo interno un'immagine che viene
				cambiata se il ramo  apreto o chiuso. Le immagini utilizzate al momento sono piu.gif o meno.gif (vedi sotto)
theId 		= E' l'id del ramo da espandere. L'id  gerarchico: se viene chiesta ad es: l'apertura di "5.6.1" verrano aperti
				tutti gli elementi con id che inizia per quello passato (es: 5.6.1.1, 5.6.1.2, 5.6.1.3...) cio, i figli del ramo.
tagName 		= E' il tipo di tag da nascondere/mostrare (div, td, etc..)
allAction	= (true/false) Se passato forza l'apertura di tutta la gerarchia.
skipLevel 	= Nel caso di AllAction, se passato, indica il livello non interessato dall'apertura/chiusura della gerarchia. Se ad esempio si
					vuole che il primo livello della gerarchia non venga contratto, per non mostrare un unico elemento, basta indicare "1".
*/
function hideShowChildrenBranch(elem, theId, tagName, allAction, skipLevel)
 {
 	//Costanti:
 	//Immagine + e -
 	var imgPiu = "piu.gif";
 	var imgMeno = "meno.gif";

 	var isHidden;
 	if (typeof(allAction)=='undefined') {
	 	//Mostro + o - a seconda dei casi
	 	var isHidden=elem.innerHTML.indexOf('/' + imgPiu)!=-1;
	  	if(isHidden){
	  		//Mostro il -
	  		elem.innerHTML=elem.innerHTML.replace(imgPiu, imgMeno);
	  	} else {
	  		//Mostro il +
	  		elem.innerHTML=elem.innerHTML.replace(imgMeno, imgPiu);
	  	}
	} else {
		isHidden = allAction;
	}

	var livello_chiamante = theId.split('.').length - 1;
  	var elements = document.getElementsByTagName(tagName);
	for (var i = 0; i < elements.length; i++ ){
		idEl = elements[i].id;
		if (idEl.indexOf(theId) != -1 && idEl != theId) {
		   var livello = idEl.split('.').length - 1;
			if (typeof(allAction)!='undefined' && typeof(skipLevel)!='undefined') {
				//Conto il numero di punti per capire il livello gerarchico e verificare non  da skippare
				if(livello == skipLevel){
				 	continue;
				 }
			} else {
			   //Apro solo i figli (e non i nipoti, per quelli ci sono i pulsnati specifici).
			   // Se si tratta di chiusura invece riguarda tutti i discendenti
			   if(isHidden && livello != livello_chiamante + 1) continue;
			}

			elements[i].style.display=(isHidden?'block':'none');
		}
	}

	if (typeof(allAction)!='undefined') {
		//Apri/chiudi tutti. Aggiorno i "+" e i "-" dei bottoni
		var elements = document.getElementsByTagName("a");
		for (var i = 0; i < elements.length; i++ ){
			if(elements[i].id == 'nodeButton'){
				var elem = elements[i];
				if(isHidden){
			  		//Mostro il -
			  		elem.innerHTML=elem.innerHTML.replace(imgPiu, imgMeno);
			  	} else {
			  		//Mostro il +
			  		elem.innerHTML=elem.innerHTML.replace(imgMeno, imgPiu);
			  	}
			}
		}
	}

  	return false;
}