/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/**************************************
**  Alcune variabili da configurare  **
***************************************/
var _DIV_ID_        = 'SearchTreeDiv';
var _TABLE_ID_      = 'SearchTreeTable';
var _IMG_PATH_ = '../../../formatter/html/data/img/img_hierarchy/';
var _TITLE_1_  = '';
var _TITLE_2_  = '';
var _TITLE_F_  = '';
var _HXP_FORM_ = "getForm('hxpForm')";

/* SOLO PER DIV A SCOMPARSA */
var _QUERY_LANG_ID_ = 'SearchTreeDivQueryLangText';
var DIV_WIDTH  = 400;
var DIV_HEIGHT = 250;
var W_OFFSET   = 150;
var H_OFFSET   = 30;
var H_QUERY_L  = 90;
var H_ERROR    = ( (navigator.userAgent.toLowerCase().indexOf('msie') != -1) ? 2 : 12 );

/*******************************
**  Alcune variabili globali  **
********************************/
var hierarchy      = null;
var hierMenuDepth  = -1;
var hierMenuBar    = null;
var hierTable      = null;
var currentSet     = null;
var explodeId      = null;
var unExploded     = null;

/***************************************
**  Definiamo l'oggetto HierMenuItem  **
****************************************/
/* Costruttore */
function HierMenuItem(id, size, text1, text2, selected) {
    this.id            = id;
    this.size          = size;
    this.text1         = text1;
    this.text2         = text2;
    this.selected      = selected;
    this.submenu       = null;
    this.parent        = null;
    this.createSubmenu = HierMenuCreateSubmenu;
    if(this.selected) currentSet = this.id;
    if ( (text2.indexOf("[fasc_") != -1) || 
         (text2.indexOf("[UD,/xw/@UdType]=fascicolo") != -1) ) this.folder = true;
    else this.folder = false;
}

/* Metodo */
function HierMenuCreateSubmenu(menu) {
    this.submenu = menu;
    this.submenu.parent = this.parent;
    return menu;
}

/***********************************
**  Definiamo l'oggetto HierMenu  **
************************************/
/* Costruttore */
function HierMenu(exploded) {
    this.item     = new Array();
    this.exploded = exploded;
    this.parent   = null;
    this.addItem  = HierMenuAddItem;
}

/* Metodo */
function HierMenuAddItem(item) {
    item.parent = this;
    this.item[this.item.length] = item;
    return item;
}

function displayHierarchy() {
    
	 //DD 19/10/05 Modalit di test. Esco dalla funzione
	 if (isTestMode()) return;
    
    hierMenuDepth  = -1;
    hierMenuBar    = new Array();
    unExploded     = new Array();
    hierTable      = document.getElementById(_TABLE_ID_);
    var firstChild = hierTable.firstChild;
    if(null != firstChild) hierTable.removeChild(firstChild);
    hierTable.appendChild(document.createElement('tbody'));
    displayMenu(hierarchy);
    visitorUnExploded(hierarchy);
    var hxpForm = eval(_HXP_FORM_);
    if( (typeof(hxpForm) != 'undefined') && 
        (hxpForm != null) && 
        (typeof(hxpForm.hierSearchList) != 'undefined')) {
            setHierSearchList(hxpForm.hierSearchList);
    }
}

function displayMenu(menu) {
    var root = false;
    hierMenuDepth++;
    if(menu.item.length > 1) hierMenuBar.push(true);
    else hierMenuBar.push(false);
    var idx = 0;
    for (; idx < menu.item.length; idx++)  {
        if( (0 == idx ) && (0 == hierMenuDepth) ) root = true;
        else root = false;
        if(idx == (menu.item.length - 1)) {
            hierMenuBar.pop();
            hierMenuBar.push(false);
        }
        displayItem(menu.item[idx], root);
    }
    hierMenuBar.pop();
    hierMenuDepth--;
}

function displayItem(item, root) {
    var title1, click1, title2, click2, titlef, clickf, text1, text2, bars, corner, minus, plus, selected;
    title1  = _TITLE_1_;
    //click1  = ( (item.size > 0) ? 'return setCurrentSet(\''+item.id+'\');' : 'return setCurrentSetNull(\''+item.id+'\');');
    click1  = 'return setCurrentSet(\''+item.id+'\');';
    title2  = _TITLE_2_;
    //click2  = ( (item.size > 0) ? (root ? 'return setCurrentSet(\''+item.id+'\');' : 'return viewCurrentSet(\''+item.id+'\', \''+item.size+'\', '+item.folder+');') : 'return setCurrentSetNull(\''+item.id+'\');');
    click2  = (root ? 'return setCurrentSet(\''+item.id+'\');' : 'return viewCurrentSet(\''+item.id+'\', \''+item.size+'\', '+item.folder+');');
    titlef  = ( (null != item.submenu) ? _TITLE_F_ : '');
    clickf  = ( (null != item.submenu) ? 'return clickFolder(\''+item.id+'\');' : '');
    text1   = item.text1;
    text2   = ( root ? item.text2+' ['+item.size+']' : '['+item.size+'] '+item.text2);
    bars    = new Array();
    var idx = 0;
    for(; idx < hierMenuBar.length-1; idx++) bars.push(hierMenuBar[idx]);
    corner  = !root && !hierMenuBar[hierMenuBar.length-1];
    if(item.id == currentSet) item.selected = true;
    else item.selected = false;
    if((item.id == explodeId) && (null != item.submenu)) {
        item.submenu.exploded = !item.submenu.exploded;
        explodeId = null;
    }
    minus    = (null != item.submenu) && item.submenu.exploded;
    plus     = (null != item.submenu) && !item.submenu.exploded;
    selected = item.selected;
    
    hierTable.tBodies[0].appendChild(createComplexNode(title1, 
                                                       click1, 
                                                       title2, 
                                                       click2, 
                                                       titlef, 
                                                       clickf, 
                                                       text1, 
                                                       text2, 
                                                       root, 
                                                       bars, 
                                                       corner, 
                                                       minus, 
                                                       plus, 
                                                       selected));
    
    if( (null != item.submenu) && item.submenu.exploded ) displayMenu(item.submenu);
}

function setCurrentSet(id) {
    currentSet = id;
    var hxpForm = eval(_HXP_FORM_);
    if(typeof(hxpForm) != 'undefined' && hxpForm != null) hxpForm.selid.value = id;
    setTimeout('displayHierarchy()', 10);
    return true;
}

function viewCurrentSet(id, size, folder) {
    setCurrentSet(id);
    if(size > 0) {
        var hxpForm = eval(_HXP_FORM_);
        setHierSearchList(hxpForm.hierSearchList);
        hxpForm.selid.value = id;
        hxpForm.pos.value   = 0;
        hxpForm.count.value = size;
        if(size > 1) hxpForm.verbo.value = 'showtitles';
        else hxpForm.verbo.value = 'showdoc';
        if(folder) hxpForm.dbTable.value = '@fascicolo';
        else hxpForm.dbTable.value = '';
        if( typeof(OpenWaitMsg) != 'undefined' ) OpenWaitMsg();
        hxpForm.submit();
    }
    return false;
}

function cuttingBranch(table) {
    var retValue = false;
    var hxpForm = eval(_HXP_FORM_);
    if( typeof(hxpForm) != 'undefined' && hxpForm != null) {
        if( (hxpForm.selid.value != hxpForm.db.value) && 
            (hxpForm.selid.value != '') ) {
            if( confirm('Rimuovere il ramo selezionato?') ) {
                hxpForm.cuttingBranch.value = 'one';
                if( typeof(OpenWaitMsg) != 'undefined' ) OpenWaitMsg();
                retValue = gotoTableQ(table);
            }
        }
        else if( (null != currentSet) &&
                 (hxpForm.db.value != currentSet) ) {
            if( confirm('Rimuovere il ramo selezionato?') ) {
                hxpForm.selid.value = currentSet;
                currentSet = null;
                hxpForm.cuttingBranch.value = 'one';
                if( typeof(OpenWaitMsg) != 'undefined' ) OpenWaitMsg();
                retValue = gotoTableQ(table);
            }
        }
        else if( (hxpForm.db.value == currentSet) &&
                 (hierarchy.item.length > 1) ) {
            if( confirm('Rimuovere tutti i rami dell\'albero?') ) {
                hxpForm.selid.value = currentSet;
                currentSet = null;
                hxpForm.cuttingBranch.value = 'all';
                if( typeof(OpenWaitMsg) != 'undefined' ) OpenWaitMsg();
                retValue = gotoTableQ(table);
            }
        }
    }
    return retValue;
}

function clickFolder(id) {
    explodeId = id;
    setTimeout('displayHierarchy()', 10);
    return true;
}

/* Verifica la presenza di menu NON esplosi */
function visitorUnExploded(menu) {
    var idx = 0;
    for (; idx < menu.item.length; idx++)  {
        if(null != menu.item[idx].submenu) { 
            if(!menu.item[idx].submenu.exploded) unExploded.push(menu.item[idx].id);
            visitorUnExploded(menu.item[idx].submenu);
        }
    }
}

/*******************************************************************
**  Definiamo le funzioni per la costruzione della struttura DOM  **
********************************************************************/

function createImg(src, alt, w, h) {
    var img = document.createElement('img');
    img.setAttribute('src', src);
    img.setAttribute('alt', alt);
    img.setAttribute('align', 'left');
    img.setAttribute('border', '0');
    img.setAttribute('vspace', '0');
    img.setAttribute('hspace', '0');
    img.setAttribute('width', w);
    img.setAttribute('height', h);
    return img;
}

function createText(text, selected) {
    var span = document.createElement('span');
    /* Vengono reintrodotti gli eventuali apostrofi escapati... */ 
    var text = document.createTextNode(text.replace(//gi, '\''));
    if(selected) span.setAttribute('id', 'span_selected');
    else span.setAttribute('id', 'span_unselected');
    span.appendChild(text);
    return span;
}

function createAnchor(title, click, style_suffix) {
    var a = document.createElement('a');
    a.setAttribute('id', 'anchor_'+style_suffix);
    a.setAttribute('href', 'javascript:void(0);');
    a.setAttribute('title', title);
    /* IE non gradisce setAttribute()... */
    try { a.attachEvent('onclick', new Function(click)); }
    catch(err) { a.setAttribute('onclick', click); }
    return a;
}

function createRow(id) {
    var tr = document.createElement('tr');
    if("" != id) tr.setAttribute('id', id);
    return tr;
}

function createCell(id) {
    var td   = document.createElement('td');
    if("" != id) td.setAttribute('id', id);
    td.setAttribute('nowrap', 'nowrap');
    return td;
}

function createComplexNode(title1, 
                           click1, 
                           title2, 
                           click2, 
                           titlef, 
                           clickf, 
                           text1, 
                           text2, 
                           root, 
                           bars, 
                           corner, 
                           minus, 
                           plus, 
                           selected) {
    var r  = createRow("");
    var c  = createCell("td_nowrap");
    var a1 = createAnchor(title1, click1, 'underline_no');
    var a2 = createAnchor(title2, click2, (root?'underline_no':'underline_yes'));
    var af = ((minus || plus)?createAnchor(titlef, clickf, 'underline_no'):null);
    var t1 = createText(text1, selected);
    var t2 = createText(text2, selected);
    var tb = createText(' ', selected);
    for (idx = 0;idx < bars.length; idx++) {
        if(bars[idx]) c.appendChild(createImg(_IMG_PATH_+"menu_bar.gif", "", 18, 20));
        else c.appendChild(createImg(_IMG_PATH_+"menu_spacer.gif", "", 18, 18));
    }
    if(!minus && !plus) {
        if(corner) c.appendChild(createImg(_IMG_PATH_+"menu_corner.gif", "", 18, 18));
        else if(!root) c.appendChild(createImg(_IMG_PATH_+"menu_tee.gif", "", 18, 20));
        if(root) a1.appendChild(createImg(_IMG_PATH_+"menu_root.gif", "", 18, 20));
        else a1.appendChild(createImg(_IMG_PATH_+"menu_link_local.gif", "", 18, 18));
    }
    else if(minus) {
        if(corner) af.appendChild(createImg(_IMG_PATH_+"menu_corner_minus.gif", "", 18, 18));
        else af.appendChild(createImg(_IMG_PATH_+"menu_tee_minus.gif", "", 18, 20));
        a1.appendChild(createImg(_IMG_PATH_+"menu_folder_open.gif", "", 18, 19));
    }
    else if(plus) {
        if(corner) af.appendChild(createImg(_IMG_PATH_+"menu_corner_plus.gif", "", 18, 18));
        else af.appendChild(createImg(_IMG_PATH_+"menu_tee_plus.gif", "", 18 ,20));
        a1.appendChild(createImg(_IMG_PATH_+"menu_folder_closed.gif", "", 18, 18));
    }
    if(!root) a1.appendChild(t1);
    a2.appendChild(t2);
    if(null != af) c.appendChild(af);
    c.appendChild(a1);
    c.appendChild(tb);
    c.appendChild(a2);
    r.appendChild(c);
    return r;
}

function on_offHierarchy(divListToResize, divListToDisplay, divToVisibility) {
    var jdx = 0;
    for(; jdx < divListToDisplay.length; jdx++) {
        var div = document.getElementById(divListToDisplay[jdx]);
        if(0 == jdx) div.style.display = 'block';
        else if(jdx > 0) div.style.display = 'none';
    }
    var idx = 0;
    for(; idx < divListToResize.length; idx++) {
        var div = document.getElementById(divListToResize[idx]);
        if(0 == idx) {
            if(div.style.display == 'block') div.style.display = 'none';
            else div.style.display = 'block';
            var hxpForm = eval(_HXP_FORM_);
            if( (typeof(hxpForm) != 'undefined' && hxpForm != null) && (typeof(hxpForm.hierSearchShow) != 'undefined') ) hxpForm.hierSearchShow.value = div.style.display;
            div.style.height  = DIV_HEIGHT+'px';
        }
        else if((divListToResize.length-1) == idx) div.style.height = (DIV_HEIGHT-20-H_QUERY_L+H_ERROR)+'px';
        div.style.width = DIV_WIDTH+'px';
    }
    var div = document.getElementById(divToVisibility);
    if(null != div) div.style.visibility = 'visible';
    return false;
}

function resizeHierarchy(divListToResize, divListToDisplay, divListToVisibility) {
    var jdx = 0;
    for(; jdx < divListToVisibility.length; jdx++) {
        var div = document.getElementById(divListToVisibility[jdx]);
        if(div.style.visibility == 'hidden')  div.style.visibility = 'visible';
        else div.style.visibility = 'hidden';
    }
    var kdx = 0;
    for(; kdx < divListToDisplay.length; kdx++) {
        var div = document.getElementById(divListToDisplay[kdx]);
        if(div.style.display == 'block')  div.style.display = 'none';
        else div.style.display = 'block';
    }
    var winW = window.innerWidth;
    var winH = window.innerHeight;
    if(typeof(winH) == 'undefined') {
        winW = document.body.offsetWidth;
        winH = document.body.offsetHeight;
    }
    winW -= W_OFFSET;
    winH -= H_OFFSET;
    var idx = 0;
    for(; idx < divListToResize.length; idx++) {
        var div = document.getElementById(divListToResize[idx]);
        if( (div.style.width == '') || (div.style.width == (DIV_WIDTH+'px')) )  div.style.width = winW+'px';
        else div.style.width = DIV_WIDTH+'px';
        if(0 == idx) {
            if( (div.style.height == '') || (div.style.height == (DIV_HEIGHT+'px')) )  div.style.height = winH+'px';
            else div.style.height = DIV_HEIGHT+'px';
        }
        else if((divListToResize.length-1) == idx) {
            if( (div.style.height == '') || (div.style.height == ((DIV_HEIGHT-20-H_QUERY_L+H_ERROR)+'px')) )  div.style.height = (winH-20-H_QUERY_L+H_ERROR)+'px';
            else div.style.height = (DIV_HEIGHT-20-H_QUERY_L+H_ERROR)+'px';
        }
    }
    return false;
}

/* Molto xDocWay... */
function resumePanelState(state) {
    var div = document.getElementById(_DIV_ID_);
    if(null != div) div.style.display = state;
    div = document.getElementById(_DIV_ID_+"Footer");
    if(null != div) div.style.height = (DIV_HEIGHT-20-H_QUERY_L+H_ERROR)+'px';
}

function setHierSearchList(hierSearchList) {
    hierSearchList.value = currentSet;
    var idx = 0;
    for(;idx < unExploded.length; idx++) hierSearchList.value += "|"+unExploded[idx];
}

function preloader() {
    var imageObj = new Image();
    var images   = new Array();
    images[0]  = _IMG_PATH_+"menu_root.gif";
    images[1]  = _IMG_PATH_+"menu_bar.gif";
    images[2]  = _IMG_PATH_+"menu_spacer.gif";
    images[3]  = _IMG_PATH_+"menu_tee.gif";
    images[4]  = _IMG_PATH_+"menu_tee_minus.gif";
    images[5]  = _IMG_PATH_+"menu_tee_plus.gif";
    images[6]  = _IMG_PATH_+"menu_corner.gif";
    images[7]  = _IMG_PATH_+"menu_corner_plus.gif";
    images[8]  = _IMG_PATH_+"menu_corner_minus.gif";
    images[9]  = _IMG_PATH_+"menu_link_local.gif";
    images[10] = _IMG_PATH_+"menu_folder_open.gif";
    images[11] = _IMG_PATH_+"menu_folder_closed.gif";
    var idx = 0;
    for(; idx < images.length; idx++) imageObj.src = images[idx];
}

function trim(str) {
    str = str.replace(/^\s+/g, '');
    str = str.replace(/\s+$/g, '');
    str = str.replace(/\n/g, ' ');
    str = str.replace(/\s+/g, ' ');
    return str;
}

function cleanTextArea(id) {
    var tArea = document.getElementById(id);
    tArea.value = '';
    return false;
}

function sendQueryLanguage(id) {
    var retValue = false;
    var tArea   = document.getElementById(id);
    var query   = ( (typeof(tArea) != 'undefined') ? trim(tArea.value) : '');
    var hxpForm = eval(_HXP_FORM_);
    if( (typeof(hxpForm) != 'undefined') && hxpForm != null &&
        (query != '') && 
        ( (typeof(makeBaseQuery) == 'undefined' ) || 
           makeBaseQuery()) ) {
        hxpForm.query.value = query;
        hxpForm.xverb.value = "";
        if( ('' == hxpForm.selid.value) && 
            ('undefined' != typeof(currentSet)) ) hxpForm.selid.value = currentSet;
        // Se risulta impostato il nome del DB si richiede query su intero archivio (selid = '')
        if( hxpForm.db.value == hxpForm.selid.value ) hxpForm.selid.value = '';
        if( typeof(setExtensionsAndOrd) != 'undefined' ) setExtensionsAndOrd();
     	if( typeof(sendQuery) != 'undefined' ) {
     	    if( typeof(OpenWaitMsg) != 'undefined' ) OpenWaitMsg();
     	    retValue = sendQuery('queryplain');
     	}
    }
    //alert(">"+query+"<");
    return retValue;
}


