/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
// codice javascript per la gestione dei div nascosti della storia.

/* 
 * Created on: 28/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per la chiusura del div nascosto per la visualizzazione dell'intervento effettuato.
 */
function CloseModDiv(startElem)
{
	if ( typeof(startElem) == 'undefined' ) {
			return;
	}
	
	var el = startElem.parentNode.parentNode;
    var mx = 6;
    
    // RW 0034461
    // Non  sufficiente tornare in su di due ... ci sono i TD e i TR di mezzo
    // Cerco in su di almeno 6 livelli un div element
    
    while ((mx > 0) && (el.tagName != "DIV")) {
        mx--;
        el = el.parentNode;
    }

    // RW 0034461
    // Si potrebbe aggiungere un controllo se el.tagName == "DIV"

    if ( el != null ) {
		el.style.display = "none";
	}
}

/* 
 * Created on: 28/08/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione per l'apertura del div nascosto per la visualizzazione dell'intervento effettuato.
 * 				Se il browser  IE, il div viene mostrato a partire dalla posizione corrente
 * 				del mouse (a destra); se, invece, il browser  diverso da IE, il div viene
 * 				mostrato al centro della pagina (circa...).
 */
function OpenModDiv(startElem)
{
    var win_ie = false;
    var el;

    if ( typeof(startElem) == 'undefined' )
		return;
    
    if ( navigator.userAgent.indexOf('MSIE') >= 0 )
        win_ie = true; 

    if ( win_ie )
        el = startElem.parentNode.childNodes.item(1)
    else
        el = startElem.nextSibling.nextSibling;

	if ( el != null  )
    {
		if ( win_ie )
        {
			// browser IE (occorre tenere conto anche dello scrolling!)
			el.style.left = event.clientX + document.body.scrollLeft;
			el.style.top = event.clientY + document.body.scrollTop;
		}
		else
        {
			// altri browser
			el.style.left = screen.availWidth / 3 + document.body.scrollLeft;
			el.style.top = screen.availHeight / 3 + document.body.scrollTop;
		}
		
		el.style.display = "block";
	}
	return;  
}
