/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
//****************************** //
//inputChkBoxOnOff.js            //
//****************************** //
 
/* 
 * Created on: 23/06/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione valorizza tutti gli input hidden inseriti dal building block 
 *              "inputCheckboxSetValueOnOff" che hanno value vuoto a seconda dello stato del
 *              checkbox associato.
 */
 function chkBoxOnOffSetEmptyValues(){
    var elements = document.getElementsByTagName("input");
    var onclickStr;
    var argsStr;
    var start, end;
    var args;
    
    for (var i = 0; i < elements.length; i++ ) {
        if (elements[i].type == "checkbox" && 
                typeof(elements[i].onclick) != 'undefined' && 
                elements[i].onclick != null) {
            
            onclickStr = new String(elements[i].onclick);
            
            if ((start = onclickStr.indexOf("setChkboxValue(this, ")) != -1) {
                // input hidden associato a 'chkbox'
                var inputHidden = getChkBoxInputHidden(elements[i]);
                
                if (inputHidden != null && 
                        typeof(inputHidden.value) != 'undefined' && 
                        inputHidden.value.length == 0) {
                    // l'input hidden  vuoto --> lo valorizzo a seconda dello stato del checkbox associato
                    end = onclickStr.indexOf(")", start);
                    argsStr = onclickStr.substring(start + 21, end);
                    args = argsStr.split(",");
                    
                    // argomenti della chiamata js nell'onclick del checkbox
                    args[0] = trim_str(args[0]);
                    args[0] = args[0].substring(1, args[0].length - 1);
                    args[1] = trim_str(args[1]);
                    args[1] = args[1].substring(1, args[1].length - 1);
                    
                    if (elements[i].checked) {
                        inputHidden.value = args[0];
                    }
                    else {
                        inputHidden.value = args[1];
                    }
                }
            }
        }
    }
 }
 
 /* 
  * Created on: 23/06/2005
  * by: Federico Grillini
  * organization: 3D Informatica
  * description: Questa funzione recupera l'input hidden associato al checkbox inserito dal building block 
  *              "inputCheckboxSetValueOnOff".
  *              Qualora l'input hidden non venga trovato, viene restituito null.
  */
 function getChkBoxInputHidden(chkbox)
 {
     // input hidden associato a 'chkbox'
     var inputHidden = null;
     
     if (typeof(chkbox.parentNode) != 'undefined') {
        var inputSons = chkbox.parentNode.getElementsByTagName("input");
        
        for (var j = 0; j < inputSons.length; j++) {
            if (inputSons[j].type == "hidden") {
                inputHidden = inputSons[j];
                break;
            }
        }
     }
     
     return inputHidden;
 }

/* 
 * Created on: 03/05/2005
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Questa funzione salva i valori 'checkedVal' e 'notCheckedVal' nell'input hidden associato al
 * 				checkbox 'chkbox', quando, rispettivamente il checkbox viene selezionato e deselezionato.
 * 				Questa funzione viene utilizzata dal building block generico "inputCheckboxSetValueOnOff", a
 * 				cui si rimanda per maggiori informazioni sulla struttura dell'html a cui si fa riferimento.
 */
function setChkboxValue(chkbox, checkedVal, notCheckedVal)
{
    // input hidden associato a 'chkbox'
    var inputHidden = getChkBoxInputHidden(chkbox);
    
    if (inputHidden != null) {
        if (chkbox.checked) {
            inputHidden.value = checkedVal;
        }
        else {
            inputHidden.value = notCheckedVal;
        }
    }
    
    return false;
}
