/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
function chkLength(theInput, confronto)
{
	var ret = false;
	var confrontoArr = confronto.split(' ');
	var operatore = confrontoArr[0];
	var _length = parseInt(confrontoArr[1]);
		
	switch (operatore){
		case 'l': if ( theInput.value.length < _length ) ret = true;
			else isNumericMSG(notLessLen, _length -1);
			break;
		case 'g': if ( theInput.value.length > _length ) ret = true;
			else isNumericMSG(notLesslLen, _length + 1);
			break;
		case 'e': if ( theInput.value.length == _length ) ret = true;
			else isNumericMSG(notEqualLen, _length);
			break;		
		case 'le': if ( theInput.value.length <= _length ) ret = true;		
			else isNumericMSG(notGreatLen, _length);
			break;
		case 'ge': if ( theInput.value.length >= _length ) ret = true;
			else isNumericMSG(notGreatLen, _length);		
			break;
		case 'ne': if ( theInput.value.length != _length ) ret = true;
			else isNumericMSG(notDiffLen, _length);		
			break;		
	}
	
	return ret;
}

function IsNumeric(FieldToCheck, Mandatory, verbose, sepToIgnore)
{
 var Decimali = 9999;
 var DecimaliEsatti = false;

	if ( typeof(MAX_DECIMALI) != 'undefined' )  {
		if ( MAX_DECIMALI < 0 )  {
			Decimali = -MAX_DECIMALI;
			DecimaliEsatti = true;
		}
		else
			Decimali = MAX_DECIMALI;
	}
	if ( Mandatory && IsEmptyField(FieldToCheck) )  {
		return false;
	}
	var value = trim(FieldToCheck.value);
	if ( !value.length )
		return true;

    if (typeof(sepToIgnore)!='undefined')
        value = replaceAll(value,sepToIgnore,""); 

	var chr;
   var Virgola = false;
	if ( value != FieldToCheck.value )
		FieldToCheck.value = value;
	for ( var i = 0; i < value.length; ++i )  {
		chr = value.charAt(i);
		if ( chr == "-" || chr == "+" )  {
			if ( i != 0 )  {
				if ( verbose == true ) isNumericMSG(signBadPosition);
				FieldToCheck.focus();
				return false;
			}
		}
		else if ( chr == "," )  {
			if ( Virgola )  {
				if ( verbose == true ) isNumericMSG(errNumericAttr);
				FieldToCheck.focus();
				return false;
			}
			else if ( Decimali <= 0 )  {
				if ( verbose == true ) isNumericMSG(errDecimals);
				FieldToCheck.focus();
				return false;
			}
			else
				Virgola = true;
		}
		else if ( chr < "0" || chr > "9" )  {
			if ( verbose == true ) isNumericMSG(errNumericAttr);
			FieldToCheck.focus();
			return false;
		}
		else if ( Virgola )  {
			--Decimali;
			if ( Decimali < 0 )  {
				if ( verbose == true ) isNumericMSG(errDecimals);
				FieldToCheck.focus();
				return false;
			}
		}
	}
	if ( DecimaliEsatti )  {
	   if ( Decimali == -MAX_DECIMALI )  {
   		if ( !Virgola )
   			FieldToCheck.value += ',';
	   	for ( ; Decimali > 0; --Decimali )  {
	   		FieldToCheck.value += '0';
	   	}
	   }
	   else if ( Decimali )  {
			if ( verbose == true ) isNumericMSG(errDecimalsMAX_DECIMALI, -MAX_DECIMALI);
			FieldToCheck.focus();
			return false;
		}
	}
	return true;
}

/*
 * Script aggiunto da mbussetti il 24/12/2004, e ottenuto modificando leggermente il sorgente proveniente dalla pagina
 * http://www.jsdir.com/staffscripts/script083.asp
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Non esiste una sezione personalizzabile vera e propria...
 *
 * L'unica cosa che si pu fare  cambiare l'ultimo valore dell'Array n10b che  uguale a "cento" con "cent"
 * nel caso si voglia ad esempio che il valore 180 venga convertito in "centottanta" anzich "centoottanta" (valori come 101 continueranno ad essere convertiti correttamente: "centouno")
 *
 * Tutto il resto non v ASSOLUTAMENTE CAMBIATO di una virgola!!!
 *
 *
 * Ultimo aggiornamento: 12 - Aprile - 2003
 *
 * Questo script e' (C)2003 gianni2000@tin.it - Lo script e' reperibile al sito http://www.jsdir.com - JavaScript Directory
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

function digit3(num)
{
    var n0_19=new Array("","uno","due","tre","quattro","cinque","sei","sette","otto","nove","dieci","undici","dodici","tredici","quattordici","quindici","sedici","diciassette","diciotto","diciannove");
    var n10a=new Array("","","venti","trenta","quaranta","cinquanta","sessanta","settanta","ottanta","novanta","cento"),n10b=new Array("","","vent","trent","quarant","cinquant","sessant","settant","ottant","novant","cento");
    var str="";
    if(num.charAt(0)!='0')
        str+=((num.charAt(0)!='1')?n0_19[num.charAt(0)]:"")+((num.charAt(1)=='8')?n10b[10]:n10a[10]);
    if(num.charAt(1)>'1')
        str+=((num.charAt(2)=='1' || num.charAt(2)=='8')?n10b[num.charAt(1)]:n10a[num.charAt(1)])+n0_19[num.charAt(2)];
    else
        str+=n0_19[parseInt(num.substring(1,3),10)];
    return str;
}
function digitation(num,lower,decimalSeparator)
{
    var pto1=new Array("","uno","mille","unmilione","unmiliardo","mille","unmilione"),pto2=new Array("","","mila","milioni","miliardi","mila","milioni");
    var pto3=new Array("","undecimo","uncentesimo","unmillesimo"),pto4=new Array("","decimi","centesimi","millesimi");
    if(isNaN(num) && decimalSeparator == '.')
      return null;
    num=String(num);
    for(var i=0;num.charAt(i)=='0';++i)
        ;
    var pt=num.lastIndexOf(decimalSeparator),num1=num.substring((i==pt)?(i-1):i,(pt<0)?num.length:pt);
    num1="000".substring((num1.length%3)?num1.length%3:3)+num1;
    if(!parseInt(num1,10) && pt<0)
        return (lower)?"zero":"Zero";
    var str1="",str2="",j=num1.length/3;
    if(j>6)
        return null;
    for(i=0;j;--j,i+=3){
        if(parseInt(num1.substring(i,i+3),10)==1)
            str1+=pto1[j];
        else if(!parseInt(num1.substring(i,i+3),10) && j==4)
            str1+=((!parseInt(num1.substring(i-3,i+3),10))?"di":"")+pto2[j];
        else{
            str1+=digit3(num1.substring(i,i+3));
            if(parseInt(num1.substring(i,i+3),10))
                str1+=pto2[j];
        }
    }
    if(pt>-1){
        var num2=num.substring(pt+1,pt+4);
        if(parseInt(num2,10)>0)
            //str2=((str1)?" e ":"")+((parseInt(num2,10)>1)?(digit3("000".substring((num2.length%3)?num2.length%3:3)+num2)+pto4[num2.length]):pto3[num2.length]);
            str2=((str1)?"/":"")+num2;
        else if(!str1)
            str2="zero";
        if(!str1)
            str2=(lower)?str2:(str2.charAt(0).toUpperCase()+str2.substring(1));
    }
    return ((lower)?str1:(str1.charAt(0).toUpperCase()+str1.substring(1)))+str2;
}
