/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* keylist.js */

 var separator = '}{';
 var lastClickedIndex = -1; // memorizza l'indice dell'ultimo checkbox selezionato per operazioni di selezione multipla
 /**
  * aggiorna il dato della form che esprime la selezione aggiungendo o togliendo il primo parametro
  * in funzione del secondo
  */
 function updateSele(theKey,isChecked)
 {var theSele=getForm('hxpForm').keylist.value;
  var pos=theSele.indexOf(theKey);
  if(isChecked){if(pos<0)theSele+=theKey;}
  else if(pos>=0)theSele=theSele.substring(0,pos)+theSele.substring(pos+theKey.length,theSele.length);
  getForm('hxpForm').keylist.value = theSele;
 }
 /**
  * percorre gli elementi della form contenente la lista dei termini selezionabili alla ricerca di
  * eventuali duplicati da de/selezionare a seguito del cambiamento di stato di uno di essi
  */
 function updateList(theForm,theValue,isChecked)
 {for(var index=0;index<theForm.elements.length;index++)
   if(theForm.elements[index].type=='checkbox'&&
      theForm.elements[index].value==theValue)
    theForm.elements[index].checked=isChecked;
 }
 /**
  * cerca nell'array elements il parametro e ne torna l'indice (base 0)
  */
 function findCheckBoxIndex(theInput)
 {for(var index=0;index<theInput.form.elements.length;index++)
   if(theInput.form.elements[index]==theInput)
    return index;
  return(-1);
 }
 /**
  * aggiorna la selezione a seguito di una variazione dello stato di un checkbox della lista
  * chiamata dallo handler onclick del checkbox associato a un elemento della lista
  */
 function checkSele(theCheck,theEvent)
 {var currentIndex=findCheckBoxIndex(theCheck);
  if(typeof(theEvent)=='undefined'||
     typeof(theEvent.shiftKey)=='undefined'||
     theEvent.shiftKey==false/*||
     theCheck.checked==false*/ || (lastClickedIndex==-1))
   lastClickedIndex=currentIndex;
  var firstIndex=lastClickedIndex<currentIndex?lastClickedIndex:currentIndex;
  var lastIndex=lastClickedIndex>currentIndex?lastClickedIndex:currentIndex;
  for(var index=firstIndex;index<=lastIndex;index++)
  {updateSele(separator+theCheck.form[index].value+separator,theCheck.checked);
   updateList(theCheck.form,theCheck.form[index].value,theCheck.checked);
  }
  lastClickedIndex=currentIndex;
 }

 // aggiorna i checkbox sulla base del contenuto della selezione
 function checkList(theForm,theSele)
 {for(var index=0;index<theForm.elements.length;index++)
   if(theForm.elements[index].type=='checkbox' && theSele.indexOf(separator+theForm.elements[index].value+separator)>=0){
    theForm.elements[index].checked = true;
   }
   else if(theForm.elements[index].type=='radio' && theSele==theForm.elements[index].value){
	 theForm.elements[index].checked = true;
   }
 }

function checkAllSele(theCheck, count)
{
    var theForm = theCheck.form;

    // per eventaule comando di selezione al di fuori della form
    if (theForm == null) theForm = getForm('theForm');

    var klAll = getForm('hxpForm').klAll;

    // Federico 12/07/07: introdotta una lista di nomi di checkbox che devono essere ignorati [RW 0045572]
    var skipList = new Array('custom_mainpage_global', 'ord_asc', 'agli_atti_chkbox');

    if (klAll.value == 'true') {
        klAll.value = 'false';

        for (var index=0; index < theForm.elements.length; index++) {
            if ((theForm.elements[index].type == 'checkbox') && !isPresent(skipList, theForm.elements[index].name)) {
                theForm.elements[index].checked = false;
            }
        }

        getForm('hxpForm').keylist.value = '';
    }
    else {
        klAll.value = 'true';
        var theSele = "";

        for (var index=0; index < theForm.elements.length; index++) {
            if ((theForm.elements[index].type == 'checkbox') && !isPresent(skipList, theForm.elements[index].name)) {
                theForm.elements[index].checked = true;
            }
        }

        for (var index=1; index <= count; index++) theSele += separator + index + separator;

        getForm('hxpForm').keylist.value = theSele;
    }
}

//<!-- Gregorio_Aggiunta -->
function writeKeylist(theValue) {
    getForm('hxpForm').keylist.value = theValue;
    // alert('theValue: ]' + theValue + '[');
    return '';
}

//<!-- Gregorio_Aggiunta -->
function generateKeylist(count) {
    var KeylistArray = new Array(1);
    KeylistArray[0] = '1';
    for (var i=1; i<count; i++) {
        KeylistArray[i] = i + 1 + '';
    }
    return separator + KeylistArray.join(separator+separator) + separator;
}

//<!-- Gregorio_Aggiunta -->
function reverseKeylist(keylist_to_reverse, totalcount) {
    if (keylist_to_reverse == '') {
        // Lista vuota --> seleziono tutti i documenti
        return generateKeylist(totalcount);
    }
    var CurrentKeylistArray = keylist_to_reverse.substr(separator.length, keylist_to_reverse.length-separator.length*2).split(separator+separator);
    if (CurrentKeylistArray.length == totalcount) {
        // Lista con tutti gli elementi selezionati --> svuoto la lista
        return '';
    }
    // Genero un array con un numero di elementi data dalla differenza tra
    var ReversedKeylistArray = new Array(totalcount - CurrentKeylistArray.length);
    var SkippedElementsNumber = 1;
    for (var i=0; i<ReversedKeylistArray.length; i++) {
        for (var z = SkippedElementsNumber; z < totalcount+1; z++) {
            if (keylist_to_reverse.indexOf(separator + z + separator) == -1) {
                SkippedElementsNumber = z + 1;
                break;
            }
        }
        ReversedKeylistArray[i] = SkippedElementsNumber - 1 + '';
    }
    return separator + ReversedKeylistArray.join(separator+separator) + separator;
}
