/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
// --------------------- Locked Text Input ---------------------
// Make a text box read only; clicking on it clears the contents
// before making it read/write again.

var locking_attribute_name = "backgroundColorBeforeLocking";
var locklist_attribute_name = "lockedInputElements";

function lock_textinput(textinput_element)
{
  if (textinput_element) with (textinput_element) {
    var background_color = getAttribute(locking_attribute_name);

    if (background_color == null)
      setAttribute(locking_attribute_name, style.backgroundColor);

    readOnly = true;
    onclick = unlock_handler;
    style.backgroundColor = "#e0e0e0";
    register_lock(textinput_element);
  }
}

function find_locked_textinput(locks, textinput_element)
{
  var count = 0;
  
  if (locks) {
    count = locks.length;
    
    for (var i = 0; i < count; ++i) {
      if (locks[i] == textinput_element)
	return i;
    }
  }

  return count;
}

function register_lock(textinput_element)
{
  if (textinput_element && textinput_element.form) {
    var locks = textinput_element.form.getAttribute(locklist_attribute_name);
    var count = 0;

    if (locks) {
      count = locks.length;

      if (find_locked_textinput(locks, textinput_element) < count)
        return;
    }
    else {
      locks = new Array();
      textinput_element.form.setAttribute(locklist_attribute_name, locks);
    }

    locks[count] = textinput_element;
  }
}

function unregister_lock(textinput_element)
{
  if (textinput_element && textinput_element.form) {
    var locks = textinput_element.form.getAttribute(locklist_attribute_name);
    var count = locks ? locks.length : 0;
    var i = find_locked_textinput(locks, textinput_element);

    if (i < count && count == 1) {
      textinput_element.form.removeAttribute(locklist_attribute_name); 
    }
    else if (i < count) {
      var lhs = locks.slice(0, i);
      var rhs = locks.slice(i + 1);
      locks = lhs.concat(rhs);
    }
  }
}

function unlock_textinput(textinput_element)
{
  if (textinput_element) with (textinput_element) {
    value = "";
    style.backgroundColor = getAttribute(locking_attribute_name);
    onclick = null;
    readOnly = false;
  }
}

function unlock_on_click(textinput_element)
{
  unlock_textinput(textinput_element);
  unregister_lock(textinput_element);
  
  if (textinput_element) {
    textinput_element.focus();

    if ("undefined" != typeof(Qbe_To_Ql))
      Qbe_To_Ql(textinput_element);
  }

  return false;
}

function unlock_handler()
{
  return unlock_on_click(event.srcElement);
}

function remove_all_locks(form_element)
{
  if (form_element) {
    var locks = form_element.getAttribute(locklist_attribute_name);
    var count = locks ? locks.length : 0;
    
    for (var i = 0; i < count; ++i) {
      unlock_textinput(locks[i]);
    }

    form_element.removeAttribute(locklist_attribute_name);
  }
}

