/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* lookup.js */

var fieldsArray = new Array;

var toSetFocus = true;
var l_operation = "";

var oneSkipPage = false;

function loadHandler()
{
    if (!oneSkipPage)
        startModalWindow();

    /* Federico 05/12/05: spostato il codice da 'var el = null;' in avanti dentro l'if seguente per evitare errori
     * js dovuti all'assenza di 'lookup' nella form 'theForm'.
     * Il problema era stato riscontrato in caso di lookup privo di risultati.
     */
    if (typeof(getForm('theForm').lookup) != 'undefined') {
    	setRadio(getForm('hxpForm').keylist.value);

        var el = null;
        for (var i = 0; i < getForm('theForm').lookup.length; i++) {
            if (getForm('theForm').lookup[i].checked) {
                el = getForm('theForm').lookup[i];
                break;
            }
        }

        if (el == null)
            el = getForm('theForm').lookup;

        // Federico 13/12/05: aggiunto test "typeof(el.onclick) != 'undefined'" per evitare errori js
        if (el != null && typeof(el.onclick) != 'undefined') {
            var fun = el.onclick.toString();
            var index = fun.indexOf('setFields') + 10;
            var args = fun.substring(index, fun.indexOf(';', index) - 1);
            setFields(replaceAll(args,"\"", ""));
        }
    }
    self.focus();//sperimentale - simone 11 Feb 2005

    // Federico 05/10/09: personalizzazione via property del link per creare una nuova struttura esterna (finestra del lookup) [EA 999]
    var lookupNewRecordStrutturaEsterna = document.getElementById("lookupNewRecordStrutturaEsterna");

    if (lookupNewRecordStrutturaEsterna != null) {
        var hxpS = new _hxpSession(getForm('hxpForm'));
        var link = hxpS.getParameter("lookupLinkNewRecordStrutturaEsterna");

        if (link != null && link.length > 0) {
            lookupNewRecordStrutturaEsterna.href    = link;
            lookupNewRecordStrutturaEsterna.onclick = "";
            lookupNewRecordStrutturaEsterna.target  = "_blank";
            hxpS.setParameter("lookupLinkNewRecordStrutturaEsterna", null);
        }
    }
}

function unloadHandler(){
    if (l_operation != "NOCLOSE")
        stopModalWindow();

	if ( toSetFocus == true && typeof(opener) != 'undefined')
		if ( opener.nodeToSetDefault != null && l_operation != "NOCLOSE" ) {
            /* Federico 13/12/05: introdotto try-catch per non mostrare errori js generati dalla chiamata a
             * 'focus()'. Tale chiamata generava un errore, per es., nella pagina di invio via email degli
             * allegati di un documento notificato in modo differito (RW 0032629), dove ho dirottato un lookup
             * su un input hidden, che, ovviamente, non pu avere il focus.
             */
            try {
                opener.nodeToSetDefault.focus();
            }
            catch (oException) {
            }
        }
}

function closeLookup()
{
    // Federico 08/10/09: ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
    cleanSAPLookupSessionData();

	if ( typeof(customCloseLookup) != 'undefined' )
		 customCloseLookup();

	self.close();
	return false;
}

function paginaPrecedente(posizioneAttuale,perPagina)
{
	l_operation = "NOCLOSE";
	if (posizioneAttuale > 0 ) {
		getForm('hxpForm').verbo.value = 'lookup_response';
		getForm('hxpForm').pos.value = (posizioneAttuale - perPagina < 0 ) ? 0 : posizioneAttuale - perPagina;
		sendRequest();
	}
	return false;
}

function paginaSuccessiva(posizioneAttuale,perPagina,totaleSelezionati)
{
	l_operation = "NOCLOSE";
	if ( totaleSelezionati > posizioneAttuale + perPagina ) {
		getForm('hxpForm').verbo.value = 'lookup_response';
		getForm('hxpForm').pos.value = posizioneAttuale + perPagina;
		sendRequest();
	}
	return false;
}


function primaPagina(posizioneAttuale)
{
		l_operation = "NOCLOSE";
	if ( posizioneAttuale > 0 ) {
		getForm('hxpForm').verbo.value = 'lookup_response';
		getForm('hxpForm').pos.value = 0;
		sendRequest();
	}
	return false;
}

function ultimaPagina(posizioneAttuale,perPagina,totaleSelezionati){
	l_operation = "NOCLOSE";
	if ( totaleSelezionati > posizioneAttuale + perPagina ) {
		getForm('hxpForm').verbo.value = 'lookup_response';
		getForm('hxpForm').pos.value = Math.floor((totaleSelezionati - 1) / perPagina) * perPagina;
		sendRequest();
	}
	return false;
}



function radioSele(theRadio, evento)
{
	getForm('hxpForm').keylist.value = theRadio.value;
}

function setRadio(radioValue)
{
	for ( var index = 0; index < getForm('theForm').lookup.length; index++ )
   	if ( getForm('theForm').lookup[index].value == radioValue )
			getForm('theForm').lookup[index].checked = true;
	fieldsArray = getForm('hxpForm').selected_campi.value.split("|");
 }

function sendRequest()
{
	getForm('hxpForm').selected_campi.value = "";
	for ( var i = 0 ; i < fieldsArray.length; i++ )
		getForm('hxpForm').selected_campi.value += fieldsArray[i] + "|";
	getForm('hxpForm').selected_campi.value.slice(0, -1);

	getForm('hxpForm').submit();
	return false;
}

function setFields()
{
    oneSkipPage = true;
	var params = arguments[0]; //#params variabile
	for ( var i = 0; i < arguments.length ;i++ )
		fieldsArray[i] = (arguments[i]);
}


function confirmLookup()
{
    OpenWaitMsg();

    // Federico 08/10/09: ripulitura degli eventuali dati di sessione dei lookup SAP [EA 999]
    cleanSAPLookupSessionData();

    if (typeof(customConfirmLookup) != 'undefined') {
        return customConfirmLookup();
    }

    var htmlField, xmlVal, v;

    for ( var i = 0 ; i < fieldsArray.length; i++ ) {
        v = fieldsArray[i].split("=");
        htmlField = v[0];
        xmlVal = v[1];

        if ( opener.dad == null ) { 	//no multistanza
            if ( htmlField != '') //non so il motivo ma se non si seleziona nulla htmlField contiene l'elelemto ''
                opener.getForm('hxpForm')[htmlField].value = xmlVal;
        }
        else { //multistanza
            /*for ( var j = 0; j < opener.dad.childNodes.length; j++ )
             if ( opener.dad.childNodes.item(j).name == htmlField )
             opener.dad.childNodes.item(j).value = xmlVal;*/
            //	var el = openerGetElementByName(htmlField, 'input');

            //simone - 15 set 2004
            elFound = null;
            visitaTree(opener.dad, htmlField);
            var el = elFound;

            //alert("Aggiorno " + el.name + " con xmlVal=" + xmlVal);

            if ( el != null )
                el.value = xmlVal;
        }
        if ( opener.nodeToSetDefault != null ){ //vedi onblurLookup
            opener.nodeToSetDefault.defaultValue = opener.nodeToSetDefault.value;
        }
    }

    toSetFocus = false;

    /* Federico 03/02/2005: mancava la chiusura della finestra (pressione "Assegna/Torna") quando
     * fieldsArray  vuoto ==> self.close()  stato spostato fuori dal for.
     */
    self.close();

    return false;
}

var elFound;

function visitaTree(el, name)
{
    if ( elFound != null )
        return;

    if ( el.name == name )
        elFound = el;

    var l = el.childNodes;
    for (var i = 0; i < l.length; i++)
        visitaTree(l.item(i), name, elFound);
}

function newRecord(params)
{
    params_v = params.split(';');
    var uri = params_v[0];
    var dbTable = params_v[1].substring(params_v[1].indexOf('=') + 1);
    var fillField = params_v[2].substring(params_v[2].indexOf('=') + 1);

    // Federico 05/10/09: per non avere problemi di comparsa/scomparsa del pulsante per creare una nuova strutt. esterna nella
    // finestra del lookup,  bene non modificare direttamente la tupla 'lookup_new' [EA 999]
    var lookup_new = params;

    var r = Math.round(Math.random()*1000);

    //caso base (stesso db e stessa applicazione)
    var t_uri = getForm('hxpForm').uri.value + "?db=" + getForm('hxpForm').db.value;

    /* INIZIO ELABORAZIONE URL */
    //specificato uri di jsp (N.B - senza primo livello di path, ovvero senza xway)
    if ( uri.length > 0 ) {
        t_uri = getForm('hxpForm').uri.value.substring(0, getForm('hxpForm').uri.value.indexOf("/", 1) ) + uri;

        //occorre cambiare url se uri corrente  jsp e proiezione specifica hc.dll (e viceversa)
        var curr_uri = getForm('hxpForm').uri.value;
        var togoLastPart = t_uri.substring(t_uri.lastIndexOf("/") + 1, t_uri.lastIndexOf("?"));
        var iamLastPart = curr_uri.substring(curr_uri.lastIndexOf("/") + 1);
        if ( iamLastPart.indexOf(".dll") != -1 )
            t_uri = t_uri.replace(togoLastPart, iamLastPart);
    }

    //se db acl -> seleziono quello corrretto (multi acl)
    if (t_uri.indexOf('db=acl') != -1 && t_uri.indexOf('db=acl-') == -1 && getForm('hxpForm').aclDb.value != '')
        t_uri = t_uri.replace('db=acl','db=' + getForm('hxpForm').aclDb.value);

    var url = buildUrlForGet(t_uri, true, true, true) + '&verbo=docEdit&dbTable=@' + dbTable + '&lookup_new=' +
              realEscape(lookup_new) + '&lookup_fieldVal=' + realEscape(getForm('hxpForm').lookup_fieldVal.value);

    if (typeof(customNewRecordAddUrl) != 'undefined')
        url += customNewRecordAddUrl();

    /*  FINE ELABORAZIONE URL */

    //var newLookupRecord = window.open(url, 'new_record' + r, "width=800,height=600,scrollbars=yes");

    //sstagni -> aggiunti nel passaggio get->post
    url += '&selid=&pos='
    var hxpForm = getForm('hxpForm');
    var oldTarget = hxpForm.target;
    hxpForm.target = 'new_record' + r;
    var oldTuples = setFormTuplesFromURL(url, hxpForm);
    var newLookupRecord = window.open(staticEmptyWindow, hxpForm.target, "width=800,height=600,scrollbars=yes");
    hxpForm.submit();
    newLookupRecord.focus();
    setFormTuplesFromURL(oldTuples, hxpForm);//restore delle tuple precedenti
    hxpForm.target = oldTarget;

    return false;
}

function getHost()
{
/* DD 19/12/2005 - RW: 0031529
    var host = window.location.host;
    if ( host.indexOf(':') != -1 )
        host = host.substring(0, host.indexOf(':'));
    return host;
*/
    return window.location.hostname;
}


function reDoLookupAfterInsert(physDoc, win)
{
	getForm('hxpForm').verbo.value = "lookup_response";
	getForm('hxpForm').selid.value = "";
	getForm('hxpForm').lookup_fieldVal.value = "_PHYSDOC=" + physDoc;
	getForm('hxpForm').submit();
	win.close();
	return false;
}

function openerGetElementByName(name,tagName)
{
	if ("undefined" == typeof(tagName)) tagName = "input";
	var elements = opener.document.getElementsByTagName(tagName);

	for (var i = 0; i < elements.length; i++ )
		if ( elements[i].name == name ) {
			return elements[i];
		}
	return null;
}

function modifyTableDoc(codRep,descrRep){
   //setGlobalFormRestore('verbo','xverb','codice_rep','descrizione_rep','dbTable');

	getForm("hxpForm").verbo.value = "docEdit";
	getForm("hxpForm").xverb.value = "@modify";
	//getForm("hxpForm").dbTable.value = ... gia' impostato
	if ( 'undefined' != typeof(codRep) ) getForm("hxpForm").codice_rep.value = codRep;
	if ( 'undefined' != typeof(descrRep) ) getForm("hxpForm").descrizione_rep.value = descrRep;

	/*
     * modifica di Federico del 16/08/2004: spostata l'apertura forzata di una sezione di un doc. di XSpring in una
     * funzione custom.
     */
	if ( typeof(customModifyTableDoc) != 'undefined' ) {
		customModifyTableDoc();
		return false;
	}

	getForm("hxpForm").submit();

	return false;
}
