/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
// evita click multipli sul pulsante della stampa degli allegati dei doc. di una selezione [RW 0043253]
var printDocsAttachIsBusy = false;

// Federico 29/03/07: errori segnalati da 'iwPrintfile' quando i suoi alert sono disabilitati [RW 0043253]
var iwPrintfileErrors = "";

// Federico 29/03/07: estensioni usate da 'iwPrintfile' per identificare le immagini [RW 0043253]
var imgsExt = "bmp|gif|ico|jpg|jpeg|jpe|pcx|png|tga|tif|tiff";

// indica il tempo di sleep tra una stampa e l'altra (si veda 'scanAttachmentsArray') [RW 0043253]
var setIntervalTimeOut = 4000;

// variabili usate da 'scanAttachmentsArray'
var attachments, currentAttachment, timerID, tipo, data_prot, num_prot;

/*
 * Created on: ?
 * by: ss
 * organization: 3D Informatica
 * description: Funzione che stampa un allegato di un documento mediante IW. La stampa dell'allegato viene preceduta
 *              da una testata (informazioni sul documento e nome dell'allegato).
 *
 * Federico 29/03/07: function spostata da 'document.js' di docway [RW 0043253].
 *                    Aggiunti parametri:
 *
 *                    disableErrorAlerts: comporta il salvataggio dei msg di errore nel buffer
 *                                        'iwPrintfileErrors' invece di mostrali all'utente.
 *                    useIWPrintForImgs:  forza l'uso del metodo 'PrintWithText' di IW per la
 *                                        stampa delle immagini. In questo caso la testata compare
 *                                        sul bordo sinistro della pagina che contiene l'immagine.
 *                    msgIWPrintForImgs:  testata da usare per le immagini quando si usa 'PrintWithText'
 *                                        di IW.
 */
function iwPrintfile(id1, title, tipo, data, numero, disableErrorAlerts, useIWPrintForImgs, msgIWPrintForImgs) {
    if (disableErrorAlerts == null || typeof(disableErrorAlerts) == 'undefined') {
        disableErrorAlerts = false;
    }

    if (disableErrorAlerts) iwPrintfileErrors = "";

    if (useIWPrintForImgs == null || typeof(useIWPrintForImgs) == 'undefined') {
        useIWPrintForImgs = false;
    }

    var theIW = document.IW;
    var firmato = id1.substring(id1.lastIndexOf(".")) == ('.p7m' || '.p7k')? true : false;

    var ext = '@.' + id1.substring(id1.indexOf(".") + 1) + '@';
    id = realEscape(id1);
    var url = buildUrlForGet("", false, false, true) + "&verbo=attach&id=" + id;

    var mode = theIW.downloadNoLoad;
    if (ext == '@.ziw@')  {
        // Paolo: 06/04/2006: per gestire il caso di file .ziw per i quali non so se sia presente la firma
        firmato = true;
        mode += theIW.downloadInflate;
    }
    else {
        mode += theIW.downloadSetExt;
        while ( ext.indexOf(".p7m@") == ext.length - 5 || ext.indexOf(".p7k@") == ext.length - 5 ) {
            ext = ext.substring(0, ext.lastIndexOf(".")) + "@";
        }
    }

    while ( title.indexOf(".p7m") == title.length - 4 || title.indexOf(".p7k") == title.length - 4 ) {
        title = title.substring(0, title.lastIndexOf("."));
    }

    // download del file
    if (theIW.DownloadParam(url, ext, mode)) {
        if (!disableErrorAlerts) alert ("Si  verificato un errore nel download del file '" + title + "'");
        else                     iwPrintfileErrors += "Si  verificato un errore nel download del file '" + title + "'\n";

        return false;
    }
    else if (document.all) {
        DoneWithDownload(null, null, null);
    }

    // preparazione pagina iniziale
    var useIWShellFile = true;
    var fileForPrint = 'null';
    var rotationForPrint = 0;
    var textX = "(pagesizex-textsizex)/2";
    var textY = "400";

    if (useIWPrintForImgs) {
        var realExt = id1.substring(id1.lastIndexOf(".") + 1).toLowerCase();

        if (imgsExt.indexOf(realExt) != -1) useIWShellFile = false;

        if (!useIWShellFile) {
            fileForPrint = theIW.GetLastFileName();
            rotationForPrint = 90 * 10;
            textX = "0";
            textY = "pagesizey";
        }
    }

    var ps = theIW.ReadPrintSettings();
    ps &= ~theIW.printSettingsPageScale;
    ps |= theIW.printSettingsPageAuto;
    theIW.WritePrintSettings(ps, "");

    var sTit;

    if (!useIWShellFile && msgIWPrintForImgs != null && typeof(msgIWPrintForImgs) != 'undefined') {
        sTit = msgIWPrintForImgs;
    }
    else {
        // se bisogna usare 'ShellFile' o se non e' stata indicata una testata per le immagini
        sTit = '<iwfont height="-10" weight="800" facename="Courier New">';

        if (useIWShellFile) {
            sTit += '__________________________________________\n \n';
            sTit += ' T E S T A T A   D I   D O C U M E N T O\n';
            sTit += '__________________________________________\n \n';
        }

        sTit += '<iwfont height="-10" weight="400" facename="Arial">';

        if (tipo == 'varie') {
            sTit += "Documento non protocollato";
        }
        else if (numero.length > 0){
            sTit += "Protocollo n. ";
            sTit += numero;
        }

        if (data.length > 0) {
            sTit += " del  ";
            sTit += data;
        }

        if (useIWShellFile) {
            sTit += '<iwfont height="-10" weight="800" facename="Courier New">\n';
            sTit += '__________________________________________\n';
            sTit += '<iwfont height="-10" weight="400" facename="Arial">';
            sTit += "\n \n " + title;
        }
        else {
            sTit += " - " + title;
        }

        if (useIWShellFile && firmato) {
            var s1 = mostraFirma(false, id1, false);

            if (s1 != false)  {
                sTit += '<iwfont height="-10" weight="800" facename="Courier New">\n';
                sTit += '__________________________________________\n \n';
                sTit += '<iwfont height="-10" weight="400" facename="Arial">';
                sTit += s1
                sTit += '<iwfont height="-10" weight="800" facename="Courier New">\n';
                sTit += '__________________________________________';
            }
        }
    }

    // stampa testata - file
    var retval = theIW.PrintWithText(fileForPrint, -10, 0,
                                     rotationForPrint, // Rotazione
                                     300, 0, 0, 0, 0, 0, 0, 0, 0, 0,
                                     "Arial",
                                     0, //Opaco
                                     0, 0, 0, //RGB
                                     textX,
                                     textY,
                                     sTit);

    if (useIWShellFile) retval = theIW.ShellFile(theIW.GetLastFileName(), "print", 7);

    if ((useIWShellFile && retval != 1) || (!useIWShellFile && retval != 0)) {
        if (!disableErrorAlerts) alert("Errore nella stampa di '" + theIW.GetLastFileName() + "' (" + retval + ")");
        else                     iwPrintfileErrors += "Errore nella stampa di '" + theIW.GetLastFileName() +
                                                      "' (" + retval + ")\n";
    }
}

/*
 * Created on: 29/03/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Funzione che avvia la stampa gli allegati dei documenti di una selezione [RW 0043253].
 *              Se viene passata una query come parametro, vengono stampati gli allegati
 *              dei documenti della selezione prodotta dalla query.
 */
function printDocsAttachments(verbo, query)
{
    if (isAjaxCompliant()) {
        if (typeof(document.IW) != 'undefined' && document.IW != null) {
            raccogli(getForm('hxpForm').selid.value, false);
    
		    var tot = getForm('hxpForm').count.value;
		    var kl = getForm('hxpForm').klRac.value;
		    if (kl.length > 0) {
		        tot = contaDocumentiRaccolti(kl);
		    }
		    var f = tot == 1? "o" : "i";
		    if (!confirm("Avviare la stampa degli allegati di " + tot + " document" + f + "?")) {
		        return false;
		    }    
            else {
                if (verbo == null || typeof(verbo) == 'undefined' || verbo == "") {
                    verbo = "get_docs_attach";
                }

                var form = getForm("hxpForm");
                var selid = "";

                if (query == null || typeof(query) == 'undefined' || query == "") {
                    query = "";
                    selid = form.selid.value;
                }

                var customClassFormatMsgForImgsPrint = "";

                if (typeof(getCustomClassFormatMsgForImgsPrint) != 'undefined') {
                    customClassFormatMsgForImgsPrint = getCustomClassFormatMsgForImgsPrint();
                }

                var params = buildUrlForGet("", true, true, true, true) +
                             "&selid=" + selid + "&verbo=" + verbo +
                             "&query=" + query + "&keylist=" + form.keylist.value +
                             "&customClassForAdditionalInfo=" + customClassFormatMsgForImgsPrint +
                             "&transformJava=ajax&enableIW=true";

                if (!printDocsAttachIsBusy) {
                    printDocsAttachIsBusy = true;
                    jsXML.sendAsyncPost(form.uri.value, params, handlePrintDocsAttach, errorHandlerPrintDocsAttach, null);
                }
            }
        }
        else {
            // oggetto IW non trovato
            alert("Oggetto IW non trovato!");
        }
    }
    else {
        // browser non compatibile con Ajax
        alert("Browser non compatibile con Ajax!");
    }

    return false;
}

/*
 * Created on: 29/03/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Funzione che stampa con IW gli allegati restituiti dalla classe generica "get_docs_attach" [RW 0043253].
 */
function handlePrintDocsAttach(text, requester)
{
    // debug
    /*alert(replaceAll(text,'\n',' '));
    printDocsAttachIsBusy = false;
    return false;*/

    var xml = jsXML.parseXMLDocument(text);

    var errorElem = xml.selectSingleNode("/response/errore");

    if (errorElem != null && typeof(errorElem) != 'undefined') {
        // messaggio di errore
        var messaggio = errorElem.selectSingleNode("./errtype").text;
        var extra     = errorElem.selectSingleNode("./extra").text;

        alert(messaggio + ((extra != "") ? "\n\n(" + extra + ")" : ""));
    }
    else {
        // stampa degli allegati trovati
        attachments = xml.selectNodes("//attachment");

        if (attachments.length > 0) {
            currentAttachment = 0;
            timerID = null;
            scanAttachmentsArray();
        }
        else {
            alert("Nessun allegato da stampare");
        }
    }

    printDocsAttachIsBusy = false;
}

/*
 * Created on: 29/03/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Funzione che gestisce gli errori ottenuti nel recupero degli allegati dei documenti
 *              di una selezione [RW 0043253].
 */
function errorHandlerPrintDocsAttach(message)
{
    alert("Si e' verificato un errore: " + message);
    printDocsAttachIsBusy = false;
}

/*
 * Created on: 30/03/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Funzione che effettua la scansione dell'array 'attachments' degli allegati da stampare con IW
 *              e avvia la stampa di ogni allegato [RW 0043253].
 */
function scanAttachmentsArray()
{
    var attachElement = attachments[currentAttachment];
    var attachElementParentNode = attachElement.parentNode;

    tipo = attachElementParentNode.getAttribute("tipo");
    data_prot = attachElementParentNode.getAttribute("data_prot");
    num_prot = attachElementParentNode.getAttribute("num_prot");

    var text4Imgs = decodeBase64(attachElementParentNode.selectSingleNode("./infoForImgsPrint").text);
    text4Imgs = text4Imgs.replace("<PAG>", "1");

    iwPrintfile(attachElement.getAttribute("name"),
                attachElement.getAttribute("title"),
                tipo,
                data_prot,
                num_prot,
                true,
                true,
                text4Imgs);

    currentAttachment++;

    if (currentAttachment == attachments.length) {
        if (timerID != null) clearInterval(timerID);

        printDocsAttachmentsFinalStatus();
    }
    else if (timerID == null) {
        // per la stampa si usa 'setInterval' per introdurre uno sleep tra una stampa e l'altra.
        // Lo scopo e' evitare che le testate degli allegati si mescolino tra loro.
        timerID = setInterval('scanAttachmentsArray()', setIntervalTimeOut);
    }
}

/*
 * Created on: 30/03/2007
 * by: fgr
 * organization: 3D Informatica
 * description: Funzione che mostra all'utente l'esito della stampa degli allegati con IW [RW 0043253].
 *              Viene invocata da 'scanAttachmentsArray' al termine della stampa.
 */
function printDocsAttachmentsFinalStatus()
{
    if (iwPrintfileErrors.length > 0) alert("Si sono verificati degli errori in fase di stampa!\n\n" +
                                            iwPrintfileErrors);
    else                              alert("Stampa eseguita correttamente.");
}
