/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* print-profiles.js
  *
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzioni per la gestione della pagina dei profili di stampa.
  */

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata all'apertura della pagina. Se esiste, viene invocata una funzione custom;
  * 			 vengono, poi, impostati l'eventuale template selezionato di default e il verbo selezionato mediante
  * 			 i radio button che indicano cosa stampare.
  */
 function loadHandler()
 {
  	if(typeof(customLoadHandler) != 'undefined')
   		customLoadHandler();

	// occorre impostare l'eventuale template selezionato di default
	var radioButtons = document.getElementsByName("profile");

	for (var i = 0; i < radioButtons.length; i++){
		if (radioButtons[i].checked) {
			setTemplate(radioButtons[i]);
			break;
		}
	}

	// occorre impostare il verbo selezionato mediante i radio button che indicano cosa stampare
	radioButtons = document.getElementsByName("typeSelection");

	for (var i = 0; i < radioButtons.length; i++){
		if (radioButtons[i].checked) {
			setVerbo(radioButtons[i]);
			break;
		}
	}
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata alla chiusura della pagina.
  */
 function unloadHandler()
 {
	/* Modifica di Federico del 30/09/2004: La chiamata alla 'CloseWaitMsg()'  necessaria con Opera e Mozilla
	 * per evitare che il div di attesa rimanga visibile dopo aver premuto il pulsante indietro nella pagina di
	 * errore visualizzata dopo una ricerca fallita.
	 */
	if (typeof(CloseWaitMsg) != 'undefined') {
		CloseWaitMsg();
    }
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata per tornare alla pagina di ricerca.
  */
 function queryPage()
 {
	getForm('hxpForm').verbo.value = 'query';
	getForm('hxpForm').dbTable.value = '';
	getForm('hxpForm').query.value = '';
	getForm('hxpForm').selid.value = '';
	getForm('hxpForm').submit();

	return false;
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata per tornare alla pagina dei titoli.
  * 			 "posizioneAttuale"  un indice in base zero e indica quale documento mettere in cima alla lista.
  * 			 "titoliPerPagina" indica il numero max di titoli da visualizzare in una pagina.
  */
 function paginaTitoli(posizioneAttuale, titoliPerPagina)
 {
	getForm('hxpForm').pos.value = Math.floor(posizioneAttuale/titoliPerPagina)*titoliPerPagina;
 	getForm('hxpForm').verbo.value = 'showtitles';
 	getForm('hxpForm').submit();

 	return false;
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata ogni volta che si seleziona un profilo di stampa.
  * 			 Il template selezionato viene prelevato dall'attributo "value" del radio button passato
  * 			 come parametro.
  */
 function setTemplate(radioB)
 {
	getForm('hxpForm').printTemplate.value = radioB.value;

	//alert(getForm('hxpForm').printTemplate.value);
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata ogni volta che si seleziona cosa stampare (la selezione corrente
  * 			 o il singolo documento).
  * 			 Il verbo da utilizzare viene prelevato dall'attributo "value" del radio button passato
  * 			 come parametro.
  */
 function setVerbo(radioB)
 {
	getForm('hxpForm').verbo.value = radioB.value;

	//alert(getForm('hxpForm').verbo.value);
 }

 /*
  * Created on: 28/10/2004
  * by: fgr
  * organization: 3D Informatica
  * description: Funzione invocata per l'avviamento della stampa. In base al verbo impostato, prepara l'url
  * 			 per la stampa del singolo documento o della selezione corrente, aprendo una nuova finestra.
  * 			 Oltre ai valori di default 'print_selection','showdoc' e 'genericPrintHandler', vengono gestiti
  *              valori di verbo che contengono almeno un '.' (che indica la presenza di un package), cioe' valori
  *              che consentono di invocare una generica classe appartenente alla gerarchia di Response.
  *				 In questo caso la sintassi da utilizzare per il verbo  la seguente:
  *				 'package.nome_classe[|eventuale_xverb]'.
  */
 function startPrint()
 {
	if (getForm('hxpForm').printTemplate.value == '') {
		// errore: non  possibile determinare il profilo di stampa da usare
		alert("Profilo di stampa vuoto. Impossibile proseguire.");
		return false;
	}

    /* Federico 03/11/05: la tupla 'printTemplate' pu contenere, oltre al nome del template di stampa da usare,
     * anche il tipo di report da generare, il tipo di output, una classe java custom da usare per la  stampa e
     * il data source da usare nelle stampe jasper.
     * La sua sintassi  la seguente: nome_template|tipo_report|tipo_output|classe_custom|data_source.
     * Qualora le ultime quattro informazioni non siano state indicate, si avra': nome_template|||| o nome_template
     * (se mancano i "|" significa che la tupla  "vecchio stile").
     * [RW 0030160]
     *
     * Federico 12/01/06: aggiunte tuple per il cambio di selezione iniziale [RW 0029314]
     *
     * Federico 29/06/07: aggiunta tupla per l'ordinamento della selezione da stampare [RW 0045047]
     */
    var tmp, printTemplate = "", profileType = "", outputType = "", customClass = "", dataSource = "", selOrder = "";
    var initDb = "", initQuery = "", initOrd = "";

    if (getForm('hxpForm').printTemplate.value.indexOf("|") != -1) {
        tmp = getForm('hxpForm').printTemplate.value.split('|');

        if (tmp.length != 9) {
            // errore di sintassi nella tupla 'printTemplate'
            alert("Errore di sintassi nel profilo di stampa selezionato. Impossibile proseguire.");
            return false;
        }

        printTemplate   = tmp[0];
        profileType     = tmp[1];
        outputType      = tmp[2];
        customClass     = tmp[3];
        dataSource      = tmp[4];
        initDb          = tmp[5];
        initQuery       = tmp[6];
        initOrd         = tmp[7];
        selOrder        = tmp[8];
    }
    else {
        // la tupla 'printTemplate' non contiene "|" -->  vecchio stile
        printTemplate = getForm('hxpForm').printTemplate.value;
    }

	if (outputType == "") {
	    // non  stato definito il tipo di output da generare per la stampa --> imposto il default (pdf)
	    outputType = "pdf";
	}

	var verbo = getForm('hxpForm').verbo.value;
    var pos; // numero del doc. da stampare (calcolato a partire dalla tupla 'physDoc')

    // Federico 06/04/06: ristrutturato codice per costruire l'url di base mediante 'buildUrlForGet' [RW 0035909]
    var url = buildUrlForGet(getForm('hxpForm').uri.value, false, true, true);

	if (verbo == 'showdoc') {
		// stampa del singolo documento con FOP
		pos = parseInt(getForm('hxpForm').physDoc.value) - 1;
		url += "&verbo=showdoc&pos=" + pos + "&view=" + getForm('hxpForm').view.value + "&printTemplate=" +
               printTemplate + "&outContent=" + outputType;
	}
	else if (verbo == 'print_selection') {
		// Federico 04/11/04: stampa con FOP di una selezione di documenti con avviamento della loadingbar
        // Federico 03/01/06: aggiunta trasmissione tupla 'keylist' [RW 0030948]
        url += "&verbo=printselection_response&xverb=stampe&selid=" + getForm('hxpForm').selid.value +
               "&dbTable=@stampe" + "&printTemplate=" + printTemplate + "&outType=" + outputType +
               "&keylist=" + getForm('hxpForm').keylist.value;
	}
	else if (verbo.indexOf('genericPrintHandler') == 0 || verbo.indexOf(".") != -1) {
	     // Federico 11/05/05: esecuzione della stampa mediante una generica classe figlia di Response
         // Federico 17/10/05: esecuzione della stampa mediante l'handler per stampe fo/jasper [RW 0030160]
     	 var xverb = "";
     	 pos = "";

     	 if (getForm('hxpForm').physDoc.value != "") {
     	    // in hxpForm  indicato un numero fisico di documento
     	    pos = "" + (parseInt(getForm('hxpForm').physDoc.value) - 1);
     	 }

     	 if (verbo.indexOf("|") != -1) {
     	     //  stato specificato anche un xverb
     	     xverb = verbo.substring(verbo.indexOf("|") + 1);
     	     verbo = verbo.substring(0, verbo.indexOf("|"));
     	 }

         // preparazione dell'url da invocare
         // Federico 03/01/06: aggiunta trasmissione tupla 'keylist' [RW 0030948]
         url += "&verbo=" +
                verbo + "&xverb=" +
                xverb + "&selid=" +
                getForm('hxpForm').selid.value + "&pos=" +
                pos + "&dbTable=@stampe" +
                "&printTemplate=" + printTemplate +
                "&outType=" + outputType + "&profileType=" +
                profileType + "&keylist=" +
                getForm('hxpForm').keylist.value +
                // Federico 27/06/06: se si stampa subito dopo un inserimento, non c'e' una selezione -->
                // occorre trasmettere anche la tupla 'physDoc' [RW 0037621]
                "&physDoc=" + getForm('hxpForm').physDoc.value;

	     if (verbo == 'genericPrintHandler') {
             /* Qualora si usi l'handler per stampe fo/jasper  utile sapere se occorre usare una classe custom
              * per la stampa.
              * 'customClass' contiene il valore di verbo da usare per istanziare la classe custom, che deve
              * appartenere alla gerarchia di Response (viene usato il meccanismo dell'indicazione, nel verbo,
              * del package della classe da istanziare).
              * L'xverb passato alla classe custom  quello presente nella richiesta inviata da questa funzione.
              */
	         url += "&useCustomClass=" + customClass;

             // In caso di stampe jasper occorre aggiungere all'url altre info necessarie per la stampa
             url += "&dataSource=" + replaceAll(dataSource, '#', '%23');

             // posizione del doc. nella selezione (x JRXWDataSource)
             url += "&selPos=" + getForm('hxpForm').pos.value;

             // Federico 12/01/06: aggiunte tuple per il cambio di selezione iniziale [RW 0029314]
             url += "&initDb=" + initDb + "&initQuery=" + initQuery + "&initOrd=" + initOrd;

             // Federico 29/06/07: aggiunta tupla per l'ordinamento della selezione da stampare [RW 0045047]
             url += "&selOrder=" + selOrder;
         }
 	}
 	else {
 	    alert("verbo \"" + verbo + "\" non gestito!");
 	    return false;
 	}

    // Federico 05/12/06: in caso di messaggi di errore il pulsante 'indietro' deve chiudere la finestra [RW 0033834]
    url += "&errorMsgHandType=CLOSE";

    sendPrintRequest(url);

    return false;
 }

 function sendPrintRequest(url)
 {
    window.open(url);//sstagni: non applicabile il post in quanto ci sono tuple non nella hxpForm
 }
