/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* query_chk_restriction.js */

// Nel caso di checkbox selezionato restringe la ricerca su un certo item

/* Restituisce la frase di ricerca della restrizione
   Se nessuna restrizione attiva restituisce stringa vuota
*/
function applyRestriction()
{
	var result = '';

	for( var index = 0; index < getForm('theForm').elements.length; index++ ) {

        // Federico 11/06/07: l'elemento esplorato potrebbe non avere un name [RW 0044319]
        var elementName = getForm('theForm').elements[index].name;

        if (typeof(elementName) == 'undefined' || elementName.length < 7) continue;

		if ( getForm('theForm').elements[index].name.substr(0,7)=='chkres_' ) {
			if ( getForm('theForm').elements[index].type == 'checkbox'
			     && getForm('theForm').elements[index].checked == true
			    )
			{
				var name = getForm('theForm').elements[index].name;
				name = name.substring(name.indexOf('_') + 1, name.lastIndexOf('_'));
				result += /*(result == '')?*/ '[' + name + ']' + '=' /*: result*/; //solo per il primo checkbox
				result += getForm('theForm').elements[index].value + ' OR ' ;
			}
			else if ( getForm('theForm').elements[index].type == 'hidden' ) {
				var name = getForm('theForm').elements[index].name;
				name = name.substring(name.indexOf('_') + 1, name.lastIndexOf('_'));
				result += /*(result == '')?*/ '[' + name + ']' + '=' /*: result*/;
				result += getForm('theForm').elements[index].value + ' OR ' ;
			}
		}
    }

	if ( result == '' )
		return '';
	else{
		result = result.slice(0,-4);
		return ('(' + result + ')');
	}
}
