/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* range.js */
// Funzioni per la gestione dei campi range (di tipo text)

//tiene traccia dell'ultimo check effettuato. 
//Stringa vuota se tutto ok, altrimenti name del campo in errore
var lastChkResult = '';


// ****************************************************** //
// N.B.: i campi range si distinguono dagli altri in base //
// al prefisso del nome e cio vengono riconosciuti come  //
// tali se iniziano per 'range', per 'rangenum', oppure   //
// per 'rangenumdifferentfield'.                          //
// ****************************************************** //
function VerifyIsRangeInput(InputNameToVerify) {
	if (InputNameToVerify.split('_')[0] == 'range') {
		// Range su data (AAAAMMGG)
		return true;
	}
	else if (InputNameToVerify.split('_')[0] == 'rangedifferentfield') {
		// Range su data (AAAAMMGG) ma con "Da" "a" collegati a campi diversi
		return true;
	}
	else if (InputNameToVerify.split('_')[0] == 'rangedifferentfieldnorepetition') {
		// Range su data (AAAAMMGG) ma con "Da" "a" collegati a campi diversi e senza RIPETIZIONE
		return true;
	}
	else if (InputNameToVerify.split('_')[0] == 'rangenum') {
		// Range di tipo numerico
		return true;
	}
	else if (InputNameToVerify.split('_')[0] == 'rangenumdifferentfield') {
		// Range di tipo numerico ma con "Da" "a" collegati a campi diversi
		return true;
	}
	else if (InputNameToVerify.split('_')[0] == 'rangenumdifferentfieldnorepetition') {
		// Range di tipo numerico ma con "Da" "a" collegati a campi diversi e senza RIPETIZIONE
		return true;
	}
	else {
		return false;
	}
}


// ********************************************************** //
// Costruisce la frase di ricerca per tutti gli input "range" //
// Sono da considerare SOLO quelli con attributo TYPE="text"  //
// ********************************************************** //
function addRangeToQuery() {
	var result = '';
	var from = '';
	var to = '';
	var separator;
	var searchName = '';
	var name_splitted;
	var valore = '';
	// var LinkedFieldName = '';
	var nameCheckPeriodoContinuo = '';
	var nameFieldFrom  = '';
	var nameFieldTo    = '';
	var valFrom        = '';
	var valTo          = '';
	var resultTemp = '';
	for( var index = 0; index < getForm('theForm').elements.length; index++ ) {
		if ( getForm('theForm').elements[index].type == 'text' && VerifyIsRangeInput(getForm('theForm').elements[index].name) ) {
			from = to = '';
			name_splitted = getForm('theForm').elements[index].name.split('_');
			if ( result.search(new RegExp('\\[' + name_splitted[1] + '\\]')) == -1 ) {
				// ************************************************************* //
				// Entro solo se l'elemento non e' gia' stato inserito in result //
				// ************************************************************* //
				if ( getForm('theForm').elements[index].name.substr(getForm('theForm').elements[index].name.length-5,5) == '_from' ) {
					// se e' "from" immagazzino il valore nella corrispondente variabile
					from = getForm('theForm').elements[index].value;
					if ( getForm('theForm').elements[index].name.substr(getForm('theForm').elements[index].name.length-9) == 'From_from' ) {
						// ********************************************** //
						// range con "Da" e "a" collegati a campi diversi //
						// Forzo un 'searchName' ad un nome impossibile   //
						// per non trovare il corrispondente              //
						// ********************************************** //
						searchName = 'undefined';
					}
					else {
						searchName = getForm('theForm').elements[index].name.substr(0, getForm('theForm').elements[index].name.length-5) + '_to';
					}
					to = typeof(getForm('theForm').elements[searchName]) != 'undefined' ? getForm('theForm').elements[searchName].value : '';
				}
				else if ( getForm('theForm').elements[index].name.substr(getForm('theForm').elements[index].name.length-3,3) == '_to' ) {
					// se e' "to" immagazzino il valore nella corrispondente variabile
					to = getForm('theForm').elements[index].value;
					if ( getForm('theForm').elements[index].name.substr(getForm('theForm').elements[index].name.length-5) == 'To_to' ) {
						// ********************************************** //
						// range con "Da" e "a" collegati a campi diversi //
						// Forzo un 'searchName' ad un nome impossibile   //
						// per non trovare il corrispondente              //
						// ********************************************** //
						searchName = 'undefined';
					}
					else {
						searchName = getForm('theForm').elements[index].name.substr(0, getForm('theForm').elements[index].name.length-3) + '_from';
					}
					from = typeof(getForm('theForm').elements[searchName]) != 'undefined' ? getForm('theForm').elements[searchName].value : '';
				}
				// **************************** //
				// Cerco il corrispondente side //
				// **************************** //
				searchName = name_splitted[0] + '_' + name_splitted[1] + '_side';
				if ( typeof(getForm('theForm').elements[searchName]) != 'undefined' ) {
					//esiste un side corrispondente
					if ( getForm('theForm').elements[searchName].type == 'checkbox' ) {
						// e' un checkbox
						separator = getSeparator(getForm('theForm').elements[searchName].checked);
					}
					else {
						// campo hidden
						separator = getSeparator(getForm('theForm').elements[searchName].value);
					}
				}
				else {
					separator = getSeparator('incl');
				}
				// ******************************** //
				// Verifico variabili "from" e "to" //
				// ******************************** //
				if ( from == '' && to == '' ) {
					// alert('from e to vuoti');
				}
				else if ( from != '' && to != '' ) {
					// **************************************************************** //
					// Sono qui se i due estremi del range sono entrambi valorizzati ed //
					// il range utilizza "Da" e "a" (data o numeri) sullo stesso campo. //
					// **************************************************************** //
					if ( getForm('theForm').elements[index].name.substr(0,6) == 'range_' ) {
						// range su date
						result += '([' + name_splitted[1] + ']={' + dateFormatted2XW(from) + separator + dateFormatted2XW(to) + '}) AND ';
					}
					else {
						// range su numeri (non convertire contenuto in formato data)
						result += '([' + name_splitted[1] + ']={' + from + separator + to + '}) AND ';
					}
				}
				else if ( from != '' || to != '' ) {
					// se utente sta usando solo un estremo del range potrebbe essere ricerca esatta
					valore = ( from != '' ) ? from : to;
					if ( getForm('theForm').elements[index].name.substr(0,6) == 'range_' ) {
						// ricerca esatta su date
						result += '([' + name_splitted[1] + ']=' + dateFormatted2XW(valore) + ') AND ';
					}
					else if ( getForm('theForm').elements[index].name.substr(0,9) == 'rangenum_' ) {
						// ricerca esatta su numeri (non convertire contenuto in formato data)
						result += '([' + name_splitted[1] + ']=' + valore + ') AND ';
					}
					else if ( getForm('theForm').elements[index].name.substr(0,20) == 'rangedifferentfield_' ) {
						// range di date su campi diversi
						if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' || name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
							resultTemp = '(([$$$_from]={|$$$_valFrom}) ADJ ([$$$_to]={$$$_valTo|})) AND ';
							if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' ) {
								nameFieldFrom = name_splitted[1];
								nameFieldTo   = name_splitted[1].substr(0,name_splitted[1].length-4)+'To';
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-4)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									 valFrom = getForm('theForm')['rangedifferentfield_'+nameFieldTo+'_to'].value;
									 valTo   = valFrom;
								}
								else {
									valFrom = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangedifferentfield_'+nameFieldTo+'_to'].value != '') {
										valTo   = getForm('theForm')['rangedifferentfield_'+nameFieldTo+'_to'].value;
									}
									else {
										valTo   = valFrom;
									}
								}
							}
							else if( name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
								nameFieldFrom = name_splitted[1].substr(0,name_splitted[1].length-2)+'From';
								nameFieldTo   = name_splitted[1];
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-2)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valTo = getForm('theForm')['rangedifferentfield_'+nameFieldFrom+'_from'].value;
									valFrom   = valTo;
								}
								else {
									valTo = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangedifferentfield_'+nameFieldFrom+'_from'].value != '') {
										valFrom   = getForm('theForm')['rangedifferentfield_'+nameFieldFrom+'_from'].value;
									}
									else {
										valFrom   = valTo;
									}
								}
							}
							else {
								// non si fa niente
							}
							resultTemp = resultTemp.split('$$$_from').join(nameFieldFrom);
							resultTemp = resultTemp.split('$$$_to').join(nameFieldTo);
							resultTemp = resultTemp.split('$$$_valFrom').join(verifyPresenceAndReturnValue(theForm, nameCheckPeriodoContinuo, dateFormatted2XW(valTo), dateFormatted2XW(valFrom) ));
							resultTemp = resultTemp.split('$$$_valTo').join(verifyPresenceAndReturnValue (theForm, nameCheckPeriodoContinuo, dateFormatted2XW(valFrom), dateFormatted2XW(valTo) ));
							result += resultTemp;
						}
						else {
							// non si fa niente
						}
					}
					else if ( getForm('theForm').elements[index].name.substr(0,23) == 'rangenumdifferentfield_' ) {
						// range numerico (non convertire contenuto in formato data) su campi diversi
						if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' || name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
							resultTemp = '(([$$$_from]={|$$$_valFrom}) ADJ ([$$$_to]={$$$_valTo|})) AND ';
							if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' ) {
								nameFieldFrom = name_splitted[1];
								nameFieldTo   = name_splitted[1].substr(0,name_splitted[1].length-4)+'To';
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-4)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valFrom = getForm('theForm')['rangenumdifferentfield_'+nameFieldTo+'_to'].value;
									valTo = valFrom;
								}
								else {
									valFrom = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangenumdifferentfield_'+nameFieldTo+'_to'].value != '') {
										valTo = getForm('theForm')['rangenumdifferentfield_'+nameFieldTo+'_to'].value;
									}
									else {
										valTo = valFrom;
									}
								}
							}
							else if( name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
								nameFieldFrom = name_splitted[1].substr(0,name_splitted[1].length-2)+'From';
								nameFieldTo   = name_splitted[1];
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-2)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valTo = getForm('theForm')['rangenumdifferentfield_'+nameFieldFrom+'_from'].value;
									valFrom = valTo;
								}
								else {
									valTo = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangenumdifferentfield_'+nameFieldFrom+'_from'].value != '') {
										valFrom = getForm('theForm')['rangenumdifferentfield_'+nameFieldFrom+'_from'].value;
									}
									else {
										valFrom   = valTo;
									}
								}
							}
							else {
								// non si fa niente
							}
							resultTemp = resultTemp.split('$$$_from').join(nameFieldFrom);
							resultTemp = resultTemp.split('$$$_to').join(nameFieldTo);
							resultTemp = resultTemp.split('$$$_valFrom').join(verifyPresenceAndReturnValue(theForm, nameCheckPeriodoContinuo, valTo, valFrom ));
							resultTemp = resultTemp.split('$$$_valTo').join(verifyPresenceAndReturnValue (theForm, nameCheckPeriodoContinuo, valFrom, valTo));
							result += resultTemp;
						}
						else {
							// non si fa niente
						}
					}
					else if ( getForm('theForm').elements[index].name.substr(0,32) == 'rangedifferentfieldnorepetition_' ) {
						// ********************************************************* //
						// range di DATE                                             //
						// su campi DIVERSI ma SENZA RIPETIZIONE                     //
						// ********************************************************* //
						if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' || name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
							resultTemp = '(([$$$_from]={|$$$_valFrom}) AND ([$$$_to]={$$$_valTo|})) AND ';
							if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' ) {
								nameFieldFrom = name_splitted[1];
								nameFieldTo   = name_splitted[1].substr(0,name_splitted[1].length-4)+'To';
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-4)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									 valFrom = getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldTo+'_to'].value;
									 valTo   = valFrom;
								}
								else {
									valFrom = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldTo+'_to'].value != '') {
										valTo   = getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldTo+'_to'].value;
									}
									else {
										valTo   = valFrom;
									}
								}
							}
							else if( name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
								nameFieldFrom = name_splitted[1].substr(0,name_splitted[1].length-2)+'From';
								nameFieldTo   = name_splitted[1];
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-2)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valTo = getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldFrom+'_from'].value;
									valFrom   = valTo;
								}
								else {
									valTo = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldFrom+'_from'].value != '') {
										valFrom   = getForm('theForm')['rangedifferentfieldnorepetition_'+nameFieldFrom+'_from'].value;
									}
									else {
										valFrom   = valTo;
									}
								}
							}
							else {
								// non si fa niente
							}
							resultTemp = resultTemp.split('$$$_from').join(nameFieldFrom);
							resultTemp = resultTemp.split('$$$_to').join(nameFieldTo);
							resultTemp = resultTemp.split('$$$_valFrom').join(verifyPresenceAndReturnValue(theForm, nameCheckPeriodoContinuo, dateFormatted2XW(valTo), dateFormatted2XW(valFrom) ));
							resultTemp = resultTemp.split('$$$_valTo').join(verifyPresenceAndReturnValue (theForm, nameCheckPeriodoContinuo, dateFormatted2XW(valFrom), dateFormatted2XW(valTo) ));
							result += resultTemp;
						}
						else {
							// non si fa niente
						}
					}
					else if ( getForm('theForm').elements[index].name.substr(0,35) == 'rangenumdifferentfieldnorepetition_' ) {
						// ********************************************************* //
						// range NUMERICO (non convertire contenuto in formato data) //
						// su campi DIVERSI ma SENZA RIPETIZIONE                     //
						// ********************************************************* //
						if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' || name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
							resultTemp = '(([$$$_from]={|$$$_valFrom}) AND ([$$$_to]={$$$_valTo|})) AND ';
							if( name_splitted[1].substr(name_splitted[1].length-4) == 'From' ) {
								nameFieldFrom = name_splitted[1];
								nameFieldTo   = name_splitted[1].substr(0,name_splitted[1].length-4)+'To';
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-4)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valFrom = getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldTo+'_to'].value;
									valTo = valFrom;
								}
								else {
									valFrom = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldTo+'_to'].value != '') {
										valTo = getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldTo+'_to'].value;
									}
									else {
										valTo = valFrom;
									}
								}
							}
							else if( name_splitted[1].substr(name_splitted[1].length-2) == 'To' ) {
								nameFieldFrom = name_splitted[1].substr(0,name_splitted[1].length-2)+'From';
								nameFieldTo   = name_splitted[1];
								nameCheckPeriodoContinuo = name_splitted[1].substr(0,name_splitted[1].length-2)+'PeriodoContinuo';
								if( getForm('theForm').elements[index].value == '' ) {
									valTo = getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldFrom+'_from'].value;
									valFrom = valTo;
								}
								else {
									valTo = getForm('theForm').elements[index].value;
									if (getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldFrom+'_from'].value != '') {
										valFrom = getForm('theForm')['rangenumdifferentfieldnorepetition_'+nameFieldFrom+'_from'].value;
									}
									else {
										valFrom   = valTo;
									}
								}
							}
							else {
								// non si fa niente
							}
							resultTemp = resultTemp.split('$$$_from').join(nameFieldFrom);
							resultTemp = resultTemp.split('$$$_to').join(nameFieldTo);
							resultTemp = resultTemp.split('$$$_valFrom').join(verifyPresenceAndReturnValue(theForm, nameCheckPeriodoContinuo, valTo, valFrom ));
							resultTemp = resultTemp.split('$$$_valTo').join(verifyPresenceAndReturnValue (theForm, nameCheckPeriodoContinuo, valFrom, valTo));
							result += resultTemp;
						}
						else {
							// non si fa niente
						}
					}
					else {
						// non si fa niente
					}
				}
			}
		}
	}

	return (result == '' ? result : result.slice(0,-5));
}


// Restituisce il separatore in base al tipo di inclusione
function getSeparator(val) {
	if ( (val == '') || (val == false) || (val == 'incl') ) {
		// default, checkbox non checked o hidden con valore 'incl'
		return '|';
	}
	else if ( val == true || (val == 'escl') ) {
		//checkbox checked o hidden con valore 'escl'
		return '^';
	}
	else {
		return '|';
	}
}


// Controlli di validita' e consistenza dei dati del campo range
function chkRange(theRange, tipo, verbose, toSelect) {
	//getForm('theForm').custom_globale.value += "  " + theRange.name + "(" + toSelect + ")";
	if( lastChkResult != '' ) {
		if( arguments.length > 4 && arguments[4] == true ) {
			if (theRange.name.substr(theRange.name.length-5) == 'To_to') {
				if (lastChkResult.name.substr(lastChkResult.name.length-9) == 'From_from') {
					if (theRange.name.substr(0, theRange.name.length-5) == lastChkResult.name.substr(0, lastChkResult.name.length-9)) {
						return true;
					}
				}
			}
			else if (theRange.name.substr(theRange.name.length-9) == 'From_from') {
				if (lastChkResult.name.substr(lastChkResult.name.length-5) == 'To_to') {
					if (theRange.name.substr(0, theRange.name.length-9) == lastChkResult.name.substr(0, lastChkResult.name.length-5)) {
						return true;
					}
				}
			}
			else {
			}
		}
		else {
			if ( lastChkResult.name.substring(0, lastChkResult.name.lastIndexOf('_')) == theRange.name.substring(0, theRange.name.lastIndexOf('_')) &&
			  lastChkResult.name.substring(lastChkResult.name.lastIndexOf('_')) != theRange.name.substring(theRange.name.lastIndexOf('_')) ) {
				//per evitare loop
				return true;
			}
		}
	}

	var message = '';
	var searchName = '';
	var from = '';
	var to = '';
	var name_splitted = theRange.name.split('_');
	var ret = true;
	lastChkResult = '';

	if ( theRange.value == '') {
		// Se il valore  vuoto esco subito //
		return true;
	}

	// ********************************************** //
	// Faccio partire la prima tornata di controlli   //
	// diversificati in base al tipo ("data" o "num") //
	// ********************************************** //
	if ( tipo == 'data' ) {
		ret = chkDate(theRange, verbose);
	}
	else if ( tipo == 'num' ) {
		ret = IsNumeric(theRange, false, verbose);
	}
	else {
	}
	// *********************************************** //
	// Se si sono verificati degli errori intraprendo  //
	// le azioni opportune.                            //
	// *********************************************** //
	if ( ret == false ) {
		//getForm('theForm').custom_globale.value += " FALSE";
		if ( typeof(toSelect) == 'undefined' || toSelect == true ) {
			theRange.select();
			setTimeout(function(){theRange.focus()}, 10);
		}
		lastChkResult = theRange;
		return false;
	}
	// *********************************************** //
	// Faccio partire la seconda tornata di controlli  //
	// e cio verifico l'input corrispondente a quello //
	// appena controllato.                             //
	// *********************************************** //
	if ( name_splitted[2] == 'from' ) {
		from = theRange.value;
		// ***************************************************** //
		// Immagazzinato il valore nella variabile "from" cerco  //
		// di determinare il nome del campo "to" corrispondente. //
		// ***************************************************** //
		if( arguments.length > 4 && arguments[4] == true ) {
			searchName = theRange.name.split('From_from').join('To_to');
		}
		else {
			searchName = name_splitted[0] + '_' + name_splitted[1] + '_to';
		}
		// *************************************************** //
		// Determinato il nome dell'input corrispondente se il //
		// valore associato ad esso  valido lo immagazzino    //
		// nella variabile associata ("to") e ne verifico la   //
		// "consistenza"                                       //
		// *************************************************** //
		if ( typeof(getForm('theForm').elements[searchName]) != 'undefined' && getForm('theForm').elements[searchName].value.length > 0 ) {
			to = getForm('theForm').elements[searchName].value;
			ret = chkConsistency(from, to, tipo, verbose);
		}
	}
	else 	if ( name_splitted[2] == 'to' ) {
		to = theRange.value;
		// ***************************************************** //
		// Immagazzinato il valore nella variabile "to" cerco di //
		// determinare il nome del campo "from" corrispondente.  //
		// ***************************************************** //
		if( arguments.length > 4 && arguments[4] == true ) {
			searchName = theRange.name.split('To_to').join('From_from');
		}
		else {
			searchName = name_splitted[0] + '_' + name_splitted[1] + '_from';
		}
		// *************************************************** //
		// Determinato il nome dell'input corrispondente se il //
		// valore associato ad esso  valido lo immagazzino    //
		// nella variabile associata ("from") e ne verifico la //
		// "consistenza"                                       //
		// *************************************************** //
		if ( typeof(getForm('theForm').elements[searchName]) != 'undefined' && getForm('theForm').elements[searchName].value.length > 0 ) {
			from = getForm('theForm').elements[searchName].value;
			ret = chkConsistency(from, to, tipo, verbose);
		}
	}
	// *********************************************** //
	// Se si sono verificati degli errori intraprendo  //
	// le azioni opportune.                            //
	// *********************************************** //
	if ( ret == false ) {
		//getForm('theForm').custom_globale.value += " FALSE2";
		//getForm('theForm').custom_globale.value += " (" + from + "*" + to + ")";
		if ( typeof(toSelect) == 'undefined' || toSelect == true ) {
			theRange.select();
			setTimeout(function(){theRange.focus()}, 10);
		}
		lastChkResult = theRange;
	}
	return ret;
}


// ********************************************************************* //
// Verifica che l'argomento "from" non sia mmaggiore dell'argomento "to" //
// Nel caso questa condizione si verifichi l'argomento bool "verbose" mi //
// indica se debba essere o meno emesso un messaggio a video; inoltre a  //
// seconda della tipologia di "from" e "to", gli stessi vengono trattati //
// e testati come numerici (tipo == 'num') o come date (previa corretta  //
// riformattazione in formato opportuno)                                 //
// ********************************************************************* //
function chkConsistency(from, to, tipo, verbose) {
	if ( tipo == 'num' ) {
		if ( parseInt(from,10) > parseInt(to,10) ) {
			if ( verbose == true ) 
				rangeMSG(fromGraterThanTo);
			return false;
		}
	}
	else if ( tipo == 'data' ) {		
		if ( dateFormatted2XW(from) > dateFormatted2XW(to) ) {
			if ( verbose == true )
				rangeMSG(fromGraterThanTo);
			return false;
		}
	}
	return true;
}


// ****************************************************************** //
// Converte una stringa rappresentativa di una data con formattazione //
// "gg/mm/aaaa" al formato "aaaammgg" (formato extraway)              //
// ****************************************************************** //
function dateFormatted2XW(date) {
	return ( date.substr(6,4) + date.substr(3,2) + date.substr(0,2) );
}


function getLastChkResult() {
	return lastChkResult;
}

// Verifica presenza input di una form e riporta opportuni valori in base al tipo di input
// e al verificarsi di determinate condizioni
function verifyPresenceAndReturnValue (theFormObj, inputName, defaultValueToReturn, alternativeValeToReturn ) {
   if( theFormObj[inputName] ) {
   	if( theFormObj[inputName].type == 'text' && theFormObj[inputName].value != '' ) {
   		// Input value valorizzato
   		return alternativeValeToReturn;
   	}
      else if( theFormObj[inputName].type == 'checkbox' && theFormObj[inputName].checked == true ) {
   		// Checkbox checcato
   		return alternativeValeToReturn;
      }
   	else {
         return defaultValueToReturn;
   	}
   }
   else {
      return defaultValueToReturn;
   }
}