/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /**
  * rifinterni-lookup-generico.js
  *
  * Questo file deve essere incluso nelle pagine "rifint_response" (rifinterni.xsl) per
  * SOVRASCRIVERE le function di lookup generico definite in docEdit.js.
  * Lo scopo e' quello di avere un lookup generico per i ruoli nelle pagine menzionate [RW 0043770].
  *
  * NOTA: Questo file non deve essere incluso nelle pagine di inserimento/modifica!
  */

// Federico 10/05/07: ricopiata da docEdit.js e opportunamente adattata per la gestione dei ruoli [RW 0043770]
//                    Questa function deve sovrascrivere quella di docEdit.js.
function lookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str)
{
    var sourceForm = getForm("theForm");
    var requestForm = getForm('hxpForm');

    var iForm, titolo, campi, xq = "", val, db = "", newrecord = "";

    var old_target = requestForm.target;
    var old_verbo = requestForm.verbo.value;
    var old_selid = requestForm.selid.value;
    var old_newrecord = requestForm.lookup_new.value;
    var old_qord = requestForm.qord.value;
    var old_lookup_titolo = requestForm.lookup_titolo.value;
    var old_lookup_campi = requestForm.lookup_campi.value;
    var old_lookup_xq = requestForm.lookup_xq.value;
    var old_lookup_new = requestForm.lookup_new.value;
    var old_lookup_db = requestForm.lookup_db.value;
    var old_lookup_fieldVal = requestForm.lookup_fieldVal.value;
    var old_lookup_alias = requestForm.lookup_alias.value;

    //multistanza - necessario poiche' non e' possibile modificare dinamicamente onclick di elemento
    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) {

        dad = inputNode.parentNode;

        var theInputName = inputNode.name;

        // Federico 15/05/07: data la possibilita' di specificare una stringa diversa dal nome dell'input
        // che contiene "[$hxp_instance()]" o "$hxp_instance()" (usata per il calcolo del numero d'istanza)
        // [RW 0043770]
        if (typeof(hxp_inst_str) == 'undefined' || hxp_inst_str == null) {
            hxp_inst_str = theInputName;
        }

        var prefix = hxp_inst_str.substring(0, hxp_inst_str.lastIndexOf('['));

        if ( prefix.charAt(0) == '.') prefix = prefix.substring(1);

        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 )
            dad = dad.parentNode;

        var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);

        //caso di istanza figlia di multistanza
        if ( inputName.indexOf('$hxp_fatherinstance()') != -1 ) {
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            inputName = inputName.replace('$hxp_fatherinstance()', fatherInstNumber);
        }

        inputName = inputName.replace('$hxp_instance()', instNumber);
        //alert (inputName);

        titolo = getElementByName('lookup_titolo_' + inputName).value;
        //alert(titolo);
        campi = getElementByName('lookup_campi_' + inputName).value;
        //alert(campi);

        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_xq_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_xq_' + inputName) ) {
            xq = getElementByName('lookup_xq_' + inputName).value;
        }
        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_new_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_new_' + inputName) ) {
            newrecord = getElementByName('lookup_new_' + inputName).value;
        }
        // Modifica effettuata da gregorio in data 12/08/2004 12.16
        // if ( typeof(getElementByName('lookup_db_' + inputName)) != 'undefined' )
        if ( getElementByName('lookup_db_' + inputName) ) {
            db = getElementByName('lookup_db_' + inputName).value;
        }

        val = getElementByName(inputName).value;
    }
    else {

        //no multistanza

        dad = null;
        titolo = sourceForm['lookup_titolo_' + inputName].value;
        campi = sourceForm['lookup_campi_' + inputName].value;
        if ( typeof(sourceForm['lookup_xq_' + inputName]) != 'undefined' )
            xq = sourceForm['lookup_xq_' + inputName].value;
        if ( typeof(sourceForm['lookup_new_' + inputName]) != 'undefined' )
            newrecord = sourceForm['lookup_new_' + inputName].value;
        if ( typeof(sourceForm['lookup_db_' + inputName]) != 'undefined' )
            db = sourceForm['lookup_db_' + inputName].value;
        val = sourceForm[inputName].value;
    }

    nodeToSetDefault = getElementByName(inputName);

    //se db acl -> seleziono quello corretto (multi acl)
    if (db == 'acl' && getForm("hxpForm").aclDb.value != '')
        db = getForm("hxpForm").aclDb.value;

    iForm = requestForm;
    iForm.selid.value          = "";
    iForm.qord.value           = ord;
    iForm.lookup_titolo.value  = titolo;
    iForm.lookup_campi.value   = campi;
    iForm.lookup_xq.value      = xq;
    iForm.lookup_new.value     = newrecord;
    iForm.lookup_db.value      = db;
    iForm.lookup_fieldVal.value= val;
    iForm.lookup_alias.value   = aliasName;

    if ( typeof(aliasName1) != 'undefined' && aliasName1.length > 0 )
        iForm.lookup_alias.value += "|" + aliasName1;

    iForm.verbo.value = "lookup_response";
    iForm.target = iForm.target + 'lookup_child';

    //if ( typeof(iForm.fromLookup) != 'undefined'  &&  iForm.fromLookup.value == 'true' )
    if ( typeof(sourceForm.fromLookup) != 'undefined'  &&  sourceForm.fromLookup.value == 'true' )
        iForm.target += '_new';

    var r = true;

    if (typeof(customPreLookup) != 'undefined') {
        r = customPreLookup(sourceForm, inputName, val);
    }

    if ( r == true ) {

        var Ajax = (isAjaxCompliant() && document.getElementById('lookupDiv') != null) ? true : false;
        var doItWithAjax = typeof(customDoLookupWithAjax) != 'undefined' && !customDoLookupWithAjax() ? false : true;
        if (!Ajax || !doItWithAjax) {
            var windowFeature = "width=620 height=520 resizable";
            if ( typeof(customSetWindowFeature) != 'undefined' )
                windowFeature = customSetWindowFeature();
            theIndexWindow=window.open(staticEmptyWindow, iForm.target, windowFeature);
            iForm.submit();
        }
        else {//AJAX
            // Federico 25/08/09: le '&' in fieldVal devono essere escapate [EB 118]
            iForm.lookup_fieldVal.value = replaceAll(iForm.lookup_fieldVal.value, '&', '%26');

            // Federico 09/10/07: introdotto uso di 'buildUrlForGet' per trasmettere anche la tupla '_cd' (serve per gestire
            // il multisocieta') [RW 0047021]
            var params = buildUrlForGet("", true, true, true, true) + "&selid=" + iForm.selid.value + "&verbo=lookup_response&lookup_campi=" + iForm.lookup_campi.value +
                "&lookup_fieldVal=" + iForm.lookup_fieldVal.value + "&lookup_alias=" + iForm.lookup_alias.value +
                "&lookup_titolo=" + iForm.lookup_titolo.value + "&lookup_xq=" + iForm.lookup_xq.value +
                "&lookup_new=" + iForm.lookup_new.value + "&lookup_db=" + iForm.lookup_db.value +
                "&qord=" + iForm.qord.value + "&transformJava=ajax&login=" + iForm.login.value;

            if (!lookupIsBusy) {
                setLastFieldsUsedLookup(iForm.lookup_campi.value, iForm.lookup_fieldVal.value);
                setNewRecordLookupVars(iForm.lookup_campi.value, iForm.lookup_titolo.value, iForm.lookup_db.value);
                lookupIsBusy = true;
                jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleLookup, errorHandlerLookup, null);
            }
        }
    }

    requestForm.target = old_target;
    requestForm.verbo.value = old_verbo;
    requestForm.selid.value = old_selid;
    requestForm.lookup_new.value = old_newrecord;
    requestForm.qord.value = old_qord;
    requestForm.lookup_titolo.value = old_lookup_titolo;
    requestForm.lookup_campi.value = old_lookup_campi;
    requestForm.lookup_xq.value = old_lookup_xq;
    requestForm.lookup_new.value = old_lookup_new;
    requestForm.lookup_db.value = old_lookup_db;
    requestForm.lookup_fieldVal.value = old_lookup_fieldVal;
    requestForm.lookup_alias.value = old_lookup_alias;

    return false;
}

// Federico 10/05/07: ricopiata da docEdit.js e opportunamente adattata per la gestione dei ruoli [RW 0043770]
//                    Questa function deve sovrascrivere quella di docEdit.js.
function onblurLookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str)
{
    var fieldName;
    nodeToSetDefault = inputNode;
    var _inputName = inputName;

    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) { //multistanza
        var dad = inputNode.parentNode;
        var theInputName = inputNode.name;

        // Federico 15/05/07: data la possibilita' di specificare una stringa diversa dal nome dell'input
        // che contiene "[$hxp_instance()]" o "$hxp_instance()" (usata per il calcolo del numero d'istanza)
        // [RW 0043770]
        if (typeof(hxp_inst_str) == 'undefined' || hxp_inst_str == null) {
            hxp_inst_str = theInputName;
        }

        var prefix = hxp_inst_str.substring(0, hxp_inst_str.lastIndexOf('['));

        if ( prefix.charAt(0) == '.') {
            prefix = prefix.substring(1);
        }

        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 ) {
            dad = dad.parentNode;
        }
        var instNumber = dad.id.substring(dad.id.lastIndexOf('.') + 1);
        _inputName = inputName.replace('$hxp_instance()', instNumber);
        //caso di istanza figlia di multistanza
        if ( typeof(_inputName.indexOf('$hxp_fatherinstance()')) != 'undefined' ) {
            // var fatherInstNumber = childName.substring(childName.indexOf('[') + 1, childName.indexOf(']'));
            var id = dad.id;
            var fatherInstNumber = id.substring(id.indexOf('[') + 1, id.indexOf(']'));
            _inputName = _inputName.replace('$hxp_fatherinstance()', fatherInstNumber);
        }
    }
    if ( inputNode.value.length == 0 && inputNode.defaultValue.length != 0 ) { //svuotare tutti i campi del lookup
        if ( typeof(customEraseLookup) == 'undefined' || (typeof(customEraseLookup) != 'undefined' && customEraseLookup(_inputName) == true ) ) {
            //var fieldsArray = getHtmlNode(inputNode, 'lookup_campi_' + _inputName).value.split(';');
            var fieldsArray = getElementByName('lookup_campi_' + _inputName).value.split(';');
            for ( var i = 0 ; i < fieldsArray.length; i++ ) {
                fieldName = fieldsArray[i].split('=')[0];
                fieldName = fieldName.replace(/ /, '');
                for ( var j = 0; j < getForm("theForm").length; j++ ) {
                    //cancello campi di lookup (operazione molto costosa)
                    if ( getForm("theForm")[j].name == fieldName ) {
                        getForm("theForm")[j].value = "";
                        break;
                    }
                }
            }
        }
    }
    else {
        if ( inputNode.value != inputNode.defaultValue ) {
            if ( typeof(aliasName1) != 'undefined' ) {
                lookup(inputNode, aliasName, inputName, ord, aliasName1, hxp_inst_str);
            }
            else {
                lookup(inputNode, aliasName, inputName, ord, '', hxp_inst_str);
            }
            // metodo brutto per impedire il salvataggio di voci non vincolate
            inputNode.value = "";
        }
    }
    return false;
}

//AJAX

// Federico 10/05/07: ricopiata da docEdit.js e opportunamente adattata per la gestione dei ruoli [RW 0043770]
//                    Questa function deve sovrascrivere quella di docEdit.js.
function fillFieldsLookup(campi)
{
  //  alert(campi);
  if (typeof(customFillFieldsLookup) != 'undefined')
      return customFillFieldsLookup(campi);

  var arr = campi.split('|');
  var riga;
  var index;
  for (var i=0; i<arr.length; i++) {
      riga = arr[i];
      index = riga.indexOf('=');
      try {
          if (dad == null)
              getForm('theForm')[riga.substring(0, index)].value = riga.substring(index + 1);
          else {
              elFoundLookup = null;
              visitaTreeLookup(dad, riga.substring(0, index));
              var el = elFoundLookup;
              if ( el != null )
                  el.value = riga.substring(index + 1);
          }

          if (nodeToSetDefault != null ) //vedi onblurLookup
              nodeToSetDefault.defaultValue = nodeToSetDefault.value;
      }
      catch (error) {
      }
  }

  resetLookupVars();
  return false;
}