/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* rifinterni.js */

//nome della finestra statica (vuota) che viene aperta quando c' un popup in modo che venga mantenuto il protocollo
//corrente (http o https)
var staticEmptyWindow = "./../formatter/html/templates/static.html";

lookupInAtto = false;
confirmClicked = false;

 /* funzioni per la pagina di inserimento dei riferimenti interni */

function rifinterniLoadHandler()
{
    startModalWindow();

    if ( getForm('hxpForm').warnings.value != '' )
        alert(getForm('hxpForm').warnings.value);

    if ( typeof(getForm('hxpForm').rifInt) != 'undefined'){
        if ( getForm('hxpForm').rifInt.value == "close" ) {  //ritorno da una assegnazione di CC/RPA
            self.close();
            opener.getForm('hxpForm').submit(); //ricarica la pagina del documento (rendere visibili le modifiche)
        }
    }

    if (getForm('theForm') != null) {
        if (typeof(getForm('theForm')['*sendMailRifInterni']) != 'undefined' && getForm('hxpForm').toDo.value == 'IS_BOZZA') {
            getForm('theForm')['*sendMailRifInterni'].checked = false;
        }
    }
}

function rifinterniUnloadHandler()
{
    //RW0048997 - 21/12/2007 - Unibo
    var operazione = getForm('hxpForm').xverb.value;
    if (!(operazione == '@CAMBIA_CLASSIF_FASC') && !(operazione == '@TRASF') && !(operazione == '@CAMBIA_CLASSIF_DOC')) stopModalWindow();
}

function closeRifInt()
{
    if (lookupInAtto) {//per Mozilla
        return false;
    }

    // Federico 11/01/08: chiudendo la pagina dei rifinterni occorre "riabilitare" la finestra principale [RW 0049549]
    stopModalWindow();

	self.close();

    return false;
}

function confirmRifInt()
{
    if (lookupInAtto) {//per Mozilla
        confirmClicked = true;
        return false;
    }

    // Federico 15/04/08: assegnazione CC a una selezione di documenti [RW 0051093]
    var isCCPage = getForm('hxpForm').rifInt.value == 'CC';

    var rifIntString = "";
    var errorFound = true;
    for ( var i = 0; i < getForm('theForm').length; i++ ){
        if ( typeof(getForm('theForm')[i].name) != 'undefined' && getForm('theForm')[i].name.charAt(0) == '*' ) {
            if (getForm('theForm')[i].type == "checkbox" ) {
                if (getForm('theForm')[i].checked)
                    rifIntString += getForm('theForm')[i].name + "=" + getForm('theForm')[i].value + "|";
            }
            else {
                rifIntString += getForm('theForm')[i].name + "=" + getForm('theForm')[i].value + "|";
                if (getForm('theForm')[i].value.length > 0 || getForm('theForm')[i].name.indexOf("assegnazioneCDS") != -1)
                    errorFound = false;
            }
        }
    }
    if ( errorFound == false ) {
        rifIntString = rifIntString.slice(0, -1);
        getForm('hxpForm').rifInt.value = rifIntString;

        //alert(rifIntString);

        getForm('hxpForm').verbo.value = "rifint_response";

        if ( typeof(getForm('theForm')['*sendMailRifInterni']) == 'undefined' )
            getForm('hxpForm').sendMail.value = false;
        else if ( getForm('theForm')['*sendMailRifInterni'].checked == true )
            getForm('hxpForm').sendMail.value = true;
        else
            getForm('hxpForm').sendMail.value = false;

        if (getForm('hxpForm').toDo.value == 'from_titles') {
            // Federico 15/04/08: assegnazione CC a una selezione di documenti [RW 0051093]
            if (!isCCPage) {
                //trasferimento multiplo selezione
                return newRPAForSel();
            }
            else {
                //assegnamento CC multiplo da selezione
                return newCCForSel();
            }
        }
        else if (getForm('hxpForm').toDo.value == 'from_fasc_titles') {
            //trasferimento multiplo selezione fascicoli
            return newRPAForSelFasc();
        }

        OpenWaitMsg();

        if (getForm('hxpForm').xverb.value != '@TRASF') {
            getForm('hxpForm').xverb.value = "@assignRif_" + getForm('hxpForm').xverb.value;
            opener.OpenWaitMsg();
        }

        var hxpS = new _hxpSession(getForm('hxpForm'));
        if (typeof(getForm('theForm')['checkNomi']) != 'undefined' && getForm('theForm')['checkNomi'].checked)
            hxpS.setParameter("checkNomi", "si");
        else
            hxpS.setParameter("checkNomi", null);

        getForm('hxpForm').submit();
    }
    else { //tutti campi vuoti (RPA non sensato oppure tutti CC fasulli)
        rifintMSG(noValField);
    }
    return false;
}

var dad = null;

// Federico 08/07/09: aggiunto parametro 'skipAOORestriction' per evitare la restrizione alla AOO nel lookup [M 0000498]
// Federico 11/11/09: aggiunti parametri 'getUORData4Titles' e 'xq' [EB 400]
function rifintLookup(inputNode, inputName, ord, fieldType, skipAOORestriction, getUORData4Titles, xq)
{
    inputName=inputName.replace('_parsedInstance_','');

    lookupInAtto = true;
    var theForm;
    if ( getForm('theForm') != null )
        theForm = getForm('theForm');
    else
        theForm = getForm('hxpForm');

    var iForm, titolo, val, input2Name, val2, inputCodUffName, inputCodPersonaName;
    var old_target = getForm('hxpForm').target;
    var old_verbo = getForm('hxpForm').verbo.value;
    var old_selid = getForm('hxpForm').selid.value;

    //multistanza - necessario poiche' non e' possibile modificare dinamicamente onclick di elemento
    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) {
        var prefix = inputName.substring(0, inputName.indexOf('['));

        if ( prefix.indexOf('assegnazioneCC') > 0 )
            prefix = "CC";
        else if ( prefix.indexOf('assegnazioneCDS') > 0 )
            prefix = "CDS";
        // Federico 07/07/09: reso piu' flessibile il meccanismo dei prefissi d'istanza (destinatari
        // interni interoperabilita' con i ws) [M 0000498]
        else if (prefix.indexOf('.') != -1) {
            prefix = prefix.substring(prefix.lastIndexOf('.') + 1);
        }

        dad = inputNode.parentNode;
        while ( typeof(dad.id) == 'undefined' || dad.id.indexOf(prefix + '.') == -1 )
            dad = dad.parentNode;

        var instNumber = dad.id.substring(dad.id.indexOf('.') + 1);

        /*
         var dad = inputNode.parentNode;
         var childName = dad.childNodes.item(0).name;
         var instNumber = childName.substring(childName.indexOf('[') + 1, childName.indexOf(']'));
         */

        inputName = inputName.replace('$hxp_instance()', instNumber);

        if ( fieldType == 'nome_uff' ) {
            input2Name = inputName.slice(0, -8) + 'nome_persona';

            // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
            // interni interoperabilita' con i ws) [M 0000498]
            inputCodUffName     = inputName.slice(0, -8) + 'cod_uff';
            inputCodPersonaName = inputName.slice(0, -8) + 'cod_persona';
        }
        else {
            input2Name = inputName.slice(0, -12) + 'nome_uff';

            // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
            // interni interoperabilita' con i ws) [M 0000498]
            inputCodUffName     = inputName.slice(0, -12) + 'cod_uff';
            inputCodPersonaName = inputName.slice(0, -12) + 'cod_persona';
        }

        for ( var i = 0; i < theForm.length; i++ ){	//(operazione molto costosa)
            if ( theForm[i].name == 'lookup_titolo_' + inputName )
                titolo = theForm[i].value;
            if ( theForm[i].name == inputName)
                val = theForm[i].value;
            if ( theForm[i].name == input2Name)
                val2 = theForm[i].value;
        }

    }
    else { //no multistanza

        if ( fieldType == 'nome_uff' ) {
            input2Name = inputName.slice(0, -8) + 'nome_persona';

            // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
            // interni interoperabilita' con i ws) [M 0000498]
            inputCodUffName     = inputName.slice(0, -8) + 'cod_uff';
            inputCodPersonaName = inputName.slice(0, -8) + 'cod_persona';
        }
        else {
            input2Name = inputName.slice(0, -12) + 'nome_uff';

            // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
            // interni interoperabilita' con i ws) [M 0000498]
            inputCodUffName     = inputName.slice(0, -12) + 'cod_uff';
            inputCodPersonaName = inputName.slice(0, -12) + 'cod_persona';
        }

        dad = null;
        titolo = theForm['lookup_titolo_' + inputName].value;
        val = theForm[inputName].value;
        val2 = theForm[input2Name].value;
    }

    //alert(inputName + " " + ord +" " + fieldType)

    iForm = getForm('hxpForm');
    iForm.selid.value = "";
    iForm.qord.value = ord;
    iForm.lookup_titolo.value = titolo;

    if ( fieldType == 'nome_uff' ) {
        // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
        // interni interoperabilita' con i ws) [M 0000498]
        iForm.lookup_campi.value = inputName + '|' + input2Name + '|' + inputCodUffName + '|' + inputCodPersonaName;

        iForm.lookup_fieldVal.value = val + '|' + val2;
        iForm.lookup_alias.value = "struint_nome,gruppi_nome";
    }
    else {
        // Federico 07/07/09: il lookup sui rifint deve recuperare anche i codici di ufficio e persona (destinatari
        // interni interoperabilita' con i ws) [M 0000498]
        iForm.lookup_campi.value = input2Name + '|' + inputName + '|' + inputCodUffName + '|' + inputCodPersonaName;

        iForm.lookup_fieldVal.value = val2 + '|' + val;
        iForm.lookup_alias.value = "persint_nomcogn";
    }

    // Federico 08/07/09: aggiunto parametro 'skipAOORestriction' per evitare la restrizione alla AOO nel lookup [M 0000498]
    // Federico 27/10/09: meglio usare '_cd' al posto di 'toDo' per evitare conflitti con altre gestioni di 'toDo' [EB 151]
    var hxpS = new _hxpSession(iForm);

    if (skipAOORestriction) hxpS.setParameter("skipAOORestriction", "true");
    else                    hxpS.setParameter("skipAOORestriction", null);

    // Federico 11/11/09: aggiunti parametri 'getUORData4Titles' e 'xq' [EB 400]
    if (getUORData4Titles) hxpS.setParameter("lookupRifInt_getUORData4Titles", "true");
    else                   hxpS.setParameter("lookupRifInt_getUORData4Titles", null);

    if (typeof(xq) != 'undefined' && xq != null && xq.length > 0) hxpS.setParameter("lookupRifInt_xq", xq);
    else                                                          hxpS.setParameter("lookupRifInt_xq", null);

    iForm.verbo.value = "rifintlookup_response";
    iForm.target = iForm.target + 'lookup_child';

	var windowFeature = "width=620 height=520";
	if ( typeof(customSetWindowFeature) != 'undefined' )
		windowFeature = customSetWindowFeature();

    var Ajax = (isAjaxCompliant() && document.getElementById('rifIntLookupDiv') != null) ? true : false;
    if (!Ajax) {
        theIndexWindow=window.open(staticEmptyWindow, iForm.target, windowFeature);
        iForm.submit();
    }
    else {//AJAX
        // Federico 25/08/09: le '&' in fieldVal devono essere escapate [EB 118]
        iForm.lookup_fieldVal.value = replaceAll(iForm.lookup_fieldVal.value, '&', '%26');

    	//RW0054196 - fcossu - Aggiunto qext_rifint_lookup
    	var params = buildUrlForGet("", true, true, true, true) +
            "&selid=&verbo=rifintlookup_response&lookup_campi=" + iForm.lookup_campi.value +
            "&lookup_fieldVal=" + iForm.lookup_fieldVal.value + "&lookup_alias=" + iForm.lookup_alias.value +
            "&qord=" + iForm.qord.value +
            ((typeof(iForm['qext_rifint_lookup']) != 'undefined' && iForm['qext_rifint_lookup'].value.length > 0) ? ("&qext_rifint_lookup=" + iForm['qext_rifint_lookup'].value) : "")
            + "&transformJava=ajax" +
            // Federico 08/07/09: aggiunto parametro 'toDo' [M 0000498]
            "&toDo=" + iForm.toDo.value;

        if (!busyLookup) {
            setLastFieldsUsed(iForm.lookup_campi.value);
            busyLookup = true;
            jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleFirstLookup, errorHandler, null);
        }
    }

    getForm('hxpForm').target = old_target;
    getForm('hxpForm').verbo.value = old_verbo;
    getForm('hxpForm').selid.value = old_selid;
    return false;
}

/* nel caso di onblur all'uscita del lookup occorre impostare il nuovo default (rifintlookup.js) */
var nodeToSetDefault = null;

// Federico 08/07/09: aggiunto parametro 'skipAOORestriction' per evitare la restrizione alla AOO nel lookup [M 0000498]
// Federico 11/11/09: aggiunti parametri 'getUORData4Titles' e 'xq' [EB 400]
function rifintOnblurLookup(inputNode, inputName, ord, fieldType, skipAOORestriction, getUORData4Titles, xq)
{
    //alert(inputNode.value + " " + inputName + " ");

    var theForm;
    if ( getForm('theForm') != null )
        theForm = getForm('theForm');
    else
        theForm = getForm('hxpForm');

    var fieldName;
    nodeToSetDefault = inputNode;
    var _inputName = inputName;

    if ( inputName.indexOf('[$hxp_instance()]') != -1 ) { //multistanza
        var dad = inputNode.parentNode;
        var childName = dad.childNodes.item(0).name;

        if ( typeof(childName) == 'undefined' )	//bug fix temporaneo per mozilla
            childName = dad.childNodes.item(1).name;

        var instNumber = childName.substring(childName.indexOf('[') + 1, childName.indexOf(']'));
        _inputName = inputName.replace('$hxp_instance()', instNumber);

        if ( fieldType == 'nome_uff' )
            input2Name = _inputName.slice(0, -8) + 'nome_persona';
        else
            input2Name = _inputName.slice(0, -12) + 'nome_uff';
    }
    else {
        if ( fieldType == 'nome_uff' )
            input2Name = inputName.slice(0, -8) + 'nome_persona';
        else
            input2Name = inputName.slice(0, -12) + 'nome_uff';
    }

    if ( inputNode.value.length == 0 ) { //svuotare i due campi del lookup
        if (fieldType == 'nome_uff')
            for ( var j = 0; j < theForm.length; j++ ){	//cancello campi di lookup (operazione molto costosa)
                if ( theForm[j].name == _inputName ) {
                    theForm[j].value = "";
                }
                if ( theForm[j].name == input2Name ) {
                    theForm[j].value = "";
                }
            }
    }
    else{
        if ( inputNode.value != inputNode.defaultValue )
            rifintLookup(inputNode, inputName, ord, fieldType, skipAOORestriction, getUORData4Titles, xq);
    }
}

function newRPAForSel() {
    var kl = getForm('hxpForm').klRac.value;
    var tot;
    if (kl.length > 0) {
        tot = contaDocumentiRaccolti(kl);
    }
    var f = tot == 1? "o" : "i";
    if (!confirm("Confermare trasferimento di " + tot + " document" + f + "?"))
        return false;

    var xv = "";
    if (getForm('hxpForm').dbTable.value != '@raccoglitore') {
        if (!confirm("Per i documenti tra uffici trasferire l'originale?\n'OK' per trasferire l'orignale.\n'Annulla' per trasfeirire la minuta"))
            xv = "RPAM"
    }

    getForm('hxpForm').verbo.value = "rifint_response";
    getForm('hxpForm').xverb.value = "@trasferisciSel" + xv;
    getForm('hxpForm').submit();

    return false;
}

// Federico 15/04/08: assegnazione CC a una selezione di documenti [RW 0051093]
function newCCForSel() {
    var kl = getForm('hxpForm').klRac.value;
    var tot;

    if (kl.length > 0) {
        tot = contaDocumentiRaccolti(kl);
    }

    var f = tot == 1? "o" : "i";

    if (!confirm("Confermare l'assegnazione dei CC a " + tot + " document" + f + "?"))
        return false;

    getForm('hxpForm').verbo.value = "rifint_response";
    getForm('hxpForm').xverb.value = "@assegnaCCSel";
    getForm('hxpForm').submit();

    return false;
}

function newRPAForSelFasc() {
    var kl = getForm('hxpForm').klRac.value;
    var tot;
    if (kl.length > 0) {
        tot = contaDocumentiRaccolti(kl);
    }
    var f = tot == 1? "o" : "i";
    if (!confirm("Confermare trasferimento di " + tot + " fascicol" + f + "?"))
        return false;

    getForm('hxpForm').verbo.value = "rifint_response";
    getForm('hxpForm').xverb.value = "@TRASF_SEL";
    getForm('hxpForm').dbTable.value = "@fascicolo";
    getForm('hxpForm').submit();

    return false;
}

function contaDocumentiRaccolti(kl) {
    var separator = "}{";
    var count = 0;
    var index = 0;
    while ((index=kl.indexOf(separator, index)) != -1) {
        count++;
        index++;
    }
    return count / 2;
}


//AJAX
var busyLookup = false;
var lastFieldsUsed = '';
var selectToHideListRifInt = null;

function hideSelectRifInt() {
    if (selectToHideListRifInt == null) {
        selectToHideListRifInt = new Array();
        var els = document.getElementsByTagName('select');
        for (var i=0; i<els.length; i++) {
            els[i].style.display = 'none';
            selectToHideListRifInt[i] = els[i];
        }
    }
}

function showSelectRifInt() {
    if (selectToHideListRifInt != null) {
        for (var i=0; i<selectToHideListRifInt.length; i++)
            selectToHideListRifInt[i].style.display = '';
    }
}

function resetLookupVarsRifInt() {
    busyLookup = false;
    lastFieldsUsed = '';
    showSelectRifInt();
    selectToHideListRifInt = null;
    lookupInAtto = false;
}

function setLastFieldsUsed(fields) {
    lastFieldsUsed = fields;
}

function emptyFields() {
    var fieldsArr = lastFieldsUsed.split('|');
    for (var i=0; i<fieldsArr.length; i++)
        try {
            getElementByName(fieldsArr[i]).value = '';
        }
        catch (error) {
        }
    lookupInAtto = false;
}

function errorHandler(message) {
    // Federico 11/11/09: introdotta chiamata a una funzione per notifica di errore nel lookup [EB 400]
    if (typeof(lookupErrorOccurred) != 'undefined') lookupErrorOccurred();

    alert("Si  verificato un errore: " + message);
    stopModalWindow(true);
    emptyFields();
    resetLookupVarsRifInt();
}

function handleFirstLookup(text, requester) {
//alert(replaceAll(text,'\n',' '));
    var xml = jsXML.parseXMLDocument(text);

    var titoli = xml.selectNodes('/response/titolo');
    var lookup_alias = xml.selectSingleNode('/response/@lookup_alias').text;
    var campi = xml.selectSingleNode('/response/@lookup_campi').text;
    var count = xml.selectSingleNode('/response/@count').text;
    var login = xml.selectSingleNode('/response/@login').text;

	//RW005416 - fcossu
	var qextRifintLookup = ((typeof(hxpForm['qext_rifint_lookup']) != 'undefined' && hxpForm['qext_rifint_lookup'].value.length > 0) ? hxpForm['qext_rifint_lookup'].value : null);


    if (count == 0) {
        alert("Nessun valore trovato");
        emptyFields();
        resetLookupVarsRifInt();
    }
    else if (count == 1) {//lookup ha individuato un solo elemento
        var fieldVal = getFieldValInfoForSecondLookup(titoli, 0, lookup_alias);
        if (fieldVal != null && qextRifintLookup == null)
            doSecondLookup(fieldVal, lookup_alias, campi, login);
        else
            fillFields(getFieldsWithVal(titoli[0]));
    }
    else { //piu' elementi trovati

        emptyAndCloseContainer();

        var fdiv = document.getElementById('rifIntLookupDiv');
        fdiv.style.display = '';
        hideSelectRifInt();
        Drag.init(fdiv);
        Drag.centerDiv(fdiv);
        startModalWindow(true);

        var campoPos = lookup_alias == 'persint_nomcogn'? 1 : 0;
        var container = document.getElementById('rifIntLookupDivContainer');
        container.style.display = 'none';

        var container1 = container.cloneNode(false);
        container1.style.display = '';
        container1.setAttribute('id', 'rifIntLookupDivContainer1');
        container.parentNode.appendChild(container1);

        //titoli
        for (var i=0; i<titoli.length; i++) {
            var fieldVal = getFieldValInfoForSecondLookup(titoli, i, lookup_alias);
			//anchor - selezione
            var cloned = container.cloneNode(true);
            cloned.removeAttribute('id');
            cloned.style.display = '';

            var anchor = getAnchorInElementRifInt(cloned);
            anchor.removeAttribute('id');

			var click;
            //RW005416 - fcossu
            if (fieldVal == null || qextRifintLookup != null)
                click = "emptyAndCloseContainer(); stopModalWindow(true); return fillFields('" + jsXML.toJsParam(getFieldsWithVal(titoli[i])) + "')";
            else
                click = "emptyAndCloseContainer();return doSecondLookup('" + jsXML.toJsParam(fieldVal) + "','" +
                        jsXML.toJsParam(lookup_alias) + "','" + jsXML.toJsParam(campi) + "')";

            try {// IE non gradisce setAttribute()...
                anchor.attachEvent('onclick', new Function(click));
            }
            catch(err) {
                anchor.setAttribute('onclick', click);
            }

            // Federico 14/10/09: se l'attributo 'testo' risulta valorizzato,  bene usarlo come titolo al posto di uno dei campi [EB 111]
            var txt;
            var testo = titoli[i].getAttribute("testo");

            if (testo.length > 0) {
                txt = document.createTextNode(testo);
            }
            else {
                txt = document.createTextNode(titoli[i].selectNodes('campo')[campoPos].text);
            }

            anchor.appendChild(txt);

            addElToContainerRifInt(container1, cloned);
        }

        //pulsanti
        addAnchor('rifIntLookupFirstPage', getFirstClickParams(xml)); //anchor - first
        addAnchor('rifIntLookupPrevPage', getPrevClickParams(xml)); //anchor - prev
        addAnchor('rifIntLookupNextPage', getNextClickParams(xml)); //anchor - next
        addAnchor('rifIntLookupLastPage', getLastClickParams(xml)); //anchor - last
        addAnchor('rifIntLookupClose', "_CLOSE_"); //anchor - close

        //campi extra
        addValueText('rifIntLookupCount', count);
        addValueText('rifIntLookupCurrPage', getCurrentPageNumber(xml));
        addValueText('rifIntLookupNumPages', getNumberOfPages(xml));

//alert(container.innerHTML);
    }

    busyLookup = false;
}

function addElToContainerRifInt(container, cloned) {
    var els = cloned.childNodes;
    for (var i=0; i<els.length; i++)
        if (els[i].nodeType != document.TEXT_NODE)
            container.appendChild(els[i]);
}

function getAnchorInElementRifInt(el) {
    if (el.tagName == 'A' || el.tagName == 'a')
        return el;
    var l = el.childNodes;
    for (var i = 0; i < l.length; i++)
        if (l[i].nodeType != document.TEXT_NODE)
            return getAnchorInElementRifInt(l[i]);
}

function getNumberOfPages(xml) {
    var count = parseInt(xml.selectSingleNode('/response/@count').text);
    var pageCount = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    return Math.floor((count + pageCount - 1) / pageCount)
}

function getCurrentPageNumber(xml) {
    var pos = parseInt(xml.selectSingleNode('/response/@pos').text);
    var pageCount = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    return Math.floor(pos / pageCount + 1);
}

function addValueText(id, val) {
    var el = document.getElementById(id);
    if (el != null) {
        var childs = el.childNodes;
        for (var i=0; i<childs.length; i++) {
            childs[i].parentNode.removeChild(childs[i]);
        }
        el.appendChild(document.createTextNode(val));
    }
}

function addAnchor(id, params) {
    var oldAnchor = document.getElementById(id + "_cloned");
    if (oldAnchor != null)
        oldAnchor.parentNode.removeChild(oldAnchor);

    var anchor = document.getElementById(id);
    if (anchor != null) {
        anchor.style.display = 'none';
        if (params != null) {
            var cloned = anchor.cloneNode(true);
            cloned.setAttribute('id', id + "_cloned");
            anchor.parentNode.insertBefore(cloned, anchor);
            cloned.style.display = '';

            var click;
            if (params == "_CLOSE_") {
                emptyFields();
                click = 'stopModalWindow(true); resetLookupVarsRifInt(); return emptyAndCloseContainer()';
            }
            else
                click = "return doAjaxReq('" + jsXML.toJsParam(params) + "');";
            try {// IE non gradisce setAttribute()...
                cloned.attachEvent('onclick', new Function(click));
            }
            catch(err) {
                cloned.setAttribute('onclick', click);
            }
        }
    }
}

function emptyAndCloseContainer() {
    document.getElementById('rifIntLookupDiv').style.display = 'none';
    var container1 = document.getElementById('rifIntLookupDivContainer1');
    if (container1 != null)
        container1.parentNode.removeChild(container1);
//alert(document.getElementById('rifIntLookupDiv').innerHTML)
}

function getStandardLookupParams(xml) {
    var params = buildUrlForGet("", true, true, true, true) +
    "&verbo=rifintlookup_response&lookup_campi=" + xml.selectSingleNode('/response/@lookup_campi').text +
    "&lookup_fieldVal=" + xml.selectSingleNode('/response/@lookup_fieldVal').text +
    "&lookup_alias=" + xml.selectSingleNode('/response/@lookup_alias').text +
    "&qord=" + xml.selectSingleNode('/response/@qord').text +
    "&selid=" + xml.selectSingleNode('/response/@selid').text + "&count=" + xml.selectSingleNode('/response/@count').text +
    "&transformJava=ajax" +
    // Federico 08/07/09: aggiunto parametro 'toDo' [M 0000498]
    (xml.selectSingleNode('/response/@toDo') != null
        ? "&toDo=" + xml.selectSingleNode('/response/@toDo').text
        : "");

    return params;
}

function getFirstClickParams(xml) {
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    if (posizioneAttuale == 0)
        return null;
    return getStandardLookupParams(xml) + "&pos=0";
}

function getPrevClickParams(xml) {
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    if (posizioneAttuale == 0)
        return null;
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    var pos = (posizioneAttuale - perPagina < 0 ) ? 0 : posizioneAttuale - perPagina;
    return getStandardLookupParams(xml) + "&pos=" + pos;
}

function getNextClickParams(xml) {
    var totaleSelezionati = parseInt(xml.selectSingleNode('/response/@count').text);
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    if ( totaleSelezionati <= posizioneAttuale + perPagina )
        return null;
    var pos = posizioneAttuale + perPagina;
    return getStandardLookupParams(xml) + "&pos=" + pos;
}

function getLastClickParams(xml) {
    var totaleSelezionati = parseInt(xml.selectSingleNode('/response/@count').text);
    var posizioneAttuale = parseInt(xml.selectSingleNode('/response/@pos').text);
    var perPagina = parseInt(xml.selectSingleNode('/response/@pageCount').text);
    if ( totaleSelezionati <= posizioneAttuale + perPagina )
        return null;
    var pos = Math.floor((totaleSelezionati - 1) / perPagina) * perPagina;
    return getStandardLookupParams(xml) + "&pos=" + pos;
}

function doAjaxReq(params) {
    if (!busyLookup) {
//alert(params);
        busyLookup = true;
        jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleFirstLookup, errorHandler, null);
    }
    return false;
}

function doSecondLookup(fieldVal, lookup_alias, lookup_campi, login) {
    var xverb;
    var alias;
    if (lookup_alias == 'persint_nomcogn') {
        xverb = '@search_uff';
        alias = 'struint_nome';
    }
    else if (lookup_alias.indexOf('struint_nome') == 0) {
    	xverb = '@search_persona';
        alias = 'persint_nomcognom';
    }

    // Federico 25/08/09: le '&' in fieldVal devono essere escapate [EB 118]
    fieldVal = replaceAll(fieldVal, '&', '%26');

    var params = buildUrlForGet("", true, true, true, true) +
                 "&selid=&verbo=rifintlookup_response&xverb=" + xverb +
                 "&lookup_campi=" + lookup_campi +
                 "&lookup_fieldVal=" + fieldVal +
                 "&lookup_alias=" + alias +
                 "&transformJava=ajax" +
                 // Federico 08/07/09: aggiunto parametro 'toDo' [M 0000498]
                 "&toDo=" + getForm('hxpForm').toDo.value;
//alert(params);
    jsXML.sendAsyncPost(getForm('hxpForm').uri.value, params, handleSecondLookup, errorHandler, null);
}

function getFieldValInfoForSecondLookup(titoli, titlePos, lookup_alias) {
    // Federico 07/07/09: ad 'extra' e' stato accodato il codice ufficio/persona (destinatari
    // interni interoperabilita' con i ws) [M 0000498]
    var extra     = titoli[titlePos].getAttribute('extra');
    var realExtra = '';
    var sepPos;

    if ((sepPos = extra.indexOf('|')) != -1) {
        realExtra = extra.substring(0, sepPos);
    }
    else {
        realExtra = extra;
    }

    if (realExtra.length == 0) return null;

    if (lookup_alias == 'persint_nomcogn') {
        return extra + "|" + titoli[titlePos].selectNodes('campo')[1].text;
    }
    else if (lookup_alias.indexOf('struint_nome') == 0) {
        return titoli[titlePos].selectNodes('campo')[0].text + "|" + extra;
    }
    return "";
}

function handleSecondLookup(text, requester) {
    stopModalWindow(true);
    var xml = jsXML.parseXMLDocument(text);
//alert(replaceAll(text,'\n',' '));
    var els = xml.selectSingleNode("/response/titolo");
    if (els == null) {
        resetLookupVarsRifInt();
        alert("Nessuna persona trovata");
        emptyFields();

        // Federico 11/11/09: introdotta chiamata a una funzione per notifica del completamento del lookup [EB 400]
        if (typeof(doneWithSecondLookup) != 'undefined') doneWithSecondLookup();

        return;
    }
    var campi = els.selectNodes('campo');
    var nome, val;
    for (var i=0; i<campi.length; i++) {
        nome = campi[i].getAttribute('nome');
        try {
            var val = campi[i].text;
            getElementByName(nome).value = val;
            //fcossu 25/05/2010 Problema nella scelta della persona [EB 734]
            getElementByName(nome).defaultValue = val;
        }
        catch (error) {
        }
    }
    resetLookupVarsRifInt();

    // Federico 15/12/08: introdotta chiamata a una funzione per notifica del completamento del lookup [RW 0053076]
    if (typeof(doneWithSecondLookup) != 'undefined') doneWithSecondLookup(campi);
}

function fillFields(campi) {
//alert(campi);
    var arr = campi.split('|');
    var riga;
    var index;
    for (var i=0; i<arr.length; i++) {
        riga = arr[i];
        index = riga.indexOf('=');
        try {
            getElementByName(riga.substring(0, index)).value = riga.substring(index + 1);
        }
        catch (error) {
        }
    }
    resetLookupVarsRifInt();

    // Federico 15/12/08: introdotta chiamata a una funzione per notifica del completamento del lookup [RW 0053076]
    if (typeof(doneWithLookupFillFields) != 'undefined') doneWithLookupFillFields(campi);
}

function getFieldsWithVal(els) {
    var ret = '';
    var campi = els.selectNodes('campo');
    for (var i=0; i<campi.length; i++)
        ret += campi[i].getAttribute('nome') + "=" + campi[i].text + "|";
    return ret;
}