/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* rifintlookup.js */

var fieldsArray = new Array;

var toSetFocus = true;
var rl_operation = "";

var oneSkipPage = false;

function loadHandler()
{
    if (!oneSkipPage)
        startModalWindow();

	this.focus(); //SOLO PAGLIATIVO --> rimane effetto flickering di finestra
	if ( typeof(getForm('theForm').lookup) != 'undefined' )
		setRadio(getForm('hxpForm').keylist.value);
}


function unloadHandler(){
    if (rl_operation != "NOCLOSE") {
        stopModalWindow();

        // Federico 02/01/07: il focus sull'input sorgente deve essere impostato solo se 'rl_operation != "NOCLOSE"',
        // se no, premendo per es. il pulsante "Successivo", il lookup va in loop con IE! [RW 0041464]
        if (toSetFocus == true && opener.nodeToSetDefault != null)
    		opener.nodeToSetDefault.focus();

        opener.lookupInAtto = false;

        if (opener.confirmClicked) opener.confirmRifInt();
    }
}


function closeLookup()
{
    // Federico 14/10/09: introdotta chiamata a 'opener.customRifIntCloseLookup' [EB 111]
    if (typeof(opener.customRifIntCloseLookup) != 'undefined') opener.customRifIntCloseLookup();

    // Federico 03/01/07: forzata chiamata a 'stopModalWindow' perche' con certi IE non viene invocato 'unloadHandler'
    // dopo la chiusura della finestra [RW 0041464]
    stopModalWindow();
    opener.confirmClicked = false;
	self.close();
	return false;
}

function paginaPrecedente(posizioneAttuale,perPagina)
{
    rl_operation = "NOCLOSE";
	if (posizioneAttuale > 0 ) {
		getForm('hxpForm').verbo.value = 'rifintlookup_response';
		getForm('hxpForm').pos.value = (posizioneAttuale - perPagina < 0 ) ? 0 : posizioneAttuale - perPagina;
		sendRequest();
	}
	return false;
}

function paginaSuccessiva(posizioneAttuale,perPagina,totaleSelezionati)
{
    rl_operation = "NOCLOSE";
	if ( totaleSelezionati > posizioneAttuale + perPagina ) {
		getForm('hxpForm').verbo.value = 'rifintlookup_response';
		getForm('hxpForm').pos.value = posizioneAttuale + perPagina;
		sendRequest();
	}
	return false;
}

function primaPagina(posizioneAttuale)
{
    rl_operation = "NOCLOSE";
	if ( posizioneAttuale > 0 ) {
		getForm('hxpForm').verbo.value = 'rifintlookup_response';
		getForm('hxpForm').pos.value = 0;
		sendRequest();
	}
	return false;
}

function ultimaPagina(posizioneAttuale,perPagina,totaleSelezionati){
    rl_operation = "NOCLOSE";
	if ( totaleSelezionati > posizioneAttuale + perPagina ) {
		getForm('hxpForm').verbo.value = 'rifintlookup_response';
		getForm('hxpForm').pos.value = Math.floor((totaleSelezionati - 1) / perPagina) * perPagina;
		sendRequest();
	}
	return false;
}

function radioSele(theRadio, evento)
{
	getForm('hxpForm').keylist.value = theRadio.value;
}

function setRadio(radioValue)
{
	for ( var index = 0; index < getForm('theForm').lookup.length; index++ )
   	if ( getForm('theForm').lookup[index].value == radioValue )
			getForm('theForm').lookup[index].checked = true;
	fieldsArray = getForm('hxpForm').selected_campi.value.split(",");
 }

function sendRequest()
{
	getForm('hxpForm').selected_campi.value = fieldsArray.toString();
	getForm('hxpForm').submit();
	return false;
}

function setFields()
{
    oneSkipPage = true;
	for ( var i = 0; i < arguments.length ;i++ ){
		fieldsArray[i] = (arguments[i]);
		//alert(arguments[i]);
		}
}

function confirmLookup()
{
    // Federico 03/01/07: forzata chiamata a 'stopModalWindow' perche' con certi IE non viene invocato 'unloadHandler'
    // dopo la chiusura della finestra [RW 0041464]
    stopModalWindow();
    OpenWaitMsg();
    var htmlField, xmlVal, v;

    var theForm;
    if ( opener.getForm('theForm') != null)
        theForm = opener.getForm('theForm');
    else
        theForm = opener.getForm('hxpForm');

    for ( var i = 1 ; i < fieldsArray.length; i++ ) { //parto da 1 perch in posizione 0 c' il valore extra
        v = fieldsArray[i].split("=");
        htmlField = v[0];
        xmlVal = v[1];

        if ( opener.dad == null ) { 	//no multistanza (solo su explorer)
            // Federico 08/07/09: aggiunto test " && typeof(theForm[htmlField]) != 'undefined'" per evitare ignoti errori js [M 0000498]
            if ( htmlField != '' && typeof(theForm[htmlField]) != 'undefined') { //non so il motivo ma se non si seleziona nulla htmlField contiene ''
                theForm[htmlField].value = xmlVal;
                theForm[htmlField].defaultValue = xmlVal;	//SPERIMENTALE
            }
        }
        else { //multistanza
            for ( var j = 0; j < theForm.length; j++ )
                if ( theForm[j].name == htmlField ) {
                    theForm[j].value = xmlVal;
                    theForm[j].defaultValue = xmlVal; //SPERIMENTALE
                    break;
                }
                /*	var el = openerGetElementByName(htmlField, 'input');
                 el.value = xmlVal;
                 el.defaultValue = xmlVal; //SPERIMENTALE*/
        }
        if ( opener.nodeToSetDefault != null ) {//vedi onblurLookup
            opener.nodeToSetDefault.defaultValue = opener.nodeToSetDefault.value;
        }
    }
    toSetFocus = false;

    //alert(fieldsArray[0]);

    // Federico 08/07/09: ad 'extra' e' stato accodato il codice ufficio/persona (destinatari
    // interni interoperabilita' con i ws) [M 0000498]
    var realExtra = '';
    var sepPos;

    if ((sepPos = fieldsArray[0].indexOf('|')) != -1) {
        realExtra = fieldsArray[0].substring(0, sepPos);
    }
    else {
        realExtra = fieldsArray[0];
    }

    if ( getForm('hxpForm').lookup_alias.value == 'persint_nomcogn' &&
            realExtra != '' ) { //lookup su persona e nome uff vuoto -> valorizzo nome_uff
        getForm('hxpForm').lookup_fieldVal.value =  fieldsArray[0] + "|" + (fieldsArray[2].split("="))[1];
        getForm('hxpForm').xverb.value = "@search_uff";
        getForm('hxpForm').selid.value = "";
        getForm('hxpForm').verbo.value = "rifintlookup_response";
        getForm('hxpForm').lookup_alias.value	= "struint_nome";
        getForm('hxpForm').submit();
    }
    else if ( getForm('hxpForm').lookup_alias.value.indexOf('struint_nome') == 0 &&
            realExtra != '' ) { //lookup su ufficio e nome uff vuoto -> valorizzo nome_persona
        getForm('hxpForm').xverb.value = "@search_persona";
        getForm('hxpForm').selid.value = "";
        getForm('hxpForm').verbo.value = "rifintlookup_response";
        getForm('hxpForm').lookup_fieldVal.value = (fieldsArray[1].split("="))[1] + "|" +  fieldsArray[0];
        getForm('hxpForm').lookup_alias.value	= "persint_nomcogn";
        getForm('hxpForm').submit();
    }
    else
        self.close();

    // Federico 15/12/08: introdotta chiamata a una funzione per notifica del completamento del lookup [RW 0053076]
    if (typeof(opener.doneWithConfirmLookup) != 'undefined') opener.doneWithConfirmLookup(fieldsArray);

    return false;
}

function openerGetElementByName(name,tagName)
{
	if ("undefined" == typeof(tagName)) tagName = "input";
	var elements = opener.document.getElementsByTagName(tagName);

	for (var i = 0; i < elements.length; i++ )
		if ( elements[i].name == name )
			return elements[i];

	return null;
}
