/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
function showthesRel(rel, keypath, startkey, nome)
{
    i_operation = 'NOCLOSE';  
	if ( nome.length > 0 ) { //valorizzato se si sta risalendo nella vista gerarchica (occorre modificare il valore creato)
		var cpath = getForm('hxpForm').cPath.value;
		
		/* Codice aggiunto da Federico il 05/10/2004: gestione del pulsante 'back' del thesauro gerarchico.
		 * La consultazione di un thesaurus pu avvenire anche per navigazione a partire da un certo nodo
		 * (non necessariamente il primo).
		 * Questo significa che il pulsante back posto sul nodo di ingresso non deve passare al nodo padre ma
		 * deve fermarsi o andare ad un link impostato dal chiamante.
		 * Il parametro 'hxpForm.thBackPage' contiene l'url a cui tornare e lo start point del thesauro nella
		 * seguente forma: "url!startPoint".  
		 * Se url  vuoto, il pulsante back si ferma sul nodo di partenza.
		 */ 
		if ( getForm('hxpForm').thBackPage.value != '' ) {
			var thBackPage = getForm('hxpForm').thBackPage.value;
			var backToUrl = thBackPage.substring(0, thBackPage.indexOf("!"));
			var startPoint = thBackPage.substring(thBackPage.indexOf("!") + 1);
			
			if ( startPoint == cpath ) {
				if ( backToUrl != "" ) {
					/* se l'url non comincia con 'http://', occorre aggiungere tale dicitura all'inizio
					 * affinch la pagina si apra correttamente.
					 */
					if ( backToUrl.indexOf("http://") == -1 ) {
						backToUrl = "http://" + backToUrl;
					}
					
					window.location = backToUrl;
				}
				
				return false; 	
			}
		}
		// fine gestione del pulsante 'back' del thesauro gerarchico.
		
		cpath = cpath.substring(0, cpath.lastIndexOf("|"));
		cpath = cpath.substring(0, cpath.lastIndexOf("|"));
		getForm('hxpForm').cPath.value = cpath;
	}

	getForm('hxpForm').verbo.value = "showthes";
	getForm('hxpForm').xverb.value = "@" + rel;

	if ( typeof(customSetForm4ShowthesRel) != 'undefined' )
		customSetForm4ShowthesRel(rel, keypath, startkey);
	else {
		if ( getForm('hxpForm').keypath.value == '' ) //vince il keypath corrente su quello specificato nel template
			getForm('hxpForm').keypath.value = keypath;
		getForm('hxpForm').relation.value = rel;
		getForm('hxpForm').startkey.value = (startkey == '') ? 'Radice' : startkey;
	}

	getForm('hxpForm').submit();

	return false;
}


function loadHandler()
{
	thesLoadHandler();
	
	//DD 29/01/06 Valorizza tutti gli attributi title delle immagini 
   setAllImgTitlesFromAlt();   
}


function thesLoadHandler()
{	
    /* Federico 15/04/2005: probabilmente in qualche file js specifico (tipo 'thes_funzioni_aggiuntive.js'
     * di XSpring) viene effettuata una 'setGlobalFormRestore(...)' per la gestione del tasto back.
     */ 
    restoreTuple();
    
    // titolo thesauro gerarchico
	/* Modifica di Federico del 06/10/2004.
	 * E' stato aggiunto il test opener != null poich in Opera e Mozilla opener  null quando non si apre
	 * una nuova finestra per il thesauro.
	 */
	if (typeof(opener) != 'undefined' && opener != null && typeof(opener.thesTitle) != 'undefined' ) {
		document.title = opener.thesTitle;
		//var ele = document.getElementById('thsTitle');
		//ele.innerHTML = opener.thesTitle; 
	}

	if ( typeof(customLoadHandler) != 'undefined' )
		customLoadHandler();
	if ( getForm('hxpForm').toDo.value == "_CLOSE_" ) {	
/*		if ( typeof(opener) == 'undefined' )
			commitQuery(getForm('hxpForm').startkey.value, getForm('hxpForm').xMode.value);
		else*/ //questo caso commentato viene realizzato a livello di Java per evitare doppia submit
			commit('');
	}
}


function commit(lastSelection)
{
	if ( typeof(customCommit) != 'undefined' )
		return customCommit(lastSelection);
	
	var field = opener.thesField;
	if ( opener.thesDad == null ) { 	//no multistanza
			opener.getForm('hxpForm')[field].value = getForm('hxpForm').cPath.value;
	}
	else { //multistanza
		for ( var j = 0; j < opener.getForm('hxpForm').length; j++ )
			if ( opener.getForm('hxpForm')[j].name == field ) {
				opener.getForm('hxpForm')[j].value = getForm('hxpForm').cPath.value;
				break;
			}
	}	
	
	self.close();
	return false; //per ora e' indispensabile la funzione custom
}


function nuovaRicerca()
{
	getForm('hxpForm').verbo.value='query';
	getForm('hxpForm').dbTable.value='';
	getForm('hxpForm').query.value='';
 	getForm('hxpForm').xverb.value='';
	getForm('hxpForm').xMode.value = '';
 	getForm('hxpForm').submit();
 	return false;
}


function commitQuery(val, alias)
{	
	var qext = getForm('hxpForm').qext.value; 
	
	getForm('hxpForm').query.value = "[" +  alias + "]=\"" +  val + "\"";
	if ( qext.length > 0 )
		getForm('hxpForm').query.value = qext + "(" + getForm('hxpForm').query.value + ")";
	
	
	if ( typeof(customCommitQuery) != 'undefined' ) {
		if ( typeof(getForm('hxpForm').xMode) != 'undefined' )
			customCommitQuery(val, alias, qext, getForm('hxpForm').xMode.value);
		else 
			customCommitQuery(val, alias, qext);
	}

	getForm('hxpForm').toDo.value = '';
	getForm('hxpForm').selid.value = '';
	getForm('hxpForm').verbo.value = 'queryplain';
	getForm('hxpForm').xverb.value = '';
	getForm('hxpForm').submit();
	 
	return false; //per ora e' indispensabile la funzione custom
}

/* 
 * Created on: 07/09/2004
 * by: Federico Grillini
 * organization: 3D Informatica
 * description: Funzione di posizionamento delle molliche. Ogni volta che si clicca su un elemento
 * 				della mollica del thesauro gerarchico, viene invocata questa funzione con la posizione
 * 				dell'elemento selezionato. Una volta aggiornata la tupla cPath, viene effettuato un submit
 * 				per posizionare il thesauro nel nodo richiesto dall'utente.
 */
function goBackN(nodo)
{
	//alert("Goto nodo: " + nodo);
	var lastPipe = 1;
	var path = getForm('hxpForm').cPath.value;
	
	// posizionamento sullo slash dell'ultimo nodo da mantenere.
	for (var i = 0; i <= nodo; i++) {
		lastPipe = path.indexOf("|", lastPipe + 1);
	}
	
	path = path.substring(0, lastPipe);
	getForm('hxpForm').cPath.value = path.substring(0, path.lastIndexOf("|"));
	
	//alert("rel: " + getForm('hxpForm').relation.value + " cPath: " + getForm('hxpForm').cPath.value + " startKey: " + path.substring(path.lastIndexOf("|") + 1));
	
	return showthesRel(getForm('hxpForm').relation.value, '', path.substring(path.lastIndexOf("|") + 1), '');
}

function customPrintClassif(val)
{
    /* DD 13/02/2006 (RW: 0033152) */
    if(getClassifFormat() != null){
        return formatClassif(val);        
    }
    retVal = arab2roman(val.substring(0, 2));

    val = val.substring(3);
    var arr = val.split('/');
    for (var i=0; i<arr.length; i++) {
        val = arr[i];
        var noZero = val.charAt(0)== "0" ? val.substring(1) : val; 
        retVal = retVal + '/' + noZero;
    }

    return retVal;
}

/*
 *	DD 27/01/2006 Assegna la classificazione passata (dopo click in viualizzazione gerarchica del titolario) 
 *	al documento correntemente in inserimento, e chiude la finestra. (RW:33793)
 */
function assignClassifAndClose(classif_cod, classif)
{	
	var label = classif_cod + " - " + classif;	
	opener.getForm('hxpForm')['.classif'].value = label;
	opener.getForm('hxpForm')['.classif.@cod'].value = classif_cod;		
	opener.document.getElementById('classif_ro').innerHTML = customPrintClassif(label);
	opener.document.getElementById('mod_classif').innerHTML = "";
	if ("undefined" != typeof(opener.getForm('hxpForm')['.voce_indice'])){
		opener.getForm('hxpForm')['.voce_indice'].value = '';
	}
	
	self.close();	
}