/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* thesauro.js */

var fieldsArray = '';
var toSetFocus = true;
var operation = '';
var oneSkipPage = false;

function loadHandler()
{
        if (!oneSkipPage) {
                startModalWindow();
        } 
    
	// titolo thesauro vincolato
        if ( typeof(customThesTitle) != 'undefined' ) {
        }
        else {
                if (typeof(opener) != 'undefined' && typeof(opener.thesTitle) != 'undefined' ) {
                        document.title = opener.thesTitle;
                }
        }

	if ( typeof(getForm('theForm').lookup) != 'undefined' ) {
		setRadio(getForm('hxpForm').keylist.value);
        }
	
	operation = '';
	
	/* Modifica di Federico del 15/10/2004:
	 * al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
	 * radio button nel thesauro vincolato (si veda anomalia 0022367).
	 * Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
	 * che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
	 * (possibili usi futuri).
	 */
	if ( getForm('hxpForm').thVOptions.value == "useChkBox" ) {
		checkList(getForm('theForm'), getForm('hxpForm').keylist.value);
        }
}

function unloadHandler()
{
    if (operation != "NOCLOSE")
        stopModalWindow(); 
	if ( toSetFocus == true )
		if ( opener.thNodeToSetDefault != null && operation != "NOCLOSE" )
			opener.thNodeToSetDefault.focus();
}


function closeLookup()
{
	self.close();
	return false;
}

function paginaPrecedente()
{
	operation = "NOCLOSE";
	getForm('hxpForm').xverb.value = "@prev";
	sendRequest();
	return false;
}
 
function paginaSuccessiva()
{
	operation = "NOCLOSE";	
	getForm('hxpForm').xverb.value = "@next";
	sendRequest();
	return false;
}

function radioSele(theRadio, evento)
{
	getForm('hxpForm').keylist.value = theRadio.value;
}

function setRadio(radioValue)
{
	for ( var index = 0; index < getForm('theForm').lookup.length; index++ ) {
                if ( getForm('theForm').lookup[index].value == radioValue ) {
                        getForm('theForm').lookup[index].checked = true;
                }
        }
        // Gregorio RW 0034473 fieldsArray = getForm('hxpForm').selected_campi.value.split(',');	
        fieldsArray = getForm('hxpForm').selected_campi.value;       
 }

function sendRequest()
{
	getForm('hxpForm').selected_campi.value = fieldsArray;
	getForm('hxpForm').submit();
	return false;
}

function setFields(testo)
{
    oneSkipPage = true;
	fieldsArray = testo;
}

function confirmLookup()
{
        if ( typeof(customConfirmLookup) != 'undefined' ) {
                return customConfirmLookup();
        }

        var htmlField = "";
        var xmlVal = "";
        var theForm;
	
        if ( getForm('hxpForm').thVOptions.value == 'useChkBox' ) {
                var keys = getForm('hxpForm').keylist.value.split("}{");
                for ( var i = 0; i < keys.length; i++ ) {
                    if ( keys[i] != '' ) {
                        fieldsArray += "\" " + keys[i] + "\"~";
                    }
                }
                
                if (keys.length > 1) {
                    fieldsArray = fieldsArray.substring(0, fieldsArray.length - 1);
                }
        }
	
	if ( fieldsArray == '' ) {
		return false;
        }
        htmlField = fieldsArray.substr(0, fieldsArray.indexOf('='));
        xmlVal = fieldsArray.substr(fieldsArray.indexOf('=') + 1);
	self.close();
	
	if ( xmlVal.length == 0 )
		return false;
	
	theForm = opener.getForm('hxpForm')
	
	if( typeof(opener.getForm('hxpForm')[htmlField]) == 'undefined')
		theForm = opener.getForm('theForm');				

    if ( opener.dad == null )
    {
        // Non  un multistanza
        if ( htmlField != '')
        {
            if (xmlVal.indexOf("~") != -1)
                xmlVal = replaceAll(xmlVal, "~", " or ");
            
            theForm[htmlField].value = xmlVal;
            
            if ( opener.thNodeToSetDefault != null )
                theForm[htmlField].defaultValue = xmlVal;
        }
    }
    else 
    {
        // E' un multistanza
        var values = xmlVal.split("~");
        var fieldName;
        var el;

        for (var k = 0; k < values.length; k++)
            if ((values[k].charAt(0) == '\"') && (values[k].charAt(values[k].length - 1) == '\"'))
                values[k] = values[k].substring(2, values[k].length - 1);

        fieldName = ( htmlField.charAt(0) == '.' ) ? htmlField.substring(1, htmlField.indexOf('[')) : htmlField.substring(0, htmlField.indexOf('['))
        el = opener.getElementByName(htmlField, "input");

        if ( el != null )
            el.value = values[0];
        
        if ( opener.thNodeToSetDefault != null )
            if ( el != null )
                el.defaultValue = values[0];

        var HtmlFieldPre = htmlField.substring(0, htmlField.indexOf('[') + 1);
        var HtmlFieldPost = htmlField.substring(htmlField.indexOf(']'));
        var indexIstanza = 0;
        var currOfValues = 1;
        var currHtmlField;
        
        while(currOfValues < values.length)
        {
            currHtmlField = HtmlFieldPre + indexIstanza + HtmlFieldPost;
            el = opener.getElementByName(currHtmlField);
            
            if ( el == null )
            {
                opener.addInstance(fieldName);
                el = opener.getElementByName(currHtmlField);
                // Se non si riesce a creare la nuova istanza: ESCO
                if ( el == null )
                    break; 
            }

            if ( el.value == '' )
            {
                el.value = values[currOfValues];
                if ( opener.thNodeToSetDefault != null )
                    el.defaultValue = values[currOfValues];
                currOfValues++;
            }
            indexIstanza++;
        }
    }
    
    if ( opener.thNodeToSetDefault != null )
        opener.thNodeToSetDefault.defaultValue = opener.thNodeToSetDefault.value;
        
    toSetFocus = false;
    
    return false;
}

var elFound;

function visitaTree(el, name)
{
    if ( elFound != null )
        return;
    
    if ( el.name == name )
        elFound = el;

    var l = el.childNodes;
    for (var i = 0; i < l.length; i++)
        visitaTree(l.item(i), name, elFound);
}

function newTermine()
{
	var r = prompt("Inserisci un nuovo termine", "");
	if ( r == null || r.length == 0 )
		return false;
	
	getForm('hxpForm').lookup_fieldVal.value = r;
	getForm('hxpForm').xverb.value = "@new";
	sendRequest();
	return false;
}

function renameTermine()
{
	/* Modifica di Federico del 15/10/2004:
	 * al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
	 * radio button nel thesauro vincolato (si veda anomalia 0022367).
	 * Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
	 * che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
	 * (possibili usi futuri).
	 */
	if ( getForm('hxpForm').thVOptions.value == 'useChkBox' ) {
		//alert('keylist: \'' + getForm('hxpForm').keylist.value + '\'');
	
		var keys = getForm('hxpForm').keylist.value.split("}{");
		
		if ( keys.length > 3 ) {
			alert("Selezionare un solo termine da rinominare");
			
			return false;
		}
		else
			if ( keys.length == 3 )
				// il primo e il terzo termine sono stringhe vuote
				fieldsArray += keys[1];
			else {
				// nessuna voce selezionata (keys.length < 3)
				alert("Selezionare un termine da rinominare");
				
				return false;
			}
	}
	
	if ( fieldsArray != '' ) {
		
		//alert(fieldsArray);
		//alert(fieldsArray.substring(fieldsArray.indexOf("=") + 1));
		
		var r = prompt("Inserisci un nuovo nome per il termine selezionato", "");
		
		if ( r == null || r.length == 0 )
			return false;
		
		/* inserimento in "lookup_fieldVal" del nuovo e del vecchio nome
		 * secondo la seguente struttura:
		 * lookup_fieldVal="<new_val>|<old_val>"
		 */
		getForm('hxpForm').lookup_fieldVal.value = "<" + r + ">|<" + fieldsArray.substring(fieldsArray.indexOf("=") + 1) + ">";
		getForm('hxpForm').xverb.value = "@rename";
		
		//alert("lookup_fieldVal = \'" + getForm('hxpForm').lookup_fieldVal.value + "\'");

		var res;
		if ( typeof(customConfirmRenameTerm) != 'undefined' )
			res = customConfirmRenameTerm();
		if ( res == false )
			return false;
		
		sendRequest();
	}
	
	return false;
}

function removeTermine()
{	
	/* Modifica di Federico del 15/10/2004:
	 * al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
	 * radio button nel thesauro vincolato (si veda anomalia 0022367).
	 * Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
	 * che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
	 * (possibili usi futuri).
	 */
	 
	// in caso di selezione multipla occorre consentire la cancellazione di pi voci
	if ( getForm('hxpForm').thVOptions.value == 'useChkBox' ) {
		//alert('keylist: \'' + getForm('hxpForm').keylist.value + '\'');
		
		if ( getForm('hxpForm').keylist.value == '' ) {
			// nessuna voce selezionata
			alert("Selezionare uno o pi termini da cancellare");
				
			return false;
		}
	
		var keys = getForm('hxpForm').keylist.value.split("}{");
		var first = true;
		
		for ( var i = 0; i < keys.length; i++ ) {
			if ( keys[i] != '' )
				if ( first ) {
					first = false; 
					fieldsArray += keys[i];
				}
				else
					fieldsArray += " or " + keys[i];
		}
	}
	
	if ( fieldsArray != '' ) {
		operation = "NOCLOSE";
		getForm('hxpForm').xverb.value = "@remove";
		getForm('hxpForm').lookup_fieldVal.value = fieldsArray.substring(fieldsArray.indexOf("=") + 1);
		sendRequest();
	}
	return false;
}


/* Gestione posizionamento (Fede) */

function posiziona(chiavePosizionamento,nomeChiave)
 {
	//alert("chiave: " + chiavePosizionamento);
	
	if ( chiavePosizionamento == '' )
		return false;
		
  	if ( getForm('hxpForm').shwMode.value != '') // yyyymmdd
   		chiavePosizionamento = usr2XwKey(getForm('hxpForm').shwMode.value,chiavePosizionamento);

  	chiavePosizionamento = getForm('hxpForm').cPath.value + chiavePosizionamento;
  	getForm('hxpForm').startkey.value = chiavePosizionamento.toUpperCase();
  	getForm('hxpForm').keylower.value = '';
  	getForm('hxpForm').keypath.value = nomeChiave;
  	
  	var oldXVerb = getForm('hxpForm').xverb.value;
	getForm('hxpForm').xverb.value = "@seek"; 

        // Vedi segnalazione RW 0034804
        operation = "NOCLOSE";

  	thSubmit();
  	
	getForm('hxpForm').xverb.value = oldXVerb;
  	
  	return false;
 }


function PosizionamentoTermineThesauro()   {
	var TermineSuCuiPosizionarsi = prompt('Dove ti vuoi posizionare ??', '');
	if (TermineSuCuiPosizionarsi != null)   {
		if (TermineSuCuiPosizionarsi.length > 0 && TermineSuCuiPosizionarsi.split(' ').join('') != '')   {
			if (document['seek'])   {
				if (document['seek']['seektext'])   {
					document['seek']['seektext'].value = TermineSuCuiPosizionarsi;
					return posiziona(TermineSuCuiPosizionarsi, getForm('hxpForm').keypath.value);
				}
				else   {
					alert('Errore di configurazione:\rnon trovato input "seektext"');
				}
			}
			else   {
				alert('Errore di configurazione:\rnon trovata form "seek"');
			}
		}
	}
	return '';
}

 
function thSubmit()
 {
 	if ( typeof(getForm('seek').minFreq) != 'undefined' )
 		getForm('hxpForm').minFreq.value = getForm('seek').minFreq.value;
 		
  	if ( typeof(getForm('seek').maxFreq) != 'undefined' )
  		getForm('hxpForm').maxFreq.value = getForm('seek').maxFreq.value;
  		
  	if( typeof(getForm('seek').minRes) != 'undefined' ) {
  		if( getForm('seek').minRes.type == "text" )
			getForm('hxpForm').minRes.value = getForm('seek').minRes.value;
   		else
   			if( getForm('seek').minRes.type == "select-one" )
				getForm('hxpForm').minRes.value = getForm('seek').minRes.options[getForm('seek').minRes.selectedIndex].value;
  	}

  	getForm('hxpForm').submit();
 }

/* intercetta la pressione del pulsante invio nell'input text della sezione 
 * "Posizionamento" ed avvia il posizionamento. Se non ci fosse questa funzione
 * verrebbe effettuato il post del form "seek" che contiene la sezione "Posizionamento"
 * con effetti deleteri (eccezione).
 */
function submitOnEnter(event)
 {
 	var key = document.layers ? event.which : event.keyCode;

  	if ( key == 13 ) {
  		event.cancelBubble = true;
   		event.returnValue = false;
   		posiziona(getForm('seek').seektext.value,getForm('hxpForm').keypath.value);
  	}
  	
  	return key;
 }

/* Fine gestione posizionamento (Fede) */

function fillWith(s,ch,len)
 {
	while ( s.length < len )
		s = ch + s;
  	
	return s;
 }

function getDateYear(s)
 {
	s = sTrim(s);
	var pos = s.lastIndexOf('/');
  
	if ( pos < 0 )
		pos = s.lastIndexOf('-');
  		
	if ( pos < 0 )
		pos = s.lastIndexOf(' ');
  		
	return fillWith(sTrim(s.substring(pos+1)),'0',4);
 }

function getDateMonth(s)
 {
	s = sTrim(s);
	var stop = s.lastIndexOf('/');
  	
	if ( stop < 0 )
		stop = s.lastIndexOf('-');
  
	if ( stop < 0 )
		stop = s.lastIndexOf(' ');
  		
	if ( stop < 0 )
		return '00';
  		
	var start = s.lastIndexOf(s.charAt(stop),stop-1);
  	
	return fillWith(sTrim(s.substring(start+1,stop)),'0',2);
 }

function getDateDay(s)
 {	s = sTrim(s);
	var pos = s.indexOf('/');
  	
	if ( pos < 0 )
		pos = s.indexOf('-');
  	
	if ( pos < 0 )
		pos = s.indexOf(' ');
  		
	if ( pos < 0 )
		return '00';
  		
	if ( s.indexOf(s.charAt(pos),pos + 1 ) < 0 )
		return '00';
  		
	return fillWith(sTrim(s.substring(0,pos)),'0',2);
 }

function usr2XwKey(mode,key)
 {
	if ( mode == 'dt' )
		key = getDateYear(key) + getDateMonth(key) + getDateDay(key); // yyyymmdd
  
	if ( mode == 'dt1' )
		key = getDateYear(key) + ' ' + getDateMonth(key) + ' ' + getDateDay(key); // yyyy mm dd
  	
	return key;
 }
