/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/
/* 'titles_wfattivi.js' */

var hxpForm;          // form 'hxpForm'
var newWindow = null; // finestra per la visualizzazione dei documenti

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione invocata all'onload del body.
 * 
 */
function loadHandler()
{
    hxpForm = getForm("hxpForm");
    
    // svuotamento tuple critiche
    hxpForm.wfMode.value = "";
    hxpForm.selectedWfDocs.value = "";
    hxpForm.WfFunctionInteractionManagerClass.value = "";
    
    // apertura del primo ramo [RW 0040278]
    var pulsante = document.getElementById('nodeButton');
    var clic = pulsante.getAttribute('onclick').toString();
    var funct = clic.substring(clic.indexOf('hideShowChildrenBranch(') + 23, clic.lastIndexOf(')'));
    funct = replaceAll(funct, "'", "");
    funct = replaceAll(funct, "\"", "");
    var funct_vect = funct.split(",");
    
    hideShowChildrenBranch(pulsante, trim_str(funct_vect[1]));
}

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione invocata al onunload del body.
 * 
 */
function unloadHandler()
{
    // chiudo un'eventuale finestra per la visualizzazione dei doc. gia' aperta [RW 0040518]
    if (newWindow != null) {
        newWindow.close();
        newWindow = null;
    }
}

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che consente di passare alla pagina principale.
 * 
 */
function nuovaRicerca()
{
    setGlobalFormRestore('verbo','xverb','dbTable','query','selid');
    
    hxpForm.verbo.value='query';
    hxpForm.dbTable.value='';
    hxpForm.personalView.value='';
    hxpForm.query.value='';
    hxpForm.xverb.value='';
    hxpForm.selid.value='';
    
    // Federico 10/11/06: se si proviene da un'email si perdono i diritti --> se torno al menu' principale devo
    // forzare il login [RW 0040278]
    hxpS = new _hxpSession(hxpForm);
    var comingFromEmail = hxpS.getParameter("comingFromEmail");
    
    if (comingFromEmail != 'undefined' && comingFromEmail == 'true') {
        hxpS.setParameter("comingFromEmail", null);
        hxpS.setParameter("forceLogin", "true");
    }
    
    OpenWaitMsg();
    hxpForm.submit();
 
    return false;
}

/* 
 * Created on: 30/06/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Visualizzazione gerarchica dei titoli dei workflow attivi [RW 0037103].
 *               Gestisce l'apertura/chiusura degli elementi nascosti, nella visualizzazione di uno
 *               specifico albero gerarchico.
 *               Parametri:
 *              
 *               elem      = L'elemento del 'bottone' che espande/contrae un ramo. Questo contiene al suo
 *                           interno un'immagine che viene cambiata se il ramo e' aperto o chiuso. Le immagini
 *                           utilizzate al momento sono 'piu.gif' o 'meno.gif'.
 *               theId     = L'id del contenuto del ramo da aprire/chiudere.
 *               allAction = (true/false) Se passato forza l'apertura di tutta la gerarchia.
 * 
 */
function hideShowChildrenBranch(elem, theId, allAction)
{
 	// costanti: immagine + e -
 	var imgPiu = "piu.gif";
 	var imgMeno = "meno.gif";
 	var isHidden;
    
 	if (typeof(allAction) == 'undefined') {
	 	// mostro +/- a seconda dei casi
	 	var isHidden = elem.innerHTML.indexOf('/' + imgPiu) != -1;
        var nodeContent = document.getElementById("(" + theId + ")_content");
        
	  	if(isHidden) {
	  		// mostro il -
	  		elem.innerHTML = elem.innerHTML.replace(imgPiu, imgMeno);
            
            // mostro il contenuto del nodo
            nodeContent.style.display = 'block';
	  	}
        else {
	  		// mostro il +
	  		elem.innerHTML=elem.innerHTML.replace(imgMeno, imgPiu);
            
            // nascondo il contenuto del nodo
            nodeContent.style.display = 'none';
	  	}	
	}
    else {
		isHidden = allAction;
	
		// apri/chiudi tutti. Aggiorno i "+" e i "-" dei bottoni
		var elements = document.getElementsByTagName("a");
        
		for (var i = 0; i < elements.length; i++) {
			if(elements[i].id == 'nodeButton') {					
				var elem = elements[i];
                var innerHtmlStr = elem.innerHTML.toLowerCase();
                var wfNameStart = innerHtmlStr.indexOf('>', innerHtmlStr.indexOf('<span')) + 1;
                var wfNameEnd = innerHtmlStr.indexOf('</span>', wfNameStart);
                var nodeContent = document.getElementById("(" +
                                                          elem.innerHTML.substring(wfNameStart, wfNameEnd) +
                                                          ")_content");
                
				if(isHidden) {
			  		// mostro il -
			  		elem.innerHTML = elem.innerHTML.replace(imgPiu, imgMeno);
                    
			  		// mostro il contenuto del nodo
                    nodeContent.style.display = 'block';
			  	} 
                else {
			  		// mostro il +
			  		elem.innerHTML = elem.innerHTML.replace(imgMeno, imgPiu);
                    
			  		// nascondo il contenuto del nodo
                    nodeContent.style.display = 'none';
			  	}
			}		
		}
    }
		
  	return false;
}

/* 
 * Created on: 03/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione invocata all'onclick sui checkbox dei documenti con istanze attive.
 *               Quando si seleziona un checkbox di un documento di un certo current step di un flusso,
 *               i checkbox di tutti gli altri current step (dello stesso modello o di altri modelli)
 *               vengono deselezionati.
 *               Le operazioni di selezione e deselezione di un checkbox comportano l'aggiornamento della
 *               tupla 'selectedWfDocs', che contiene coppie 'nrecord|instId' separate da ','.
 *               Tali coppie rappresentano i documenti selezionati su cui deve essere avviata una action
 *               disponibile.
 * 
 */
function selectWfDoc(currChkbox, nrecord, instId)
{
    // in caso di selezione del chkbox deseleziono tutti i checkbox della pagina con id differente da quello corrente
    if (currChkbox.checked) {
        var inputs = document.getElementsByTagName("input");
    
        for (var i = 0; i < inputs.length; i++) {
            if (inputs[i].type == 'checkbox' && inputs[i].name != currChkbox.name && inputs[i].checked) {
                // deseleziono il checkbox
                inputs[i].checked = '';
                
                // rimuovo la corrispondente coppia 'nrecord|instId' dalla tupla 'selectedWfDocs'
                if (inputs[i].name != 'checkAll') removeFromSelectedWfDocs(inputs[i].value);
            }
        }
    }
    else {
        // deseleziono il checkbox --> deseleziono anche il checkbox "Tutti" [RW 0040278]
        currChkbox.parentNode.childNodes[0].checked = '';
    }
    
    // aggiorno la tupla 'selectedWfDocs'
    var selWfDocs = hxpForm.selectedWfDocs.value;
    
    if (currChkbox.checked && selWfDocs.indexOf(nrecord + '|' + instId) == -1) {
        // selezione del checkbox
        hxpForm.selectedWfDocs.value += ((selWfDocs.length > 0) ? ',' : '') + 
                                                   nrecord + '|' + instId;
    }
    else if (!currChkbox.checked && selWfDocs.indexOf(nrecord + '|' + instId) != -1) {
        // deselezione del checkbox
        removeFromSelectedWfDocs(nrecord + '|' + instId);
    }
    
    return true;
}

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che rimuove dalla tupla 'selectedWfDocs' una coppia 'nrecord|instId'.
 * 
 */
function removeFromSelectedWfDocs(couple)
{
    var docs = hxpForm.selectedWfDocs.value.split(',');
    var tmp = "";
    
    for (var j = 0; j < docs.length; j++) {
        if (docs[j] != couple) {
            tmp += ((tmp.length > 0) ? ',' : '') + docs[j];
        }
    }
    
    hxpForm.selectedWfDocs.value = tmp;
}

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che lancia un'action su un gruppo di documenti selezionati.
 *               Parametri:
 * 
 *               actionId:                          id dell'action da eseguire.
 *               divId:                             id del div del gruppo dell'action selezionata.
 *               WfFunctionInteractionManagerClass: nome della classe che gestisce le interazioni utente richieste dalle function.
 * 
 */
function doAction(actionId, divId, WfFunctionInteractionManagerClass)
{
    // almeno un checkbox del gruppo dell'action selezionata deve essere checked
    if (hxpForm.selectedWfDocs.value.length == 0 ||
            chkboxGroupNotChecked(divId)) {
        
        alert("Selezionare almeno un documento su cui pu essere eseguita l'action");
        return false;
    }
    
    setGlobalFormRestore('verbo','xverb','dbTable');
    
    hxpForm.verbo.value='workflow_activewf_manager';
    hxpForm.dbTable.value='@doWfAction';             // per la loadingbar
    hxpForm.xverb.value='@doAction|' + actionId;
    
    if (typeof(WfFunctionInteractionManagerClass) != 'undefined' && WfFunctionInteractionManagerClass != null) {
        hxpForm.WfFunctionInteractionManagerClass.value = WfFunctionInteractionManagerClass;
    }
    
    OpenWaitMsg();
    hxpForm.submit();
 
    return false;
}

/* 
 * Created on: 04/07/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che restituisce true se tutti i checkbox contenuti nel div con id 'divId' non
 *               sono stati selezionati.
 * 
 */
function chkboxGroupNotChecked(divId)
{
    var group = document.getElementById(divId);
    var chkboxes = group.getElementsByTagName("input");
    
    for (var j = 0; j < chkboxes.length; j++) {
        if (chkboxes[j].checked) return false;
    }
    
    return true;
}

/* 
 * Created on: 08/11/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che seleziona tutti i checkbox contenuti nel div con id 'divId' [RW 0040278].
 * 
 */
function selectAll(divId)
{
    var group = document.getElementById(divId);
    var chkboxes = group.getElementsByTagName("input");
    
    if (chkboxes.length > 1) {
        // deseleziono tutti i checkbox della pagina appartenenti agli altri gruppi
        var inputs = document.getElementsByTagName("input");
        var firstChkbox = chkboxes[1]; // il primo checkbox e' "Tutti"
    
        for (var i = 0; i < inputs.length; i++) {
            if (inputs[i].type == 'checkbox' && inputs[i].name != firstChkbox.name && inputs[i].checked) {
                // deseleziono il checkbox
                inputs[i].checked = '';
                
                // rimuovo la corrispondente coppia 'nrecord|instId' dalla tupla 'selectedWfDocs'
                if (inputs[i].name != 'checkAll') removeFromSelectedWfDocs(inputs[i].value);
            }
        }
        
        // selezione dei checkbox (tranne il primo che e' "Tutti")
        for (var j = 0; j < chkboxes.length; j++) {
            if (!chkboxes[j].checked) {
                chkboxes[j].checked = "checked";
                
                if (chkboxes[j].name != 'checkAll') {
                    var selWfDocs = hxpForm.selectedWfDocs.value;
                    hxpForm.selectedWfDocs.value += ((selWfDocs.length > 0) ? ',' : '') + chkboxes[j].value;
                }
            }
        }
    }
    
    return false;
}

/* 
 * Created on: 08/11/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che deseleziona tutti i checkbox contenuti nel div con id 'divId' [RW 0040278].
 * 
 */
function deselectAll(divId)
{
    var group = document.getElementById(divId);
    var chkboxes = group.getElementsByTagName("input");
    
    for (var j = 0; j < chkboxes.length; j++) {
        if (chkboxes[j].name == 'checkAll') continue; // devo saltare il checkbox "Tutti"
        
        if (chkboxes[j].checked) {
            chkboxes[j].checked = '';
            removeFromSelectedWfDocs(chkboxes[j].value);
        }
    }
    
    return false;
}

/* 
 * Created on: 09/11/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che seleziona/deseleziona tutti i checkbox contenuti nel div con id 'divId' [RW 0040278].
 *               'currChkbox' e' il checkbox "Tutti".
 * 
 */
function selectAllChkbox(currChkbox, divId)
{
    if (currChkbox.checked) {
        selectAll(divId);
    }
    else {
        deselectAll(divId);
    }
    
    return true;
}

/* 
 * Created on: 22/11/06
 * by: Federico Grillini
 * organization: 3D Informatica
 * description:  Funzione che consente di visualizzare in una nuova finestra il documento corrispondente al
 *               titolo associato [RW 0040518].
 * 
 */
function showDoc(docNrecord)
{
	if (typeof(docNrecord) == 'undefined' || docNrecord == null) {
        alert("NRecord del documento non specificato!");
        return false;
    }
    
    // chiudo un'eventuale finestra gia' aperta
    if (newWindow != null) {
        newWindow.close();
        newWindow = null;
    }
    
    var old_target = getForm('hxpForm').target;
    var old_verbo = getForm('hxpForm').verbo.value;
    var old_xverb = getForm('hxpForm').xverb.value;
    var old_selid = getForm('hxpForm').selid.value;
    var old_query = getForm('hxpForm').query.value;
    var old_cd = getForm('hxpForm')._cd.value;

    var iForm = getForm('hxpForm');
    
    iForm.verbo.value = "queryplain";
    iForm.xverb.value = "";
    iForm.target = iForm.target + 'show_doc';
    iForm.selid.value = "";
    iForm.query.value = '[docnrecord]="' + docNrecord + '"';
    
    // segnalo alla showdoc di rimuovere le funzionalita' disponibili (cosa che elimina la pulsantiera) e
    // le action disponibili per evitare che l'utente possa utilizzare la nuova finestra al posto di quella
    // principale
    var hxpS = new _hxpSession(iForm);
    hxpS.setParameter("resetFunctionalities", "resetWfAvailableActions");
    
    newWindow = window.open('', iForm.target, "width=800,height=600,scrollbars");
    iForm.submit();
    
    getForm('hxpForm').target = old_target;
    getForm('hxpForm').verbo.value = old_verbo;
    getForm('hxpForm').xverb.value = old_xverb;
    getForm('hxpForm').selid.value = old_selid;
    getForm('hxpForm').query.value = old_query;
    getForm('hxpForm')._cd.value = old_cd;
    
    return false;       
}