/*
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
*/

 /* showtitles@map.js */

 var hxpSession=null;
 var theQuery=null;
 var theProj=null;
 var theLegend=null;

 var theLayers=new Array();
 var itemSep = new Array(); 
 itemSep['poi']='#1%';//separatore per POI nei dati da inviare al plugin
 itemSep['pat']='$B%';//separatore per PATH nei dati da inviare al plugin
 
 function Layer(theData,theDes,theColor,lc,fc,theType,cData)
 {this.data=theData;
  this.type=theType;
  this.color=theColor;
  this.lc=lc;
  this.fc=fc;
  this.des=new Array();
  if(theDes.length)this.des[theDes]='';
  this.cData=new Array();
  if(cData.length)this.cData[cData]='';
  this.child=null;
  this.scale=null;
  this.lastScaleChecked=-1;
//alert(theData+','+theDes+','+theColor+','+theType+','+cData)  
 }
 function initialize()
 {hxpSession=new _hxpSession(document.hxpForm);
  theQuery=hxpSession.getParameter('q');
  theProj=hxpSession.getParameter('p');
  theLegend=hxpSession.getParameter('l');
 }
 
 /**
  * Chiamata  ad ogni riga di titoli.
  * @theType  indica il tipo di dato se punto ('poi') o altro
  * @theData  i dati da passare al plugin, vedi ../../../../factory/map/titleData.xsl per il formato
  * @theShape  determinato dal valore identificato con '#%s: ' nel titolo; 
  *           se non  presente in proj.xml un elemento map-feeder/item[@n=<valore nel titolo>]
  *           ha valore 'default'  
  * @theDes   in proj.xml map-feeder/item[@n=<theShape>] o se assente <theShape> 
  * @theColor in proj.xml map-feeder/item[@n=<theShape>]/@c
  * @lc       in proj.xml map-feeder/item[@n=<theShape>]/@lc line color
  * @fc       in proj.xml map-feeder/item[@n=<theShape>]/@fc fill color
  * @cData    il valore identificato con '#%c: ' nel titolo
  */
 function title2Map(theType,theData,theShape,theDes,theColor,lc,fc,cData)
 {var layerKey=theShape+'_'+theType;
  var layer=theLayers[layerKey];
  if(layer==null)
  {theLayers[layerKey]=new Layer(theData,theDes,theColor,lc,fc,theType,cData);
  }
  else
  {layer.data+=itemSep[theType]+theData;
   if(layer.des[theDes]==null)layer.des[theDes]='';
   if(cData.length)
   {if(layer.cData[cData]==null)layer.cData[cData]='';
   }
  }
 }
 /**
  * Crea un layer dipendente da layer e scala
  * @theParentType typo del layer da cui dipende (utilizzato per associare dei simboli a poligoni diversamente non visibili a scale non di dettaglio) 
  * @theScale il valore di scala per la disattivazione del layer (gestito ora nel caso del parent sopra) 
  */
 function childTitle2Map(theType,theData,theShape,theDes,theColor,lc,fc,cData,theParentType,theScale)
 {var layerKey=theShape+'_'+theParentType;
  var layer=theLayers[layerKey];
  if(layer==null)
  {alert('parent not found but needed!')
   return;   
  }
  if(layer.child==null)
  {layer.child = new Layer(theData,theDes,theColor,lc,fc,theType,cData);   
   layer.child.scale = theScale;
   layer.child.lastScaleChecked = -1;
  }
  else
  {layer = layer.child;
   layer.data += itemSep[theType]+theData;
   if(layer.des[theDes]==null)layer.des[theDes]='';
   if(cData.length)
   {if(layer.cData[cData]==null)layer.cData[cData]='';
   }
  }  
 }
