<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->
<!-- Visualizzazione di un documento -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
				xmlns:xw="http://www.3di.it/ns/xw-200203121136"
				xmlns:h="http://www.w3.org/HTML/1998/html4"
				xmlns:str="http://xsltsl.org/string"
				exclude-result-prefixes="xw h str"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->

    <xsl:key name="rightsTable" match="/response/*/personal_rights/right" use="@cod"/>

	<xsl:include href="hxp.xsl" />

	<xsl:include href="filelist_embedded.xsl"/> <!--  Per l'utilizzo di iw -->

	<xsl:include href="navbar.xsl"/> <!--per scorrimento numerico pagina titoli AAA-->

	<!-- Javascript da includere -->
	<xsl:template name="jslist">

		<xsl:call-template name="jslist_embedded"/> <!-- per iw -->

		<script> <!-- importante ordine di inclusione di questi file -->
			<xsl:attribute name="src">../../../formatter/html/data/js/docEdit.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/document.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/msg/document.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/formTupleRestore.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<xsl:if test="'1'=$isAdmin and starts-with($hxpdata/@xverb,'spot') and ($hxpdata/@verbo='docEdit')">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/spotEdit.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>

		<!--
			Aggiunto da Federico il 28/08/2004:
			Se trova almeno un blocco "iconTypeOperationHistory" (mediante l'id
			"hxp-contextcustom-showTypeIcon-modifica"), inserisce il javascript
			per la gestione dei div nascosti della storia.
		-->
		<xsl:if test="count(//*[@id='hxp-contextcustom-showTypeIcon-modifica'])>0">
			<script>
				<xsl:attribute name="src">../../../formatter/html/data/js/history.js</xsl:attribute>
				<xsl:attribute name="type">text/javascript</xsl:attribute>
				<xsl:text>;</xsl:text>
			</script>
		</xsl:if>

		<!-- Federico 28/03/07: librerie per il parsing xml con Ajax e stampa degli allegati [RW 0043253] -->
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/xml.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/dom-drag.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/printFiles.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
		<script>
			<xsl:attribute name="src">../../../formatter/html/data/js/base64.js</xsl:attribute>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:text>;</xsl:text>
		</script>
	</xsl:template>

	<!-- attributi del body -->
	<xsl:template name="bodyattributes">
		<xsl:call-template name="bodyattributes_embedded"/>
	</xsl:template>

	<!-- hxpForm (form nascosta) -->
	<xsl:template name="beforeend">
		<!-- Federico 03/08/05: eliminato 'name="hxpForm"' in quanto proibito in strict xhtml -->
		<form method="post" id="hxpForm" action="{$hxpdata/@uri}" accept-charset="iso-8859-1">
			<!-- Federico 19/07/05: gli input hidden devono essere contenuti in un "div" o un "p" (specifiche W3C) -->
			<div>
				<xsl:call-template name="sessiondata" />
				<input type="hidden" name="sele" value="{$hxpdata/@sele}" />
				<input type="hidden" name="verbo" value="{$hxpdata/@verbo}" />
				<input type="hidden" name="xverb" value="{$hxpdata/@xverb}" />

				<!--
					Federico 02/07/08: l'opzione "(lt:1)" in xDoc non viene piu' usata dai tempi del Nif e degrada pure le prestazioni,
					oltre a creare problemi con le eventuali entity &#... a causa delle processing instruction inserite da xw [RW 0052875]
				 -->
				<input type="hidden" name="xDoc" value="" />

				<input type="hidden" name="asText"   value="{$hxpdata/@asText}"/>
				<input type="hidden" name="pne"      value="{$hxpdata/@pne}"/>
				<input type="hidden" name="qord" value="{$hxpdata/@qord}" />
				<input type="hidden" name="destPage" value="{$hxpdata/@destPage}" />
				<input type="hidden" name="physDoc" value="{$hxpdata/@physDoc}" />
				<input type="hidden" name="rifInt" value="{$hxpdata/@rifInt}" /> <!-- esclusivo per i riferimenti interni -->
				<input type="hidden" name="attach" value="{$hxpdata/@attach}" /> <!-- esclusivo per allegati -->
				<input type="hidden" name="id" value="{$hxpdata/@id}" /> <!-- esclusivo per allegati -->
				<input type="hidden" name="name" value="{$hxpdata/@name}" /> <!-- esclusivo per allegati -->
				<input type="hidden" name="postitPos" value="" /> <!-- posizione del postit -->
				<input type="hidden" name="postitText" value="" /> <!-- testo del postit (modifica)-->
				<input type="hidden" name="dbToUse" value="" /> <!-- db da utilizzare (nel caso di proiezioni) -->

				<!-- per la creazione di sottofascicoli -->
				<input type="hidden" name="fasc_numero_sottofasc" value=""/>
				<input type="hidden" name="physDoc_sottofasc" value="{$hxpdata/@physDoc_sottofasc}"/>
				<input type="hidden" name="nome_persona_sottofasc" value="{$hxpdata/@nome_persona_sottofasc}"/>
				<input type="hidden" name="nome_uff_sottofasc" value="{$hxpdata/@nome_uff_sottofasc}"/>
				<input type="hidden" name="cod_persona_sottofasc" value="{$hxpdata/@cod_persona_sottofasc}"/>
				<input type="hidden" name="cod_uff_sottofasc" value="{$hxpdata/@cod_uff_sottofasc}"/>

				<!-- Federico 16/05/07: introdotto tipo del valore contenuto nei campi ufficio [RW 0043770] -->
				<input type="hidden" name="tipo_uff_sottofasc" value="{$hxpdata/@tipo_uff_sottofasc}"/>

				<input type="hidden" name="classif_sottofasc" value="{$hxpdata/@classif_sottofasc}"/>
				<input type="hidden" name="classif_cod_sottofasc" value="{$hxpdata/@classif_cod_sottofasc}"/>

				<!-- per inserimento/modifica di repertori -->
				<input type="hidden" name="codice_rep" value="" />
				<input type="hidden" name="descrizione_rep" value="" />

				<!-- per visualizzazione della storia -->
				<input type="hidden" name="oldTable" value="{$hxpdata/@oldTable}" />

				<!--
					Modifica di Federico del 07/12/2004:
					tuple per l'apertura del thesauro dalle molliche relative alla classificazione del documento
				-->
				<input type="hidden" name="keypath"  value="{$hxpdata/@keypath}"/> <!-- la chiave -->
				<input type="hidden" name="startkey" value="{$hxpdata/@startkey}"/>
				<input type="hidden" name="xMode"    value="{$hxpdata/@xMode}"/>
	   			<input type="hidden" name="relation" value="{$hxpdata/@relation}"/> <!-- stringa che identifica la relazione richiesta -->
				<input type="hidden" name="cPath"    value="{$hxpdata/@cPath}"/>    <!-- percorso comune -->

				<!-- specifici -->
				<xsl:call-template name="contextcustom">
					<xsl:with-param name="specName" select="'beforeend'"/>
				</xsl:call-template>

	            <!-- simone - 7 Dic 2004 -->
			    <input type="hidden" name="personalView" value="{$hxpdata/@personalViewToUse}" />

			    <!-- mbussetti - 21/03/2005 -->
			    <input type="hidden" name="convReq" value="{$hxpdata/@convReq}" /> <!--riporta le conversioni richieste sull'ultima versione-->

				<!-- Federico 11/04/2005: contiene le informazioni necessarie per visualizzare i doc. collegati a quello visualizzato -->
				<input type="hidden" name="showLinkedDocsInfo" value="{$hxpdata/@showLinkedDocsInfo}" />

				<xsl:call-template name="beforeend_embedded"/>
			</div>
		</form>
	</xsl:template>



	<!-- Info su chkout
	   id="hxp-doc-data-infoChkout" -->
	<xsl:template name="docinfochkout">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<!-- mballerini 19/06/2011 - modificato il window.status in title poich non pi funzionante --> 
			<xsl:attribute name="title">
				<xsl:text>Prenotato da </xsl:text>
				<xsl:value-of select="$blockData/chkout/@operatore"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Info su chkin
	   id="hxp-doc-data-infoChkin" -->
	<xsl:template name="docinfochkin">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onmouseover">
				<xsl:text>window.status='A cura di </xsl:text>
				<xsl:value-of select="$blockData/chkin/@operatore"/>
				<xsl:text>';return true;</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onmouseout">
				<xsl:text>window.status=window.defaultStatus</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
		introdotto da mbussetti il 29/03/2005
		id="hxp-doc-datanocopy-metadata"
		Inserisce nella pagina di visualizzazione i metadati di un allegato (in un div nascosto)

		Federico 24/05/07: cambiato 'mode' ("metadata") negli apply-templates [RW 0044319]
	-->
	<xsl:template name="docmetadata">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="id">
				<xsl:text>metaView_</xsl:text>
				<xsl:value-of select="$blockData/../@name"/>
			</xsl:attribute>
			<xsl:apply-templates select="$blockData/*" mode="metadata">
	  		</xsl:apply-templates>
		</xsl:copy>
	</xsl:template>

	<!--
		introdotto da mbussetti il 01/04/2005
		id="hxp-doc-datanocopy-listImagesMetadata"
		Inserisce nella pagina di visualizzazione i metadati di tutte le immagini allegate (in una serie di div
		nascosti, ciascuno individuabile tramite un id che contenga un riferimento univoco all'immagine)

		Federico 24/05/07: cambiato 'mode' ("metadata") negli apply-templates [RW 0044319]
	-->
	<xsl:template name="docimagesmetadata">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:for-each select="$hxpdata//immagini/xw:file/metadata">
				<xsl:element name="div">
					<xsl:attribute name="id">
						<xsl:text>metaView_</xsl:text>
						<xsl:value-of select="../@title"/>
					</xsl:attribute>
					<xsl:attribute name="style">
						<xsl:text>display:none</xsl:text>
					</xsl:attribute>
					<xsl:element name="p">
						<xsl:apply-templates select="./*" mode="metadata">
				  		</xsl:apply-templates>
			  		</xsl:element>
			  	</xsl:element>
		  	</xsl:for-each>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-doc-data-... scrive COMUNQUE il nodo corrente-->
	<xsl:template name="docdata">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:choose>
				<xsl:when test="$value='asText'">
					<xsl:attribute name="id">hxp-doc-data-asText</xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
				</xsl:when>
				<xsl:when test="$value='infoChkin'">
					<xsl:call-template name="docinfochkin">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="$value='infoChkout'">
					<xsl:call-template name="docinfochkout">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>

				<!-- Restituisce l'indice dell'istanza in cui  inserito l'id
				    id="hxp-doc-data-instNumber" -->
				<xsl:when test="$value='instNumber'">
					<xsl:variable name="remainder">
						<xsl:call-template name="hxpstring">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
							<xsl:with-param name="thestring" select="'$hxp_instance('" />
						</xsl:call-template>
					</xsl:variable>
					<xsl:value-of select="$remainder" />
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>

				<!-- Restituisce il numero totale di istanze in cui  inserito l'id
				    id="hxp-doc-data-instTotalNumber" -->
				<xsl:when test="$value='instTotalNumber'">
					<xsl:variable name="remainder">
						<xsl:variable name="elemName" select="name($blockData/.)"/>
						<xsl:for-each select="$blockData/.">
							<xsl:value-of select="string(count(preceding-sibling::*[name()=$elemName]) + count(following-sibling::*[name()=$elemName]) + 1)"/>
						</xsl:for-each>
					</xsl:variable>
					<xsl:value-of select="$remainder" />
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>

				<xsl:when test="$value='pagenumber'"> <!-- hxp-doc-data-pagenumber - numero della pagina corrente -->
					<xsl:number value="floor($hxpdata/@pos + 1)" format="1" />
				</xsl:when>
				<xsl:when test="$value='numberofpages'"> <!-- hxp-doc-data-numberofpages - numero totale di pagine -->
					<xsl:number value="$hxpdata/@count" format="1" />
				</xsl:when>
				<xsl:when test="starts-with(substring-before($value,'-'),'pi')"> <!-- hxp-doc-data-pi-... - processing instruction -->
					<xsl:call-template name="procinstr">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="caller" select="substring-after($value,'pi-')" />
					</xsl:call-template>
				</xsl:when>
				<!--
					Federico 08/04/2005: "hxp-doc-data-tittext" - visualizzazione testo di un titolo (messo a
					disposizione per la visualizzazione dei documenti collegati a quello visualizzato [RW0027042]).
				-->
				<xsl:when test="$value='tittext'">
					<xsl:value-of select="$blockData/@testo"/>
				</xsl:when>

				<xsl:when test="$value='numnavbar'"> <!-- barra di navigazione -->
				<!--
                                        <span id="numdocnavbarcode" style="display:none">
						<xsl:text>numdocnavbarcode(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos"/>
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count"/>
						<xsl:text>)</xsl:text>
                                        </span>
                                 -->
                                 	<xsl:call-template name="numdocnavbarcode"/>
				</xsl:when>


				<xsl:otherwise>
					<xsl:call-template name="hxperrorhandler">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:copy>
	</xsl:template>


	<xsl:template name="copyIfFascLevel">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="levelEquals" select="''"/>
		<xsl:param name="levelAtLeast" select="''"/>

		<!-- Federico 06/07/07: introdotta gestione numeri di fascicolo privi di classificazione [RW 0045509] -->
		<xsl:variable name="classifAndNum">
			<xsl:value-of select="substring-after(substring-after($hxpdata/fascicolo/@numero,'-'),'-')"/>
		</xsl:variable>

		<xsl:variable name="realNumber">
			<xsl:choose>
				<xsl:when test="contains($classifAndNum, '/')">
					<!-- numero con classificazione -->
					<xsl:value-of select="$classifAndNum"/>
				</xsl:when>
				<xsl:otherwise>
					<!-- numero privo di classificazione -->
					<xsl:text>.</xsl:text><xsl:value-of select="$classifAndNum"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="numDots">
			<xsl:call-template name="countTokenFreq">
				<xsl:with-param name="text" select="$realNumber"/>
				<xsl:with-param name="token" select="'.'"/>
				<xsl:with-param name="freq" select="'0'"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:choose>
			<xsl:when test="$levelEquals!=''">
				<xsl:if test="$numDots=$levelEquals and $hxpdata//funzionalita_disponibili/@sottofascicoloinserimento='true'">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$numDots &gt;= $levelAtLeast and $hxpdata//funzionalita_disponibili/@sottofascicoloinserimento='true'">
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!--  Copia l'elemento contenente l'id solo se il documento  segreto o
	 	altamente confidenziale(segreto) a seconda del tipo. Nel caso di
	 	documento riservato viene valorizzato anche il baloon dell'elemento
	 	con le informazioni sulla data fino alla quale  riservato
		id="hxp-doc-datanocopy-visibilita-(tipo)"
		(tipo) = riservato
		(tipo) = segreto
	-->
	<xsl:template name="copyIfvisibilita">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tipo" select="''"/>
		<xsl:choose>
			<xsl:when test="$tipo='riservato' and $hxpdata//visibilita/@tipo='Riservato'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="alt">
						<xsl:text>Documento </xsl:text>
						<xsl:value-of select="substring-before(substring-before(substring-after(concat($hxpdata/@dicitVis,'&#38;'),'dicitRiservato='),'&#38;'),'|')"/>
						<xsl:if test="$hxpdata//visibilita/@fino_al!=''">
							<xsl:text> fino al </xsl:text>
							<xsl:call-template name="dateformatter">
								<xsl:with-param name="datas" select="$hxpdata//visibilita/@fino_al"/>
							</xsl:call-template>
						</xsl:if>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:when test="$tipo='segreto' and $hxpdata//visibilita/@tipo='Altamente confidenziale'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="alt">
						<xsl:text>Documento </xsl:text>
						<xsl:value-of select="substring-before(substring-before(substring-after(concat($hxpdata/@dicitVis,'&#38;'),'dicitAltConf='),'&#38;'),'|')"/>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:when test="$tipo='segretissimo' and $hxpdata//visibilita/@tipo='Segretissimo'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="alt">
						<xsl:text>Documento </xsl:text>
						<xsl:value-of select="substring-before(substring-before(substring-after(concat($hxpdata/@dicitVis,'&#38;'),'dicitSegreto='),'&#38;'),'|')"/>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
		</xsl:choose>
	</xsl:template>


	<!--  Copia l'elemento contenente l'id solo se il documento possiede la segnatura.
		id="hxp-doc-datanocopy-segnatura"
	-->
	<xsl:template name="copyIfSegnatura">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="count($hxpdata//storia/segnatura[@cod_uff_oper!=''])>0">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />

				<xsl:attribute name="alt">
					<xsl:text>Segnatura applicata il </xsl:text>
					<xsl:call-template name="dateformatter">
						<xsl:with-param name="datas" select="$hxpdata//storia/segnatura/@data"/>
					</xsl:call-template>
					<xsl:text> alle </xsl:text>
					<xsl:value-of select="$hxpdata//storia/segnatura/@ora"/>
					<xsl:text> da </xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata//storia/segnatura/@oper"/>
					</xsl:call-template>				
					<xsl:text> (</xsl:text>
					<xsl:value-of select="$hxpdata//storia/segnatura/@uff_oper"/>
					<xsl:text>)</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onmouseover">
					<xsl:text>window.status='Segnatura applicata il </xsl:text>
					<xsl:call-template name="dateformatter">
						<xsl:with-param name="datas" select="$hxpdata//storia/segnatura/@data"/>
					</xsl:call-template>
					<xsl:text> alle </xsl:text>
					<xsl:value-of select="$hxpdata//storia/segnatura/@ora"/>
					<xsl:text> da </xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata//storia/segnatura/@oper"/>
					</xsl:call-template>
					<xsl:text> (</xsl:text>
					<xsl:value-of select="$hxpdata//storia/segnatura/@uff_oper"/>
					<xsl:text>)'; return true;</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onmouseout">
					<xsl:text>window.status=''; return true;</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Smistamento dei template hxp-doc-datanocopy-... NON scrive il nodo corrente-->
	<xsl:template name="docdatanocopy">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:choose>
			<xsl:when test="$value='segnatura'">
				<xsl:call-template name="copyIfSegnatura">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>

			<!--
				inserito da mbussetti il 29/03/2005: visualizzazione dei metadati di un allegato
			-->
			<xsl:when test="$value='metadata'">
				<xsl:call-template name="docmetadata">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<!--
				inserito da mbussetti il 01/04/2005: lista dei metadati di tutte le immagini di un documento
			-->
			<xsl:when test="$value='listImagesMetadata'">
				<xsl:call-template name="docimagesmetadata">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>

			<xsl:when test="starts-with($value,'visibilita-')">
				<xsl:call-template name="copyIfvisibilita">
					<xsl:with-param name="tipo" select="substring-after($value,'visibilita-')"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showInsertSottofascicolo'">
				<xsl:call-template name="copyIfFascLevel">
					<xsl:with-param name="levelEquals" select="'1'"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showInsertInserto'">
				<xsl:call-template name="copyIfFascLevel">
					<xsl:with-param name="levelEquals" select="'2'"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showInsertAnnesso'">
				<xsl:call-template name="copyIfFascLevel">
					<xsl:with-param name="levelAtLeast" select="'3'"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='flap'">
				<xsl:call-template name="docflap">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='group'">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:choose>
					<xsl:when test="$specific='onecheck_main'">
						<xsl:call-template name="docgrouponecheck_main">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='explain_main'">
						<xsl:call-template name="docgroupexplain_main">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='explain_fhalf'">
						<xsl:call-template name="docgroupexplain_fhalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='explain_shalf'">
						<xsl:call-template name="docgroupexplain_shalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='onecheck_father'">
						<xsl:call-template name="docgrouponecheck_father">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='onecheck_child'">
						<xsl:call-template name="docgrouponecheck_child">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='onecheck_child_fhalf'">
						<xsl:call-template name="docgrouponecheck_child_fhalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='onecheck_child_shalf'">
						<xsl:call-template name="docgrouponecheck_child_shalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='onecheck_single'">
						<xsl:call-template name="docgrouponecheck_single">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='multicheck_father'">
						<xsl:call-template name="docgroupmulticheck_father">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='multicheck_child_fhalf'">
						<xsl:call-template name="docgroupmulticheck_child_fhalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='multicheck_child_shalf'">
						<xsl:call-template name="docgroupmulticheck_child_shalf">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="$value='right'">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:call-template name="docright">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="specific" select="$specific"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="($value='right_fhalf') or (substring-before($value,'-')='right_fhalf')">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:call-template name="docright_fhalf">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="specific" select="$specific"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="($value='right_shalf') or (substring-before($value,'-')='right_shalf')">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:call-template name="docright_shalf">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="specific" select="$specific"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='right_yes'">
				<xsl:call-template name="docright_yes">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='right_not'">
				<xsl:call-template name="docright_not">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='right_text'">
				<xsl:call-template name="docright_text">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='right_password'">
				<xsl:call-template name="docright_password">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='input'">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:choose>
					<xsl:when test="$specific='check'">
						<xsl:call-template name="docinputcheck">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='radio'">
						<xsl:call-template name="docinputradio">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='boolean'">
						<xsl:call-template name="docinputboolean">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='textual'">
						<xsl:call-template name="docinputtextual">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='rep'">
				<xsl:variable name="specific" select="substring-after($value,'-')"/>
				<xsl:choose>
					<xsl:when test="$specific='yes'">
						<xsl:call-template name="docrepyes">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='not'">
						<xsl:call-template name="docrepnot">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='title'">
						<xsl:call-template name="docreptitle">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:when test="$specific='imgSetting'">
						<xsl:call-template name="docrepimgSetting">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--

   Implementazione dei singoli template action

	-->

	<!-- Restituisce il documento docNumber (Gestione gerarchica dei documenti).
	@param docNumber numero del documento desiderato -->
	<xsl:template name="seekdoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="docNumber" select="''" />
		<xsl:choose>
			<xsl:when test="$docNumber>=0">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return seekDoc(</xsl:text>
						<xsl:value-of select="$docNumber" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
   Templates per la gestione gerarchica dei documenti
	-->

	<!-- Restituisce il padre del documento attuale: id="hxp-doc-action-father" -->
	<xsl:template name="docfather">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:call-template name="seekdoc">
			<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="docNumber" select="$hxpdata/@docFather" />
		</xsl:call-template>
	</xsl:template>

	<!-- Restituisce il fratello precedente del documento attuale: id="hxp-doc-action-upperbrother" -->
	<xsl:template name="docupperbrother">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:call-template name="seekdoc">
			<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="docNumber" select="$hxpdata/@docUpperbrother" />
		</xsl:call-template>
	</xsl:template>

	<!-- Restituisce il primo figlio del documento attuale: id="hxp-doc-action-firstson" -->
	<xsl:template name="docfirstson">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:call-template name="seekdoc">
			<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="docNumber" select="$hxpdata/@docFirstson" />
		</xsl:call-template>
	</xsl:template>

	<!-- Restituisce il fratello successivo del documento attuale: id="hxp-doc-action-lowerbrother" -->
	<xsl:template name="doclowerbrother">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:call-template name="seekdoc">
			<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="docNumber" select="$hxpdata/@docLowerbrother" />
		</xsl:call-template>
	</xsl:template>

	<!--
	Templates per la gestione dei documenti di una selezione
	-->

	<!-- Restituisce il primo documento della selezione: id="hxp-doc-action-first" -->
	<xsl:template name="docfirst">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return primaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Restituisce il documento precedente: id="hxp-doc-action-prev" -->
	<xsl:template name="docprev">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@pos>0">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaPrecedente(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="docrefresh">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text> - 1,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
	</xsl:template>

	<!-- Restituisce il documento successivo: id="hxp-doc-action-next" -->
	<xsl:template name="docnext">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaSuccessiva(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Restituisce l'ultimo documento della selezione: id="hxp-doc-action-last" -->
	<xsl:template name="doclast">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@count>$hxpdata/@pos+1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return ultimaPagina(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 27/10/2005 GMG & VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Questo template si occupa della rimozione di un documento dalla selezione corrente
		* (id gestito: "hxp-doc-action-removeDocFromSel").
	-->
	<xsl:template name="removeDocFromSel">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:choose>
			<!--  Nella selezione ci sono 2 o pi documenti -->
			<xsl:when test="$hxpdata/@count > 1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return removeDocFromSel();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<!--  Nella selezione c' un solo documento -->
			<xsl:when test="$hxpdata/@count = 1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return nuovaRicerca();</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<!-- Sono in situazione anomala @count < 1 -->
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Nuova ricerca (chiude la pagina del documento-si torna a quella di ricerca):
	id="hxp-doc-action-query" -->
	<xsl:template name="docquery">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return nuovaRicerca();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Cancellazione fisica del documento
	id="hxp-doc-action-remove" -->
	<xsl:template name="docremove">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return remove();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Vai alla pagina di query specifica di tabella: id="hxp-doc-action-gototableq-(nome tabella)"
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="docgototableq">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vai alla pagina di query specifica di tabella e utilizza la selezione corrente per un raffinamento:
	id="hxp-doc-action-refinetableq-(nome tabella)"
	(nome tabella)  opzionale. Nel caso in cui venga omesso si suppone che la pagina principale sia quella di ricerca
	Notare che (nome tabella) deve corrispondere alla parte del nome del template html (di ricerca della
	tabella in questione) successivo al carattere '@'.
	Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
	html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="docrefinetableq">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tableName" select="''" />
		<xsl:param name="disabilita_ritorno_etichetta" select="''" />
		<xsl:variable name="selid" select="$hxpdata/@selid" />
		<xsl:choose>
			<xsl:when test="$selid!='' and $hxpdata/@count>1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return gotoTableQ('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>','R')</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<!-- 21/11/2005 VM - Se disabilita_ritorno_etichetta  vuoto viene
				processato il contenuto (quindi viene riportata l'etichetta del bottone) -->
				<xsl:if test="$disabilita_ritorno_etichetta=''">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="'1'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Restituisce la pagina dei titoli: id="hxp-doc-action-titles" -->
	<xsl:template name="doctitles">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="selid" select="$hxpdata/@selid" />
		<xsl:choose>
			<xsl:when test="$selid!='' and $hxpdata/@count>1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return paginaTitoli(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@pageCount" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Pagina di lista file (scelta allegati): id="hxp-doc-action-filelist" -->
	<xsl:template name="docfilelist">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="filelist" select="translate($hxpdata/@fileList,'\','/')" />
		<xsl:choose>
			<xsl:when test="$filelist!=''">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return openFileList('</xsl:text>
						<xsl:value-of select="$filelist" />
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Pagina di visualizzazione gerarchica(grafica) dei documenti: id="hxp-doc-action-hier" -->
	<xsl:template name="dochierbrowser">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="selid" select="$hxpdata/@selid" />
		<xsl:choose>
			<xsl:when test="$selid='' or $selid!=''">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return paginaBrowse(</xsl:text>
						<xsl:value-of select="$hxpdata/@physDoc" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<!-- Restituisce un documento dato il suo numero fisico: id="hxp-doc-action-physdoc" -->
	<xsl:template name="docphysdoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return seekDoc(</xsl:text>
					<xsl:value-of select="$blockData/@physDoc" />
					<xsl:text>, true);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Va in modifica del documento corrente - rispettando la tabella di appartenenza:
	N.B - NON viene sbiancata la tupla dbTable.
	   id="hxp-doc-action-modifytabledoc" -->
	<xsl:template name="docmodifytabledoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<xsl:copy>
				<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>

				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return modifyTableDoc(</xsl:text>
					<xsl:if test="$hxpdata//repertorio/@cod">
						<xsl:value-of select="concat('&#34;',$hxpdata//repertorio/@cod,'&#34;,&#34;')" />
						<xsl:call-template name="toJSParam">
							<xsl:with-param name="testo" select="$hxpdata//repertorio" />
						</xsl:call-template>
						<xsl:text>&#34;</xsl:text>
					</xsl:if>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Apre la pagina per l'aggiunta di riferimenti interni
	   id="hxp-doc-action-openRifInt-'RPA'" oppure id="hxp-doc-action-openRifInt-'CC'" -->
	<xsl:template name="docopenRifInt">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="addType" select="'RPA'" />
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return openRifInt(</xsl:text>
					<xsl:value-of select="$addType"/>
					<xsl:if test="$hxpdata/doc/@bozza='si'">
						<xsl:text>,true</xsl:text>
					</xsl:if>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- Rimuove un riferimento interno
	   id="hxp-doc-action-removeRifInt" -->
	<xsl:template name="docremoveRifInt">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<!-- Federico 15/05/09: disabilitazione delle funz. di modifica dei CC sui CC ereditati dal fascicolo (gestione dei CC nei fascicoli) [M 0000378] -->
			<xsl:if test="not($blockData/@cc_from_fasc)">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/>
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return removeRifInt('</xsl:text>
						<xsl:value-of select="$blockData/@cod_persona"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@cod_uff"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@diritto"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:if>
	</xsl:template>


	<!-- Rimuove un allegato
	   id="hxp-doc-action-removeAttach" -->
	<xsl:template name="docremoveAttach">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tipo" select="'file'" />
		<xsl:copy>
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="data" select="$blockData"/>
				</xsl:call-template>
			</xsl:for-each>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return removeAttach('</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$tipo"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Protocolla una bozza
			 id="hxp-doc-action-protocolla"
	 -->
	<xsl:template name="docprotocolla">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="pne">
			<xsl:for-each select="$hxpdata/*[position()=1]">
                <!--
				<xsl:value-of select="name(current())" />
                -->
				<xsl:value-of select="name(.)" />
			</xsl:for-each>
		</xsl:variable>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return protocolla('</xsl:text>
				<xsl:choose>
					<xsl:when test="not($hxpdata//repertorio/@cod)">
						<xsl:text>false</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>true</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$pne" />
				<xsl:text>','</xsl:text>
				<xsl:value-of select="concat('list_of_',$pne)" />
				<xsl:if test="$hxpdata//repertorio/@cod">
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$hxpdata//repertorio/@cod" />
					<xsl:text>','</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata//repertorio" />
					</xsl:call-template>
				</xsl:if>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Inserisci documento nella collezione attiva: id="hxp-doc-action-collect" -->
	<xsl:template name="doccollect">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tableName" select="''" />
		<xsl:choose>
			<xsl:when test="$hxpdata/@cName != '' and $hxpdata/@cId != $hxpdata/@selid">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<!--
						<xsl:text>return collection();</xsl:text>
						-->
						<xsl:text>return gotoTableQ('</xsl:text>
						<xsl:value-of select="$tableName"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Visualizza una proiezione ovvero una ricerca su (nome alias) ordinando la selezione in base a (ord)
	id="hxp-doc-action-projection-'(nome alias)','(ord)',(uri),(new window)"
	(nome alias) potrebbe essere una lista di alias separati da virgole ','
	(ord) e (uri) e (new) sono facoltativi. Se (uri) assente, viene utilizzato uri corrente.

	uri serve, ad esempio per eseguire la proiezione su un altro applicativo. Questo permette di poter utilizzare il
	jsp dell'applicativo sul quale si effettua la proiezione.
	Il formato deve essere: (esempio)
	           /base/acl/engine/acl.jsp?db=acl (NOTARE CHE MANCA LA STRINGA xway IN TESTA)

**************************************************************************
	N.B quindi non deve venire specificato il primo livello ovvero xway/ questo perch
	il punto di ingresso dell'applicativo potrebbe dipendere dall'installazione, al contrario la parte che
	viene specificat nel template  garantita essere sostante
**************************************************************************

	quindi comprensivo di db

	Se (new window) assente viene eseguita proiezione sulla stessa finestra, se presente e vale '_NEW_' allora
	viene aperto in nuova finestra.
	Nel template html deve esistere una ancora (figlio dello span che ha questo id).
	Eventuali parti di testo contenute nello span devo essere racchiuse in elementi (tipo span)
	-->
	<xsl:template name="projection">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="params" select="''" />
			<xsl:for-each select="./child::*">
			<xsl:if test="name()!='a'">
				<xsl:copy>
                <!--
					<xsl:copy-of select="@*" />
                 -->
				<xsl:for-each select="@*">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>

				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
				</xsl:copy>
			</xsl:if>
			<xsl:if test="name()='a'"> <!-- e' una ancora -->
				<xsl:copy>
                <!--
					<xsl:copy-of select="@*" />
                 -->
				<xsl:for-each select="@*">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>

					<xsl:variable name="val">
						<xsl:for-each select="$blockData">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-before($params,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:variable>

					<xsl:if test="$val!=''">
						<xsl:attribute name="href">
							<xsl:text>javascript:void(0);</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:if test="string-length(@onclick) &gt; 0">
								<xsl:value-of select="@onclick"/>
								<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
									<xsl:text>;</xsl:text>
								</xsl:if>
							</xsl:if>
							<xsl:text>return doProjection('</xsl:text>
							<xsl:call-template name="toJSParam">
								<xsl:with-param name="testo" select="$val"/>
							</xsl:call-template>
							<xsl:text>',</xsl:text>
							<xsl:value-of select="substring-after($params,'-')" />
							<xsl:text>);</xsl:text>
						</xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="'0'" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="$val=''">
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="'1'" />
						</xsl:call-template>
					</xsl:if>
				</xsl:copy>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>


	<!-- Visualizza una proiezione ovvero una ricerca su (nome alias) ordinando la selezione in base a (ord).
	Rispetto a doProjection che effettua la proiezione tramite url (che si porta dietro
	let tuple transformJava e enableIW) si porta dietro tutte le tuple attuali ma ha la limitazione di dover mantere lo
	stesso db.
	id="hxp-doc-action-projectionWithSubmit-'(nome alias)','(ord)',(new window)"
	(nome alias) potrebbe essere una lista di alias separati da virgole ','
	(ord) e (new) sono facoltativi.
	Se (new window) assente viene eseguita proiezione sulla stessa finestra, se presente e vale '_NEW_' allora
	viene aperto in nuova finestra.
	Nel template html deve esistere una ancora (figlio dello span che ha questo id).
	Eventuali parti di testo contenute nello span devo essere racchiuse in elementi (tipo span)
	-->
	<xsl:template name="projectionWithSubmit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="params" select="''" />
			<xsl:for-each select="./child::*">
			<xsl:if test="name()!='a'">
				<xsl:copy>
					<xsl:copy-of select="@*" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
				</xsl:copy>
			</xsl:if>
			<xsl:if test="name()='a'"> <!-- e' una ancora -->
				<xsl:copy>
					<xsl:copy-of select="@*"/>
					<xsl:variable name="val">
						<xsl:for-each select="$blockData">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-before($params,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:variable>
					<xsl:if test="$val!=''">
						<xsl:attribute name="href">
							<xsl:text>javascript:void(0);</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:text>return doProjectionWithSubmit('</xsl:text>
							<xsl:call-template name="toJSParam">
								<xsl:with-param name="testo" select="$val"/>
							</xsl:call-template>
							<xsl:text>',</xsl:text>
							<xsl:value-of select="substring-after($params,'-')" />
							<xsl:text>);</xsl:text>
						</xsl:attribute>
					</xsl:if>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- Gregorio_Aggiunta : verificare conflitto con "removeDocFromSel" -->
	<!-- Elimina il documento dalla selezione: id="hxp-doc-action-deselect" -->
	<xsl:template name="docdeselect">
	<!-- template fotocopia di 'titledeselect' -->
	<!-- cambia anche il baloon nel caso di titoli di raccolta-->
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="''"/>
		<xsl:choose>
			<xsl:when test="$hxpdata/@count > 1">
				<xsl:copy>
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="blockPath" select="$blockPath"/>
							<xsl:with-param name="data" select="$blockData"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:choose>
						<xsl:when test="$hxpdata/@cId = $hxpdata/@selid">
							<xsl:attribute name="title">
								<xsl:text>Rimuovi dalla raccolta corrente</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onmouseover">
								<xsl:text>window.status='Rimuovi dalla raccolta corrente';return true</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="title">
								<xsl:text>Rimuovi dalla selezione corrente</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onmouseover">
								<xsl:text>window.status='Rimuovi dalla selezione corrente';return true</xsl:text>
							</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return deselect(</xsl:text>
						<xsl:value-of select="$hxpdata/@pos" />
						<xsl:text>,</xsl:text>
						<xsl:value-of select="$hxpdata/@count" />
						<xsl:text>);</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disable" select="'1'" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Esegue check se documento in CC visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoCC">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:if test="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@visto_da!=''">
						<xsl:text> da </xsl:text>
						<xsl:value-of select="translate($hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@visto_da,'%','')"/>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Esegue check se documento in OP visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoOP">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:if test="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@visto_da!=''">
						<xsl:text> da </xsl:text>
						<xsl:value-of select="translate($hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@visto_da,'%','')"/>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Esegue check se documento in OPM visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoOPM">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:if test="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@visto_da!=''">
						<xsl:text> da </xsl:text>
						<xsl:value-of select="translate($hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@visto_da,'%','')"/>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Esegue check se documento in CDS visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoCDS">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:if test="$hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@visto_da!=''">
						<xsl:text> da </xsl:text>
						<xsl:value-of select="translate($hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@visto_da,'%','')"/>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/assegnazione_cds[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Info su assegnazione CC
	   id="hxp-doc-action-infoAssegnazioneCC" -->
	<xsl:template name="docinfoAssegnazioneCC">
	    <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
            <xsl:if test="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@operatore">
                <xsl:copy>
	            <xsl:copy-of select="@*[name()!='id']" />
		    <xsl:attribute name="alt">
		        <xsl:text>Assegnato da </xsl:text>
                        <xsl:value-of select="$hxpdata//storia/assegnazione_cc[@nome_persona=$blockData/@nome_persona][last()]/@operatore"/>
                    </xsl:attribute>
		    <xsl:call-template name="hxpcontinuecontext">
                        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
                    </xsl:call-template>
                </xsl:copy>
            </xsl:if>
	</xsl:template>

	<!-- Info su assegnazione OP
	   id="hxp-doc-action-infoAssegnazioneOP" -->
	<xsl:template name="docinfoAssegnazioneOP">
            <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
            <xsl:if test="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@operatore">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="alt">
				<xsl:text>Assegnato da </xsl:text>
				<xsl:value-of select="$hxpdata//storia/assegnazione_op[@nome_persona=$blockData/@nome_persona][last()]/@operatore"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
            </xsl:if>
	</xsl:template>

	<!-- Info su assegnazione OPM
	   id="hxp-doc-action-infoAssegnazioneOPM" -->
	<xsl:template name="docinfoAssegnazioneOPM">
            <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
            <xsl:if test="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@operatore">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="alt">
				<xsl:text>Assegnato da </xsl:text>
				<xsl:value-of select="$hxpdata//storia/assegnazione_opm[@nome_persona=$blockData/@nome_persona][last()]/@operatore"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
            </xsl:if>
	</xsl:template>

	<!-- Esegue check se documento in RPA visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoRPA">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/responsabilita[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:variable name="nome_persona" select="$hxpdata//storia/responsabilita[@nome_persona=$blockData/@nome_persona][last()]/@visto_da"/>
					<xsl:if test="$nome_persona!=''">
						<xsl:text> da </xsl:text>
						<xsl:choose>
							<xsl:when test="starts-with($nome_persona,'%')">
								<xsl:value-of select="translate($nome_persona,'%','')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$nome_persona"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/responsabilita[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/responsabilita[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/responsabilita[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Esegue check se documento in RPAM visto
	   id="hxp-doc-action-checkVisto" -->
	<xsl:template name="doccheckvistoRPAM">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$hxpdata//storia/responsabilita_minuta[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto!=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="alt">
					<xsl:text>Visto</xsl:text>
					<xsl:variable name="nome_persona" select="$hxpdata//storia/responsabilita_minuta[@nome_persona=$blockData/@nome_persona][last()]/@visto_da"/>
					<xsl:if test="$nome_persona!=''">
						<xsl:text> da </xsl:text>
						<xsl:choose>
							<xsl:when test="starts-with($nome_persona,'%')">
								<xsl:value-of select="translate($nome_persona,'%','')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$nome_persona"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="$hxpdata//storia/responsabilita_minuta[@nome_persona=$blockData/@nome_persona][last()]/@data_visto!='n.d'">
						<xsl:text> il </xsl:text>
						<xsl:call-template name="dateformatter">
							<xsl:with-param name="datas" select="$hxpdata//storia/responsabilita_minuta[@nome_persona=$blockData/@nome_persona][last()]/@data_visto"/>
						</xsl:call-template>
						<xsl:text> alle </xsl:text>
						<xsl:value-of select="$hxpdata//storia/responsabilita_minuta[@nome_persona=$blockData/@nome_persona][last()]/@ora_visto"/>
					</xsl:if>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!--  Effettua il calcolo dell'impronta controllando se corrisponde con quella salvata nel documento
	   id="hxp-doc-action-checkImpronta" -->
	<xsl:template name="doccheckimpronta">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<xsl:copy>
				<xsl:choose>
					<xsl:when test="count($hxpdata/doc/files/*)>0 or count($hxpdata/doc/immagini/*)>0">
						<xsl:copy-of select="@*[name()!='id']" />
						<xsl:attribute name="href">
							<xsl:text>javascript:void(0);</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:text>checkImpronta();</xsl:text>
						</xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="'1'" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:copy>
	</xsl:template>


	<!--  Inserisce una annotazione
	   id="hxp-doc-action-addPostit" -->
	<xsl:template name="docaddpostit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>addPostit('','');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!--  Elimina una annotazione
	   id="hxp-doc-action-delPostit" -->
	<xsl:template name="docdelpostit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return delPostit('</xsl:text>
				<xsl:for-each select="$hxpdata//postit">
					<!--
						Federico 04/04/2005: forzato test sull'uguaglianza COMPLETA (attr. e contenuto) tra il postit
						corrente ('.') e quello puntato da 'blockData' per evitare una numerazione non corretta dei
						postit nel caso in cui ci siano postit con la stessa data, ora e codice operatore (RW0024798).
					-->
					<!--<xsl:if test="./@ora=$blockData/@ora and ./@data=$blockData/@data and ./@cod_operatore=$blockData/@cod_operatore">-->
					<xsl:if test=".=$blockData">
						<xsl:value-of select="position()"/>
					</xsl:if>
				</xsl:for-each>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!--  Modifica una annotazione
	   id="hxp-doc-action-modPostit" -->
	<xsl:template name="docmodpostit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>modPostit('</xsl:text>
				<xsl:for-each select="$hxpdata//postit">
					<!--
						Federico 04/04/2005: forzato test sull'uguaglianza COMPLETA (attr. e contenuto) tra il postit
						corrente ('.') e quello puntato da 'blockData' per evitare una numerazione non corretta dei
						postit nel caso in cui ci siano postit con la stessa data, ora e codice operatore (RW0024798).
					-->
					<!--<xsl:if test="./@ora=$blockData/@ora and ./@data=$blockData/@data and ./@cod_operatore=$blockData/@cod_operatore">-->
					<xsl:if test=".=$blockData">
						<xsl:value-of select="position()"/>
					</xsl:if>
				</xsl:for-each>
				<xsl:text>','</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/text()"/>
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Vecchia implementazione dell'id "hxp-doc-action-instabledoc-(nome tabella)"
			 NON prevede la gestione dei repertori
	-->
	<!--
	<xsl:template name="docinstabledoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tableName" select="''" />
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return insTableDoc('</xsl:text><xsl:value-of select="$tableName"/><xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>
	-->

	<!-- Implementazione dell'id "hxp-docedit-action-instabledoc-'specification'":
			 se 'specification'  il nome di una tabella, apre la pagina di inserimento di quella tabella, il cui nome
			 deve corrispondere alla parte del nome del template html (di inserimento della tabella in questione) successivo
			 al carattere '@' (ad esempio docedit@'specification'.html);
			 se 'specification' ha valore "rep" apre la pagina di inserimento di un documento del repertorio corrente,
			 estraendo dal contenuto XML l'informazione sulla tabella di appartenenza del repertorio in questione;
			 se 'specification' ha il valore 'nometabella'-"withRep" decide se aprire la pagina di inserimento (della tabella
			 specificata) per un documento normale o per un repertorio in base al tipo di documento in cui si trova.

			 Federico 21/03/2005: se 'specification' contiene "codRep-<codice>-<descrizione>", apre la pagina di inserimento
			 del repertorio con codice "<codice>" e descrizione "<descrizione>".

			 Il template xsl specifico deve effettuare il controllo necessario alla corretta inclusione del template
			 html aggiungendo il contenuto di xverb.
	-->
	<xsl:template name="docinstabledoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="tableName" select="''" />
		<xsl:choose>
			<xsl:when test="$tableName='rep'">
			<!-- inserimento di un repertorio dalla pagina contenente l'elenco dei rep su cui l'utente ha diritto di inserimento -->
				<xsl:choose>
					<xsl:when test="$hxpdata/@dbTable='@repertorio'">
					<!-- sono effettivamente nella pagina con l'elenco dei repertori che posso inserire -->
						<xsl:variable name="effectiveTableName">
							<xsl:choose>
								<xsl:when test="$blockData/@tipo='P'">
									<xsl:text>partenza</xsl:text>
								</xsl:when>
								<xsl:when test="$blockData/@tipo='A'">
									<xsl:text>arrivo</xsl:text>
								</xsl:when>
								<xsl:when test="$blockData/@tipo='I'">
									<xsl:text>interno</xsl:text>
								</xsl:when>
								<xsl:when test="$blockData/@tipo='V'">
									<xsl:text>varie</xsl:text>
								</xsl:when>
							</xsl:choose>
						</xsl:variable>
						<xsl:variable name="descrizione">
							<xsl:value-of select="$blockData/../descrizione"/>
							<xsl:if test="$blockData/text()!=''">
								<xsl:value-of select="concat(' ',$blockData/text())"/>
							</xsl:if>
						</xsl:variable>
						<xsl:copy>
							<xsl:copy-of select="@*[name()!='id']" />
							<xsl:attribute name="href">
								<xsl:text>javascript:void(0);</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onclick">
								<xsl:if test="string-length(@onclick) &gt; 0">
									<xsl:value-of select="@onclick"/>
									<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
										<xsl:text>;</xsl:text>
									</xsl:if>
								</xsl:if>
								<xsl:text>return insTableDocRep('</xsl:text>
								<xsl:value-of select="$effectiveTableName"/>
								<xsl:text>','</xsl:text>
								<xsl:value-of select="$blockData/../@codice"/>
								<xsl:text>','</xsl:text>
								<xsl:call-template name="toJSParam">
									<xsl:with-param name="testo" select="$descrizione"/>
								</xsl:call-template>
								<xsl:text>')</xsl:text>
							</xsl:attribute>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:when>
					<xsl:otherwise>
					<!-- sono su un repertorio ma nella pagina specifica della sua tabella di appartenenza -->
						<xsl:copy>
							<xsl:copy-of select="@*[name()!='id']" />
							<xsl:attribute name="href">
								<xsl:text>javascript:void(0);</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onclick">
								<xsl:if test="string-length(@onclick) &gt; 0">
									<xsl:value-of select="@onclick"/>
									<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
										<xsl:text>;</xsl:text>
									</xsl:if>
								</xsl:if>
								<xsl:if test="$hxpdata//repertorio/@cod">
									<xsl:text>return insTableDocRep('</xsl:text>
									<xsl:value-of select="substring-after($hxpdata/@dbTable,'@')"/>
									<xsl:text>','</xsl:text>
									<xsl:value-of select="$hxpdata//repertorio/@cod"/>
									<xsl:text>','</xsl:text>
									<xsl:call-template name="toJSParam">
										<xsl:with-param name="testo" select="$hxpdata//repertorio"/>
									</xsl:call-template>
									<xsl:text>')</xsl:text>
								</xsl:if>
							</xsl:attribute>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="contains($tableName,'-')">
			<!-- inserimento di un nuovo documento con un'estensione alla semplice indicazione della tabella -->
				<xsl:variable name="realTable" select="substring-before($tableName,'-')" />
				<xsl:variable name="extension" select="substring-after($tableName,'-')" />
				<xsl:choose>
					<xsl:when test="$extension='withRep'">
					<!-- si tiene conto del caso in cui il documento sia un repertorio -->
						<xsl:choose>
							<xsl:when test="$hxpdata//repertorio/@cod">
							<!-- siamo in un repertorio -->
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />
									<xsl:attribute name="href">
										<xsl:text>javascript:void(0);</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="onclick">
										<xsl:if test="string-length(@onclick) &gt; 0">
											<xsl:value-of select="@onclick"/>
											<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
												<xsl:text>;</xsl:text>
											</xsl:if>
										</xsl:if>
										<xsl:text>return insTableDocRep('</xsl:text>
										<xsl:value-of select="$realTable"/>
										<xsl:text>','</xsl:text>
										<xsl:value-of select="$hxpdata//repertorio/@cod"/>
										<xsl:text>','</xsl:text>
										<xsl:call-template name="toJSParam">
											<xsl:with-param name="testo">
												<xsl:call-template name="do-replace">
													<xsl:with-param name="text" select="$hxpdata//repertorio"/>
													<xsl:with-param name="replace" select="'&#xa;'"/>
													<xsl:with-param name="by" select="''"/>
												</xsl:call-template>
											</xsl:with-param>
										</xsl:call-template>
										<xsl:text>')</xsl:text>
									</xsl:attribute>
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
									</xsl:call-template>
								</xsl:copy>
							</xsl:when>
							<xsl:otherwise>
							<!-- non siamo in un repertorio -->
								<xsl:copy>
									<xsl:copy-of select="@*[name()!='id']" />

									<xsl:attribute name="href">
										<xsl:text>javascript:void(0);</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="onclick">
										<xsl:if test="string-length(@onclick) &gt; 0">
											<xsl:value-of select="@onclick"/>
											<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
												<xsl:text>;</xsl:text>
											</xsl:if>
										</xsl:if>
										<xsl:text>return insTableDoc('</xsl:text>
										<xsl:value-of select="$realTable"/>
										<xsl:text>')</xsl:text>
									</xsl:attribute>
									<xsl:call-template name="hxpcontinuecontext">
										<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
									</xsl:call-template>
								</xsl:copy>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<!--
						Federico 21/03/2005: apertura di un generico repertorio dato il suo codice e la sua
						descrizione.
						Si suppone che la variabile "extension" abbia la seguente struttura:

							"codRep-<codice>-<descrizione>"

						dove "<codice>" rappresenta il codice del repertorio che si vuole aprire e "<descrizione>"
						la sua descrizione.
					-->
					<xsl:when test="contains($extension,'codRep-')">
						<xsl:variable name="info_rep" select="substring-after($extension,'codRep-')"/>
						<xsl:variable name="codice_rep" select="substring-before($info_rep,'-')"/>
						<xsl:variable name="descr_rep" select="substring-after($info_rep,'-')"/>

						<xsl:copy>
							<xsl:copy-of select="@*[name()!='id']" />
							<xsl:attribute name="href">
								<xsl:text>javascript:void(0);</xsl:text>
							</xsl:attribute>
							<xsl:attribute name="onclick">
								<xsl:if test="string-length(@onclick) &gt; 0">
									<xsl:value-of select="@onclick"/>
									<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
										<xsl:text>;</xsl:text>
									</xsl:if>
								</xsl:if>
								<xsl:text>return insTableDocRep('</xsl:text>
								<xsl:value-of select="$realTable"/>
								<xsl:text>','</xsl:text>
								<xsl:value-of select="$codice_rep"/>
								<xsl:text>','</xsl:text>
								<xsl:call-template name="toJSParam">
									<xsl:with-param name="testo">
										<xsl:call-template name="do-replace">
											<xsl:with-param name="text" select="$descr_rep"/>
											<xsl:with-param name="replace" select="'&#xa;'"/>
											<xsl:with-param name="by" select="''"/>
										</xsl:call-template>
									</xsl:with-param>
								</xsl:call-template>
								<xsl:text>')</xsl:text>
							</xsl:attribute>
							<xsl:call-template name="hxpcontinuecontext">
								<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							</xsl:call-template>
						</xsl:copy>
					</xsl:when>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
			<!-- inserimento di un nuovo documento della tabella specificata (non un repertorio) -->
				<xsl:copy>
					<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
					<xsl:for-each select="@*[name()!='id']">
						<xsl:call-template name="stringparser">
							<xsl:with-param name="data" select="$blockData" />
						</xsl:call-template>
					</xsl:for-each>

					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:if test="string-length(@onclick) &gt; 0">
							<xsl:value-of select="@onclick"/>
							<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
								<xsl:text>;</xsl:text>
							</xsl:if>
						</xsl:if>
						<xsl:text>return insTableDoc('</xsl:text>
						<xsl:value-of select="$tableName"/>
						<xsl:text>')</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* @param blockData contiene l'xml da esaminare
		* @param params parametri da passare alla funzione js 'insDocFromDoc' (def. in 'document.js'). Questi
		*				parametri devono avere la struttura "<dbTable>|[<codice_rep>]|[<descr_rep>]|[<tipologia>]",
		* 				dove i campi tra '[...]' sono opzionali ( comunque necessario metterli vuoti; per es.
		* 				"varie|||tipol_XXX").
		*
		* Questo template aggiunge al nodo corrente una chiamata alla funzione javascript 'insDocFromDoc'
		* che consente di aprire la pagina di inserimento di un documento di tipo differente da quello del
		* documento che si sta visualizzando (RW0027037).<br><br>
		* L'id a cui si fa riferimento e' "hxp-doc-action-insdocfromdoc-<dbTable>|[<codice_rep>]|[<descr_rep>]|[<tipologia>]".
		*
	-->
	<xsl:template name="insdocfromdoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''" />

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return insDocFromDoc('</xsl:text>
				<xsl:value-of select="$params"/>
				<xsl:text>')</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Assegna il documento come radice delle relazioni
	id="hcp-doc-action-relSetRoot"
	-->
	<xsl:template name="docrelsetroot">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return relSetRoot()</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Copia l'elemento contenente l'id se la funzionalit specifica
	     corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	     id="hxp-doc-action-enableFunctionality-(attributo da testare)"
	-->
	<xsl:template name="enableFunctionality">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Scarta il documento dalla vaschetta dei documenti in CC
	   id="hxp-doc-action-scartaDoc" -->
	<xsl:template name="docscartadoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$blockData/@scartabile='true' and not($blockData/@scartato='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return scartaDoc('</xsl:text>
					<xsl:value-of select="$blockData/@cod_persona"/><xsl:text>','</xsl:text>
					<xsl:value-of select="$blockData/@cod_uff"/><xsl:text>','</xsl:text>
					<xsl:value-of select="$blockData/@diritto"/>
					<xsl:text>');</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Va nella pagina di inserimento di un sottofascicolo, inserto o annesso
	   id="hxp-doc-action-docinsertsottofasc" -->
	<xsl:template name="docinsertsottofasc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
					<xsl:if test="string-length(@onclick) &gt; 0">
						<xsl:value-of select="@onclick"/>
						<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
							<xsl:text>;</xsl:text>
						</xsl:if>
					</xsl:if>
					<xsl:text>return insertSottoFasc('</xsl:text>
						<xsl:value-of select="$hxpdata/fascicolo/@numero"/>
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$hxpdata/@physDoc" />
					<xsl:text>','</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="$hxpdata/fascicolo/rif_interni/rif[@diritto='RPA']/@nome_persona" />
					</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="$hxpdata/fascicolo/rif_interni/rif[@diritto='RPA']/@nome_uff" />
					</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="$hxpdata/fascicolo/rif_interni/rif[@diritto='RPA']/@cod_persona" />
					</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="$hxpdata/fascicolo/rif_interni/rif[@diritto='RPA']/@cod_uff" />
					</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata/fascicolo/classif" />
					</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:value-of select="$hxpdata/fascicolo/classif/@cod" />
					<!-- Federico 16/05/07: introdotto tipo del valore contenuto nei campi ufficio [RW 0043770] -->
					<xsl:text>','</xsl:text>
					<xsl:call-template name="quoteString">
						<xsl:with-param name="stringa" select="$hxpdata/fascicolo/rif_interni/rif[@diritto='RPA']/@tipo_uff" />
					</xsl:call-template>
					<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Archivia un fascicolo
	   id="hxp-doc-action-archiviaFascicolo" -->
	<xsl:template name="docarchiviafascicolo">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return archiviaFascicolo();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Apertura un fascicolo
	   id="hxp-doc-action-apriFascicolo" -->
	<xsl:template name="docaprifascicolo">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return apriFascicolo();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Annullamento di un documento
	   id="hxp-doc-action-annullaDoc" -->
	<xsl:template name="docannulladoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return annullaDoc('</xsl:text>
				<xsl:value-of select="$hxpdata//funzionalita_disponibili/@annulladoc"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Valida il documento
	   id="hxp-doc-action-validaDoc" -->
	<xsl:template name="docvalidadoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return validaDoc();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Esegue il chkout del documento
	   id="hxp-doc-action-chkout" -->
	<xsl:template name="docchkout">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">

			<!-- variabile aggiunta da mbussetti il 21/03/2005 per riportare alla pagina di 'nuova versione'
				 anche l'elenco delle conversioni richieste per l'ultima versione dell'allegato corrente
			-->
			<xsl:variable name="convRequested">
				<xsl:for-each select="$blockData/@*[starts-with(name(),'agent.')]">
					<xsl:value-of select="substring-after(name(.),'agent.')"/>
					<xsl:text>;</xsl:text>
				</xsl:for-each>
			</xsl:variable>

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return chkout('</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>','</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@title"/>
				</xsl:call-template>
					<xsl:text>','</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$convRequested"/>
					</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Abbandona un chkout del documento
	   id="hxp-doc-action-abandonChkout" -->
	<xsl:template name="docabandonchkout">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return abandonChkout('</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>','</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@title"/>
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Esegue il chkin di un file
	   id="hxp-doc-action-chkin" -->
	<xsl:template name="docchkin">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return chkin('</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>','</xsl:text>
				<xsl:call-template name="toJSParam">
					<xsl:with-param name="testo" select="$blockData/@title"/>
				</xsl:call-template>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>



	<!-- Apre la pagina con le versioni del file selezionato
	   id="hxp-doc-action-fileVersions" -->
	<xsl:template name="docfileversions">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:variable name="fatherName">
			<xsl:for-each select="$blockData/..">
				<xsl:value-of select="name()"/>
			</xsl:for-each>
		</xsl:variable>

		<!-- 'if' modificato da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi

		<xsl:if test="$fatherName='xw:file'">
		-->
		<xsl:if test="not($blockData/@der_from) and $fatherName='xw:file'">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return fileVersions('</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>

	</xsl:template>

	<!-- Federico 03/10/08: introdotto confronto tra l'ultima e la prima versione di un allegato [RW 0054369] -->
	<xsl:template name="showDiffBetweenVersions">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="expType"   select="''" />

		<!-- Federico 30/10/08: introdotta property per abilitare o meno il confronto tra le versioni di un allegato [RW 0054369] -->
		<xsl:if test="$hxpdata/funzionalita_disponibili/@versionsDiffEnable='true'">
			<xsl:variable name="fatherName">
				<xsl:for-each select="$blockData/..">
					<xsl:value-of select="name()"/>
				</xsl:for-each>
			</xsl:variable>

	 		<xsl:if test="not($blockData/@der_from) and $fatherName='xw:file'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']" />
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return showDiffBetweenVersions('</xsl:text>
						<xsl:value-of select="$blockData/@name"/>
						<xsl:text>','</xsl:text>
						<xsl:value-of select="$expType"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:if>
		</xsl:if>
	</xsl:template>


	<!-- Ripeti nuovo documento
	   id="hxp-doc-action-ripetinuovo"  oppure
	   id="hxp-doc-action-ripetinuovo-(information unit)"
	   -->
	<xsl:template name="docripetinuovo">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''" />
		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']" / -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>

			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return ripetiNuovo('</xsl:text>
				<xsl:value-of select="$params"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<xsl:template name="docedit">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="xparms" select="''"/>
		<xsl:variable name="jcode"><xsl:text>return modificaDocumento('</xsl:text><xsl:value-of select="name($hxpdata/*[1])"/><xsl:text>',</xsl:text><xsl:value-of select="$hxpdata/@pos"/><xsl:text>,</xsl:text><xsl:value-of select="$hxpdata/@count"/><xsl:text>,'</xsl:text><xsl:value-of select="$hxpdata/@selid"/><xsl:text>'</xsl:text><xsl:if test="$xparms!=''"><xsl:text>,</xsl:text><xsl:value-of select="$xparms"/></xsl:if><xsl:text>);</xsl:text></xsl:variable>
		<xsl:call-template name="hxpjhandler">
			<xsl:with-param name="blockData" select="$blockData"/>
			<xsl:with-param name="jcode" select="$jcode"/>
			<xsl:with-param name="benable" select="$isAdmin = '1'"/>
			<xsl:with-param name="hidedisabled" select="'true'"/>
		</xsl:call-template>
	</xsl:template>


	<!-- Visualizza registro di modifiche di documento (comando di motore)
	   id="hxp-doc-action-showRegister" -->
	<xsl:template name="docshowregister">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=viewregister&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;physDoc=</xsl:text>
				<xsl:value-of select="$hxpdata/@physDoc"/>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Visualizza Storia
	   id="hxp-doc-action-docshowhistory"  oppure
	   id="hxp-doc-action-docshowhistory-(attribute di ordinamento)"
	   -->
	<xsl:template name="docshowhistory">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return showHistory('</xsl:text>
				<xsl:value-of select="$params"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!--
		Produzione di una stampa in pdf id="hxp-doc-action-printPdf"

		Federico 11/01/06: sarebbe piu' opportuno usare l'id "hxp-doc-action-printProfiles".

		@deprecated
	-->
	<xsl:template name="docprintpdf">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>

		<xsl:call-template name="docPrintProfiles">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
		</xsl:call-template>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* created on: 11/01/06
		*
		* @param blockData contiene l'xml da esaminare
		*
		* Questo template gestisce l'id 'hxp-doc-action-printProfiles', sostituendolo con la chiamata
		* alla funzione javascript che apre la pagina dei profili di stampa.
		*
	-->
	<xsl:template name="docPrintProfiles">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>

		<xsl:copy>
			<!-- VM 14/03/2006 xsl:copy-of select="@*[name()!='id']"/ -->
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>


			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return printProfiles();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Copia elemento contenente l'id se il file  firmato
	   id="hxp-doc-action-fileIsSigned"
	   -->
	<xsl:template name="docfileissigned">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="contains($blockData/@name,'.p7m') or
                              contains($blockData/@name,'.s@s') or $blockData/@force_sign='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="docfileiscrypted">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="contains($blockData/@name,'.c@s')">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Mostra le informazioni sulla firma di un file
	   id="hxp-doc-action-showSign"
	   -->
	<xsl:template name="docshowsign">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraFirma(false,'</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="docshowreaders">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return mostraLettori(false,'</xsl:text>
				<xsl:value-of select="$blockData/@name"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Rigetta il documento al protocollista
	   id="hxp-doc-action-rigetta"
	   -->
	<xsl:template name="docrigetta">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return rigetta();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Invio telematico del documento a casella di posta certificata
	   id="hxp-doc-action-invioTelematico"
	   DD 17/01/06 - Cambiato l'indice del riferimento: adesso  valorizzato non pi in base alla posizione
	   di viusalizzazione ma in base all'attributo @idx di rif.
	-->
	<xsl:template name="docinvioTelematico">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return invioTelematico('</xsl:text>
				<xsl:value-of select="$blockData/@idx"/>
				<xsl:text>',</xsl:text>
				<xsl:choose>
					<xsl:when test="count($blockData/interoperabilita[@name!=''])>0">
						<xsl:text>true</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>false</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Federico 08/07/09: invio multiplo ai destinatari interni (interoperabilita' con i ws) [M 0000498] -->
	<xsl:template name="invioTelematicoWSDestIntMultiplo">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return invioTelematicoWSDestIntMultiplo(</xsl:text>
				<xsl:choose>
					<xsl:when test="count($blockData//interoperabilita[@name!=''])>0">
						<xsl:text>true</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>false</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Federico 18/12/09: invio multiplo a destinatari PEC [EF 492] -->
	<xsl:template name="invioTelematicoPECMultiplo">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']"/>
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return invioTelematicoPECMultiplo(</xsl:text>
				<xsl:choose>
					<xsl:when test="count($blockData//interoperabilita[@name!=''])>0">
						<xsl:text>true</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:text>false</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 06/12/2004
		* Last modified on: 16/06/2005
		*
		* Questo template mostra le molliche associate a un documento relative alla classificazione "elemName".
		* Ogni mollica corrisponde a codice xml con la seguente struttura:<br><br>
		* 		&lt;thPath cPath="cPath_della_mollica" thChannel="canale_del_th_da_usare" searchAlias="alias_per_la_ricerca"
				classifElemName="nome_elemento_xml"&gt;<br>
	 	* 			&lt;thnode name="nome_del_nodo_da_visualizzare_nella_mollica" pos="posizione_nella_mollica"
	 	* 				link="y|n"/&gt;<br>
	 	* 			&lt;thnode .../&gt;<br>
	 	* 			...<br>
	 	* 		&lt;/thPath&gt;<br>
	 	* <br><br>
	 	* thPath indica l'elemento che identifica la mollica. Esso ha come attributi:<br><br>
	 	*
	 	* - cPath: indica il cPath associato alla mollica corrente. Questa informazione pu essere utile per la
	 	* 			navigazione del thesauro mediante la mollica, quando una pagina possiede pi molliche.
	 	* 			In tal caso  utile avere il cPath associato a ogni mollica del documento.<br>
	 	* - thChannel: indica il canale del thesauro (chiave) da utilizzare.<br>
	 	* - searchAlias (opzionale): indica l'alias per la ricerca da usare quando  necessario effettuare
	 	* 							  una ricerca una volta arrivati a una foglia del thesauro.<br>
	 	* - classifElemName: indica il nome dell'elemento xml relativo alla classificazione del documento a cui si
	 						 riferisce la mollica.<br><br>
	 	*
		* Una mollica  costituita da uno o pi thnode i cui parametri sono:<br><br>
		*  - name: indica il nome del nodo da visualizzare nella mollica;<br>
		*  - pos: indica la posizione nella mollica (0, 1, ...). I thnode vengono ordinati dall'xsl in base a
		*		   questo parametro;<br>
		*  - link: indica se visualizzare o meno un link che consente di posizionarsi sul nodo (i valori
		* 			possibili sono y e n). Attualmente solo l'ultimo nodo del percorso (che indica la posizione
		* 			attuale) non ha un link.
		* <br><br>
		*
		* Modifica di Federico del 02/12/2004:<br>
		* qualora sia attivata la navigazione multilingua del thesaurus, viene cercata la traduzione nella
		* lingua corrente del termine contenuto nell'attributo 'name'. Se la traduzione viene trovata, essa
		* viene inserita come contenuto del nodo thnode; se , invece, la traduzione non viene trovata, l'elemento
		* thnode risulta essere vuoto.<br><br>
		*
		* Modifica di Federico del 12/01/2005:<br>
		* viene effettuata un'iterazione di tutti i nodi "thPath" il cui attributo "classifElemName" coincide con
		* "elemName" e, se e' stato specificato anche un canale del thesauro, il cui attributo "thChannel" coincide
		* con la var. "thChannel".
		*
		* Modifica di Federico del 16/06/2005:<br>
		* se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL per aprire il th.
		* gerarchico. In questo caso, quando si passa nella pagina del th. gerarchico dopo aver cliccato su una parte
		* di una mollica, non viene mostrata la mollica del thesauro, dato che nell'url inserito al posto del js
		* non viene passata la tupla cPath. Questa scelta e' stata fatta per semplificare la parte xsl, poiche'
		* la trasmissione di cPath richiederebbe un'operazione di troncamento della tupla nella posizione opportuna,
		* cosa non semplice in xsl (il js, ovviamente, effettua questa operazione...).
	-->
	<xsl:template name="docBuildThPaths">
		<xsl:param name="classifType" select="''"/>

		<!--
			Modifica di Federico del 12/01/2005: 'classifType' puo' essere nelle seguenti forme:

			- 'nome_elemento_xml'
			- 'nome_elemento_xml-canale_del_thesauro'

			In questo modo  possibile specificare non solo il nome dell'elemento xml relativo alla
			classificazione di cui si vogliono mostrare le molliche, ma anche un preciso canale di thesauro.
			E', per esempio, possibile specificare '-classif-infogiovani', che significa: mostra, tra tutte
			le molliche relative alla classificazione 'classif', solo quelle associate al canale 'infogiovani'.
		-->
		<xsl:variable name="elemName"> <!-- nome dell'elemento xml -->
			<xsl:choose>
				<xsl:when test="$classifType!='' and contains($classifType, '-')">
					<xsl:value-of select="substring-before($classifType, '-')"/>
				</xsl:when>
				<xsl:when test="$classifType!='' and not(contains($classifType, '-'))">
					<xsl:value-of select="$classifType"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="thChannel"> <!-- eventuale canale del thesauro -->
			<xsl:choose>
				<xsl:when test="$classifType!='' and contains($classifType, '-')">
					<xsl:value-of select="substring-after($classifType, '-')"/>
				</xsl:when>
				<xsl:when test="$classifType!='' and not(contains($classifType, '-'))">
					<xsl:value-of select="''"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>

		<!--
			iterazione sulle molliche relative alla classificazione rappresentata da "elemName", cio i nodi
			'thPath' con '@classifElemName=$elemName'
		-->
		<xsl:for-each select="$hxpdata//*[name()='thPath' and @classifElemName=$elemName and (($thChannel!='' and @thChannel=$thChannel) or ($thChannel='' and @thChannel!=''))]">
			<xsl:variable name="channel" select="@thChannel"/> <!-- canale del th -->
			<xsl:variable name="alias" select="@searchAlias"/> <!-- alias per la ricerca -->
			<xsl:variable name="cPath" select="@cPath"/> 	   <!-- cPath associato alla mollica -->

			<!-- iterazione su ogni elemento della mollica esplorata -->
			<xsl:for-each select="./*">
				<xsl:sort select="@pos" data-type="number" order="ascending"/>
				<xsl:text> / </xsl:text>
				<a>
					<xsl:attribute name="href">
						<!--
							Federico 16/06/05:
							se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
							per aprire il th. gerarchico.
						-->
						<xsl:choose>
							<xsl:when test="$nojs!='1'">
								<xsl:text>javascript:void(0);</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<!-- inserimento dell'url al posto della chiamata js -->
								<xsl:value-of select="$hxpdata/@uri"/>
								<xsl:text>?db=</xsl:text>
								<xsl:value-of select="$hxpdata/@db"/>
								<xsl:text>&amp;transformJava=</xsl:text>
								<xsl:value-of select="$hxpdata/@transformJava"/>
								<xsl:text>&amp;verbo=showthes&amp;xverb=@NT</xsl:text>
								<xsl:text>&amp;view=</xsl:text>
								<xsl:value-of select="$hxpdata/@view"/>
								<xsl:text>&amp;enableIW=</xsl:text>
								<xsl:value-of select="$hxpdata/@enableIW"/>
								<xsl:text>&amp;toDo=set_minFreq_for_TH_navigation:1&amp;keypath=</xsl:text>
								<xsl:value-of select="$channel"/>
								<xsl:text>&amp;startkey=</xsl:text>
								<xsl:value-of select="@name"/>
								<xsl:if test=".!=''">
									<xsl:text> - </xsl:text>
									<xsl:value-of select="."/>
								</xsl:if>
								<xsl:text>&amp;relation=NT&amp;xMode=</xsl:text>
								<xsl:value-of select="$alias"/>

								<!-- dati di autenticazione -->
								<xsl:call-template name="aclparams"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>

					<!--
						Federico 16/06/05:
						se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
						per aprire il th. gerarchico.
					-->
					<xsl:if test="$nojs!='1'">
						<xsl:attribute name="onclick">
							<xsl:text>return showthesRel("NT","</xsl:text>
							<xsl:value-of select="$channel"/> <!-- canale del th -->
							<xsl:text>","</xsl:text>
							<!--
								visualizzazione dell'eventuale traduzione del termine del thesaurus
								(navigazione multilingua del th)
							-->
							<xsl:value-of select="@name"/>
							<xsl:if test=".!=''">
								<xsl:text> - </xsl:text>
								<xsl:value-of select="."/>
							</xsl:if>
							<xsl:text>","</xsl:text>
							<xsl:value-of select="$alias"/> <!-- alias per la ricerca -->
							<xsl:text>","</xsl:text>
							<xsl:value-of select="$cPath"/> <!-- cPath che rappresenta la mollica -->
							<xsl:text>","</xsl:text>
							<xsl:value-of select="@pos"/>	<!-- posizione nel cPath a cui saltare -->
							<xsl:text>");</xsl:text>
						</xsl:attribute>
					</xsl:if>
					<!--
						Se la tupla cPath trasmessa in ricerca  uguale a quella
						associata alla mollica che si sta analizzando, occorre evidenziare la mollica corrente.
					-->
					<xsl:variable name="c1" select="translate($cPath, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>
					<xsl:variable name="c2" select="translate($hxpdata/@cPath, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>

					<xsl:choose>
						<!--xsl:when test="contains($c1,$c2)">-->
						<xsl:when test="$c1=$c2">
							<!-- uso del bold per la mollica -->
							<b>
								<xsl:value-of select="@name"/>
								<!--
									visualizzazione dell'eventuale traduzione del termine del thesaurus
									(navigazione multilingua del th)
								-->
								<xsl:if test=".!=''">
									<xsl:text> - </xsl:text>
									<xsl:value-of select="."/>
								</xsl:if>
							</b>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="@name"/>
							<!--
								visualizzazione dell'eventuale traduzione del termine del thesaurus
								(navigazione multilingua del th) senza bold
							-->
							<xsl:if test=".!=''">
								<xsl:text> - </xsl:text>
								<xsl:value-of select="."/>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</a>
				<!--
				  	Il seguente a capo serve per evitare che vengano generate delle linee troppo
				  	lunghe che possono essere troncate con line break dal parser (e ci pu creare
				  	problemi in html, basti pensare alle chiamate javascript).
				-->
				<xsl:text>&#xA;</xsl:text>
			</xsl:for-each>
			<!-- fine visualizzazione dell'xml della mollica -->
			<br/>
		</xsl:for-each>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 06/12/2004
		* Last modified on: 16/06/2005
		*
		* Questo template effettua le stesse operazioni del template "docBuildThPaths", senza visualizzare i
		* codici dei termini del thesauro.
	-->
	<xsl:template name="docBuildThPathsNoCode">
		<xsl:param name="classifType" select="''"/>

		<!--
			Modifica di Federico del 12/01/2005: 'classifType' puo' essere nelle seguenti forme:

			- 'nome_elemento_xml'
			- 'nome_elemento_xml-canale_del_thesauro'

			In questo modo  possibile specificare non solo il nome dell'elemento xml relativo alla
			classificazione di cui si vogliono mostrare le molliche, ma anche un preciso canale di thesauro.
			E', per esempio, possibile specificare '-classif-infogiovani', che significa: mostra, tra tutte
			le molliche relative alla classificazione 'classif', solo quelle associate al canale 'infogiovani'.
		-->
		<xsl:variable name="elemName">
			<xsl:choose>
				<xsl:when test="$classifType!='' and contains($classifType, '-')">
					<xsl:value-of select="substring-before($classifType, '-')"/>
				</xsl:when>
				<xsl:when test="$classifType!='' and not(contains($classifType, '-'))">
					<xsl:value-of select="$classifType"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="thChannel">
			<xsl:choose>
				<xsl:when test="$classifType!='' and contains($classifType, '-')">
					<xsl:value-of select="substring-after($classifType, '-')"/>
				</xsl:when>
				<xsl:when test="$classifType!='' and not(contains($classifType, '-'))">
					<xsl:value-of select="''"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>

		<!--
			iterazione sulle molliche relative alla classificazione rappresentata da "elemName", cio i nodi
			'thPath' con '@classifElemName=$elemName'
		-->
		<xsl:for-each select="$hxpdata//*[name()='thPath' and @classifElemName=$elemName and (($thChannel!='' and @thChannel=$thChannel) or ($thChannel='' and @thChannel!=''))]">
			<xsl:variable name="channel" select="@thChannel"/> <!-- canale del th -->
			<xsl:variable name="alias" select="@searchAlias"/> <!-- alias per la ricerca -->
			<xsl:variable name="cPath" select="@cPath"/> 	   <!-- cPath associato alla mollica -->

			<!-- iterazione su ogni elemento della mollica esplorata -->
			<xsl:for-each select="./*">
				<xsl:sort select="@pos" data-type="number" order="ascending"/>
				<xsl:text> / </xsl:text>
					<a>
						<xsl:attribute name="href">
							<!--
								Federico 16/06/05:
								se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
								per aprire il th. gerarchico.
							-->
							<xsl:choose>
								<xsl:when test="$nojs!='1'">
									<xsl:text>javascript:void(0);</xsl:text>
								</xsl:when>
								<xsl:otherwise>
									<!-- inserimento dell'url al posto della chiamata js -->
									<xsl:value-of select="$hxpdata/@uri"/>
									<xsl:text>?db=</xsl:text>
									<xsl:value-of select="$hxpdata/@db"/>
									<xsl:text>&amp;transformJava=</xsl:text>
									<xsl:value-of select="$hxpdata/@transformJava"/>
									<xsl:text>&amp;verbo=showthes&amp;xverb=@NT</xsl:text>
									<xsl:text>&amp;view=</xsl:text>
									<xsl:value-of select="$hxpdata/@view"/>
									<xsl:text>&amp;enableIW=</xsl:text>
									<xsl:value-of select="$hxpdata/@enableIW"/>
									<xsl:text>&amp;toDo=set_minFreq_for_TH_navigation:1&amp;keypath=</xsl:text>
									<xsl:value-of select="$channel"/>
									<xsl:text>&amp;startkey=</xsl:text>
									<xsl:value-of select="@name"/>
									<xsl:if test=".!=''">
										<xsl:text> - </xsl:text>
										<xsl:value-of select="."/>
									</xsl:if>
									<xsl:text>&amp;relation=NT&amp;xMode=</xsl:text>
									<xsl:value-of select="$alias"/>

									<!-- dati di autenticazione -->
									<xsl:call-template name="aclparams"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>

						<!--
							Federico 16/06/05:
							se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL
							per aprire il th. gerarchico.
						-->
						<xsl:if test="$nojs!='1'">
							<xsl:attribute name="onclick">
								<xsl:text>return showthesRel("NT","</xsl:text>
								<xsl:value-of select="$channel"/> <!-- canale del th -->
								<xsl:text>","</xsl:text>
								<!--
									visualizzazione dell'eventuale traduzione del termine del thesaurus
									(navigazione multilingua del th)
								-->
								<xsl:value-of select="@name"/>
								<xsl:if test=".!=''">
									<xsl:text> - </xsl:text>
									<xsl:value-of select="."/>
								</xsl:if>
								<xsl:text>","</xsl:text>
								<xsl:value-of select="$alias"/> <!-- alias per la ricerca -->
								<xsl:text>","</xsl:text>
								<xsl:value-of select="$cPath"/> <!-- cPath che rappresenta la mollica -->
								<xsl:text>","</xsl:text>
								<xsl:value-of select="@pos"/>	<!-- posizione nel cPath a cui saltare -->
								<xsl:text>");</xsl:text>
							</xsl:attribute>
						</xsl:if>
						<!--
							Se la tupla cPath trasmessa in ricerca  uguale a quella
							associata alla mollica che si sta analizzando, occorre evidenziare la mollica corrente.
						-->
						<xsl:variable name="c1" select="translate($cPath, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>
						<xsl:variable name="c2" select="translate($hxpdata/@cPath, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')"/>

						<xsl:choose>
							<!--<xsl:when test="contains($c1,$c2)">-->
							<xsl:when test="$c1=$c2">
								<!-- uso del bold per la mollica -->
								<b>
									<!--
										visualizzazione dell'eventuale traduzione del termine del thesaurus
										(navigazione multilingua del th)
									-->
									<xsl:choose>
										<xsl:when test=".!=''">
											<!-- visualizzazione della traduzione -->
											<xsl:value-of select="."/>
										</xsl:when>
										<xsl:otherwise>
											<!-- visualizzazione della chiave -->
											<xsl:choose>
												<xsl:when test="contains(@name,' - ')">
													<xsl:value-of select="substring-after(@name,' - ')"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:value-of select="@name"/>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:otherwise>
									</xsl:choose>
								</b>
							</xsl:when>
							<xsl:otherwise>
								<!--
									visualizzazione dell'eventuale traduzione del termine del thesaurus
									(navigazione multilingua del th) senza bold
								-->
								<xsl:choose>
									<xsl:when test=".!=''">
										<!-- visualizzazione della traduzione -->
										<xsl:value-of select="."/>
									</xsl:when>
									<xsl:otherwise>
										<!-- visualizzazione della chiave -->
										<xsl:choose>
											<xsl:when test="contains(@name,' - ')">
												<xsl:value-of select="substring-after(@name,' - ')"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="@name"/>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</a>
					<!--
					  	Il seguente a capo serve per evitare che vengano generate delle linee troppo
					  	lunghe che possono essere troncate con line break dal parser (e ci pu creare
					  	problemi in html, basti pensare alle chiamate javascript).
					-->
					<xsl:text>&#xA;</xsl:text>
			</xsl:for-each>
			<!-- fine visualizzazione dell'xml della mollica -->
			<br/>
		</xsl:for-each>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 06/04/2005
		*
		* Questo template gestisce l'id 'hxp-doc-action-getLinkedDocs-[queryBehaviour]-[info]-[query]' inserendo
		* al suo posto una chiamata js alla funzione 'getLinkedDocs' (document.js generico).<br>
		* 'getLinkedDocs' consente di recuperare dei documenti collegati a quello che si sta per visualizzare
		* con la Showdoc mediante la query indicata da '[query]'.<br>
		* '[info]' contiene, invece, delle informazioni generiche che e' possibile mostrare in visualizzazione
		* (per es. un titolo da mostrare prima dell'elenco dei documenti trovati).
		* '[queryBehaviour]' indica se restituire i titoli sempre oppure solo nel caso in cui vengano trovati
		* pi documenti (valori possibili "forceShowTitles" o "normal").
		*
		* @param blockData xml da esaminare.
		* @param params stringa "[queryBehaviour]-[info]-[query]".
	-->
	<xsl:template name="docGetLinkedDocs">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>

		<!-- Federico 22/06/05: introdotta variabile 'queryBehaviour' -->
		<xsl:variable name="queryBehaviour" select="substring-before($params, '-')"/>
		<xsl:variable name="infoAndQuery" select="substring-after($params, '-')"/>
		<xsl:variable name="query" select="substring-after($infoAndQuery, '-')"/>
		<xsl:variable name="info" select="substring-before($infoAndQuery, '-')"/>

		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:if test="string-length(@onclick) &gt; 0">
					<xsl:value-of select="@onclick"/>
					<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
						<xsl:text>;</xsl:text>
					</xsl:if>
				</xsl:if>
				<xsl:text>return getLinkedDocs('</xsl:text>
				<xsl:value-of select="$query"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$info"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$queryBehaviour"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 11/04/2005
		*
		* Questo template gestisce l'id 'hxp-doc-action-showLinkedDoc[-xDoc]'
		* inserendo al suo posto una chiamata js alla funzione 'showLinkedDoc' (document.js generico).<br>
		* 'showLinkedDoc' consente di passare alla visualizzazione di uno dei documenti collegati a quello
		* visualizzato.<br>
		* E' possibile specificare delle estensioni per il caricamento del documento che si vuole visualizzare
		* mediante il parametro opzionale 'xDoc'.
		*
		* @param blockData xml da esaminare.
		* @param params eventuali estensioni da usare per il caricamento di un documento collegato.
	-->
	<xsl:template name="showLinkedDoc">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="params" select="''"/>

		<!-- Federico 03/04/06: se il doc. corrispondente al titolo non  visibile, non mostro il titolo [RW 0035753] -->
		<xsl:if test="not($blockData/@visible) or $blockData/@visible!='false'">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>

				<xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>

				<xsl:choose>
					<xsl:when test="$blockData/@db!=''">
						<xsl:choose>
							<xsl:when test="$blockData/@db='titlex'">
								<xsl:attribute name="style"><xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="onclick">
								<xsl:if test="string-length(@onclick) &gt; 0">
									<xsl:value-of select="@onclick"/>
									<xsl:if test="contains(substring(normalize-space(@onclick), string-length(normalize-space(@onclick)), 1), ';') = false">
										<xsl:text>;</xsl:text>
									</xsl:if>
								</xsl:if>
								<xsl:text>return showLinkedDoc(</xsl:text><xsl:value-of select="number($blockData/@indice) - 1"/><xsl:text>, '</xsl:text><xsl:value-of select="$blockData/@db" /><xsl:text>',0,'</xsl:text><xsl:value-of select="$params" /><xsl:text>');</xsl:text></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="_doctype" select="/response/@db" />

						<xsl:choose>
							<xsl:when test="string($_doctype)='titlex'">
								<xsl:attribute name="style"><xsl:text>text-decoration:none;cursor:default;color:black;font-family:san-serif;font-size:110%;</xsl:text></xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="onclick"><xsl:text>return showLinkedDoc(</xsl:text><xsl:value-of select="number($blockData/@indice) - 1"/><xsl:text>, '</xsl:text><xsl:value-of select="$_doctype" /><xsl:text>',0,'</xsl:text><xsl:value-of select="$params" /><xsl:text>');</xsl:text></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>

				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 16/06/2005
		*
		* Questo template gestisce l'id 'hxp-doc-action-showXLink-...' che mostra il contenuto di un elemento
		* "xlink" inserendo un'ancora contenente una chiamata js o un url a seconda di quanto indicato nella
		* variabile globale "nojs".<br>
		* Il tipo dell'xlink indica cosa aprire: un normale url o un documento dato il suo nrecord.<br>
		* Qualora sia necessario non usare il javascript (nojs='1'), per capire se l'xlink rappresentato da
		* 'blockData' contiene l'nrecord di un documento viene invocato il template custom "customLinkIsNRecord".<br>
		* Inoltre, se nojs='1' per aprire gli url/documenti non vengono aperte nuove finestre e non e' possibile
		* utilizzare viste particolari (cosa che, invece, il javascript consente di fare).
		*
		* @param blockData	xml da esaminare.
		* @param jsparams 	eventuali parametri da passare alla funzione javascript (usato solo se nojs!='1').
	-->
	<xsl:template name="docShowXLink">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="jsparams" select="''"/>

		<a>
			<xsl:attribute name="href">
				<!-- se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL -->
				<xsl:choose>
					<xsl:when test="$nojs!='1'">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<!-- inserimento dell'url al posto della chiamata js -->

						<!-- indica se il link e' un nrecord o no -->
						<xsl:variable name="isNrecord">
							<!-- chiamata a un template specifico di applicazione -->
							<xsl:apply-templates select="$blockData" mode="xlinkTypeTest">
								<xsl:with-param name="xlinkType" select="$blockData/@type"/>
							</xsl:apply-templates>
						</xsl:variable>

						<xsl:choose>
							<xsl:when test="$isNrecord='true'">
								<!-- visualizzazione doc. dato il suo nrecord -->
								<xsl:value-of select="$hxpdata/@uri"/>
								<xsl:text>?db=</xsl:text>
								<xsl:value-of select="$hxpdata/@db"/>
								<xsl:text>&amp;transformJava=</xsl:text>
								<xsl:value-of select="$hxpdata/@transformJava"/>
								<xsl:text>&amp;verbo=queryplain&amp;view=</xsl:text>
								<xsl:value-of select="$hxpdata/@view"/>
								<xsl:text>&amp;enableIW=</xsl:text>
								<xsl:value-of select="$hxpdata/@enableIW"/>
								<xsl:text>&amp;query=[doc_nrecord]=</xsl:text>
								<xsl:value-of select="$blockData/@href"/>

								<!-- dati di autenticazione -->
								<xsl:call-template name="aclparams"/>
							</xsl:when>
							<xsl:otherwise>
								<!-- visualizzazione di un normale link -->
								<xsl:if test="not(starts-with($blockData/@href,'http://') or starts-with($blockData/@href,'mailto:'))">
									<xsl:text>http://</xsl:text>
								</xsl:if>
								<xsl:value-of select="$blockData/@href"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>

			<!-- se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL. -->
			<xsl:if test="$nojs!='1'">
				<xsl:attribute name="onclick">
					<xsl:text>return openUrl("</xsl:text>
					<xsl:value-of select="$blockData/@href"/>
					<xsl:text>","</xsl:text>
					<xsl:value-of select="$blockData/@type"/>
					<xsl:text>"</xsl:text>
					<xsl:if test="$jsparams!=''">
						<xsl:text>, </xsl:text>
						<xsl:value-of select="$jsparams"/>
					</xsl:if>
					<xsl:text>);</xsl:text>
				</xsl:attribute>
			</xsl:if>
			<!-- testo da mostrare nel link -->
			<xsl:value-of select="$blockData/@href"/>
		</a>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 21/06/2005
		*
		* Questo template viene invocato, quando la variabile globale "nojs" e' uguale a '1', dal template generico
		* "docShowXLink" per capire se un xlink rappresenta o meno un nrecord.<br>
		* Questa implementazione generica restituisce sempre false, indipendentemente dal valore di 'xlinkType'.<br>
		* Per avere un comportamento differente occorre definire un template analogo a livello specifico
		* con priorita' > -1.
		*
		* @param xlinkType tipo dell'xlink che si sta esaminando.
	-->
	<xsl:template match="xlink" mode="xlinkTypeTest" priority="-1">
		<xsl:param name="xlinkType" select="''"/>

		<xsl:text>false</xsl:text>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 16/06/2005
		*
		* Questo template gestisce l'id 'hxp-doc-action-openUrl-urlXPath' inserendo un'ancora contenente una
		* chiamata js o un url a seconda di quanto indicato nella variabile globale "nojs".<br>
		* 'urlXPath' rappresenta l'xpath rispetto al contesto corrente ('blockData') del nodo (elemento o
		* attributo) che contiene l'url da visualizzare in una nuova finestra.<br>
		*
		* @param blockData	xml da esaminare.
		* @param urlPath 	xpath rispetto al contesto corrente ('blockData') del nodo (elemento o attributo)
		* 					che contiene l'url da visualizzare.<br>
		*					L'xpath puo' essere 'elemento', '@attributo', 'elemento/@attributo'.
	-->
	<xsl:template name="docOpenUrl">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="urlPath" select="''" />

		<xsl:if test="$urlPath!=''">
			<xsl:variable name="url">
				<xsl:call-template name="hxpcontent">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
	  				<xsl:with-param name="elemName" select="$urlPath" />
				</xsl:call-template>
			</xsl:variable>

			<xsl:if test="$url!=''">
				<!-- Federico 19/07/05: rimosso il target dall'anchor dato che tale attr. non esiste in strict xhtml -->
				<a>
					<xsl:attribute name="href">
						<!-- se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL -->
						<xsl:choose>
							<xsl:when test="$nojs!='1'">
								<xsl:text>javascript:void(0);</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<!-- inserimento dell'url al posto della chiamata js -->
								<xsl:if test="not(starts-with($url,'http://') or starts-with($url,'mailto:'))">
									<xsl:text>http://</xsl:text>
								</xsl:if>
								<xsl:value-of select="$url"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>

					<!-- se la var. globale "nojs" e' "1", al posto di un link javascript viene inserito un URL. -->
					<xsl:if test="$nojs!='1'">
						<xsl:attribute name="onclick">
							<xsl:text>return openUrl("</xsl:text>
							<xsl:value-of select="$url"/>
							<xsl:text>");</xsl:text>
						</xsl:attribute>
					</xsl:if>
					<!-- testo da mostrare nel link -->
					<xsl:value-of select="$url"/>
				</a>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 07/04/2005
		*
		* Questo template gestisce l'id "hxp-doc-titlevispart-(num)" e consente di visualizzare la (num)esima parte
		* di un titolo. <br>
	    * Si assume che il titolo abbia il '|' come separatore.<br>
		*
		* @param blockData xml da esaminare.
		* @param partnum 	posizione dell'elemento del titolo da visualizzare (parte da 1).
		* @param iternum 	contatore per le iterazioni sul testo del titolo.
		* @param testo 		testo del titolo da esaminare. Il valore di default e' il contenuto dell'attributo 'testo'
		*					dell'elemento corrente.
		* @param visdata 	indica se cio' che si vuole visualizzare e' una data. In caso affermativo formatta la
		*					data.<br>
		*					I valori possibili sono '0' e '1'.
	-->
	<xsl:template name="titlevispart">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="partnum" select="'1'" />
		<xsl:param name="iternum" select="'1'" />
		<xsl:param name="testo" select="$blockData/@testo" />
		<xsl:param name="visdata" select="'0'" />
		<xsl:choose>
			<xsl:when test="$iternum=$partnum">
				<xsl:choose>
					<xsl:when test="substring-after($testo,'|')!=''">
						<xsl:choose>
							<xsl:when test="$visdata='1'">
								<xsl:if test="not(starts-with($testo,'~'))">  <!-- capita in conversione di doc -->
									<xsl:call-template name="dateformatter">
										<xsl:with-param name="datas" select="substring-before($testo,'|')"/>
									</xsl:call-template>
								</xsl:if>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="substring-before($testo,'|')"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$visdata='1'">
								<xsl:if test="not(starts-with($testo,'~'))">  <!-- capita in conversione di doc -->
									<xsl:call-template name="dateformatter">
										<xsl:with-param name="datas" select="$testo"/>
									</xsl:call-template>
								</xsl:if>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$testo"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
				<!-- introduced by Mario per la descrizione dei repertori -->
				<xsl:if test="$partnum='12' and not($testo='') and not(starts-with($testo,'|'))">
					<xsl:copy>
						<br/>
					</xsl:copy>
				</xsl:if>
				<!-- end introduced by Mario -->
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="titlevispart">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="partnum" select="$partnum" />
					<xsl:with-param name="iternum" select="$iternum+1" />
					<xsl:with-param name="testo" select="substring-after($testo,'|')" />
					<xsl:with-param name="visdata" select="$visdata" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
		* @author Federico Grillini
		*
		* @version 1.0
		*
		* Created on: 29/06/05
		*
		* Questo template gestisce l'id "hxp-doc-action-formatNumber-xpath-formatStr" che consente di formattare
		* un campo numerico con eventuali decimali.<br>
		* La stringa restituita risulta essere un numero con separatori '.' per le migliaia e ',' per i decimali.
		* Inoltre, la formattazione di default impone un numero di decimali pari a due anche se il numero non ne
		* possiede.<br>
		* Se la stringa da formattare e' vuota o non e' un numero, essa viene restituita cosi' come e'.
		*
		* @param blockData 			xml da esaminare.
		* @param xpath-formatStr 	stringa contenente l'xpath (elemento/@attributo, elemento, @attributo)
		*							del nodo che contiene il dato numerico e la stringa che indica la
		*							formattazione da usare (per questa fare riferimento alla documentazione
		*							della funzione xsl 'format-number').<br>
		*							Se 'formatStr' vale 'def', viene usata la formattazione di default
		*							'###,###.00'.
	-->
	<xsl:template name="docFormatNumber">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="xpath-formatStr" select="''" />

		<xsl:if test="$xpath-formatStr!=''">
			<xsl:variable name="xpath" select="substring-before($xpath-formatStr,'-')"/>
			<xsl:variable name="formatStr">
				<xsl:variable name="tmp" select="substring-after($xpath-formatStr,'-')"/>

				<xsl:choose>
					<xsl:when test="$tmp='def'">
						<!--
							il chiamante non ha indicato una formattazione; uso quella di default
							(separatore per le migliaia e 2 decimali. Es: 1,253.48).
						-->
						<xsl:text>###,###.00</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<!-- il chiamante ha indicato una formattazione -->
						<xsl:value-of select="$tmp"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<!-- recupero il valore del nodo indicato da xpath -->
			<xsl:variable name="strvalue">
				<xsl:call-template name="hxpcontent">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
	  				<xsl:with-param name="elemName" select="$xpath" />
				</xsl:call-template>
			</xsl:variable>

			<!-- controllo se 'strvalue' e' non vuota e contiene un numero (anche con ',' o '.') -->
			<xsl:choose>
				<xsl:when test="$strvalue!='' and string-length(translate($strvalue,'0123456789,.',''))=0">
				<xsl:variable name="numericValue">
					<xsl:choose>
						<xsl:when test="contains($strvalue,',')">
							<!-- numero con virgola; la sostituisco con '.' -->
							<xsl:variable name="validNumber">
								<xsl:call-template name="str:subst">
								     <xsl:with-param name="text" select="$strvalue"/>
								     <xsl:with-param name="replace" select="','"/>
								     <xsl:with-param name="with" select="'.'"/>
								</xsl:call-template>
							</xsl:variable>
							<xsl:value-of select="number($validNumber)"/>
						</xsl:when>
						<xsl:otherwise>
							<!-- numero senza virgola -->
							<xsl:value-of select="number($strvalue)"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>

				<!-- formattazione del numero -->
				<xsl:variable name="formattedNumber" select="format-number($numericValue,$formatStr)"/>

				<!-- il separatore delle migliaia deve essere '.'; quello dei decimali ',' -->
				<xsl:variable name="parteIntera">
					<xsl:call-template name="str:subst">
					     <xsl:with-param name="text" select="substring-before($formattedNumber,'.')"/>
					     <xsl:with-param name="replace" select="','"/>
					     <xsl:with-param name="with" select="'.'"/>
					</xsl:call-template>
				</xsl:variable>

				<xsl:variable name="parteDecimale">
					<xsl:value-of select="substring-after($formattedNumber,'.')"/>
				</xsl:variable>

				<xsl:choose>
					<xsl:when test="$parteIntera=''">
						<xsl:text>0</xsl:text>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$parteIntera"/>
					</xsl:otherwise>
				</xsl:choose>

				<xsl:if test="$parteDecimale!=''">
					<xsl:text>,</xsl:text>
					<xsl:value-of select="$parteDecimale"/>
				</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<!-- 'strvalue' e' vuota o non e' un numero; la visualizzo cosi' come e' -->
					<xsl:value-of select="$strvalue" disable-output-escaping="yes"/>
				</xsl:otherwise>
			</xsl:choose>
			</xsl:if>
	</xsl:template>

	<!-- Informazioni sul diritto di intervento
	   id="hxp-doc-action-infoIntervento"
	   -->
	<xsl:template name="docinfointervento">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:if test="$blockData/@intervento='si'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Pulsante di assegnazione di diritto di intervento
	   id="hxp-doc-action-assegnaIntervento"
	   -->
	<xsl:template name="docassegnaintervento">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- Federico 15/05/09: disabilitazione delle funz. di modifica dei CC sui CC ereditati dal fascicolo (gestione dei CC nei fascicoli) [M 0000378] -->
		<xsl:if test="not($blockData/@cc_from_fasc)">
			<xsl:if test="not($blockData/@intervento='si')">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']"/>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return assegnaIntervento('</xsl:text>
						<xsl:value-of select="$blockData/@cod_persona"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@cod_uff"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@diritto"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			</xsl:if>
		</xsl:if>
	</xsl:template>


	<!-- Pulsante di rimozione di diritto di intervento
	   id="hxp-doc-action-rimuoviIntervento"
	   -->
	<xsl:template name="docrimuoviintervento">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<!-- Federico 15/05/09: disabilitazione delle funz. di modifica dei CC sui CC ereditati dal fascicolo (gestione dei CC nei fascicoli) [M 0000378] -->
		<xsl:if test="not($blockData/@cc_from_fasc)">
			<xsl:if test="$blockData/@intervento='si'">
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']"/>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return rimuoviIntervento('</xsl:text>
						<xsl:value-of select="$blockData/@cod_persona"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@cod_uff"/><xsl:text>','</xsl:text>
						<xsl:value-of select="$blockData/@diritto"/>
						<xsl:text>');</xsl:text>
					</xsl:attribute>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			</xsl:if>
		</xsl:if>
	</xsl:template>


	<!-- Apertura di un raccoglitore
	   id="hxp-doc-action-apriRaccoglitore" -->
	<xsl:template name="docapriraccoglitore">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return apriRaccoglitore();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<!-- Archivia un raccoglitore
	   id="hxp-doc-action-archiviaRaccoglitore" -->
	<xsl:template name="docarchiviaraccoglitore">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return archiviaRaccoglitore();</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--  Download di un file tramite iw  -->
	<xsl:template name="iwgetfile">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="fileid" select="''"/>
		<xsl:param name="save" select="''"/>
		<xsl:variable name="theid">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="concat('$hxp_data(',$fileid,')')"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:copy>
			<xsl:copy-of select="@*[name()!='id']" />
			<xsl:attribute name="href">
				<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
				<xsl:text>return iwGetFile('</xsl:text>
				<xsl:value-of select="$theid"/>
				<xsl:text>','</xsl:text>
				<xsl:value-of select="$save"/>
				<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Smistamento dei template hxp-doc-action-... -->
	<xsl:template name="docaction">
		<xsl:param name="value" select="''" />
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:choose>
			<xsl:when test="$value='apriRaccoglitore'">
				<xsl:call-template name="docapriraccoglitore">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='archiviaRaccoglitore'">
				<xsl:call-template name="docarchiviaraccoglitore">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rimuoviIntervento'">
				<xsl:call-template name="docrimuoviintervento">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='assegnaIntervento'">
				<xsl:call-template name="docassegnaintervento">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='infoIntervento'">
				<xsl:call-template name="docinfointervento">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='invioTelematico'">
				<xsl:call-template name="docinvioTelematico">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Gestione id "hxp-doc-action-invioTelematicoWS": invio telematico del documento mediante i web service [RW 0048112]
			-->
			<xsl:when test="$value='invioTelematicoWS'">
				<xsl:call-template name="docinvioTelematico">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData/.." />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 08/07/09: invio multiplo ai destinatari interni (interoperabilita' con i ws) [M 0000498] -->
			<xsl:when test="$value='invioTelematicoWSDestIntMultiplo'">
				<xsl:call-template name="invioTelematicoWSDestIntMultiplo">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData/.." />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 18/12/09: invio multiplo a destinatari PEC [EF 492] -->
			<xsl:when test="$value='invioTelematicoPECMultiplo'">
				<xsl:call-template name="invioTelematicoPECMultiplo">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData/.." />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='rigetta'">
				<xsl:call-template name="docrigetta">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showSign'">
				<xsl:call-template name="docshowsign">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showReaders'">
				<xsl:call-template name="docshowreaders">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileIsSigned'">
				<xsl:call-template name="docfileissigned">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileIsEncrypted'">
				<xsl:call-template name="docfileiscrypted">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='printPdf'">
				<xsl:call-template name="docprintpdf">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Federico 11/01/06: gestione dell'id 'hxp-doc-action-printProfiles'
				per la visualizzazione della pagina dei profili di stampa.
			-->
			<xsl:when test="$value='printProfiles'">
				<xsl:call-template name="docPrintProfiles">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showHistory' or substring-before($value,'-')='showHistory'">
				<xsl:call-template name="docshowhistory">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='showRegister'">
				<xsl:call-template name="docshowregister">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='ripetinuovo'">
				<xsl:call-template name="docripetinuovo">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='ripetinuovo'">
				<xsl:call-template name="docripetinuovo">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='fileVersions'">
				<xsl:call-template name="docfileversions">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 03/10/08: introdotto confronto tra l'ultima e la prima versione di un allegato [RW 0054369] -->
			<xsl:when test="starts-with($value,'showDiff-')">
				<xsl:call-template name="showDiffBetweenVersions">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="expType" select="substring-after($value,'showDiff-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='chkin'">
				<xsl:call-template name="docchkin">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='abandonChkout'">
				<xsl:call-template name="docabandonchkout">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='chkout'">
				<xsl:call-template name="docchkout">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='validaDoc'">
				<xsl:call-template name="docvalidadoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='annullaDoc'">
				<xsl:call-template name="docannulladoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='apriFascicolo'">
				<xsl:call-template name="docaprifascicolo">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='archiviaFascicolo'">
				<xsl:call-template name="docarchiviafascicolo">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='insertSottoFasc'">
				<xsl:call-template name="docinsertsottofasc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='scartaDoc'">
				<xsl:call-template name="docscartadoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='enableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='disableFunctionality'">
				<xsl:call-template name="disableFunctionality">
					<xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$hxpdata">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='blockDataEnableFunctionality'">
				<xsl:call-template name="enableFunctionality">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="attrVal">
						<xsl:for-each select="$blockData">
							<xsl:call-template name="matchcontent">
								<xsl:with-param name="elemName" select="substring-after($value,'-')" />
							</xsl:call-template>
						</xsl:for-each>
					</xsl:with-param>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='relSetRoot'">
				<xsl:call-template name="docrelsetroot">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='instabledoc'">
				<xsl:call-template name="docinstabledoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Federico 23/03/2005: chiamata al template 'insdocfromdoc' (RW0027037).
				L'id gestito e' "hxp-doc-action-insdocfromdoc-<dbTable>|[<codice_rep>]|[<descr_rep>]|[<tipologia>]".
			-->
			<xsl:when test="substring-before($value,'-')='insdocfromdoc'">
				<xsl:call-template name="insdocfromdoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='modPostit'">
				<xsl:call-template name="docmodpostit">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='delPostit'">
				<xsl:call-template name="docdelpostit">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='addPostit'">
				<xsl:call-template name="docaddpostit">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkImpronta'">
				<xsl:call-template name="doccheckimpronta">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='getfile'">
				<xsl:call-template name="getfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='iwGetfile'">
				<xsl:call-template name="iwgetfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='iwSavefile'">
				<xsl:call-template name="iwgetfile">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
                    <xsl:with-param name="save" select="'true'"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='getfilethumb'">
				<xsl:call-template name="getfilethumb">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='noIWgetfilethumb'">
				<xsl:call-template name="noIWgetfilethumbdocs">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="relpath" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- introdotto da mbussetti il 18/03/2005 -->
			<xsl:when test="substring-before($value,'-')='getfileconversions'">
				<xsl:call-template name="getfileconversions">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- introdotto da mbussetti il 18/03/2005 -->
			<xsl:when test="$value='disappear'">
				<xsl:call-template name="disappear">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<!-- introdotto da mbussetti il 01/06/2005 -->
			<xsl:when test="$value='showDirectInformation'">
				<xsl:call-template name="showDirectInformation">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='imglink'">
				<xsl:call-template name="imglink">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='imglinkwithIW'">
				<xsl:call-template name="imglinkwithIW">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="fileid" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='dinamicIWcheck'">
				<xsl:call-template name="dinamicIWcheck">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='dinamicNOIWcheck'">
				<xsl:call-template name="dinamicNOIWcheck">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
		    <xsl:when test="$value='imgsNOIW'">
				<xsl:call-template name="imgsNOIW">
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoCC'">
				<xsl:call-template name="doccheckvistoCC">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoOP'">
				<xsl:call-template name="doccheckvistoOP">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoOPM'">
				<xsl:call-template name="doccheckvistoOPM">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoCDS'">
				<xsl:call-template name="doccheckvistoCDS">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoRPA'">
				<xsl:call-template name="doccheckvistoRPA">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='checkVistoRPAM'">
				<xsl:call-template name="doccheckvistoRPAM">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='infoAssegnazioneCC'">
				<xsl:call-template name="docinfoAssegnazioneCC">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='infoAssegnazioneOP'">
				<xsl:call-template name="docinfoAssegnazioneOP">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='infoAssegnazioneOPM'">
				<xsl:call-template name="docinfoAssegnazioneOPM">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='collect' or starts-with($value,'collect-')">
				<xsl:call-template name="doccollect">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'collect-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- Gregorio_Aggiunta : verificare conflitto con "removeDocFromSel" -->
			<xsl:when test="$value='deselect'">
				<xsl:call-template name="docdeselect">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='projection'">
				<xsl:call-template name="projection">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='projectionWithSubmit'">
				<xsl:call-template name="projectionWithSubmit">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='father'">
				<xsl:call-template name="docfather">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='upperbrother'">
				<xsl:call-template name="docupperbrother">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='firstson'">
				<xsl:call-template name="docfirstson">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='lowerbrother'">
				<xsl:call-template name="doclowerbrother">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='first'">
				<xsl:call-template name="docfirst">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='first_no_label'">
				<xsl:call-template name="docfirst">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev'">
				<xsl:call-template name="docprev">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='prev_no_label'">
				<xsl:call-template name="docprev">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='refresh'">
				<xsl:call-template name="docrefresh">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next'">
				<xsl:call-template name="docnext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='next_no_label'">
				<xsl:call-template name="docnext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last'">
				<xsl:call-template name="doclast">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='last_no_label'">
				<xsl:call-template name="doclast">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removeDocFromSel'">
				<xsl:call-template name="removeDocFromSel">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='query'">
				<xsl:call-template name="docquery">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='edit' or substring-before($value,'-')='edit'">
				<xsl:call-template name="docedit">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="xparms" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='remove'">
				<xsl:call-template name="docremove">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='gototableq'">
				<xsl:call-template name="docgototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @dbTable -->
			<xsl:when test="$value='gotocurrenttableq'">
				<xsl:call-template name="docgototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @selTable -->
			<xsl:when test="$value='gotostartingtableq'">
				<xsl:call-template name="docgototableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@selTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='refinetableq'">
				<xsl:call-template name="docrefinetableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @dbTable -->
			<xsl:when test="$value='refinecurrenttableq'">
				<xsl:call-template name="docrefinetableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @selTable -->
			<xsl:when test="$value='refinestartingtableq'">
				<xsl:call-template name="docrefinetableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@selTable,'@')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @dbTable -->
			<xsl:when test="$value='refinecurrenttableq_no_label'">
				<xsl:call-template name="docrefinetableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@dbTable,'@')" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<!-- Utilizza quanto contenuto in @selTable -->
			<xsl:when test="$value='refinestartingtableq_no_label'">
				<xsl:call-template name="docrefinetableq">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tableName" select="substring-after($hxpdata/@selTable,'@')" />
					<xsl:with-param name="disabilita_ritorno_etichetta" select="'si'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='titles'">
				<xsl:call-template name="doctitles">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='filelist'">
				<xsl:call-template name="docfilelist">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='hier'">
				<xsl:call-template name="dochierbrowser">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='physdoc'">
				<xsl:call-template name="docphysdoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='modifytabledoc'">
				<xsl:call-template name="docmodifytabledoc">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="substring-before($value,'-')='openRifInt'">
				<xsl:call-template name="docopenRifInt">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="addType" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removeRifInt'">
				<xsl:call-template name="docremoveRifInt">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removeAttach'">
				<xsl:call-template name="docremoveAttach">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='removeImmagine'">
				<xsl:call-template name="docremoveAttach">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					<xsl:with-param name="tipo" select="'immagine'" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='protocolla'">
				<xsl:call-template name="docprotocolla">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Modifica di Federico del 06/12/2004:
				gestione id 'hxp-doc-action-buildThPaths' per la creazione delle molliche di un documento.
			-->
			<xsl:when test="substring-before($value,'-')='buildThPaths'">
				<xsl:call-template name="docBuildThPaths">
					<xsl:with-param name="classifType" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!--
				Modifica di Federico del 06/12/2004:
				gestione id 'hxp-doc-action-buildThPaths_without_code' per la creazione delle molliche di un documento
				senza la visualizzazione dei codici.
			-->
			<xsl:when test="substring-before($value,'-')='buildThPaths_without_code'">
				<xsl:call-template name="docBuildThPathsNoCode">
					<xsl:with-param name="classifType" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 06/04/2005: gestione id 'hxp-doc-action-getLinkedDocs-[info]-[query]' -->
			<xsl:when test="substring-before($value,'-')='getLinkedDocs'">
				<xsl:call-template name="docGetLinkedDocs">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="params" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 11/04/2005: gestione id 'hxp-doc-action-showLinkedDoc[-xDoc]' -->
			<xsl:when test="$value='showLinkedDoc' or starts-with($value,'showLinkedDoc-')">
				<xsl:call-template name="showLinkedDoc">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="params" select="substring-after($value,'-')"/>
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 16/06/2005: gestione id 'hxp-doc-action-showXLink-...' -->
			<xsl:when test="substring-before($value,'-')='showXLink'">
				<xsl:call-template name="docShowXLink">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="jsparams" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 16/06/2005: gestione id 'hxp-doc-action-openUrl-urlXPath' -->
			<xsl:when test="substring-before($value,'-')='openUrl'">
				<xsl:call-template name="docOpenUrl">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="urlPath" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<!-- Federico 29/06/05: gestione id 'hxp-doc-action-formatNumber-xpath-formatStr' -->
			<xsl:when test="substring-before($value,'-')='formatNumber'">
				<xsl:call-template name="docFormatNumber">
					<xsl:with-param name="blockData" select="$blockData"/>
					<xsl:with-param name="xpath-formatStr" select="substring-after($value,'-')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="$value='hideShowCC'">
				<xsl:call-template name="hideShowCC">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<!-- fcossu 29/12/2009 Scarto vaschetta ruoli [EA 501] -->
			<xsl:when test="$value='scartaRuoli'">
				<xsl:call-template name="docscartaRuoli">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="hxperrorhandler">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Cerca il template xsl generico da eseguire -->
	<xsl:template match="*[@id]" mode="template" name="hxparser">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="disable" select="''" />
		<xsl:choose>
			<!--xsl:when test="substring-before(@id,'-')='hxp'"-->
			<xsl:when test="starts-with(@id,'hxp')">
				<xsl:variable name="value" select="substring-after(@id,'-')" />
				<xsl:choose>
					<xsl:when test="substring-before($value,'-')='doc'">
						<xsl:choose>
							<xsl:when test="starts-with(substring-after($value,'-'),'action-')"> <!-- hxp-doc-action-... -->
								<xsl:call-template name="docaction">
									<xsl:with-param name="value" select="substring-after($value,'action-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'data-')"> <!-- hxp-doc-data-... -->
								<xsl:call-template name="docdata">
									<xsl:with-param name="value" select="substring-after($value,'data-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:when test="starts-with(substring-after($value,'-'),'datanocopy-')"> <!-- hxp-doc-datanocopy-... -->
								<xsl:call-template name="docdatanocopy">
									<xsl:with-param name="value" select="substring-after($value,'datanocopy-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<!-- Federico 07/04/2005: gestione id 'hxp-doc-titlevispart-...' -->
							<xsl:when test="starts-with(substring-after($value,'-'),'titlevispart-')">
								<xsl:call-template name="titlevispart">
									<xsl:with-param name="partnum" select="substring-after($value,'titlevispart-')" />
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="hxperrorhandler">
									<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="hxparser_embedded">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
							<xsl:with-param name="disable" select="$disable" />
						</xsl:call-template>
<!--						<xsl:call-template name="hxpidhandler">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>-->
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:copy>
					<xsl:copy-of select="@*" />
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						<xsl:with-param name="disable" select="$disable" />
					</xsl:call-template>
				</xsl:copy>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- Restituisce il contenuto di una processing instruction "xw-at": id="hxp-doc-data-pi-(nome)" -->
	<xsl:template name="procinstr">
		<xsl:param name="blockData" />
		<xsl:param name="caller" />
		<xsl:for-each select="$blockData/processing-instruction('xw-at')">
			<xsl:variable name="text" select="." />
			<xsl:if test="starts-with(substring-before($text,':'),$caller)">
				<xsl:value-of select="substring-after($text,':')" />
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-rep-yes", che lascia procedere il parser nell'element se il documento
			 corrente E' un documento di repertorio
	-->
	<xsl:template name="docrepyes">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="$hxpdata//repertorio/@cod">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-rep-not", che lascia procedere il parser nell'element se il documento
			 corrente NON  un documento di repertorio
	-->
	<xsl:template name="docrepnot">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="not($hxpdata//repertorio/@cod)">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-rep-title", che associa al tag cui  applicato la descrizione del repertorio
			 cui appartiene il documento corrente
	-->
	<xsl:template name="docreptitle">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:copy>
			<xsl:copy-of select="@*[not(name()='id')]"/>
			<xsl:value-of select="$hxpdata//repertorio" />
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-rep-imgSetting" che inserisce nel tag <img> cui  applicato, nel caso
			 in cui il documento corrente sia un documento di repertorio, un @alt e un @onmouseover in cui compare la descrizione
			 del repertorio
	-->
	<xsl:template name="docrepimgSetting">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
        <!--
		<xsl:if test="name(current())='img' and $hxpdata//repertorio">
        -->
		<xsl:if test="name(.)='img' and $hxpdata//repertorio">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:attribute name="alt">
					<!--xsl:value-of select="$hxpdata//repertorio" /-->
					<xsl:call-template name="toHtmlFormatted">
						<xsl:with-param name="testo" select="$hxpdata//repertorio" />
					</xsl:call-template>
				</xsl:attribute>
				<xsl:attribute name="onmouseover">
					<xsl:text>javascript:self.status='</xsl:text>
					<xsl:call-template name="toJSParam">
						<xsl:with-param name="testo" select="$hxpdata//repertorio" />
					</xsl:call-template>
					<xsl:text>'; return(true);</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- *************************************************************** -->
	<!-- DA QUI COMINCIANO I TEMPLATE PER LA VISUALIZZAZIONE DEI DIRITTI -->
	<!-- *************************************************************** -->

	<!-- Implementazione dell'id "hxp-doc-datanocopy-flap", contenitore per ora vuoto ma predisposto
			 per gestire un'eventuale divisione in diverse linguette dei diritti relativi a diversi applicativi
	-->
	<xsl:template name="docflap">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:copy>
			<xsl:copy-of select="@*[not(name()='id')]"/>
			<xsl:value-of select="$blockData"/>
		</xsl:copy>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-onecheck_main, che seleziona gli elementi
			 <group> che sono di tipo 'base'
	-->
	<xsl:template name="docgrouponecheck_main">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="($blockData/@tipo='base' and $blockData/@label!='') or not($blockData/@tipo)">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-explain_main, che seleziona gli elementi
			 elementi <group> di tipo 'base' che hanno tra i figli l'elemento <explain>
	-->
	<xsl:template name="docgroupexplain_main">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="($blockData/explain) and (($blockData/@tipo='base') or not($blockData/@tipo))">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-explain_fhalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere di tipo 'base'
			 - avere tra i figli l'elemento <explain>
			 - rispetto alla somma di tutti gli elementi <group> di pari livello e di tutti gli elementi <right>
			   figli di tali <group>, avere una posizione <= met
	-->
	<xsl:template name="docgroupexplain_fhalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(not($blockData/@tipo) or ($blockData/@tipo='base'))">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group|$blockData/../*/right)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group|$blockData/../*/right"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-explain_shalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere di tipo 'base'
			 - avere tra i figli l'elemento <explain>
			 - rispetto alla somma di tutti gli elementi <group> di pari livello e di tutti gli elementi <right>
			   figli di tali <group>, avere una posizione > met
	-->
	<xsl:template name="docgroupexplain_shalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(not($blockData/@tipo) or ($blockData/@tipo='base'))">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group|$blockData/../*/right)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group|$blockData/../*/right"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-onecheck_father, che seleziona gli elementi
			 <group> che sono di tipo 'base' e hanno tra i figli almeno un altro elemento <group>
	-->
	<xsl:template name="docgrouponecheck_father">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="($blockData/group) and (($blockData/@tipo='base') or not($blockData/@tipo))">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-onecheck_child_fhalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere figli di un elemento <group> di tipo 'base'
			 - rispetto alla somma di tutti gli elementi <group> di pari livello e di tutti gli elementi <right>
			   figli di tali <group>, avere una posizione <= met
	-->
	<xsl:template name="docgrouponecheck_child_fhalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and (($blockData/../@tipo='base') or not($blockData/@tipo))">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group|$blockData/../*/right)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group|$blockData/../*/right"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-onecheck_child_shalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere figli di un elemento <group> di tipo 'base'
			 - rispetto alla somma di tutti gli elementi <group> di pari livello e di tutti gli elementi <right>
			   figli di tali <group>, avere una posizione > met
	-->
	<xsl:template name="docgrouponecheck_child_shalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and (($blockData/../@tipo='base') or not($blockData/@tipo))">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group|$blockData/../*/right)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group|$blockData/../*/right"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-onecheck_single, che seleziona gli elementi
			 <group> che non hanno tra i figli un altro elemento <group>
	-->
	<xsl:template name="docgrouponecheck_single">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="not($blockData/group)">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-multicheck_father, che seleziona gli elementi
			 <group> che sono di tipo 'multiple' e hanno tra i figli almeno un altro elemento <group>
	-->
	<xsl:template name="docgroupmulticheck_father">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="($blockData/@tipo='multiple') and ($blockData/group)">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-multicheck_child_fhalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere figli di un elemento <group> di tipo 'multiple'
			 - rispetto alla somma di tutti gli elementi <group> di pari livello, avere una posizione <= met
	-->
	<xsl:template name="docgroupmulticheck_child_fhalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and ($blockData/../@tipo='multiple')">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-group-multicheck_child_shalf, che seleziona gli elementi
			 <group> aventi le seguenti caratteristiche:
			 - essere figli di un elemento <group> di tipo 'multiple'
			 - rispetto alla somma di tutti gli elementi <group> di pari livello, avere una posizione > met
	-->
	<xsl:template name="docgroupmulticheck_child_shalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and ($blockData/../@tipo='multiple')">
		<xsl:variable name="howmany">
			<xsl:value-of select="count($blockData/../group)"/>
		</xsl:variable>
		<xsl:variable name="interesting_nodes" select="$blockData/../group"/>
		<xsl:variable name="where">
			<xsl:apply-templates mode="count" select="$interesting_nodes">
				<xsl:with-param name="target" select="$blockData"/>
			</xsl:apply-templates>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="($wellplaced='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione degli id "hxp-doc-datanocopy-right_fhalf-[option], che si comporta diversamente a
			 seconda dell'option:
			 1) nessuna option: seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello e di tutti gli elementi <right> figli di tali <group>,
			 		ha una posizione <= met;
			 2) option='m': seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello, ha una posizione <= met;
			 3) option='short': seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello, ha una posizione <= met; inoltre scrive in uscita
			 		la lettera che identifica il valore dell'attributo @label dell'element <right> selezionato.
			 		Tale lettera si trova nell'element <explain> che  figlio dell'element <group> 'nonno' dell'element <right>
			 		selezionato.
	-->
	<xsl:template name="docright_fhalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="specific" select="''"/>

        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
	<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $theRight) or ($specific='not' and not($theRight))">
<!--
	<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $hxpdata/*/personal_rights/right[@cod=$blockData/@cod]) or ($specific='not' and not($hxpdata/*/personal_rights/right[@cod=$blockData/@cod]))">
-->
		<xsl:variable name="howmany">
			<xsl:choose>
				<xsl:when test="($specific='short') or ($specific='m') or ($specific='yes') or ($specific='not')">
					<xsl:value-of select="count($blockData/../../group)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="count($blockData/../../group/right|$blockData/../../group)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="where">
			<xsl:choose>
				<xsl:when test="($specific='short') or ($specific='m') or ($specific='yes') or ($specific='not')">
					<xsl:apply-templates mode="count" select="$blockData/../../group">
						<xsl:with-param name="target" select="$blockData/.."/>
					</xsl:apply-templates>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates mode="count" select="$blockData/../../group/right|$blockData/../../group">
						<xsl:with-param name="target" select="$blockData/.."/>
					</xsl:apply-templates>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$wellplaced='true'">
            <!--
			<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $hxpdata//personal_rights/right[@cod=$blockData/@cod]) or ($specific='not' and not($hxpdata//personal_rights/right[@cod=$blockData/@cod]))">
            -->
				<xsl:copy>
			<!--<xsl:value-of select="$pos"/>
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$howmany"/>-->
					<xsl:copy-of select="@*[not(name()='id')]"/>
					<xsl:if test="$specific='short'">
						<xsl:variable name="letter"> <!--select="substring($blockData/@label,1,1)"-->
							<xsl:variable name="etichetta" select="$blockData/@label" />
							<xsl:choose>
								<xsl:when test="$blockData/../../explain">
									<xsl:variable name="legenda" select="$blockData/../../explain" />
									<xsl:choose>
										<xsl:when test="contains($legenda,concat('=',$etichetta,'  '))">
											<xsl:variable name="porzione1" select="substring-before($legenda,concat('=',$etichetta,'  '))" />
											<xsl:value-of select="substring($porzione1,string-length($porzione1),1)" />
										</xsl:when>
										<xsl:otherwise>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:text>?</xsl:text>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<!--<xsl:text>&#160;</xsl:text>-->
						<xsl:value-of select="$letter"/>
						<!--<xsl:text>&#160;</xsl:text>-->
					</xsl:if>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
            <!--
			</xsl:if>
            -->
		</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione degli id "hxp-doc-datanocopy-right_shalf-[option], che si comporta diversamente a
			 seconda dell'option:
			 1) nessuna option: seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello e di tutti gli elementi <right> figli di tali <group>,
			 		ha una posizione > met;
			 2) option='m': seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello, ha una posizione > met;
			 3) option='short': seleziona gli elementi <right> il cui padre <group>, rispetto alla somma
			 		di tutti gli elementi <group> di pari livello, ha una posizione > met; inoltre scrive in uscita
			 		la lettera che identifica il valore dell'attributo @label dell'element <right> selezionato.
			 		Tale lettera si trova nell'element <explain> che  figlio dell'element <group> 'nonno' dell'element <right>
			 		selezionato.
	-->
	<xsl:template name="docright_shalf">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="specific" select="''"/>

        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
	<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $theRight) or ($specific='not' and not($theRight))">
    <!--
	<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $hxpdata/*/personal_rights/right[@cod=$blockData/@cod]) or ($specific='not' and not($hxpdata/*/personal_rights/right[@cod=$blockData/@cod]))">
    -->
		<xsl:variable name="howmany">
			<xsl:choose>
				<xsl:when test="($specific='short') or ($specific='m') or ($specific='yes') or ($specific='not')">
					<xsl:value-of select="count($blockData/../../group)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="count($blockData/../../group/right|$blockData/../../group)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="where">
			<xsl:choose>
				<xsl:when test="($specific='short') or ($specific='m') or ($specific='yes') or ($specific='not')">
					<xsl:apply-templates mode="count" select="$blockData/../../group">
						<xsl:with-param name="target" select="$blockData/.."/>
					</xsl:apply-templates>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates mode="count" select="$blockData/../../group/right|$blockData/../../group">
						<xsl:with-param name="target" select="$blockData/.."/>
					</xsl:apply-templates>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="pos" select="(string-length(substring-before($where,'1')) div 2)+1"/>
		<xsl:variable name="wellplaced">
			<xsl:choose>
				<xsl:when test="$pos &lt;= ceiling($howmany div 2)">
					<xsl:text>false</xsl:text>
				</xsl:when>
				<xsl:when test="$pos &gt; ceiling($howmany div 2)">
					<xsl:text>true</xsl:text>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$wellplaced='true'">
            <!--
			<xsl:if test="($specific!='yes' and $specific!='not') or ($specific='yes' and $hxpdata//personal_rights/right[@cod=$blockData/@cod]) or ($specific='not' and not($hxpdata//personal_rights/right[@cod=$blockData/@cod]))">
            -->
				<xsl:copy>
			<!--<xsl:value-of select="$pos"/>
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$howmany"/>-->
					<xsl:copy-of select="@*[not(name()='id')]"/>
					<xsl:if test="$specific='short'">
						<xsl:variable name="letter"> <!--select="substring($blockData/@label,1,1)"-->
							<xsl:variable name="etichetta" select="$blockData/@label" />
							<xsl:choose>
								<xsl:when test="$blockData/../../explain">
									<xsl:variable name="legenda" select="$blockData/../../explain" />
									<xsl:choose>
										<xsl:when test="contains($legenda,concat('=',$etichetta,'  '))">
											<xsl:variable name="porzione1" select="substring-before($legenda,concat('=',$etichetta,'  '))" />
											<xsl:value-of select="substring($porzione1,string-length($porzione1),1)" />
										</xsl:when>
										<xsl:otherwise>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:text>?</xsl:text>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:value-of select="$letter"/>
					</xsl:if>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
            <!--
			</xsl:if>
            -->
		</xsl:if>
	</xsl:if>
	</xsl:template>

	<xsl:template name="docgrouponecheck_child">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and (($blockData/../@tipo='base') or not($blockData/@tipo))">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<xsl:template name="docright">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:param name="specific" select="''"/>
        <xsl:variable name="test">
         <xsl:choose>
          <xsl:when test="$specific!='yes' and $specific!='not'"><xsl:value-of select="true()"/></xsl:when>
          <xsl:otherwise>
           <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
	       <xsl:value-of select="($specific='yes' and $theRight) or ($specific='not' and not($theRight))"/>
          </xsl:otherwise>
         </xsl:choose>
        </xsl:variable>
        <xsl:if test="$test">
				<xsl:copy>
			<!--<xsl:value-of select="$pos"/>
					<xsl:text>-</xsl:text>
					<xsl:value-of select="$howmany"/>-->
					<xsl:copy-of select="@*[not(name()='id')]"/>
					<xsl:if test="$specific='short'">
						<xsl:variable name="letter"> <!--select="substring($blockData/@label,1,1)"-->
							<xsl:variable name="etichetta" select="$blockData/@label" />
							<xsl:choose>
								<xsl:when test="$blockData/../../explain">
									<xsl:variable name="legenda" select="$blockData/../../explain" />
									<xsl:choose>
										<xsl:when test="contains($legenda,concat('=',$etichetta,'  '))">
											<xsl:variable name="porzione1" select="substring-before($legenda,concat('=',$etichetta,'  '))" />
											<xsl:value-of select="substring($porzione1,string-length($porzione1),1)" />
										</xsl:when>
										<xsl:otherwise>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:text>?</xsl:text>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<!--<xsl:text>&#160;</xsl:text>-->
						<xsl:value-of select="$letter"/>
						<!--<xsl:text>&#160;</xsl:text>-->
					</xsl:if>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-right_yes", che seleziona gli element <right> che costituiscono
			 diritti posseduti dalla persona interna di cui si sta visualizzando la scheda, vale a dire quelli presenti nell'xml,
			 oltre che come figli di <listof_rights>, anche come figli di <personal_rights> con valore 'TRUE', oppure quelli
			 presenti solo come figli di <listof_rights> ma con l'attributo @default='true'
	-->
	<xsl:template name="docright_yes">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
        <!--
        <xsl:variable name="theRight" select="$hxpdata/*/personal_rights/right[@cod=$blockData/@cod]"/>
        -->
		<xsl:variable name="myRight">
			<xsl:choose>
				<xsl:when test="$theRight">
					<xsl:value-of select="$theRight" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:text></xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<!--
			Federico 05/09/05: la modifica di una persona interna con il viewer ha introdotto uno spazio
			alla fine di ogni diritto. Meglio "trimmare" la stringa 'myRight' per precauzione.
		-->
		<xsl:variable name="trimmedRight">
			<xsl:call-template name="trim">
				<xsl:with-param name="s" select="$myRight"/>
			</xsl:call-template>
		</xsl:variable>

		<!--<xsl:if test="($myRight!='' and $myRight='TRUE') or ($myRight='' and $blockData/@default='true')">-->
		<xsl:if test="($trimmedRight!='' and $trimmedRight='TRUE') or ($trimmedRight='' and $blockData/@default='true')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-right_not", che seleziona gli element <right> che costituiscono
			 diritti NON posseduti dalla persona interna di cui si sta visualizzando la scheda, vale a dire quelli presenti
			 nell'xml solo come figli di <listof_rights> e privi dell'attributo @default o con @default='false',
			 oppure presenti anche come figli di <personal_rights> ma con valore 'FALSE'
	-->
	<xsl:template name="docright_not">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
        <!--
        <xsl:variable name="theRight" select="$hxpdata/*/personal_rights/right[@cod=$blockData/@cod]"/>
        -->
		<xsl:variable name="myRight">
			<xsl:choose>
				<xsl:when test="$theRight">
					<xsl:value-of select="$theRight" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:text></xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<!--
			Federico 05/09/05: la modifica di una persona interna con il viewer ha introdotto uno spazio
			alla fine di ogni diritto. Meglio "trimmare" la stringa 'myRight' per precauzione.
		-->
		<xsl:variable name="trimmedRight">
			<xsl:call-template name="trim">
				<xsl:with-param name="s" select="$myRight"/>
			</xsl:call-template>
		</xsl:variable>

		<!--<xsl:if test="($myRight!='' and $myRight='FALSE') or ($myRight='' and (not($blockData/@default) or $blockData/@default='false'))">-->
		<xsl:if test="($trimmedRight!='' and $trimmedRight='FALSE') or ($trimmedRight='' and (not($blockData/@default) or $blockData/@default='false'))">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-input-check", che seleziona gli element <right> figli di
			 un element <group> in cui l'attributo @exclusive  assente o ha valore 'false'; assegna al tag HTML
			 avente tale id (tipicamente un <input>) l'attributo 'name' con valore ricavato da quello dell'attributo
			 @cod dell'element <right> selezionato.
	-->
	<xsl:template name="docinputcheck">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and (not($blockData/../@exclusive) or $blockData/../@exclusive='false')">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:attribute name="name">
					<xsl:text>*right_</xsl:text>
					<xsl:value-of select="$blockData/@cod"/>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>


	<!-- Implementazione dell'id "hxp-doc-datanocopy-input-radio", che seleziona gli element <right> figli di
			 un element <group> in cui l'attributo @exclusive ha valore 'true'; assegna al tag HTML
			 avente tale id (tipicamente un <input>) l'attributo 'name' con valore ricavato da quello dell'attributo
			 @cod dell'element <right> selezionato.
	-->
	<xsl:template name="docinputradio">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="(name($blockData/..)='group') and $blockData/../@exclusive='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[not(name()='id')]"/>
				<xsl:attribute name="name">
					<xsl:text>*rgp_</xsl:text>
					<xsl:value-of select="$blockData/../@label"/>
				</xsl:attribute>
				<xsl:attribute name="value">
					<!--<xsl:text>*right_</xsl:text>-->
					<xsl:value-of select="$blockData/@cod"/>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-input-boolean", che seleziona gli element <right> privi dell'attributo
			 @type, cio i diritti di tipo vero/falso (=ho/non ho questo diritto)
	 -->
	<xsl:template name="docinputboolean">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
	<xsl:if test="not($blockData/@type)">
		<xsl:copy>
			<xsl:copy-of select="@*[not(name()='id')]"/>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-input-textual", che seleziona gli element <right> aventi l'attributo
			 @type, cio i diritti che possono avere un valore alfanumerico (=impostazioni di utente)
	-->
	<xsl:template name="docinputtextual">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
	<xsl:if test="$blockData/@type">
		<xsl:copy>
			<xsl:copy-of select="@*[not(name()='id')]"/>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
			</xsl:call-template>
		</xsl:copy>
	</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-right_text", che associa agli element <right> di tipo testuale
			 il valore che essi hanno per la persona interna di cui si sta visualizzando la scheda; tale valore pu anche
			 essere nullo.
			 Se viene trovato un diritto che non compare in quelli salvati per la persona interna in questione, esso viene
			 valorizzato per quella persona con l'eventuale valore di default specificato nel file di descrizione dei diritti.
			 Il valore '*NHL*' equivale al valore nullo.
	-->
	<xsl:template name="docright_text">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="$blockData/@type='alfa' or $blockData/@type='num'">
        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
        <!--
        <xsl:variable name="theRight" select="$hxpdata/*/personal_rights/right[@cod=$blockData/@cod]"/>
        -->
		<xsl:variable name="myRight">
			<xsl:choose>
				<xsl:when test="$theRight">
					<xsl:value-of select="$theRight" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:text></xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
			<xsl:text>: </xsl:text>
			<xsl:choose>
				<xsl:when test="$myRight!='' and $myRight!='*NHL*'">
					<xsl:copy>
						<xsl:copy-of select="@*[not(name()='id')]"/>
						<xsl:value-of select="$theRight"/>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:when test="$myRight='' and $blockData/@default and $blockData/@default!=''">
					<xsl:copy>
						<xsl:copy-of select="@*[not(name()='id')]"/>
						<xsl:value-of select="$blockData/@default"/>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
			</xsl:choose>
		</xsl:if>
	</xsl:template>

	<!-- Implementazione dell'id "hxp-doc-datanocopy-right_password", che associa agli element <right> che rappresentano
			 diritti testuali criptati (password) tanti asterischi quanti sono i caratteri dell'effettivo valore che essi hanno
			 per la persona interna di cui si sta visualizzando la scheda; ovviamente gli asterischi possono anche essere in
			 numero uguale a 0.
			 Il valore '*NHL*' equivale al valore nullo.
	-->
	<xsl:template name="docright_password">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		<xsl:if test="$blockData/@type='password'">
        <xsl:variable name="theRight"><xsl:for-each select="$hxpdata"><xsl:copy-of select="key('rightsTable',$blockData/@cod)"/></xsl:for-each></xsl:variable>
        <!--
        <xsl:variable name="theRight" select="$hxpdata/*/personal_rights/right[@cod=$blockData/@cod]"/>
        -->
		<xsl:variable name="myRight">
			<xsl:choose>
				<xsl:when test="$theRight">
					<xsl:value-of select="$theRight" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:text></xsl:text>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
			<xsl:text>: </xsl:text>
			<xsl:choose>
				<xsl:when test="$myRight!='' and $myRight!='*NHL*'">
					<xsl:copy>
						<xsl:copy-of select="@*[not(name()='id')]"/>
						<xsl:call-template name="scriviAsterisco">
							<xsl:with-param name="mensura" select="$theRight" />
						</xsl:call-template>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:when test="$myRight='' and $blockData/@default and $blockData/@default!=''">
					<xsl:copy>
						<xsl:copy-of select="@*[not(name()='id')]"/>
						<xsl:call-template name="scriviAsterisco">
							<xsl:with-param name="mensura" select="$blockData/@default" />
						</xsl:call-template>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
			</xsl:choose>
		</xsl:if>
	</xsl:template>

	<xsl:template name="scriviAsterisco">
		<xsl:param name="mensura" select="''" />
		<xsl:if test="$mensura!=''">
			<xsl:text>*</xsl:text>
			<xsl:if test="string-length($mensura)>1">
				<xsl:call-template name="scriviAsterisco">
					<xsl:with-param name="mensura" select="substring($mensura,2)" />
				</xsl:call-template>
			</xsl:if>
		</xsl:if>
	</xsl:template>


	<xsl:template match="*//*" mode="count">
		<xsl:param name="target" select="''"/>
			<xsl:choose>
                <!--
				<xsl:when test="generate-id(current())=generate-id($target)">
                -->
				<xsl:when test="generate-id(.)=generate-id($target)">
					<xsl:text>1+</xsl:text>
				</xsl:when>
				<xsl:otherwise>
					<xsl:text>0+</xsl:text>
				</xsl:otherwise>
			</xsl:choose>
	</xsl:template>

	<!--
	 	* @author Federico Grillini (copiato qui da DD il 27/04/06)
		*
	 	* Created on: 30/11/2005
		*
	 	* @param blockPath
	 	* @param blockData	contesto corrente nell'xml.
	 	* @param attrVal	valore dell'attributo da testare.
	 	*
	 	* Questo template copia l'elemento contenente l'id se la funzionalit specifica
	    * corrispondente non deve essere abilitata, ovvero se l'attributo da testare vale 'false' o non c'e'.
	    *
	    * id="hxp-title-action-disableFunctionality-(attributo da testare)"
	    *
	-->
	<xsl:template name="disableFunctionality">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />

		<xsl:if test="$attrVal='false' or $attrVal=''">
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="data" select="$blockData" />
					</xsl:call-template>
				</xsl:for-each>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!-- Scarta il documento dalla vaschetta dei documenti in CC
	   id="hxp-doc-action-hideShowCC" -->
	<xsl:template name="hideShowCC">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return hideShowCC('</xsl:text>
					<xsl:value-of select="$blockData/@cod_uff"/>
					<!--
						Federico 18/05/09: introdotto parametro 'isCCFasc' in 'hideShowCC(...)' che vale true per i CC ereditati
						dai fascicoli (gestione dei CC nei fascicoli) [M 0000378]
					-->
					<xsl:choose>
						<xsl:when test="not($blockData/@cc_from_fasc) or $blockData/@cc_from_fasc=''">
							<xsl:text>');</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<!-- Federico 21/05/09: gestione raggruppamento CC dei fascicoli collegati/minuta per ufficio [M 0000378] -->
							<xsl:text>','',true</xsl:text>
							<xsl:if test="name($blockData)='rif_fasc'">
								<xsl:text>,'</xsl:text>
								<xsl:value-of select="$blockData/../../@cod"/>
								<xsl:text>'</xsl:text>
							</xsl:if>
							<xsl:if test="name($blockData)='rif_minuta'">
								<xsl:text>,'M'</xsl:text>
							</xsl:if>
							<xsl:text>);</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

	<!-- fcossu 29/12/2009 Scarto vaschetta ruoli [EA 501] -->
	<xsl:template name="docscartaRuoli">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
			<xsl:copy>
				<xsl:for-each select="@*[name()!='id']">
					<xsl:call-template name="stringparser">
						<xsl:with-param name="blockPath" select="$blockPath"/>
						<xsl:with-param name="data" select="$blockData"/>
					</xsl:call-template>
				</xsl:for-each>
				<xsl:attribute name="href">
					<xsl:text>javascript:void(0);</xsl:text>
				</xsl:attribute>
				<xsl:attribute name="onclick">
					<xsl:text>return scartaRuoli();</xsl:text>
				</xsl:attribute>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
	</xsl:template>

</xsl:stylesheet>
