<?xml version="1.0" encoding="iso-8859-1" ?>
<!-- 
eXtraWay XML DB - DMS - Record Management and Information Retrieval System

Original code by

Bazzigotti Franco (franco.bazzigotti[at]gmail.com)
Gelli Mauro (gellimauro[at]gmail.com)

Copyright 2005-2012 by 3D Informatica

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Wherever third party code has been used, credit has been given in the code's
comments.

Please contact us for any question at:

3D Informatica
Via Speranza 35 
40068, San Lazzaro di Savena (BOLOGNA)
Italy

Web Site http://www.3di.it

Email to info[at]3di.it

eXtraWay is released under the GPLv2
-->


<!--

Id di grande utilizzo:

*********************************
hxp-content-(element/@attribute)       (attribute  facoltativo)

visualizza il contenuto di (element/@attribute) nel contesto corrente

*********************************
htmlContent-(element/@attribute)        (attribute  facoltativo)

Come hxp-content- ma l'output e' formattato per la visualizzazione html
(vengono mantenuti spazi e newline)

*********************************
containerof-(element/@attribute)        (attribute generalmente non  mai utilizzato)

Itera il primo figlio del template html per
ogni elemento (element) dell'xml.
Ad ogni iterazione il contesto corrente  quello
dell'(element) in questione. Nel caso in cui non
esista nessun (element) col nome specificato l'elemento figlio
non viene copiato, ma l'elemento contenente l'id hxp-containerof si.

*********************************
containsOr-(element/@attribute)       (attribute generalmente non  mai utilizzato)

Analogo a hxp-containerof, ma l'elemento
figlio viene copiato almeno una volta, ovvero anche
se non esiste nessun (element) col nome indicato.
Generalmente viene utilizzato nei template di modifica
di documenti.

*********************************

fulliterator-(element/@attribute)     (attribute generalmente non  mai utilizzato)

Analogo a hxp-containerof, ma effettua la copia
di tutti i figli dell'elemento che contiene tale id (non solo del primo).
Invece, nel caso in cui non esistano (element) col nome indicato
non viene effettuata neppure la copia dell'elemento stesso contenente l'id.
Molto utile per evitare di visualizzare campi con diciture nel caso un cui
non contengano nessuna informazione.

N.B eventuale testo dell'elemento contenente questo id viene ignorato.
Se importante inserirlo in uno span

*********************************

Nota sul template hxp-containsOr:
Pu avere le seguenti forme:
1) hxp-containsOr-(element)/@attribute    attribute facoltativo
2) hxp-containsOr-(element)/@attribute-(nome template)    attribute facoltativo
(nome template) e' il nome di un template a scelta o una stringa identificativa per permettere di effettuare
un ulteriore filtro su (element) per restringere il contesto della copia del 'famoso' primo figlio...
Tutti i file xsl custom devono implementare il seguente template:

	<xsl:template name="containerConditional">
		<xsl:param name="tempName" select="''"/>
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>
		IMPLEMENTARE QUI IL TEST O CHIAMARE ALTRI TEMPLATE PER IL TEST.
		$tempName contiene (nome template) passato .
		Se si vuole visualizzare il contenuto dell'elemento in questione (quello attualmente
		processato dal container) restituire 1, per inibirne la visualizzazione non restituire nulla
	</xsl:template>

N.B Lo stesso meccanismo appena descritto si pu utilizzare con altri id: hxp-containerof e hxp-fulliterator

-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
				xmlns:xw="http://www.3di.it/ns/xw-200203121136"
				xmlns:h="http://www.w3.org/HTML/1998/html4"
				xmlns:str="http://xsltsl.org/string"
				exclude-result-prefixes="xw h str"> <!-- Federico 16/06/05: per eliminare "xmlns:*" nell'html finale -->

 <!-- XML da processare -->
 <xsl:variable name="hxpdata" select="/*" />
 <xsl:include href="core.xsl" />
 <xsl:include href="ttree.xsl" />
 <xsl:include href="quote.xsl" />
 <xsl:include href="range.xsl" />
 <xsl:include href="notEmptyIteratorImplementation.xsl" />

 <!-- Federico 17/06/2005: file che contiene dei template per l'elaborazione di stringhe -->
 <xsl:include href="stringUtils.xsl" />

 <!-- Federico 17/12/2004: inclusione del file che contiene i template relativi al calendario javascript -->
 <xsl:include href="jsCalendar.xsl" />

 <xsl:variable name="isAdmin">
  <xsl:if test="contains($hxpdata/@uri,'prot.') or contains($hxpdata/@uri,'adm.' )">
   <xsl:text>1</xsl:text>
  </xsl:if>
 </xsl:variable>

<!-- fabio --><!-- vedi anche attributo priority-->
 <xsl:variable name="nojs">
  <xsl:call-template name="customcontent">
   <xsl:with-param name="templatedata" select="'hxp-probe-nojs'"/>
  </xsl:call-template>
 </xsl:variable>
<!-- /fabio -->

 <!-- Si applicano i template xsl: il contesto a cui applicarli  costituito dal template
 html incluso (nell'xsl specifico) -->
 <xsl:template match="/">
  <xsl:apply-templates select="$hxptemplate" mode="template" />
 </xsl:template>

 <!-- default handler: copy-through template elements -->
 <xsl:template match="*|@*|text()" mode="template">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" />
  <xsl:param name="instPosDep" select="''" />

  <xsl:copy>
   <xsl:apply-templates select="node()|@*" mode="template">
    <xsl:with-param name="blockPath" select="$blockPath"/>
    <xsl:with-param name="blockData" select="$blockData" />
    <xsl:with-param name="disable" select="$disable" />
    <xsl:with-param name="instPosDep" select="$instPosDep" />
   </xsl:apply-templates>
  </xsl:copy>
 </xsl:template>

 <!-- simone 23 Set 2004 : vengono ricopiati SOLO i commenti 'if' che capisce Explorer -->
 <xsl:template match="comment()" mode="template">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" />
  <xsl:param name="instPosDep" select="''" />
  <xsl:if test="starts-with(.,'[if')">
   <xsl:copy/>
    <!--
   <xsl:copy>
    <xsl:apply-templates select="node()|@*" mode="template">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="disable" select="$disable" />
     <xsl:with-param name="instPosDep" select="$instPosDep" />
    </xsl:apply-templates>
   </xsl:copy>
    -->
  </xsl:if>
 </xsl:template>

 <!-- form nascosta -->
 <xsl:template name="sessiondata">
  <input type="hidden" name="globalFormRestore" value="" />

  <input type="hidden" name="host" value="{$hxpdata/@host}" />
  <input type="hidden" name="_hcf" value="{$hxpdata/@_hcf}"/>
  <input type="hidden" name="_hca" value="{$hxpdata/@_hca}"/>
  <input type="hidden" name="uri" value="{$hxpdata/@uri}" />
  <input type="hidden" name="port" value="{$hxpdata/@port}" />
  <input type="hidden" name="db" value="{$hxpdata/@db}" />
  <input type="hidden" name="dbTable" value="{$hxpdata/@dbTable}" />
  <input type="hidden" name="user" value="{$hxpdata/@user}" />
  <input type="hidden" name="pwd" value="{$hxpdata/@pwd}" />
  <input type="hidden" name="query" value="{$hxpdata/@query}" />
  <input type="hidden" name="pos" value="{$hxpdata/@pos}" />
  <input type="hidden" name="count" value="{$hxpdata/@count}" />
  <input type="hidden" name="keyCount"   value="{$hxpdata/@keyCount}"/><!-- numero di elementi idx/ths -->
  <input type="hidden" name="pageCount" value="{$hxpdata/@pageCount}" />
  <input type="hidden" name="selid" value="{$hxpdata/@selid}" />
  <input type="hidden" name="selTable" value="{$hxpdata/@selTable}" />
  <input type="hidden" name="dt" value="{$hxpdata/@dt}" />
  <input type="hidden" name="noRef" value="{$hxpdata/@noref}" /> <!-- flag visibilit termini senza riferimenti in th -->
  <input type="hidden" name="opt" value="{$hxpdata/@opt}" />
  <input type="hidden" name="qopt" value="{$hxpdata/@qopt}" />
  <input type="hidden" name="qadj" value="{$hxpdata/@qadj}" />
  <input type="hidden" name="qext" value="{$hxpdata/@qext}" />
  <input type="hidden" name="keylist" value="{$hxpdata/@keylist}" /> <!-- termini selezionati -->
  <input type="hidden" name="klAll" value="{$hxpdata/@klAll}" /> <!-- se tutti termini selezionati -->
  <input type="hidden" name="klRac" value="{$hxpdata/@klRac}" /> <!-- termini raccolti -->
  <input type="hidden" name="selRac" value="{$hxpdata/@selRac}" /> <!-- seleziona relativa ai termini raccolti -->
  <input type="hidden" name="revSel"     value="{$hxpdata/@revSel}"/>
  <input type="hidden" name="flap" value="{$hxpdata/@flap}" />    <!-- per apertura flap -->
  <input type="hidden" name="aclDb" value="{$hxpdata/@aclDb}" />
  <input type="hidden" name="login" value="{$hxpdata/@login}" />
  <input type="hidden" name="matricola" value="{$hxpdata/@matricola}" />
  <!-- browser gerarchico -->
  <input type="hidden" name="hierCount" value="{$hxpdata/@hierCount}" /> <!-- numero di elementi richiesto -->
  <input type="hidden" name="hierStatus" value="{$hxpdata/@hierStatus}" /> <!-- stato corrente -->
  <input type="hidden" name="docStart" value="{$hxpdata/@docStart}" />

  <!-- raccolte -->
  <input type="hidden" name="cName" value="{$hxpdata/@cName}" />
  <input type="hidden" name="cId" value="{$hxpdata/@cId}" />
  <input type="hidden" name="cCount" value="{$hxpdata/@cCount}" />
  <!-- aggiunto per poter utilizzare il codice per la gestione delle raccolte impiegato su nif -->
  <input type="hidden" name="cIsPublic"  value="{$hxpdata/@cIsPublic}"/>

  <!-- informazioni su utente -->
  <input type="hidden" name="userRights" value="{$hxpdata/@userRights}" />
  <input type="hidden" name="acl" value="{$hxpdata/@acl}" />  <!-- diritti utente personali -->
  <input type="hidden" name="showdocUOR" value="{$hxpdata/@showdocUOR}" />  <!-- uffici di estensione di visibilit docs -->
  <input type="hidden" name="doceditUOR" value="{$hxpdata/@doceditUOR}" />  <!-- uffici di estensione di intervento docs -->
  <input type="hidden" name="docInGestioneUOR" value="{$hxpdata/@docInGestioneUOR}" />  <!-- uor/gruppi per docs in gestione -->
  <input type="hidden" name="uorInGestioneSelected" value="{$hxpdata/@uorInGestioneSelected}" />
  <input type="hidden" name="browser" value="{$hxpdata/@browser}" />
  <input type="hidden" name="enableIW" value="{$hxpdata/@enableIW}" />
  <input type="hidden" name="transformJava" value="{$hxpdata/@transformJava}" />
  <input type="hidden" name="view" value="{$hxpdata/@view}" />
  <input type="hidden" name="toDo" value="{$hxpdata/@toDo}" />
  <input type="hidden" name="specificAppCode" value="{$hxpdata/@specificAppCode}" />
  <input type="hidden" name="specificDbCode" value="{$hxpdata/@specificDbCode}" />
  <input type="hidden" name="warnings" value="{$hxpdata/@warnings}" />
  <input type="hidden" name="appPreferences" value="{$hxpdata/@appPreferences}" />
  <input type="hidden" name="appStringPreferences" value="{$hxpdata/@appStringPreferences}" />
  <input type="hidden" name="mansioni" value="{$hxpdata/@mansioni}" />
  <input type="hidden" name="respUOR" value="{$hxpdata/@respUOR}" />
  <input type="hidden" name="groups" value="{$hxpdata/@groups}" />
  <input type="hidden" name="language" value="{$hxpdata/@language}" />
  <!-- profilo -->
  <input type="hidden" name="_r"         value="{$hxpdata/@_r}"/>

  <!-- workflow -->
  <input type="hidden" name="wfActive" value="{$hxpdata/@wfActive}" />
  <input type="hidden" name="wfId" value="{$hxpdata/@wfId}" />
  <input type="hidden" name="wfAction" value="{$hxpdata/@wfAction}" />
  <input type="hidden" name="wfDoc" value="{$hxpdata/@wfDoc}" />
  <input type="hidden" name="wfText" value="{$hxpdata/@wfText}" />
  <input type="hidden" name="wfLock" value="{$hxpdata/@wfLock}" />
  <input type="hidden" name="wfSelId" value="{$hxpdata/@wfSelId}" />
  <input type="hidden" name="wfPos" value="{$hxpdata/@wfPos}" />
  <input type="hidden" name="wfFCount" value="{$hxpdata/@wfFCount}" />
  <input type="hidden" name="wfMode" value="{$hxpdata/@wfMode}" />

  <!-- documenti selezionati per l'esecuzione delle action disponibili di un flusso [RW 0037104] -->
  <input type="hidden" name="selectedWfDocs" value="{$hxpdata/@selectedWfDocs}" />

  <!-- nome della classe che gestisce le interazioni utente richieste dalle function [RW 0037104] -->
  <input type="hidden" name="WfFunctionInteractionManagerClass" value="{$hxpdata/@WfFunctionInteractionManagerClass}" />

  <!--gis-->
  <input type="hidden" name="allotri" value="{$hxpdata/@allotri}" />

  <!-- indice della tendina dell'ordinamento selezionato -->
  <input type="hidden" name="qordIdx" value="{$hxpdata/@qordIdx}" />
  <input type="hidden" name="qordIdx1" value="{$hxpdata/@qordIdx1}" />

  <!-- per larghezza colonne titoli -->
  <input type="hidden" name="colsSize" value="{$hxpdata/@colsSize}" />

  <!-- dati custom -->
  <input type="hidden" name="_cd" value="{$hxpdata/@_cd}" />

  <!-- showtitles page title -->
  <input type="hidden" name="stpTitle" value="{$hxpdata/@stpTitle}" />

  <!--
  	Modifica di Federico del 15/10/2004:
	al posto di dbTable ora viene utilizzata la tupla 'thVOptions' per usare i checkbox al posto dei
	radio button nel thesauro vincolato (si veda anomalia 0022367).
	Il nome di tale tupla  volutamente generico (cio non riferito all'uso dei checkbox) in modo
	che possa essere utilizzata per trasmettere anche altre opzioni relative ai th vincolati
	(possibili usi futuri).
  -->
  <input type="hidden" name="thVOptions" value="{$hxpdata/@thVOptions}" />

  <!--
  	Modifica di Federico del 15/11/2004:
	tupla che indica il marcatore xml delle sezioni in lingua dei documenti.
  -->
  <input type="hidden" name="languageMarker" value="{$hxpdata/@languageMarker}" />

  <!-- DD 13/02/2006 Pattern della classificazione custom -->
  <input type="hidden" name="classifFormat" value="{$hxpdata/@classifFormat}" />

  <!--
  	Federico 05/12/06: handType per la creazione delle risposte di errore (consente di chiudere o meno le finestre
  	aperte dal js premendo 'indietro' nelle pagine di errore) [RW 0033834]
  -->
  <input type="hidden" name="errorMsgHandType" value="" />

  <!-- Federico 12/10/09: introdotta possibilit di avere dei file di risorse personalizzati per cliente [EB 111] -->
  <input type="hidden" name="resourceFileCustomDir" value="{$hxpdata/@resourceFileCustomDir}" />
 </xsl:template>

 <xsl:template name="attrparser">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>
  <!--
  <xsl:apply-templates mode="template" select="@*"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
  -->
  <xsl:for-each select="@*"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:call-template></xsl:for-each>
 </xsl:template>

 <xsl:template name="hxpjhandler">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="jcode" select="''"/>
  <xsl:param name="benable" select="'true'"/>
  <xsl:param name="hidedisabled" select="'false'"/>
  <xsl:choose>
   <xsl:when test="name()='a'">
    <xsl:choose>
     <xsl:when test="$benable">
      <xsl:copy>
       <!--xsl:copy-of select="@*"/-->
       <xsl:call-template name="attrparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/></xsl:call-template>
       <xsl:attribute name="href"><xsl:text>javascript:void(0);</xsl:text></xsl:attribute>
       <xsl:attribute name="onclick"><xsl:value-of select="$jcode"/></xsl:attribute>
       <xsl:call-template name="hxpcontinuecontext">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       </xsl:call-template>
      </xsl:copy>
     </xsl:when>
     <xsl:otherwise>
      <xsl:if test="$hidedisabled='false'">
       <xsl:call-template name="hxpcontinuecontext">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
        <xsl:with-param name="disable" select="'1'"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:when test="name()='input' and @type='image'">
    <xsl:choose>
     <xsl:when test="$benable">
      <xsl:copy>
       <xsl:copy-of select="@*"/>
       <xsl:attribute name="onclick"><xsl:value-of select="$jcode"/></xsl:attribute>
      </xsl:copy>
     </xsl:when>
     <xsl:otherwise>
      <xsl:if test="$hidedisabled='false'">
       <xsl:copy>
        <xsl:attribute name="disabled">
         <xsl:text>disabled</xsl:text>
        </xsl:attribute>
        <xsl:copy-of select="@type"/>
        <xsl:apply-templates select="@src" mode="template">
         <xsl:with-param name="disable" select="'1'"/>
        </xsl:apply-templates>
       </xsl:copy>
      </xsl:if>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <br/><b>unhandled element: <xsl:value-of select="name()"/></b><br/>
	<!--
    <xsl:call-template name="hxpcontinue"/>
	-->
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="disable" select="not($benable)"/>
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="hxp-plain">
  <xsl:param name="blockPath" select="''"/><xsl:param name="data" select="$hxpdata" />
  <xsl:text>*entering hxp-plain*</xsl:text>
  <br />
  <xsl:text>the data requested is </xsl:text>
  <b>
   <xsl:value-of select="$data" />
  </b>
  <xsl:apply-templates select="./*" mode="template" />
 </xsl:template>

 <xsl:template name="makecoord">
  <!-- costruisce una stringa composta da numeri separati da punto che esprimono per ogni livello
    la posizione del corrispondente ancestor per elementi dello stesso tipo -->
  <xsl:variable name="elemName" select="name()" />
  <xsl:for-each select="ancestor::*[name()=$elemName]">
   <xsl:value-of select="concat(string(1+count(preceding-sibling::*[name()=$elemName])),'.')" />
  </xsl:for-each>
  <xsl:value-of select="string(1+count(preceding-sibling::*[name()=$elemName]))" />
 </xsl:template>

 <xsl:template name="makeabscoord">
    <!-- costruisce una stringa composta da numeri separati da punto che
         esprimono per ogni livello la posizione del corrispondente ancestor -->
  <xsl:for-each select="ancestor::*">
   <xsl:value-of select="concat(string(1+count(preceding-sibling::*)),'.')"/>
  </xsl:for-each>
  <xsl:value-of select="string(1+count(preceding-sibling::*))"/>
 </xsl:template>

 <xsl:variable name="paramid"       select="'$hxp_'" />
 <xsl:variable name="paramcore"     select="'core_'" />
 <xsl:variable name="paramdata"     select="'data('" />
 <xsl:variable name="paramfcdata"   select="'fcdata('" />
 <xsl:variable name="paramlcdata"   select="'lcdata('" />
 <xsl:variable name="paramfulldata" select="'fulldata('" />
 <xsl:variable name="paramcoord"    select="'coord('" />
 <xsl:variable name="paramabscoord" select="'abscoord('"/>
 <xsl:variable name="paramchoose"   select="'choose('" />
 <xsl:variable name="paraminstance" select="'instance('"/>
 <xsl:variable name="paramfatherinstance" select="'fatherinstance('"/>
 <xsl:variable name="paramtemplate" select="'template('"/>

 <!-- Utile per sostituire in un id una parte da processare -->
 <xsl:template name="hxpstring">
  <xsl:param name="blockPath" select="''"/><xsl:param name="data" select="$hxpdata" />
  <xsl:param name="thestring" select="''" />
  <xsl:param name="instPosDep" select="''" />
  <xsl:choose>
   <xsl:when test="contains($thestring,$paramid)">
    <xsl:value-of select="substring-before($thestring,$paramid)" />
    <xsl:variable name="remainder" select="substring-after($thestring,$paramid)" />
    <xsl:choose>
     <xsl:when test="starts-with($remainder,$paramcore)">
      <xsl:call-template name="hxp-core-string">
       <xsl:with-param name="block-path" select="$blockPath"/>
       <xsl:with-param name="block-data" select="$data" />
       <xsl:with-param name="the-string" select="concat($paramid,substring-before($remainder,')'),')')" />
      </xsl:call-template>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramdata)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="matchcontent">
        <xsl:with-param name="elemName" select="substring-before(substring-after($remainder,$paramdata),')')" />
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramfcdata)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="matchcontentfc">
        <xsl:with-param name="elemName" select="substring-before(substring-after($remainder,$paramfcdata),')')" />
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramlcdata)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="matchcontentlc">
        <xsl:with-param name="elemName" select="substring-before(substring-after($remainder,$paramlcdata),')')" />
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramfulldata)">
      <xsl:for-each select="$hxpdata/.">
       <xsl:call-template name="matchcontent">
        <xsl:with-param name="elemName" select="substring-before(substring-after($remainder,$paramdata),')')" />
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramcoord)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="makecoord" />
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramabscoord)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="makeabscoord"/>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramchoose)">
      <xsl:for-each select="$data/.">
       <xsl:call-template name="matchchoose">
        <xsl:with-param name="elemName" select="substring-before(substring-after($remainder,$paramchoose),')')" />
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramtemplate)">
      <xsl:choose>
       <xsl:when test="count($data/.)>0">
        <xsl:variable name="template" select="."/>
        <xsl:for-each select="$data/.">
         <xsl:call-template name="customcontent">
          <xsl:with-param name="templatedata" select="substring-before(substring-after($remainder,$paramtemplate),')')"/>
          <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$data" />
          <xsl:with-param name="template" select="$template"/>
         </xsl:call-template>
        </xsl:for-each>
       </xsl:when>
       <xsl:otherwise><!-- nessun contesto -->
        <xsl:call-template name="customcontent">
         <xsl:with-param name="templatedata" select="substring-before(substring-after($remainder,$paramtemplate),')')"/>
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$data" />
         <xsl:with-param name="template" select="."/>
        </xsl:call-template>
       </xsl:otherwise>
      </xsl:choose>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paraminstance)">
      <xsl:variable name="elemName" select="name($data/.)"/>
      <!-- in caso di istanza inesistente -->
      <xsl:if test="count($data/.) = 0">
       <xsl:text>0</xsl:text>
      </xsl:if>
      <xsl:for-each select="$data/.">
       <xsl:value-of select="string(count(preceding-sibling::*[name()=$elemName]))"/>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="starts-with($remainder,$paramfatherinstance)">
      <xsl:value-of select="$instPosDep"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$paramid" />
      <xsl:value-of select="substring-before($remainder,')')" />
      <xsl:value-of select="')'" />
     </xsl:otherwise>
    </xsl:choose>

    <xsl:variable name="args" select="substring-after($remainder,'(')"/>
    <xsl:variable name="test" select="substring-before($args,')')"/>
    <xsl:variable name="used">
     <xsl:call-template name="matchBrace">
      <xsl:with-param name="where" select="$args"/>
      <xsl:with-param name="match" select="$test"/>
      <xsl:with-param name="test" select="$test"/>
     </xsl:call-template>
    </xsl:variable>

    <xsl:call-template name="hxpstring">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
     <xsl:with-param name="thestring" select="substring-after($args,concat($used,')'))" />
     <!--
     <xsl:with-param name="thestring" select="substring-after($remainder,')')" />
     -->
     <xsl:with-param name="instPosDep" select="$instPosDep" />
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$thestring" />
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

<!--
 <xsl:template match="@*[not(name()='id') and contains(.,'$hxp_')]" mode="template" priority="2">
 -->
 <xsl:template match="@*[contains(.,'$hxp_')]" mode="template" priority="2">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''" />
  <xsl:attribute name="{name()}">
   <xsl:call-template name="hxpstring"><xsl:with-param name="thestring" select="."/><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:call-template>
  </xsl:attribute>
  <!--
  <xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/><xsl:with-param name="instPosDep" select="$instPosDep" /></xsl:call-template>
  -->
 </xsl:template>

 <xsl:template match="@id[starts-with(.,'hxpid')]" mode="template" priority="2">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''" />
  <xsl:attribute name="id">
   <!-- <xsl:value-of select="substring-after(substring-before(.,'-'),'hxpid')"/> -->
   <xsl:call-template name="hxpstring"><xsl:with-param name="thestring" select="substring-after(substring-before(.,'-'),'hxpid')"/><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:call-template>
  </xsl:attribute>
 </xsl:template>

 <!-- (Al posto di copy-of) Utile per copiare parte di un elemento nel quale si vuole processare qualcosa -->

 <xsl:template name="stringparser">
  <xsl:param name="blockPath" select="''"/><xsl:param name="data" select="$hxpdata"/><xsl:param name="instPosDep" select="''" />

  <xsl:choose>
   <xsl:when test="name()='id' and starts-with(.,'hxp')"><!-- da call-template -->
    <xsl:if test="starts-with(.,'hxpid')"><!-- ignora gli 'hxp-' -->
     <xsl:attribute name="id">
      <!-- <xsl:value-of select="substring-after(substring-before(.,'-'),'hxpid')"/> -->
      <xsl:call-template name="hxpstring"><xsl:with-param name="thestring" select="substring-after(substring-before(.,'-'),'hxpid')"/><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:call-template>
     </xsl:attribute>
    </xsl:if>
   </xsl:when>
   <!--
   <xsl:when test="contains(.,$paramid)">
    <xsl:attribute name="{name()}">
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data"/>
      <xsl:with-param name="thestring" select="."/>
       <xsl:with-param name="instPosDep" select="$instPosDep" />
     </xsl:call-template>
    </xsl:attribute>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy/>
   </xsl:otherwise>
   -->
   <xsl:otherwise>
    <xsl:apply-templates mode="template" select="."><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$data"/><xsl:with-param name="instPosDep" select="$instPosDep" /></xsl:apply-templates>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

<!--
 <xsl:template match="@*" name="stringparser" mode="stringparser">
  <xsl:param name="blockPath" select="''"/><xsl:param name="data" select="$hxpdata" />
  <xsl:param name="instPosDep" select="''" />
  <xsl:choose>
   <xsl:when test="contains(.,$paramid)">
    <xsl:choose>
     <xsl:when test="name()='id' or name()='ID'">
      <xsl:attribute name="id">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='onload' or name()='onLoad'">
      <xsl:attribute name="onload">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='onunload' or name()='onUnload'">
      <xsl:attribute name="onunload">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='onclick' or name()='onClick'">
      <xsl:attribute name="onclick">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='onchange' or name()='onChange'">
      <xsl:attribute name="onchange">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='onmouseover'">
      <xsl:attribute name="onmouseover">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='title'">
      <xsl:attribute name="title">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='value'">
      <xsl:attribute name="value">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data" />
        <xsl:with-param name="thestring" select="." />
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:when test="name()='name'">
      <xsl:attribute name="name">
       <xsl:call-template name="hxpstring">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$data"/>
        <xsl:with-param name="thestring" select="."/>
        <xsl:with-param name="instPosDep" select="$instPosDep" />
       </xsl:call-template>
      </xsl:attribute>
     </xsl:when>
     <xsl:otherwise>
      <xsl:copy />
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy />
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>
-->

 <!-- Aggiunge al body eventuali attributi definiti in "bodyattributes"
      e gli handler "loadHandler()" e "unloadHandler()".
      Infine aggiunge eventuali input nascosti definiti in "beforeend". -->
 <xsl:template match="body" mode="template" priority="1">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:apply-templates mode="template" select="@*[name()!='onload' and name()!='onunload']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
   <xsl:copy-of select="@*" />
   -->
   <!--
   <xsl:for-each select="@*[name()!='onload' and name()!='onunload']"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /></xsl:call-template></xsl:for-each>
   -->
<!-- fabio -->
   <xsl:if test="$nojs!='1'">
<!-- /fabio -->
    <xsl:attribute name="onload">
     <xsl:text>loadHandler(</xsl:text>
     <!--
     	Federico 15/12/06: questi parametri vanno aggiunti solo nella pagina di interazione utente della
     	function "ModificaAllegato" [RW 0040831]
     -->
     <!-- Mario4workflow -->
     <xsl:if test="$hxpdata/@wfAction!='' and $hxpdata/@verbo='documento_response' and $hxpdata/@xverb='@openChkinPage'">
		<xsl:text>'</xsl:text>
		<xsl:call-template name="toJSParam">
			<xsl:with-param name="testo" select="$hxpdata/coming_from/description" />
		</xsl:call-template>
		<xsl:text>','</xsl:text>
		<xsl:call-template name="toJSParam">
			<xsl:with-param name="testo" select="$hxpdata/coming_from/notes" />
		</xsl:call-template>
		<xsl:text>'</xsl:text>
	 </xsl:if>
     <!-- /Mario4workflow -->
	 <xsl:text>);</xsl:text>
     <!--
     <xsl:value-of select="@onload" />
     -->
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      <xsl:with-param name="thestring" select="@onload"/>
     </xsl:call-template>
     <!--controllo sul checksum-->
     <xsl:if test="$hxpdata/@verbo='showdoc' and $hxpdata/@dbTable!='@reload'">
     <!-- nel caso di caricamento della pagina vuota che serve per evitare che il reload della pagina di visualizzazione
     	  faccia rieseguire certe azioni critiche,  inutile fare il controllo del checksum
     -->
      <xsl:variable name="chkContent">
       <xsl:for-each select="$hxpdata//processing-instruction('xw-crc')">
        <xsl:value-of select="current()"/>
       </xsl:for-each>
      </xsl:variable>
      <xsl:if test="$chkContent!=''">
       <xsl:text>checksum('</xsl:text>
       <xsl:value-of select="$chkContent"/>
       <xsl:text>');</xsl:text>
      </xsl:if>
     </xsl:if>
    </xsl:attribute>
    <xsl:attribute name="onunload">
     <xsl:text>unloadHandler();</xsl:text>
     <!--
     <xsl:value-of select="@onunload" />
     -->
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      <xsl:with-param name="thestring" select="@onunload"/>
     </xsl:call-template>
    </xsl:attribute>
<!-- fabio -->
   </xsl:if>
<!-- /fabio -->
   <xsl:call-template name="bodyattributes" />
   <xsl:apply-templates select="node()" mode="template" />

   <!--
   	Modifica di Federico del 17/12/2004: chiamata al template "includeCalendarDiv" per l'eventuale inclusione del
   	div nascosto del calendario javascript.
   -->
   <xsl:call-template name="includeCalendarDiv"/>

   <xsl:call-template name="beforeend" />
  </xsl:copy>
 </xsl:template>

 <!-- Applica a head il template "jslist"(Javascript da includere)... -->
 <xsl:template match="head" mode="template">
  <xsl:copy>
   <!--
   		Gestione delle informazioni relative alla document type definition dell'output finale
   		(si veda file doctype.xsl sotto generic presentation).
   		Gli eventuali attributi "docTypePublic" e "docTypeSystem" non devono essere copiati.
   		(codice aggiunto da Federico il 28/08/2004)
   -->
   <xsl:copy-of select="@* [not(name() = 'docTypePublic' or name() = 'docTypeSystem')]" />

   <meta name="generator" content="fabio@hxp" />
   <meta http-equiv="pragma" content="no-cache" />
   <meta http-equiv="expires" content="now" />
   <xsl:if test="$nojs!='1'">
    <xsl:element name="script">
     <xsl:attribute name="src">../../../formatter/html/data/js/common.js</xsl:attribute>
     <xsl:attribute name="type">text/javascript</xsl:attribute>
     <xsl:text>;</xsl:text>
    </xsl:element>
	<!--
		Federico 08/11/05: dato che 'varie.js' generico deve essere presente in tutte le pag., la sua inclusione
		e' stata spostata qui [RW 0031851].
	-->
	<script>
		<xsl:attribute name="src">../../../formatter/html/data/js/varie.js</xsl:attribute>
		<xsl:attribute name="type">text/javascript</xsl:attribute>
		<xsl:text>;</xsl:text>
	</script>
   </xsl:if>
   <xsl:call-template name="jslist" />
   <xsl:call-template name="rangejslist" />

   <!--
   	Modifica di Federico del 17/12/2004: chiamata al template "includeJsForCalendar" per l'eventuale inclusione del
   	javascript del calendario javascript.
   -->
   <xsl:call-template name="includeJsForCalendar" />

   <xsl:apply-templates select="node()" mode="template" />
  </xsl:copy>
 </xsl:template>

 <!-- Segnala errore in caso di id non gestito  -->
 <xsl:template name="hxperrorhandler">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <br />
  <b>unhandled id: <xsl:value-of select="@id" /></b>
  <br />
  <!--
  <xsl:call-template name="hxpcontinue" />
  -->
  <xsl:call-template name="hxpcontinuecontext">
   <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
  </xsl:call-template>
 </xsl:template>

 <!-- Conversione mese
 @param month numero del mese
 @return nome del mese per esteso
 -->
 <xsl:template name="italian-month">
  <xsl:param name="month" select="number('99')" />
  <xsl:choose>
   <xsl:when test="$month=1">gennaio</xsl:when>
   <xsl:when test="$month=2">febbraio</xsl:when>
   <xsl:when test="$month=3">marzo</xsl:when>
   <xsl:when test="$month=4">aprile</xsl:when>
   <xsl:when test="$month=5">maggio</xsl:when>
   <xsl:when test="$month=6">giugno</xsl:when>
   <xsl:when test="$month=7">luglio</xsl:when>
   <xsl:when test="$month=8">agosto</xsl:when>
   <xsl:when test="$month=9">settembre</xsl:when>
   <xsl:when test="$month=10">ottobre</xsl:when>
   <xsl:when test="$month=11">novembre</xsl:when>
   <xsl:when test="$month=12">dicembre</xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$month" />
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <!-- Formattazione della data.
 Formati di input riconosciuti: aaaammgg, ggmmaaaa, aaaa-mm-gg, gg-mm-aaaa (- oppure /)
 @param mode se uguale a "it" restituisce la data col mese in italiano per esteso (gg nome_mese aaaa), altrimenti
 la restituisce nel formato gg/mm/aaaa -->
 <xsl:template name="dateformatter">
  <xsl:param name="mode" select="''" />
  <xsl:param name="datas" select="." />

  <!-- Federico 25/05/06: introdotta gestione data non definita ('n.d.') [RW 0037124] -->
  <xsl:choose>
	  <xsl:when test="string-length($datas) > 0 and $datas!='n.d.'">
	   <xsl:choose>
	    <xsl:when test="$mode='it'">
	     <xsl:choose>
	      <xsl:when test="string-length($datas)=10"> <!-- ci sono separatori -->
	       <xsl:choose>
	        <xsl:when test="string-length(substring-before($datas,'-'))=4
	                        or string-length(substring-before($datas,'-'))=4">
	         <!-- data in formato aaaa-mm-gg -->
	         <xsl:value-of select="number(substring($datas,9,2))" />
	         <xsl:text></xsl:text>
	         <xsl:call-template name="italian-month">
	          <xsl:with-param name="month" select="number(substring($datas,6,2))" />
	         </xsl:call-template>
	         <xsl:text></xsl:text>
	         <xsl:value-of select="substring($datas,1,4)" />
	        </xsl:when>
	        <xsl:otherwise>
	         <!-- data in formato gg-mm-aaaa -->
	         <xsl:value-of select="number(substring($datas,1,2))" />
	         <xsl:text></xsl:text>
	         <xsl:call-template name="italian-month">
	          <xsl:with-param name="month" select="number(substring($datas,4,2))" />
	         </xsl:call-template>
	         <xsl:text></xsl:text>
	         <xsl:value-of select="substring($datas,7,4)" />
	        </xsl:otherwise>
	       </xsl:choose>
	      </xsl:when>
	      <xsl:when test="13>number(substring($datas,5,2))">
	        <!-- data in formato aaaammgg -->
	        <xsl:value-of select="number(substring($datas,7,2))" />
	        <xsl:text></xsl:text>
	        <xsl:call-template name="italian-month">
	         <xsl:with-param name="month" select="number(substring($datas,5,2))" />
	        </xsl:call-template>
	        <xsl:text></xsl:text>
	        <xsl:value-of select="substring($datas,1,4)" />
	      </xsl:when>
	      <xsl:otherwise>
	       <!-- data in formato ggmmaaaa -->
	       <xsl:value-of select="number(substring($datas,1,2))" />
	       <xsl:text></xsl:text>
	       <xsl:call-template name="italian-month">
	        <xsl:with-param name="month" select="number(substring($datas,3,2))" />
	       </xsl:call-template>
	       <xsl:text></xsl:text>
	       <xsl:value-of select="substring($datas,5,4)" />
	      </xsl:otherwise>
	     </xsl:choose>
	    </xsl:when>
	    <xsl:otherwise>
	     <xsl:choose>
	      <xsl:when test="string-length($datas)=10"> <!-- ci sono separatori -->
	       <xsl:choose>
	        <xsl:when test="string-length(substring-before($datas,'-'))=4
	                        or string-length(substring-before($datas,'-'))=4">
	         <!-- data in formato aaaa-mm-gg -->
	         <xsl:value-of select="substring($datas,9,2)" />
	         <xsl:text>/</xsl:text>
	         <xsl:value-of select="substring($datas,6,2)" />
	         <xsl:text>/</xsl:text>
	         <xsl:value-of select="substring($datas,1,4)" />
	        </xsl:when>
	        <xsl:otherwise>
	         <!-- data in formato gg-mm-aaaa -->
	         <xsl:value-of select="substring($datas,1,2)" />
	         <xsl:text>/</xsl:text>
	         <xsl:value-of select="substring($datas,4,2)" />
	         <xsl:text>/</xsl:text>
	         <xsl:value-of select="substring($datas,7,4)" />
	        </xsl:otherwise>
	       </xsl:choose>
	      </xsl:when>
	      <xsl:when test="13>number(substring($datas,5,2))">
	       <!-- data in formato aaaammgg -->
	       <xsl:value-of select="substring($datas,7,2)" />
	       <xsl:text>/</xsl:text>
	       <xsl:value-of select="substring($datas,5,2)" />
	       <xsl:text>/</xsl:text>
	       <xsl:value-of select="substring($datas,1,4)" />
	      </xsl:when>
	      <xsl:otherwise>
	       <!-- data in formato ggmmaaaa -->
	       <xsl:value-of select="substring($datas,1,2)" />
	       <xsl:text>/</xsl:text>
	       <xsl:value-of select="substring($datas,3,2)" />
	       <xsl:text>/</xsl:text>
	       <xsl:value-of select="substring($datas,5,4)" />
	      </xsl:otherwise>
	     </xsl:choose>
	    </xsl:otherwise>
	   </xsl:choose>
	  </xsl:when>
	  <xsl:otherwise>
	    <!-- data vuota o non definita ('n.d.') -->
	  	<xsl:value-of select="$datas"/>
	  </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <!-- begin of content handler -->

 <xsl:template name="showpi">
  <xsl:param name="attrib" select="''"/>
  <xsl:param name="copy" select="''"/>
  <xsl:variable name="base">
   <xsl:choose>
    <xsl:when test="contains($attrib,'|')">
     <xsl:value-of select="substring-before($attrib,'|')"/>
    </xsl:when>
    <xsl:otherwise>
     <xsl:value-of select="string($attrib)"/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:variable>
  <xsl:variable name="campo" select="concat(substring-after($attrib,'|'),':')"/>
  <xsl:for-each select="./processing-instruction()[$base=name()][(':'=$campo) or (starts-with(.,$campo))][1]">
   <xsl:choose>
    <xsl:when test="':'!=$campo">
     <xsl:if test="starts-with(.,$campo)">
      <xsl:value-of select="substring-after(.,$campo)"/>
     </xsl:if>
    </xsl:when>
    <xsl:otherwise>
     <xsl:apply-templates select="."/>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:for-each>
  <xsl:if test="0=count(./processing-instruction()[$base=name()][(':'=$campo) or (starts-with(.,$campo))][1])">
   <xsl:for-each select="./following-sibling::processing-instruction()[$base=name()][(':'=$campo) or (starts-with(.,$campo))][1]">
    <xsl:choose>
     <xsl:when test="':'!=$campo">
      <xsl:if test="starts-with(.,$campo)">
       <xsl:value-of select="substring-after(.,$campo)"/>
      </xsl:if>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-templates select="."/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:for-each>
  </xsl:if>
 </xsl:template>

 <xsl:template name="showtext">
  <xsl:param name="attrib" select="''"/>
  <xsl:param name="copy" select="''"/>
  <xsl:choose>
   <xsl:when test="$copy=''">
    <xsl:choose>
     <xsl:when test="$attrib=''">

	  <!--
		Modifica di Federico del 24/08/2004 (intervento per evidenziare i termini cercati in una query):
		occorre forzare il matching con le eventali processing instruction contenute nell'elemento che si
		sta esaminando per effettuare l'highlighting dei termini cercati in una query.
		I template che elaborano le processing instruction devono essere inseriti nella presentation specifica
		dell'applicazione (meglio se in un file xsl apposito, come, per esempio, "highlight.xsl").
	  -->
      <xsl:apply-templates select="text()|processing-instruction()"/>

     </xsl:when>
     <xsl:otherwise>
       <xsl:apply-templates select="@*[name()=$attrib]"/> <!-- mode="highlight" -->
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:choose>
     <xsl:when test="$attrib=''">
      <xsl:for-each select="./node()">
       <xsl:copy-of select="."/>
      </xsl:for-each>
     </xsl:when>
     <xsl:otherwise>
      <xsl:copy-of select="@*[name()=$attrib]"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

<!--
	<xsl:template name="showtext">
		<xsl:param name="attrib" select="''" />
		<xsl:choose>
			<xsl:when test="$attrib=''">
				<xsl:apply-templates />
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="@*[name()=$attrib]" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>-->

<!--	<xsl:template name="matchcontent">
		<xsl:param name="elemName" select="''" />
		<xsl:choose>
			<xsl:when test="name()=$elemName or name()=substring-before($elemName,'/@')">
				<xsl:call-template name="showtext">
					<xsl:with-param name="attrib" select="substring-after($elemName,'/@')" />
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="*">
					<xsl:call-template name="matchcontent">
						<xsl:with-param name="elemName" select="$elemName" />
					</xsl:call-template>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template> -->

 <xsl:template name="matchcontent">
  <xsl:param name="elemName" select="''"/>
  <xsl:param name="copy" select="''"/>
  <xsl:choose>
   <xsl:when test="starts-with($elemName,'pi-')">
    <xsl:call-template name="showpi">
     <xsl:with-param name="attrib" select="substring-after($elemName,'pi-')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="starts-with($elemName,'@')">
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="name()=$elemName or name()=substring-before($elemName,'/@')">
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'/@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:for-each select="*">
     <xsl:call-template name="matchcontent">
      <xsl:with-param name="elemName" select="$elemName"/>
      <xsl:with-param name="copy" select="$copy"/>
     </xsl:call-template>
    </xsl:for-each>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

  <xsl:template name="matchcontentfc">
  <xsl:param name="elemName" select="''"/>
  <xsl:param name="copy" select="''"/>

  <xsl:choose>

   <xsl:when test="starts-with($elemName,'pi-')">
  <!-- <xsl:text>pi-</xsl:text>-->
    <xsl:call-template name="showpi">
     <xsl:with-param name="attrib" select="substring-after($elemName,'pi-')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:when test="starts-with($elemName,'@')">
 <!--  <xsl:text>attrib</xsl:text>-->
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:when test="name()=$elemName or name()=substring-before($elemName,'/@')">
   <!--<xsl:text>element</xsl:text>-->
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'/@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:otherwise>
     <!-- <xsl:text>figlio</xsl:text>-->
      <xsl:variable name='realElem'>
       <xsl:choose>
       <xsl:when test="contains($elemName,'/')">
       <xsl:value-of select="substring-before($elemName,'/')"/>
       </xsl:when>
       <xsl:otherwise>
       <xsl:value-of select="$elemName"/>
       </xsl:otherwise>
       </xsl:choose>
      </xsl:variable>

     <!--  <xsl:value-of select='count(.//*[name()=$realElem][position()=1])'/>-->

    <xsl:for-each select="(.//*[name()=$realElem])[position()=1]">

     		<xsl:call-template name="matchcontentfc">
      		<xsl:with-param name="elemName" select="$elemName"/>
      		<xsl:with-param name="copy" select="$copy"/>
     		</xsl:call-template>

    </xsl:for-each>
   </xsl:otherwise>

  </xsl:choose>
 </xsl:template>

 <xsl:template name="matchcontentlc">
  <xsl:param name="elemName" select="''"/>
  <xsl:param name="copy" select="''"/>

  <xsl:choose>

   <xsl:when test="starts-with($elemName,'pi-')">
  <!-- <xsl:text>pi-</xsl:text>-->
    <xsl:call-template name="showpi">
     <xsl:with-param name="attrib" select="substring-after($elemName,'pi-')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:when test="starts-with($elemName,'@')">
 <!--  <xsl:text>attrib</xsl:text>-->
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:when test="name()=$elemName or name()=substring-before($elemName,'/@')">
   <!--<xsl:text>element</xsl:text>-->
    <xsl:call-template name="showtext">
     <xsl:with-param name="attrib" select="substring-after($elemName,'/@')"/>
     <xsl:with-param name="copy" select="$copy"/>
    </xsl:call-template>

   </xsl:when>
   <xsl:otherwise>
     <!-- <xsl:text>figlio</xsl:text>-->
      <xsl:variable name='realElem'>
       <xsl:choose>
       <xsl:when test="contains($elemName,'/')">
       <xsl:value-of select="substring-before($elemName,'/')"/>
       </xsl:when>
       <xsl:otherwise>
       <xsl:value-of select="$elemName"/>
       </xsl:otherwise>
       </xsl:choose>
      </xsl:variable>

     <!--  <xsl:value-of select='count(.//*[name()=$realElem][position()=1])'/>-->

    <xsl:if test="count(.//*[name()=$realElem])>1"><!--se sono solo sono il primo...no ultimo valore-->
    <xsl:for-each select="(.//*[name()=$realElem])[position()=last()]">

     		<xsl:call-template name="matchcontentfc">
      		<xsl:with-param name="elemName" select="$elemName"/>
      		<xsl:with-param name="copy" select="$copy"/>
     		</xsl:call-template>

    </xsl:for-each>
 	</xsl:if>

   </xsl:otherwise>

  </xsl:choose>
 </xsl:template>


 <xsl:template name="matchchoose">
  <xsl:param name="elemName" select="''" />
  <xsl:variable name="cont">
   <xsl:choose>
    <xsl:when test="string-length(substring-before($elemName,','))">
     <xsl:call-template name="matchcontent">
      <xsl:with-param name="elemName" select="substring-before($elemName,',')" />
     </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
     <xsl:call-template name="matchcontent">
      <xsl:with-param name="elemName" select="$elemName" />
     </xsl:call-template>
    </xsl:otherwise>
   </xsl:choose>
  </xsl:variable>
  <xsl:choose>
   <xsl:when test="string-length($cont)">
    <xsl:value-of select="normalize-space($cont)" />
   </xsl:when>
   <xsl:when test="string-length(substring-after($elemName,','))">
    <xsl:call-template name="matchchoose">
     <xsl:with-param name="elemName" select="substring-after($elemName,',')" />
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise />
  </xsl:choose>
 </xsl:template>

 <!-- Implementazione di id="hxp-content".
 Restituisce il valore di un elemento XML in hxpdata
 @param elemName elemento di cui si restituisce il valore -->
 <xsl:template name="hxpcontent">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="elemName" select="''" />
  <xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:call-template name="attrparser">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/><xsl:with-param name="instPosDep" select="$instPosDep"/>
   </xsl:call-template>
   <!--
   <xsl:for-each select="@*[name()!='id']"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:call-template></xsl:for-each>
   -->
   <xsl:for-each select="$blockData">
    <xsl:call-template name="matchcontent">
     <xsl:with-param name="elemName" select="$elemName" />
    </xsl:call-template>
   </xsl:for-each>
  </xsl:copy>
 </xsl:template>

 <!-- Implementazione di id="hxp-htmlContent".
 Restituisce il valore di un elemento XML in hxpdata
 formattandolo come HTML, cio sostituendo i CR LF con dei <br/>
 @param elemName elemento di cui si restituisce il valore -->
 <xsl:template name="hxphtmlcontent">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="elemName" select="''" /><xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
    <xsl:for-each select="@*[name()!='id']"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/></xsl:call-template></xsl:for-each>
    -->
   <xsl:variable name="testo">
    <xsl:for-each select="$blockData">
     <xsl:call-template name="matchcontent">
      <xsl:with-param name="elemName" select="$elemName"/>
     </xsl:call-template>
    </xsl:for-each>
   </xsl:variable>
   <xsl:call-template name="toHtmlFormatted">
    <xsl:with-param name="testo" select="$testo"/>
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <!--
 	Visualizzazione di elementi contenenti dell'html (prodotto, per esempio, dall'editor javascript per le textarea).
	Occorre disabilitare l'escaping nel visualizzare il contenuto dell'elemento che contiene l'html (var. elemName)
	in modo che venga restituito dell'html valido per il browser.
	(Federico)
 -->
 <xsl:template name="hxpshowHtmlNode">
  <xsl:param name="elemName" select="''" />
  <!--
  	Federico 18/11/2004: il parametro "blockData" contiene il contesto corrente. Quando viene passato
  	come parametro,  importante usare tale contesto al posto di "hxpdata", poich, se l'xml prodotto da java 
  	una lista di documenti, iterare su tutti i nodi alla ricerca di "elemName" porta a selezionare tutti i nodi
  	"elemName" di tutti i documenti e non di quello che si sta analizzando.
  	Nell'uso di "blockData" si  reso necessario specificare l'XPath "$blockData/..//", poich l'elemento
  	con id "hxp-showHtmlNode-nodo" potrebbe essere contenuto in un "hxp-notEmptyIterator-nodo" che, come ogni
  	iteratore, fissa il contesto a "nodo" (caso riscontrato in visualizzazione).
  	Qualora il contesto fosse corretto (cio fosse il padre di "nodo"), non ci sarebbero comunque problemi (questo
  	grazie alla presenza di "//").
  -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>

  <!--
  	Federico 18/11/2004: il parametro "outContentType" consente di distinguere la semplice visualizza-
  	zione dalla generazione di un pdf. In quest'ultimo caso occorre forzare il matching con i template che trasformano
  	l'html in xsl-fo.
  -->
  <xsl:param name="outContentType" select="''" />

  <!--
  	Federico 17/11/2004: modificata la struttura del template per la gestione dei nodi
  	multifont multilingua.
  -->
  <xsl:variable name="nodeName">
  	<xsl:choose>
  		<xsl:when test="contains($elemName, '.$lang')">
  			<xsl:value-of select="substring-before($elemName, '.$lang')"/>
  			<xsl:value-of select="substring-after($elemName, '.$lang')"/>
  		</xsl:when>
  		<xsl:otherwise>
  			<xsl:value-of select="$elemName"/>
  		</xsl:otherwise>
  	</xsl:choose>
  </xsl:variable>

  <xsl:for-each select="$blockData/..//*[name()=$nodeName]">
	<!--
		Federico 11/10/2004:
		In seguito alle modifiche introdotte per risolvere l'anomalia 0023181, il codice prodotto dall'editor
		javascript per le textarea pu essere inserito in un elemento del doc. xml o come semplice testo o
		come codice xhtml well-formed.
		Nel primo caso occorre capire se sono presenti dei tag html nel nodo corrente, in modo da visualizzarne
		il contenuto disabilitando l'escaping; nel secondo caso, invece, occorre ricopiare nell'output l'intero
		sottoalbero contenuto nel nodo corrente.
	-->
	<xsl:choose>
		  	<!--
			Federico 10/08/05: 'jsEditorContent' potrebbe non essere presente per una dimenticanza (per es. e'
			successo in caso di import di documenti convertiti da una vecchia banca dati spring 2000),
			nonostante il nodo corrente contenga codice html non escapato.
			Quindi, la condizione di contenuto testuale si ha quando non e' presente 'jsEditorContent' e
			il nodo corrente ha un solo figlio di tipo testo.
		-->
  		<xsl:when test="count(./jsEditorContent) = 0 and count(./*) = 1 and count(child::text()) = 1">
		  	<!--
		  		CONTENUTO TESTUALE

		  		Cerco di capire se il nodo contiene dell'html e, in tal caso, lo visualizzo disabilitando l'escaping.
		  		Qualora il contenuto non sia html, chiamo il template "toHtmlFormatted" per mantenere gli spazi e i
		  		new line (cio sostituendo i CR LF con dei <br/>).
		  	-->

		  	<!--
				Federico 24/08/04:
				occorre forzare il matching con le eventali processing instruction contenute nell'elemento che si
				sta esaminando per effettuare l'highlighting dei termini cercati in una query.
				I template che elaborano le processing instruction devono essere inseriti nella presentation specifica
				dell'applicazione (meglio se in un file xsl apposito, come, per esempio, "highlight.xsl").
			-->
		  	<xsl:variable name="content">
			  	<xsl:apply-templates select="."/>
			</xsl:variable>

		  	<xsl:choose>
		  		<!--
		  			Federico 02/03/2005: eliminati i test "contains($content,'&lt;A') or contains($content,'&lt;a') or"
		  			poiche' sono stati trovati dei documenti contenenti dei link (url e mail) in cui e' necessario inserire
		  			i <br/> al posto degli a capo.
		  		-->
		  		<xsl:when test="contains($content,'&lt;BR') or
		  						contains($content,'&lt;P') or
		  						contains($content,'&lt;TABLE') or
		  						contains($content,'&lt;FONT') or
		  						contains($content,'&lt;DIV') or
		  						contains($content,'&lt;STRONG') or
		  						contains($content,'&lt;U') or
		  						contains($content,'&lt;OL') or
		  						contains($content,'&lt;UL') or
		  						contains($content,'&lt;EM') or
		  						contains($content,'&lt;br') or
		  						contains($content,'&lt;p') or
		  						contains($content,'&lt;table') or
		  						contains($content,'&lt;font') or
		  						contains($content,'&lt;div') or
		  						contains($content,'&lt;strong') or
		  						contains($content,'&lt;u') or
		  						contains($content,'&lt;ol') or
		  						contains($content,'&lt;ul') or
		  						contains($content,'&lt;em')">

					<xsl:value-of select="$content" disable-output-escaping="yes"/>
			  	</xsl:when>
			  	<xsl:otherwise>
			  		<!--
			  			Federico 27/01/2005: la copia del nodo corrente non deve essere fatta, dato che si tratta
			  			di un elemento xml del documento esaminato e non di un tag xhtml.
			  		-->
		      			<xsl:call-template name="toHtmlFormatted">
						    <xsl:with-param name="testo" select="$content"/>
					   	</xsl:call-template>
				</xsl:otherwise>
		  	</xsl:choose>
		</xsl:when>
		<xsl:otherwise>
			<!-- CONTENUTO XHTML -->

			<!--
				Solo qui ha senso intervenire per la gestione dei nodi multilingua, dato che sicuramente
				sono stati salvati come frammenti (==> hanno il tag radice <jsEditorContent>).
			-->
			<xsl:choose>
		  		<xsl:when test="contains($elemName, '.$lang')">
		  			<!-- gestione nodo multifont multilingua: occorre mostrare solo le sezioni nella lingua scelta -->
		  			<xsl:variable name="langMarkerName" select="substring-before($hxpdata/@languageMarker, '@')"/>
					<xsl:variable name="langMarkerAttr" select="substring-after($hxpdata/@languageMarker, '@')"/>
		  			<xsl:variable name="langContent">
						<xsl:for-each select=".//*[name()=$langMarkerName]">
							<xsl:variable name="lang">
								<xsl:value-of select="./@*[name()=$langMarkerAttr]"/>
							</xsl:variable>
							<xsl:if test="$hxpdata/@language=$lang">
								<!--  stata trovata una sezione nella lingua specificata -->
								<xsl:choose>
									<xsl:when test="$outContentType='pdf'">
										<!--
											per generare i pdf occorre forzare il matching con i template che
											trasformano l'html in xsl-fo.
										-->
										<xsl:apply-templates select="./* | ./text()"/>
									</xsl:when>
									<xsl:otherwise>
										<!-- Federico 23/09/05: forzato matching sulle processing instruction per highlight -->
										<!--<xsl:copy-of select="./* | ./text()"/>-->
										<xsl:apply-templates select="./* | ./text() | ./processing-instruction()" mode="showMultiLangHtmlNodeMode">
						  					<xsl:with-param name="lMarkerName" select="'!'"/>
						  					<xsl:with-param name="outContentType" select="$outContentType" />
						  				</xsl:apply-templates>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:if>
						</xsl:for-each>
					</xsl:variable>
					<xsl:choose>
			  			<xsl:when test="$langContent!=''">
			  				<xsl:copy-of select="$langContent"/>
						</xsl:when>
						<xsl:otherwise>
							<!-- adattamento alla modifica del 10/08/05 (vedi sopra) -->
				  			<xsl:choose>
				  				<xsl:when test="count(./jsEditorContent) = 0">
				  					<!-- Federico 23/09/05: forzato matching sulle processing instruction per highlight -->
				  					<xsl:apply-templates select="./* | ./text() | ./processing-instruction()" mode="showMultiLangHtmlNodeMode">
					  					<xsl:with-param name="lMarkerName" select="$langMarkerName"/>
					  					<xsl:with-param name="outContentType" select="$outContentType" />
					  				</xsl:apply-templates>
				  				</xsl:when>
				  				<xsl:otherwise>
									<!-- non  stata trovata la lingua selezionata ==> mostro la lingua di default -->
									<!-- Federico 23/09/05: forzato matching sulle processing instruction per highlight -->
									<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text() | ./jsEditorContent/processing-instruction()" mode="showMultiLangHtmlNodeMode">
					  					<xsl:with-param name="lMarkerName" select="$langMarkerName"/>
					  					<xsl:with-param name="outContentType" select="$outContentType" />
				  					</xsl:apply-templates>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
		  		</xsl:when>
		  		<xsl:otherwise>
			  		<!-- gestione nodo multifont non multilingua -->
		  			<!--
						La struttura html viene mantenuta grazie al matching con il template contenuto nel file
						'preserve-html-tags.xsl'.
					-->
					<xsl:choose>
						<xsl:when test="$outContentType='pdf'">
							<!--
								per generare i pdf occorre forzare il matching con i template che
								trasformano l'html in xsl-fo.
							-->

							<!-- adattamento alla modifica del 10/08/05 (vedi sopra) -->
				  			<xsl:choose>
				  				<xsl:when test="count(./jsEditorContent) = 0">
				  					<xsl:apply-templates select="./* | ./text()"/>
				  				</xsl:when>
				  				<xsl:otherwise>
							<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text()"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<!--
								Federico 05/08/05:
								e' bene evitare 'copy-of' o 'copy' per non avere inutili namespace nel codice prodotto
								(non digeriti dai validatori).

								Fabio 21/09/2005: hc (msxml4) si lamenta in fase di compilazione perch $content non
								contiene un set di nodi.

								Federico 23/09/05: risolto eliminando $content e forzando matching sulle processing
								instruction per highlight.
							-->
							<!--
								<xsl:apply-templates select="$content" mode="showMultiLangHtmlNodeMode">
				  					<xsl:with-param name="lMarkerName" select="'!'"/>
				  					<xsl:with-param name="outContentType" select="$outContentType" />
			  					</xsl:apply-templates>
							-->
				  			<xsl:choose>
				  				<xsl:when test="count(./jsEditorContent) = 0">
									<xsl:apply-templates select="./* | ./text() | ./processing-instruction()" mode="showMultiLangHtmlNodeMode">
					  					<xsl:with-param name="lMarkerName" select="'!'"/>
					  					<xsl:with-param name="outContentType" select="$outContentType" />
				  					</xsl:apply-templates>
				  				</xsl:when>
				  				<xsl:otherwise>
				  					<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text() | ./jsEditorContent/processing-instruction()" mode="showMultiLangHtmlNodeMode">
					  					<xsl:with-param name="lMarkerName" select="'!'"/>
					  					<xsl:with-param name="outContentType" select="$outContentType" />
				  					</xsl:apply-templates>
				  				</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
		  		</xsl:otherwise>
		  	</xsl:choose>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:for-each>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 17/11/2004
	*
	* @version 1.0
	*
	* @param lMarkerName Nome dell'elemento del marcatore per le sezioni in lingua.
	* @param outContentType Tipo di output da generare (per ora viene gestito solo il tipo 'pdf').
	*
	* Questo template consente di escludere i marcatori di sezioni in lingua presenti in un nodo html
	* generato dall'editor javascript, in modo che venga visualizzata solo la parte relativa alla lingua
	* di default.
 -->
 <xsl:template match="*" mode="showMultiLangHtmlNodeMode">
  <xsl:param name="lMarkerName" select="''"/>
  <!--
  	Federico 18/11/2004: il parametro "outContentType" consente di distinguere la semplice visualizza-
  	zione dalla generazione di un pdf. In quest'ultimo caso occorre forzare il matching con i template che trasformano
  	l'html in xsl-fo.
  -->
  <xsl:param name="outContentType" select="''" />

  <xsl:if test="name()!=$lMarkerName">
  	<!-- il nodo corrente non indica una sezione multilingua ==> lo mostro -->
  	<xsl:choose>
		<xsl:when test="$outContentType='pdf'">
			<!--
				per generare i pdf occorre forzare il matching con i template che
				trasformano l'html in xsl-fo.
			-->
			<xsl:apply-templates select="."/>
		</xsl:when>
		<xsl:otherwise>
			<!-- copio il nodo e i suoi attributi e avvio la ricorsione per analizzare il contenuto del nodo -->
			<!-- Federico 21/07/05: evito di usare 'xsl:copy' per non avere dichiarazioni 'xmlns:*' nei nodi copiati -->
			<xsl:element name="{name()}">
				<xsl:copy-of select="@*" />
				<xsl:apply-templates select="./* | ./text()" mode="showMultiLangHtmlNodeMode">
			  		<xsl:with-param name="lMarkerName" select="$lMarkerName"/>
			  		<xsl:with-param name="outContentType" select="$outContentType" />
			  	</xsl:apply-templates>
			</xsl:element>
		</xsl:otherwise>
	</xsl:choose>
  </xsl:if>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 23/09/05
	*
	* Questo template consente di evidenziare i termini cercati con le query presenti nelle sezioni in lingua
	* in un nodo html generato dall'editor javascript.
 -->
 <xsl:template match="processing-instruction()" mode="showMultiLangHtmlNodeMode">
 	<!-- avvio il matching con il giusto mode con i template per l'highlight -->
	<xsl:apply-templates select="."/>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 11/10/2004
	*
	* @version 1.0
	*
	* @param elemName elemento del documento da visualizzare
	*
	* Questo template implementa gli id che cominciano con 'hxp-editHtmlNode-'.
	* La struttura di questi id  la seguente:
	*
	*				'hxp-editHtmlNode-nome_nodo'
	*
	* dove 'nome_nodo' rappresenta il nome dell'elemento xml da visualizzare.
	* Se tale elemento contiene del testo, occorre semplicemente visualizzarlo; se, invece, contiene
	* un frammento xhtml, occorre copiare nell'output l'intero sottoalbero in esso contenuto, gestendo,
	* eventualmente, le sezioni multilingua presenti.
 -->
 <xsl:template name="hxpeditHtmlNode">
  <xsl:param name="elemName" select="''" />

  <!-- Federico 02/03/2005: aggiunto parametro "blockData" -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>

  <!--
  	Modifica di Federico del 17/11/2004: modificata la struttura del template per la gestione dei nodi
  	multifont multilingua.
  -->
  <xsl:variable name="nodeName">
  	<xsl:choose>
  		<xsl:when test="contains($elemName, '.$lang')">
  			<xsl:value-of select="substring-before($elemName, '.$lang')"/>
  			<xsl:value-of select="substring-after($elemName, '.$lang')"/>
  		</xsl:when>
  		<xsl:otherwise>
  			<xsl:value-of select="$elemName"/>
  		</xsl:otherwise>
  	</xsl:choose>
  </xsl:variable>
  <xsl:copy>
	<xsl:copy-of select="@* [not(name()='id')]" />

	<!--
		Federico 02/03/2005:
		Spostato "for-each" per iterare sui nodi contenuti in "blockData";
		Differenziata la gestione nodi testuali - nodi xhtml (come in visualizzazione - si veda template
		"hxpshowHtmlNode").
	-->
	<xsl:for-each select="$blockData/..//*[name()=$nodeName]">
		<xsl:choose>
			  	<!--
				Federico 10/08/05: 'jsEditorContent' potrebbe non essere presente per una dimenticanza (per es. e'
				successo in caso di import di documenti convertiti da una vecchia banca dati spring 2000),
				nonostante il nodo corrente contenga codice html non escapato.
				Quindi, la condizione di contenuto testuale si ha quando non e' presente 'jsEditorContent' e
				il nodo corrente ha un solo figlio di tipo testo.
			-->
	  		<xsl:when test="count(./jsEditorContent) = 0 and count(./*) = 1 and count(child::text()) = 1">
			  	<!--
			  		CONTENUTO TESTUALE

			  		Cerco di capire se il nodo contiene dell'html e, in tal caso, lo visualizzo disabilitando l'escaping.
			  		Qualora il contenuto non sia html, chiamo il template "toHtmlFormatted" per mantenere gli spazi e i new line
			  		(cio sostituendo i CR LF con dei <br/>).
			  	-->
			  	<xsl:choose>
			  		<!--
			  			Federico 02/03/2005: eliminati i test "contains(.,'&lt;A') or contains(.,'&lt;a') or"
			  			poiche' sono stati trovati dei documenti contenenti dei link (url e mail) in cui e' necessario inserire
			  			i <br/> al posto degli a capo.
			  		-->
			  		<xsl:when test="contains(.,'&lt;BR') or
			  						contains(.,'&lt;P') or
			  						contains(.,'&lt;TABLE') or
			  						contains(.,'&lt;FONT') or
			  						contains(.,'&lt;DIV') or
			  						contains(.,'&lt;STRONG') or
			  						contains(.,'&lt;U') or
			  						contains(.,'&lt;OL') or
			  						contains(.,'&lt;UL') or
			  						contains(.,'&lt;EM') or
			  						contains(.,'&lt;br') or
			  						contains(.,'&lt;p') or
			  						contains(.,'&lt;table') or
			  						contains(.,'&lt;font') or
			  						contains(.,'&lt;div') or
			  						contains(.,'&lt;strong') or
			  						contains(.,'&lt;u') or
			  						contains(.,'&lt;ol') or
			  						contains(.,'&lt;ul') or
			  						contains(.,'&lt;em')">

						<xsl:value-of select="." disable-output-escaping="yes"/>
				  	</xsl:when>
				  	<xsl:otherwise>
		      			<xsl:call-template name="toHtmlFormatted">
						    <xsl:with-param name="testo" select="."/>
					   	</xsl:call-template>
					</xsl:otherwise>
			  	</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<!-- CONTENUTO XHTML -->

				<!--
					Federico 12/09/05: introdotto controllo dei nodi testo in caso di dimenticanza, in fase
					di import, del tag 'jsEditorContent' (RW 0030230).
				-->
				<xsl:variable name="chkTextNodes">
					<xsl:choose>
						<xsl:when test="count(./jsEditorContent) = 0">
							<!--
								Il tag 'jsEditorContent' potrebbe essere stato omesso in fase di import a causa di
								una dimenticanza.
							-->
							<xsl:text>true</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>false</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>

				<!--
					Solo qui ha senso intervenire per la gestione dei nodi multilingua, dato che sicuramente
					sono stati salvati come frammenti (==> hanno il tag radice <jsEditorContent>).
				-->
			  	<xsl:choose>
			  		<xsl:when test="contains($elemName, '.$lang')">
			  			<!-- gestione nodo multifont multilingua: occorre effettuare l'escaping dei marcatori delle sezioni in lingua -->
			  			<xsl:variable name="langMarkerName" select="substring-before($hxpdata/@languageMarker, '@')"/>
						<xsl:variable name="langMarkerAttr" select="substring-after($hxpdata/@languageMarker, '@')"/>

			  			<!-- adattamento alla modifica del 10/08/05 e del 12/09/05 (vedi sopra) -->
			  			<xsl:choose>
			  				<xsl:when test="count(./jsEditorContent) = 0">
				  				<xsl:apply-templates select="./* | ./text()" mode="editMultiLangHtmlNodeMode">
				  					<xsl:with-param name="lMarkerName" select="$langMarkerName"/>
				  					<xsl:with-param name="lMarkerAttr" select="$langMarkerAttr"/>
						  				<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
				  				</xsl:apply-templates>
					  		</xsl:when>
			  				<xsl:otherwise>
			  					<!-- Federico 08/08/05: e' inutile ricopiare il nodo 'jsEditorContent' -->
				  				<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text()" mode="editMultiLangHtmlNodeMode">
				  					<xsl:with-param name="lMarkerName" select="$langMarkerName"/>
				  					<xsl:with-param name="lMarkerAttr" select="$langMarkerAttr"/>
					  				<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
				  				</xsl:apply-templates>
			  				</xsl:otherwise>
			  			</xsl:choose>
			  		</xsl:when>
			  		<xsl:otherwise>
			  			<!-- gestione nodo multifont non multilingua -->

			  			<!-- adattamento alla modifica del 10/08/05 e del 12/09/05 (vedi sopra) -->
			  			<xsl:choose>
			  				<xsl:when test="count(./jsEditorContent) = 0">
			  					<xsl:apply-templates select="./* | ./text()" mode="editMultiLangHtmlNodeMode">
				  					<xsl:with-param name="lMarkerName" select="'!'"/>
				  					<xsl:with-param name="lMarkerAttr" select="''"/>
					  				<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
				  				</xsl:apply-templates>
			  				</xsl:when>
			  				<xsl:otherwise>
								<!-- Federico 08/08/05: meglio usare 'apply-templates' per non avere inutili namespace nei nodi ricopiati -->
								<!--<xsl:copy-of select="./jsEditorContent/* | ./jsEditorContent/text()"/>-->
				  				<xsl:apply-templates select="./jsEditorContent/* | ./jsEditorContent/text()" mode="editMultiLangHtmlNodeMode">
				  					<xsl:with-param name="lMarkerName" select="'!'"/>
				  					<xsl:with-param name="lMarkerAttr" select="''"/>
					  				<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
				  				</xsl:apply-templates>
			  		</xsl:otherwise>
			  	</xsl:choose>
			</xsl:otherwise>
	  	</xsl:choose>
			</xsl:otherwise>
	  	</xsl:choose>
	</xsl:for-each>
  </xsl:copy>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 17/11/2004
	*
	* @param lMarkerName Nome dell'elemento del marcatore per le sezioni in lingua.
	* @param lMarkerAttr Nome dell'attributo del marcatore per le sezioni in lingua.
	*
	* Questo template consente di escapare i marcatori di sezioni in lingua presenti in un nodo html
	* generato dall'editor javascript.
	* La conversione effettuata  la seguente:
	*
	*	<lMarkerName lMarkerAttr="..."> ==> <p>&lt;lMarkerName lMarkerAttr="..."&gt;</p>
	*	</lMarkerName>					==> <p>&lt;/lMarkerName&gt;</p>
	*
	* Tutti gli altri nodi contenuti nell'elemento html, invece, vengono copiati nell'output cos come sono.
 -->
 <xsl:template match="*|text()" mode="editMultiLangHtmlNodeMode">
  <xsl:param name="lMarkerName" select="''"/>
  <xsl:param name="lMarkerAttr" select="''"/>
  <!--
  	Federico 12/09/05: introdotto controllo dei nodi testo in caso di dimenticanza, in fase
	di import, del tag 'jsEditorContent' (RW 0030230).
  -->
  <xsl:param name="chkTextNodes" select="'false'"/>

  <xsl:choose>
  	<xsl:when test="name()=$lMarkerName">
  		<!-- il nodo corrente indica una sezione multilingua ==> occorre escapare -->
  		<!-- tag di apertura -->
  		<p>
  			<xsl:text>&amp;lt;</xsl:text>
  			<xsl:value-of select="$lMarkerName"/>
  			<xsl:text> </xsl:text>
  			<xsl:value-of select="$lMarkerAttr"/>
  			<xsl:text>="</xsl:text>
  			<xsl:value-of select="./@*[name()=$lMarkerAttr]"/>
  			<xsl:text>"</xsl:text>
  			<xsl:text>&amp;gt;</xsl:text>
  		</p>
  		<!-- avvio la ricorsione sul contenuto del nodo -->
  		<xsl:apply-templates select="./* | ./text()" mode="editMultiLangHtmlNodeMode">
  			<xsl:with-param name="lMarkerName" select="$lMarkerName"/>
  			<xsl:with-param name="lMarkerAttr" select="$lMarkerAttr"/>
			<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
  		</xsl:apply-templates>
  		<!-- tag di chiusura -->
  		<p>
  			<xsl:text>&amp;lt;/</xsl:text>
  			<xsl:value-of select="$lMarkerName"/>
  			<xsl:text>&amp;gt;</xsl:text>
  		</p>
  	</xsl:when>
  	<xsl:otherwise>
  		<!-- il nodo corrente non indica una sezione multilingua -->

  		<!-- Federico 12/09/05: controllo dei nodi testo -->
  		<xsl:choose>
  			<xsl:when test="self::text()">
  				<!-- il nodo corrente e' di tipo testo -->
   				<xsl:choose>
   					<xsl:when test="$chkTextNodes='true'">
   						<!-- occorre aggiungere i br al posto degli a capo e occorre disescapare il testo -->
   						<xsl:variable name="content">
							<xsl:call-template name="toHtmlFormatted">
							    <xsl:with-param name="testo" select="."/>
						   	</xsl:call-template>
						</xsl:variable>
						<xsl:value-of select="$content" disable-output-escaping="yes"/>
   					</xsl:when>
   					<xsl:otherwise>
   						<!-- basta visualizzare il testo cosi' com'e' -->
   						<xsl:value-of select="."/>
   					</xsl:otherwise>
   				</xsl:choose>
  			</xsl:when>
  			<xsl:otherwise>
		  		<!-- Federico 08/08/05: evito di usare 'xsl:copy' per non avere dichiarazioni 'xmlns:*' nei nodi copiati -->
				<xsl:element name="{name()}">
					<!--
						Federico 19/09/05: negli attributi 'href' delle ancore vengono effettuate le sostituzioni
						'&quot;' e '&#34;' ==> '%22', in modo che tali attributi non contengano delle '"' quando
						editati con l'editor js [RW 0029489].
					-->
					<!--<xsl:copy-of select="@*" />-->
					<xsl:for-each select="@*">
						<xsl:attribute name="{name()}">
							<xsl:choose>
								<xsl:when test="name()='href' and contains(., '&quot;')">
									<xsl:call-template name="str:subst">
										<xsl:with-param name="text" select="."/>
										<xsl:with-param name="replace" select="'&quot;'"/>
										<xsl:with-param name="with" select="'%22'"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:when test="name()='href' and contains(., '&#34;')">
									<xsl:call-template name="str:subst">
										<xsl:with-param name="text" select="."/>
										<xsl:with-param name="replace" select="'&#34;'"/>
										<xsl:with-param name="with" select="'%22'"/>
									</xsl:call-template>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="."/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
					</xsl:for-each>
					<xsl:apply-templates select="./* | ./text()" mode="editMultiLangHtmlNodeMode">
		  				<xsl:with-param name="lMarkerName" select="$lMarkerName"/>
		  				<xsl:with-param name="lMarkerAttr" select="$lMarkerAttr"/>
						<xsl:with-param name="chkTextNodes" select="$chkTextNodes"/>
		  			</xsl:apply-templates>
				</xsl:element>
		  	</xsl:otherwise>
		</xsl:choose>
  	</xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <!--
	* @author Mario Bussetti
	*
	* Created on 29/03/2005
	*
	* @version 1.0
	*
	* Questo template consente di scrivere un frammento xml in una pagina html, tag inclusi
	* La conversione effettuata  la seguente:
	*
	*	<elemento attributo1="..." attributo2="..."> ==> &lt;elemento attributo1="..." attributo2="..."&gt;
	*	</elemento>					==> &lt;/elemento&gt;
	*
	* Tutti gli altri nodi contenuti nell'elemento html, invece, vengono copiati nell'output cos come sono.
 -->
 <xsl:template match="*" mode="editXmlAsHtml">
	<xsl:text>&lt;</xsl:text>
	<xsl:value-of select="name()"/>
	<xsl:text> </xsl:text>
	<xsl:for-each select="@*">
		<xsl:value-of select="name()"/>
		<xsl:text>="</xsl:text>
		<xsl:value-of select="."/>
		<xsl:text>" </xsl:text>
	</xsl:for-each>
	<xsl:text>&gt;</xsl:text>
	<!--xsl:element name="br"/-->
	<!-- avvio la ricorsione sul contenuto del nodo -->
	<xsl:apply-templates select="./* | ./text()" mode="editXmlAsHtml">
	</xsl:apply-templates>
	<!-- tag di chiusura -->
	<xsl:text>&lt;/</xsl:text>
	<xsl:value-of select="name()"/>
	<xsl:text>&gt;</xsl:text>
	<xsl:element name="br"/>
 </xsl:template>

 <!-- *********************************** VISUALIZZAZIONE METADATI *********************************** -->

 <!--
	* @author Mario Bussetti
	*
	* Created on 24/05/2005
	*
	* @version 1.0
	*
	* Questo template consente di scrivere un frammento xml in una pagina html come elenco piatto fatto nel seguente
	* modo:
	*
	*   <elementoP>
	*		<elemento attributo1="..." attributo2="...">valore</elemento>
	*   </elementoP>
	*	==> <span>elementoP/elemento:valore</span>
	*
	* Federico 24/05/07: aggiunto parametro 'priority="1"' per consentire una gestione specifica per alcuni elementi dei
	* metadati (si vedano template con 'mode="metadata"') [RW 0044319]
	*
 -->
 <xsl:template match="*" mode="metadata" priority="1">
 	<xsl:variable name="testo">
 		<xsl:call-template name="do-replace">
			<xsl:with-param name="text" select="normalize-space(./text())"/>
			<xsl:with-param name="replace" select="','"/>
			<xsl:with-param name="by" select="', &#32;'"/>
		</xsl:call-template>
 	</xsl:variable>
	<xsl:element name="span">
		<b>
			<xsl:value-of select="name()"/>
		</b>
		<xsl:choose>
			<xsl:when test="string-length($testo) = 0">
				<xsl:text>/</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>: </xsl:text>
				<xsl:value-of select="$testo"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:element>
	<xsl:if test="string-length($testo) > 0">
		<xsl:element name="br"/>
	</xsl:if>

	<!-- avvio la ricorsione sul contenuto del nodo -->
	<xsl:apply-templates select="./*" mode="metadata">
	</xsl:apply-templates>
 </xsl:template>

 <!-- Federico 24/05/07: gestione elementi 'imageMetadata', 'documentMetadata' e 'avMetadata' dei metadati [RW 0044319] -->
 <xsl:template match="*[name()='imageMetadata' or name()='documentMetadata' or name()='avMetadata']" mode="metadata" priority="2">
 	<xsl:apply-templates select="./*" mode="metadata"/>
 </xsl:template>

 <!-- Federico 24/05/07: gestione elementi 'userDefined' dei metadati [RW 0044319] -->
 <xsl:template match="*[name()='userDefined']" mode="metadata" priority="2">
 	<b><xsl:value-of select="@name"/><xsl:text> (</xsl:text><xsl:value-of select="name()"/><xsl:text>): </xsl:text><xsl:value-of select="."/></b><br/>
 </xsl:template>

 <!--
 	Federico 24/05/07: gestione elementi 'exifData' e 'iptcData' dei metadati [RW 0044319]
 	Federico 29/05/07: restyling della visualizzazione exif/iptc (test con IE, Firefox, Safari e Camino) [RW 0044319]
 -->
 <xsl:template match="*[name()='exifData' or name()='iptcData']" mode="metadata" priority="2">
 	<div style="height:1em; background-color:#transparent; padding:0px 0px 0px 0px; font-size:45%;"/>
	<fieldset>
		<legend style="font-family:arial; font-size:100%; font-style:oblique; font-weight:bold; color:#000000; padding:0px 4px">
			<xsl:value-of select="substring-before(name(),'Data')"/>
		</legend>
		<dl style="margin:3px 5px; height:7em; background-color:#transparent; color:#00639C; vertical-align:center; overflow:auto;">
		 	<xsl:for-each select="./*[name()='tag']">
		 		<dt style="float:left; width:200px; line-height:1em; font-weight:bold; color:#000000;">
	 				<xsl:value-of select="@name"/>
	 				<xsl:text>: </xsl:text>
		 		</dt>
		 		<dd style="margin-left:220px; line-height:1em; color:#000000;">
		 			<xsl:value-of select="."/>
		 		</dd>
		 	</xsl:for-each>
		</dl>
	</fieldset>
 </xsl:template>

 <!-- *********************************** FINE VISUALIZZAZIONE METADATI *********************************** -->

 <!--			TEMPLATE PER LA GESTIONE DEL MULTILINGUA			-->
 <!--
	* @author Federico Grillini
	*
	* Created on 16/11/2004
	*
	* @param elemName elemento del documento da visualizzare.
	* @param blockData rappresenta il contesto corrente da analizzare.
	*
	* Questo template implementa gli id che cominciano con 'hxp-showMultiLangNode-'.
	* La struttura di questi id  la seguente:
	*
	*				'hxp-showMultiLangNode-nome_nodo'
	*
	* dove 'nome_nodo' rappresenta il nome dell'elemento xml multilingua da visualizzare.
	* Per ora 'nome_nodo' non viene utilizzato, dato che si fa riferimento al contesto corrente rappresentato
	* da 'blockData'.
	* Tale parametro  stato, comunque, lasciato per possibili usi futuri.
 -->
 <xsl:template name="hxpshowMultiLangNode">
  <xsl:param name="elemName" select="''" />
  <!--
  	Modifica di Federico del 18/11/2004: il parametro "blockData" contiene il contesto corrente. Quando viene passato
  	come parametro,  importante usare tale contesto al posto di "hxpdata", poich, se l'xml prodotto da java 
  	una lista di documenti, iterare su tutti i nodi alla ricerca di "elemName" porta a selezionare tutti i nodi
  	"elemName" di tutti i documenti e non di quello che si sta analizzando.
  	Lo stesso comportamento, inoltre, si ha per gli elementi multistanza.
  -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />

  <xsl:copy>
  	  <xsl:copy-of select="@*[not(name()='id')]" />
		<!-- occorre visualizzare la lingua selezionata, o, in sua assenza, quella di default -->
		<xsl:variable name="langMarkerName" select="substring-before($hxpdata/@languageMarker, '@')"/>
		<xsl:variable name="langMarkerAttr" select="substring-after($hxpdata/@languageMarker, '@')"/>
		<xsl:variable name="langContent">
			<xsl:for-each select="$blockData/*[name()=$langMarkerName]">
				<xsl:variable name="lang">
					<xsl:value-of select="./@*[name()=$langMarkerAttr]"/>
				</xsl:variable>
				<xsl:if test="$hxpdata/@language=$lang">
					<!-- Federico 23/09/05: forzato matching per highlight -->
					<!--<xsl:value-of select="."/>-->
					<xsl:apply-templates select="."/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
  			<xsl:when test="$langContent!=''">
  				<!-- Federico 23/09/05: 'langContent' puo' contenere degli span per l'highlight ==> uso copy-of -->
  				<!--<xsl:value-of select="$langContent"/>-->
  				<xsl:copy-of select="$langContent"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- non  stata trovata la lingua selezionata ==> mostro la lingua di default -->
				<!-- Federico 23/09/05: forzato matching per highlight (uso lo stesso mode per i nodi dell'editor js) -->
				<!--<xsl:value-of select="$blockData/text()"/>-->
				<xsl:apply-templates select="$blockData/text() | $blockData/processing-instruction()" mode="showMultiLangHtmlNodeMode">
  					<xsl:with-param name="lMarkerName" select="$langMarkerName"/>
  					<xsl:with-param name="outContentType" select="'html'" />
  				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
  </xsl:copy>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 16/11/2004
	*
	* @param param output field ed elemento del documento da visualizzare.
	* @param instPosDep indicatore dell'indice dei campi multistanza.
	* @param blockData rappresenta il contesto corrente da analizzare.
	*
	* Questo template implementa gli id che cominciano con 'hxp-editMultiLangNode-'.
	* La struttura di questi id  la seguente:
	*
	*				'hxp-editMultiLangNode-[setAttrib#attribName|setContent]-nome_nodo'
	*
	* dove 'nome_nodo' rappresenta il nome dell'elemento xml multilingua da editare.
	* 'nome_nodo' viene utilizzato solo quando il contesto corrente (rappresentato da 'blockData')
	* risulta essere errato, cio quando risulta essere 'name($blockData)!=nome_nodo)'. In tal caso
	* si itera su 'hxpdata' alla ricerca di 'nome_nodo'.
	* Se 'nome_nodo' contiene del testo, occorre semplicemente visualizzarlo; se, invece, contiene
	* un frammento xml (marcatori di sezioni in lingua), occorre copiare nell'output l'intero sottoalbero
	* in esso contenuto.
	*
	* "setAttrib|setContent", invece, indica l'output field:
	*
	*	setAttrib: indica che il contenuto dell'elemento "nome_nodo" deve essere messo nell'attributo "attribName"
	*			   dell'elemento corrente (cio quello che contiene l'id "hxp-editMultiLangNode");
	*	setContent: indica che il contenuto dell'elemento "nome_nodo" deve essere messo nel content
	*			   dell'elemento corrente (cio quello che contiene l'id "hxp-editMultiLangNode").
 -->
 <xsl:template name="hxpeditMultiLangNode">
  <xsl:param name="param" select="''" /><xsl:param name="instPosDep" select="''"/>
  <!--
  	Modifica di Federico del 19/11/2004: il parametro "blockData" contiene il contesto corrente. Quando viene passato
  	come parametro,  importante usare tale contesto al posto di "hxpdata", poich l'xml del documento potrebbe
  	contenere pi nodi dello stesso tipo (multistanza).
  -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''"/>

  <xsl:copy>
  	  <!--
  	  	Dato che l'elemento del template che sto analizzando potrebbe essere multistanza
  	  	(quindi, potrebbe contenere nel name stringhe come "hxp_fatherinstance()" e affini per la determinazione
  	  	del numero dell'istanza corrente), la copia degli attributi non deve essere fatta con <xsl:copy-of...>,
  	  	bens con una chiamata al template "attrparser", passandogli il parametro "instPosDep".
  	  -->
  	  <xsl:call-template name="attrparser">
		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
		<xsl:with-param name="instPosDep" select="$instPosDep"/>
	  </xsl:call-template>
  	  <xsl:variable name="elemName" select="substring-after($param, '-')"/>
  	  <xsl:choose>
  	  	<xsl:when test="name($blockData)=$elemName">
  	  	  <!-- "blockData" rappresenta il contesto corretto (cio quello di "elemName") -->
	  	  <xsl:choose>
		  	<xsl:when test="substring-before($param, '-')='setContent'">
				<!-- inserimento nel content dell'elemento di output -->
				<xsl:copy-of select="$blockData/* | $blockData/text()"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- inserimento nell'attributo specificato dell'elemento di output -->
				<xsl:variable name="attrCmd" select="substring-before($param, '-')"/>
				<xsl:if test="substring-before($attrCmd, '#')='setAttrib'">
					<xsl:variable name="attrName" select="substring-after($attrCmd, '#')"/>
					<xsl:attribute name="{$attrName}">
						<!--
							"attribute" pu contenere solo stringhe ==> occorre convertire in stringa il contenuto
							dell'elemento corrente (rappresentato da "blockData").
						-->
						<xsl:apply-templates select="$blockData/* | $blockData/text()" mode="editMultiLangNodeMode"/>
					</xsl:attribute>
				</xsl:if>
			</xsl:otherwise>
		  </xsl:choose>
		 </xsl:when>
		 <xsl:otherwise>
		  <!-- "blockData" non rappresenta il contesto corretto (cio quello di "elemName") ==> itero su "hxpdata" -->
		  <xsl:choose>
		  	<xsl:when test="substring-before($param, '-')='setContent'">
				<!-- inserimento nel content dell'elemento di output -->
				<xsl:for-each select="$hxpdata//*[name()=$elemName]">
					<xsl:copy-of select="./* | ./text()"/>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<!-- inserimento nell'attributo specificato dell'elemento di output -->
				<xsl:variable name="attrCmd" select="substring-before($param, '-')"/>
				<xsl:if test="substring-before($attrCmd, '#')='setAttrib'">
					<xsl:variable name="attrName" select="substring-after($attrCmd, '#')"/>
					<xsl:attribute name="{$attrName}">
						<!--
							"attribute" pu contenere solo stringhe ==> occorre convertire in stringa il contenuto
							dell'elemento "elemName".
						-->
						<xsl:apply-templates select="$hxpdata//*[name()=$elemName]/* | $hxpdata//*[name()=$elemName]/text()" mode="editMultiLangNodeMode"/>
					</xsl:attribute>
				</xsl:if>
			</xsl:otherwise>
		  </xsl:choose>
		 </xsl:otherwise>
	  </xsl:choose>
  </xsl:copy>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 16/11/2004
	*
	* Questo template consente di trasformare in stringa tutti i nodi contenuti all'interno di un campo multilingua.
	* La rappresentazione in stringa riproduce gli attributi e la gerarchia dei nodi.
 -->
 <xsl:template match="*" mode="editMultiLangNodeMode">
  <!-- tag di apertura: <nome_nodo_corrente -->
  <xsl:value-of select="'&lt;'" disable-output-escaping="yes"/>
  <xsl:value-of select="name()"/>
  <!-- copia degli attributi del nodo corrente -->
  <xsl:for-each select="@*">
	<xsl:text> </xsl:text>
	<xsl:value-of select="name()"/>
	<xsl:text>="</xsl:text>
	<xsl:value-of select="."/>
	<xsl:text>"</xsl:text>
  </xsl:for-each>
  <!-- chiusura del tag di apertura: > -->
  <xsl:text>></xsl:text>
  <!-- avvio la ricorsione per analizzare il contenuto del nodo corrente -->
  <xsl:apply-templates select="./* | ./text()" mode="editMultiLangNodeMode"/>
  <!-- tag di chiusura: </nome_nodo_corrente> -->
  <xsl:value-of select="'&lt;/'" disable-output-escaping="yes"/>
  <xsl:value-of select="name()"/>
  <xsl:text>></xsl:text>
 </xsl:template>

 <!--
	* @author Federico Grillini
	*
	* Created on 16/11/2004
	*
	* Questo template consente di trasformare in stringa tutti i nodi testo contenuti all'interno di un campo
	* multilingua.
 -->
 <xsl:template match="text()" mode="editMultiLangNodeMode">
  <xsl:value-of select="."/>
 </xsl:template>
 <!--			FINE TEMPLATE PER LA GESTIONE DEL MULTILINGUA			-->

 <!-- Implementazione di id="hxp-contextcustom-(specializzazione)".
 Occorre implementare un template contextcustom in tutti i file xsl specifici.
 (specializzazione serve per offrire una sorta di switch) -->
 <xsl:template name="hxpcontextcustom">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="specName" select="''" /><xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
   <xsl:for-each select="@*[name()!='id']"><xsl:call-template name="stringparser"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/></xsl:call-template></xsl:for-each>
   -->
   <xsl:call-template name="contextcustom">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="specName" select="$specName" />
   </xsl:call-template>
  </xsl:copy>
 </xsl:template>

 <!-- Implementazione di id="hxp-contextcustomNoCopy-(specializzazione)".
 Occorre implementare un template contextcustom in tutti i file xsl specifici.
 (specializzazione serve per offrire una sorta di switch) -->
 <xsl:template name="hxpcontextcustomnocopy">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="specName" select="''" />
  <xsl:call-template name="contextcustom">
   <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
   <xsl:with-param name="specName" select="$specName" />
  </xsl:call-template>
 </xsl:template>

 <!-- end of content handler -->

 <!-- aumentata la priority rispetto a stringparser perch messo in causa qui solo se  il caso -->
 <xsl:template match="img/@alt" mode="template" priority="3">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="disable" select="''" />
  <xsl:if test="not($disable='1')">
   <xsl:attribute name="alt"><xsl:call-template name="hxpstring"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/><xsl:with-param name="thestring" select="."/></xsl:call-template></xsl:attribute>
  </xsl:if>
  <!--
  <xsl:choose>
   <xsl:when test="$disable='1'">
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="stringparser">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
  -->
 </xsl:template>

 <xsl:template name="srcHandler">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="thestring" select="."/><xsl:param name="disable" select="''" />
  <xsl:choose>
  <!--
   <xsl:when test="$disable='1' and contains(.,'_on_')">
    <xsl:attribute name="src">
     <xsl:copy-of select="substring-before(.,'_on_')" />
     <xsl:text>_off_</xsl:text>
     <xsl:copy-of select="substring-after(.,'_on_')" />
    </xsl:attribute>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy />
   </xsl:otherwise>
  -->
   <xsl:when test="$disable='1' and contains(.,'_on_')">
     <xsl:variable name="s">
      <xsl:copy-of select="substring-before(.,'_on_')" />
      <xsl:text>_off_</xsl:text>
      <xsl:copy-of select="substring-after(.,'_on_')" />
     </xsl:variable>
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
      <xsl:with-param name="thestring" select="$s"/>
     </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
      <xsl:with-param name="thestring" select="."/>
     </xsl:call-template>
    <!--
    <xsl:call-template name="stringparser">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
    </xsl:call-template>
    -->
   </xsl:otherwise>

  </xsl:choose>
 </xsl:template>

 <!-- Modifica il nome del file associato a un'immagine
 @param disable se uguale a "1" modifica il nome del file associato a un'immagine
 sostituendo "_on_" con "_off_". Utile nel caso in cui si voglia disabilitare un pulsante
 (cambiandone l'immagine) in determinate condizioni -->

 <!-- aumentata la priority rispetto a stringparser perch messo in causa qui dopo l'opportuna elaborazione -->
 <xsl:template match="img/@src|input/@src" mode="template" priority="3">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" />

  <xsl:attribute name="src">
   <xsl:call-template name="srcHandler">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
    <xsl:with-param name="thestring" select="." /><xsl:with-param name="disable" select="$disable" />
   </xsl:call-template>
  </xsl:attribute>

 </xsl:template>
<!--
 <xsl:template name="hxpcontinue">
  <xsl:copy>
   <xsl:copy-of select="@*" />
   <xsl:apply-templates mode="template" />
  </xsl:copy>
 </xsl:template>
-->
  <!-- come il template precedente ma la disabilitazione avviene modificando il class dello span in questione -->
  <xsl:template match="span/@class|div/@class" mode="template">
  <xsl:param name="disable" select="''" />
  <xsl:choose>
   <xsl:when test="$disable='1'">
    <xsl:attribute name="class">
     <xsl:value-of select="." /><xsl:text>_disabled</xsl:text>
    </xsl:attribute>
   </xsl:when>
   <xsl:otherwise>
    <xsl:copy />
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>


 <!-- begin of container handler -->

 <xsl:template name="hxpcontinuecontext">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" />
  <xsl:apply-templates mode="template">
   <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
   <xsl:with-param name="disable" select="$disable" />
  </xsl:apply-templates>
 </xsl:template>

 <xsl:template name="copyBlockTemplateElement">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''" />
  <xsl:param name="instPosDep" select="''"/>
  <xsl:choose>
   <!--xsl:when test="substring-before(@id,'-')='hxp'"-->
   <xsl:when test="starts-with(@id,'hxp')">
    <xsl:call-template name="hxparser">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>

    <xsl:copy>

     <xsl:apply-templates mode="template" select="@*"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
<!--
     <xsl:for-each select="@*">
      <xsl:call-template name="stringparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/>
      </xsl:call-template>
     </xsl:for-each>
-->
     <xsl:for-each select="node()">
      <xsl:if test="name()=''">
       <xsl:copy-of select="." />
      </xsl:if>
      <xsl:if test="name()!=''">
       <xsl:call-template name="copyBlockTemplateElement">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:for-each>
    </xsl:copy>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="blockFormatter">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="''" />
  <xsl:param name="blockTemplate" select="''" />
  <xsl:param name="instPosDep" select="''"/>
  <xsl:for-each select="$blockTemplate">
   <xsl:call-template name="copyBlockTemplateElement">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    <xsl:with-param name="instPosDep" select="$instPosDep"/>
   </xsl:call-template>
  </xsl:for-each>
 </xsl:template>

 <xsl:template name="applycontent" match="*" mode="nonhocontesto">
  <xsl:param name="blockPath" select="''"/><xsl:param name="elemName" select="''"/>
  <xsl:param name="elemTemplate" select="''"/>
  <xsl:param name="anyway" select="''"/>
  <xsl:param name="tempName" select="''"/>
  <xsl:param name="instPosDep" select="''"/>

  <xsl:choose>
   <xsl:when test="substring-after($elemName,',')!=''">
    <xsl:variable name="parms">
     <xsl:call-template name="hxpstring">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="."/>
      <xsl:with-param name="thestring" select="substring-after($elemName,',')"/>
      <xsl:with-param name="instPosDep" select="$instPosDep"/>
     </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="minpos" select="$parms"/>
    <xsl:variable name="maxpos" select="substring-after($minpos,',')"/>
    <xsl:choose>
     <xsl:when test="substring(normalize-space($parms),string-length(normalize-space($parms)))=',' or normalize-space($parms)=''">
      <xsl:for-each select="(descendant-or-self::*[name()=substring-before($elemName,',')])">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:when test="$maxpos!=''">
      <xsl:for-each select="(descendant-or-self::*[name()=substring-before($elemName,',')])[position()>=number(substring-before($minpos,',')) and number($maxpos)>=position()]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
     </xsl:when>
     <xsl:otherwise>
      <xsl:for-each select="(descendant-or-self::*[name()=substring-before($elemName,',')])[position()>=number($minpos)]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:choose>

     <xsl:when test="starts-with($elemName,'@')">
      <xsl:if test="./@*[name()=substring-after($elemName,'@')]!=''">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
      <xsl:if test="$anyway='1' and count(./@*[name()=substring-after($elemName,'@')])=0">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:when>

     <xsl:when test="contains($elemName,'/@')">
      <xsl:for-each select="descendant-or-self::*[name()=substring-before($elemName,'/@')]">
<!--
      <xsl:for-each select="self::*[name()=substring-before($elemName,'/@')]">
-->
       <xsl:if test="./@*[name()=substring-after($elemName,'/@')]!=''">
        <xsl:call-template name="blockFormatter">
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
         <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
         <xsl:with-param name="instPosDep" select="$instPosDep"/>
        </xsl:call-template>
       </xsl:if>
      </xsl:for-each>
      <xsl:if test="$anyway='1' and count(descendant-or-self::*[name()=substring-before($elemName,'/@')])=0">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:when>

     <xsl:when test="$elemName='*'">
      <xsl:for-each select="*">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
      <xsl:if test="$anyway='1'">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:when>

     <xsl:when test="starts-with($elemName,'*[')">
      <xsl:for-each select="*[position()=number(translate(substring-after($elemName,'*['),']',' '))]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
      <xsl:if test="$anyway='1' and count(*[position()=number(translate(substring-after($elemName,'*['),']',' '))])=0">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:when>

     <xsl:when test="contains($elemName,'[')">
      <xsl:for-each select="descendant-or-self::*[name()=substring-before($elemName,'[')]
                               [position()=number(translate(substring-after($elemName,'['),']',' '))]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:for-each>
      <xsl:if test="$anyway='1' and count(descendant-or-self::*[name()=substring-before($elemName,'[')]
                                              [position()=number(translate(substring-after($elemName,'['),']',' '))])=0">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:when>
     <xsl:otherwise>
      <xsl:for-each select="descendant-or-self::*[name()=$elemName]">
       <xsl:variable name="elaborate">
        <xsl:choose>
         <xsl:when test="$tempName!=''">
          <xsl:call-template name="containerConditional">
           <xsl:with-param name="tempName" select="$tempName"/>
           <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
          </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
          <xsl:text>1</xsl:text>
         </xsl:otherwise>
        </xsl:choose>
       </xsl:variable>
       <xsl:if test="string-length($elaborate) &gt; 0">
        <xsl:call-template name="blockFormatter">
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
         <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
         <xsl:with-param name="instPosDep" select="$instPosDep"/>
        </xsl:call-template>
       </xsl:if>
      </xsl:for-each>
      <xsl:variable name="zeroCase">
       <xsl:for-each select="descendant-or-self::*[name()=$elemName]"><!-- caso particolare -->
        <xsl:choose>
         <xsl:when test="$tempName!=''">
          <xsl:call-template name="containerConditional">
           <xsl:with-param name="tempName" select="$tempName"/>
           <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
          </xsl:call-template>
         </xsl:when>
         <xsl:otherwise>
          <xsl:text>1</xsl:text>
         </xsl:otherwise>
        </xsl:choose>
       </xsl:for-each>
      </xsl:variable>
      <xsl:if test="($anyway='1' and count(descendant-or-self::*[name()=$elemName])=0) or
                    ($anyway='1' and string-length($zeroCase)=0)">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="/text()"/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
        <xsl:with-param name="instPosDep" select="$instPosDep"/>
       </xsl:call-template>
      </xsl:if>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>


 <!-- Implementazione di id="hxp-containerof".
  Container di vari "hxp-content" che si vuole reiterare. -->
 <xsl:template name="hxpcontainer">
  <!-- Copy the current element, then copy the first child
      filling with data for each elemName in $hxpdata.
      The remainders are ignored. -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="instPosDep" select="''"/>
  <xsl:param name="elemName" select="''" /><xsl:param name="tempName" select="''"/>
  <xsl:copy>

   <xsl:apply-templates mode="template" select="@*"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
   <xsl:for-each select="@*[name()!='id']">
    <xsl:call-template name="stringparser">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
    </xsl:call-template>
   </xsl:for-each>
   -->

   <xsl:variable name="elemTemplate" select="*[position()=1]" />
   <xsl:for-each select="$blockData"> <!-- applica a ogni elemento (che ha il nome specificato nel containerof) del file xml il contesto del primo figlio del container(template da applicargli) -->
    <xsl:call-template name="applycontent">
     <xsl:with-param name="elemName" select="$elemName" />
     <xsl:with-param name="elemTemplate" select="$elemTemplate" />
     <xsl:with-param name="tempName" select="$tempName"/>
    </xsl:call-template>
   </xsl:for-each>
  </xsl:copy>
 </xsl:template>

 <!-- Implementazione di id="hxp-fulliterator" -->
 <xsl:template name="hxpfulliterator">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="instPosDep" select="''"/>
  <xsl:param name="elemName" select="''" /><xsl:param name="tempName" select="''"/>
   <xsl:variable name="todo">
    <xsl:variable name="elemTemplate" select="*" />
    <xsl:for-each select="$blockData">
     <xsl:call-template name="applycontent">
      <xsl:with-param name="elemName" select="$elemName" />
      <xsl:with-param name="elemTemplate" select="$elemTemplate" />
      <xsl:with-param name="tempName" select="$tempName"/>
     </xsl:call-template>
    </xsl:for-each>
   </xsl:variable>
   <!-- test ri-corretto da mbussetti il 13/09/2005 -->
   <!--xsl:if test="$todo!=''"-->
   <!--xsl:if test="$todo"-->
   <xsl:if test="normalize-space(string($todo))!=''">
    <xsl:copy>
     <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
     <!--
     <xsl:for-each select="@*[name()!='id']">
      <xsl:call-template name="stringparser">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
      </xsl:call-template>
     </xsl:for-each>
     -->
     <!--xsl:variable name="elemTemplate" select="*" />
     <xsl:for-each select="$blockData">
      <xsl:call-template name="applycontent">
       <xsl:with-param name="elemName" select="$elemName" />
       <xsl:with-param name="elemTemplate" select="$elemTemplate" />
       <xsl:with-param name="tempName" select="$tempName"/>
      </xsl:call-template>
     </xsl:for-each-->
     <xsl:copy-of select="$todo"/>
    </xsl:copy>
  </xsl:if>
 </xsl:template>

 <!-- Fabio: Il template  frutto di lavorazione a pi mani di cui si  persa la traccia.
             Cercando di ricostruirne la logica con Simone siamo giunti alla seguente conclusione:
             scopo del template  la realizzazione di un iteratore sul contesto dati passato come
             parametro da applicarsi a tutti gli elementi del template HTML (contesto corrente).
             In origine l'implementazione consisteva nel solo codice ora contenuto nella variabile
             todo. La variabile todo1  stata introdotta per la verifica della presenza di dati in
             mancanza dei quali non si vuole proseguire l'elaborazione (come suggerisce il nome),
             non solo del contesto esplicitato dal parametro ma in generale per tutto il sottoalbero.
             L'implementazione attuale non tiene conte della presenza di attributi per cui se il
             valore da verificare  un attributo va specificato nel parametro con la sintassi
             <elemento padre>/@<nome attributo>.
             Di fatto si genera una incongruenza se il template HTML richiama solo un sottoinsieme
             dei dati contenuti nel sottoalbero e il test sul contenuto di todo pu rivelarsi
             fuorviante se sono presenti diciture o altro. Per evitare effetti indesiderati sul
             pregresso mi sono per ora limitato a sostituire per ragioni di efficienza al blocco di
             codice in fondo al template il valore della variabile todo che ne costituisce l'esito.
 -->
 <!-- Implementazione di id="hxp-notEmptyIterator" -->
 <xsl:template name="notemptyiterator">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" /><xsl:param name="instPosDep" select="''"/>
  <xsl:param name="elemName" select="''" /><xsl:param name="tempName" select="''"/>
  <!-- todo1 rappresenta gli elementi del template da ricopiare -->
  <xsl:variable name="todo">
   <xsl:variable name="elemTemplate" select="*" />
   <xsl:for-each select="$blockData">
    <xsl:call-template name="applycontent">
     <xsl:with-param name="elemName" select="$elemName" />
     <xsl:with-param name="elemTemplate" select="$elemTemplate" />
     <xsl:with-param name="tempName" select="$tempName"/>
    </xsl:call-template>
   </xsl:for-each>
  </xsl:variable>
  <!-- todo1 rappresenta il contenuto dell'elemento/attributo del contesto specificato (sottoalbero compreso) -->
  <xsl:variable name="todo1">
   <xsl:for-each select="$blockData">
    <xsl:call-template name="hxpcontent_nei">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="elemName" select="$elemName" />
    </xsl:call-template>
   </xsl:for-each>
  </xsl:variable>
  <!-- test ri-corretto da mbussetti il 13/09/2005 -->
  <!--xsl:if test="normalize-space($todo)!='' and normalize-space($todo1)!=''"-->
  <!--xsl:if test="$todo and $todo1"-->
  <xsl:if test="normalize-space(string($todo))!='' and normalize-space(string($todo1))!=''">
   <xsl:copy>
    <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
    <!--
    <xsl:for-each select="@*[name()!='id']">
     <xsl:call-template name="stringparser">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
     </xsl:call-template>
    </xsl:for-each>
    -->
    <xsl:copy-of select="$todo"/>
    <!--
    <xsl:variable name="elemTemplate" select="*" />
    <xsl:for-each select="$blockData">
     <xsl:call-template name="applycontent">
      <xsl:with-param name="elemName" select="$elemName" />
      <xsl:with-param name="elemTemplate" select="$elemTemplate" />
      <xsl:with-param name="tempName" select="$tempName"/>
     </xsl:call-template>
    </xsl:for-each>
    -->
   </xsl:copy>
  </xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 31/08/2004
	*
 	* @param blockData xml da analizzare
 	* @param elemName elemento da controllare
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-notEmpy-elem'.
 	* Esso verifica se elem  vuoto e nel caso in cui non lo sia copia nell'output il contenuto
 	* dell'elemento corrente.
 	* A differenza di notemptyiterator non esegue alcuna iterazione nel caso siano presenti pi elementi
 	* elem.
 -->
 <xsl:template name="hxpnotempty">
 	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="elemName" select="''" />

   	<xsl:variable name="content">
   		<xsl:for-each select="$blockData">
		    <xsl:call-template name="matchcontent">
		     <xsl:with-param name="elemName" select="$elemName" />
		    </xsl:call-template>
   		</xsl:for-each>
   	</xsl:variable>

   	<xsl:if test="not($content='')">
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 28/06/2005
	*
 	* @param blockData	xml da analizzare.
 	* @param elemName 	elementi da cercare e controllare.
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-exists-elem'.
 	* Esso copia nell'output il contenuto dell'elemento del template html che possiede l'id menzionato
 	* solo se tra i figli di 'blockData' esiste almeno un elemento di nome 'elem' che non e' vuoto o che
 	* possiede almeno un attributo non vuoto.
 -->
 <xsl:template name="hxpexists">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="elemName" select="''" />

   	<xsl:variable name="exists">
   	 	<!-- controllo dei figli di 'blockData' -->
   		<xsl:for-each select="$blockData/*[name()=$elemName]">
	    	<!-- verifico che il nodo contenga qualcosa -->
	    	<xsl:variable name="content">
	    		<xsl:copy-of select="./*"/>
	    	</xsl:variable>

	    	<xsl:choose>
	    		<xsl:when test="$content!=''">
	    			<xsl:text>true</xsl:text>
	    		</xsl:when>
	    		<xsl:otherwise>
	    			<!-- verifico che il nodo abbia almeno un attributo non vuoto -->
	    			<xsl:variable name="attribContent">
		    			<xsl:for-each select="./@*">
		    				<xsl:value-of select="."/>
		    			</xsl:for-each>
		    		</xsl:variable>

		    		<xsl:if test="$attribContent!=''">
		    			<xsl:text>true</xsl:text>
		    		</xsl:if>
	    		</xsl:otherwise>
	    	</xsl:choose>
   		</xsl:for-each>
   	</xsl:variable>

	<xsl:if test="$exists!=''">
   		<!-- ho trovato un 'elemName' non vuoto tra i figli di 'blockData' -->
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 20/12/2005
	*
 	* @param blockData	xml da analizzare.
 	* @param elemName 	elementi da cercare e controllare.
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-notexists-elem'.
 	* Esso copia nell'output il contenuto dell'elemento del template html che possiede l'id menzionato
 	* solo se tra i figli di 'blockData' non esistono elementi di nome 'elem' non vuoti o che
 	* possiedono almeno un attributo non vuoto.<br>
 	* In sostanza rappresenta la negazione del template 'hxpexists'.
 -->
 <xsl:template name="hxpnotexists">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="elemName" select="''" />

   	<xsl:variable name="exists">
   	 	<xsl:call-template name="hxpexists">
	     <xsl:with-param name="blockPath" select="$blockPath"/>
	     <xsl:with-param name="blockData" select="$blockData"/>
	     <xsl:with-param name="elemName" select="$elemName"/>
	    </xsl:call-template>
   	</xsl:variable>

	<xsl:if test="$exists=''">
   		<!-- non ho trovato un 'elemName' non vuoto tra i figli di 'blockData' -->
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 14/05/2007
	*
 	* @param blockData	xml da analizzare.
 	* @param attrName 	attributo da cercare e controllare.
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-notExistOrEmptyAttr-attrName'.
 	* Esso copia nell'output il contenuto dell'elemento del template html che possiede l'id menzionato
 	* solo se tra gli attributi di 'blockData' non esiste quello indicato ('attrName'), nel senso che o
 	* non c'e' o e' vuoto.
 -->
 <xsl:template name="hxpNotExistOrEmptyAttr">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="attrName" select="''" />

   	<xsl:variable name="exists" select="$blockData/@*[name()=$attrName]"/>

	<xsl:if test="string-length($exists)=0">
   		<!-- non ho trovato l'attributo indicato -->
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 02/11/2009
	*
 	* @param blockData	xml da analizzare.
 	* @param attrName 	attributo da cercare e controllare.
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-existAndFullAttr-attrName'.
 	* Esso copia nell'output il contenuto dell'elemento del template html che possiede l'id menzionato
 	* solo se tra gli attributi di 'blockData' esiste quello indicato ('attrName'), nel senso che
 	* c'e' e non e' vuoto.
 -->
 <xsl:template name="hxpExistAndFullAttr">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="attrName" select="''" />

   	<xsl:variable name="exists" select="$blockData/@*[name()=$attrName]"/>

	<xsl:if test="string-length($exists)&gt;0">
   		<!-- ho trovato l'attributo indicato -->
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
 	* Created on: 23/12/2008
	*
 	* @param blockData	xml da analizzare.
 	* @param elemName 	elementi da cercare e controllare.
 	*
 	* Questo template si occupa della gestione dell'id 'hxp-exists_everywhere-elem'.
 	* Esso copia nell'output il contenuto dell'elemento del template html che possiede l'id menzionato
 	* solo se tra i figli di 'blockData' (indipendentemente dallo loro posizione nell'albero di 'blockData')
 	* esiste almeno un elemento di nome 'elem' che non e' vuoto o che possiede almeno un attributo non vuoto.
 -->
 <xsl:template name="hxpexistseverywhere">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
  	<xsl:param name="elemName" select="''" />

   	<xsl:variable name="exists">
   	 	<!-- controllo dei figli di 'blockData' -->
   		<xsl:for-each select="$blockData//*[name()=$elemName]">
	    	<!-- verifico che il nodo contenga qualcosa -->
	    	<xsl:variable name="content">
	    		<!-- Federico 30/03/09: al posto di './*', che non seleziona i nodi testo ma solo gli elementi figli, e' meglio usare '.' [M 0000278] -->
	    		<xsl:copy-of select="."/>
	    	</xsl:variable>

	    	<xsl:choose>
	    		<xsl:when test="$content!=''">
	    			<xsl:text>true</xsl:text>
	    		</xsl:when>
	    		<xsl:otherwise>
	    			<!-- verifico che il nodo abbia almeno un attributo non vuoto -->
	    			<xsl:variable name="attribContent">
	    				<!-- Federico 28/05/09: e' bene non considerare gli attributi 'xml:space' per non fare comparire campi che in realta' sono vuoti [M 0000460] -->
		    			<xsl:for-each select="./@*[name()!='xml:space']">
		    				<xsl:value-of select="."/>
		    			</xsl:for-each>
		    		</xsl:variable>

		    		<xsl:if test="$attribContent!=''">
		    			<xsl:text>true</xsl:text>
		    		</xsl:if>
	    		</xsl:otherwise>
	    	</xsl:choose>
   		</xsl:for-each>
   	</xsl:variable>

	<xsl:if test="$exists!=''">
   		<!-- ho trovato un 'elemName' non vuoto tra i figli di 'blockData' -->
   		<xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
   	</xsl:if>
 </xsl:template>

 <xsl:template name="hxprecurse">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="templateName" select="''"/>
  <xsl:for-each select="./ancestor::*[@id=$templateName]">
   <xsl:call-template name="hxpidhandler">
    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
   </xsl:call-template>
  </xsl:for-each>
 </xsl:template>

 <xsl:template name="hxpcontainerofchild">
     <!-- if there are child with name()=$elemName then
           copy the current element
           for each child with name()=$elemName
            copy the content of the current element filling with data in $blockData.
      -->
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
  <xsl:param name="elemName" select="''"/><xsl:param name="instPosDep" select="''"/>
  <xsl:variable name="elemTemplate" select="*|text()"/>
  <xsl:choose>
   <xsl:when test="contains($elemName,'[')">
    <xsl:if test="count($blockData/*[name()=substring-before($elemName,'[')]
                                [position()=number(translate(substring-after($elemName,'['),']',' '))]) > 0">
     <xsl:copy>
      <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
      <!--
      <xsl:for-each select="@*[name()!='id']">
       <xsl:call-template name="stringparser">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
       </xsl:call-template>
      </xsl:for-each>
      -->
      <xsl:for-each select="$blockData/*[name()=substring-before($elemName,'[')]
                              [position()=number(translate(substring-after($elemName,'['),']',' '))]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
       </xsl:call-template>
      </xsl:for-each>
     </xsl:copy>
    </xsl:if>
   </xsl:when>
   <xsl:otherwise>
    <xsl:if test="count($blockData/*[name()=$elemName]) > 0">
     <xsl:copy>
      <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
      <!--
      <xsl:for-each select="@*[name()!='id']">
       <xsl:call-template name="stringparser">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
       </xsl:call-template>
      </xsl:for-each>
      -->
      <xsl:for-each select="$blockData/*[name()=$elemName]">
       <xsl:call-template name="blockFormatter">
        <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="."/>
        <xsl:with-param name="blockTemplate" select="$elemTemplate"/>
       </xsl:call-template>
      </xsl:for-each>
     </xsl:copy>
    </xsl:if>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="hxpcontainsOr">
  <xsl:param name="blockData" select="$hxpdata"/><xsl:param name="blockPath" select="''"/>
  <xsl:param name="elemName" select="''"/><xsl:param name="tempName" select="''"/><xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
   <xsl:for-each select="@*[name()!='id']">
    <xsl:call-template name="stringparser">
     <xsl:with-param name="data" select="$blockData"/>
     <xsl:with-param name="instPosDep" select="$instPosDep"/>
    </xsl:call-template>
   </xsl:for-each>
   -->
   <xsl:variable name="elemTemplate" select="*[position()=1]"/>
   <xsl:for-each select="$blockData">
    <xsl:call-template name="applycontent">
     <xsl:with-param name="elemName" select="$elemName"/>
     <xsl:with-param name="elemTemplate" select="$elemTemplate"/>
     <xsl:with-param name="anyway" select="'1'"/>
     <xsl:with-param name="tempName" select="$tempName"/>
     <xsl:with-param name="instPosDep" select="$instPosDep"/>
    </xsl:call-template>
   </xsl:for-each>
   <xsl:if test="count($blockData)=0">
    <xsl:variable name="emptycontext" select="document('./emptycontext.xml')"/>
    <xsl:apply-templates select="$emptycontext/*" mode="nonhocontesto">
     <xsl:with-param name="elemName" select="$elemName"/>
     <xsl:with-param name="elemTemplate" select="$elemTemplate"/>
     <xsl:with-param name="anyway" select="'1'"/>
     <xsl:with-param name="instPosDep" select="$instPosDep"/>
    </xsl:apply-templates>
   </xsl:if>
  </xsl:copy>
 </xsl:template>

 <xsl:template name="applycondcontent">
  <xsl:param name="blockPath" select="''"/><xsl:param name="elemName" select="''" />
  <xsl:param name="elemTemplate"/>
  <xsl:for-each select="(descendant-or-self::*[name()=substring-before($elemName,',')])[position()=1 and .=substring-after($elemName,',')]">
   <xsl:variable name="blockData" select="."/>
   <xsl:for-each select="$elemTemplate">
    <xsl:call-template name="hxpcontinuecontext">
	 <!--
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$hxpdata" />
	 -->
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:for-each>
  </xsl:for-each>
 </xsl:template>

 <xsl:template name="hxpcontains">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="elemName" select="''" /><xsl:param name="instPosDep" select="''"/>
  <xsl:copy>
   <xsl:apply-templates mode="template" select="@*[name()!='id']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
   <!--
   <xsl:for-each select="@*[name()!='id']">
    <xsl:call-template name="stringparser">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
    </xsl:call-template>
   </xsl:for-each>
   -->
   <xsl:variable name="elemTemplate" select="node()" />
   <xsl:for-each select="$blockData">
    <xsl:call-template name="applycondcontent">
     <xsl:with-param name="elemName" select="$elemName" />
     <xsl:with-param name="elemTemplate" select="$elemTemplate" />
    </xsl:call-template>
   </xsl:for-each>
  </xsl:copy>
 </xsl:template>

 <!-- end of container handler -->

 <!--
 	Federico 11/05/07: gestione id 'hxp-insertJsLink-...' [RW 0043770]

 	L'id semplicemente inserisce un link javascript nell'elemento corrente (attributi 'href'
 	e 'onclick').
 	Quello che segue 'hxp-insertJsLink-' e' il contenuto dell'attributo 'onclick'.
 	Lo scopo dell'id e' evitare che le stringhe '$hxp_instance()' vengano convertite nel corrispondente
 	numero d'istanza.
 -->
 <xsl:template name="hxpInsertJsLink">
 	<xsl:param name="blockPath" select="''"/>
 	<xsl:param name="blockData" select="$hxpdata" />
    <xsl:param name="onclickVal" select="''" />

    <xsl:copy>
    	<xsl:for-each select="@*[name()!='id']">
		    <xsl:call-template name="stringparser">
		     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
		    </xsl:call-template>
	   </xsl:for-each>
	   <xsl:attribute name="href">
	   	<xsl:text>javascript:void(0);</xsl:text>
	   </xsl:attribute>
	   <xsl:attribute name="onclick">
	   	<xsl:value-of select="$onclickVal"/>
	   </xsl:attribute>
	   <xsl:call-template name="hxpcontinuecontext">
	 	<xsl:with-param name="blockData" select="$blockData"/>
	 	<xsl:with-param name="blockPath" select="$blockPath"/>
	   </xsl:call-template>
    </xsl:copy>
 </xsl:template>

 <!-- Smista i template di hxp.xsl da eseguire: id="hxp-content", id="hxp-containerof"... -->
 <xsl:template name="hxpformatter">
  <xsl:param name="value" select="''" />
  <xsl:param name="instPosDep" select="''"/>
  <xsl:param name="blockPath" select="''"/>
  <xsl:param name="blockData" select="$hxpdata" />

  <xsl:choose>
   <xsl:when test="substring-before($value,'-')='content'">
    <xsl:call-template name="hxpcontent">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="elemName" select="substring-after($value,'-')" />
     <xsl:with-param name="instPosDep" select="$instPosDep"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='htmlContent'">
    <xsl:call-template name="hxphtmlcontent">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="elemName" select="substring-after($value,'-')" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='contextcustom'">
    <xsl:call-template name="hxpcontextcustom">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="specName" select="substring-after($value,'-')" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='contextcustomNoCopy'">
    <xsl:call-template name="hxpcontextcustomnocopy">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="specName" select="substring-after($value,'-')" />
    </xsl:call-template>
   </xsl:when>

   <!--
		Federico: Visualizzazione di elementi contenenti dell'html (prodotto, per esempio, dall'editor javascript
		per le textarea).

		Federico 02/03/2005: aggiunto passaggio parametro "blockData".
	-->
	<xsl:when test="substring-before($value,'-')='showHtmlNode'">
		<xsl:call-template name="hxpshowHtmlNode">
     		<xsl:with-param name="elemName" select="substring-after($value,'-')" />
     		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
	</xsl:when>

   <!--
		Federico 11/10/2004:
		editing di elementi contenenti dell'html (prodotto, per esempio, dall'editor javascript
		per le textarea).

		Federico 02/03/2005: aggiunto passaggio parametro "blockData".
	-->
	<xsl:when test="substring-before($value,'-')='editHtmlNode'">
		<xsl:call-template name="hxpeditHtmlNode">
     		<xsl:with-param name="elemName" select="substring-after($value,'-')" />
     		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
	</xsl:when>
   <!--
		Modifica di Federico del 16/11/2004: editing di elementi multilingua.
	-->
	<xsl:when test="substring-before($value,'-')='editMultiLangNode'">
		<xsl:call-template name="hxpeditMultiLangNode">
     		<xsl:with-param name="param" select="substring-after($value,'-')" />
     		<xsl:with-param name="instPosDep" select="$instPosDep"/>
     		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
    	</xsl:call-template>
	</xsl:when>
	<!--
		Modifica di Federico del 16/11/2004: visualizzazione di elementi multilingua.
	-->
	<xsl:when test="substring-before($value,'-')='showMultiLangNode'">
		<xsl:call-template name="hxpshowMultiLangNode">
     		<xsl:with-param name="elemName" select="substring-after($value,'-')" />
     		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    	</xsl:call-template>
	</xsl:when>
   <!-- Per togliere le diciture -->
   <xsl:when test="substring-before($value,'-')='fulliterator'">
    <xsl:choose>
     <xsl:when test="string-length(substring-before(substring-after($value,'-'),'-'))=0">
      <xsl:call-template name="hxpfulliterator">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpfulliterator">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-before(substring-after($value,'-'),'-')"/>
       <xsl:with-param name="tempName" select="substring-after(substring-after($value,'-'),'-')"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>

   <xsl:when test="substring-before($value,'-')='notEmptyIterator'">
    <xsl:choose>
     <xsl:when test="string-length(substring-before(substring-after($value,'-'),'-'))=0">
      <xsl:call-template name="notemptyiterator">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="notemptyiterator">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-before(substring-after($value,'-'),'-')"/>
       <xsl:with-param name="tempName" select="substring-after(substring-after($value,'-'),'-')"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <!-- Federico 31/08/2004: gestione dell'id 'hxp-notEmpy-elem' -->
   <xsl:when test="substring-before($value,'-')='notEmpty'">
    <xsl:choose>
     <xsl:when test="string-length(substring-before(substring-after($value,'-'),'-'))=0">
      <xsl:call-template name="hxpnotempty">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
      </xsl:call-template>
     </xsl:when>
    </xsl:choose>
   </xsl:when>
   <!-- Federico 28/06/05: gestione dell'id 'hxp-exists-elem' -->
   <xsl:when test="substring-before($value,'-')='exists'">
    <xsl:call-template name="hxpexists">
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <!-- Federico 20/12/05: gestione dell'id 'hxp-notexists-elem' -->
   <xsl:when test="substring-before($value,'-')='notexists'">
    <xsl:call-template name="hxpnotexists">
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <!-- Federico 23/12/08: gestione dell'id 'hxp-exists_everywhere-elem' [RW 0055118] -->
   <xsl:when test="substring-before($value,'-')='exists_everywhere'">
    <xsl:call-template name="hxpexistseverywhere">
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='containerof'">
    <xsl:choose>
     <xsl:when test="string-length(substring-before(substring-after($value,'-'),'-'))=0">
      <xsl:call-template name="hxpcontainer">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpcontainer">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-before(substring-after($value,'-'),'-')"/>
       <xsl:with-param name="tempName" select="substring-after(substring-after($value,'-'),'-')"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='containerofchild'">
    <xsl:call-template name="hxpcontainerofchild">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='recurse'">
    <xsl:call-template name="hxprecurse">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="templateName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>

   <xsl:when test="substring-before($value,'-')='core'">
    <xsl:call-template name="hxp-core">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="param" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>

   <xsl:when test="substring-before($value,'-')='containsOr'">
    <xsl:choose>
     <xsl:when test="string-length(substring-after(substring-after($value,'-'),'-'))>0">
      <xsl:call-template name="hxpcontainsOr">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-before(substring-after($value,'-'),'-')"/>
       <xsl:with-param name="tempName" select="substring-after(substring-after($value,'-'),'-')"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:when test="string-length(substring-after(substring-after($value,'-'),','))>0">
      <xsl:call-template name="hxpcontainsOr">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-before(substring-after($value,'-'),',')"/>
       <xsl:with-param name="instPosDep">
        <xsl:call-template name="hxpstring">
         <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData" />
         <xsl:with-param name="thestring" select="substring-after($value,',')" />
        </xsl:call-template>
       </xsl:with-param>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpcontainsOr">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
       <xsl:with-param name="elemName" select="substring-after($value,'-')"/>
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='contains'">
    <xsl:call-template name="hxpcontains">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="elemName" select="substring-after($value,'-')" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='ttree'">
    <xsl:call-template name="hxpttreehandler">
     <xsl:with-param name="value" select="substring-after($value,'-')" />
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='range'">
    <xsl:call-template name="hxprangehandler">
     <xsl:with-param name="value" select="substring-after($value,'-')" />
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:when>
   <!-- Federico 05/10/05: gestione id = "hxp-test_tuple-..."  -->
   <xsl:when test="substring-before($value,'-')='test_tuple'">
    <xsl:call-template name="hxptesttuple">
     <xsl:with-param name="operator" select="substring-after($value,'-')" />
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
    </xsl:call-template>
   </xsl:when>
   <!-- Federico 17/08/2004: gestione id = "hxp-test_value-..."  -->
   <xsl:when test="substring-before($value,'-')='test_value'">
    <xsl:call-template name="hxptestvalue">
     <xsl:with-param name="operator" select="substring-after($value,'-')" />
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='test_const_value'">
	<xsl:call-template name="hxptestconstvalue">
	<xsl:with-param name="operator" select="substring-after($value,'-')" />
	<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
	</xsl:call-template>
   </xsl:when>
   <!--
   	Federico 17/12/2004: gestione id 'hxp-includeJsCalendar' che consente di inserire il javascript
   	e il div nascosto del calendario js.
   -->
   <xsl:when test="$value='includeJsCalendar'">
   	<xsl:copy>
   		<xsl:copy-of select="@*"/>
   	</xsl:copy>
   </xsl:when>
   <!--
   	Federico 14/03/2005: gestione id 'hxp-showJsCalendar' che consente di inserire la chiamata javascript
   	per mostrare il calendario js.
   -->
   <xsl:when test="substring-before($value,'-')='showJsCalendar'">
   	<xsl:call-template name="showJsCalendar"> <!-- definito nel file generico 'jsCalendar.xsl' -->
		<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
		<xsl:with-param name="params" select="substring-after($value,'-')" />
	</xsl:call-template>
   </xsl:when>
   <!-- Federico 25/07/05: gestione id 'hxp-button-[testType]' -->
   <xsl:when test="substring-before($value,'-')='button'">
    <xsl:call-template name="hxpbutton">
     <xsl:with-param name="testType" select="substring-after($value,'-')" />
     <xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:when>
   <xsl:when test="substring-before($value,'-')='getCustomTupleValue'">
   	<xsl:call-template name="getCustomTupleValue">
   		<xsl:with-param name="tupleParam" select="substring-after($value,'-')" />
   	</xsl:call-template>
   </xsl:when>
   <!-- Federico 11/05/07: gestione id 'hxp-insertJsLink-...' [RW 0043770] -->
   <xsl:when test="substring-before($value,'-')='insertJsLink'">
		<xsl:call-template name="hxpInsertJsLink">
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="onclickVal" select="substring-after($value,'-')" />
		</xsl:call-template>
   </xsl:when>
   <!-- Federico 14/05/07: gestione id 'hxp-notExistOrEmptyAttr-...' [RW 0043770] -->
   <xsl:when test="substring-before($value,'-')='notExistOrEmptyAttr'">
    <xsl:call-template name="hxpNotExistOrEmptyAttr">
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="attrName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <!-- Federico 02/11/09: gestione id 'hxp-existAndFullAttr-...' [EF 160] -->
   <xsl:when test="substring-before($value,'-')='existAndFullAttr'">
    <xsl:call-template name="hxpExistAndFullAttr">
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$blockData"/>
     <xsl:with-param name="attrName" select="substring-after($value,'-')"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxperrorhandler">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

 <xsl:template name="getCustomTupleValue">
 	<xsl:param name="tupleParam" select="''"/>
 	<xsl:variable name="tupleName" select="concat('&#38;',$tupleParam,'=')"/>
   	<xsl:value-of select="substring-before(substring-after(concat('&#38;',$hxpdata/@_cd,'&#38;'),$tupleName),'&#38;')"/>
 </xsl:template>

 <!--
 		@author 3D Informatica - Federico Grillini

 		Data creazione:  05/10/2005

 		Questo template viene invocato ogni volta che si incontra un id "hxp-test_tuple-..." e
 		consente di testare il valore di una tupla indipendentemente dal contesto corrente.
 		La sintassi degli id e' la stessa di quella degli id "hxp-test_value-..." e sostanzialmente
 		questo template non fa altro che invocare il template "hxptestvalue" impostando come contesto
 		corrente quello di hxpdata.
 		Per maggiori informazioni si veda il template "hxptestvalue".

		Nicola 02/02/2006: Aggiunta variabile 'hresult' per distinguere il contesto in cui cercare la
		tupla ($hxpdata) e quello da usare in caso di chiamata a 'hxpcontinuecontext'.

 -->
 <xsl:template name="hxptesttuple">
 	<xsl:param name="operator" select="''" />
    <xsl:param name="blockPath" select="''"/>
    <xsl:param name="blockData" select="$hxpdata"/>

    <xsl:variable name="hresult">
    <xsl:call-template name="hxptestvalue">
     <xsl:with-param name="operator" select="$operator" />
     <xsl:with-param name="blockPath" select="$blockPath"/>
     <xsl:with-param name="blockData" select="$hxpdata" />
    </xsl:call-template>
    </xsl:variable>

    <xsl:if test="$hresult != ''">
     <!-- il test e' andato a buon fine, quindi occorre ricopiare il contenuto del nodo contenente l'id -->
	 <xsl:call-template name="hxpcontinuecontext">
	 <xsl:with-param name="blockData" select="$blockData"/>
	 </xsl:call-template>
    </xsl:if>
 </xsl:template>

 <!--
 		@author 3D Informatica - Federico Grillini

 		Data creazione:  17/08/2004
 		Ultima modifica: 25/11/2004

 		Questo template viene invocato ogni volta che si incontra un id "hxp-test_value-..." e
 		consente di confrontare due valori mediante l'operatore specificato.
 		La sintassi degli id e' la seguente: "hxp-test_value-operatore-attributo/elemento_da_testare-valore".
 		Per gli operatori che e' possibile specificare fare riferimento al template "doTestValue".
 -->
 <xsl:template name="hxptestvalue">
 	<xsl:param name="operator" select="''" />
    <xsl:param name="blockPath" select="''"/>
    <xsl:param name="blockData" select="$hxpdata"/>

	<xsl:variable name="termini" select="substring-after($operator,'-')"/>
	<xsl:variable name="termine" select="substring-before($termini,'-')"/>
	<xsl:variable name="valore" select="substring-after($termini,'-')"/>

	<!--
		Modifica di Federico del 06/10/2004.
		Realizzato il seguente TODO:

 		TODO Per il momento si suppone che l'attributo (var. 'termine') cominci con '@' e che sia unico
	  		 in tutto il documento.
 			 Fare in modo che si recuperi l'attributo/elemento specificato (var. 'termine') riferendosi al
 			 contesto corrente.

 		Il valore dell'attributo/elemento specificato viene ora recuperato mediante una chiamata al template
 		"hxpcontent", per il cui funzionamento si rimanda al commento in testa al presente file.

 		Modifiche del 27/09/2005

 		Sono stati inseriti dei controlli sulla variabile TERM (Rif. Anomalia n. 0028480).
 		Il contenuto della varibaile term viene filtrata ed epurata dai tag: <span class="key-hit">, <span> e </span>
 		Ora  possibile utilizzare il contenuto della variabile TERM effettuare dei test.

 		Nicola & Federico

	-->

	<xsl:variable name="term1">
		<xsl:call-template name="hxpcontent">
	     <xsl:with-param name="blockPath" select="$blockPath" />
	     <xsl:with-param name="blockData" select="$blockData" />
	     <xsl:with-param name="elemName" select="$termine" />
	     <xsl:with-param name="instPosDep" select="''"/>
	    </xsl:call-template>
    </xsl:variable>

	<xsl:variable name="term2">
		<xsl:call-template name="str:subst">
	        <xsl:with-param name="text">
	          <xsl:value-of select="$term1"/>
	        </xsl:with-param>
	        <xsl:with-param name="replace">
	          <xsl:text>&lt;span class="key-hit"&gt;</xsl:text>
	        </xsl:with-param>
	        <xsl:with-param name="with" select="''" />
	      </xsl:call-template>
    </xsl:variable>

	<xsl:variable name="term3">
		<xsl:call-template name="str:subst">
	        <xsl:with-param name="text">
	          <xsl:value-of select="$term2"/>
	        </xsl:with-param>
	        <xsl:with-param name="replace">
	          <xsl:text>&lt;span&gt;</xsl:text>
	        </xsl:with-param>
	        <xsl:with-param name="with" select="''" />
	      </xsl:call-template>
    </xsl:variable>

	<xsl:variable name="term">
		<xsl:call-template name="str:subst">
	        <xsl:with-param name="text">
	          <xsl:value-of select="$term3"/>
	        </xsl:with-param>
	        <xsl:with-param name="replace">
	          <xsl:text>&lt;/span&gt;</xsl:text>
	        </xsl:with-param>
	        <xsl:with-param name="with" select="''" />
	      </xsl:call-template>
    </xsl:variable>

	<!-- Fine modifica di Federico del 06/10/2004 -->

	<!-- debug -->

	<!--
	<xsl:copy>
		<p>
		<br /> <xsl:text>[term]=</xsl:text> <xsl:value-of select="$term" />
		<br /> <xsl:text>[valore]=</xsl:text> <xsl:value-of select="$valore" />
		<br /> (<xsl:value-of select="name()" />)
		</p>
	</xsl:copy>
	-->

	<!--
		Modifica di Federico del 25/11/2004:
		per generare pagine accessibili, il template  stato modificato in modo tale che, se il
		nodo corrente  uno span con un solo attributo (l'id), esso non viene ricopiato nell'
		output, poich  inutile e potrebbe ritrovarsi al di fuori di un <td> di una tabella.
	-->
	<xsl:choose>
		<!--
			Il nodo corrente, contenente l'id "hxp-test_value-...", deve essere copiato nell'output
			(insieme ai suoi attributi) se il suo nome non  "span" o se ha pi di un attributo.
		-->
		<xsl:when test="name()!='span' or count(@*)>1">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="doTestValue">
					<xsl:with-param name="operator" select="$operator" />
				 	<xsl:with-param name="term" select="$term" />
				 	<xsl:with-param name="valore" select="$valore" />
				    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
			<!--
				Siamo in presenza di uno span con un solo attributo (l'id) ==> il nodo corrente non va copiato
				nell'output.
			-->
			<xsl:call-template name="doTestValue">
				<xsl:with-param name="operator" select="$operator" />
			 	<xsl:with-param name="term" select="$term" />
			 	<xsl:with-param name="valore" select="$valore" />
			    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
 </xsl:template>

<!--
 		@author 3D Informatica - Federica Cossu

 		Data creazione:  11/04/2008
 		Ultima modifica: 11/04/2008

 		Questo template viene invocato ogni volta che si incontra un id "hxp-test_const_value-..." e
 		consente di confrontare due valori mediante l'operatore specificato.
 		La sintassi degli id e' la seguente: "hxp-test_value-operatore-attributo/elemento_da_testare-valore".
 		Per gli operatori che e' possibile specificare fare riferimento al template "doTestValue".
 -->
 <xsl:template name="hxptestconstvalue">
 	<xsl:param name="operator" select="''" />
    <xsl:param name="blockPath" select="''"/>
    <xsl:param name="blockData" select="$hxpdata"/>

	<xsl:variable name="termini" select="substring-after($operator,'-')"/>
	<xsl:variable name="termine" select="substring-before($termini,'-')"/>
	<xsl:variable name="valore" select="substring-after($termini,'-')"/>


	<!-- Fine modifica di Federico del 06/10/2004 -->

	<!-- debug -->


	<!--<xsl:copy>
		<p>
		<br /> <xsl:text>[termine]=</xsl:text> <xsl:value-of select="$termine" />
		<br /> <xsl:text>[valore]=</xsl:text> <xsl:value-of select="$valore" />
		<br /> <xsl:text>[operator]=</xsl:text> <xsl:value-of select="$operator" />
		<br /> (<xsl:value-of select="name()" />)
		</p>
	</xsl:copy>-->


	<!--
		Modifica di Federico del 25/11/2004:
		per generare pagine accessibili, il template  stato modificato in modo tale che, se il
		nodo corrente  uno span con un solo attributo (l'id), esso non viene ricopiato nell'
		output, poich  inutile e potrebbe ritrovarsi al di fuori di un <td> di una tabella.
	-->
	<xsl:choose>
		<!--
			Il nodo corrente, contenente l'id "hxp-test_value-...", deve essere copiato nell'output
			(insieme ai suoi attributi) se il suo nome non  "span" o se ha pi di un attributo.
		-->
		<xsl:when test="name()!='span' or count(@*)>1">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="doTestValue">
					<xsl:with-param name="operator" select="$operator" />
				 	<xsl:with-param name="term" select="$termine" />
				 	<xsl:with-param name="valore" select="$valore" />
				    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:when>
		<xsl:otherwise>
			<!--
				Siamo in presenza di uno span con un solo attributo (l'id) ==> il nodo corrente non va copiato
				nell'output.
			-->
			<xsl:call-template name="doTestValue">
				<xsl:with-param name="operator" select="$operator" />
			 	<xsl:with-param name="term" select="$termine" />
			 	<xsl:with-param name="valore" select="$valore" />
			    <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
	* Created on 25/11/2004
	*
	* @version 1.0
	*
	* @param operator stringa che contiene l'operatore da eseguire
 	* @param term termine da esaminare
 	* @param valore valore da confrontare con "term"
	* @param blockData rappresenta il contesto corrente da analizzare.
	*
	* Questo template viene invocato dal template "hxptestvalue" per confrontare due valori mediante
	* l'operatore specificato.
	*
 	* Gli operatori gestiti sono: gt              ('>')
 	*							  get             ('>=')
 	*							  eq              ('=')
 	*							  lt              ('<')
 	*							  let             ('<=')
 	*							  neq             ('!=')
 	*							  str_eq          ('=' tra stringhe)
 	*							  str_neq         ('!=' tra stringhe)
 	*							  str_startwith   (controlla se una stringa comincia con una certa stringa)
 	*							  str_nstartwith  (controlla se una stringa non comincia con una certa stringa)
 	*							  str_endwith     (controlla se una stringa finisce con una certa stringa)
 	*							  str_nendwith    (controlla se una stringa non finisce con una certa stringa)
 	*							  str_contains    (controlla se una stringa contiene una certa stringa)
 	*							  str_ncontains   (controlla se una stringa non contiene una certa stringa)
 -->
 <xsl:template name="doTestValue">
 	<xsl:param name="operator" select="''" />
 	<xsl:param name="term" select="''" />
 	<xsl:param name="valore" select="''" />
    <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>

	<xsl:choose>
		<!-- confronto valori numerici -->
		<xsl:when test="substring-before($operator,'-')='gt'">
			<xsl:choose>
				<xsl:when test="number($term) > number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='eq'">
			<xsl:choose>
				<xsl:when test="number($term) = number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='get'">
			<xsl:choose>
				<xsl:when test="number($term) >= number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='lt'">
			<xsl:choose>
				<xsl:when test="number($term) &lt; number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='let'">
			<xsl:choose>
				<xsl:when test="number($term) &lt;= number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='neq'">
			<xsl:choose>
				<xsl:when test="number($term) != number($valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<!-- confronto stringhe -->
		<xsl:when test="substring-before($operator,'-')='str_eq'">
			<xsl:choose>
				<xsl:when test="$term = $valore">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='str_neq'">
			<xsl:choose>
				<xsl:when test="$term != $valore">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<!--
			Federico 18/04/2005: implementati test 'str_startwith' e 'str_nstartwith' che rispettivamente
			controllano se '$term' comincia o non comincia con '$valore'.
		-->
		<xsl:when test="substring-before($operator,'-')='str_startwith'">
			<xsl:choose>
				<xsl:when test="starts-with($term, $valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
            </xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='str_nstartwith'">
			<xsl:choose>
				<xsl:when test="not(starts-with($term, $valore))">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
			</xsl:choose>
		</xsl:when>
		<!--
			mbussetti 15/07/2005: implementati test 'str_endwith' e 'str_nendwith' che rispettivamente
			controllano se '$term' finisce o non finisce con '$valore'.
			In entrambi i casi utilizzato il template 'splitlast': se, interpretando la stringa 1 come
			separatore, l'ultima porzione della stringa 2  vuota, allora significa che la stringa 2 finisce
			con la stringa 1.
		-->
		<xsl:when test="substring-before($operator,'-')='str_endwith'">
			<xsl:variable name="appoggio">
				<xsl:call-template name="splitLast">
					<xsl:with-param name="salsiccia" select="$term" />
					<xsl:with-param name="nodino" select="$valore" />
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="string-length($appoggio)=0">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:if>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='str_nendwith'">
			<xsl:variable name="appoggio">
				<xsl:call-template name="splitLast">
					<xsl:with-param name="salsiccia" select="$term" />
					<xsl:with-param name="nodino" select="$valore" />
				</xsl:call-template>
			</xsl:variable>
			<xsl:if test="string-length($appoggio) > 0">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:if>
		</xsl:when>
		<!--
			Federico 05/01/06: implementati test 'str_contains' e 'str_ncontains' che rispettivamente
			controllano se '$term' contiene o non contiene '$valore' [RW 0032020].
		-->
		<xsl:when test="substring-before($operator,'-')='str_contains'">
			<xsl:choose>
				<xsl:when test="contains($term, $valore)">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
            </xsl:choose>
		</xsl:when>
		<xsl:when test="substring-before($operator,'-')='str_ncontains'">
			<xsl:choose>
				<xsl:when test="not(contains($term, $valore))">
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
					</xsl:call-template>
				</xsl:when>
            </xsl:choose>
		</xsl:when>
    </xsl:choose>
 </xsl:template>

 <!--
 	* @author Federico Grillini
	*
	* Created on 25/07/05
	*
	* @version 1.0
	*
	* Questo template consente di abilitare/disabilitare il pulsante a cui e' associato l'id 'hxp-button-[testType]'.<br>
	* 'testType' rappresenta il test da effettuare per attivare/disattivare il pulsante.<br>
	* I test supportati sono:<br><br>
	* <ul>
 	* 							  <li>elenco, per il pulsante "Elenco";</li>
	*							  <li>inizio, per il pulsante "Inizio";</li>
	*							  <li>indietro, per il pulsante "Indietro";</li>
	* 							  <li>avanti, per il pulsante "Avanti";</li>
	*							  <li>fine, per il pulsante "Fine";</li>
	*							  <li>ins_rac_attiva, per il pulsante di inserimento nella raccolta attiva;</li>
	*							  <li>raffina, per il pulsante "Raffina".</li>
	* </ul>
 	*
 	* @param testType	test da effettuare per attivare/disattivare il pulsante.<br>
	*					Se il test risulta essere vero, viene usata la classe del nodo corrente;
	*					se, invece, il test risulta essere falso, viene usata la classe del nodo corrente
	*					seguita dal suffisso '_disabled'.<br>
	*					Se il parametro 'testType' viene omesso, il pulsante sara' sempre attivo.
	* @param blockData 	rappresenta il contesto corrente da analizzare.
	*
	* @see building block generico 'Button'.
	*
 -->
 <xsl:template name="hxpbutton">
 	<xsl:param name="testType" select="''" />
    <xsl:param name="blockData" select="$hxpdata" />

    <xsl:variable name="test_result">
    	<xsl:choose>
    		<!-- test attivazione/disattivazione pulsanti -->
	    	<xsl:when test="$testType='elenco'">
	    		<xsl:if test="$hxpdata/@selid!='' and $hxpdata/@count&gt;1">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='inizio'">
	    		<xsl:if test="$hxpdata/@pos&gt;0">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='indietro'">
	    		<xsl:if test="$hxpdata/@pos&gt;0">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='avanti'">
	    		<xsl:if test="$hxpdata/@count&gt;$hxpdata/@pos+1">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='fine'">
	    		<xsl:if test="$hxpdata/@count&gt;$hxpdata/@pos+1">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='ins_rac_attiva'">
	    		<xsl:if test="$hxpdata/@cName != '' and $hxpdata/@cId != $hxpdata/@selid">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:when test="$testType='raffina'">
	    		<xsl:if test="$hxpdata/@selid!='' and $hxpdata/@count&gt;1">
	    			<xsl:text>ok</xsl:text>
	    		</xsl:if>
	    	</xsl:when>
	    	<xsl:otherwise>
	    		<!-- nessun test da effettuare; pulsante sempre attivo -->
	    		<xsl:text>ok</xsl:text>
	    	</xsl:otherwise>
		</xsl:choose>
    </xsl:variable>

    <xsl:copy>
    	<xsl:copy-of select="@*[not(name()='id') and not(name()='class')]"/>
	    <xsl:choose>
	    	<xsl:when test="$test_result!=''">
	    		<!-- il test e' andato a buon fine. Il bottone deve essere abilitato -->
	    		<xsl:attribute name="class">
	    			<xsl:value-of select="@class"/>
	    		</xsl:attribute>
	    	</xsl:when>
	    	<xsl:otherwise>
	    		<!-- il test non e' andato a buon fine. Il bottone deve essere disabilitato -->
	    		<xsl:attribute name="class">
	    			<xsl:value-of select="@class"/>
	    			<xsl:text>_disabled</xsl:text>
	    		</xsl:attribute>
	    	</xsl:otherwise>
	    </xsl:choose>

	    <xsl:call-template name="hxpcontinuecontext">
			<xsl:with-param name="blockData" select="$blockData" />
		</xsl:call-template>
    </xsl:copy>
 </xsl:template>

 <xsl:template name="hxpurihandler">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']" />
   <xsl:choose>
    <xsl:when test="name()='form'">
     <xsl:attribute name="action">
      <xsl:value-of select="$hxpdata/@uri" />
     </xsl:attribute>
    </xsl:when>
    <xsl:when test="name()='a'">
     <xsl:attribute name="href">
      <xsl:value-of select="$hxpdata/@uri" />
      <xsl:value-of select="@href" />
     </xsl:attribute>
    </xsl:when>
    <xsl:otherwise>
     <xsl:call-template name="hxperrorhandler">
      <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     </xsl:call-template>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:apply-templates mode="template" />
  </xsl:copy>
 </xsl:template>

 <!--
 <xsl:template name="hxpresourcehandler">
  <xsl:param name="resource" select="substring-after($value,'-')"/>
  <xsl:copy>
   <xsl:copy-of select="@*[name()!='id']" />
   <xsl:value-of select="$hxpresource/*[@id=$resource]/@value"/>
  </xsl:copy>
 </xsl:template>
 -->

 <!-- Deve essere richiamato dagli xsl generici.
 Se l'id inizia per "hxp-custom" allora deve essere implementato nell'xsl specifico,
 se inizia semplicemente per "hxp" allora applica il template "hxpformatter" -->
 <xsl:template name="hxpidhandler">
  <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata" />
  <xsl:param name="disable" select="''" /><xsl:param name="instPosDep" select="''"/>
  <xsl:choose>
   <!--xsl:when test="substring-before(@id,'-')='hxp'"-->
   <xsl:when test="starts-with(@id,'hxp')">
    <xsl:variable name="value" select="substring-after(@id,'-')" />
    <xsl:choose>
     <xsl:when test="substring-before($value,'-')='uri' or $value='uri'">
      <xsl:call-template name="hxpurihandler">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
      </xsl:call-template>
     </xsl:when>
     <xsl:when test="substring-before($value,'-')='resource'">
      <xsl:call-template name="customcontent">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
       <xsl:with-param name="templatedata" select="$value"/>
      </xsl:call-template>
      <!-- andrebbe implementato qui ma richiede la dichiarazione della variabile resource nel chiamante
      <xsl:call-template name="hxpresourcehandler">
       <xsl:with-param name="resource" select="substring-after($value,'-')"/>
      </xsl:call-template>
      -->
     </xsl:when>
     <xsl:when test="substring-before($value,'-')='custom'">
      <xsl:apply-templates select=".">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
      </xsl:apply-templates>
     </xsl:when>
	<!--
		 Codice aggiunto da Danilo Cicognani (Tinfo Srl) il 09/03/2005.
		 Copia l'elemento contenente l'id se la funzionalit specifica
		 corrispondente deve essere abilitata, ovvero se l'attributo da
		 testare vale 'true'
		 id="hxp-enableFunctionality-(attributo da testare)"
		 Generica dei vari hxp-<verbo>-action-enableFunctionality.
	-->
	<xsl:when test="substring-before($value,'-')='enableFunctionality'">
		<xsl:call-template name="genericEnableFunctionality">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="attrVal">
				<xsl:for-each select="$hxpdata">
					<xsl:call-template name="matchcontent">
						<xsl:with-param name="elemName" select="substring-after($value,'-')" />
					</xsl:call-template>
				</xsl:for-each>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:when>
	<!--
		 Codice aggiunto da GMG il 02/04/2007.
		 Copia l'elemento contenente l'id se la funzionalit specifica
		 corrispondente deve essere abilitata, ovvero se l'attributo
		 da testare vale il parametro passato (theCondition prefissato a 'false')
	-->
	<xsl:when test="substring-before($value,'-')='enableFalseFunctionality'">
		<xsl:call-template name="genericFunctionality">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="theCondition" select="'false'" />
			<xsl:with-param name="attrVal">
				<xsl:for-each select="$hxpdata">
					<xsl:call-template name="matchcontent">
						<xsl:with-param name="elemName" select="substring-after($value,'-')" />
					</xsl:call-template>
				</xsl:for-each>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:when>
	<!--
		 Codice aggiunto da GMG il 02/04/2007.
		 Copia l'elemento contenente l'id se la funzionalit specifica
		 corrispondente deve essere abilitata, ovvero se l'attributo
		 da testare vale il parametro passato (theCondition) e dedotto
		 dopo la stringa ':::'
	-->
	<xsl:when test="starts-with(substring-before($value, '-'), 'enableFunctionality:::')">
		<xsl:call-template name="genericFunctionality">
			<xsl:with-param name="blockPath" select="$blockPath"/>
			<xsl:with-param name="blockData" select="$blockData" />
			<xsl:with-param name="theCondition" select="substring-after(substring-before($value, '-'), ':::')" />
			<xsl:with-param name="attrVal">
				<xsl:for-each select="$hxpdata">
					<xsl:call-template name="matchcontent">
						<xsl:with-param name="elemName" select="substring-after($value,'-')" />
					</xsl:call-template>
				</xsl:for-each>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:when>
     <xsl:when test="substring-before($value,'-')='call'">
      <xsl:variable name="idval" select="substring-after($value,'-')"/>
      <xsl:apply-templates select="//*[starts-with(@id,$idval)]" mode="template">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
      </xsl:apply-templates>
     </xsl:when>
     <!--
     	Codice aggiunto da Federico il 08/10/2004.
     	Gestione degli id 'hxp-htmlNodes4fop-' (viene forzato il matching con i template contenuti nel
     	file 'htmlNodesHandler4fop.xsl').
     -->
     <xsl:when test="substring-before($value,'-')='htmlNodes4fop'">
      <xsl:apply-templates select=".">
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
      </xsl:apply-templates>
     </xsl:when>
     <xsl:otherwise>
      <xsl:call-template name="hxpformatter">
       <xsl:with-param name="value" select="$value" />
       <xsl:with-param name="instPosDep" select="$instPosDep"/>
       <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
      </xsl:call-template>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
   <xsl:otherwise>
    <xsl:call-template name="hxpcontinuecontext">
     <xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" />
     <xsl:with-param name="instPosDep" select="$instPosDep"/>
     <xsl:with-param name="disable" select="$disable" />
    </xsl:call-template>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

	<!--
	 Codice aggiunto da Danilo Cicognani (Tinfo Srl) il 09/03/2005.
	 Copia l'elemento contenente l'id se la funzionalit specifica
	 corrispondente deve essere abilitata, ovvero se l'attributo da testare vale 'true'
	 id="hxp-enableFunctionality-(attributo da testare)"
	 Versione generica dei vari hxp-<verbo>-action-enableFunctionality.
	-->
	<xsl:template name="genericEnableFunctionality">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:if test="$attrVal='true'">
			<xsl:copy>
				<!--xsl:copy-of select="@*[name()!='id']" /-->
				<xsl:call-template name="attrparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>

	<!--
	 Codice aggiunto da GMG il 02/04/2007.
	 Copia l'elemento contenente l'id se la funzionalit specifica
	 corrispondente deve essere abilitata, ovvero se l'attributo da
	 testare ($attrVal) vale il parametro ($theCondition)
	-->
	<xsl:template name="genericFunctionality">
		<xsl:param name="blockPath" select="''"/>
		<xsl:param name="blockData" select="$hxpdata" />
		<xsl:param name="attrVal" select="''" />
		<xsl:param name="theCondition" select="''" />
		<xsl:if test="$attrVal=$theCondition">
			<xsl:copy>
				<!--xsl:copy-of select="@*[name()!='id']" /-->
				<xsl:call-template name="attrparser">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/>
					<xsl:with-param name="blockData" select="$blockData" />
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
	</xsl:template>



 <!-- Effettua un replace pi complesso; l'implementazione prevede un parametro 'type' per ampliare in
      futuro il template con nuove trasformazioni -->
 <xsl:template name="replace-transform">
  <xsl:param name="text"/>
  <xsl:param name="type"/>
  <xsl:choose>
   <xsl:when test="$type='check'">
    <xsl:variable name="theForm" select="'hxpForm'"/>
    <xsl:choose>
     <xsl:when test="contains($text,'%')">
      <xsl:value-of select="substring-before($text,'%')"/>
      <xsl:variable name="startpos" select="string-length(substring-before($text,'%'))+2"/>
      <xsl:variable name="endpos" select="string-length(substring-before($text,'.'))+1"/>
      <xsl:variable name="lunghezza" select="($endpos)-($startpos)"/>
      <xsl:variable name="code" select="substring($text,$startpos,$lunghezza)"/>
      <!--<xsl:value-of select="$code"/>--> <!-- debug -->
      <xsl:for-each select="$hxpdata//listof_rights//right[@cod=$code]">
       <xsl:choose>
        <xsl:when test="name(current()/..)='group' and current()/../@exclusive='true'"> <!--caso del radiobutton-->
         <xsl:variable name="ranking" select="string(count(preceding-sibling::*[name()=name(current())]))"/>
         <xsl:text>document["</xsl:text>
         <xsl:value-of select="$theForm"/>
         <xsl:text>"]["*rgp_</xsl:text>
         <xsl:value-of select="current()/../@label"/>
         <xsl:text>"][</xsl:text>
         <xsl:value-of select="$ranking"/>
         <xsl:text>].</xsl:text>
        </xsl:when>
        <xsl:otherwise> <!--caso del checkbox-->
         <xsl:text>document["</xsl:text>
         <xsl:value-of select="$theForm"/>
         <xsl:text>"]["*right_</xsl:text>
         <xsl:value-of select="$code"/>
         <xsl:text>"].</xsl:text>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:for-each>
      <!--ricorsione-->
      <xsl:call-template name="replace-transform">
       <xsl:with-param name="text" select="substring-after($text,'.')"/>
       <xsl:with-param name="type" select="'check'"/>
      </xsl:call-template>
     </xsl:when>
     <xsl:otherwise>
      <xsl:value-of select="$text"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:when>
  </xsl:choose>
 </xsl:template>

 <!-- restituisce il numero di occorrenze di 'token' nella stringa 'text' -->
 <xsl:template name="countTokenFreq">
  <xsl:param name="text" select="''"/>
  <xsl:param name="token" select="''"/>
  <xsl:param name="freq" select="''"/>
  <xsl:choose>
   <xsl:when test="contains($text,$token)">
    <xsl:call-template name="countTokenFreq">
     <xsl:with-param name="text" select="substring-after($text,$token)"/>
     <xsl:with-param name="token" select="$token"/>
     <xsl:with-param name="freq" select="$freq + 1"/>
    </xsl:call-template>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="$freq"/>
   </xsl:otherwise>
  </xsl:choose>
 </xsl:template>

  <!--
  		Gestione delle informazioni relative alla document type definition dell'html finale.
  	  	(modifica di Federico effettuata per XSpring)
  -->
  <!-- 27/08/2004 disattivato da Fabio perch solo chi chiama sa che output produrre, questa dichiarazione va inserita nello xsl di partenza
  <xsl:output method="html" indent="yes" encoding="iso-8859-1" doctype-public='{$_docTypePublic}' doctype-system='{$_docTypeSystem}'/>
  -->
  <!-- Fine gestione delle informazioni relative alla document type definition dell'html finale. -->


	<xsl:template name="aclparams">
				<xsl:text>&#38;userRights=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@userRights"/>
				</xsl:call-template>
			    <xsl:text>&#38;specificAppCode=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@specificAppCode"/>
				</xsl:call-template>
				<xsl:text>&#38;specificDbCode=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@specificDbCode"/>
				</xsl:call-template>

    			<xsl:text>&#38;showdocUOR=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@showdocUOR"/>
				</xsl:call-template>
			    <xsl:text>&#38;doceditUOR=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@doceditUOR"/>
				</xsl:call-template>
                                <!-- fabio -->
			    <xsl:text>&#38;acl=</xsl:text>
				<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$hxpdata/@acl"/>
				</xsl:call-template>
	</xsl:template>

	<!-- Get di un attachment
	   id="hxp-query-action-getfile"
	   id="hxp-doc-action-getfile"
       id="hxp-docedit-action-getfile"
       id="hxp-doc_response-action-getfile"
	   -->
	<xsl:template name="getfile">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="fileid" select="''"/>

		<!--possibilt di specificare il nome del db -->
		<xsl:variable name="realid">
			<xsl:choose>
				<xsl:when test="contains($fileid,'-')">
					<xsl:value-of select="substring-after($fileid,'-')"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$fileid"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="theid">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="concat('$hxp_data(',$realid,')')"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<!-- 'if' aggiunto da mbussetti il 18/03/2005 per non visualizzare i "finti" allegati, cio i file che sono
             il risultato delle conversioni degli allegati effettivi
		-->
		<xsl:if test="not($blockData/@der_from)">

			<xsl:variable name="nameVal">
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<!--
							Federico 21/04/09: modificato il test per controllare se la descrizione dell'allegato contiene o meno l'estensione del
							file per evitare di duplicarla [M 0000323]
						-->
						<xsl:variable name="ext">
							<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:variable>
						<!-- il test equivale a not(endsWith($name,$ext) -->
						<xsl:if test="string-length($name)-string-length($ext)&lt;0 or substring($name,string-length($name)-string-length($ext)+1)!=$ext">
							<xsl:value-of select="$ext"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:variable name="theDb">
				<xsl:choose>
					<xsl:when test="contains($fileid,'-')">
						<xsl:value-of select="substring-before($fileid,'-')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$hxpdata/@db"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>

			<xsl:choose>
				<xsl:when test="string-length($hxpdata/@_cd)>1800"> <!-- download tramite post (limite #caratteri in url ~ 2000) -->
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id'][name()!='target']"/>
						<xsl:attribute name="href">
							<xsl:text>javascript:void(0);</xsl:text>
						</xsl:attribute>
						<xsl:attribute name="onclick">
							<xsl:text>return getFilePost('</xsl:text>
							<xsl:value-of select="$theid"/>
							<xsl:text>','</xsl:text>
							<xsl:value-of select="$nameVal"/>
							<xsl:text>','</xsl:text>
							<xsl:value-of select="$theDb"/>
							<xsl:text>');</xsl:text>
						</xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>
				</xsl:when>
				<xsl:otherwise>
					<xsl:copy>
						<xsl:copy-of select="@*[name()!='id']"/>
						<xsl:attribute name="href">
							<xsl:value-of select="$hxpdata/@uri"/>
							<xsl:text>?verbo=attach&#38;db=</xsl:text>
							<xsl:value-of select="$theDb"/>
							<xsl:text>&#38;id=</xsl:text>
							<xsl:value-of select="$escapedId"/>
							<xsl:text>&#38;host=</xsl:text>
							<xsl:value-of select="$hxpdata/@host"/>
							<xsl:text>&#38;port=</xsl:text>
							<xsl:value-of select="$hxpdata/@port"/>
							<xsl:text>&#38;login=</xsl:text>
							<xsl:value-of select="$hxpdata/@login"/>

							<xsl:text>&#38;name=</xsl:text>
							<xsl:value-of select="$nameVal"/>

							<xsl:call-template name="aclparams"/>

							<xsl:text>&#38;user=</xsl:text>
							<xsl:call-template name="escapeURL">
			                                 <xsl:with-param name="url" select="$hxpdata/@user"/>
							</xsl:call-template>
							<xsl:text>&#38;pwd=</xsl:text>
							<xsl:call-template name="escapeURL">
			                                 <xsl:with-param name="url" select="$hxpdata/@pwd"/>
							</xsl:call-template>

							<xsl:text>&#38;_cd=</xsl:text>
							<xsl:call-template name="escapeURL">
			                                 <xsl:with-param name="url" select="$hxpdata/@_cd"/>
							</xsl:call-template>

						</xsl:attribute>
						<xsl:call-template name="hxpcontinuecontext">
							<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
						</xsl:call-template>
					</xsl:copy>

				</xsl:otherwise>
			</xsl:choose>

		</xsl:if>
	</xsl:template>

	<!-- Get dei risultati delle conversioni richieste per un attachment
	     id="hxp-doc-action-getfileconversions"
	     @author: mbussetti
	     @date: 21/03/2005
	-->
	<xsl:template name="getfileconversions">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="fileid" select="''"/>

		<xsl:variable name="theid">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="concat('$hxp_data(',$fileid,')')"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="targetD">
			<xsl:value-of select="./a/@target"/>
		</xsl:variable>
		<xsl:variable name="classD">
			<xsl:value-of select="./a/@class"/>
		</xsl:variable>

		<xsl:variable name="iconaXML">
			<xsl:value-of select="./a/img[@id='xml']/@src"/>
		</xsl:variable>
		<xsl:variable name="borderXML">
			<xsl:value-of select="./a/img[@id='xml']/@border"/>
		</xsl:variable>
		<xsl:variable name="heightXML">
			<xsl:value-of select="./a/img[@id='xml']/@height"/>
		</xsl:variable>
		<xsl:variable name="titleXML">
			<xsl:value-of select="./a/img[@id='xml']/@title"/>
		</xsl:variable>

		<xsl:variable name="iconaPDF">
			<xsl:value-of select="./a/img[@id='pdf']/@src"/>
		</xsl:variable>
		<xsl:variable name="borderPDF">
			<xsl:value-of select="./a/img[@id='pdf']/@border"/>
		</xsl:variable>
		<xsl:variable name="heightPDF">
			<xsl:value-of select="./a/img[@id='pdf']/@height"/>
		</xsl:variable>
		<xsl:variable name="titlePDF">
			<xsl:value-of select="./a/img[@id='pdf']/@title"/>
		</xsl:variable>

		<xsl:variable name="iconaMETA">
			<xsl:value-of select="./a/img[@id='meta']/@src"/>
		</xsl:variable>
		<xsl:variable name="borderMETA">
			<xsl:value-of select="./a/img[@id='meta']/@border"/>
		</xsl:variable>
		<xsl:variable name="heightMETA">
			<xsl:value-of select="./a/img[@id='meta']/@height"/>
		</xsl:variable>
		<xsl:variable name="titleMETA">
			<xsl:value-of select="./a/img[@id='meta']/@title"/>
		</xsl:variable>

		<xsl:copy>
			<xsl:for-each select="$hxpdata//*[name()='xw:file' and starts-with(@der_from,$theid)]">

				<xsl:variable name="derivedId">
					<xsl:call-template name="hxpstring">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="current()"/>
						<xsl:with-param name="thestring" select="concat('$hxp_data(',$fileid,')')"/>
					</xsl:call-template>
				</xsl:variable>

				<xsl:variable name="extension">
					<xsl:call-template name="splitLast">
						<xsl:with-param name="nodino" select="'.'"/>
						<xsl:with-param name="salsiccia" select="$derivedId"/>
					</xsl:call-template>
				</xsl:variable>

				<xsl:variable name="escapedDerivedId">
					<xsl:call-template name="escapeURL">
						<xsl:with-param name="url" select="$derivedId"/>
					</xsl:call-template>
				</xsl:variable>

				<xsl:variable name="name">
					<xsl:call-template name="hxpstring">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="current()"/>
						<xsl:with-param name="thestring" select="current()/@title"/>
					</xsl:call-template>
				</xsl:variable>

				<xsl:if test="$extension!='txt'">
					<xsl:element name="a">

						<xsl:choose>
							<!--
								Federico 12/10/07: introdotto foglio di stile per mostrare l'albero xml del file 'content.xml'
								(conversioni XML) [RW 0047486]
								In questo caso con IE e' opportuno non usare IW.
							-->
							<xsl:when test="$hxpdata/@enableIW='true' and ($hxpdata//funzionalita_disponibili/@disableDisplayODContent4XmlConversion='true' or ($extension!='xml' and not(starts-with($extension,'od'))))">
								<xsl:attribute name="href">
									<xsl:text>javascript:void(0);</xsl:text>
								</xsl:attribute>
								<xsl:attribute name="onclick">
									<xsl:text>return iwGetFile('</xsl:text>
									<xsl:value-of select="$derivedId"/>
									<xsl:text>');</xsl:text>
								</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="target">
									<xsl:value-of select="$targetD"/>
								</xsl:attribute>
								<xsl:attribute name="class">
									<xsl:value-of select="$classD"/>
								</xsl:attribute>
								<xsl:attribute name="href">
									<xsl:value-of select="$hxpdata/@uri"/>
									<xsl:text>?verbo=attach&#38;db=</xsl:text>
									<xsl:value-of select="$hxpdata/@db"/>
									<xsl:text>&#38;id=</xsl:text>
									<xsl:value-of select="$escapedDerivedId"/>
									<xsl:text>&#38;host=</xsl:text>
									<xsl:value-of select="$hxpdata/@host"/>
									<xsl:text>&#38;port=</xsl:text>
									<xsl:value-of select="$hxpdata/@port"/>
									<xsl:text>&#38;name=</xsl:text>
									<xsl:choose>
										<xsl:when test="$name!=''">
											<xsl:call-template name="do-replace">
												<xsl:with-param name="text" select="$name"/>
												<xsl:with-param name="replace">'</xsl:with-param>
												<xsl:with-param name="by" select="'_'"/>
											</xsl:call-template>
											<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
											 	<xsl:text>.</xsl:text>
												<xsl:value-of select="substring-after($theid,'.')"/>
											</xsl:if>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="$theid"/>
										</xsl:otherwise>
									</xsl:choose>
									<!-- Federico 14/09/07: introdotta visualizzazione contenuto xml delle conversioni in xml [RW 0046316] -->
									<xsl:if test="$extension='xml' or starts-with($extension,'od')">
										<xsl:text>&#38;toDo=getXmlConversionResult</xsl:text>
									</xsl:if>
									<xsl:call-template name="aclparams">
									</xsl:call-template>
								</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>

						<!--xsl:value-of select="$extension"/-->

						<!-- Federico 13/09/07: introdotta gestione del formato OpenDocument 'od?' nella conversione 'xml' [RW 0046316] -->
						<xsl:element name="img">
							<xsl:attribute name="border">
								<xsl:choose>
									<xsl:when test="$extension='xml' or starts-with($extension,'od')">
										<xsl:value-of select="$borderXML"/>
									</xsl:when>
									<xsl:when test="$extension='pdf'">
										<xsl:value-of select="$borderPDF"/>
									</xsl:when>
								</xsl:choose>
							</xsl:attribute>
							<xsl:attribute name="height">
								<xsl:choose>
									<xsl:when test="$extension='xml' or starts-with($extension,'od')">
										<xsl:value-of select="$heightXML"/>
									</xsl:when>
									<xsl:when test="$extension='pdf'">
										<xsl:value-of select="$heightPDF"/>
									</xsl:when>
								</xsl:choose>
							</xsl:attribute>
							<xsl:attribute name="src">
								<xsl:choose>
									<xsl:when test="$extension='xml' or starts-with($extension,'od')">
										<xsl:value-of select="$iconaXML"/>
									</xsl:when>
									<xsl:when test="$extension='pdf'">
										<xsl:value-of select="$iconaPDF"/>
									</xsl:when>
								</xsl:choose>
							</xsl:attribute>
							<xsl:attribute name="title">
								<xsl:choose>
									<xsl:when test="$extension='xml' or starts-with($extension,'sx')">
										<xsl:value-of select="$titleXML"/>
									</xsl:when>
									<xsl:when test="$extension='pdf'">
										<xsl:value-of select="$titlePDF"/>
									</xsl:when>
								</xsl:choose>
							</xsl:attribute>
						</xsl:element>
					</xsl:element>

					<xsl:text>&#160;&#160;&#160;</xsl:text>
				</xsl:if>

			</xsl:for-each>

			<xsl:if test="$blockData/*[name()='metadata']">
				<xsl:element name="a">
					<xsl:attribute name="class">
						<xsl:value-of select="$classD"/>
					</xsl:attribute>
					<xsl:attribute name="href">
						<xsl:text>javascript:void(0);</xsl:text>
					</xsl:attribute>
					<xsl:attribute name="onclick">
						<xsl:text>return showMetadata('</xsl:text>
						<xsl:value-of select="$blockData/@name"/>
						<xsl:text>')</xsl:text>
					</xsl:attribute>
					<!--xsl:text>meta</xsl:text-->
					<xsl:element name="img">
						<xsl:attribute name="border">
							<xsl:value-of select="$borderMETA"/>
						</xsl:attribute>
						<xsl:attribute name="height">
							<xsl:value-of select="$heightMETA"/>
						</xsl:attribute>
						<xsl:attribute name="src">
							<xsl:value-of select="$iconaMETA"/>
						</xsl:attribute>
						<xsl:attribute name="title">
							<xsl:value-of select="$titleMETA"/>
						</xsl:attribute>
					</xsl:element>
				</xsl:element>
			</xsl:if>

			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<!--
		@author: Mario Bussetti
		@date: 01/06/2005
		Mostra accanto al title degli allegati la dimensione e il numero di pagine (se tali info sono state
		estratte come metadati)
	-->
	<xsl:template name="showDirectInformation">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>

		<xsl:if test="$blockData/*[name()='metadata']">
			<xsl:variable name="metaNode" select="$blockData/*[name()='metadata']"/>
			<xsl:variable name="sizeNodes" select="$metaNode//*[name()='FileSize' or name()='fileSize' or name()='filesize']"/>
			<xsl:variable name="pageNodes" select="$metaNode//*[name()='PageCount' or name()='pageCount' or name()='pagecount']"/>
			<xsl:variable name="pageIndicator">
				<xsl:if test="count($pageNodes) > 0">
					<xsl:value-of select="sum($pageNodes)"/>
					<xsl:text>&#160;pag.</xsl:text>
				</xsl:if>
			</xsl:variable>
			<xsl:variable name="sizeIndicator">
				<xsl:for-each select="$sizeNodes[1]">
					<xsl:value-of select="round(text() div 1024)"/>
					<xsl:text>&#160;KB</xsl:text>
				</xsl:for-each>
			</xsl:variable>

			<!--xsl:if test="string-length(normalize-space($pageIndicator)) > 0 or string-length(normalize-space($sizeIndicator)) > 0"-->
				<xsl:copy>
					<xsl:copy-of select="@*[name()!='id']"/>
					<xsl:text>(</xsl:text>
					<xsl:if test="string-length(normalize-space($sizeIndicator)) > 0">
						<xsl:value-of select="$sizeIndicator"/>
					</xsl:if>
					<xsl:if test="string-length(normalize-space($pageIndicator)) > 0">
						<xsl:text>, </xsl:text>
						<xsl:value-of select="$pageIndicator"/>
					</xsl:if>
					<xsl:text>)</xsl:text>
					<xsl:call-template name="hxpcontinuecontext">
						<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
					</xsl:call-template>
				</xsl:copy>
			<!--/xsl:if-->
		</xsl:if>
	</xsl:template>

	<!-- introdotto da mbussetti il 18/03/2005
		 Fa "sparire" il tag cui  applicato
	-->
	<xsl:template name="disappear">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
	</xsl:template>

<xsl:template name="getfilethumb">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>

		<xsl:param name="fileid" select="''"/>

		<xsl:variable name="theid">
			<xsl:value-of select="$blockData/@name"/>
		</xsl:variable>


		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='src']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                        -->
			<xsl:attribute name="src">
				<!-- rende il riferimento assoluto per la risoluzione da fop -->
                                <xsl:choose>
				<xsl:when test="string-length($hxpdata/@protocolHostAndPort) > 0">
					<xsl:value-of select="$hxpdata/@protocolHostAndPort"/>
					<xsl:value-of select="$hxpdata/@localUri"/>
                                </xsl:when>
                                <xsl:otherwise>
				<xsl:value-of select="$hxpdata/@uri"/>
                                </xsl:otherwise>
                                </xsl:choose>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;userName=</xsl:text>
				<xsl:value-of select="$hxpdata/@userName"/>
				<xsl:text>&#38;userAddr=</xsl:text>
				<xsl:value-of select="$hxpdata/@userAddr"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
			<xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
</xsl:template>


<xsl:template name="getfilethumbtitles">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>
		<xsl:param name="fileid" select="''"/>

		<xsl:variable name="theid">
			<xsl:value-of select="$blockData/thumb/@name"/>
		</xsl:variable>


		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='src']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                        -->
			<xsl:attribute name="src">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
			<xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
</xsl:template>

<xsl:template name="imglink">
	<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>
		<xsl:param name="fileid" select="''"/>

		<xsl:variable name="theid">
			<xsl:value-of select="$blockData/@name"/>
		</xsl:variable>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='src']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
                        <!--
			<xsl:copy-of select="@*[name()!='id']"/>
                        -->
			<xsl:attribute name="src">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
		     <xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>

		</xsl:copy>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
                        <!--
			<xsl:copy-of select="@*[name()!='id']"/>
                        -->
			<xsl:attribute name="href">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
			<xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>

</xsl:template>

<xsl:template name="imglinkwithIW">
<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>
		<xsl:param name="fileid" select="''"/>

<xsl:if test="count($blockData/@name)>0">

		<xsl:variable name="theid" select="$blockData/@srn"/>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href' and name()!='onclick']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                        -->
			<xsl:attribute name="href">
			<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
			<xsl:text>return openInNewWindow_xpreview('|</xsl:text>
			<xsl:value-of select="$theid"/>
			<xsl:text>');</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
</xsl:if>
</xsl:template>

<xsl:template name="imglinkwithIWtitles">
<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/><xsl:param name="instPosDep" select="''"/>
		<xsl:param name="fileid" select="''"/>

	<xsl:variable name="mypos" select="$blockData/@indice"/>

<xsl:if test="count($blockData/immagini/xw:file/@name)>0">

		<xsl:variable name="theid" select="$blockData/immagini/xw:file/@name"/>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData/immagini/xw:file"/>
				<xsl:with-param name="thestring" select="$blockData/immagini/xw:file/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='href']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
			<!-- 23/09/2005 Gregorio -->
			<!--xsl:copy-of select="@*[name()!='id']" /-->
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
                        -->
			<xsl:attribute name="href">
			<xsl:text>javascript:void(0);</xsl:text>
			</xsl:attribute>
			<xsl:attribute name="onclick">
			<xsl:text>return openInNewWindow_xpreview('|</xsl:text>
			<xsl:value-of select="$theid"/>
			<xsl:text>',null,</xsl:text>
			<xsl:value-of select="$mypos"/>
			<xsl:text>);</xsl:text>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
</xsl:if>
</xsl:template>

<xsl:template name="browserCut">
       <xsl:param name="blockPath" select="''"/>
       <xsl:param name="blockData" select="$hxpdata"/>
       <xsl:param name="browser" select="''"/>
       <xsl:if test="not( contains($browser,$hxpdata/@browser))">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
        </xsl:if>
</xsl:template>

<xsl:template name="dinamicIWcheck">
       <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
       <xsl:if test="$hxpdata/@enableIW='true'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
        </xsl:if>
</xsl:template>

<xsl:template name="dinamicNOIWcheck">
       <xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
       <xsl:if test="$hxpdata/@enableIW='false'">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
		<xsl:if test="$hxpdata/@enableIW=''">
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:copy>
		</xsl:if>
</xsl:template>

<xsl:template name="imgsNOIW">

		<xsl:variable name="theid">
			<xsl:value-of select="$hxpdata/@selectedIndex"/>
		</xsl:variable>

		<xsl:variable name="theidreal">
		   <xsl:value-of select="substring-after($theid,'*')"/>
		</xsl:variable>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theidreal"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theidreal"/>
			</xsl:call-template>
		</xsl:variable>
			<xsl:copy>
				<xsl:copy-of select="@*[name()!='id']" />
				<xsl:attribute name="src">
                    <xsl:value-of select="$hxpdata/@uri"/>
                    <xsl:text>?verbo=attach&#38;db=</xsl:text>
                    <xsl:value-of select="$hxpdata/@db"/>
                    <xsl:text>&#38;id=</xsl:text>
                    <xsl:value-of select="$escapedId"/>
                    <xsl:text>&#38;host=</xsl:text>
                    <xsl:value-of select="$hxpdata/@host"/>
                    <xsl:text>&#38;port=</xsl:text>
                    <xsl:value-of select="$hxpdata/@port"/>
                    <xsl:text>&#38;name=</xsl:text>
                   <xsl:value-of select="$theidreal"/>
                </xsl:attribute>
			</xsl:copy>
</xsl:template>

<xsl:template name="noIWgetfilethumbtitles">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="fileid" select="''"/><xsl:param name="instPosDep" select="''"/>

   		<xsl:variable name="noIWElemName">
			<xsl:text>noIwImage-</xsl:text>
			<xsl:value-of select="$blockData/@indice" />
		</xsl:variable>

		<xsl:variable name="theid">
			<xsl:value-of select="$blockData/immagini/xw:file/thumb/@name"/>
		</xsl:variable>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='src']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
			<!--<xsl:copy-of select="@*[name()!='id']"/>-->
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			-->
			<xsl:attribute name="id">
				<xsl:value-of select="$noIWElemName"/>
			</xsl:attribute>

			<xsl:attribute name="src">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
            <xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>


	<xsl:template name="noIWgetfilethumbdocs">

		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="relpath" select="''"/><xsl:param name="instPosDep" select="''"/>


		<xsl:variable name="Indice_Contenitore">
			<!-- Indice dell'elemento corrente/contenitore (RIC) in base 0 -->
			<xsl:value-of select="count($blockData/preceding-sibling::*[name()=name($blockData)])+1" />
		</xsl:variable>

   		<xsl:variable name="noIWElemName">
			<xsl:text>noIwImage-</xsl:text>
			<xsl:copy-of select="$relpath"/>
			<xsl:text>-</xsl:text>
			<xsl:copy-of select="$Indice_Contenitore"/>

		</xsl:variable>

		<xsl:variable name="theid">
			<xsl:value-of select="$blockData/*[name()=$relpath]/thumb/xw:file/@name"/>
		</xsl:variable>

		<xsl:variable name="escapedId">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>

		<xsl:variable name="escapedName">
			<xsl:call-template name="escapeURL">
				<xsl:with-param name="url" select="$theid"/>
			</xsl:call-template>
		</xsl:variable>


		<xsl:variable name="name">
			<xsl:call-template name="hxpstring">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="data" select="$blockData"/>
				<xsl:with-param name="thestring" select="$blockData/@title"/>
			</xsl:call-template>
		</xsl:variable>



		<xsl:copy>
                        <xsl:apply-templates mode="template" select="@*[name()!='id' and name()!='src']"><xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData" /><xsl:with-param name="instPosDep" select="$instPosDep"/></xsl:apply-templates>
			<!-- xsl:copy-of select="@*[name()!='id']"/ -->
                        <!--
			<xsl:for-each select="@*[name()!='id']">
				<xsl:call-template name="stringparser">
					<xsl:with-param name="data" select="$blockData" />
				</xsl:call-template>
			</xsl:for-each>
			-->
			<xsl:attribute name="id">
				<xsl:value-of select="$noIWElemName"/>
			</xsl:attribute>

			<xsl:attribute name="src">
				<xsl:value-of select="$hxpdata/@uri"/>
				<xsl:text>?verbo=attach&#38;db=</xsl:text>
				<xsl:value-of select="$hxpdata/@db"/>
				<xsl:text>&#38;id=</xsl:text>
				<xsl:value-of select="$escapedId"/>
				<xsl:text>&#38;host=</xsl:text>
				<xsl:value-of select="$hxpdata/@host"/>
				<xsl:text>&#38;port=</xsl:text>
				<xsl:value-of select="$hxpdata/@port"/>
				<xsl:text>&#38;name=</xsl:text>
				<xsl:choose>
					<xsl:when test="$name!=''">
						<xsl:call-template name="do-replace">
							<xsl:with-param name="text" select="$name"/>
							<xsl:with-param name="replace">'</xsl:with-param>
							<xsl:with-param name="by" select="'_'"/>
						</xsl:call-template>

						<xsl:if test="not(starts-with(substring($name,string-length($name)-3),'.') or starts-with(substring($name,string-length($name)-4),'.'))">
						 	<xsl:text>.</xsl:text>
							<xsl:value-of select="substring-after($theid,'.')"/>
						</xsl:if>

						<!-- simone 7 Ott 2004 aggiunge .p7m se non ce l'ha-->
						<xsl:if test="contains(substring-after($theid,'.'),'.p7m') and not(contains(substring-after($name,'.'),'.p7m'))">
						 	<xsl:text>.p7m</xsl:text>
						</xsl:if>

					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$theid"/>
					</xsl:otherwise>
				</xsl:choose>
            <xsl:call-template name="aclparams">
			</xsl:call-template>
			</xsl:attribute>
			<xsl:call-template name="hxpcontinuecontext">
				<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
			</xsl:call-template>
		</xsl:copy>
	</xsl:template>

	<xsl:template name="NoiwThumb">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		     <xsl:if test="count($blockData/immagini/xw:file)>1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>

    	<xsl:template name="NoiwThumbsimple">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		     <xsl:if test="count($blockData/immagini/xw:file)=1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>

      <xsl:template name="NoiwThumbLI">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="relpath" select="''"/>
		     <xsl:if test="count($blockData//*[name()=$relpath])>1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>

     <xsl:template name="NoiwThumbLII">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="relpath" select="''"/>
		     <xsl:if test="count($blockData//*[name()=$relpath])>1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>

     <xsl:template name="NoiwThumbLIsimple">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="relpath" select="''"/>
		     <xsl:if test="count($blockData//*[name()=$relpath])=1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>

     <xsl:template name="NoiwThumbLIIsimple">
		<xsl:param name="blockPath" select="''"/><xsl:param name="blockData" select="$hxpdata"/>
		<xsl:param name="relpath" select="''"/>
		     <xsl:if test="count($blockData//*[name()=$relpath])=1">
				<xsl:call-template name="hxpcontinuecontext">
					<xsl:with-param name="blockPath" select="$blockPath"/><xsl:with-param name="blockData" select="$blockData"/>
				</xsl:call-template>
			</xsl:if>
    </xsl:template>
</xsl:stylesheet>
<!-- Stylus Studio meta-information - (c)1998-2004. Sonic Software Corporation. All rights reserved.
<metaInformation>
<scenarios/><MapperMetaTag><MapperInfo srcSchemaPathIsRelative="yes" srcSchemaInterpretAsXML="no" destSchemaPath="" destSchemaRoot="" destSchemaPathIsRelative="yes" destSchemaInterpretAsXML="no"/><MapperBlockPosition></MapperBlockPosition></MapperMetaTag>
</metaInformation>
-->